/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/path","vs/base/common/errors","vs/platform/environment/common/environment","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/base/common/types","vs/base/common/arrays","vs/base/common/network","vs/base/common/resources","vs/base/common/buffer","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/uuid","vs/base/common/json","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/errorMessage","vs/base/common/map","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","child_process","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/codicons","vs/base/common/stream","fs","vs/platform/instantiation/common/descriptors","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/jsonEdit","net","vs/base/common/date","vs/base/parts/ipc/node/ipc.cp","vs/platform/files/common/watcher","vs/platform/localizations/common/localizations","vs/platform/native/electron-sandbox/native","vs/base/common/semver/semver","vs/platform/remote/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/jsonFormatter","vs/base/common/normalization","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","crypto","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/processes","vs/base/common/skipList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/ports","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/assignment/common/assignment","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/sharedProcessTunnelService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sign/node/signService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/assignment/common/assignmentService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","string_decoder","util","minimist","assert","graceful-fs","yauzl","yazl","zlib","vs/code/electron-browser/sharedProcess/sharedProcessMain"],ne=function(Q){for(var e=[],T=0,_=Q.length;T<_;T++)e[T]=te[Q[T]];return e};define(te[99],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function T(_,k){if(!_)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=T}),define(te[65],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const T=Object.prototype.hasOwnProperty;function _(I){const E=[];for(let f in I)T.call(I,f)&&E.push(I[f]);return E}e.values=_;function k(I,E){for(let f in I)if(T.call(I,f)&&E({key:f,value:I[f]},function(){delete I[f]})===!1)return}e.forEach=k;function L(I,E){const f=Object.create(null);for(const S of I){const h=E(S);let y=f[h];y||(y=f[h]=[]),y.push(S)}return f}e.groupBy=L;function i(I){const E=Object.create(null);return I&&I.forEach((f,S)=>{E[S]=f}),E}e.fromMap=i;function R(I,E){const f=[],S=[];for(let h of I)E.has(h)||f.push(h);for(let h of E)I.has(h)||S.push(h);return{removed:f,added:S}}e.diffSets=R;function b(I,E){const f=[],S=[];for(let[h,y]of I)E.has(h)||f.push(y);for(let[h,y]of E)I.has(h)||S.push(y);return{removed:f,added:S}}e.diffMaps=b;class C{constructor(){this.map=new Map}add(E,f){let S=this.map.get(E);S||(S=new Set,this.map.set(E,S)),S.add(f)}delete(E,f){const S=this.map.get(E);!S||(S.delete(f),S.size===0&&this.map.delete(E))}forEach(E,f){const S=this.map.get(E);!S||S.forEach(f)}}e.SetMap=C}),define(te[66],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function T(i){return(R,b,C)=>{let I=null,E=null;if(typeof C.value=="function"?(I="value",E=C.value):typeof C.get=="function"&&(I="get",E=C.get),!E)throw new Error("not supported");C[I]=i(E,b)}}e.createDecorator=T;function _(i,R,b){let C=null,I=null;if(typeof b.value=="function"?(C="value",I=b.value,I.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(C="get",I=b.get),!I)throw new Error("not supported");const E=`$memoize$${R}`;b[C]=function(...f){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:I.apply(this,f)}),this[E]}}e.memoize=_;function k(i,R,b){return T((C,I)=>{const E=`$debounce$${I}`,f=`$debounce$result$${I}`;return function(...S){this[f]||(this[f]=b?b():void 0),clearTimeout(this[E]),R&&(this[f]=R(this[f],...S),S=[this[f]]),this[E]=setTimeout(()=>{C.apply(this,S),this[f]=b?b():void 0},i)}})}e.debounce=k;function L(i,R,b){return T((C,I)=>{const E=`$throttle$timer$${I}`,f=`$throttle$result$${I}`,S=`$throttle$lastRun$${I}`,h=`$throttle$pending$${I}`;return function(...y){if(this[f]||(this[f]=b?b():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),R&&(this[f]=R(this[f],...y)),this[h])return;const v=this[S]+i;v<=Date.now()?(this[S]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0):(this[h]=!0,this[E]=setTimeout(()=>{this[h]=!1,this[S]=Date.now(),C.apply(this,[this[f]]),this[f]=b?b():void 0},v-Date.now()))}})}e.throttle=L}),define(te[10],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class T{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(r){setTimeout(()=>{throw r.stack?new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.listeners.push(r),()=>{this._removeListener(r)}}emit(r){this.listeners.forEach(a=>{a(r)})}_removeListener(r){this.listeners.splice(this.listeners.indexOf(r),1)}setUnexpectedErrorHandler(r){this.unexpectedErrorHandler=r}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(r){this.unexpectedErrorHandler(r),this.emit(r)}onUnexpectedExternalError(r){this.unexpectedErrorHandler(r)}}e.ErrorHandler=T,e.errorHandler=new T;function _(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=_;function k(u){b(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function L(u){b(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function i(u){if(u instanceof Error){let{name:r,message:a}=u;const n=u.stacktrace||u.stack;return{$isError:!0,name:r,message:a,stack:n}}return u}e.transformErrorForSerialization=i;const R="Canceled";function b(u){return u instanceof Error&&u.name===R&&u.message===R}e.isPromiseCanceledError=b;class C extends Error{constructor(){super(R);this.name=this.message}}e.CancellationError=C;function I(){const u=new Error(R);return u.name=u.message,u}e.canceled=I;function E(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=E;function f(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=f;function S(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=S;function h(u){const r=new Error(`${u} has been disposed`);return r.name="DISPOSED",r}e.disposed=h;function y(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=y;class v extends Error{constructor(r){super("NotImplemented");r&&(this.message=r)}}e.NotImplementedError=v;class m extends Error{constructor(r){super("NotSupported");r&&(this.message=r)}}e.NotSupportedError=m;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function g(u){const r=u;return r instanceof Error&&Array.isArray(r.actions)}e.isErrorWithActions=g;function l(u,r=Object.create(null)){const a=new Error(u);return r.actions&&(a.actions=r.actions),a}e.createErrorWithActions=l}),define(te[16],ne([0,1,10]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function _(q,H=0){return q[q.length-(1+H)]}e.tail=_;function k(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=k;function L(q,H,Y=(x,K)=>x===K){if(q===H)return!0;if(!q||!H||q.length!==H.length)return!1;for(let x=0,K=q.length;x<K;x++)if(!Y(q[x],H[x]))return!1;return!0}e.equals=L;function i(q,H,Y){let x=0,K=q.length-1;for(;x<=K;){const re=(x+K)/2|0,se=Y(q[re],H);if(se<0)x=re+1;else if(se>0)K=re-1;else return re}return-(x+1)}e.binarySearch=i;function R(q,H){let Y=0,x=q.length;if(x===0)return 0;for(;Y<x;){const K=Math.floor((Y+x)/2);H(q[K])?x=K:Y=K+1}return Y}e.findFirstInSorted=R;function b(q,H,Y){if(q=q|0,q>=H.length)throw new TypeError("invalid index");let x=H[Math.floor(H.length*Math.random())],K=[],re=[],se=[];for(let ce of H){const he=Y(ce,x);he<0?K.push(ce):he>0?re.push(ce):se.push(ce)}return q<K.length?b(q,K,Y):q<K.length+se.length?se[0]:b(q-(K.length+se.length),re,Y)}e.quickSelect=b;function C(q,H){const Y=[];let x;for(const K of q.slice(0).sort(H))!x||H(x[0],K)!==0?(x=[K],Y.push(x)):x.push(K);return Y}e.groupBy=C;function I(q,H,Y){const x=[];function K(ce,he,me){if(he===0&&me.length===0)return;const ye=x[x.length-1];ye&&ye.start+ye.deleteCount===ce?(ye.deleteCount+=he,ye.toInsert.push(...me)):x.push({start:ce,deleteCount:he,toInsert:me})}let re=0,se=0;for(;;){if(re===q.length){K(re,0,H.slice(se));break}if(se===H.length){K(re,q.length-re,[]);break}const ce=q[re],he=H[se],me=Y(ce,he);me===0?(re+=1,se+=1):me<0?(K(re,1,[]),re+=1):me>0&&(K(re,0,[he]),se+=1)}return x}e.sortedDiff=I;function E(q,H,Y){const x=I(q,H,Y),K=[],re=[];for(const se of x)K.push(...q.slice(se.start,se.start+se.deleteCount)),re.push(...se.toInsert);return{removed:K,added:re}}e.delta=E;function f(q,H,Y){if(Y===0)return[];const x=q.slice(0,Y).sort(H);return h(q,H,x,Y,q.length),x}e.top=f;function S(q,H,Y,x,K){return Y===0?Promise.resolve([]):new Promise((re,se)=>{(async()=>{const ce=q.length,he=q.slice(0,Y).sort(H);for(let me=Y,ye=Math.min(Y+x,ce);me<ce;me=ye,ye=Math.min(ye+x,ce)){if(me>Y&&await new Promise(we=>setTimeout(we)),K&&K.isCancellationRequested)throw(0,T.canceled)();h(q,H,he,me,ye)}return he})().then(re,se)})}e.topAsync=S;function h(q,H,Y,x,K){for(const re=Y.length;x<K;x++){const se=q[x];if(H(se,Y[re-1])<0){Y.pop();const ce=R(Y,he=>H(se,he)<0);Y.splice(ce,0,se)}}}function y(q){return q.filter(H=>!!H)}e.coalesce=y;function v(q){let H=0;for(let Y=0;Y<q.length;Y++)q[Y]&&(q[H]=q[Y],H+=1);q.length=H}e.coalesceInPlace=v;function m(q,H,Y){q.splice(Y,0,q.splice(H,1)[0])}e.move=m;function w(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=w;function g(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=g;function l(q,H=Y=>Y){const Y=new Set;return q.filter(x=>{const K=H(x);return Y.has(K)?!1:(Y.add(K),!0)})}e.distinct=l;function u(q){const H=Object.create(null);return Y=>{const x=q(Y);return H[x]?!1:(H[x]=!0,!0)}}e.uniqueFilter=u;function r(q,H){const Y=a(q,H);if(Y!==-1)return q[Y]}e.findLast=r;function a(q,H){for(let Y=q.length-1;Y>=0;Y--){const x=q[Y];if(H(x))return Y}return-1}e.lastIndex=a;function n(q,H){return q.length>0?q[0]:H}e.firstOrDefault=n;function t(q,H,Y=(x,K)=>x===K){let x=0;for(let K=0,re=Math.min(q.length,H.length);K<re&&Y(q[K],H[K]);K++)x++;return x}e.commonPrefixLength=t;function s(q){return[].concat(...q)}e.flatten=s;function o(q,H){let Y=typeof H=="number"?q:0;typeof H=="number"?Y=q:(Y=0,H=q);const x=[];if(Y<=H)for(let K=Y;K<H;K++)x.push(K);else for(let K=Y;K>H;K--)x.push(K);return x}e.range=o;function c(q,H,Y){return q.reduce((x,K)=>(x[H(K)]=Y?Y(K):K,x),Object.create(null))}e.index=c;function d(q,H){return q.push(H),()=>p(q,H)}e.insert=d;function p(q,H){const Y=q.indexOf(H);if(Y>-1)return q.splice(Y,1),H}e.remove=p;function P(q,H,Y){const x=q.slice(0,H),K=q.slice(H);return x.concat(Y,K)}e.arrayInsert=P;function O(q,H){let Y;if(typeof H=="number"){let x=H;Y=()=>{const K=Math.sin(x++)*179426549;return K-Math.floor(K)}}else Y=Math.random;for(let x=q.length-1;x>0;x-=1){const K=Math.floor(Y()*(x+1)),re=q[x];q[x]=q[K],q[K]=re}}e.shuffle=O;function A(q,H){const Y=q.indexOf(H);Y>-1&&(q.splice(Y,1),q.unshift(H))}e.pushToStart=A;function N(q,H){const Y=q.indexOf(H);Y>-1&&(q.splice(Y,1),q.push(H))}e.pushToEnd=N;function $(q,H){return Array.isArray(q)?q.map(H):H(q)}e.mapArrayOrNot=$;function D(q){return Array.isArray(q)?q:[q]}e.asArray=D;function F(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=F;function M(q,H){for(const Y of q){const x=H(Y);if(x!==void 0)return x}}e.mapFind=M;function U(q,H,Y){const x=ee(q,H),K=q.length,re=Y.length;q.length=K+re;for(let se=K-1;se>=x;se--)q[se+re]=q[se];for(let se=0;se<re;se++)q[se+x]=Y[se]}e.insertInto=U;function G(q,H,Y,x){const K=ee(q,H),re=q.splice(K,Y);return U(q,K,x),re}e.splice=G;function ee(q,H){return H<0?Math.max(H+q.length,0):Math.min(H,q.length)}function V(q,H){return(Y,x)=>H(q(Y),q(x))}e.compareBy=V;const j=(q,H)=>q-H;e.numberComparator=j;function Z(q,H){if(q.length===0)return;let Y=q[0];for(let x=1;x<q.length;x++){const K=q[x];H(K,Y)>0&&(Y=K)}return Y}e.findMaxBy=Z;function W(q,H){if(q.length===0)return;let Y=q[0];for(let x=1;x<q.length;x++){const K=q[x];H(K,Y)>=0&&(Y=K)}return Y}e.findLastMaxBy=W;function z(q,H){return Z(q,(Y,x)=>-H(Y,x))}e.findMinBy=z;class B{constructor(H){this.items=H,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(H){let Y=this.firstIdx;for(;Y<this.items.length&&H(this.items[Y]);)Y++;const x=Y===this.firstIdx?null:this.items.slice(this.firstIdx,Y);return this.firstIdx=Y,x}takeFromEndWhile(H){let Y=this.lastIdx;for(;Y>=0&&H(this.items[Y]);)Y--;const x=Y===this.lastIdx?null:this.items.slice(Y+1,this.lastIdx+1);return this.lastIdx=Y,x}peek(){return this.items[this.firstIdx]}dequeue(){const H=this.items[this.firstIdx];return this.firstIdx++,H}takeCount(H){const Y=this.items.slice(this.firstIdx,this.firstIdx+H);return this.firstIdx+=H,Y}}e.ArrayQueue=B}),define(te[67],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function T(_){const k=this;let L=!1,i;return function(){return L||(L=!0,i=_.apply(k,arguments)),i}}e.once=T}),define(te[52],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var T;(function(_){function k(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}_.is=k;const L=Object.freeze([]);function i(){return L}_.empty=i;function*R(u){yield u}_.single=R;function b(u){return u||L}_.from=b;function C(u){return!u||u[Symbol.iterator]().next().done===!0}_.isEmpty=C;function I(u){return u[Symbol.iterator]().next().value}_.first=I;function E(u,r){for(const a of u)if(r(a))return!0;return!1}_.some=E;function f(u,r){for(const a of u)if(r(a))return a}_.find=f;function*S(u,r){for(const a of u)r(a)&&(yield a)}_.filter=S;function*h(u,r){let a=0;for(const n of u)yield r(n,a++)}_.map=h;function*y(...u){for(const r of u)for(const a of r)yield a}_.concat=y;function*v(u){for(const r of u)for(const a of r)yield a}_.concatNested=v;function m(u,r,a){let n=a;for(const t of u)n=r(n,t);return n}_.reduce=m;function*w(u,r,a=u.length){for(r<0&&(r+=u.length),a<0?a+=u.length:a>u.length&&(a=u.length);r<a;r++)yield u[r]}_.slice=w;function g(u,r=Number.POSITIVE_INFINITY){const a=[];if(r===0)return[a,u];const n=u[Symbol.iterator]();for(let t=0;t<r;t++){const s=n.next();if(s.done)return[a,_.empty()];a.push(s.value)}return[a,{[Symbol.iterator](){return n}}]}_.consume=g;function l(u,r,a=(n,t)=>n===t){const n=u[Symbol.iterator](),t=r[Symbol.iterator]();for(;;){const s=n.next(),o=t.next();if(s.done!==o.done)return!1;if(s.done)return!0;if(!a(s.value,o.value))return!1}}_.equals=l})(T=e.Iterable||(e.Iterable={}))}),define(te[31],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var T;(function(r){r[r.None=0]="None",r[r.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=2]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",r[r.InvalidUnicode=4]="InvalidUnicode",r[r.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",r[r.InvalidCharacter=6]="InvalidCharacter"})(T=e.ScanError||(e.ScanError={}));var _;(function(r){r[r.OpenBraceToken=1]="OpenBraceToken",r[r.CloseBraceToken=2]="CloseBraceToken",r[r.OpenBracketToken=3]="OpenBracketToken",r[r.CloseBracketToken=4]="CloseBracketToken",r[r.CommaToken=5]="CommaToken",r[r.ColonToken=6]="ColonToken",r[r.NullKeyword=7]="NullKeyword",r[r.TrueKeyword=8]="TrueKeyword",r[r.FalseKeyword=9]="FalseKeyword",r[r.StringLiteral=10]="StringLiteral",r[r.NumericLiteral=11]="NumericLiteral",r[r.LineCommentTrivia=12]="LineCommentTrivia",r[r.BlockCommentTrivia=13]="BlockCommentTrivia",r[r.LineBreakTrivia=14]="LineBreakTrivia",r[r.Trivia=15]="Trivia",r[r.Unknown=16]="Unknown",r[r.EOF=17]="EOF"})(_=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(r){r[r.InvalidSymbol=1]="InvalidSymbol",r[r.InvalidNumberFormat=2]="InvalidNumberFormat",r[r.PropertyNameExpected=3]="PropertyNameExpected",r[r.ValueExpected=4]="ValueExpected",r[r.ColonExpected=5]="ColonExpected",r[r.CommaExpected=6]="CommaExpected",r[r.CloseBraceExpected=7]="CloseBraceExpected",r[r.CloseBracketExpected=8]="CloseBracketExpected",r[r.EndOfFileExpected=9]="EndOfFileExpected",r[r.InvalidCommentToken=10]="InvalidCommentToken",r[r.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",r[r.UnexpectedEndOfString=12]="UnexpectedEndOfString",r[r.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",r[r.InvalidUnicode=14]="InvalidUnicode",r[r.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",r[r.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(r){r.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function i(r,a=!1){let n=0,t=r.length,s="",o=0,c=16,d=0;function p(F){let M=0,U=0;for(;M<F;){const G=r.charCodeAt(n);if(G>=48&&G<=57)U=U*16+G-48;else if(G>=65&&G<=70)U=U*16+G-65+10;else if(G>=97&&G<=102)U=U*16+G-97+10;else break;n++,M++}return M<F&&(U=-1),U}function P(F){n=F,s="",o=0,c=16,d=0}function O(){const F=n;if(r.charCodeAt(n)===48)n++;else for(n++;n<r.length&&C(r.charCodeAt(n));)n++;if(n<r.length&&r.charCodeAt(n)===46)if(n++,n<r.length&&C(r.charCodeAt(n)))for(n++;n<r.length&&C(r.charCodeAt(n));)n++;else return d=3,r.substring(F,n);let M=n;if(n<r.length&&(r.charCodeAt(n)===69||r.charCodeAt(n)===101))if(n++,(n<r.length&&r.charCodeAt(n)===43||r.charCodeAt(n)===45)&&n++,n<r.length&&C(r.charCodeAt(n))){for(n++;n<r.length&&C(r.charCodeAt(n));)n++;M=n}else d=3;return r.substring(F,M)}function A(){let F="",M=n;for(;;){if(n>=t){F+=r.substring(M,n),d=2;break}const U=r.charCodeAt(n);if(U===34){F+=r.substring(M,n),n++;break}if(U===92){if(F+=r.substring(M,n),n++,n>=t){d=2;break}switch(r.charCodeAt(n++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:const ee=p(4);ee>=0?F+=String.fromCharCode(ee):d=4;break;default:d=5}M=n;continue}if(U>=0&&U<=31)if(b(U)){F+=r.substring(M,n),d=2;break}else d=6;n++}return F}function N(){if(s="",d=0,o=n,n>=t)return o=t,c=17;let F=r.charCodeAt(n);if(R(F)){do n++,s+=String.fromCharCode(F),F=r.charCodeAt(n);while(R(F));return c=15}if(b(F))return n++,s+=String.fromCharCode(F),F===13&&r.charCodeAt(n)===10&&(n++,s+=`
`),c=14;switch(F){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,s=A(),c=10;case 47:const M=n-1;if(r.charCodeAt(n+1)===47){for(n+=2;n<t&&!b(r.charCodeAt(n));)n++;return s=r.substring(M,n),c=12}if(r.charCodeAt(n+1)===42){n+=2;const U=t-1;let G=!1;for(;n<U;){if(r.charCodeAt(n)===42&&r.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,d=1),s=r.substring(M,n),c=13}return s+=String.fromCharCode(F),n++,c=16;case 45:if(s+=String.fromCharCode(F),n++,n===t||!C(r.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=O(),c=11;default:for(;n<t&&$(F);)n++,F=r.charCodeAt(n);if(o!==n){switch(s=r.substring(o,n),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(F),n++,c=16}}function $(F){if(R(F)||b(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function D(){let F;do F=N();while(F>=12&&F<=15);return F}return{setPosition:P,getPosition:()=>n,scan:a?D:N,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>d}}e.createScanner=i;function R(r){return r===32||r===9||r===11||r===12||r===160||r===5760||r>=8192&&r<=8203||r===8239||r===8287||r===12288||r===65279}function b(r){return r===10||r===13||r===8232||r===8233}function C(r){return r>=48&&r<=57}var I;(function(r){r[r.nullCharacter=0]="nullCharacter",r[r.maxAsciiCharacter=127]="maxAsciiCharacter",r[r.lineFeed=10]="lineFeed",r[r.carriageReturn=13]="carriageReturn",r[r.lineSeparator=8232]="lineSeparator",r[r.paragraphSeparator=8233]="paragraphSeparator",r[r.nextLine=133]="nextLine",r[r.space=32]="space",r[r.nonBreakingSpace=160]="nonBreakingSpace",r[r.enQuad=8192]="enQuad",r[r.emQuad=8193]="emQuad",r[r.enSpace=8194]="enSpace",r[r.emSpace=8195]="emSpace",r[r.threePerEmSpace=8196]="threePerEmSpace",r[r.fourPerEmSpace=8197]="fourPerEmSpace",r[r.sixPerEmSpace=8198]="sixPerEmSpace",r[r.figureSpace=8199]="figureSpace",r[r.punctuationSpace=8200]="punctuationSpace",r[r.thinSpace=8201]="thinSpace",r[r.hairSpace=8202]="hairSpace",r[r.zeroWidthSpace=8203]="zeroWidthSpace",r[r.narrowNoBreakSpace=8239]="narrowNoBreakSpace",r[r.ideographicSpace=12288]="ideographicSpace",r[r.mathematicalSpace=8287]="mathematicalSpace",r[r.ogham=5760]="ogham",r[r._=95]="_",r[r.$=36]="$",r[r._0=48]="_0",r[r._1=49]="_1",r[r._2=50]="_2",r[r._3=51]="_3",r[r._4=52]="_4",r[r._5=53]="_5",r[r._6=54]="_6",r[r._7=55]="_7",r[r._8=56]="_8",r[r._9=57]="_9",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.ampersand=38]="ampersand",r[r.asterisk=42]="asterisk",r[r.at=64]="at",r[r.backslash=92]="backslash",r[r.bar=124]="bar",r[r.caret=94]="caret",r[r.closeBrace=125]="closeBrace",r[r.closeBracket=93]="closeBracket",r[r.closeParen=41]="closeParen",r[r.colon=58]="colon",r[r.comma=44]="comma",r[r.dot=46]="dot",r[r.doubleQuote=34]="doubleQuote",r[r.equals=61]="equals",r[r.exclamation=33]="exclamation",r[r.greaterThan=62]="greaterThan",r[r.lessThan=60]="lessThan",r[r.minus=45]="minus",r[r.openBrace=123]="openBrace",r[r.openBracket=91]="openBracket",r[r.openParen=40]="openParen",r[r.percent=37]="percent",r[r.plus=43]="plus",r[r.question=63]="question",r[r.semicolon=59]="semicolon",r[r.singleQuote=39]="singleQuote",r[r.slash=47]="slash",r[r.tilde=126]="tilde",r[r.backspace=8]="backspace",r[r.formFeed=12]="formFeed",r[r.byteOrderMark=65279]="byteOrderMark",r[r.tab=9]="tab",r[r.verticalTab=11]="verticalTab"})(I||(I={}));function E(r,a){const n=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function d(p,P,O,A){o.value=p,o.offset=P,o.length=O,o.type=A,o.colonOffset=void 0,s=o}try{g(r,{onObjectBegin:(p,P)=>{if(a<=p)throw t;s=void 0,c=a>p,n.push("")},onObjectProperty:(p,P,O)=>{if(a<P||(d(p,P,O,"property"),n[n.length-1]=p,a<=P+O))throw t},onObjectEnd:(p,P)=>{if(a<=p)throw t;s=void 0,n.pop()},onArrayBegin:(p,P)=>{if(a<=p)throw t;s=void 0,n.push(0)},onArrayEnd:(p,P)=>{if(a<=p)throw t;s=void 0,n.pop()},onLiteralValue:(p,P,O)=>{if(a<P||(d(p,P,O,u(p)),a<=P+O))throw t},onSeparator:(p,P,O)=>{if(a<=P)throw t;if(p===":"&&s&&s.type==="property")s.colonOffset=P,c=!1,s=void 0;else if(p===","){const A=n[n.length-1];typeof A=="number"?n[n.length-1]=A+1:(c=!0,n[n.length-1]=""),s=void 0}}})}catch(p){if(p!==t)throw p}return{path:n,previousNode:s,isAtPropertyKey:c,matches:p=>{let P=0;for(let O=0;P<p.length&&O<n.length;O++)if(p[P]===n[O]||p[P]==="*")P++;else if(p[P]!=="**")return!1;return P===p.length}}}e.getLocation=E;function f(r,a=[],n=L.DEFAULT){let t=null,s=[];const o=[];function c(p){Array.isArray(s)?s.push(p):t!==null&&(s[t]=p)}return g(r,{onObjectBegin:()=>{const p={};c(p),o.push(s),s=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const p=[];c(p),o.push(s),s=p,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(p,P,O)=>{a.push({error:p,offset:P,length:O})}},n),s[0]}e.parse=f;function S(r,a=[],n=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(p){t.type==="property"&&(t.length=p-t.offset,t=t.parent)}function o(p){return t.children.push(p),p}g(r,{onObjectBegin:p=>{t=o({type:"object",offset:p,length:-1,parent:t,children:[]})},onObjectProperty:(p,P,O)=>{t=o({type:"property",offset:P,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:p,offset:P,length:O,parent:t})},onObjectEnd:(p,P)=>{t.length=p+P-t.offset,t=t.parent,s(p+P)},onArrayBegin:(p,P)=>{t=o({type:"array",offset:p,length:-1,parent:t,children:[]})},onArrayEnd:(p,P)=>{t.length=p+P-t.offset,t=t.parent,s(p+P)},onLiteralValue:(p,P,O)=>{o({type:u(p),offset:P,length:O,parent:t,value:p}),s(P+O)},onSeparator:(p,P,O)=>{t.type==="property"&&(p===":"?t.colonOffset=P:p===","&&s(P))},onError:(p,P,O)=>{a.push({error:p,offset:P,length:O})}},n);const d=t.children[0];return d&&delete d.parent,d}e.parseTree=S;function h(r,a){if(!r)return;let n=r;for(let t of a)if(typeof t=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let s=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===t){n=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(n.type!=="array"||s<0||!Array.isArray(n.children)||s>=n.children.length)return;n=n.children[s]}return n}e.findNodeAtLocation=h;function y(r){if(!r.parent||!r.parent.children)return[];const a=y(r.parent);if(r.parent.type==="property"){const n=r.parent.children[0].value;a.push(n)}else if(r.parent.type==="array"){const n=r.parent.children.indexOf(r);n!==-1&&a.push(n)}return a}e.getNodePath=y;function v(r){switch(r.type){case"array":return r.children.map(v);case"object":const a=Object.create(null);for(let n of r.children){const t=n.children[1];t&&(a[n.children[0].value]=v(t))}return a;case"null":case"string":case"number":case"boolean":return r.value;default:return}}e.getNodeValue=v;function m(r,a,n=!1){return a>=r.offset&&a<r.offset+r.length||n&&a===r.offset+r.length}e.contains=m;function w(r,a,n=!1){if(m(r,a,n)){const t=r.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=a;s++){const o=w(t[s],a,n);if(o)return o}return r}}e.findNodeAtOffset=w;function g(r,a,n=L.DEFAULT){const t=i(r,!1);function s(B){return B?()=>B(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(B){return B?q=>B(q,t.getTokenOffset(),t.getTokenLength()):()=>!0}const c=s(a.onObjectBegin),d=o(a.onObjectProperty),p=s(a.onObjectEnd),P=s(a.onArrayBegin),O=s(a.onArrayEnd),A=o(a.onLiteralValue),N=o(a.onSeparator),$=s(a.onComment),D=o(a.onError),F=n&&n.disallowComments,M=n&&n.allowTrailingComma;function U(){for(;;){const B=t.scan();switch(t.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:F||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(B){case 12:case 13:F?G(10):$();break;case 16:G(1);break;case 15:case 14:break;default:return B}}}function G(B,q=[],H=[]){if(D(B),q.length+H.length>0){let Y=t.getToken();for(;Y!==17;){if(q.indexOf(Y)!==-1){U();break}else if(H.indexOf(Y)!==-1)break;Y=U()}}}function ee(B){const q=t.getTokenValue();return B?A(q):d(q),U(),!0}function V(){switch(t.getToken()){case 11:let B=0;try{B=JSON.parse(t.getTokenValue()),typeof B!="number"&&(G(2),B=0)}catch(q){G(2)}A(B);break;case 7:A(null);break;case 8:A(!0);break;case 9:A(!1);break;default:return!1}return U(),!0}function j(){return t.getToken()!==10?(G(3,[],[2,5]),!1):(ee(!1),t.getToken()===6?(N(":"),U(),z()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function Z(){c(),U();let B=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(B||G(4,[],[]),N(","),U(),t.getToken()===2&&M)break}else B&&G(6,[],[]);j()||G(4,[],[2,5]),B=!0}return p(),t.getToken()!==2?G(7,[2],[]):U(),!0}function W(){P(),U();let B=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(B||G(4,[],[]),N(","),U(),t.getToken()===4&&M)break}else B&&G(6,[],[]);z()||G(4,[],[4,5]),B=!0}return O(),t.getToken()!==4?G(8,[4],[]):U(),!0}function z(){switch(t.getToken()){case 3:return W();case 1:return Z();case 10:return ee(!0);default:return V()}}return U(),t.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):z()?(t.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=g;function l(r,a){let n=i(r),t=[],s,o=0,c;do switch(c=n.getPosition(),s=n.scan(),s){case 12:case 13:case 17:o!==c&&t.push(r.substring(o,c)),a!==void 0&&t.push(n.getTokenValue().replace(/[^\r\n]/g,a)),o=n.getPosition();break}while(s!==17);return t.join("")}e.stripComments=l;function u(r){switch(typeof r){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(r){if(Array.isArray(r))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(te[68],ne([0,1,31]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function _(C,I,E){let f,S,h,y,v;if(I){for(y=I.offset,v=y+I.length,h=y;h>0&&!b(C,h-1);)h--;let c=v;for(;c<C.length&&!b(C,c);)c++;S=C.substring(h,c),f=i(S,E)}else S=C,f=0,h=0,y=0,v=C.length;const m=R(E,C);let w=!1,g=0,l;E.insertSpaces?l=L(" ",E.tabSize||4):l="	";const u=(0,T.createScanner)(S,!1);let r=!1;function a(){return m+L(l,f+g)}function n(){let c=u.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=u.scan();return r=c===16||u.getTokenError()!==0,c}const t=[];function s(c,d,p){!r&&d<v&&p>y&&C.substring(d,p)!==c&&t.push({offset:d,length:p-d,content:c})}let o=n();if(o!==17){const c=u.getTokenOffset()+h,d=L(l,f);s(d,h,c)}for(;o!==17;){let c=u.getTokenOffset()+u.getTokenLength()+h,d=n(),p="";for(;!w&&(d===12||d===13);){const O=u.getTokenOffset()+h;s(" ",c,O),c=u.getTokenOffset()+u.getTokenLength()+h,p=d===12?a():"",d=n()}if(d===2)o!==1&&(g--,p=a());else if(d===4)o!==3&&(g--,p=a());else{switch(o){case 3:case 1:g++,p=a();break;case 5:case 12:p=a();break;case 13:w?p=a():p=" ";break;case 6:p=" ";break;case 10:if(d===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:d===12||d===13?p=" ":d!==5&&d!==17&&(r=!0);break;case 16:r=!0;break}w&&(d===12||d===13)&&(p=a())}const P=u.getTokenOffset()+h;s(p,c,P),o=d}return t}e.format=_;function k(C,I){const E=JSON.stringify(C,void 0,I.insertSpaces?I.tabSize||4:"	");return I.eol!==void 0?E.replace(/\r\n|\r|\n/g,I.eol):E}e.toFormattedString=k;function L(C,I){let E="";for(let f=0;f<I;f++)E+=C;return E}function i(C,I){let E=0,f=0;const S=I.tabSize||4;for(;E<C.length;){const h=C.charAt(E);if(h===" ")f++;else if(h==="	")f+=S;else break;E++}return Math.floor(f/S)}function R(C,I){for(let E=0;E<I.length;E++){const f=I.charAt(E);if(f==="\r")return E+1<I.length&&I.charAt(E+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return C&&C.eol||`
`}e.getEOL=R;function b(C,I){return`\r
`.indexOf(C.charAt(I))!==-1}e.isEOL=b}),define(te[53],ne([0,1,31,68]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(C,I,E){return L(C,I,void 0,E)}e.removeProperty=k;function L(C,I,E,f,S){const h=I.slice(),y=[],v=(0,T.parseTree)(C,y);let m,w;for(;h.length>0&&(w=h.pop(),m=(0,T.findNodeAtLocation)(v,h),m===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(m)if(m.type==="object"&&typeof w=="string"&&Array.isArray(m.children)){const g=(0,T.findNodeAtLocation)(m,[w]);if(g!==void 0)if(E===void 0){if(!g.parent)throw new Error("Malformed AST");const l=m.children.indexOf(g.parent);let u,r=g.parent.offset+g.parent.length;if(l>0){const a=m.children[l-1];u=a.offset+a.length}else u=m.offset+1,m.children.length>1&&(r=m.children[1].offset);return i(C,{offset:u,length:r-u,content:""},f)}else return i(C,{offset:g.offset,length:g.length,content:JSON.stringify(E)},f);else{if(E===void 0)return[];const l=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,u=S?S(m.children.map(a=>a.children[0].value)):m.children.length;let r;if(u>0){const a=m.children[u-1];r={offset:a.offset+a.length,length:0,content:","+l}}else m.children.length===0?r={offset:m.offset+1,length:0,content:l}:r={offset:m.offset+1,length:0,content:l+","};return i(C,r,f)}}else if(m.type==="array"&&typeof w=="number"&&Array.isArray(m.children))if(E!==void 0){const g=`${JSON.stringify(E)}`;let l;if(m.children.length===0||w===0)l={offset:m.offset+1,length:0,content:m.children.length===0?g:g+","};else{const u=w===-1||w>m.children.length?m.children.length:w,r=m.children[u-1];l={offset:r.offset+r.length,length:0,content:","+g}}return i(C,l,f)}else{const g=w,l=m.children[g];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===g){const r=m.children[g-1],a=r.offset+r.length,n=m.offset+m.length;u={offset:a,length:n-2-a,content:""}}else u={offset:l.offset,length:m.children[g+1].offset-l.offset,content:""};return i(C,u,f)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${m.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return i(C,{offset:v?v.offset:0,length:v?v.length:0,content:JSON.stringify(E)},f)}}e.setProperty=L;function i(C,I,E){let f=R(C,I),S=I.offset,h=I.offset+I.content.length;if(I.length===0||I.content.length===0){for(;S>0&&!(0,_.isEOL)(f,S-1);)S--;for(;h<f.length&&!(0,_.isEOL)(f,h);)h++}const y=(0,_.format)(f,{offset:S,length:h-S},E);for(let m=y.length-1;m>=0;m--){const w=y[m];f=R(f,w),S=Math.min(S,w.offset),h=Math.max(h,w.offset+w.length),h+=w.content.length-w.length}const v=C.length-(f.length-h)-S;return[{offset:S,length:v,content:f.substring(S,h)}]}e.withFormatting=i;function R(C,I){return C.substring(0,I.offset)+I.content+C.substring(I.offset+I.length)}e.applyEdit=R;function b(C,I){let E=I.slice(0).sort((S,h)=>{const y=S.offset-h.offset;return y===0?S.length-h.length:y}),f=C.length;for(let S=E.length-1;S>=0;S--){let h=E[S];if(h.offset+h.length<=f)C=R(C,h);else throw new Error("Overlapping edit");f=h.offset}return C}e.applyEdits=b}),define(te[2],ne([0,1,67,52]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let L=null;function i(t){L=t}if(e.setDisposableTracker=i,k){const t="__is_disposable_tracked__";i(new class{trackDisposable(s){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{s[t]||console.log(o)},3e3)}setParent(s,o){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsDisposed(s){if(s&&s!==w.None)try{s[t]=!0}catch{}}markAsSingleton(s){}})}function R(t){return L?.trackDisposable(t),t}function b(t){L?.markAsDisposed(t)}function C(t,s){L?.setParent(t,s)}function I(t,s){if(!!L)for(const o of t)L.setParent(o,s)}function E(t){return L?.markAsSingleton(t),t}e.markAsSingleton=E;class f extends Error{constructor(s){super(`Encountered errors while disposing of store. Errors: [${s.join(", ")}]`);this.errors=s}}e.MultiDisposeError=f;function S(t){return typeof t.dispose=="function"&&t.dispose.length===0}e.isDisposable=S;function h(t){if(_.Iterable.is(t)){let s=[];for(const o of t)if(o)try{o.dispose()}catch(c){s.push(c)}if(s.length===1)throw s[0];if(s.length>1)throw new f(s);return Array.isArray(t)?[]:t}else if(t)return t.dispose(),t}e.dispose=h;function y(...t){const s=v(()=>h(t));return I(t,s),s}e.combinedDisposable=y;function v(t){const s=R({dispose:(0,T.once)(()=>{b(s),t()})});return s}e.toDisposable=v;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,R(this)}dispose(){this._isDisposed||(b(this),this._isDisposed=!0,this.clear())}clear(){try{h(this._toDispose.values())}finally{this._toDispose.clear()}}add(s){if(!s)return s;if(s===this)throw new Error("Cannot register a disposable on itself!");return C(s,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(s),s}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new m,R(this),C(this._store,this)}dispose(){b(this),this._store.dispose()}_register(s){if(s===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(s)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,R(this)}get value(){return this._isDisposed?void 0:this._value}set value(s){this._isDisposed||s===this._value||(this._value?.dispose(),s&&C(s,this),this._value=s)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,b(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const s=this._value;return this._value=void 0,s&&C(s,null),s}}e.MutableDisposable=g;class l{constructor(s){this._disposable=s,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class u{constructor(){this.references=new Map}acquire(s,...o){let c=this.references.get(s);c||(c={counter:0,object:this.createReferencedObject(s,...o)},this.references.set(s,c));const{object:d}=c,p=(0,T.once)(()=>{--c.counter==0&&(this.destroyReferencedObject(s,c.object),this.references.delete(s))});return c.counter++,{object:d,dispose:p}}}e.ReferenceCollection=u;class r{constructor(s){this.referenceCollection=s}async acquire(s,...o){const c=this.referenceCollection.acquire(s,...o);try{return{object:await c.object,dispose:()=>c.dispose()}}catch(d){throw c.dispose(),d}}}e.AsyncReferenceCollection=r;class a{constructor(s){this.object=s}dispose(){}}e.ImmortalReference=a;function n(t){const s=new m;try{t(s)}finally{s.dispose()}}e.disposeOnReturn=n}),define(te[100],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class T{constructor(L){this.element=L,this.next=T.Undefined,this.prev=T.Undefined}}T.Undefined=new T(void 0);class _{constructor(){this._first=T.Undefined,this._last=T.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===T.Undefined}clear(){let L=this._first;for(;L!==T.Undefined;){const i=L.next;L.prev=T.Undefined,L.next=T.Undefined,L=i}this._first=T.Undefined,this._last=T.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,i){const R=new T(L);if(this._first===T.Undefined)this._first=R,this._last=R;else if(i){const C=this._last;this._last=R,R.prev=C,C.next=R}else{const C=this._first;this._first=R,R.next=C,C.prev=R}this._size+=1;let b=!1;return()=>{b||(b=!0,this._remove(R))}}shift(){if(this._first!==T.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==T.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==T.Undefined&&L.next!==T.Undefined){const i=L.prev;i.next=L.next,L.next.prev=i}else L.prev===T.Undefined&&L.next===T.Undefined?(this._first=T.Undefined,this._last=T.Undefined):L.next===T.Undefined?(this._last=this._last.prev,this._last.next=T.Undefined):L.prev===T.Undefined&&(this._first=this._first.next,this._first.prev=T.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==T.Undefined;)yield L.element,L=L.next}}e.LinkedList=_}),function(){function Q(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function i(b){L.push(b,Date.now())}function R(){const b=[];for(let C=0;C<L.length;C+=2)b.push({name:L[C],startTime:L[C+1]});return b}return{mark:i,getMarks:R}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Q():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const i of performance.getEntriesByType("mark"))L.push({name:i.name,startTime:Math.round(k+i.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Q(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),Q()}function T(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var _;typeof global=="object"?_=global:typeof self=="object"?_=self:_={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(_)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(_):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),_.perf=T(_))}(),define(te[4],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const T="en";let _=!1,k=!1,L=!1,i=!1,R=!1,b=!1,C=!1,I=!1,E,f=T,S,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const v=typeof y?.versions?.electron=="string",m=v&&y?.type==="renderer";if(e.isElectronSandboxed=m&&y?.sandboxed,typeof navigator=="object"&&!m)h=navigator.userAgent,_=h.indexOf("Windows")>=0,k=h.indexOf("Macintosh")>=0,I=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=h.indexOf("Linux")>=0,b=!0,E=navigator.language,f=E;else if(typeof y=="object"){_=y.platform==="win32",k=y.platform==="darwin",L=y.platform==="linux",i=L&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,C=v,E=T,f=T;const s=y.env.VSCODE_NLS_CONFIG;if(s)try{const o=JSON.parse(s),c=o.availableLanguages["*"];E=o.locale,f=c||T,S=o._translationsConfigFile}catch(o){}R=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function g(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=g;let l=0;k?l=1:_?l=3:L&&(l=2),e.isWindows=_,e.isMacintosh=k,e.isLinux=L,e.isLinuxSnap=i,e.isNative=R,e.isElectron=C,e.isWeb=b,e.isIOS=I,e.platform=l,e.userAgent=h,e.language=f;var u;(function(s){function o(){return e.language}s.value=o;function c(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=c;function d(){return e.language==="en"}s.isDefault=d})(u=e.Language||(e.Language={})),e.locale=E,e.translationsConfigFile=S,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let s=[];e.globals.addEventListener("message",c=>{if(c.data&&c.data.vscodeScheduleAsyncWork)for(let d=0,p=s.length;d<p;d++){const P=s[d];if(P.id===c.data.vscodeScheduleAsyncWork){s.splice(d,1),P.callback();return}}});let o=0;return c=>{const d=++o;s.push({id:d,callback:c}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return s=>setTimeout(s)})();var r;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=k||I?2:_?1:3;let a=!0,n=!1;function t(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,a=new Uint16Array(s.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=t}),define(te[32],ne([0,1,4]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let _;if(typeof T.globals.vscode!="undefined"&&typeof T.globals.vscode.process!="undefined"){const k=T.globals.vscode.process;_={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?_={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:_={get platform(){return T.isWindows?"win32":T.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=_.cwd,e.env=_.env,e.platform=_.platform,e.arch=_.arch}),define(te[9],ne([0,1,32]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const _=65,k=97,L=90,i=122,R=46,b=47,C=92,I=58,E=63;class f extends Error{constructor(l,u,r){let a;typeof u=="string"&&u.indexOf("not ")===0?(a="must not be",u=u.replace(/^not /,"")):a="must be";const n=l.indexOf(".")!==-1?"property":"argument";let t=`The "${l}" ${n} ${a} of type ${u}`;t+=`. Received type ${typeof r}`,super(t),this.code="ERR_INVALID_ARG_TYPE"}}function S(g,l){if(typeof g!="string")throw new f(l,"string",g)}function h(g){return g===b||g===C}function y(g){return g===b}function v(g){return g>=_&&g<=L||g>=k&&g<=i}function m(g,l,u,r){let a="",n=0,t=-1,s=0,o=0;for(let c=0;c<=g.length;++c){if(c<g.length)o=g.charCodeAt(c);else{if(r(o))break;o=b}if(r(o)){if(!(t===c-1||s===1))if(s===2){if(a.length<2||n!==2||a.charCodeAt(a.length-1)!==R||a.charCodeAt(a.length-2)!==R){if(a.length>2){const d=a.lastIndexOf(u);d===-1?(a="",n=0):(a=a.slice(0,d),n=a.length-1-a.lastIndexOf(u)),t=c,s=0;continue}else if(a.length!==0){a="",n=0,t=c,s=0;continue}}l&&(a+=a.length>0?`${u}..`:"..",n=2)}else a.length>0?a+=`${u}${g.slice(t+1,c)}`:a=g.slice(t+1,c),n=c-t-1;t=c,s=0}else o===R&&s!==-1?++s:s=-1}return a}function w(g,l){if(l===null||typeof l!="object")throw new f("pathObject","Object",l);const u=l.dir||l.root,r=l.base||`${l.name||""}${l.ext||""}`;return u?u===l.root?`${u}${r}`:`${u}${g}${r}`:r}e.win32={resolve(...g){let l="",u="",r=!1;for(let a=g.length-1;a>=-1;a--){let n;if(a>=0){if(n=g[a],S(n,"path"),n.length===0)continue}else l.length===0?n=T.cwd():(n=T.env[`=${l}`]||T.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===C)&&(n=`${l}\\`));const t=n.length;let s=0,o="",c=!1;const d=n.charCodeAt(0);if(t===1)h(d)&&(s=1,c=!0);else if(h(d))if(c=!0,h(n.charCodeAt(1))){let p=2,P=p;for(;p<t&&!h(n.charCodeAt(p));)p++;if(p<t&&p!==P){const O=n.slice(P,p);for(P=p;p<t&&h(n.charCodeAt(p));)p++;if(p<t&&p!==P){for(P=p;p<t&&!h(n.charCodeAt(p));)p++;(p===t||p!==P)&&(o=`\\\\${O}\\${n.slice(P,p)}`,s=p)}}}else s=1;else v(d)&&n.charCodeAt(1)===I&&(o=n.slice(0,2),s=2,t>2&&h(n.charCodeAt(2))&&(c=!0,s=3));if(o.length>0)if(l.length>0){if(o.toLowerCase()!==l.toLowerCase())continue}else l=o;if(r){if(l.length>0)break}else if(u=`${n.slice(s)}\\${u}`,r=c,c&&l.length>0)break}return u=m(u,!r,"\\",h),r?`${l}\\${u}`:`${l}${u}`||"."},normalize(g){S(g,"path");const l=g.length;if(l===0)return".";let u=0,r,a=!1;const n=g.charCodeAt(0);if(l===1)return y(n)?"\\":g;if(h(n))if(a=!0,h(g.charCodeAt(1))){let s=2,o=s;for(;s<l&&!h(g.charCodeAt(s));)s++;if(s<l&&s!==o){const c=g.slice(o,s);for(o=s;s<l&&h(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!h(g.charCodeAt(s));)s++;if(s===l)return`\\\\${c}\\${g.slice(o)}\\`;s!==o&&(r=`\\\\${c}\\${g.slice(o,s)}`,u=s)}}}else u=1;else v(n)&&g.charCodeAt(1)===I&&(r=g.slice(0,2),u=2,l>2&&h(g.charCodeAt(2))&&(a=!0,u=3));let t=u<l?m(g.slice(u),!a,"\\",h):"";return t.length===0&&!a&&(t="."),t.length>0&&h(g.charCodeAt(l-1))&&(t+="\\"),r===void 0?a?`\\${t}`:t:a?`${r}\\${t}`:`${r}${t}`},isAbsolute(g){S(g,"path");const l=g.length;if(l===0)return!1;const u=g.charCodeAt(0);return h(u)||l>2&&v(u)&&g.charCodeAt(1)===I&&h(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let l,u;for(let n=0;n<g.length;++n){const t=g[n];S(t,"path"),t.length>0&&(l===void 0?l=u=t:l+=`\\${t}`)}if(l===void 0)return".";let r=!0,a=0;if(typeof u=="string"&&h(u.charCodeAt(0))){++a;const n=u.length;n>1&&h(u.charCodeAt(1))&&(++a,n>2&&(h(u.charCodeAt(2))?++a:r=!1))}if(r){for(;a<l.length&&h(l.charCodeAt(a));)a++;a>=2&&(l=`\\${l.slice(a)}`)}return e.win32.normalize(l)},relative(g,l){if(S(g,"from"),S(l,"to"),g===l)return"";const u=e.win32.resolve(g),r=e.win32.resolve(l);if(u===r||(g=u.toLowerCase(),l=r.toLowerCase(),g===l))return"";let a=0;for(;a<g.length&&g.charCodeAt(a)===C;)a++;let n=g.length;for(;n-1>a&&g.charCodeAt(n-1)===C;)n--;const t=n-a;let s=0;for(;s<l.length&&l.charCodeAt(s)===C;)s++;let o=l.length;for(;o-1>s&&l.charCodeAt(o-1)===C;)o--;const c=o-s,d=t<c?t:c;let p=-1,P=0;for(;P<d;P++){const A=g.charCodeAt(a+P);if(A!==l.charCodeAt(s+P))break;A===C&&(p=P)}if(P!==d){if(p===-1)return r}else{if(c>d){if(l.charCodeAt(s+P)===C)return r.slice(s+P+1);if(P===2)return r.slice(s+P)}t>d&&(g.charCodeAt(a+P)===C?p=P:P===2&&(p=3)),p===-1&&(p=0)}let O="";for(P=a+p+1;P<=n;++P)(P===n||g.charCodeAt(P)===C)&&(O+=O.length===0?"..":"\\..");return s+=p,O.length>0?`${O}${r.slice(s,o)}`:(r.charCodeAt(s)===C&&++s,r.slice(s,o))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const l=e.win32.resolve(g);if(l.length<=2)return g;if(l.charCodeAt(0)===C){if(l.charCodeAt(1)===C){const u=l.charCodeAt(2);if(u!==E&&u!==R)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(v(l.charCodeAt(0))&&l.charCodeAt(1)===I&&l.charCodeAt(2)===C)return`\\\\?\\${l}`;return g},dirname(g){S(g,"path");const l=g.length;if(l===0)return".";let u=-1,r=0;const a=g.charCodeAt(0);if(l===1)return h(a)?g:".";if(h(a)){if(u=r=1,h(g.charCodeAt(1))){let s=2,o=s;for(;s<l&&!h(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&h(g.charCodeAt(s));)s++;if(s<l&&s!==o){for(o=s;s<l&&!h(g.charCodeAt(s));)s++;if(s===l)return g;s!==o&&(u=r=s+1)}}}}else v(a)&&g.charCodeAt(1)===I&&(u=l>2&&h(g.charCodeAt(2))?3:2,r=u);let n=-1,t=!0;for(let s=l-1;s>=r;--s)if(h(g.charCodeAt(s))){if(!t){n=s;break}}else t=!1;if(n===-1){if(u===-1)return".";n=u}return g.slice(0,n)},basename(g,l){l!==void 0&&S(l,"ext"),S(g,"path");let u=0,r=-1,a=!0,n;if(g.length>=2&&v(g.charCodeAt(0))&&g.charCodeAt(1)===I&&(u=2),l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,s=-1;for(n=g.length-1;n>=u;--n){const o=g.charCodeAt(n);if(h(o)){if(!a){u=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(n=g.length-1;n>=u;--n)if(h(g.charCodeAt(n))){if(!a){u=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(u,r)},extname(g){S(g,"path");let l=0,u=-1,r=0,a=-1,n=!0,t=0;g.length>=2&&g.charCodeAt(1)===I&&v(g.charCodeAt(0))&&(l=r=2);for(let s=g.length-1;s>=l;--s){const o=g.charCodeAt(s);if(h(o)){if(!n){r=s+1;break}continue}a===-1&&(n=!1,a=s+1),o===R?u===-1?u=s:t!==1&&(t=1):u!==-1&&(t=-1)}return u===-1||a===-1||t===0||t===1&&u===a-1&&u===r+1?"":g.slice(u,a)},format:w.bind(null,"\\"),parse(g){S(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const u=g.length;let r=0,a=g.charCodeAt(0);if(u===1)return h(a)?(l.root=l.dir=g,l):(l.base=l.name=g,l);if(h(a)){if(r=1,h(g.charCodeAt(1))){let p=2,P=p;for(;p<u&&!h(g.charCodeAt(p));)p++;if(p<u&&p!==P){for(P=p;p<u&&h(g.charCodeAt(p));)p++;if(p<u&&p!==P){for(P=p;p<u&&!h(g.charCodeAt(p));)p++;p===u?r=p:p!==P&&(r=p+1)}}}}else if(v(a)&&g.charCodeAt(1)===I){if(u<=2)return l.root=l.dir=g,l;if(r=2,h(g.charCodeAt(2))){if(u===3)return l.root=l.dir=g,l;r=3}}r>0&&(l.root=g.slice(0,r));let n=-1,t=r,s=-1,o=!0,c=g.length-1,d=0;for(;c>=r;--c){if(a=g.charCodeAt(c),h(a)){if(!o){t=c+1;break}continue}s===-1&&(o=!1,s=c+1),a===R?n===-1?n=c:d!==1&&(d=1):n!==-1&&(d=-1)}return s!==-1&&(n===-1||d===0||d===1&&n===s-1&&n===t+1?l.base=l.name=g.slice(t,s):(l.name=g.slice(t,n),l.base=g.slice(t,s),l.ext=g.slice(n,s))),t>0&&t!==r?l.dir=g.slice(0,t-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let l="",u=!1;for(let r=g.length-1;r>=-1&&!u;r--){const a=r>=0?g[r]:T.cwd();S(a,"path"),a.length!==0&&(l=`${a}/${l}`,u=a.charCodeAt(0)===b)}return l=m(l,!u,"/",y),u?`/${l}`:l.length>0?l:"."},normalize(g){if(S(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===b,u=g.charCodeAt(g.length-1)===b;return g=m(g,!l,"/",y),g.length===0?l?"/":u?"./":".":(u&&(g+="/"),l?`/${g}`:g)},isAbsolute(g){return S(g,"path"),g.length>0&&g.charCodeAt(0)===b},join(...g){if(g.length===0)return".";let l;for(let u=0;u<g.length;++u){const r=g[u];S(r,"path"),r.length>0&&(l===void 0?l=r:l+=`/${r}`)}return l===void 0?".":e.posix.normalize(l)},relative(g,l){if(S(g,"from"),S(l,"to"),g===l||(g=e.posix.resolve(g),l=e.posix.resolve(l),g===l))return"";const u=1,r=g.length,a=r-u,n=1,t=l.length-n,s=a<t?a:t;let o=-1,c=0;for(;c<s;c++){const p=g.charCodeAt(u+c);if(p!==l.charCodeAt(n+c))break;p===b&&(o=c)}if(c===s)if(t>s){if(l.charCodeAt(n+c)===b)return l.slice(n+c+1);if(c===0)return l.slice(n+c)}else a>s&&(g.charCodeAt(u+c)===b?o=c:c===0&&(o=0));let d="";for(c=u+o+1;c<=r;++c)(c===r||g.charCodeAt(c)===b)&&(d+=d.length===0?"..":"/..");return`${d}${l.slice(n+o)}`},toNamespacedPath(g){return g},dirname(g){if(S(g,"path"),g.length===0)return".";const l=g.charCodeAt(0)===b;let u=-1,r=!0;for(let a=g.length-1;a>=1;--a)if(g.charCodeAt(a)===b){if(!r){u=a;break}}else r=!1;return u===-1?l?"/":".":l&&u===1?"//":g.slice(0,u)},basename(g,l){l!==void 0&&S(l,"ext"),S(g,"path");let u=0,r=-1,a=!0,n;if(l!==void 0&&l.length>0&&l.length<=g.length){if(l===g)return"";let t=l.length-1,s=-1;for(n=g.length-1;n>=0;--n){const o=g.charCodeAt(n);if(o===b){if(!a){u=n+1;break}}else s===-1&&(a=!1,s=n+1),t>=0&&(o===l.charCodeAt(t)?--t==-1&&(r=n):(t=-1,r=s))}return u===r?r=s:r===-1&&(r=g.length),g.slice(u,r)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===b){if(!a){u=n+1;break}}else r===-1&&(a=!1,r=n+1);return r===-1?"":g.slice(u,r)},extname(g){S(g,"path");let l=-1,u=0,r=-1,a=!0,n=0;for(let t=g.length-1;t>=0;--t){const s=g.charCodeAt(t);if(s===b){if(!a){u=t+1;break}continue}r===-1&&(a=!1,r=t+1),s===R?l===-1?l=t:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||r===-1||n===0||n===1&&l===r-1&&l===u+1?"":g.slice(l,r)},format:w.bind(null,"/"),parse(g){S(g,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return l;const u=g.charCodeAt(0)===b;let r;u?(l.root="/",r=1):r=0;let a=-1,n=0,t=-1,s=!0,o=g.length-1,c=0;for(;o>=r;--o){const d=g.charCodeAt(o);if(d===b){if(!s){n=o+1;break}continue}t===-1&&(s=!1,t=o+1),d===R?a===-1?a=o:c!==1&&(c=1):a!==-1&&(c=-1)}if(t!==-1){const d=n===0&&u?1:n;a===-1||c===0||c===1&&a===t-1&&a===n+1?l.base=l.name=g.slice(d,t):(l.name=g.slice(d,a),l.base=g.slice(d,t),l.ext=g.slice(a,t))}return n>0?l.dir=g.slice(0,n-1):u&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=T.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=T.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=T.platform==="win32"?e.win32.join:e.posix.join,e.resolve=T.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=T.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=T.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=T.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=T.platform==="win32"?e.win32.extname:e.posix.extname,e.format=T.platform==="win32"?e.win32.format:e.posix.format,e.parse=T.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=T.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=T.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=T.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(te[101],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var T;(function(L){L[L.stdout=0]="stdout",L[L.stderr=1]="stderr"})(T=e.Source||(e.Source={}));var _;(function(L){L[L.Success=0]="Success",L[L.Unknown=1]="Unknown",L[L.AccessDenied=2]="AccessDenied",L[L.ProcessNotFound=3]="ProcessNotFound"})(_=e.TerminateResponseCode||(e.TerminateResponseCode={}));function k(L,...i){const R=i.reduce((I,E)=>(I[E]=!0,I),{}),b=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(L).filter(I=>!R[I]).forEach(I=>{for(let E=0;E<b.length;E++)if(I.search(b[E])!==-1){delete L[I];break}})}e.sanitizeProcessEnvironment=k}),function(Q,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var T=e();for(var _ in T)(typeof exports=="object"?exports:Q)[_]=T[_]}}(typeof self!="undefined"?self:this,function(){return function(Q){var e={};function T(_){if(e[_])return e[_].exports;var k=e[_]={i:_,l:!1,exports:{}};return Q[_].call(k.exports,k,k.exports,T),k.l=!0,k.exports}return T.m=Q,T.c=e,T.d=function(_,k,L){T.o(_,k)||Object.defineProperty(_,k,{enumerable:!0,get:L})},T.r=function(_){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(_,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(_,"__esModule",{value:!0})},T.t=function(_,k){if(1&k&&(_=T(_)),8&k||4&k&&typeof _=="object"&&_&&_.__esModule)return _;var L=Object.create(null);if(T.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:_}),2&k&&typeof _!="string")for(var i in _)T.d(L,i,function(R){return _[R]}.bind(null,i));return L},T.n=function(_){var k=_&&_.__esModule?function(){return _.default}:function(){return _};return T.d(k,"a",k),k},T.o=function(_,k){return Object.prototype.hasOwnProperty.call(_,k)},T.p="",T(T.s=0)}([function(Q,e,T){(function(_){var k;e=Q.exports=H,k=typeof _=="object"&&_.env&&_.env.NODE_DEBUG&&/\bsemver\b/i.test(_.env.NODE_DEBUG)?function(){var ie=Array.prototype.slice.call(arguments,0);ie.unshift("SEMVER"),console.log.apply(console,ie)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,i=Number.MAX_SAFE_INTEGER||9007199254740991,R=e.re=[],b=e.src=[],C=0,I=C++;b[I]="0|[1-9]\\d*";var E=C++;b[E]="[0-9]+";var f=C++;b[f]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=C++;b[S]="("+b[I]+")\\.("+b[I]+")\\.("+b[I]+")";var h=C++;b[h]="("+b[E]+")\\.("+b[E]+")\\.("+b[E]+")";var y=C++;b[y]="(?:"+b[I]+"|"+b[f]+")";var v=C++;b[v]="(?:"+b[E]+"|"+b[f]+")";var m=C++;b[m]="(?:-("+b[y]+"(?:\\."+b[y]+")*))";var w=C++;b[w]="(?:-?("+b[v]+"(?:\\."+b[v]+")*))";var g=C++;b[g]="[0-9A-Za-z-]+";var l=C++;b[l]="(?:\\+("+b[g]+"(?:\\."+b[g]+")*))";var u=C++,r="v?"+b[S]+b[m]+"?"+b[l]+"?";b[u]="^"+r+"$";var a="[v=\\s]*"+b[h]+b[w]+"?"+b[l]+"?",n=C++;b[n]="^"+a+"$";var t=C++;b[t]="((?:<|>)?=?)";var s=C++;b[s]=b[E]+"|x|X|\\*";var o=C++;b[o]=b[I]+"|x|X|\\*";var c=C++;b[c]="[v=\\s]*("+b[o]+")(?:\\.("+b[o]+")(?:\\.("+b[o]+")(?:"+b[m]+")?"+b[l]+"?)?)?";var d=C++;b[d]="[v=\\s]*("+b[s]+")(?:\\.("+b[s]+")(?:\\.("+b[s]+")(?:"+b[w]+")?"+b[l]+"?)?)?";var p=C++;b[p]="^"+b[t]+"\\s*"+b[c]+"$";var P=C++;b[P]="^"+b[t]+"\\s*"+b[d]+"$";var O=C++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var A=C++;b[A]="(?:~>?)";var N=C++;b[N]="(\\s*)"+b[A]+"\\s+",R[N]=new RegExp(b[N],"g");var $=C++;b[$]="^"+b[A]+b[c]+"$";var D=C++;b[D]="^"+b[A]+b[d]+"$";var F=C++;b[F]="(?:\\^)";var M=C++;b[M]="(\\s*)"+b[F]+"\\s+",R[M]=new RegExp(b[M],"g");var U=C++;b[U]="^"+b[F]+b[c]+"$";var G=C++;b[G]="^"+b[F]+b[d]+"$";var ee=C++;b[ee]="^"+b[t]+"\\s*("+a+")$|^$";var V=C++;b[V]="^"+b[t]+"\\s*("+r+")$|^$";var j=C++;b[j]="(\\s*)"+b[t]+"\\s*("+a+"|"+b[c]+")",R[j]=new RegExp(b[j],"g");var Z=C++;b[Z]="^\\s*("+b[c]+")\\s+-\\s+("+b[c]+")\\s*$";var W=C++;b[W]="^\\s*("+b[d]+")\\s+-\\s+("+b[d]+")\\s*$";var z=C++;b[z]="(<|>)?=?\\s*\\*";for(var B=0;B<35;B++)k(B,b[B]),R[B]||(R[B]=new RegExp(b[B]));function q(ie,ae){if(ie instanceof H)return ie;if(typeof ie!="string"||ie.length>L||!(ae?R[n]:R[u]).test(ie))return null;try{return new H(ie,ae)}catch(le){return null}}function H(ie,ae){if(ie instanceof H){if(ie.loose===ae)return ie;ie=ie.version}else if(typeof ie!="string")throw new TypeError("Invalid Version: "+ie);if(ie.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof H))return new H(ie,ae);k("SemVer",ie,ae),this.loose=ae;var le=ie.trim().match(ae?R[n]:R[u]);if(!le)throw new TypeError("Invalid Version: "+ie);if(this.raw=ie,this.major=+le[1],this.minor=+le[2],this.patch=+le[3],this.major>i||this.major<0)throw new TypeError("Invalid major version");if(this.minor>i||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>i||this.patch<0)throw new TypeError("Invalid patch version");le[4]?this.prerelease=le[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<i)return Ie}return be}):this.prerelease=[],this.build=le[5]?le[5].split("."):[],this.format()}e.parse=q,e.valid=function(ie,ae){var le=q(ie,ae);return le?le.version:null},e.clean=function(ie,ae){var le=q(ie.trim().replace(/^[=v]+/,""),ae);return le?le.version:null},e.SemVer=H,H.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},H.prototype.toString=function(){return this.version},H.prototype.compare=function(ie){return k("SemVer.compare",this.version,this.loose,ie),ie instanceof H||(ie=new H(ie,this.loose)),this.compareMain(ie)||this.comparePre(ie)},H.prototype.compareMain=function(ie){return ie instanceof H||(ie=new H(ie,this.loose)),x(this.major,ie.major)||x(this.minor,ie.minor)||x(this.patch,ie.patch)},H.prototype.comparePre=function(ie){if(ie instanceof H||(ie=new H(ie,this.loose)),this.prerelease.length&&!ie.prerelease.length)return-1;if(!this.prerelease.length&&ie.prerelease.length)return 1;if(!this.prerelease.length&&!ie.prerelease.length)return 0;var ae=0;do{var le=this.prerelease[ae],be=ie.prerelease[ae];if(k("prerelease compare",ae,le,be),le===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(le===void 0)return-1;if(le!==be)return x(le,be)}while(++ae)},H.prototype.inc=function(ie,ae){switch(ie){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var le=this.prerelease.length;--le>=0;)typeof this.prerelease[le]=="number"&&(this.prerelease[le]++,le=-2);le===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+ie)}return this.format(),this.raw=this.version,this},e.inc=function(ie,ae,le,be){typeof le=="string"&&(be=le,le=void 0);try{return new H(ie,le).inc(ae,be).version}catch(Ie){return null}},e.diff=function(ie,ae){if(ce(ie,ae))return null;var le=q(ie),be=q(ae);if(le.prerelease.length||be.prerelease.length){for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in le)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&le[Ie]!==be[Ie])return Ie},e.compareIdentifiers=x;var Y=/^[0-9]+$/;function x(ie,ae){var le=Y.test(ie),be=Y.test(ae);return le&&be&&(ie=+ie,ae=+ae),le&&!be?-1:be&&!le?1:ie<ae?-1:ie>ae?1:0}function K(ie,ae,le){return new H(ie,le).compare(new H(ae,le))}function re(ie,ae,le){return K(ie,ae,le)>0}function se(ie,ae,le){return K(ie,ae,le)<0}function ce(ie,ae,le){return K(ie,ae,le)===0}function he(ie,ae,le){return K(ie,ae,le)!==0}function me(ie,ae,le){return K(ie,ae,le)>=0}function ye(ie,ae,le){return K(ie,ae,le)<=0}function we(ie,ae,le,be){var Ie;switch(ae){case"===":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ie=ie===le;break;case"!==":typeof ie=="object"&&(ie=ie.version),typeof le=="object"&&(le=le.version),Ie=ie!==le;break;case"":case"=":case"==":Ie=ce(ie,le,be);break;case"!=":Ie=he(ie,le,be);break;case">":Ie=re(ie,le,be);break;case">=":Ie=me(ie,le,be);break;case"<":Ie=se(ie,le,be);break;case"<=":Ie=ye(ie,le,be);break;default:throw new TypeError("Invalid operator: "+ae)}return Ie}function pe(ie,ae){if(ie instanceof pe){if(ie.loose===ae)return ie;ie=ie.value}if(!(this instanceof pe))return new pe(ie,ae);k("comparator",ie,ae),this.loose=ae,this.parse(ie),this.semver===Re?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ie,ae){return x(ae,ie)},e.major=function(ie,ae){return new H(ie,ae).major},e.minor=function(ie,ae){return new H(ie,ae).minor},e.patch=function(ie,ae){return new H(ie,ae).patch},e.compare=K,e.compareLoose=function(ie,ae){return K(ie,ae,!0)},e.rcompare=function(ie,ae,le){return K(ae,ie,le)},e.sort=function(ie,ae){return ie.sort(function(le,be){return e.compare(le,be,ae)})},e.rsort=function(ie,ae){return ie.sort(function(le,be){return e.rcompare(le,be,ae)})},e.gt=re,e.lt=se,e.eq=ce,e.neq=he,e.gte=me,e.lte=ye,e.cmp=we,e.Comparator=pe;var Re={};function Ee(ie,ae){if(ie instanceof Ee)return ie.loose===ae?ie:new Ee(ie.raw,ae);if(ie instanceof pe)return new Ee(ie.value,ae);if(!(this instanceof Ee))return new Ee(ie,ae);if(this.loose=ae,this.raw=ie,this.set=ie.split(/\s*\|\|\s*/).map(function(le){return this.parseRange(le.trim())},this).filter(function(le){return le.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ie);this.format()}function De(ie){return!ie||ie.toLowerCase()==="x"||ie==="*"}function Le(ie,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue){return((ae=De(le)?"":De(be)?">="+le+".0.0":De(Ie)?">="+le+"."+be+".0":">="+ae)+" "+(Ne=De(Ae)?"":De(Ue)?"<"+(+Ae+1)+".0.0":De(X)?"<"+Ae+"."+(+Ue+1)+".0":oe?"<="+Ae+"."+Ue+"."+X+"-"+oe:"<="+Ne)).trim()}function Fe(ie,ae){for(var le=0;le<ie.length;le++)if(!ie[le].test(ae))return!1;if(ae.prerelease.length){for(le=0;le<ie.length;le++)if(k(ie[le].semver),ie[le].semver!==Re&&ie[le].semver.prerelease.length>0){var be=ie[le].semver;if(be.major===ae.major&&be.minor===ae.minor&&be.patch===ae.patch)return!0}return!1}return!0}function $e(ie,ae,le){try{ae=new Ee(ae,le)}catch(be){return!1}return ae.test(ie)}function ze(ie,ae,le,be){var Ie,Me,Te,Ne,Ae;switch(ie=new H(ie,be),ae=new Ee(ae,be),le){case">":Ie=re,Me=ye,Te=se,Ne=">",Ae=">=";break;case"<":Ie=se,Me=me,Te=re,Ne="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(ie,ae,be))return!1;for(var Ue=0;Ue<ae.set.length;++Ue){var X=ae.set[Ue],oe=null,ue=null;if(X.forEach(function(fe){fe.semver===Re&&(fe=new pe(">=0.0.0")),oe=oe||fe,ue=ue||fe,Ie(fe.semver,oe.semver,be)?oe=fe:Te(fe.semver,ue.semver,be)&&(ue=fe)}),oe.operator===Ne||oe.operator===Ae||(!ue.operator||ue.operator===Ne)&&Me(ie,ue.semver)||ue.operator===Ae&&Te(ie,ue.semver))return!1}return!0}pe.prototype.parse=function(ie){var ae=this.loose?R[ee]:R[V],le=ie.match(ae);if(!le)throw new TypeError("Invalid comparator: "+ie);this.operator=le[1],this.operator==="="&&(this.operator=""),le[2]?this.semver=new H(le[2],this.loose):this.semver=Re},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ie){return k("Comparator.test",ie,this.loose),this.semver===Re||(typeof ie=="string"&&(ie=new H(ie,this.loose)),we(ie,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ie,ae){if(!(ie instanceof pe))throw new TypeError("a Comparator is required");var le;if(this.operator==="")return le=new Ee(ie.value,ae),$e(this.value,le,ae);if(ie.operator==="")return le=new Ee(this.value,ae),$e(ie.semver,le,ae);var be=!(this.operator!==">="&&this.operator!==">"||ie.operator!==">="&&ie.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ie.operator!=="<="&&ie.operator!=="<"),Me=this.semver.version===ie.semver.version,Te=!(this.operator!==">="&&this.operator!=="<="||ie.operator!==">="&&ie.operator!=="<="),Ne=we(this.semver,"<",ie.semver,ae)&&(this.operator===">="||this.operator===">")&&(ie.operator==="<="||ie.operator==="<"),Ae=we(this.semver,">",ie.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(ie.operator===">="||ie.operator===">");return be||Ie||Me&&Te||Ne||Ae},e.Range=Ee,Ee.prototype.format=function(){return this.range=this.set.map(function(ie){return ie.join(" ").trim()}).join("||").trim(),this.range},Ee.prototype.toString=function(){return this.range},Ee.prototype.parseRange=function(ie){var ae=this.loose;ie=ie.trim(),k("range",ie,ae);var le=ae?R[W]:R[Z];ie=ie.replace(le,Le),k("hyphen replace",ie),ie=ie.replace(R[j],"$1$2$3"),k("comparator trim",ie,R[j]),ie=(ie=(ie=ie.replace(R[N],"$1~")).replace(R[M],"$1^")).split(/\s+/).join(" ");var be=ae?R[ee]:R[V],Ie=ie.split(" ").map(function(Me){return function(Te,Ne){return k("comp",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){k("caret",oe,ue);var fe=ue?R[G]:R[U];return oe.replace(fe,function(Se,ge,Ce,Pe,ke){var _e;return k("caret",oe,Se,ge,Ce,Pe,ke),De(ge)?_e="":De(Ce)?_e=">="+ge+".0.0 <"+(+ge+1)+".0.0":De(Pe)?_e=ge==="0"?">="+ge+"."+Ce+".0 <"+ge+"."+(+Ce+1)+".0":">="+ge+"."+Ce+".0 <"+(+ge+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),_e=ge==="0"?Ce==="0"?">="+ge+"."+Ce+"."+Pe+ke+" <"+ge+"."+Ce+"."+(+Pe+1):">="+ge+"."+Ce+"."+Pe+ke+" <"+ge+"."+(+Ce+1)+".0":">="+ge+"."+Ce+"."+Pe+ke+" <"+(+ge+1)+".0.0"):(k("no pr"),_e=ge==="0"?Ce==="0"?">="+ge+"."+Ce+"."+Pe+" <"+ge+"."+Ce+"."+(+Pe+1):">="+ge+"."+Ce+"."+Pe+" <"+ge+"."+(+Ce+1)+".0":">="+ge+"."+Ce+"."+Pe+" <"+(+ge+1)+".0.0"),k("caret return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),k("caret",Te),Te=function(Ae,Ue){return Ae.trim().split(/\s+/).map(function(X){return function(oe,ue){var fe=ue?R[D]:R[$];return oe.replace(fe,function(Se,ge,Ce,Pe,ke){var _e;return k("tilde",oe,Se,ge,Ce,Pe,ke),De(ge)?_e="":De(Ce)?_e=">="+ge+".0.0 <"+(+ge+1)+".0.0":De(Pe)?_e=">="+ge+"."+Ce+".0 <"+ge+"."+(+Ce+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),_e=">="+ge+"."+Ce+"."+Pe+ke+" <"+ge+"."+(+Ce+1)+".0"):_e=">="+ge+"."+Ce+"."+Pe+" <"+ge+"."+(+Ce+1)+".0",k("tilde return",_e),_e})}(X,Ue)}).join(" ")}(Te,Ne),k("tildes",Te),Te=function(Ae,Ue){return k("replaceXRanges",Ae,Ue),Ae.split(/\s+/).map(function(X){return function(oe,ue){oe=oe.trim();var fe=ue?R[P]:R[p];return oe.replace(fe,function(Se,ge,Ce,Pe,ke,_e){k("xRange",oe,Se,ge,Ce,Pe,ke,_e);var qe=De(Ce),He=qe||De(Pe),Ye=He||De(ke);return ge==="="&&Ye&&(ge=""),qe?Se=ge===">"||ge==="<"?"<0.0.0":"*":ge&&Ye?(He&&(Pe=0),Ye&&(ke=0),ge===">"?(ge=">=",He?(Ce=+Ce+1,Pe=0,ke=0):Ye&&(Pe=+Pe+1,ke=0)):ge==="<="&&(ge="<",He?Ce=+Ce+1:Pe=+Pe+1),Se=ge+Ce+"."+Pe+"."+ke):He?Se=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":Ye&&(Se=">="+Ce+"."+Pe+".0 <"+Ce+"."+(+Pe+1)+".0"),k("xRange return",Se),Se})}(X,Ue)}).join(" ")}(Te,Ne),k("xrange",Te),Te=function(Ae,Ue){return k("replaceStars",Ae,Ue),Ae.trim().replace(R[z],"")}(Te,Ne),k("stars",Te),Te}(Me,ae)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(be)})),Ie=Ie.map(function(Me){return new pe(Me,ae)})},Ee.prototype.intersects=function(ie,ae){if(!(ie instanceof Ee))throw new TypeError("a Range is required");return this.set.some(function(le){return le.every(function(be){return ie.set.some(function(Ie){return Ie.every(function(Me){return be.intersects(Me,ae)})})})})},e.toComparators=function(ie,ae){return new Ee(ie,ae).set.map(function(le){return le.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ee.prototype.test=function(ie){if(!ie)return!1;typeof ie=="string"&&(ie=new H(ie,this.loose));for(var ae=0;ae<this.set.length;ae++)if(Fe(this.set[ae],ie))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(ie,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch(Te){return null}return ie.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==-1||(Ie=new H(be=Te,le)))}),be},e.minSatisfying=function(ie,ae,le){var be=null,Ie=null;try{var Me=new Ee(ae,le)}catch(Te){return null}return ie.forEach(function(Te){Me.test(Te)&&(be&&Ie.compare(Te)!==1||(Ie=new H(be=Te,le)))}),be},e.validRange=function(ie,ae){try{return new Ee(ie,ae).range||"*"}catch(le){return null}},e.ltr=function(ie,ae,le){return ze(ie,ae,"<",le)},e.gtr=function(ie,ae,le){return ze(ie,ae,">",le)},e.outside=ze,e.prerelease=function(ie,ae){var le=q(ie,ae);return le&&le.prerelease.length?le.prerelease:null},e.intersects=function(ie,ae,le){return ie=new Ee(ie,le),ae=new Ee(ae,le),ie.intersects(ae)},e.coerce=function(ie){if(ie instanceof H)return ie;if(typeof ie!="string")return null;var ae=ie.match(R[O]);return ae==null?null:q((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,T(1))},function(Q,e){var T,_,k=Q.exports={};function L(){throw new Error("setTimeout has not been defined")}function i(){throw new Error("clearTimeout has not been defined")}function R(v){if(T===setTimeout)return setTimeout(v,0);if((T===L||!T)&&setTimeout)return T=setTimeout,setTimeout(v,0);try{return T(v,0)}catch(m){try{return T.call(null,v,0)}catch(w){return T.call(this,v,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:L}catch(v){T=L}try{_=typeof clearTimeout=="function"?clearTimeout:i}catch(v){_=i}})();var b,C=[],I=!1,E=-1;function f(){I&&b&&(I=!1,b.length?C=b.concat(C):E=-1,C.length&&S())}function S(){if(!I){var v=R(f);I=!0;for(var m=C.length;m;){for(b=C,C=[];++E<m;)b&&b[E].run();E=-1,m=C.length}b=null,I=!1,function(w){if(_===clearTimeout)return clearTimeout(w);if((_===i||!_)&&clearTimeout)return _=clearTimeout,clearTimeout(w);try{_(w)}catch(g){try{return _.call(null,w)}catch(l){return _.call(this,w)}}}(v)}}function h(v,m){this.fun=v,this.array=m}function y(){}k.nextTick=function(v){var m=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)m[w-1]=arguments[w];C.push(new h(v,m)),C.length!==1||I||R(S)},h.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(v){return[]},k.binding=function(v){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(v){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(te[102],ne([0,1]),function(Q,e){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class _{constructor(R,b,C){this.level=R,this.key=b,this.value=C,this.forward=[]}}const k=void 0;class L{constructor(R,b=2**16){this.comparator=R,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(b)|0),this._header=new _(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new _(this._maxLevel,k,k)}has(R){return Boolean(L._search(this,R,this.comparator))}get(R){return L._search(this,R,this.comparator)?.value}set(R,b){return L._insert(this,R,b,this.comparator)&&(this._size+=1),this}delete(R){const b=L._delete(this,R,this.comparator);return b&&(this._size-=1),b}forEach(R,b){let C=this._header.forward[0];for(;C;)R.call(b,C.value,C.key,this),C=C.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let R=this._header.forward[0];for(;R;)yield[R.key,R.value],R=R.forward[0]}*keys(){let R=this._header.forward[0];for(;R;)yield R.key,R=R.forward[0]}*values(){let R=this._header.forward[0];for(;R;)yield R.value,R=R.forward[0]}toString(){let R="[SkipList]:",b=this._header.forward[0];for(;b;)R+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return R}static _search(R,b,C){let I=R._header;for(let E=R._level-1;E>=0;E--)for(;I.forward[E]&&C(I.forward[E].key,b)<0;)I=I.forward[E];if(I=I.forward[0],I&&C(I.key,b)===0)return I}static _insert(R,b,C,I){let E=[],f=R._header;for(let S=R._level-1;S>=0;S--){for(;f.forward[S]&&I(f.forward[S].key,b)<0;)f=f.forward[S];E[S]=f}if(f=f.forward[0],f&&I(f.key,b)===0)return f.value=C,!1;{let S=L._randomLevel(R);if(S>R._level){for(let h=R._level;h<S;h++)E[h]=R._header;R._level=S}f=new _(S,b,C);for(let h=0;h<S;h++)f.forward[h]=E[h].forward[h],E[h].forward[h]=f;return!0}}static _randomLevel(R,b=.5){let C=1;for(;Math.random()<b&&C<R._maxLevel;)C+=1;return C}static _delete(R,b,C){let I=[],E=R._header;for(let f=R._level-1;f>=0;f--){for(;E.forward[f]&&C(E.forward[f].key,b)<0;)E=E.forward[f];I[f]=E}if(E=E.forward[0],!E||C(E.key,b)!==0)return!1;for(let f=0;f<R._level&&I[f].forward[f]===E;f++)I[f].forward[f]=E.forward[f];for(;R._level>0&&R._header.forward[R._level-1]===k;)R._level-=1;return!0}}e.SkipList=L}),define(te[103],ne([0,1,4]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const _=T.globals.performance&&typeof T.globals.performance.now=="function";class k{constructor(i){this._highResolution=_&&i,this._startTime=this._now(),this._stopTime=-1}static create(i=!0){return new k(i)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?T.globals.performance.now():Date.now()}}e.StopWatch=k}),define(te[3],ne([0,1,10,67,2,100,103]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var R;(function(l){l.None=()=>k.Disposable.None;function u(U){return(G,ee=null,V)=>{let j=!1,Z;return Z=U(W=>{if(!j)return Z?Z.dispose():j=!0,G.call(ee,W)},null,V),j&&Z.dispose(),Z}}l.once=u;function r(U,G){return c((ee,V=null,j)=>U(Z=>ee.call(V,G(Z)),null,j))}l.map=r;function a(U,G){return c((ee,V=null,j)=>U(Z=>{G(Z),ee.call(V,Z)},null,j))}l.forEach=a;function n(U,G){return c((ee,V=null,j)=>U(Z=>G(Z)&&ee.call(V,Z),null,j))}l.filter=n;function t(U){return U}l.signal=t;function s(...U){return(G,ee=null,V)=>(0,k.combinedDisposable)(...U.map(j=>j(Z=>G.call(ee,Z),null,V)))}l.any=s;function o(U,G,ee){let V=ee;return r(U,j=>(V=G(V,j),V))}l.reduce=o;function c(U){let G;const ee=new f({onFirstListenerAdd(){G=U(ee.fire,ee)},onLastListenerRemove(){G.dispose()}});return ee.event}function d(U,G,ee=100,V=!1,j){let Z,W,z,B=0;const q=new f({leakWarningThreshold:j,onFirstListenerAdd(){Z=U(H=>{B++,W=G(W,H),V&&!z&&(q.fire(W),W=void 0),clearTimeout(z),z=setTimeout(()=>{const Y=W;W=void 0,z=void 0,(!V||B>1)&&q.fire(Y),B=0},ee)})},onLastListenerRemove(){Z.dispose()}});return q.event}l.debounce=d;function p(U,G=(ee,V)=>ee===V){let ee=!0,V;return n(U,j=>{const Z=ee||!G(j,V);return ee=!1,V=j,Z})}l.latch=p;function P(U,G){return[l.filter(U,G),l.filter(U,ee=>!G(ee))]}l.split=P;function O(U,G=!1,ee=[]){let V=ee.slice(),j=U(z=>{V?V.push(z):W.fire(z)});const Z=()=>{V&&V.forEach(z=>W.fire(z)),V=null},W=new f({onFirstListenerAdd(){j||(j=U(z=>W.fire(z)))},onFirstListenerDidAdd(){V&&(G?setTimeout(Z):Z())},onLastListenerRemove(){j&&j.dispose(),j=null}});return W.event}l.buffer=O;class A{constructor(G){this.event=G}map(G){return new A(r(this.event,G))}forEach(G){return new A(a(this.event,G))}filter(G){return new A(n(this.event,G))}reduce(G,ee){return new A(o(this.event,G,ee))}latch(){return new A(p(this.event))}debounce(G,ee=100,V=!1,j){return new A(d(this.event,G,ee,V,j))}on(G,ee,V){return this.event(G,ee,V)}once(G,ee,V){return u(this.event)(G,ee,V)}}function N(U){return new A(U)}l.chain=N;function $(U,G,ee=V=>V){const V=(...z)=>W.fire(ee(...z)),j=()=>U.on(G,V),Z=()=>U.removeListener(G,V),W=new f({onFirstListenerAdd:j,onLastListenerRemove:Z});return W.event}l.fromNodeEventEmitter=$;function D(U,G,ee=V=>V){const V=(...z)=>W.fire(ee(...z)),j=()=>U.addEventListener(G,V),Z=()=>U.removeEventListener(G,V),W=new f({onFirstListenerAdd:j,onLastListenerRemove:Z});return W.event}l.fromDOMEventEmitter=D;function F(U){return new Promise(G=>u(U)(G))}l.toPromise=F;function M(U,G){return G(void 0),U(ee=>G(ee))}l.runAndSubscribe=M})(R=e.Event||(e.Event={}));class b{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${b._idPool++}`}start(u){this._stopWatch=new i.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}b._idPool=0;let C=-1;function I(l){const u=C;return C=l,{dispose(){C=u}}}e.setGlobalLeakWarningThreshold=I;class E{constructor(u,r=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=r,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let r=C;if(typeof this.customThreshold=="number"&&(r=this.customThreshold),r<=0||u<r)return;this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),n=this._stacks.get(a)||0;if(this._stacks.set(a,n+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=r*.5;let t,s=0;for(const[o,c]of this._stacks)(!t||s<c)&&(t=o,s=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${s}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}class f{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=C>0?new E(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new b(this._options._profName):void 0}get event(){return this._event||(this._event=(u,r,a)=>{this._listeners||(this._listeners=new L.LinkedList);const n=this._listeners.isEmpty();n&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const t=this._listeners.push(r?[u,r]:u);n&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,r);const s=this._leakageMon?.check(this._listeners.size),o=(0,k.toDisposable)(()=>{s&&s(),this._disposed||(t(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return a instanceof k.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new L.LinkedList);for(let r of this._listeners)this._deliveryQueue.push([r,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[r,a]=this._deliveryQueue.shift();try{typeof r=="function"?r.call(void 0,a):r[0].call(r[1],a)}catch(n){(0,T.onUnexpectedError)(n)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=f;class S extends f{async fireAsync(u,r,a){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const n of this._listeners)this._asyncDeliveryQueue.push([n,u]);for(;this._asyncDeliveryQueue.size>0&&!r.isCancellationRequested;){const[n,t]=this._asyncDeliveryQueue.shift(),s=[],o={...t,token:r,waitUntil:c=>{if(Object.isFrozen(s))throw new Error("waitUntil can NOT be called asynchronous");a&&(c=a(c,typeof n=="function"?n:n[0])),s.push(c)}};try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(c){(0,T.onUnexpectedError)(c);continue}Object.freeze(s),await Promise.allSettled(s).then(c=>{for(const d of c)d.status==="rejected"&&(0,T.onUnexpectedError)(d.reason)})}}}}e.AsyncEmitter=S;class h extends f{constructor(u){super(u);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=h;class y extends h{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=y;class v extends f{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(r=>super.fire(r)),this._queuedEvents=[]})}}e.MicrotaskEmitter=v;class m{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new f({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const r={event:u,listener:null};this.events.push(r),this.hasListeners&&this.hook(r);const a=()=>{this.hasListeners&&this.unhook(r);const n=this.events.indexOf(r);this.events.splice(n,1)};return(0,k.toDisposable)((0,_.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(r=>this.emitter.fire(r))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=m;class w{constructor(){this.buffers=[]}wrapEvent(u){return(r,a,n)=>u(t=>{const s=this.buffers[this.buffers.length-1];s?s.push(()=>r.call(a,t)):r.call(a,t)},void 0,n)}bufferEvents(u){const r=[];this.buffers.push(r);const a=u();return this.buffers.pop(),r.forEach(n=>n()),a}}e.EventBufferer=w;class g{constructor(){this.listening=!1,this.inputEvent=R.None,this.inputEventListener=k.Disposable.None,this.emitter=new f({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=g}),define(te[27],ne([0,1,3]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const _=Object.freeze(function(R,b){const C=setTimeout(R.bind(b),0);return{dispose(){clearTimeout(C)}}});var k;(function(R){function b(C){return C===R.None||C===R.Cancelled||C instanceof L?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}R.isCancellationToken=b,R.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:T.Event.None}),R.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:_})})(k=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?_:(this._emitter||(this._emitter=new T.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class i{constructor(b){this._token=void 0,this._parentListener=void 0,this._parentListener=b&&b.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=k.Cancelled}dispose(b=!1){b&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=i}),define(te[47],ne([0,1,3]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class _{constructor(){this._icons=new Map,this._onDidRegister=new T.Emitter}add(I){const E=this._icons.get(I.id);E?I.description?E.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const k=new _;e.iconRegistry=k;function L(C){return C?C.replace(/\$\((.*?)\)/g,(I,E)=>` ${E} `).trim():""}e.getCodiconAriaLabel=L;class i{constructor(I,E,f){this.id=I,this.definition=E,this.description=f,k.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=i,i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function R(C,I){const E=["codicon","codicon-"+C];return I&&E.push("codicon-modifier-"+I),E}e.getClassNamesArray=R;var b;(function(C){C.iconNameSegment="[A-Za-z0-9]+",C.iconNameExpression="[A-Za-z0-9-]+",C.iconModifierExpression="~[A-Za-z]+",C.iconNameCharacter="[A-Za-z0-9~-]";const I=new RegExp(`^(${C.iconNameExpression})(${C.iconModifierExpression})?$`);function E(h){if(h instanceof i)return["codicon","codicon-"+h.id];const y=I.exec(h.id);if(!y)return E(i.error);let[,v,m]=y;const w=["codicon","codicon-"+v];return m&&w.push("codicon-modifier-"+m.substr(1)),w}C.asClassNameArray=E;function f(h){return E(h).join(" ")}C.asClassName=f;function S(h){return"."+E(h).join(".")}C.asCSSSelector=S})(b=e.CSSIcon||(e.CSSIcon={}))}),define(te[48],ne([0,1,10,2]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function k(g){const l=g;return l?[l.on,l.pause,l.resume,l.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=k;function L(g){const l=g;return l?k(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=L;function i(g,l){return new R(g,l)}e.newWriteableStream=i;class R{constructor(l,u){this.reducer=l,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(u=>u(l))}emitError(l){this.listeners.error.length===0?(0,T.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(u=>u(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,u){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(l,u){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const a=r.indexOf(u);a>=0&&r.splice(a,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function b(g,l){const u=[];let r;for(;(r=g.read())!==null;)u.push(r);return l(u)}e.consumeReadable=b;function C(g,l,u){const r=[];let a;for(;(a=g.read())!==null&&r.length<u;)r.push(a);return a===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof a!="undefined"){const n=a;return a=void 0,n}return g.read()}}}e.peekReadable=C;function I(g,l){return new Promise((u,r)=>{const a=[];E(g,{onData:n=>{l&&a.push(n)},onError:n=>{l?r(n):u(void 0)},onEnd:()=>{u(l?l(a):void 0)}})})}e.consumeStream=I;function E(g,l){g.on("error",u=>l.onError(u)),g.on("end",()=>l.onEnd()),g.on("data",u=>l.onData(u))}e.listenStream=E;function f(g,l){return new Promise((u,r)=>{const a=new _.DisposableStore,n=[],t=c=>{if(n.push(c),n.length>l)return a.dispose(),g.pause(),u({stream:g,buffer:n,ended:!1})},s=c=>r(c),o=()=>u({stream:g,buffer:n,ended:!0});a.add((0,_.toDisposable)(()=>g.removeListener("error",s))),g.on("error",s),a.add((0,_.toDisposable)(()=>g.removeListener("end",o))),g.on("end",o),a.add((0,_.toDisposable)(()=>g.removeListener("data",t))),g.on("data",t)})}e.peekStream=f;function S(g,l){const u=i(l);return u.end(g),u}e.toStream=S;function h(){const g=i(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=h;function y(g){let l=!1;return{read:()=>l?null:(l=!0,g)}}e.toReadable=y;function v(g,l,u){const r=i(u);return E(g,{onData:a=>r.write(l.data(a)),onError:a=>r.error(l.error?l.error(a):a),onEnd:()=>r.end()}),r}e.transform=v;function m(g,l,u){let r=!1;return{read:()=>{const a=l.read();return r?a:(r=!0,a!==null?u([g,a]):g)}}}e.prefixedReadable=m;function w(g,l,u){let r=!1;const a=i(u);return E(l,{onData:n=>r?a.write(n):(r=!0,a.write(u([g,n]))),onError:n=>a.error(n),onEnd:()=>{r||(r=!0,a.write(g)),a.end()}}),a}e.prefixedStream=w}),define(te[19],ne([0,1,48]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const _=typeof Buffer!="undefined";let k,L;class i{constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}static alloc(t){return _?new i(Buffer.allocUnsafe(t)):new i(new Uint8Array(t))}static wrap(t){return _&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new i(t)}static fromString(t,s){return!(s?.dontUseNodeBuffer||!1)&&_?new i(Buffer.from(t)):(k||(k=new TextEncoder),new i(k.encode(t)))}static fromByteArray(t){const s=i.alloc(t.length);for(let o=0,c=t.length;o<c;o++)s.buffer[o]=t[o];return s}static concat(t,s){if(typeof s=="undefined"){s=0;for(let d=0,p=t.length;d<p;d++)s+=t[d].byteLength}const o=i.alloc(s);let c=0;for(let d=0,p=t.length;d<p;d++){const P=t[d];o.set(P,c),c+=P.byteLength}return o}clone(){const t=i.alloc(this.byteLength);return t.set(this),t}toString(){return _?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(t,s){return new i(this.buffer.subarray(t,s))}set(t,s){if(t instanceof i)this.buffer.set(t.buffer,s);else if(t instanceof Uint8Array)this.buffer.set(t,s);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),s);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),s);else throw new Error("Unkown argument 'array'")}readUInt32BE(t){return C(this.buffer,t)}writeUInt32BE(t,s){I(this.buffer,t,s)}readUInt32LE(t){return E(this.buffer,t)}writeUInt32LE(t,s){f(this.buffer,t,s)}readUInt8(t){return S(this.buffer,t)}writeUInt8(t,s){h(this.buffer,t,s)}}e.VSBuffer=i;function R(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=R;function b(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255}e.writeUInt16LE=b;function C(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=C;function I(n,t,s){n[s+3]=t,t=t>>>8,n[s+2]=t,t=t>>>8,n[s+1]=t,t=t>>>8,n[s]=t}e.writeUInt32BE=I;function E(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=E;function f(n,t,s){n[s+0]=t&255,t=t>>>8,n[s+1]=t&255,t=t>>>8,n[s+2]=t&255,t=t>>>8,n[s+3]=t&255}e.writeUInt32LE=f;function S(n,t){return n[t]}e.readUInt8=S;function h(n,t,s){n[s]=t}e.writeUInt8=h;function y(n){return T.consumeReadable(n,t=>i.concat(t))}e.readableToBuffer=y;function v(n){return T.toReadable(n)}e.bufferToReadable=v;function m(n){return T.consumeStream(n,t=>i.concat(t))}e.streamToBuffer=m;async function w(n){return n.ended?i.concat(n.buffer):i.concat([...n.buffer,await m(n.stream)])}e.bufferedStreamToBuffer=w;function g(n){return T.toStream(n,t=>i.concat(t))}e.bufferToStream=g;function l(n){return T.transform(n,{data:t=>typeof t=="string"?i.fromString(t):i.wrap(t)},t=>i.concat(t))}e.streamToBufferReadableStream=l;function u(n){return T.newWriteableStream(t=>i.concat(t),n)}e.newWriteableBufferStream=u;function r(n,t){return T.prefixedReadable(n,t,s=>i.concat(s))}e.prefixedBufferReadable=r;function a(n,t){return T.prefixedStream(n,t,s=>i.concat(s))}e.prefixedBufferStream=a}),define(te[25],ne([0,1,4]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function _(X){return!X||typeof X!="string"?!0:X.trim().length===0}e.isFalsyOrWhitespace=_;const k=/{(\d+)}/g;function L(X,...oe){return oe.length===0?X:X.replace(k,function(ue,fe){const Se=parseInt(fe,10);return isNaN(Se)||Se<0||Se>=oe.length?ue:oe[Se]})}e.format=L;const i=/{([^}]+)}/g;function R(X,oe){return X.replace(i,(ue,fe)=>oe[fe]??ue)}e.format2=R;function b(X){return X.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=b;function C(X){return X.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=C;function I(X,oe){let ue=0;const fe=oe.charCodeAt(0);for(let Se=X.length-1;Se>=0;Se--)X.charCodeAt(Se)===fe&&ue++;return ue}e.count=I;function E(X,oe,ue="\u2026"){return X.length<=oe?X:`${X.substr(0,oe)}${ue}`}e.truncate=E;function f(X,oe=" "){const ue=S(X,oe);return h(ue,oe)}e.trim=f;function S(X,oe){if(!X||!oe)return X;const ue=oe.length;if(ue===0||X.length===0)return X;let fe=0;for(;X.indexOf(oe,fe)===fe;)fe=fe+ue;return X.substring(fe)}e.ltrim=S;function h(X,oe){if(!X||!oe)return X;const ue=oe.length,fe=X.length;if(ue===0||fe===0)return X;let Se=fe,ge=-1;for(;ge=X.lastIndexOf(oe,Se-1),!(ge===-1||ge+ue!==Se);){if(ge===0)return"";Se=ge}return X.substring(0,Se)}e.rtrim=h;function y(X){return X.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function v(X){return X.replace(/\*/g,"")}e.stripWildcards=v;function m(X,oe,ue={}){if(!X)throw new Error("Cannot create regex from empty string");oe||(X=C(X)),ue.wholeWord&&(/\B/.test(X.charAt(0))||(X="\\b"+X),/\B/.test(X.charAt(X.length-1))||(X=X+"\\b"));let fe="";return ue.global&&(fe+="g"),ue.matchCase||(fe+="i"),ue.multiline&&(fe+="m"),ue.unicode&&(fe+="u"),new RegExp(X,fe)}e.createRegExp=m;function w(X){return X.source==="^"||X.source==="^$"||X.source==="$"||X.source==="^\\s*$"?!1:!!(X.exec("")&&X.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function g(X){return!!X.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function l(X){return(X.global?"g":"")+(X.ignoreCase?"i":"")+(X.multiline?"m":"")+(X.unicode?"u":"")}e.regExpFlags=l;function u(X){return X.split(/\r\n|\r|\n/)}e.splitLines=u;function r(X){for(let oe=0,ue=X.length;oe<ue;oe++){const fe=X.charCodeAt(oe);if(fe!==32&&fe!==9)return oe}return-1}e.firstNonWhitespaceIndex=r;function a(X,oe=0,ue=X.length){for(let fe=oe;fe<ue;fe++){const Se=X.charCodeAt(fe);if(Se!==32&&Se!==9)return X.substring(oe,fe)}return X.substring(oe,ue)}e.getLeadingWhitespace=a;function n(X,oe=X.length-1){for(let ue=oe;ue>=0;ue--){const fe=X.charCodeAt(ue);if(fe!==32&&fe!==9)return ue}return-1}e.lastNonWhitespaceIndex=n;function t(X,oe){return X<oe?-1:X>oe?1:0}e.compare=t;function s(X,oe,ue=0,fe=X.length,Se=0,ge=oe.length){for(;ue<fe&&Se<ge;ue++,Se++){let ke=X.charCodeAt(ue),_e=oe.charCodeAt(Se);if(ke<_e)return-1;if(ke>_e)return 1}const Ce=fe-ue,Pe=ge-Se;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstring=s;function o(X,oe){return c(X,oe,0,X.length,0,oe.length)}e.compareIgnoreCase=o;function c(X,oe,ue=0,fe=X.length,Se=0,ge=oe.length){for(;ue<fe&&Se<ge;ue++,Se++){let ke=X.charCodeAt(ue),_e=oe.charCodeAt(Se);if(ke===_e)continue;if(ke>=128||_e>=128)return s(X.toLowerCase(),oe.toLowerCase(),ue,fe,Se,ge);d(ke)&&(ke-=32),d(_e)&&(_e-=32);const qe=ke-_e;if(qe!==0)return qe}const Ce=fe-ue,Pe=ge-Se;return Ce<Pe?-1:Ce>Pe?1:0}e.compareSubstringIgnoreCase=c;function d(X){return X>=97&&X<=122}e.isLowerAsciiLetter=d;function p(X){return X>=65&&X<=90}e.isUpperAsciiLetter=p;function P(X,oe){return X.length===oe.length&&c(X,oe)===0}e.equalsIgnoreCase=P;function O(X,oe){const ue=oe.length;return oe.length>X.length?!1:c(X,oe,0,ue)===0}e.startsWithIgnoreCase=O;function A(X,oe){let ue,fe=Math.min(X.length,oe.length);for(ue=0;ue<fe;ue++)if(X.charCodeAt(ue)!==oe.charCodeAt(ue))return ue;return fe}e.commonPrefixLength=A;function N(X,oe){let ue,fe=Math.min(X.length,oe.length);const Se=X.length-1,ge=oe.length-1;for(ue=0;ue<fe;ue++)if(X.charCodeAt(Se-ue)!==oe.charCodeAt(ge-ue))return ue;return fe}e.commonSuffixLength=N;function $(X){return 55296<=X&&X<=56319}e.isHighSurrogate=$;function D(X){return 56320<=X&&X<=57343}e.isLowSurrogate=D;function F(X,oe){return(X-55296<<10)+(oe-56320)+65536}e.computeCodePoint=F;function M(X,oe,ue){const fe=X.charCodeAt(ue);if($(fe)&&ue+1<oe){const Se=X.charCodeAt(ue+1);if(D(Se))return F(fe,Se)}return fe}e.getNextCodePoint=M;function U(X,oe){const ue=X.charCodeAt(oe-1);if(D(ue)&&oe>1){const fe=X.charCodeAt(oe-2);if($(fe))return F(fe,ue)}return ue}function G(X,oe){const ue=ae.getInstance(),fe=oe,Se=X.length,ge=M(X,Se,oe);oe+=ge>=65536?2:1;let Ce=ue.getGraphemeBreakType(ge);for(;oe<Se;){const Pe=M(X,Se,oe),ke=ue.getGraphemeBreakType(Pe);if(ze(Ce,ke))break;oe+=Pe>=65536?2:1,Ce=ke}return oe-fe}e.nextCharLength=G;function ee(X,oe){const ue=ae.getInstance(),fe=oe,Se=U(X,oe);oe-=Se>=65536?2:1;let ge=ue.getGraphemeBreakType(Se);for(;oe>0;){const Ce=U(X,oe),Pe=ue.getGraphemeBreakType(Ce);if(ze(Pe,ge))break;oe-=Ce>=65536?2:1,ge=Pe}return fe-oe}e.prevCharLength=ee;function V(X,oe){const ue=ae.getInstance(),fe=X.length,Se=oe,ge=M(X,fe,oe),Ce=ue.getGraphemeBreakType(ge);oe+=ge>=65536?2:1;let Pe=Ce;for(;oe<fe;){const _e=M(X,fe,oe),qe=ue.getGraphemeBreakType(_e);if(ze(Pe,qe))break;oe+=_e>=65536?2:1,Pe=qe}const ke=oe;for(oe=Se,Pe=Ce;oe>0;){const _e=U(X,oe),qe=ue.getGraphemeBreakType(_e);if(ze(qe,Pe))break;oe-=_e>=65536?2:1,Pe=qe}return[oe,ke]}function j(X,oe){return oe>0&&D(X.charCodeAt(oe))?V(X,oe-1):V(X,oe)}e.getCharContainingOffset=j;const Z=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(X){return Z.test(X)}e.containsRTL=W;const z=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function B(X){return z.test(X)}e.containsEmoji=B;const q=/^[\t\n\r\x20-\x7E]*$/;function H(X){return q.test(X)}e.isBasicASCII=H,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(X){return e.UNUSUAL_LINE_TERMINATORS.test(X)}e.containsUnusualLineTerminators=Y;function x(X){for(let oe=0,ue=X.length;oe<ue;oe++)if(K(X.charCodeAt(oe)))return!0;return!1}e.containsFullWidthCharacter=x;function K(X){return X>=11904&&X<=55215||X>=63744&&X<=64255||X>=65281&&X<=65374}e.isFullWidthCharacter=K;function re(X){return X>=127462&&X<=127487||X===8986||X===8987||X===9200||X===9203||X>=9728&&X<=10175||X===11088||X===11093||X>=127744&&X<=128591||X>=128640&&X<=128764||X>=128992&&X<=129008||X>=129280&&X<=129535||X>=129648&&X<=129782}e.isEmojiImprecise=re;function se(X,oe){if(X.length<oe)return X;const ue=/\b/g;let fe=0;for(;ue.test(X)&&!(X.length-ue.lastIndex<oe);)fe=ue.lastIndex,ue.lastIndex+=1;return X.substring(fe).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function ye(X){return X&&(X=X.replace(ce,""),X=X.replace(he,""),X=X.replace(me,"")),X}e.removeAnsiEscapeCodes=ye,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(X){return!!(X&&X.length>0&&X.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function pe(X){return we(X)?X.substr(1):X}e.stripUTF8BOM=pe;function Re(X,oe){if(!X||!oe||X.length<oe.length)return!1;const ue=oe.length,fe=X.toLowerCase();let Se=0,ge=-1;for(;Se<ue;){const Ce=fe.indexOf(oe[Se],ge+1);if(Ce<0)return!1;ge=Ce,Se++}return!0}e.fuzzyContains=Re;function Ee(X,oe=!1){return X?(oe&&(X=X.replace(/\\./g,"")),X.toLowerCase()!==X):!1}e.containsUppercaseCharacter=Ee;function De(X){return X.charAt(0).toUpperCase()+X.slice(1)}e.uppercaseFirstLetter=De;function Le(X,oe=1){if(oe===0)return"";let ue=-1;do ue=X.indexOf(`
`,ue+1),oe--;while(oe>0&&ue>=0);return ue===-1?X:(X[ue-1]==="\r"&&ue--,X.substr(0,ue))}e.getNLines=Le;function Fe(X){const oe=90-65+1;return X=X%(2*oe),X<oe?String.fromCharCode(97+X):String.fromCharCode(65+X-oe)}e.singleLetterHash=Fe;function $e(X){return ae.getInstance().getGraphemeBreakType(X)}e.getGraphemeBreakType=$e;function ze(X,oe){return X===0?oe!==5&&oe!==7:X===2&&oe===3?!1:X===4||X===2||X===3||oe===4||oe===2||oe===3?!0:!(X===8&&(oe===8||oe===9||oe===11||oe===12)||(X===11||X===9)&&(oe===9||oe===10)||(X===12||X===10)&&oe===10||oe===5||oe===13||oe===7||X===1||X===13&&oe===14||X===6&&oe===6)}e.breakBetweenGraphemeBreakType=ze;var ie;(function(X){X[X.Other=0]="Other",X[X.Prepend=1]="Prepend",X[X.CR=2]="CR",X[X.LF=3]="LF",X[X.Control=4]="Control",X[X.Extend=5]="Extend",X[X.Regional_Indicator=6]="Regional_Indicator",X[X.SpacingMark=7]="SpacingMark",X[X.L=8]="L",X[X.V=9]="V",X[X.T=10]="T",X[X.LV=11]="LV",X[X.LVT=12]="LVT",X[X.ZWJ=13]="ZWJ",X[X.Extended_Pictographic=14]="Extended_Pictographic"})(ie=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ae{constructor(){this._data=le()}static getInstance(){return ae._INSTANCE||(ae._INSTANCE=new ae),ae._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const ue=this._data,fe=ue.length/3;let Se=1;for(;Se<=fe;)if(oe<ue[3*Se])Se=2*Se;else if(oe>ue[3*Se+1])Se=2*Se+1;else return ue[3*Se+2];return 0}}ae._INSTANCE=null;function le(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function be(X,oe){if(X===0)return 0;const ue=Ie(X,oe);if(ue!==void 0)return ue;const fe=U(oe,X);return X-=Me(fe),X}e.getLeftDeleteOffset=be;function Ie(X,oe){let ue=U(oe,X);for(X-=Me(ue);Te(ue)||ue===65039||ue===8419;){if(X===0)return;ue=U(oe,X),X-=Me(ue)}if(!!re(ue)){if(X>=0){const fe=U(oe,X);fe===8205&&(X-=Me(fe))}return X}}function Me(X){return X>=65536?2:1}function Te(X){return 127995<=X&&X<=127999}var Ne;(function(X){X[X.zwj=8205]="zwj",X[X.emojiVariantSelector=65039]="emojiVariantSelector",X[X.enclosingKeyCap=8419]="enclosingKeyCap"})(Ne||(Ne={})),e.noBreakWhitespace="\xA0";class Ae{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ae.map){let fe=function(Ce){const Pe=new Map;for(let ke=0;ke<Ce.length;ke+=2)Pe.set(Ce[ke],Ce[ke+1]);return Pe};const oe=Ae.getData();let ue=T.locale;(!ue||!(ue in oe))&&(ue=T.language),(!ue||!(ue in oe))&&(ue="_default");const Se=fe(oe._common),ge=fe(oe[ue]);for(const[Ce,Pe]of ge)Se.set(Ce,Pe);Ae.map=Se}return Ae.map}static isAmbiguous(oe){return Ae.getConfusablesForCurrentLocale().has(oe)}static getPrimaryConfusable(oe){return Ae.getConfusablesForCurrentLocale().get(oe)}static getPrimaryConfusableCodePoints(){return new Set(Ae.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ae;class Ue{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ue.getRawData())),this._data}static isInvisibleCharacter(oe){return Ue.getData().has(oe)}static get codePoints(){return Ue.getData()}}e.InvisibleCharacters=Ue,Ue._data=void 0}),define(te[104],ne([0,1,25]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function _(m){return k(m,0)}e.hash=_;function k(m,w){switch(typeof m){case"object":return m===null?L(349,w):Array.isArray(m)?b(m,w):C(m,w);case"string":return R(m,w);case"boolean":return i(m,w);case"number":return L(m,w);case"undefined":return L(937,w);default:return L(617,w)}}e.doHash=k;function L(m,w){return(w<<5)-w+m|0}e.numberHash=L;function i(m,w){return L(m?433:863,w)}function R(m,w){w=L(149417,w);for(let g=0,l=m.length;g<l;g++)w=L(m.charCodeAt(g),w);return w}e.stringHash=R;function b(m,w){return w=L(104579,w),m.reduce((g,l)=>k(l,g),w)}function C(m,w){return w=L(181387,w),Object.keys(m).sort().reduce((g,l)=>(g=R(l,g),k(m[l],g)),w)}class I{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=k(w,this._value),this._value}}e.Hasher=I;var E;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function f(m,w,g=32){const l=g-w,u=~((1<<l)-1);return(m<<w|(u&m)>>>l)>>>0}function S(m,w=0,g=m.byteLength,l=0){for(let u=0;u<g;u++)m[w+u]=l}function h(m,w,g="0"){for(;m.length<w;)m=g+m;return m}function y(m,w=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(g=>g.toString(16).padStart(2,"0")).join(""):h((m>>>0).toString(16),w/4)}e.toHexString=y;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const g=w.length;if(g===0)return;const l=this._buff;let u=this._buffLen,r=this._leftoverHighSurrogate,a,n;for(r!==0?(a=r,n=-1,r=0):(a=w.charCodeAt(0),n=0);;){let t=a;if(T.isHighSurrogate(a))if(n+1<g){const s=w.charCodeAt(n+1);T.isLowSurrogate(s)?(n++,t=T.computeCodePoint(a,s)):t=65533}else{r=a;break}else T.isLowSurrogate(a)&&(t=65533);if(u=this._push(l,u,t),n++,n<g)a=w.charCodeAt(n);else break}this._buffLen=u,this._leftoverHighSurrogate=r}_push(w,g,l){return l<128?w[g++]=l:l<2048?(w[g++]=192|(l&1984)>>>6,w[g++]=128|(l&63)>>>0):l<65536?(w[g++]=224|(l&61440)>>>12,w[g++]=128|(l&4032)>>>6,w[g++]=128|(l&63)>>>0):(w[g++]=240|(l&1835008)>>>18,w[g++]=128|(l&258048)>>>12,w[g++]=128|(l&4032)>>>6,w[g++]=128|(l&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),y(this._h0)+y(this._h1)+y(this._h2)+y(this._h3)+y(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,S(this._buff,this._buffLen),this._buffLen>56&&(this._step(),S(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=v._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)w.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,f(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let l=this._h0,u=this._h1,r=this._h2,a=this._h3,n=this._h4,t,s,o;for(let c=0;c<80;c++)c<20?(t=u&r|~u&a,s=1518500249):c<40?(t=u^r^a,s=1859775393):c<60?(t=u&r|u&a|r&a,s=2400959708):(t=u^r^a,s=3395469782),o=f(l,5)+t+n+s+w.getUint32(c*4,!1)&4294967295,n=a,a=r,r=f(u,30),u=l,l=o;this._h0=this._h0+l&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+r&4294967295,this._h3=this._h3+a&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))});var bt=this&&this.__classPrivateFieldSet||function(Q,e,T,_,k){if(_==="m")throw new TypeError("Private method is not writable");if(_==="a"&&!k)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Q!==e||!k:!e.has(Q))throw new TypeError("Cannot write private member to an object whose class did not declare it");return _==="a"?k.call(Q,T):k?k.value=T:e.set(Q,T),T},Ve=this&&this.__classPrivateFieldGet||function(Q,e,T,_){if(T==="a"&&!_)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Q!==e||!_:!e.has(Q))throw new TypeError("Cannot read private member from an object whose class did not declare it");return T==="m"?_:T==="a"?_.call(Q):_?_.value:e.get(Q)};define(te[39],ne([0,1,16,25]),function(Q,e,T,_){"use strict";var k,L,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function R(n,t,s){let o=n.get(t);return o===void 0&&(o=s,n.set(t,o)),o}e.getOrSet=R;function b(n){const t=[];return n.forEach((s,o)=>{t.push(`${o} => ${s}`)}),`Map(${n.size}) {${t.join(", ")}}`}e.mapToString=b;function C(n){const t=[];return n.forEach(s=>{t.push(s)}),`Set(${n.size}) {${t.join(", ")}}`}e.setToString=C;class I{constructor(){this._value="",this._pos=0}reset(t){return this._value=t,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(t){const s=t.charCodeAt(0),o=this._value.charCodeAt(this._pos);return s-o}value(){return this._value[this._pos]}}e.StringIterator=I;class E{constructor(t=!0){this._caseSensitive=t}reset(t){return this._value=t,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let t=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(t)this._from++;else break;else t=!1;return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=E;class f{constructor(t=!0,s=!0){this._splitOnBackslash=t,this._caseSensitive=s}reset(t){this._from=0,this._to=0,this._value=t,this._valueLen=t.length;for(let s=t.length-1;s>=0;s--,this._valueLen--){const o=this._value.charCodeAt(s);if(!(o===47||this._splitOnBackslash&&o===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let t=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(t)this._from++;else break;else t=!1}return this}cmp(t){return this._caseSensitive?(0,_.compareSubstring)(t,this._value,0,t.length,this._from,this._to):(0,_.compareSubstringIgnoreCase)(t,this._value,0,t.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=f;var S;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(S||(S={}));class h{constructor(t){this._ignorePathCasing=t,this._states=[],this._stateIdx=0}reset(t){return this._value=t,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new f(!1,!this._ignorePathCasing(t)),this._pathIterator.reset(t.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(t){if(this._states[this._stateIdx]===1)return(0,_.compareIgnoreCase)(t,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,_.compareIgnoreCase)(t,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(t);if(this._states[this._stateIdx]===4)return(0,_.compare)(t,this._value.query);if(this._states[this._stateIdx]===5)return(0,_.compare)(t,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const t=this.right;return this.right=t.left,t.left=this,this.updateHeight(),t.updateHeight(),t}rotateRight(){const t=this.left;return this.left=t.right,t.right=this,this.updateHeight(),t.updateHeight(),t}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(v||(v={}));class m{constructor(t){this._iter=t}static forUris(t=()=>!1){return new m(new h(t))}static forPaths(){return new m(new f)}static forStrings(){return new m(new I)}static forConfigKeys(){return new m(new E)}clear(){this._root=void 0}fill(t,s){if(s){const o=s.slice(0);(0,T.shuffle)(o);for(let c of o)this.set(c,t)}else{const o=t.slice(0);(0,T.shuffle)(o);for(let c of o)this.set(c[0],c[1])}}set(t,s){const o=this._iter.reset(t);let c;this._root||(this._root=new y,this._root.segment=o.value());const d=[];for(c=this._root;;){const P=o.cmp(c.segment);if(P>0)c.left||(c.left=new y,c.left.segment=o.value()),d.push([-1,c]),c=c.left;else if(P<0)c.right||(c.right=new y,c.right.segment=o.value()),d.push([1,c]),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new y,c.mid.segment=o.value()),d.push([0,c]),c=c.mid;else break}const p=c.value;c.value=s,c.key=t;for(let P=d.length-1;P>=0;P--){const O=d[P][1];O.updateHeight();const A=O.balanceFactor();if(A<-1||A>1){const N=d[P][0],$=d[P+1][0];if(N===1&&$===1)d[P][1]=O.rotateLeft();else if(N===-1&&$===-1)d[P][1]=O.rotateRight();else if(N===1&&$===-1)O.right=d[P+1][1]=d[P+1][1].rotateRight(),d[P][1]=O.rotateLeft();else if(N===-1&&$===1)O.left=d[P+1][1]=d[P+1][1].rotateLeft(),d[P][1]=O.rotateRight();else throw new Error;if(P>0)switch(d[P-1][0]){case-1:d[P-1][1].left=d[P][1];break;case 1:d[P-1][1].right=d[P][1];break;case 0:d[P-1][1].mid=d[P][1];break}else this._root=d[0][1]}}return p}get(t){return this._getNode(t)?.value}_getNode(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else break}return o}has(t){const s=this._getNode(t);return!(s?.value===void 0&&s?.mid===void 0)}delete(t){return this._delete(t,!1)}deleteSuperstr(t){return this._delete(t,!0)}_delete(t,s){const o=this._iter.reset(t),c=[];let d=this._root;for(;d;){const p=o.cmp(d.segment);if(p>0)c.push([-1,d]),d=d.left;else if(p<0)c.push([1,d]),d=d.right;else if(o.hasNext())o.next(),c.push([0,d]),d=d.mid;else break}if(!!d){if(s?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const p=this._min(d.right),{key:P,value:O,segment:A}=p;this._delete(p.key,!1),d.key=P,d.value=O,d.segment=A}else{const p=d.left??d.right;if(c.length>0){const[P,O]=c[c.length-1];switch(P){case-1:O.left=p;break;case 0:O.mid=p;break;case 1:O.right=p;break}}else this._root=p}for(let p=c.length-1;p>=0;p--){const P=c[p][1];P.updateHeight();const O=P.balanceFactor();if(O>1?(P.right.balanceFactor()>=0||(P.right=P.right.rotateRight()),c[p][1]=P.rotateLeft()):O<-1&&(P.left.balanceFactor()<=0||(P.left=P.left.rotateLeft()),c[p][1]=P.rotateRight()),p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this._root=c[0][1]}}}_min(t){for(;t.left;)t=t.left;return t}findSubstr(t){const s=this._iter.reset(t);let o=this._root,c;for(;o;){const d=s.cmp(o.segment);if(d>0)o=o.left;else if(d<0)o=o.right;else if(s.hasNext())s.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(t){const s=this._iter.reset(t);let o=this._root;for(;o;){const c=s.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(t){for(const[s,o]of this)t(o,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(t){!t||(t.left&&(yield*this._entries(t.left)),t.value&&(yield[t.key,t.value]),t.mid&&(yield*this._entries(t.mid)),t.right&&(yield*this._entries(t.right)))}_isBalanced(){const t=s=>{if(!s)return!0;const o=s.balanceFactor();return o<-1||o>1?!1:t(s.left)&&t(s.right)};return t(this._root)}}e.TernarySearchTree=m;class w{constructor(t,s){this.uri=t,this.value=s}}class g{constructor(t,s){this[k]="ResourceMap",t instanceof g?(this.map=new Map(t.map),this.toKey=s??g.defaultToKey):(this.map=new Map,this.toKey=t??g.defaultToKey)}set(t,s){return this.map.set(this.toKey(t),new w(t,s)),this}get(t){return this.map.get(this.toKey(t))?.value}has(t){return this.map.has(this.toKey(t))}get size(){return this.map.size}clear(){this.map.clear()}delete(t){return this.map.delete(this.toKey(t))}forEach(t,s){typeof s!="undefined"&&(t=t.bind(s));for(let[o,c]of this.map)t(c.value,c.uri,this)}*values(){for(let t of this.map.values())yield t.value}*keys(){for(let t of this.map.values())yield t.uri}*entries(){for(let t of this.map.values())yield[t.uri,t.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(let[,t]of this.map)yield[t.uri,t.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();var l;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class u{constructor(){this[L]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(t){return this._map.has(t)}get(t,s=0){const o=this._map.get(t);if(!!o)return s!==0&&this.touch(o,s),o.value}set(t,s,o=0){let c=this._map.get(t);if(c)c.value=s,o!==0&&this.touch(c,o);else{switch(c={key:t,value:s,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(t,c),this._size++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this._map.get(t);if(!!s)return this._map.delete(t),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const t=this._head;return this._map.delete(t.key),this.removeItem(t),this._size--,t.value}forEach(t,s){const o=this._state;let c=this._head;for(;c;){if(s?t.bind(s)(c.value,c.key,this):t(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.key,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return c}values(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:o.value,done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return c}entries(){const t=this,s=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(t._state!==s)throw new Error("LinkedMap got modified during iteration.");if(o){const d={value:[o.key,o.value],done:!1};return o=o.next,d}else return{value:void 0,done:!0}}};return c}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this._head,o=this.size;for(;s&&o>t;)this._map.delete(s.key),s=s.next,o--;this._head=s,this._size=o,s&&(s.previous=void 0),this._state++}addItemFirst(t){if(!this._head&&!this._tail)this._tail=t;else if(this._head)t.next=this._head,this._head.previous=t;else throw new Error("Invalid list");this._head=t,this._state++}addItemLast(t){if(!this._head&&!this._tail)this._head=t;else if(this._tail)t.previous=this._tail,this._tail.next=t;else throw new Error("Invalid list");this._tail=t,this._state++}removeItem(t){if(t===this._head&&t===this._tail)this._head=void 0,this._tail=void 0;else if(t===this._head){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this._head=t.next}else if(t===this._tail){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this._tail=t.previous}else{const s=t.next,o=t.previous;if(!s||!o)throw new Error("Invalid list");s.previous=o,o.next=s}t.next=void 0,t.previous=void 0,this._state++}touch(t,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this._head)return;const o=t.next,c=t.previous;t===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),t.previous=void 0,t.next=this._head,this._head.previous=t,this._head=t,this._state++}else if(s===2){if(t===this._tail)return;const o=t.next,c=t.previous;t===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),t.next=void 0,t.previous=this._tail,this._tail.next=t,this._tail=t,this._state++}}}toJSON(){const t=[];return this.forEach((s,o)=>{t.push([o,s])}),t}fromJSON(t){this.clear();for(const[s,o]of t)this.set(s,o)}}e.LinkedMap=u;class r extends u{constructor(t,s=1){super();this._limit=t,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(t){this._limit=t,this.checkTrim()}get ratio(){return this._ratio}set ratio(t){this._ratio=Math.min(Math.max(0,t),1),this.checkTrim()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r;class a{constructor(t){i.set(this,void 0),bt(this,i,t,"f")}get size(){return Ve(this,i,"f").size}forEach(t,s){Ve(this,i,"f").forEach(t,s)}get(t){return Ve(this,i,"f").get(t)}has(t){return Ve(this,i,"f").has(t)}entries(){return Ve(this,i,"f").entries()}keys(){return Ve(this,i,"f").keys()}values(){return Ve(this,i,"f").values()}[(i=new WeakMap,Symbol.iterator)](){return Ve(this,i,"f").entries()}}e.ReadonlyMapView=a}),define(te[69],ne([0,1,39]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const _=new T.LRUCache(1e4);function k(C){return b(C,"NFC",_)}e.normalizeNFC=k;const L=new T.LRUCache(1e4);function i(C){return b(C,"NFD",L)}e.normalizeNFD=i;const R=/[^\u0000-\u0080]/;function b(C,I,E){if(!C)return C;const f=E.get(C);if(f)return f;let S;return R.test(C)?S=C.normalize(I):S=C,E.set(C,S),S}e.removeAccents=function(){const C=/[\u0300-\u036f]/g;return function(I){return i(I).replace(C,"")}}()}),define(te[15],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function T(d){return Array.isArray(d)}e.isArray=T;function _(d){return typeof d=="string"}e.isString=_;function k(d){return Array.isArray(d)&&d.every(p=>_(p))}e.isStringArray=k;function L(d){return typeof d=="object"&&d!==null&&!Array.isArray(d)&&!(d instanceof RegExp)&&!(d instanceof Date)}e.isObject=L;function i(d){return typeof d=="number"&&!isNaN(d)}e.isNumber=i;function R(d){return!!d&&typeof d[Symbol.iterator]=="function"}e.isIterable=R;function b(d){return d===!0||d===!1}e.isBoolean=b;function C(d){return typeof d=="undefined"}e.isUndefined=C;function I(d){return!E(d)}e.isDefined=I;function E(d){return C(d)||d===null}e.isUndefinedOrNull=E;function f(d,p){if(!d)throw new Error(p?`Unexpected type, expected '${p}'`:"Unexpected type")}e.assertType=f;function S(d){if(E(d))throw new Error("Assertion Failed: argument is undefined or null");return d}e.assertIsDefined=S;function h(...d){const p=[];for(let P=0;P<d.length;P++){const O=d[P];if(E(O))throw new Error(`Assertion Failed: argument at index ${P} is undefined or null`);p.push(O)}return p}e.assertAllDefined=h;const y=Object.prototype.hasOwnProperty;function v(d){if(!L(d))return!1;for(let p in d)if(y.call(d,p))return!1;return!0}e.isEmptyObject=v;function m(d){return typeof d=="function"}e.isFunction=m;function w(...d){return d.length>0&&d.every(m)}e.areFunctions=w;function g(d,p){const P=Math.min(d.length,p.length);for(let O=0;O<P;O++)l(d[O],p[O])}e.validateConstraints=g;function l(d,p){if(_(p)){if(typeof d!==p)throw new Error(`argument does not match constraint: typeof ${p}`)}else if(m(p)){try{if(d instanceof p)return}catch{}if(!E(d)&&d.constructor===p||p.length===1&&p.call(void 0,d)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function u(d){let p=[],P=Object.getPrototypeOf(d);for(;Object.prototype!==P;)p=p.concat(Object.getOwnPropertyNames(P)),P=Object.getPrototypeOf(P);return p}e.getAllPropertyNames=u;function r(d){const p=[];for(const P of u(d))typeof d[P]=="function"&&p.push(P);return p}e.getAllMethodNames=r;function a(d,p){const P=A=>function(){const N=Array.prototype.slice.call(arguments,0);return p(A,N)};let O={};for(const A of d)O[A]=P(A);return O}e.createProxyObject=a;function n(d){return d===null?void 0:d}e.withNullAsUndefined=n;function t(d){return typeof d=="undefined"?null:d}e.withUndefinedAsNull=t;function s(d){return class{constructor(){return new Proxy({},{get(p,P){if(p[P])return p[P];throw new Error(`Not Implemented: ${d}->${String(P)}`)}})}}}e.NotImplementedProxy=s;function o(d,p="Unreachable"){throw new Error(p)}e.assertNever=o;function c(d){return!!d&&typeof d.then=="function"&&typeof d.catch=="function"}e.isPromise=c}),define(te[40],ne([0,1,9,4,25,15]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function i(n){return n===47||n===92}e.isPathSeparator=i;function R(n){return n.replace(/[\\/]/g,T.posix.sep)}e.toSlashes=R;function b(n){return n.indexOf("/")===-1&&(n=R(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=b;function C(n,t=T.posix.sep){if(!n)return"";const s=n.length,o=n.charCodeAt(0);if(i(o)){if(i(n.charCodeAt(1))&&!i(n.charCodeAt(2))){let d=3;const p=d;for(;d<s&&!i(n.charCodeAt(d));d++);if(p!==d&&!i(n.charCodeAt(d+1))){for(d+=1;d<s;d++)if(i(n.charCodeAt(d)))return n.slice(0,d+1).replace(/[\\/]/g,t)}}return t}else if(m(o)&&n.charCodeAt(1)===58)return i(n.charCodeAt(2))?n.slice(0,2)+t:n.slice(0,2);let c=n.indexOf("://");if(c!==-1){for(c+=3;c<s;c++)if(i(n.charCodeAt(c)))return n.slice(0,c+1)}return""}e.getRoot=C;function I(n){if(!_.isWindows||!n||n.length<5)return!1;let t=n.charCodeAt(0);if(t!==92||(t=n.charCodeAt(1),t!==92))return!1;let s=2;const o=s;for(;s<n.length&&(t=n.charCodeAt(s),t!==92);s++);return!(o===s||(t=n.charCodeAt(s+1),isNaN(t)||t===92))}e.isUNC=I;const E=/[\\/:\*\?"<>\|]/g,f=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(n,t=_.isWindows){const s=t?E:f;return!(!n||n.length===0||/^\s+$/.test(n)||(s.lastIndex=0,s.test(n))||t&&S.test(n)||n==="."||n===".."||t&&n[n.length-1]==="."||t&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=h;function y(n,t,s){const o=n===t;return!s||o?o:!n||!t?!1:(0,k.equalsIgnoreCase)(n,t)}e.isEqual=y;function v(n,t,s,o=T.sep){if(n===t)return!0;if(!n||!t||t.length>n.length)return!1;if(s){if(!(0,k.startsWithIgnoreCase)(n,t))return!1;if(t.length===n.length)return!0;let d=t.length;return t.charAt(t.length-1)===o&&d--,n.charAt(d)===o}return t.charAt(t.length-1)!==o&&(t+=o),n.indexOf(t)===0}e.isEqualOrParent=v;function m(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=m;function w(n,t){return _.isWindows&&n.endsWith(":")&&(n+=T.sep),(0,T.isAbsolute)(n)||(n=(0,T.join)(t,n)),n=(0,T.normalize)(n),_.isWindows?(n=(0,k.rtrim)(n,T.sep),n.endsWith(":")&&(n+=T.sep)):(n=(0,k.rtrim)(n,T.sep),n||(n=T.sep)),n}e.sanitizeFilePath=w;function g(n){const t=(0,T.normalize)(n);return _.isWindows?n.length>3?!1:l(t)&&(n.length===2||t.charCodeAt(2)===92):t===T.posix.sep}e.isRootOrDriveLetter=g;function l(n,t){return(t!==void 0?t:_.isWindows)?m(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function u(n){return l(n)?n[0]:void 0}e.getDriveLetter=u;function r(n,t,s){return t.length>n.length?-1:n===t?0:(s&&(n=n.toLowerCase(),t=t.toLowerCase()),n.indexOf(t))}e.indexOfPath=r;function a(n){const t=n.split(":");let s,o,c;if(t.forEach(d=>{const p=Number(d);(0,L.isNumber)(p)?o===void 0?o=p:c===void 0&&(c=p):s=s?[s,d].join(":"):d}),!s)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:s,line:o!==void 0?o:void 0,column:c!==void 0?c:o!==void 0?1:void 0}}e.parseLineAndColumnAware=a}),define(te[28],ne([0,1,15]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function _(y){if(!y||typeof y!="object"||y instanceof RegExp)return y;const v=Array.isArray(y)?[]:{};return Object.keys(y).forEach(m=>{y[m]&&typeof y[m]=="object"?v[m]=_(y[m]):v[m]=y[m]}),v}e.deepClone=_;function k(y){if(!y||typeof y!="object")return y;const v=[y];for(;v.length>0;){const m=v.shift();Object.freeze(m);for(const w in m)if(L.call(m,w)){const g=m[w];typeof g=="object"&&!Object.isFrozen(g)&&v.push(g)}}return y}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function i(y,v){return R(y,v,new Set)}e.cloneAndChange=i;function R(y,v,m){if((0,T.isUndefinedOrNull)(y))return y;const w=v(y);if(typeof w!="undefined")return w;if((0,T.isArray)(y)){const g=[];for(const l of y)g.push(R(l,v,m));return g}if((0,T.isObject)(y)){if(m.has(y))throw new Error("Cannot clone recursive data-structure");m.add(y);const g={};for(let l in y)L.call(y,l)&&(g[l]=R(y[l],v,m));return m.delete(y),g}return y}function b(y,v,m=!0){return(0,T.isObject)(y)?((0,T.isObject)(v)&&Object.keys(v).forEach(w=>{w in y?m&&((0,T.isObject)(y[w])&&(0,T.isObject)(v[w])?b(y[w],v[w],m):y[w]=v[w]):y[w]=v[w]}),y):v}e.mixin=b;function C(y,v){if(y===v)return!0;if(y==null||v===null||v===void 0||typeof y!=typeof v||typeof y!="object"||Array.isArray(y)!==Array.isArray(v))return!1;let m,w;if(Array.isArray(y)){if(y.length!==v.length)return!1;for(m=0;m<y.length;m++)if(!C(y[m],v[m]))return!1}else{const g=[];for(w in y)g.push(w);g.sort();const l=[];for(w in v)l.push(w);if(l.sort(),!C(g,l))return!1;for(m=0;m<g.length;m++)if(!C(y[g[m]],v[g[m]]))return!1}return!0}e.equals=C;function I(y){const v=new Set;return JSON.stringify(y,(m,w)=>{if((0,T.isObject)(w)||Array.isArray(w)){if(v.has(w))return"[Circular]";v.add(w)}return w})}e.safeStringify=I;function E(y,v,m){const w=v(y);return typeof w=="undefined"?m:w}e.getOrDefault=E;function f(y,v){const m=Object.create(null);return!y||!v||Object.keys(v).forEach(g=>{const l=y[g],u=v[g];C(l,u)||(m[g]=u)}),m}e.distinct=f;function S(y,v){const m=v.toLowerCase(),w=Object.keys(y).find(g=>g.toLowerCase()===m);return w?y[w]:y[v]}e.getCaseInsensitive=S;function h(y,v){const m=Object.create(null);for(const[w,g]of Object.entries(y))v(w,g)&&(m[w]=g);return m}e.filter=h}),define(te[7],ne([0,1,9,4]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,L=/^\//,i=/^\/\//;function R(n,t){if(!n.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!k.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!L.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(i.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(n,t){return!n&&!t?"file":n}function C(n,t){switch(n){case"https":case"http":case"file":t?t[0]!==E&&(t=E+t):t=E;break}return t}const I="",E="/",f=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class S{constructor(t,s,o,c,d,p=!1){typeof t=="object"?(this.scheme=t.scheme||I,this.authority=t.authority||I,this.path=t.path||I,this.query=t.query||I,this.fragment=t.fragment||I):(this.scheme=b(t,p),this.authority=s||I,this.path=C(this.scheme,o||I),this.query=c||I,this.fragment=d||I,R(this,p))}static isUri(t){return t instanceof S?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}get fsPath(){return g(this,!1)}with(t){if(!t)return this;let{scheme:s,authority:o,path:c,query:d,fragment:p}=t;return s===void 0?s=this.scheme:s===null&&(s=I),o===void 0?o=this.authority:o===null&&(o=I),c===void 0?c=this.path:c===null&&(c=I),d===void 0?d=this.query:d===null&&(d=I),p===void 0?p=this.fragment:p===null&&(p=I),s===this.scheme&&o===this.authority&&c===this.path&&d===this.query&&p===this.fragment?this:new y(s,o,c,d,p)}static parse(t,s=!1){const o=f.exec(t);return o?new y(o[2]||I,a(o[4]||I),a(o[5]||I),a(o[7]||I),a(o[9]||I),s):new y(I,I,I,I,I)}static file(t){let s=I;if(_.isWindows&&(t=t.replace(/\\/g,E)),t[0]===E&&t[1]===E){const o=t.indexOf(E,2);o===-1?(s=t.substring(2),t=E):(s=t.substring(2,o),t=t.substring(o)||E)}return new y("file",s,t,I,I)}static from(t){const s=new y(t.scheme,t.authority,t.path,t.query,t.fragment);return R(s,!0),s}static joinPath(t,...s){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return _.isWindows&&t.scheme==="file"?o=S.file(T.win32.join(g(t,!0),...s)).path:o=T.posix.join(t.path,...s),t.with({path:o})}toString(t=!1){return l(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof S)return t;{const s=new y(t);return s._formatted=t.external,s._fsPath=t._sep===h?t.fsPath:null,s}}else return t}}e.URI=S;const h=_.isWindows?1:void 0;class y extends S{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(t=!1){return t?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=h),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(n,t){let s,o=-1;for(let c=0;c<n.length;c++){const d=n.charCodeAt(c);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||t&&d===47)o!==-1&&(s+=encodeURIComponent(n.substring(o,c)),o=-1),s!==void 0&&(s+=n.charAt(c));else{s===void 0&&(s=n.substr(0,c));const p=v[d];p!==void 0?(o!==-1&&(s+=encodeURIComponent(n.substring(o,c)),o=-1),s+=p):o===-1&&(o=c)}}return o!==-1&&(s+=encodeURIComponent(n.substring(o))),s!==void 0?s:n}function w(n){let t;for(let s=0;s<n.length;s++){const o=n.charCodeAt(s);o===35||o===63?(t===void 0&&(t=n.substr(0,s)),t+=v[o]):t!==void 0&&(t+=n[s])}return t!==void 0?t:n}function g(n,t){let s;return n.authority&&n.path.length>1&&n.scheme==="file"?s=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?t?s=n.path.substr(1):s=n.path[1].toLowerCase()+n.path.substr(2):s=n.path,_.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=g;function l(n,t){const s=t?w:m;let o="",{scheme:c,authority:d,path:p,query:P,fragment:O}=n;if(c&&(o+=c,o+=":"),(d||c==="file")&&(o+=E,o+=E),d){let A=d.indexOf("@");if(A!==-1){const N=d.substr(0,A);d=d.substr(A+1),A=N.indexOf(":"),A===-1?o+=s(N,!1):(o+=s(N.substr(0,A),!1),o+=":",o+=s(N.substr(A+1),!1)),o+="@"}d=d.toLowerCase(),A=d.indexOf(":"),A===-1?o+=s(d,!1):(o+=s(d.substr(0,A),!1),o+=d.substr(A))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const A=p.charCodeAt(1);A>=65&&A<=90&&(p=`/${String.fromCharCode(A+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const A=p.charCodeAt(0);A>=65&&A<=90&&(p=`${String.fromCharCode(A+32)}:${p.substr(2)}`)}o+=s(p,!0)}return P&&(o+="?",o+=s(P,!1)),O&&(o+="#",o+=t?O:m(O,!1)),o}function u(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+u(n.substr(3)):n}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(n){return n.match(r)?n.replace(r,t=>u(t)):n}}),define(te[105],ne([0,1,7]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function _(C){const I=C;return I&&typeof I.type=="string"&&typeof I.severity=="string"}e.isRemoteConsoleLog=_;function k(C){const I=[];let E;try{const f=JSON.parse(C.arguments),S=f[f.length-1];S&&S.__$stack&&(f.pop(),E=S.__$stack),I.push(...f)}catch(f){I.push("Unable to log remote console arguments",C.arguments)}return{args:I,stack:E}}e.parse=k;function L(C){if(typeof C!="string")return L(k(C).stack);const I=C;if(I){const E=i(I),f=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(f&&f.length===4)return{uri:T.URI.file(f[1]),line:Number(f[2]),column:Number(f[3])}}}e.getFirstFrame=L;function i(C){if(!C)return C;const I=C.indexOf(`
`);return I===-1?C:C.substring(0,I)}function R(C,I){const{args:E,stack:f}=k(C),S=typeof E[0]=="string"&&E.length===1;let h=i(f);h&&(h=`(${h.trim()})`);let y=[];if(typeof E[0]=="string"?h&&S?y=[`%c[${I}] %c${E[0]} %c${h}`,b("blue"),b(""),b("grey")]:y=[`%c[${I}] %c${E[0]}`,b("blue"),b(""),...E.slice(1)]:y=[`%c[${I}]%`,b("blue"),...E],h&&!S&&y.push(h),typeof console[C.severity]!="function")throw new Error("Unknown console method");console[C.severity].apply(console,y)}e.log=R;function b(C){return`color: ${C}`}}),define(te[106],ne([0,1,19,25,7]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,b)}e.stringify=L;function i(I){let E=JSON.parse(I);return E=C(E),E}e.parse=i;var R;(function(I){I[I.Uri=1]="Uri",I[I.Regexp=2]="Regexp",I[I.ScmResource=3]="ScmResource",I[I.ScmResourceGroup=4]="ScmResourceGroup",I[I.ScmProvider=5]="ScmProvider",I[I.CommentController=6]="CommentController",I[I.CommentThread=7]="CommentThread",I[I.CommentThreadReply=8]="CommentThreadReply",I[I.CommentNode=9]="CommentNode",I[I.CommentThreadNode=10]="CommentThreadNode",I[I.TimelineActionContext=11]="TimelineActionContext",I[I.NotebookCellActionContext=12]="NotebookCellActionContext",I[I.TestItemContext=13]="TestItemContext"})(R=e.MarshalledId||(e.MarshalledId={}));function b(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,_.regExpFlags)(E)}:E}function C(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return k.URI.revive(I);case 2:return new RegExp(I.source,I.flags)}if(I instanceof T.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let f=0;f<I.length;++f)I[f]=C(I[f],E+1);else for(const f in I)Object.hasOwnProperty.call(I,f)&&(I[f]=C(I[f],E+1))}return I}e.revive=C}),define(te[17],ne([0,1,4,7]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var k;(function(R){R.inMemory="inmemory",R.vscode="vscode",R.internal="private",R.walkThrough="walkThrough",R.walkThroughSnippet="walkThroughSnippet",R.http="http",R.https="https",R.file="file",R.mailto="mailto",R.untitled="untitled",R.data="data",R.command="command",R.vscodeRemote="vscode-remote",R.vscodeRemoteResource="vscode-remote-resource",R.userData="vscode-userdata",R.vscodeCustomEditor="vscode-custom-editor",R.vscodeNotebook="vscode-notebook",R.vscodeNotebookCell="vscode-notebook-cell",R.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",R.vscodeNotebookCellOutput="vscode-notebook-cell-output",R.vscodeInteractive="vscode-interactive",R.vscodeInteractiveInput="vscode-interactive-input",R.vscodeSettings="vscode-settings",R.vscodeWorkspaceTrust="vscode-workspace-trust",R.vscodeTerminal="vscode-terminal",R.webviewPanel="webview-panel",R.vscodeWebview="vscode-webview",R.extension="extension",R.vscodeFileResource="vscode-file",R.tmp="tmp",R.vsls="vsls"})(k=e.Schemas||(e.Schemas={}));class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(b){this._preferredWebSchema=b}setDelegate(b){this._delegate=b}set(b,C,I){this._hosts[b]=C,this._ports[b]=I}setConnectionToken(b,C){this._connectionTokens[b]=C}rewrite(b){if(this._delegate)return this._delegate(b);const C=b.authority;let I=this._hosts[C];I&&I.indexOf(":")!==-1&&(I=`[${I}]`);const E=this._ports[C],f=this._connectionTokens[C];let S=`path=${encodeURIComponent(b.path)}`;return typeof f=="string"&&(S+=`&tkn=${encodeURIComponent(f)}`),_.URI.from({scheme:T.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${I}:${E}`,path:"/vscode-remote-resource",query:S})}}e.RemoteAuthorities=new L;class i{asBrowserUri(b,C){const I=this.toUri(b,C);return I.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(I):I.scheme===k.file&&(T.isNative||typeof T.globals.importScripts=="function"&&T.globals.origin===`${k.vscodeFileResource}://${i.FALLBACK_AUTHORITY}`)?I.with({scheme:k.vscodeFileResource,authority:I.authority||i.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(b,C){const I=this.toUri(b,C);return I.scheme===k.vscodeFileResource?I.with({scheme:k.file,authority:I.authority!==i.FALLBACK_AUTHORITY?I.authority:null,query:null,fragment:null}):I}toUri(b,C){return _.URI.isUri(b)?b:_.URI.parse(C.toUrl(b))}}i.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new i}),define(te[18],ne([0,1,40,17,9,4,25,7]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function b(S){return(0,R.uriToFsPath)(S,!0)}e.originalFSPath=b;class C{constructor(h){this._ignorePathCasing=h}compare(h,y,v=!1){return h===y?0:(0,i.compare)(this.getComparisonKey(h,v),this.getComparisonKey(y,v))}isEqual(h,y,v=!1){return h===y?!0:!h||!y?!1:this.getComparisonKey(h,v)===this.getComparisonKey(y,v)}getComparisonKey(h,y=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,y,v=!1){if(h.scheme===y.scheme){if(h.scheme===_.Schemas.file)return T.isEqualOrParent(b(h),b(y),this._ignorePathCasing(h))&&h.query===y.query&&(v||h.fragment===y.fragment);if((0,e.isEqualAuthority)(h.authority,y.authority))return T.isEqualOrParent(h.path,y.path,this._ignorePathCasing(h),"/")&&h.query===y.query&&(v||h.fragment===y.fragment)}return!1}joinPath(h,...y){return R.URI.joinPath(h,...y)}basenameOrAuthority(h){return(0,e.basename)(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let y;return h.scheme===_.Schemas.file?y=R.URI.file(k.dirname(b(h))).path:(y=k.posix.dirname(h.path),h.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),y="/")),h.with({path:y})}normalizePath(h){if(!h.path.length)return h;let y;return h.scheme===_.Schemas.file?y=R.URI.file(k.normalize(b(h))).path:y=k.posix.normalize(h.path),h.with({path:y})}relativePath(h,y){if(h.scheme!==y.scheme||!(0,e.isEqualAuthority)(h.authority,y.authority))return;if(h.scheme===_.Schemas.file){const w=k.relative(b(h),b(y));return L.isWindows?T.toSlashes(w):w}let v=h.path||"/",m=y.path||"/";if(this._ignorePathCasing(h)){let w=0;for(const g=Math.min(v.length,m.length);w<g&&!(v.charCodeAt(w)!==m.charCodeAt(w)&&v.charAt(w).toLowerCase()!==m.charAt(w).toLowerCase());w++);v=m.substr(0,w)+v.substr(w)}return k.posix.relative(v,m)}resolvePath(h,y){if(h.scheme===_.Schemas.file){const v=R.URI.file(k.resolve(b(h),y));return h.with({authority:v.authority,path:v.path})}return y=T.toPosixPath(y),h.with({path:k.posix.resolve(h.path,y)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,y){return h===y||h!==void 0&&y!==void 0&&(0,i.equalsIgnoreCase)(h,y)}hasTrailingPathSeparator(h,y=k.sep){if(h.scheme===_.Schemas.file){const v=b(h);return v.length>T.getRoot(v).length&&v[v.length-1]===y}else{const v=h.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,y=k.sep){return(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,y=k.sep){let v=!1;if(h.scheme===_.Schemas.file){const m=b(h);v=m!==void 0&&m.length===T.getRoot(m).length&&m[m.length-1]===y}else{y="/";const m=h.path;v=m.length===1&&m.charCodeAt(m.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(h,y)?h.with({path:h.path+"/"}):h}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(S=>S.scheme===_.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new C(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function I(S,h){const y=[];for(let v=0;v<S.length;v++){const m=h(S[v]);S.some((w,g)=>g===v?!1:(0,e.isEqualOrParent)(m,h(w)))||y.push(S[v])}return y}e.distinctParents=I;var E;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function h(y){const v=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(g=>{const[l,u]=g.split(":");l&&u&&v.set(l,u)});const w=y.path.substring(0,y.path.indexOf(";"));return w&&v.set(S.META_DATA_MIME,w),v}S.parseMetaData=h})(E=e.DataUri||(e.DataUri={}));function f(S,h,y){if(h){let v=S.path;return v&&v[0]!==k.posix.sep&&(v=k.posix.sep+v),S.with({scheme:y,authority:h,path:v})}return S.with({scheme:y})}e.toLocalResource=f}),define(te[5],ne([0,1,27,10,3,2,18,4]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(W){return!!W&&typeof W.then=="function"}e.isThenable=b;function C(W){const z=new T.CancellationTokenSource,B=W(z.token),q=new Promise((H,Y)=>{const x=z.token.onCancellationRequested(()=>{x.dispose(),z.dispose(),Y((0,_.canceled)())});Promise.resolve(B).then(K=>{x.dispose(),z.dispose(),H(K)},K=>{x.dispose(),z.dispose(),Y(K)})});return new class{cancel(){z.cancel()}then(H,Y){return q.then(H,Y)}catch(H){return this.then(void 0,H)}finally(H){return q.finally(H)}}}e.createCancelablePromise=C;function I(W,z,B){return Promise.race([W,new Promise(q=>z.onCancellationRequested(()=>q(B)))])}e.raceCancellation=I;async function E(W){let z=-1;const B=W.map((H,Y)=>H.then(x=>(z=Y,x))),q=await Promise.race(B);return W.forEach((H,Y)=>{Y!==z&&H.cancel()}),q}e.raceCancellablePromises=E;function f(W,z,B){let q;const H=setTimeout(()=>{q?.(void 0),B?.()},z);return Promise.race([W.finally(()=>clearTimeout(H)),new Promise(Y=>q=Y)])}e.raceTimeout=f;function S(W){return new Promise((z,B)=>{const q=W();b(q)?q.then(z,B):z(q)})}e.asPromise=S;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(z){if(this.activePromise){if(this.queuedPromiseFactory=z,!this.queuedPromise){const B=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(B,B).then(q)})}return new Promise((B,q)=>{this.queuedPromise.then(B,q)})}return this.activePromise=z(),new Promise((B,q)=>{this.activePromise.then(H=>{this.activePromise=null,B(H)},H=>{this.activePromise=null,q(H)})})}}e.Throttler=h;class y{constructor(){this.current=Promise.resolve(null)}queue(z){return this.current=this.current.then(()=>z(),()=>z())}}e.Sequencer=y;class v{constructor(){this.promiseMap=new Map}queue(z,B){const H=(this.promiseMap.get(z)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.promiseMap.get(z)===H&&this.promiseMap.delete(z)});return this.promiseMap.set(z,H),H}}e.SequencerByKey=v;class m{constructor(z){this.defaultDelay=z,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(z,B=this.defaultDelay){return this.task=z,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((q,H)=>{this.doResolve=q,this.doReject=H}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const q=this.task;return this.task=null,q()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},B),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,_.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=m;class w{constructor(z){this.delayer=new m(z),this.throttler=new h}trigger(z,B){return this.delayer.trigger(()=>this.throttler.queue(z),B)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class g{constructor(){this._isOpen=!1,this._promise=new Promise((z,B)=>{this._completePromise=z})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class l extends g{constructor(z){super();this._timeout=setTimeout(()=>this.open(),z)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function u(W,z){return z?new Promise((B,q)=>{const H=setTimeout(()=>{Y.dispose(),B()},W),Y=z.onCancellationRequested(()=>{clearTimeout(H),Y.dispose(),q((0,_.canceled)())})}):C(B=>u(W,B))}e.timeout=u;function r(W,z=0){const B=setTimeout(W,z);return(0,L.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=r;function a(W){const z=[];let B=0;const q=W.length;function H(){return B<q?W[B++]():null}function Y(x){x!=null&&z.push(x);const K=H();return K?K.then(Y):Promise.resolve(z)}return Promise.resolve(null).then(Y)}e.sequence=a;function n(W,z=q=>!!q,B=null){let q=0;const H=W.length,Y=()=>{if(q>=H)return Promise.resolve(B);const x=W[q++];return Promise.resolve(x()).then(re=>z(re)?Promise.resolve(re):Y())};return Y()}e.first=n;function t(W,z=q=>!!q,B=null){if(W.length===0)return Promise.resolve(B);let q=W.length;const H=()=>{q=-1;for(const Y of W)Y.cancel?.()};return new Promise((Y,x)=>{for(const K of W)K.then(re=>{--q>=0&&z(re)?(H(),Y(re)):q===0&&Y(B)}).catch(re=>{--q>=0&&(H(),x(re))})})}e.firstParallel=t;class s{constructor(z){this._size=0,this.maxDegreeOfParalellism=z,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new k.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(z){return this._size++,new Promise((B,q)=>{this.outstandingPromises.push({factory:z,c:B,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const z=this.outstandingPromises.shift();this.runningPromises++;const B=z.factory();B.then(z.c,z.e),B.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=s;class o extends s{constructor(){super(1)}}e.Queue=o;class c{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const z=new U;return this.drainers.add(z),z.p}isDrained(){for(const[,z]of this.queues)if(z.size>0)return!1;return!0}queueFor(z,B=i.extUri){const q=B.getComparisonKey(z);let H=this.queues.get(q);return H||(H=new o,k.Event.once(H.onFinished)(()=>{H?.dispose(),this.queues.delete(q),this.onDidQueueFinish()}),this.queues.set(q,H)),H}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const z of this.drainers)z.complete();this.drainers.clear()}dispose(){for(const[,z]of this.queues)z.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=c;class d{constructor(z,B){this._token=-1,typeof z=="function"&&typeof B=="number"&&this.setIfNotSet(z,B)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(z,B){this.cancel(),this._token=setTimeout(()=>{this._token=-1,z()},B)}setIfNotSet(z,B){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,z()},B))}}e.TimeoutTimer=d;class p{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(z,B){this.cancel(),this._token=setInterval(()=>{z()},B)}}e.IntervalTimer=p;class P{constructor(z,B){this.timeoutToken=-1,this.runner=z,this.timeout=B,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(z=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,z)}get delay(){return this.timeout}set delay(z){this.timeout=z}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class O{constructor(z,B){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.runner=z,this.timeout=B,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(z=this.timeout){z%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${z}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(z/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=O;class A extends P{constructor(z,B){super(z,B);this.units=[]}work(z){this.units.push(z),this.isScheduled()||this.schedule()}doRun(){const z=this.units;this.units=[],this.runner&&this.runner(z)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=A;class N extends L.Disposable{constructor(z,B,q,H){super();this.maxWorkChunkSize=z,this.maxPendingWork=B,this.throttleDelay=q,this.handler=H,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(z){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+z.length>this.maxPendingWork)return!1}else if(this.pending+z.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...z),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=N,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=W=>{(0,R.setTimeout0)(()=>{if(z)return;const B=Date.now()+3;W(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let z=!1;return{dispose(){z||(z=!0)}}}:e.runWhenIdle=(W,z)=>{const B=requestIdleCallback(W,typeof z=="number"?{timeout:z}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(B))}}}}();class ${constructor(z){this._didRun=!1,this._executor=()=>{try{this._value=z()}catch(B){this._error=B}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=$;async function D(W,z,B){let q;for(let H=0;H<B;H++)try{return await W()}catch(Y){q=Y,await u(z)}throw q}e.retry=D;class F{hasPending(z){return this._pending?typeof z=="number"?this._pending.taskId===z:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(z,B,q){return this._pending={taskId:z,cancel:()=>q?.(),promise:B},B.then(()=>this.donePending(z),()=>this.donePending(z)),B}donePending(z){this._pending&&z===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const z=this._next;this._next=void 0,z.run().then(z.promiseResolve,z.promiseReject)}}setNext(z){if(this._next)this._next.run=z;else{let B,q;const H=new Promise((Y,x)=>{B=Y,q=x});this._next={run:z,promise:H,promiseResolve:B,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=F;class M{constructor(z,B=()=>Date.now()){this.interval=z,this.nowFn=B,this.lastIncrementTime=0,this.value=0}increment(){const z=this.nowFn();return z-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=z,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class U{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((z,B)=>{this.completeCallback=z,this.errorCallback=B})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(z){return new Promise(B=>{this.completeCallback(z),this.resolved=!0,B()})}error(z){return new Promise(B=>{this.errorCallback(z),this.rejected=!0,B()})}cancel(){new Promise(z=>{this.errorCallback((0,_.canceled)()),this.rejected=!0,z()})}}e.DeferredPromise=U;var G;(function(W){async function z(q){let H;const Y=await Promise.all(q.map(x=>x.then(K=>K,K=>{H||(H=K)})));if(typeof H!="undefined")throw H;return Y}W.settled=z;function B(q){return new Promise(async(H,Y)=>{try{await q(H,Y)}catch(x){Y(x)}})}W.withAsyncBody=B})(G=e.Promises||(e.Promises={}));var ee;(function(W){W[W.Initial=0]="Initial",W[W.DoneOK=1]="DoneOK",W[W.DoneError=2]="DoneError"})(ee||(ee={}));class V{constructor(z){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const B={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(z(B)),this.resolve()}catch(q){this.reject(q)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}static fromArray(z){return new V(B=>{B.emitMany(z)})}static fromPromise(z){return new V(async B=>{B.emitMany(await z)})}static fromPromises(z){return new V(async B=>{await Promise.all(z.map(async q=>B.emitOne(await q)))})}static merge(z){return new V(async B=>{await Promise.all(z.map(async q=>{for await(const H of q)B.emitOne(H)}))})}[Symbol.asyncIterator](){let z=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(z<this._results.length)return{done:!1,value:this._results[z++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(z,B){return new V(async q=>{for await(const H of z)q.emitOne(B(H))})}map(z){return V.map(this,z)}static filter(z,B){return new V(async q=>{for await(const H of z)B(H)&&q.emitOne(H)})}filter(z){return V.filter(this,z)}static coalesce(z){return V.filter(z,B=>!!B)}coalesce(){return V.coalesce(this)}static async toPromise(z){const B=[];for await(const q of z)B.push(q);return B}toPromise(){return V.toPromise(this)}emitOne(z){this._state===0&&(this._results.push(z),this._onStateChanged.fire())}emitMany(z){this._state===0&&(this._results=this._results.concat(z),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(z){this._state===0&&(this._state=2,this._error=z,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class j extends V{constructor(z,B){super(B);this._source=z}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=j;function Z(W){const z=new T.CancellationTokenSource,B=W(z.token);return new j(z,async q=>{const H=z.token.onCancellationRequested(()=>{H.dispose(),z.dispose(),q.reject((0,_.canceled)())});try{for await(const Y of B){if(z.token.isCancellationRequested)return;q.emitOne(Y)}H.dispose(),z.dispose()}catch(Y){H.dispose(),z.dispose(),q.reject(Y)}})}e.createCancelableAsyncIterable=Z}),define(te[107],ne([0,1,5,40,39,9,25]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function R(){return Object.create(null)}e.getEmptyExpression=R;const b="**",C="/",I="[/\\\\]",E="[^/\\\\]",f=/\//g;function S(j){switch(j){case 0:return"";case 1:return`${E}*?`;default:return`(?:${I}|${E}+${I}|${I}${E}+)*?`}}function h(j,Z){if(!j)return[];const W=[];let z=!1,B=!1,q="";for(const H of j){switch(H){case Z:if(!z&&!B){W.push(q),q="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":B=!0;break;case"]":B=!1;break}q+=H}return q&&W.push(q),W}e.splitGlobAware=h;function y(j){if(!j)return"";let Z="";const W=h(j,C);if(W.every(z=>z===b))Z=".*";else{let z=!1;W.forEach((B,q)=>{if(B===b){z||(Z+=S(2),z=!0);return}let H=!1,Y="",x=!1,K="";for(const re of B){if(re!=="}"&&H){Y+=re;continue}if(x&&(re!=="]"||!K)){let se;re==="-"?se=re:(re==="^"||re==="!")&&!K?se="^":re===C?se="":se=i.escapeRegExpCharacters(re),K+=se;continue}switch(re){case"{":H=!0;continue;case"[":x=!0;continue;case"}":Z+=`(?:${h(Y,",").map(he=>y(he)).join("|")})`,H=!1,Y="";break;case"]":Z+="["+K+"]",x=!1,K="";break;case"?":Z+=E;continue;case"*":Z+=S(1);continue;default:Z+=i.escapeRegExpCharacters(re)}}q<W.length-1&&(W[q+1]!==b||q+2<W.length)&&(Z+=I),z=!1})}return Z}const v=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,r=new k.LRUCache(1e4),a=function(){return!1},n=function(){return null};function t(j,Z){if(!j)return n;let W;typeof j!="string"?W=j.pattern:W=j,W=W.trim();const z=`${W}_${!!Z.trimForExclusions}`;let B=r.get(z);if(B)return s(B,j);let q;if(v.test(W)){const H=W.substr(4);B=function(Y,x){return typeof Y=="string"&&Y.endsWith(H)?W:null}}else(q=m.exec(o(W,Z)))?B=c(q[1],W):(Z.trimForExclusions?g:w).test(W)?B=d(W,Z):(q=l.exec(o(W,Z)))?B=p(q[1].substr(1),W,!0):(q=u.exec(o(W,Z)))?B=p(q[1],W,!1):B=P(W);return r.set(z,B),s(B,j)}function s(j,Z){return typeof Z=="string"?j:function(W,z){return _.isEqualOrParent(W,Z.base)?j(L.relative(Z.base,W),z):null}}function o(j,Z){return Z.trimForExclusions&&j.endsWith("/**")?j.substr(0,j.length-2):j}function c(j,Z){const W=`/${j}`,z=`\\${j}`,B=function(H,Y){return typeof H!="string"?null:Y?Y===j?Z:null:H===j||H.endsWith(W)||H.endsWith(z)?Z:null},q=[j];return B.basenames=q,B.patterns=[Z],B.allBasenames=q,B}function d(j,Z){const W=V(j.slice(1,-1).split(",").map(Y=>t(Y,Z)).filter(Y=>Y!==n),j),z=W.length;if(!z)return n;if(z===1)return W[0];const B=function(Y,x){for(let K=0,re=W.length;K<re;K++)if(W[K](Y,x))return j;return null},q=W.find(Y=>!!Y.allBasenames);q&&(B.allBasenames=q.allBasenames);const H=W.reduce((Y,x)=>x.allPaths?Y.concat(x.allPaths):Y,[]);return H.length&&(B.allPaths=H),B}function p(j,Z,W){const z=L.sep===L.posix.sep,B=z?j:j.replace(f,L.sep),q=L.sep+B,H=L.posix.sep+j,Y=W?function(x,K){return typeof x=="string"&&(x===B||x.endsWith(q)||!z&&(x===j||x.endsWith(H)))?Z:null}:function(x,K){return typeof x=="string"&&(x===B||!z&&x===j)?Z:null};return Y.allPaths=[(W?"*/":"./")+j],Y}function P(j){try{const Z=new RegExp(`^${y(j)}$`);return function(W){return Z.lastIndex=0,typeof W=="string"&&Z.test(W)?j:null}}catch(Z){return n}}function O(j,Z,W){return!j||typeof Z!="string"?!1:A(j)(Z,void 0,W)}e.match=O;function A(j,Z={}){if(!j)return a;if(typeof j=="string"||F(j)){const W=t(j,Z);if(W===n)return a;const z=function(B,q){return!!W(B,q)};return W.allBasenames&&(z.allBasenames=W.allBasenames),W.allPaths&&(z.allPaths=W.allPaths),z}return G(j,Z)}e.parse=A;function N(j){if(!j)return;let Z;return W=>(Z||(Z=(j()||Promise.resolve([])).then(z=>z?D(z):{})),Z.then(z=>!!z[W]))}e.hasSiblingPromiseFn=N;function $(j){if(!j)return;let Z;return W=>{if(!Z){const z=j();Z=z?D(z):{}}return!!Z[W]}}e.hasSiblingFn=$;function D(j){const Z={};for(const W of j)Z[W]=!0;return Z}function F(j){const Z=j;return Z&&typeof Z.base=="string"&&typeof Z.pattern=="string"}e.isRelativePattern=F;function M(j){return j.allBasenames||[]}e.getBasenameTerms=M;function U(j){return j.allPaths||[]}e.getPathTerms=U;function G(j,Z){const W=V(Object.getOwnPropertyNames(j).map(Y=>ee(Y,j[Y],Z)).filter(Y=>Y!==n)),z=W.length;if(!z)return n;if(!W.some(Y=>!!Y.requiresSiblings)){if(z===1)return W[0];const Y=function(re,se){for(let ce=0,he=W.length;ce<he;ce++){const me=W[ce](re,se);if(me)return me}return null},x=W.find(re=>!!re.allBasenames);x&&(Y.allBasenames=x.allBasenames);const K=W.reduce((re,se)=>se.allPaths?re.concat(se.allPaths):re,[]);return K.length&&(Y.allPaths=K),Y}const B=function(Y,x,K){let re;for(let se=0,ce=W.length;se<ce;se++){const he=W[se];he.requiresSiblings&&K&&(x||(x=L.basename(Y)),re||(re=x.substr(0,x.length-L.extname(Y).length)));const me=he(Y,x,re,K);if(me)return me}return null},q=W.find(Y=>!!Y.allBasenames);q&&(B.allBasenames=q.allBasenames);const H=W.reduce((Y,x)=>x.allPaths?Y.concat(x.allPaths):Y,[]);return H.length&&(B.allPaths=H),B}function ee(j,Z,W){if(Z===!1)return n;const z=t(j,W);if(z===n)return n;if(typeof Z=="boolean")return z;if(Z){const B=Z.when;if(typeof B=="string"){const q=(H,Y,x,K)=>{if(!K||!z(H,Y))return null;const re=B.replace("$(basename)",x),se=K(re);return(0,T.isThenable)(se)?se.then(ce=>ce?j:null):se?j:null};return q.requiresSiblings=!0,q}}return z}function V(j,Z){const W=j.filter(Y=>!!Y.basenames);if(W.length<2)return j;const z=W.reduce((Y,x)=>{const K=x.basenames;return K?Y.concat(K):Y},[]);let B;if(Z){B=[];for(let Y=0,x=z.length;Y<x;Y++)B.push(Z)}else B=W.reduce((Y,x)=>{const K=x.patterns;return K?Y.concat(K):Y},[]);const q=function(Y,x){if(typeof Y!="string")return null;if(!x){let re;for(re=Y.length;re>0;re--){const se=Y.charCodeAt(re-1);if(se===47||se===92)break}x=Y.substr(re)}const K=z.indexOf(x);return K!==-1?B[K]:null};q.basenames=z,q.patterns=B,q.allBasenames=z;const H=j.filter(Y=>!Y.basenames);return H.push(q),H}}),define(te[108],ne([0,1,107,17,9,18,25]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var R;(function(t){t.text="text/plain",t.binary="application/octet-stream",t.unknown="application/unknown",t.markdown="text/markdown",t.latex="text/latex"})(R=e.Mimes||(e.Mimes={}));let b=[],C=[],I=[];function E(t,s=!1){const o=f(t);b.push(o),o.userConfigured?I.push(o):C.push(o),s&&!o.userConfigured&&b.forEach(c=>{c.mime===o.mime||c.userConfigured||(o.extension&&c.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&c.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&c.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&c.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=E;function f(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?(0,T.parse)(t.filepattern.toLowerCase()):void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(k.posix.sep)>=0:!1}}function S(t){t?(b=b.filter(s=>!s.userConfigured),I=[]):(b=[],C=[],I=[])}e.clearTextMimes=S;function h(t,s){let o;if(t)switch(t.scheme){case _.Schemas.file:o=t.fsPath;break;case _.Schemas.data:o=L.DataUri.parseMetaData(t).get(L.DataUri.META_DATA_LABEL);break;default:o=t.path}if(!o)return[R.unknown];o=o.toLowerCase();const c=(0,k.basename)(o),d=y(o,c,I);if(d)return[d,R.text];const p=y(o,c,C);if(p)return[p,R.text];if(s){const P=v(s);if(P)return[P,R.text]}return[R.unknown]}e.guessMimeTypes=h;function y(t,s,o){let c=null,d=null,p=null;for(let P=o.length-1;P>=0;P--){const O=o[P];if(s===O.filenameLowercase){c=O;break}if(O.filepattern&&(!d||O.filepattern.length>d.filepattern.length)){const A=O.filepatternOnPath?t:s;O.filepatternLowercase?.(A)&&(d=O)}O.extension&&(!p||O.extension.length>p.extension.length)&&s.endsWith(O.extensionLowercase)&&(p=O)}return c?c.mime:d?d.mime:p?p.mime:null}function v(t){if((0,i.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let s=b.length-1;s>=0;s--){const o=b[s];if(!o.firstline)continue;const c=t.match(o.firstline);if(c&&c.length>0)return o.mime}return null}function m(t){return t?typeof t=="string"?t===R.binary||t===R.text||t===R.unknown:t.length===1&&m(t[0]):!0}e.isUnspecific=m;const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(t){const s=(0,k.extname)(t),o=w[s.toLowerCase()];return o!==void 0?o:u(t)}e.getMediaOrTextMime=l;function u(t){const s=(0,k.extname)(t);return g[s.toLowerCase()]}e.getMediaMime=u;function r(t){for(const s in g)if(g[s]===t)return s}e.getExtensionForMimeType=r;const a=/^(.+)\/(.+?)(;.+)?$/;function n(t,s){const o=a.exec(t);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:s?void 0:t}e.normalizeMimeType=n}),define(te[109],ne([0,1,7]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function _(I){return I.toJSON()}class k{constructor(E){this._uriTransformer=E}transformIncoming(E){const f=this._uriTransformer.transformIncoming(E);return f===E?E:_(T.URI.from(f))}transformOutgoing(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:_(T.URI.from(f))}transformOutgoingURI(E){const f=this._uriTransformer.transformOutgoing(E);return f===E?E:T.URI.from(f)}transformOutgoingScheme(E){return this._uriTransformer.transformOutgoingScheme(E)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function L(I,E,f){if(!I||f>200)return null;if(typeof I=="object"){if(I instanceof T.URI)return E.transformOutgoing(I);for(let S in I)if(Object.hasOwnProperty.call(I,S)){const h=L(I[S],E,f+1);h!==null&&(I[S]=h)}}return null}function i(I,E){const f=L(I,E,0);return f===null?I:f}e.transformOutgoingURIs=i;function R(I,E,f,S){if(!I||S>200)return null;if(typeof I=="object"){if(I.$mid===1)return f?T.URI.revive(E.transformIncoming(I)):E.transformIncoming(I);for(let h in I)if(Object.hasOwnProperty.call(I,h)){const y=R(I[h],E,f,S+1);y!==null&&(I[h]=y)}}return null}function b(I,E){const f=R(I,E,!1,0);return f===null?I:f}e.transformIncomingURIs=b;function C(I,E){const f=R(I,E,!0,0);return f===null?I:f}e.transformAndReviveIncomingURIs=C}),define(te[30],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const T=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function _(b){return T.test(b)}e.isUUID=_;const k=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));let i;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?i=crypto.getRandomValues.bind(crypto):i=function(b){for(let C=0;C<b.length;C++)b[C]=Math.floor(Math.random()*256);return b};function R(){i(k),k[6]=k[6]&15|64,k[8]=k[8]&63|128;let b=0,C="";return C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C+="-",C+=L[k[b++]],C+=L[k[b++]],C+="-",C+=L[k[b++]],C+=L[k[b++]],C+="-",C+=L[k[b++]],C+=L[k[b++]],C+="-",C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C+=L[k[b++]],C}e.generateUuid=R}),define(te[110],ne([0,1,242]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class _{constructor(L="utf8"){this.stringDecoder=new T.StringDecoder(L),this.remaining=null}write(L){const i=[],R=this.remaining?this.remaining+this.stringDecoder.write(L):this.stringDecoder.write(L);if(R.length<1)return i;let b=0,C,I=b;for(;I<R.length;)if(C=R.charCodeAt(I),C===13||C===10){if(i.push(R.substring(b,I)),I++,I<R.length){const E=C;C=R.charCodeAt(I),(E===13&&C===10||E===10&&C===13)&&I++}b=I}else I++;return this.remaining=b<R.length?R.substr(b):null,i}end(){return this.remaining}}e.LineDecoder=_}),define(te[111],ne([0,1,33]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const _=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(i){const R=i.replace(/\-/g,":").toLowerCase();return!_.has(R)}function L(){const i=(0,T.networkInterfaces)();for(let R in i){const b=i[R];if(b){for(const{mac:C}of b)if(k(C))return C}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(te[112],ne([0,1,33,10,39,30,111]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(I){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(I)}value(){if(this._value===void 0){let I=0,E=0;const f=(0,T.networkInterfaces)();for(let S in f){const h=f[S];if(h)for(const{mac:y,internal:v}of h)v||(E+=1,this._isVirtualMachineMacAddress(y.toUpperCase())&&(I+=1))}this._value=E>0?I/E:0}return this._value}};let R;async function b(){return R||(R=(async()=>await C()||L.generateUuid())()),R}e.getMachineId=b;async function C(){try{const I=await new Promise((f,S)=>{Q(["crypto"],f,S)}),E=(0,i.getMac)();return I.createHash("sha256").update(E,"utf8").digest("hex")}catch(I){_.onUnexpectedError(I);return}}}),define(te[20],ne([0,1,49,33,243,5,40,69,9,4,18,7,30]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function h(M,U=S.UNLINK){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");return U===S.UNLINK?v(M):y(M)}async function y(M){try{const U=(0,b.join)((0,_.tmpdir)(),(0,f.generateUuid)());try{await e.Promises.rename(M,U)}catch(G){return v(M)}v(U).catch(G=>{})}catch(U){if(U.code!=="ENOENT")throw U}}async function v(M){return e.Promises.rmdir(M,{recursive:!0,maxRetries:3})}function m(M){if((0,i.isRootOrDriveLetter)(M))throw new Error("rimraf - will refuse to recursively delete root");T.rmdirSync(M,{recursive:!0})}e.rimrafSync=m;async function w(M,U){return u(await(U?g(M):(0,k.promisify)(T.readdir)(M)))}async function g(M){try{return await(0,k.promisify)(T.readdir)(M,{withFileTypes:!0})}catch(ee){console.warn("[node.js fs] readdir with filetypes failed with error: ",ee)}const U=[],G=await w(M);for(const ee of G){let V=!1,j=!1,Z=!1;try{const W=await e.Promises.lstat((0,b.join)(M,ee));V=W.isFile(),j=W.isDirectory(),Z=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}U.push({name:ee,isFile:()=>V,isDirectory:()=>j,isSymbolicLink:()=>Z})}return U}function l(M){return u(T.readdirSync(M))}e.readdirSync=l;function u(M){return M.map(U=>typeof U=="string"?C.isMacintosh?(0,R.normalizeNFC)(U):U:(U.name=C.isMacintosh?(0,R.normalizeNFC)(U.name):U.name,U))}async function r(M){const U=await w(M),G=[];for(const ee of U)await n.existsDirectory((0,b.join)(M,ee))&&G.push(ee);return G}function a(M,U=1e3){return new Promise(G=>{let ee=!1;const V=setInterval(()=>{ee||(ee=!0,T.access(M,j=>{ee=!1,j&&(clearInterval(V),G(void 0))}))},U)})}e.whenDeleted=a;var n;(function(M){async function U(V){let j;try{if(j=await e.Promises.lstat(V),!j.isSymbolicLink())return{stat:j}}catch(Z){}try{return{stat:await e.Promises.stat(V),symbolicLink:j?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};if(C.isWindows&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&j)return{stat:j,symbolicLink:{dangling:!0}};throw W}throw Z}}M.stat=U;async function G(V){try{const{stat:j,symbolicLink:Z}=await M.stat(V);return j.isFile()&&Z?.dangling!==!0}catch(j){}return!1}M.existsFile=G;async function ee(V){try{const{stat:j,symbolicLink:Z}=await M.stat(V);return j.isDirectory()&&Z?.dangling!==!0}catch(j){}return!1}M.existsDirectory=ee})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function s(M,U,G){return t.queueFor(E.URI.file(M),I.extUriBiasedIgnorePathCase).queue(()=>{const ee=p(G);return new Promise((V,j)=>c(M,U,ee,Z=>Z?j(Z):V()))})}let o=!0;function c(M,U,G,ee){if(!o)return T.writeFile(M,U,{mode:G.mode,flag:G.flag},ee);T.open(M,G.flag,G.mode,(V,j)=>{if(V)return ee(V);T.writeFile(j,U,Z=>{if(Z)return T.close(j,()=>ee(Z));T.fdatasync(j,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),o=!1),T.close(j,z=>ee(z))))})})}function d(M,U,G){const ee=p(G);if(!o)return T.writeFileSync(M,U,{mode:ee.mode,flag:ee.flag});const V=T.openSync(M,ee.flag,ee.mode);try{T.writeFileSync(V,U);try{T.fdatasyncSync(V)}catch(j){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",j),o=!1}}finally{T.closeSync(V)}}e.writeFileSync=d;function p(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function P(M,U){if(M===U)return;async function G(ee){try{const V=await e.Promises.lstat(ee);if(V.isDirectory()||V.isSymbolicLink())return;await e.Promises.utimes(ee,V.atime,new Date)}catch(V){}}try{await e.Promises.rename(M,U),await G(U)}catch(ee){if(M.toLowerCase()!==U.toLowerCase()&&ee.code==="EXDEV"||M.endsWith("."))await O(M,U,{preserveSymlinks:!1}),await h(M,S.MOVE),await G(U);else throw ee}}async function O(M,U,G){return N(M,U,{root:{source:M,target:U},options:G,handledSourcePaths:new Set})}const A=511;async function N(M,U,G){if(G.handledSourcePaths.has(M))return;G.handledSourcePaths.add(M);const{stat:ee,symbolicLink:V}=await n.stat(M);if(V){if(G.options.preserveSymlinks)try{return await F(M,U,G)}catch(j){console.warn("[node.js fs] copy of symlink failed: ",j)}if(V.dangling)return}return ee.isDirectory()?$(M,U,ee.mode&A,G):D(M,U,ee.mode&A)}async function $(M,U,G,ee){await e.Promises.mkdir(U,{recursive:!0,mode:G});const V=await w(M);for(const j of V)await N((0,b.join)(M,j),(0,b.join)(U,j),ee)}async function D(M,U,G){await e.Promises.copyFile(M,U),await e.Promises.chmod(U,G)}async function F(M,U,G){let ee=await e.Promises.readlink(M);(0,i.isEqualOrParent)(ee,G.root.source,!C.isLinux)&&(ee=(0,b.join)(G.root.target,ee.substr(G.root.source.length+1))),await e.Promises.symlink(ee,U)}e.Promises=new class{get access(){return(0,k.promisify)(T.access)}get stat(){return(0,k.promisify)(T.stat)}get lstat(){return(0,k.promisify)(T.lstat)}get utimes(){return(0,k.promisify)(T.utimes)}get read(){return(0,k.promisify)(T.read)}get readFile(){return(0,k.promisify)(T.readFile)}get write(){return(0,k.promisify)(T.write)}get appendFile(){return(0,k.promisify)(T.appendFile)}get fdatasync(){return(0,k.promisify)(T.fdatasync)}get truncate(){return(0,k.promisify)(T.truncate)}get rename(){return(0,k.promisify)(T.rename)}get copyFile(){return(0,k.promisify)(T.copyFile)}get open(){return(0,k.promisify)(T.open)}get close(){return(0,k.promisify)(T.close)}get symlink(){return(0,k.promisify)(T.symlink)}get readlink(){return(0,k.promisify)(T.readlink)}get chmod(){return(0,k.promisify)(T.chmod)}get mkdir(){return(0,k.promisify)(T.mkdir)}get unlink(){return(0,k.promisify)(T.unlink)}get rmdir(){return(0,k.promisify)(T.rmdir)}get realpath(){return(0,k.promisify)(T.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return w}get readDirsInDir(){return r}get writeFile(){return s}get rm(){return h}get move(){return P}get copy(){return O}}}),define(te[113],ne([0,1,49,9,25,20]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function i(I){const E=(0,_.dirname)(I);if(I===E)return I;const f=((0,_.basename)(I)||I).toLowerCase();try{const h=(0,L.readdirSync)(E).filter(y=>y.toLowerCase()===f);if(h.length===1){const y=i(E);if(y)return(0,_.join)(y,h[0])}else if(h.length>1){const y=h.indexOf(f);if(y>=0){const v=i(E);if(v)return(0,_.join)(v,h[y])}}}catch(S){}return null}e.realcaseSync=i;async function R(I){try{return await L.Promises.realpath(I)}catch(E){const f=C(I);return await L.Promises.access(f,T.constants.R_OK),f}}e.realpath=R;function b(I){try{return T.realpathSync(I)}catch(E){const f=C(I);return T.accessSync(f,T.constants.R_OK),f}}e.realpathSync=b;function C(I){return(0,k.rtrim)((0,_.normalize)(I),_.sep)}}),define(te[114],ne([0,1,54]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function _(R,b,C,I=1){let E=!1;return new Promise(f=>{const S=setTimeout(()=>{if(!E)return E=!0,f(0)},C);k(R,b,I,h=>{if(!E)return E=!0,clearTimeout(S),f(h)})})}e.findFreePort=_;function k(R,b,C,I){if(b===0)return I(0);const E=new T.Socket;E.once("connect",()=>(i(E),k(R+C,b-1,C,I))),E.once("data",()=>{}),E.once("error",f=>(i(E),f.code!=="ECONNREFUSED"?k(R+C,b-1,C,I):I(R))),E.connect(R,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(R,b,C){let I=!1,E,f=1;const S=T.createServer({pauseOnConnect:!0});function h(y,v){I||(I=!0,S.removeAllListeners(),S.close(),E&&clearTimeout(E),v(y))}return new Promise(y=>{E=setTimeout(()=>{h(0,y)},C),S.on("listening",()=>{h(R,y)}),S.on("error",v=>{v&&(v.code==="EADDRINUSE"||v.code==="EACCES")&&f<b?(R++,f++,S.listen(R,"127.0.0.1")):h(0,y)}),S.on("close",()=>{h(0,y)}),S.listen(R,"127.0.0.1")})}e.findFreePortFaster=L;function i(R){try{R.removeAllListeners("connect"),R.removeAllListeners("error"),R.end(),R.destroy(),R.unref()}catch(b){console.error(b)}}}),define(te[70],ne([0,1,33,9,20]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,i=/^Microsoft.PowerShell_.*/,R=/^Microsoft.PowerShellPreview_.*/;var b;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(b||(b={}));let C;switch(process.arch){case"ia32":case"x32":C=1;break;case"arm":case"arm64":C=2;break;default:C=0;break}let I;process.env.PROCESSOR_ARCHITEW6432?I=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?I=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?I=1:I=0;class E{constructor(u,r,a){this.exePath=u,this.displayName=r,this.knownToExist=a}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function f({useAlternateBitness:l=!1}={}){return l?C===0?process.env["ProgramFiles(x86)"]||null:I===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function S({useAlternateBitness:l=!1,findPreview:u=!1}={}){const r=f({useAlternateBitness:l});if(!r)return null;const a=_.join(r,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(a))return null;let n=-1,t=null;for(const c of await k.Promises.readdir(a)){let d=-1;if(u){const P=c.indexOf("-");if(P<0)continue;const O=c.substring(0,P);if(!L.test(O)||c.substring(P+1)!=="preview")continue;d=parseInt(O,10)}else{if(!L.test(c))continue;d=parseInt(c,10)}if(d<=n)continue;const p=_.join(a,c,"pwsh.exe");!await k.SymlinkSupport.existsFile(p)||(t=p,n=d)}if(!t)return null;const s=r.includes("x86")?" (x86)":"",o=u?" Preview":"";return new E(t,`PowerShell${o}${s}`,!0)}async function h({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const u=_.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:r,pwshMsixName:a}=l?{pwshMsixDirRegex:R,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:i,pwshMsixName:"PowerShell (Store)"};for(const n of await k.Promises.readdir(u))if(r.test(n)){const t=_.join(u,n,"pwsh.exe");return new E(t,a)}return null}function y(){const l=_.join(T.homedir(),".dotnet","tools","pwsh.exe");return new E(l,".NET Core PowerShell Global Tool")}function v(){const l=_.join(process.env.windir,C===1&&I!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(l,"Windows PowerShell",!0)}async function*m(){let l=await S();l&&(yield l),l=await S({useAlternateBitness:!0}),l&&(yield l),l=await h(),l&&(yield l),l=y(),l&&(yield l),l=await S({findPreview:!0}),l&&(yield l),l=await h({findPreview:!0}),l&&(yield l),l=await S({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=v(),l&&(yield l)}async function*w(){for await(const l of m())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=w;async function g(){for await(const l of w())return l;return null}e.getFirstAvailablePowerShellInstallation=g}),define(te[115],ne([0,1,44,17]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(i){return new Promise((R,b)=>{let C;const I=new Map;function E(S,h,y,v,m){const w=I.get(h);if(S===i||w){const g={name:f(y),cmd:y,pid:S,ppid:h,load:v,mem:m};I.set(S,g),S===i&&(C=g),w&&(w.children||(w.children=[]),w.children.push(g),w.children.length>1&&(w.children=w.children.sort((l,u)=>l.pid-u.pid)))}}function f(S){const h=/--vscode-window-kind=shared-process/,y=/--vscode-window-kind=issue-reporter/,v=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,w=/--crashes-directory/,g=/\\pipe\\winpty-control/,l=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(w.exec(S))return"electron-crash-reporter";if(g.exec(S))return"winpty-process";if(l.exec(S))return"console-window-host (Windows internal process)";let r=u.exec(S);if(r&&r.length===2)return r[1]==="renderer"?h.exec(S)?"shared-process":y.exec(S)?"issue-reporter":v.exec(S)?"process-explorer":"window":r[1]==="utility"&&m.exec(S)?"utility-network-service":r[1];const a=/[a-zA-Z-]+\.js/g;let n="";do r=a.exec(S),r&&(n+=r+" ");while(r);return n&&S.indexOf("node ")<0&&S.indexOf("node.exe")<0?`electron_node ${n}`:S}if(process.platform==="win32"){const S=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,y)=>{Q(["windows-process-tree"],h,y)}).then(h=>{h.getProcessList(i,y=>{h.getProcessCpuUsage(y,v=>{const m=new Map;v.forEach(w=>{const g=S(w.commandLine||"");m.set(w.pid,{name:f(g),cmd:g,pid:w.pid,ppid:w.ppid,load:w.cpu||0,mem:w.memory||0})}),C=m.get(i),C?(m.forEach(w=>{const g=m.get(w.ppid);g&&(g.children||(g.children=[]),g.children.push(w))}),m.forEach(w=>{w.children&&(w.children=w.children.sort((g,l)=>g.pid-l.pid))}),R(C)):b(new Error(`Root process ${i} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let S=function(){let h=[C];const y=[];for(;h.length;){const m=h.shift();m&&(y.push(m.pid),m.children&&(h=h.concat(m.children)))}let v=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",Q).fsPath);v+=" "+y.join(" "),(0,T.exec)(v,{},(m,w,g)=>{if(m||g)b(m||new Error(g.toString()));else{const l=w.toString().split(`
`);for(let u=0;u<y.length;u++){const r=I.get(y[u]);r.load=parseFloat(l[u])}if(!C){b(new Error(`Root process ${i} not found`));return}R(C)}})};(0,T.exec)("which ps",{},(h,y,v)=>{if(h||v)if(process.platform!=="linux")b(h||new Error(v.toString()));else{const m=JSON.stringify(_.FileAccess.asFileUri("vs/base/node/ps.sh",Q).fsPath);(0,T.exec)(m,{},(w,g,l)=>{w||l?b(w||new Error(l.toString())):(L(g,E),S())})}else{const m=y.toString().trim(),w="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,T.exec)(`${m} ${w}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,l,u)=>{g||u&&!u.includes("screen size is bogus")?b(g||new Error(u.toString())):(L(l,E),process.platform==="linux"?S():C?R(C):b(new Error(`Root process ${i} not found`)))})}})}})}e.listProcesses=k;function L(i,R){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,C=i.toString().split(`
`);for(const I of C){const E=b.exec(I.trim());E&&E.length===6&&R(parseInt(E[1]),parseInt(E[2]),E[5],parseFloat(E[3]),parseFloat(E[4]))}}}),define(te[116],ne([0,1,49,27,40,2,69,9,4,20]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function I(h,y,v){return f({path:h,isDirectory:!1},y,v)}e.watchFile=I;function E(h,y,v){return f({path:h,isDirectory:!0},y,v)}e.watchFolder=E,e.CHANGE_BUFFER_DELAY=100;function f(h,y,v){if(b.isMacintosh&&(0,k.isEqualOrParent)(h.path,"/Volumes/"))return v(`Refusing to watch ${h.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.Disposable.None;const m=(0,R.basename)(h.path),w=new Map;let g=!1,l=[(0,L.toDisposable)(()=>{w.forEach(u=>(0,L.dispose)(u)),w.clear()})];try{const u=(0,T.watch)(h.path);l.push((0,L.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const r=new Set;h.isDirectory&&C.Promises.readdir(h.path).then(a=>a.forEach(n=>r.add(n))),u.on("error",(a,n)=>{g||v(`Failed to watch ${h.path} for changes using fs.watch() (${a}, ${n})`)}),u.on("change",(a,n)=>{if(g)return;let t="";if(n&&(t=n.toString(),b.isMacintosh&&(t=(0,i.normalizeNFC)(t))),!t||a!=="change"&&a!=="rename")return;const s=h.isDirectory?(0,R.join)(h.path,t):h.path;if(h.isDirectory)if(a==="rename"){const o=w.get(s);o&&(0,L.dispose)(o);const c=setTimeout(async()=>{w.delete(s);const d=await C.Promises.exists(s);if(g)return;let p;d?r.has(t)?p="changed":(p="added",r.add(t)):(r.delete(t),p="deleted"),y(p,s)},e.CHANGE_BUFFER_DELAY);w.set(s,(0,L.toDisposable)(()=>clearTimeout(c)))}else{let o;r.has(t)?o="changed":(o="added",r.add(t)),y(o,s)}else if(a==="rename"||t!==m){const o=setTimeout(async()=>{const c=await C.Promises.exists(s);g||(c?(y("changed",s),l=[f(h,y,v)]):y("deleted",s))},e.CHANGE_BUFFER_DELAY);(0,L.dispose)(l),l=[(0,L.toDisposable)(()=>clearTimeout(o))]}else y("changed",s)})}catch(u){C.Promises.exists(h.path).then(r=>{r&&!g&&v(`Failed to watch ${h.path} for changes using fs.watch() (${u.toString()})`)})}return(0,L.toDisposable)(()=>{g=!0,l=(0,L.dispose)(l)})}async function S(h,y,v,m=512){const w=await C.Promises.open(h,"r"),g=Buffer.allocUnsafe(m),l=new _.CancellationTokenSource(v);let u,r=!1;const a=I(h,async n=>{if(n==="changed"){if(r)return;r=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:t}=await C.Promises.read(w,g,0,m,null);if(!t||l.token.isCancellationRequested)break;y(g.slice(0,t))}}catch(t){u=new Error(t),l.dispose(!0)}finally{r=!1}}},n=>{u=new Error(n),l.dispose(!0)});return new Promise((n,t)=>{l.token.onCancellationRequested(async()=>{a.dispose(),await C.Promises.close(w),u?t(u):n()})})}e.watchFileContents=S});var de=this&&this.__decorate||function(Q,e,T,_){var k=arguments.length,L=k<3?e:_===null?_=Object.getOwnPropertyDescriptor(e,T):_,i;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(Q,e,T,_);else for(var R=Q.length-1;R>=0;R--)(i=Q[R])&&(L=(k<3?i(L):k>3?i(e,T,L):i(e,T))||L);return k>3&&L&&Object.defineProperty(e,T,L),L};define(te[36],ne([0,1,16,5,19,27,66,10,3,2,106,25,15]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var S;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(S=e.RequestType||(e.RequestType={}));function h(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(y=e.ResponseType||(e.ResponseType={}));function v(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(m||(m={}));class w{constructor(j){this.buffer=j,this.pos=0}read(j){const Z=this.buffer.slice(this.pos,this.pos+j);return this.pos+=Z.byteLength,Z}}class g{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(j){this.buffers.push(j)}}var l;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object"})(l||(l={}));function u(V){const j=k.VSBuffer.alloc(4);return j.writeUInt32BE(V,0),j}function r(V){return V.read(4).readUInt32BE(0)}function a(V){const j=k.VSBuffer.alloc(1);return j.writeUInt8(V,0),j}const n={Undefined:a(l.Undefined),String:a(l.String),Buffer:a(l.Buffer),VSBuffer:a(l.VSBuffer),Array:a(l.Array),Object:a(l.Object)},t=typeof Buffer!="undefined";function s(V,j){if(typeof j=="undefined")V.write(n.Undefined);else if(typeof j=="string"){const Z=k.VSBuffer.fromString(j);V.write(n.String),V.write(u(Z.byteLength)),V.write(Z)}else if(t&&Buffer.isBuffer(j)){const Z=k.VSBuffer.wrap(j);V.write(n.Buffer),V.write(u(Z.byteLength)),V.write(Z)}else if(j instanceof k.VSBuffer)V.write(n.VSBuffer),V.write(u(j.byteLength)),V.write(j);else if(Array.isArray(j)){V.write(n.Array),V.write(u(j.length));for(const Z of j)s(V,Z)}else{const Z=k.VSBuffer.fromString(JSON.stringify(j));V.write(n.Object),V.write(u(Z.byteLength)),V.write(Z)}}function o(V){switch(V.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return V.read(r(V)).toString();case l.Buffer:return V.read(r(V)).buffer;case l.VSBuffer:return V.read(r(V));case l.Array:{const Z=r(V),W=[];for(let z=0;z<Z;z++)W.push(o(V));return W}case l.Object:return JSON.parse(V.read(r(V)).toString())}}class c{constructor(j,Z,W=null,z=1e3){this.protocol=j,this.ctx=Z,this.logger=W,this.timeoutDelay=z,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(B=>this.onRawMessage(B)),this.sendResponse({type:200})}registerChannel(j,Z){this.channels.set(j,Z),setTimeout(()=>this.flushPendingRequests(j),0)}sendResponse(j){switch(j.type){case 200:{const Z=this.send([j.type]);this.logger&&this.logger.logOutgoing(Z,0,1,v(j.type));return}case 201:case 202:case 204:case 203:{const Z=this.send([j.type,j.id],j.data);this.logger&&this.logger.logOutgoing(Z,j.id,1,v(j.type),j.data);return}}}send(j,Z=void 0){const W=new g;return s(W,j),s(W,Z),this.sendBuffer(W.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Z){return 0}}onRawMessage(j){const Z=new w(j),W=o(Z),z=o(Z),B=W[0];switch(B){case 100:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(B)}: ${W[2]}.${W[3]}`,z),this.onPromise({type:B,id:W[1],channelName:W[2],name:W[3],arg:z});case 102:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(B)}: ${W[2]}.${W[3]}`,z),this.onEventListen({type:B,id:W[1],channelName:W[2],name:W[3],arg:z});case 101:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],1,`${h(B)}`),this.disposeActiveRequest({type:B,id:W[1]})}}onPromise(j){const Z=this.channels.get(j.channelName);if(!Z){this.collectPendingRequest(j);return}const W=new L.CancellationTokenSource;let z;try{z=Z.call(this.ctx,j.name,j.arg,W.token)}catch(H){z=Promise.reject(H)}const B=j.id;z.then(H=>{this.sendResponse({id:B,data:H,type:201}),this.activeRequests.delete(j.id)},H=>{H instanceof Error?this.sendResponse({id:B,data:{message:H.message,name:H.name,stack:H.stack?H.stack.split?H.stack.split(`
`):H.stack:void 0},type:202}):this.sendResponse({id:B,data:H,type:203}),this.activeRequests.delete(j.id)});const q=(0,C.toDisposable)(()=>W.cancel());this.activeRequests.set(j.id,q)}onEventListen(j){const Z=this.channels.get(j.channelName);if(!Z){this.collectPendingRequest(j);return}const W=j.id,B=Z.listen(this.ctx,j.name,j.arg)(q=>this.sendResponse({id:W,data:q,type:204}));this.activeRequests.set(j.id,B)}disposeActiveRequest(j){const Z=this.activeRequests.get(j.id);Z&&(Z.dispose(),this.activeRequests.delete(j.id))}collectPendingRequest(j){let Z=this.pendingRequests.get(j.channelName);Z||(Z=[],this.pendingRequests.set(j.channelName,Z));const W=setTimeout(()=>{console.error(`Unknown channel: ${j.channelName}`),j.type===100&&this.sendResponse({id:j.id,data:{name:"Unknown channel",message:`Channel name '${j.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Z.push({request:j,timeoutTimer:W})}flushPendingRequests(j){const Z=this.pendingRequests.get(j);if(Z){for(const W of Z)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(j)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}e.ChannelServer=c;var d;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(j,Z=null){this.protocol=j,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new b.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=Z}getChannel(j){const Z=this;return{call(W,z,B){return Z.isDisposed?Promise.reject(R.canceled()):Z.requestPromise(j,W,z,B)},listen(W,z){return Z.isDisposed?Promise.reject(R.canceled()):Z.requestEvent(j,W,z)}}}requestPromise(j,Z,W,z=L.CancellationToken.None){const B=this.lastRequestId++,H={id:B,type:100,channelName:j,name:Z,arg:W};if(z.isCancellationRequested)return Promise.reject(R.canceled());let Y;return new Promise((K,re)=>{if(z.isCancellationRequested)return re(R.canceled());const se=()=>{const ye=we=>{switch(we.type){case 201:this.handlers.delete(B),K(we.data);break;case 202:this.handlers.delete(B);const pe=new Error(we.data.message);pe.stack=we.data.stack,pe.name=we.data.name,re(pe);break;case 203:this.handlers.delete(B),re(we.data);break}};this.handlers.set(B,ye),this.sendRequest(H)};let ce=null;this.state===m.Idle?se():(ce=(0,_.createCancelablePromise)(ye=>this.whenInitialized()),ce.then(()=>{ce=null,se()}));const he=()=>{ce?(ce.cancel(),ce=null):this.sendRequest({id:B,type:101}),re(R.canceled())},me=z.onCancellationRequested(he);Y=(0,C.combinedDisposable)((0,C.toDisposable)(he),me),this.activeRequests.add(Y)}).finally(()=>{this.activeRequests.delete(Y)})}requestEvent(j,Z,W){const z=this.lastRequestId++,q={id:z,type:102,channelName:j,name:Z,arg:W};let H=null;const Y=new b.Emitter({onFirstListenerAdd:()=>{H=(0,_.createCancelablePromise)(K=>this.whenInitialized()),H.then(()=>{H=null,this.activeRequests.add(Y),this.sendRequest(q)})},onLastListenerRemove:()=>{H?(H.cancel(),H=null):(this.activeRequests.delete(Y),this.sendRequest({id:z,type:103}))}}),x=K=>Y.fire(K.data);return this.handlers.set(z,x),Y.event}sendRequest(j){switch(j.type){case 100:case 102:{const Z=this.send([j.type,j.id,j.channelName,j.name],j.arg);this.logger&&this.logger.logOutgoing(Z,j.id,0,`${h(j.type)}: ${j.channelName}.${j.name}`,j.arg);return}case 101:case 103:{const Z=this.send([j.type,j.id]);this.logger&&this.logger.logOutgoing(Z,j.id,0,h(j.type));return}}}send(j,Z=void 0){const W=new g;return s(W,j),s(W,Z),this.sendBuffer(W.buffer)}sendBuffer(j){try{return this.protocol.send(j),j.byteLength}catch(Z){return 0}}onBuffer(j){const Z=new w(j),W=o(Z),z=o(Z),B=W[0];switch(B){case 200:return this.logger&&this.logger.logIncoming(j.byteLength,0,0,v(B)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(j.byteLength,W[1],0,v(B),z),this.onResponse({type:W[0],id:W[1],data:z})}}onResponse(j){if(j.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const Z=this.handlers.get(j.id);Z&&Z(j)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(j=>j.dispose()),this.activeRequests.clear()}}de([i.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class P{constructor(j){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new b.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new b.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,j(({protocol:Z,onDidClientDisconnect:W})=>{b.Event.once(Z.onMessage)(B=>{const q=new w(B),H=o(q),Y=new c(Z,H),x=new p(Z);this.channels.forEach((re,se)=>Y.registerChannel(se,re));const K={channelServer:Y,channelClient:x,ctx:H};this._connections.add(K),this._onDidAddConnection.fire(K),W(()=>{Y.dispose(),x.dispose(),this._connections.delete(K),this._onDidRemoveConnection.fire(K)})})})}get connections(){const j=[];return this._connections.forEach(Z=>j.push(Z)),j}getChannel(j,Z){const W=this;return{call(z,B,q){let H;if((0,f.isFunction)(Z)){let x=(0,T.getRandomElement)(W.connections.filter(Z));H=x?Promise.resolve(x):b.Event.toPromise(b.Event.filter(W.onDidAddConnection,Z))}else H=Z.routeCall(W,z,B);const Y=H.then(x=>x.channelClient.getChannel(j));return A(Y).call(z,B,q)},listen(z,B){if((0,f.isFunction)(Z))return W.getMulticastEvent(j,Z,z,B);const q=Z.routeEvent(W,z,B).then(H=>H.channelClient.getChannel(j));return A(q).listen(z,B)}}}getMulticastEvent(j,Z,W,z){const B=this;let q=new C.DisposableStore;const H=new b.Emitter({onFirstListenerAdd:()=>{q=new C.DisposableStore;const Y=new b.EventMultiplexer,x=new Map,K=se=>{const he=se.channelClient.getChannel(j).listen(W,z),me=Y.add(he);x.set(se,me)},re=se=>{const ce=x.get(se);!ce||(ce.dispose(),x.delete(se))};B.connections.filter(Z).forEach(K),b.Event.filter(B.onDidAddConnection,Z)(K,void 0,q),B.onDidRemoveConnection(re,void 0,q),Y.event(H.fire,H,q),q.add(Y)},onLastListenerRemove:()=>{q.dispose()}});return H.event}registerChannel(j,Z){this.channels.set(j,Z),this._connections.forEach(W=>{W.channelServer.registerChannel(j,Z)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=P;class O{constructor(j,Z,W=null){const z=new g;s(z,Z),j.send(z.buffer),this.channelClient=new p(j,W),this.channelServer=new c(j,Z,W)}getChannel(j){return this.channelClient.getChannel(j)}registerChannel(j,Z){this.channelServer.registerChannel(j,Z)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function A(V){return{call(j,Z,W){return V.then(z=>z.call(j,Z,W))},listen(j,Z){const W=new b.Relay;return V.then(z=>W.input=z.listen(j,Z)),W.event}}}e.getDelayedChannel=A;function N(V){let j=!1;return{call(Z,W,z){return j?V.call(Z,W,z):(0,_.timeout)(0).then(()=>j=!0).then(()=>V.call(Z,W,z))},listen(Z,W){if(j)return V.listen(Z,W);const z=new b.Relay;return(0,_.timeout)(0).then(()=>j=!0).then(()=>z.input=V.listen(Z,W)),z.event}}}e.getNextTickChannel=N;class ${constructor(j){this.fn=j}routeCall(j){return this.route(j)}routeEvent(j){return this.route(j)}async route(j){for(const Z of j.connections)if(await Promise.resolve(this.fn(Z.ctx)))return Promise.resolve(Z);return await b.Event.toPromise(j.onDidAddConnection),await this.route(j)}}e.StaticRouter=$;var D;(function(V){function j(B,q){const H=B,Y=q&&q.disableMarshalling,x=new Map;for(const K in H)W(K)&&x.set(K,b.Event.buffer(H[K],!0));return new class{listen(K,re,se){const ce=x.get(re);if(ce)return ce;if(z(re)){const he=H[re];if(typeof he=="function")return he.call(H,se)}throw new Error(`Event not found: ${re}`)}call(K,re,se){const ce=H[re];if(typeof ce=="function"){if(!Y&&Array.isArray(se))for(let he=0;he<se.length;he++)se[he]=(0,I.revive)(se[he]);return ce.apply(H,se)}throw new Error(`Method not found: ${re}`)}}}V.fromService=j;function Z(B,q){const H=q&&q.disableMarshalling;return new Proxy({},{get(Y,x){if(typeof x=="string")return q?.properties?.has(x)?q.properties.get(x):z(x)?function(K){return B.listen(x,K)}:W(x)?B.listen(x):async function(...K){let re;q&&!(0,f.isUndefinedOrNull)(q.context)?re=[q.context,...K]:re=K;const se=await B.call(x,re);return H?se:(0,I.revive)(se)};throw new Error(`Property not found: ${String(x)}`)}})}V.toService=Z;function W(B){return B[0]==="o"&&B[1]==="n"&&E.isUpperAsciiLetter(B.charCodeAt(2))}function z(B){return/^onDynamic/.test(B)&&E.isUpperAsciiLetter(B.charCodeAt(9))}})(D=e.ProxyChannel||(e.ProxyChannel={}));const F=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){let j=V.toString();if(j!=="[object Object]")return j}return V}function U(V){return Array.isArray(V)?V.map(M):M(V)}function G(V,j,Z,W,z,B,q){q=U(q);const H=F[z],Y=H[W%H.length];let x=[`%c[${V}]%c[${String(j).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${Y}`];/\($/.test(B)?(x=x.concat(q),x.push(")")):x.push(q),console.log.apply(console,x)}e.logWithColors=G;class ee{constructor(j,Z){this._outgoingPrefix=j,this._incomingPrefix=Z,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(j,Z,W,z,B){this._totalOutgoing+=j,G(this._outgoingPrefix,this._totalOutgoing,j,Z,W,z,B)}logIncoming(j,Z,W,z,B){this._totalIncoming+=j,G(this._incomingPrefix,this._totalIncoming,j,Z,W,z,B)}}e.IPCLogger=ee}),define(te[117],ne([0,1,19,3,36]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(b){this.port=b,this.onMessage=_.Event.fromDOMEventEmitter(this.port,"message",C=>T.VSBuffer.wrap(C.data)),b.start()}send(b){this.port.postMessage(b.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class i extends k.IPCClient{constructor(b,C){const I=new L(b);super(I,C);this.protocol=I}dispose(){this.protocol.disconnect()}}e.Client=i}),define(te[71],ne([0,1,19,3,2,36]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var i;(function(t){t.Created="created",t.Read="read",t.Write="write",t.Open="open",t.Error="error",t.Close="close",t.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",t.NodeEndReceived="nodeEndReceived",t.NodeEndSent="nodeEndSent",t.NodeDrainBegin="nodeDrainBegin",t.NodeDrainEnd="nodeDrainEnd",t.zlibInflateError="zlibInflateError",t.zlibInflateData="zlibInflateData",t.zlibInflateInitialWrite="zlibInflateInitialWrite",t.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",t.zlibInflateWrite="zlibInflateWrite",t.zlibInflateFlushFired="zlibInflateFlushFired",t.zlibDeflateError="zlibDeflateError",t.zlibDeflateData="zlibDeflateData",t.zlibDeflateWrite="zlibDeflateWrite",t.zlibDeflateFlushFired="zlibDeflateFlushFired",t.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",t.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",t.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",t.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",t.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",t.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",t.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",t.ProtocolHeaderRead="protocolHeaderRead",t.ProtocolMessageRead="protocolMessageRead",t.ProtocolHeaderWrite="protocolHeaderWrite",t.ProtocolMessageWrite="protocolMessageWrite",t.ProtocolWrite="protocolWrite"})(i=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var R;(function(t){t.enableDiagnostics=!1,t.records=[];const s=new WeakMap;let o=0;function c(p,P){if(!s.has(p)){const O=String(++o);s.set(p,O)}return s.get(p)}function d(p,P,O,A){if(!t.enableDiagnostics)return;const N=c(p,P);if(A instanceof T.VSBuffer||A instanceof Uint8Array||A instanceof ArrayBuffer||ArrayBuffer.isView(A)){const $=T.VSBuffer.alloc(A.byteLength);$.set(A),t.records.push({timestamp:Date.now(),id:N,label:P,type:O,buff:$})}else t.records.push({timestamp:Date.now(),id:N,label:P,type:O,data:A})}t.traceSocketEvent=d})(R=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(t){t[t.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",t[t.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let C=null;function I(){return C||(C=T.VSBuffer.alloc(0)),C}class E{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(s){this._chunks.push(s),this._totalLength+=s.byteLength}read(s){return this._read(s,!0)}peek(s){return this._read(s,!1)}_read(s,o){if(s===0)return I();if(s>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===s){const P=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=s),P}if(this._chunks[0].byteLength>s){const P=this._chunks[0].slice(0,s);return o&&(this._chunks[0]=this._chunks[0].slice(s),this._totalLength-=s),P}let c=T.VSBuffer.alloc(s),d=0,p=0;for(;s>0;){const P=this._chunks[p];if(P.byteLength>s){const O=P.slice(0,s);c.set(O,d),d+=s,o&&(this._chunks[p]=P.slice(s),this._totalLength-=s),s-=s}else c.set(P,d),d+=P.byteLength,o?(this._chunks.shift(),this._totalLength-=P.byteLength):p++,s-=P.byteLength}return c}}e.ChunkStream=E;var f;(function(t){t[t.None=0]="None",t[t.Regular=1]="Regular",t[t.Control=2]="Control",t[t.Ack=3]="Ack",t[t.Disconnect=5]="Disconnect",t[t.ReplayRequest=6]="ReplayRequest",t[t.Pause=7]="Pause",t[t.Resume=8]="Resume"})(f||(f={}));function S(t){switch(t){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var h;(function(t){t[t.HeaderLength=13]="HeaderLength",t[t.AcknowledgeTime=2e3]="AcknowledgeTime",t[t.TimeoutTime=2e4]="TimeoutTime",t[t.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",t[t.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class y{constructor(s,o,c,d){this.type=s,this.id=o,this.ack=c,this.data=d,this.writtenTime=0}get size(){return this.data.byteLength}}class v extends k.Disposable{constructor(s){super();this._onMessage=this._register(new _.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=s,this._isDisposed=!1,this._incomingData=new E,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(s){if(!(!s||s.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(s);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:S(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,d=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",o),this._onMessage.fire(new y(c,d,p,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(s){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=s,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(s){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(s){if(this._isDisposed)return;s.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=T.VSBuffer.alloc(13);o.writeUInt8(s.type,0),o.writeUInt32BE(s.id,1),o.writeUInt32BE(s.ack,5),o.writeUInt32BE(s.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:S(s.type),id:s.id,ack:s.ack,messageSize:s.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",s.data),this._writeSoon(o,s.data)}_bufferAdd(s,o){const c=this._totalLength===0;return this._data.push(s,o),this._totalLength+=s.byteLength+o.byteLength,c}_bufferTake(){const s=T.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,s}_writeSoon(s,o){this._bufferAdd(s,o)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const s=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:s.byteLength}),this._socket.write(s)}}class w extends k.Disposable{constructor(s){super();this._onMessage=new _.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new _.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=s,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new v(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(s){this._socketWriter.write(new y(1,0,0,s))}}e.Protocol=w;class g extends L.IPCClient{constructor(s,o,c=null){super(s,o,c);this.protocol=s}static fromSocket(s,o){return new g(new w(s),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const s=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),s.end()}}e.Client=g;class l{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new _.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(s){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(s):this._emitter.fire(s):this._bufferedMessages.push(s)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=l;class u{constructor(s){this.data=s,this.next=null}}class r{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let s=[],o=0,c=this._first;for(;c;)s[o++]=c.data,c=c.next;return s}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(s){const o=new u(s);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class a{constructor(){this.lastRuns=[];const s=Date.now();for(let o=0;o<a._HISTORY_LENGTH;o++)this.lastRuns[o]=s-1e3*o;setInterval(()=>{for(let o=a._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const s=Date.now(),o=(1+a._HISTORY_LENGTH)*1e3;let c=0;for(let d=0;d<a._HISTORY_LENGTH;d++)s-this.lastRuns[d]<=o&&c++;return 1-c/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class n{constructor(s,o=null,c=a.getInstance()){this._onControlMessage=new l,this.onControlMessage=this._onControlMessage.event,this._onMessage=new l,this.onMessage=this._onMessage.event,this._onDidDispose=new l,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new l,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new l,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new r,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(d=>this._receiveMessage(d))),this._socketDisposables.push(this._socket.onClose(d=>this._onSocketClose.fire(d))),o&&this._socketReader.acceptChunk(o)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const s=new y(5,0,0,I());this._socketWriter.write(s),this._socketWriter.flush()}sendPause(){const s=new y(7,0,0,I());this._socketWriter.write(s)}sendResume(){const s=new y(8,0,0,I());this._socketWriter.write(s)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(s,o){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=s,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new v(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s);const o=this._outgoingUnackMsg.toArray();for(let c=0,d=o.length;c<d;c++)this._socketWriter.write(o[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(s){if(s.ack>this._outgoingAckId){this._outgoingAckId=s.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=s.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(s.type){case 0:break;case 1:{if(s.id>this._incomingMsgId)if(s.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new y(6,0,0,I())))}else this._incomingMsgId=s.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(s.data);break}case 2:{this._onControlMessage.fire(s.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const o=this._outgoingUnackMsg.toArray();for(let c=0,d=o.length;c<d;c++)this._socketWriter.write(o[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(s){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new y(1,o,this._incomingAckId,s);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(s){const o=new y(2,0,0,s);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const s=Date.now()-this._incomingMsgLastTime;if(s>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-s+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const s=this._outgoingUnackMsg.peek(),o=Date.now()-s.writtenTime,c=Date.now()-this._socketReader.lastReadTime,d=Date.now()-this._lastSocketTimeoutTime;if(o>=2e4&&c>=2e4&&d>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const p=Math.max(2e4-o,2e4-c,2e4-d,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const s=new y(3,0,this._incomingAckId,I());this._socketWriter.write(s)}}e.PersistentProtocol=n}),define(te[118],ne([0,1,72,3,36,117]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class i extends k.IPCServer{static getOnDidClientConnect(){const b=_.Event.fromNodeEventEmitter(T.ipcRenderer,"vscode:createMessageChannel",(C,I)=>I);return _.Event.map(b,C=>{const{port1:I,port2:E}=new MessageChannel,S={protocol:new L.Protocol(I),onDidClientDisconnect:_.Event.fromDOMEventEmitter(I,"close")};return T.ipcRenderer.postMessage("vscode:createMessageChannelResult",C,[E]),S})}constructor(){super(i.getOnDidClientConnect())}}e.Server=i}),define(te[119],ne([0,1,19,10]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function k(R,b){R.proxyAuthorization&&(R.headers={...R.headers||{},"Proxy-Authorization":R.proxyAuthorization});const C=new XMLHttpRequest;return new Promise((I,E)=>{C.open(R.type||"GET",R.url||"",!0,R.user,R.password),L(C,R),C.responseType="arraybuffer",C.onerror=f=>E(new Error(C.statusText&&"XHR failed: "+C.statusText||"XHR failed")),C.onload=f=>{I({res:{statusCode:C.status,headers:i(C)},stream:(0,T.bufferToStream)(T.VSBuffer.wrap(new Uint8Array(C.response)))})},C.ontimeout=f=>E(new Error(`XHR timeout: ${R.timeout}ms`)),R.timeout&&(C.timeout=R.timeout),C.send(R.data),b.onCancellationRequested(()=>{C.abort(),E((0,_.canceled)())})})}e.request=k;function L(R,b){if(b.headers){e:for(let C in b.headers){switch(C){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}R.setRequestHeader(C,b.headers[C])}}}function i(R){const b=Object.create(null);for(const C of R.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(C){const I=C.indexOf(":");b[C.substr(0,I).trim().toLowerCase()]=C.substr(I+1).trim()}return b}}),define(te[73],ne([0,1,5,3,2,15]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var i;(function(E){E[E.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(i=e.StorageHint||(e.StorageHint={}));function R(E){const f=E;return f?.changed instanceof Map||f?.deleted instanceof Set}e.isStorageItemsChangeEvent=R;var b;(function(E){E[E.None=0]="None",E[E.Initialized=1]="Initialized",E[E.Closed=2]="Closed"})(b||(b={}));class C extends k.Disposable{constructor(f,S=Object.create(null)){super();this.database=f,this.options=S,this._onDidChangeStorage=this._register(new _.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=b.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(C.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){f.changed?.forEach((S,h)=>this.accept(h,S)),f.deleted?.forEach(S=>this.accept(S,void 0))}accept(f,S){if(this.state===b.Closed)return;let h=!1;(0,L.isUndefinedOrNull)(S)?h=this.cache.delete(f):this.cache.get(f)!==S&&(this.cache.set(f,S),h=!0),h&&this._onDidChangeStorage.fire(f)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===b.None&&(this.state=b.Initialized,this.options.hint!==i.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,S){const h=this.cache.get(f);return(0,L.isUndefinedOrNull)(h)?S:h}getBoolean(f,S){const h=this.get(f);return(0,L.isUndefinedOrNull)(h)?S:h==="true"}getNumber(f,S){const h=this.get(f);return(0,L.isUndefinedOrNull)(h)?S:parseInt(h,10)}async set(f,S){if(this.state===b.Closed)return;if((0,L.isUndefinedOrNull)(S))return this.delete(f);const h=String(S);if(this.cache.get(f)!==h)return this.cache.set(f,h),this.pendingInserts.set(f,h),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async delete(f){if(!(this.state===b.Closed||!this.cache.delete(f)))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=b.Closed;try{await this.doFlush(0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(f){if(!!this.hasPending)return this.doFlush(f)}async doFlush(f){return this.flushDelayer.trigger(()=>this.flushPending(),f)}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=C,C.DEFAULT_FLUSH_DELAY=100;class I{constructor(){this.onDidChangeItemsExternal=_.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((S,h)=>this.items.set(h,S)),f.delete&&f.delete.forEach(S=>this.items.delete(S))}async close(){}}e.InMemoryStorageDatabase=I}),define(te[120],ne([12,13]),function(Q,e){return Q.create("vs/base/common/date",e)}),define(te[55],ne([0,1,120]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const _=60,k=_*60,L=k*24,i=L*7,R=L*30,b=L*365;function C(E,f){typeof E!="number"&&(E=E.getTime());const S=Math.round((new Date().getTime()-E)/1e3);if(S<-30)return(0,T.localize)(0,null,C(new Date().getTime()+S*1e3,!1));if(S<30)return(0,T.localize)(1,null);let h;return S<_?(h=S,f?h===1?(0,T.localize)(2,null,h):(0,T.localize)(3,null,h):h===1?(0,T.localize)(4,null,h):(0,T.localize)(5,null,h)):S<k?(h=Math.floor(S/_),f?h===1?(0,T.localize)(6,null,h):(0,T.localize)(7,null,h):h===1?(0,T.localize)(8,null,h):(0,T.localize)(9,null,h)):S<L?(h=Math.floor(S/k),f?h===1?(0,T.localize)(10,null,h):(0,T.localize)(11,null,h):h===1?(0,T.localize)(12,null,h):(0,T.localize)(13,null,h)):S<i?(h=Math.floor(S/L),f?h===1?(0,T.localize)(14,null,h):(0,T.localize)(15,null,h):h===1?(0,T.localize)(16,null,h):(0,T.localize)(17,null,h)):S<R?(h=Math.floor(S/i),f?h===1?(0,T.localize)(18,null,h):(0,T.localize)(19,null,h):h===1?(0,T.localize)(20,null,h):(0,T.localize)(21,null,h)):S<b?(h=Math.floor(S/R),f?h===1?(0,T.localize)(22,null,h):(0,T.localize)(23,null,h):h===1?(0,T.localize)(24,null,h):(0,T.localize)(25,null,h)):(h=Math.floor(S/b),f?h===1?(0,T.localize)(26,null,h):(0,T.localize)(27,null,h):h===1?(0,T.localize)(28,null,h):(0,T.localize)(29,null,h))}e.fromNow=C;function I(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=I}),define(te[121],ne([12,13]),function(Q,e){return Q.create("vs/base/common/errorMessage",e)}),define(te[38],ne([0,1,16,15,121]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function L(C,I){return I&&(C.stack||C.stacktrace)?k.localize(0,null,R(C),i(C.stack)||i(C.stacktrace)):R(C)}function i(C){return Array.isArray(C)?C.join(`
`):C}function R(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?k.localize(1,null,C.message):C.message||k.localize(2,null)}function b(C=null,I=!1){if(!C)return k.localize(3,null);if(Array.isArray(C)){const E=T.coalesce(C),f=b(E[0],I);return E.length>1?k.localize(4,null,f,E.length):f}if(_.isString(C))return C;if(C.detail){const E=C.detail;if(E.error)return L(E.error,I);if(E.exception)return L(E.exception,I)}return C.stack?L(C,I):C.message?C.message:k.localize(5,null)}e.toErrorMessage=b}),define(te[122],ne([12,13]),function(Q,e){return Q.create("vs/base/node/processes",e)}),define(te[74],ne([0,1,44,40,17,28,9,4,32,101,15,110,20,122]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return C.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return C.TerminateResponseCode}});function h(r){switch(r){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function y(r,a){if(R.isWindows)try{const n={stdio:["pipe","pipe","ignore"]};a&&(n.cwd=a);const t=T.execFile("taskkill",["/T","/F","/PID",r.pid.toString()],n);return new Promise(s=>{t.once("error",o=>{s({success:!1,error:o})}),t.once("exit",(o,c)=>{s(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(n){return Promise.resolve({success:!1,error:n,code:n.status?h(n.status):1})}else if(R.isLinux||R.isMacintosh)try{const n=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",Q).fsPath;return new Promise(t=>{T.execFile(n,[r.pid.toString()],{encoding:"utf8",shell:!0},(s,o,c)=>{t(s?{success:!1,error:s}:{success:!0})})})}catch(n){return Promise.resolve({success:!1,error:n})}else r.kill("SIGKILL");return Promise.resolve({success:!0})}function v(r){!r||(delete r.DEBUG,R.isMacintosh&&delete r.DYLD_LIBRARY_PATH,R.isLinux&&delete r.LD_PRELOAD)}e.removeDangerousEnvVariables=v;function m(r=b.env){return r.comspec||"cmd.exe"}e.getWindowsShell=m;class w{constructor(a,n,t,s){if(n!==void 0&&t!==void 0&&s!==void 0)this.cmd=a,this.args=n,this.shell=t,this.options=s;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(b.env).forEach(c=>{o[c]=b.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const n=a.lastIndexOf(i.sep);return n!==-1&&(a=a.substring(n+1)),w.WellKnowCommands[a]?a:"other"}start(a){return R.isWindows&&(this.options&&this.options.cwd&&_.isUNC(this.options.cwd)||!this.options&&_.isUNC(b.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(n=>{let t,s;const o=new Promise((c,d)=>{t=c,s=d});if(n){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=T.exec(c,this.options,(d,p,P)=>{this.childProcess=null;const O=d;O&&O.killed?s({killed:this.terminateRequested,stdout:p.toString(),stderr:P.toString()}):this.handleExec(t,a,d,p,P)})}else{let c=null;const d=p=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(p,t,a,s);const P={terminated:this.terminateRequested};I.isNumber(p)&&(P.cmdCode=p),t(P)};if(this.shell&&R.isWindows){const p=L.deepClone(this.options);p.windowsVerbatimArguments=!0,p.detached=!1;let P=!1,O=!1;const A=[];let N=this.ensureQuotes(this.cmd);A.push(N.value),P=N.quoted,this.args&&this.args.forEach(D=>{N=this.ensureQuotes(D),A.push(N.value),O=O&&N.quoted});const $=["/s","/c"];P?O?$.push('"'+A.join(" ")+'"'):A.length>1?$.push('"'+A[0]+'" '+A.slice(1).join(" ")):$.push('"'+A[0]+'"'):$.push(A.join(" ")),c=T.spawn(m(),$,p)}else this.cmd&&(c=T.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(I.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",p=>{this.childProcess=null,s({terminated:this.terminateRequested,error:p})}),c.pid&&(this.childProcess.on("close",d),this.handleSpawn(c,t,a,s,!0)))}return o})}handleClose(a,n,t,s){}ensureQuotes(a){return w.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,y(a,this.options.cwd).then(n=>(n.success&&(this.childProcess=null),n))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!R.isWindows)return a(!1);const n=T.spawn(m(),["/s","/c"]);n.on("error",t=>a(!0)),n.on("exit",t=>a(!1))})}}e.AbstractProcess=w,w.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},w.regexp=/^[^"].* .*[^"]/;class g extends w{constructor(a,n,t,s){super(a,n,t,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,n,t,s,o){[s,o].forEach((c,d)=>{const p=new E.LineDecoder;p.write(c).forEach(A=>{n({line:A,source:d===0?0:1})});const O=p.end();O&&n({line:O,source:d===0?0:1})}),a({terminated:this.terminateRequested,error:t})}handleSpawn(a,n,t,s,o){const c=new E.LineDecoder,d=new E.LineDecoder;a.stdout.on("data",p=>{c.write(p).forEach(O=>t({line:O,source:0}))}),a.stderr.on("data",p=>{d.write(p).forEach(O=>t({line:O,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=d}handleClose(a,n,t,s){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=g;function l(r){let a=[],n=!1;const t=function(s){if(n){a.push(s);return}(!r.send(s,c=>{if(c&&console.error(c),n=!1,a.length>0){const d=a.slice(0);a=[],d.forEach(p=>t(p))}})||R.isWindows)&&(n=!0)};return{send:t}}e.createQueuedSender=l;var u;(function(r){async function a(n,t,s){if(i.isAbsolute(n))return n;if(t===void 0&&(t=b.cwd()),i.dirname(n)!=="."||(s===void 0&&I.isString(b.env.PATH)&&(s=b.env.PATH.split(i.delimiter)),s===void 0||s.length===0))return i.join(t,n);async function c(d){if(await f.Promises.exists(d)){let p;try{p=await f.Promises.stat(d)}catch(P){P.message.startsWith("EACCES")&&(p=await f.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(let d of s){let p;if(i.isAbsolute(d)?p=i.join(d,n):p=i.join(t,d,n),await c(p))return p;let P=p+".com";if(await c(P)||(P=p+".exe",await c(P)))return P}return i.join(t,n)}r.findExecutable=a})(u=e.win32||(e.win32={}))}),define(te[123],ne([0,1,33,4,70,74]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function i(S,h){return S===1?_.isWindows?E():L.getWindowsShell(h):C(S,h)}e.getSystemShell=i;function R(S,h){return S===1?_.isWindows?f(h):L.getWindowsShell(h):C(S,h)}e.getSystemShellSync=R;let b=null;function C(S,h){if(_.isLinux&&S===2||_.isMacintosh&&S===3)return"/bin/bash";if(!b){let y;if(_.isWindows)y="/bin/bash";else{if(y=h.SHELL,!y)try{y=(0,T.userInfo)().shell}catch(v){}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}b=y}return b}let I=null;async function E(){return I||(I=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),I}function f(S){if(I)return I;const h=_.isWindows&&parseFloat((0,T.release)())>=10,y=S.hasOwnProperty("PROCESSOR_ARCHITEW6432"),v=`${S.windir}\\${y?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return h?v:L.getWindowsShell(S)}}),define(te[56],ne([0,1,44,5,19,27,105,10,3,2,28,74,36]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class S extends f.ChannelServer{constructor(v){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(w){}},onMessage:b.Event.fromNodeEventEmitter(process,"message",m=>k.VSBuffer.wrap(Buffer.from(m,"base64")))},v);process.once("disconnect",()=>this.dispose())}}e.Server=S;class h{constructor(v,m){this.modulePath=v,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new b.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const w=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new _.Delayer(w),this.child=null,this._client=null}getChannel(v){const m=this;return{call(w,g,l){return m.requestPromise(v,w,g,l)},listen(w,g){return m.requestEvent(v,w,g)}}}requestPromise(v,m,w,g=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(R.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(v),u=(0,_.createCancelablePromise)(n=>l.call(m,w,n)),r=g.onCancellationRequested(()=>u.cancel()),a=(0,C.toDisposable)(()=>u.cancel());return this.activeRequests.add(a),u.finally(()=>{r.dispose(),this.activeRequests.delete(a),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(v,m,w){if(!this.disposeDelayer)return b.Event.None;this.disposeDelayer.cancel();let g;const l=new b.Emitter({onFirstListenerAdd:()=>{g=this.getCachedChannel(v).listen(m,w)(l.fire,l),this.activeRequests.add(g)},onLastListenerRemove:()=>{this.activeRequests.delete(g),g.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,I.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t))),(0,E.removeDangerousEnvVariables)(m.env),this.child=(0,T.fork)(this.modulePath,v,m);const w=new b.Emitter;b.Event.fromNodeEventEmitter(this.child,"message",t=>t)(t=>{if((0,i.isRemoteConsoleLog)(t)){(0,i.log)(t,`IPC Library: ${this.options.serverName}`);return}w.fire(k.VSBuffer.wrap(Buffer.from(t,"base64")))});const l=this.options.useQueue?(0,E.createQueuedSender)(this.child):this.child,u=t=>this.child&&this.child.connected&&l.send(t.buffer.toString("base64")),r=w.event,a={send:u,onMessage:r};this._client=new f.ChannelClient(a);const n=()=>this.disposeClient();process.once("exit",n),this.child.on("error",t=>console.warn('IPC "'+this.options.serverName+'" errored with '+t)),this.child.on("exit",(t,s)=>{process.removeListener("exit",n),this.activeRequests.forEach(o=>(0,C.dispose)(o)),this.activeRequests.clear(),t!==0&&s!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+t+" and signal "+s),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:t,signal:s})})}return this._client}getCachedChannel(v){let m=this.channels.get(v);return m||(m=this.client.getChannel(v),this.channels.set(v,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=h}),define(te[124],ne([12,13]),function(Q,e){return Q.create("vs/base/node/zip",e)}),define(te[125],ne([12,13]),function(Q,e){return Q.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[126],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/argv",e)}),define(te[127],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/argvHelper",e)}),define(te[128],ne([12,13]),function(Q,e){return Q.create("vs/platform/environment/node/shellEnv",e)}),define(te[129],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(te[130],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[131],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(te[132],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(te[133],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(te[134],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(te[135],ne([12,13]),function(Q,e){return Q.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[136],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/fileService",e)}),define(te[137],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/files",e)}),define(te[138],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/common/io",e)}),define(te[139],ne([12,13]),function(Q,e){return Q.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[140],ne([12,13]),function(Q,e){return Q.create("vs/platform/request/common/request",e)}),define(te[141],ne([12,13]),function(Q,e){return Q.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[142],ne([12,13]),function(Q,e){return Q.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(te[143],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(te[144],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(te[145],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/settingsSync",e)}),define(te[146],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(te[147],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSync",e)}),define(te[148],ne([12,13]),function(Q,e){return Q.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(te[149],ne([0,1,4]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentFilterProvider=e.Filters=e.TargetPopulation=e.ASSIGNMENT_REFETCH_INTERVAL=e.ASSIGNMENT_STORAGE_KEY=void 0,e.ASSIGNMENT_STORAGE_KEY="VSCode.ABExp.FeatureData",e.ASSIGNMENT_REFETCH_INTERVAL=0;var _;(function(i){i.Team="team",i.Internal="internal",i.Insiders="insider",i.Public="public"})(_=e.TargetPopulation||(e.TargetPopulation={}));var k;(function(i){i.Market="X-MSEdge-Market",i.CorpNet="X-FD-Corpnet",i.ApplicationVersion="X-VSCode-AppVersion",i.Build="X-VSCode-Build",i.ClientId="X-MSEdge-ClientId",i.ExtensionName="X-VSCode-ExtensionName",i.Language="X-VSCode-Language",i.TargetPopulation="X-VSCode-TargetPopulation"})(k=e.Filters||(e.Filters={}));class L{constructor(R,b,C,I){this.version=R,this.appName=b,this.machineId=C,this.targetPopulation=I}getFilterValue(R){switch(R){case k.ApplicationVersion:return this.version;case k.Build:return this.appName;case k.ClientId:return this.machineId;case k.Language:return T.language;case k.ExtensionName:return"vscode-core";case k.TargetPopulation:return this.targetPopulation;default:return""}}getFilters(){let R=new Map,b=Object.values(k);for(let C of b)R.set(C,this.getFilterValue(C));return R}}e.AssignmentFilterProvider=L}),define(te[75],ne([0,1,55,66,17,9,32,18,7]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class C{constructor(y,v,m){this._args=y,this.paths=v,this.productService=m}get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("",Q).fsPath)}get userHome(){return b.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return b.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.paths.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const y=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",y)}return this.args.logsPath}get userDataSyncLogResource(){return b.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(b.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return b.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return b.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=i.env.VSCODE_PORTABLE;return y?b.URI.file((0,L.join)(y,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.resolve)(y):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("",Q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const y=this.args["extensions-download-dir"];return y?(0,L.resolve)(y):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.resolve)(y);const v=i.env.VSCODE_EXTENSIONS;if(v)return v;const m=i.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(v=>/^[^:/?#]+?:\/\//.test(v)?b.URI.parse(v):b.URI.file((0,L.normalize)(v)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?b.URI.parse(y):b.URI.file((0,L.normalize)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return I(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!i.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return b.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([_.memoize],C.prototype,"appRoot",null),de([_.memoize],C.prototype,"userHome",null),de([_.memoize],C.prototype,"userDataPath",null),de([_.memoize],C.prototype,"appSettingsHome",null),de([_.memoize],C.prototype,"tmpDir",null),de([_.memoize],C.prototype,"cacheHome",null),de([_.memoize],C.prototype,"userRoamingDataHome",null),de([_.memoize],C.prototype,"settingsResource",null),de([_.memoize],C.prototype,"userDataSyncHome",null),de([_.memoize],C.prototype,"userDataSyncLogResource",null),de([_.memoize],C.prototype,"sync",null),de([_.memoize],C.prototype,"machineSettingsResource",null),de([_.memoize],C.prototype,"globalStorageHome",null),de([_.memoize],C.prototype,"workspaceStorageHome",null),de([_.memoize],C.prototype,"keybindingsResource",null),de([_.memoize],C.prototype,"keyboardLayoutResource",null),de([_.memoize],C.prototype,"argvResource",null),de([_.memoize],C.prototype,"snippetsHome",null),de([_.memoize],C.prototype,"isExtensionDevelopment",null),de([_.memoize],C.prototype,"untitledWorkspacesHome",null),de([_.memoize],C.prototype,"installSourcePath",null),de([_.memoize],C.prototype,"builtinExtensionsPath",null),de([_.memoize],C.prototype,"extensionsPath",null),de([_.memoize],C.prototype,"extensionDevelopmentLocationURI",null),de([_.memoize],C.prototype,"extensionDevelopmentKind",null),de([_.memoize],C.prototype,"extensionTestsLocationURI",null),de([_.memoize],C.prototype,"debugExtensionHost",null),de([_.memoize],C.prototype,"serviceMachineIdResource",null),de([_.memoize],C.prototype,"telemetryLogResource",null),de([_.memoize],C.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=C;function I(h,y){return S(h["inspect-extensions"],h["inspect-brk-extensions"],5870,y,h.debugId,h.extensionEnvironment)}e.parseExtensionHostPort=I;function E(h,y){return S(h["inspect-search"],h["inspect-brk-search"],5876,y,h.extensionEnvironment)}e.parseSearchPort=E;function f(h,y){return S(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,y,h.extensionEnvironment)}e.parsePtyHostPort=f;function S(h,y,v,m,w,g){const u=Number(y||h)||(m?null:v),r=u?Boolean(!!y):!1;let a;if(g)try{a=JSON.parse(g)}catch{}return{port:u,break:r,debugId:w,env:a}}}),define(te[150],ne([0,1,244,4,126]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,k.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},category:{type:"string",cat:"e",description:(0,k.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,k.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,k.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,k.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,k.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,k.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,k.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const i={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function R(h,y,v=i){const m={},w=[],g=[];for(let a in y){const n=y[a];n.alias&&(m[a]=n.alias),n.type==="string"||n.type==="string[]"?(w.push(a),n.deprecates&&w.push(n.deprecates)):n.type==="boolean"&&(g.push(a),n.deprecates&&g.push(n.deprecates))}const l=T(h,{string:w,boolean:g,alias:m}),u={},r=l;u._=l._.map(a=>String(a)).filter(a=>a.length>0),delete r._;for(let a in y){const n=y[a];n.alias&&delete r[n.alias];let t=r[a];n.deprecates&&r.hasOwnProperty(n.deprecates)&&(t||(t=r[n.deprecates],t&&v.onDeprecatedOption(n.deprecates,a)),delete r[n.deprecates]),typeof t!="undefined"&&(n.type==="string[]"?t&&!Array.isArray(t)&&(t=[t]):n.type==="string"&&Array.isArray(t)&&(t=t.pop(),v.onMultipleValues(a,t)),u[a]=t),delete r[a]}for(let a in r)v.onUnknownOption(a);return u}e.parseArgs=R;function b(h,y){let v="";return y.args&&(Array.isArray(y.args)?v=` <${y.args.join("> <")}>`:v=` <${y.args}>`),y.alias?`-${y.alias} --${h}${v}`:`--${h}${v}`}function C(h,y){let v=0,m=[];for(const u in h){const r=h[u],a=b(u,r);v=Math.max(v,a.length),m.push([a,r.description])}let w=v+2+1;if(y-w<25)return m.reduce((u,r)=>u.concat([`  ${r[0]}`,`      ${r[1]}`]),[]);let g=y-w-1,l=[];for(const u of m){let r=u[0],a=E(u[1],g),n=I(w-r.length-2);l.push("  "+r+n+a[0]);for(let t=1;t<a.length;t++)l.push(I(w)+a[t])}return l}e.formatOptions=C;function I(h){return" ".repeat(h)}function E(h,y){let v=[];for(;h.length;){let m=h.length<y?h.length:h.lastIndexOf(" ",y),w=h.slice(0,m).trim();h=h.slice(m),v.push(w)}return v}function f(h,y,v,m,w){const g=process.stdout.isTTY&&process.stdout.columns||80,l=w?.noInputFiles!==!0?`[${(0,k.localize)(33,null)}...]`:"",u=[`${h} ${v}`];u.push(""),u.push(`${(0,k.localize)(34,null)}: ${y} [${(0,k.localize)(35,null)}]${l}`),u.push(""),w?.noPipe!==!0&&(_.isWindows?u.push((0,k.localize)(36,null,y)):u.push((0,k.localize)(37,null,y)),u.push(""));const r={};for(const a in m){const n=m[a];if(n.description&&n.cat){let t=r[n.cat];t||(r[n.cat]=t={}),t[a]=n}}for(let a in r){const n=a;let t=r[n];t&&(u.push(L[n]),u.push(...C(t,g)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=f;function S(h,y){return`${h||(0,k.localize)(38,null)}
${y||(0,k.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=S}),function(){"use strict";function Q(e,T,_,k){function L(R){const b=i(R),C=[b];return e.isAbsolute(b)||C.unshift(k),e.resolve(...C)}function i(R){const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let C=process.env.VSCODE_APPDATA;if(C)return e.join(C,_);const I=R["user-data-dir"];if(I)return I;switch(process.platform){case"win32":if(C=process.env.APPDATA,!C){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");C=e.join(E,"AppData","Roaming")}break;case"darwin":C=e.join(T.homedir(),"Library","Application Support");break;case"linux":C=process.env.XDG_CONFIG_HOME||e.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(C,_)}return{getUserDataPath:L}}if(typeof define=="function")define(te[151],ne([0,152,33,17,18,32]),function(e,T,_,k,L,i){const R=L.dirname(k.FileAccess.asFileUri("",e)),b=e.__$__nodeRequire(L.joinPath(R,"package.json").fsPath);return Q(T,_,b.name,i.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),T=require("path"),_=require("os");module.exports=Q(T,_,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[153],ne([0,1,33,75,151]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends _.AbstractNativeEnvironmentService{constructor(R,b){super(R,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,k.getUserDataPath)(R)},b)}}e.NativeEnvironmentService=L}),define(te[154],ne([0,1,7]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const _=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,i=/([^@:.]+\.[^@:.]+)(:\d+)?$/,R=/^\s*url\s*=\s*(.+\S)\s*$/mg,b=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function C(v){const m=v.match(i);return m?m[1]:null}function I(v){if(v.indexOf("://")===-1){const m=v.match(_);return m?C(m[2]):null}try{const m=T.URI.parse(v);if(m.authority)return C(m.authority)}catch(m){}return null}function E(v,m){const w=new Set;let g;for(;g=R.exec(v);){const u=I(g[1]);u&&w.add(u)}const l=new Set(m);return Array.from(w).map(u=>l.has(u)?u:u.replace(b,"a"))}e.getDomainsOfRemotes=E;function f(v){const m=v.match(L);return m?m[2]:null}function S(v,m,w){return v&&m?(w&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${v}${m}`:`${v}/${m}`):null}function h(v,m){if(v.indexOf("://")===-1){const w=v.match(k);if(w)return S(w[2],w[3],m)}try{const w=T.URI.parse(v);if(w.authority)return S(f(w.authority),w.path,m)}catch(w){}return null}function y(v,m=!1){const w=[];let g;for(;g=R.exec(v);){const l=h(g[1],m);l&&w.push(l)}return w}e.getRemotes=y}),define(te[155],ne([0,1,28]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const _=/^%([\w\d.-]+)%$/i;function k(L,i){const R=b=>{if(typeof b!="string")return;const C=_.exec(b);if(!C)return;const I=i[C[1]]??b;return typeof I=="string"?I:typeof I.message=="string"?I.message:b};return(0,T.cloneAndChange)(L,R)}e.localizeManifest=k}),define(te[156],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class T{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,i,R,b){return this.channel.call("promptImportantExtensionsInstallNotification",[L,i,R,b])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=T;class _{constructor(L){this.service=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,R){switch(i){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(R[0],R[1],R[2],R[3])}throw new Error(`Call not found: ${i}`)}}e.ExtensionRecommendationNotificationServiceChannel=_}),define(te[76],ne([0,1,135]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const _=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function L(f){return f=f.trim(),f==="*"||_.test(f)}e.isValidVersionStr=L;function i(f){if(!L(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let S=f.match(_);return S?{hasCaret:S[1]==="^",hasGreaterEquals:S[1]===">=",majorBase:S[2]==="x"?0:parseInt(S[2],10),majorMustEqual:S[2]!=="x",minorBase:S[4]==="x"?0:parseInt(S[4],10),minorMustEqual:S[4]!=="x",patchBase:S[6]==="x"?0:parseInt(S[6],10),patchMustEqual:S[6]!=="x",preRelease:S[8]||null}:null}e.parseVersion=i;function R(f){if(!f)return null;let S=f.majorBase,h=f.majorMustEqual,y=f.minorBase,v=f.minorMustEqual,m=f.patchBase,w=f.patchMustEqual;f.hasCaret&&(S===0||(v=!1),w=!1);let g=0;if(f.preRelease){const l=k.exec(f.preRelease);if(l){const[,u,r,a]=l;g=Date.UTC(Number(u),Number(r)-1,Number(a))}}return{majorBase:S,majorMustEqual:h,minorBase:y,minorMustEqual:v,patchBase:m,patchMustEqual:w,isMinimum:f.hasGreaterEquals,notBefore:g}}e.normalizeVersion=R;function b(f,S,h){let y;typeof f=="string"?y=R(i(f)):y=f;let v;S instanceof Date?v=S.getTime():typeof S=="string"&&(v=new Date(S).getTime());let m;if(typeof h=="string"?m=R(i(h)):m=h,!y||!m)return!1;let w=y.majorBase,g=y.minorBase,l=y.patchBase,u=m.majorBase,r=m.minorBase,a=m.patchBase,n=m.notBefore,t=m.majorMustEqual,s=m.minorMustEqual,o=m.patchMustEqual;return m.isMinimum?w>u?!0:w<u?!1:g>r?!0:g<r||v&&v<n?!1:l>=a:(w===1&&u===0&&(!t||!s||!o)&&(u=1,r=0,a=0,t=!0,s=!1,o=!1),w<u?!1:w>u?!t:g<r?!1:g>r?!s:l<a?!1:l>a?!o:!(v&&v<n))}e.isValidVersion=b;function C(f,S,h,y){return h.isBuiltin||typeof h.main=="undefined"?!0:E(f,S,h.engines.vscode,y)}e.isValidExtensionVersion=C;function I(f,S,h){return f==="*"||E(S,h,f)}e.isEngineValid=I;function E(f,S,h,y=[]){let v=R(i(h));if(!v)return y.push(T.localize(0,null,h)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return y.push(T.localize(1,null,h)),!1}else if(!v.majorMustEqual)return y.push(T.localize(2,null,h)),!1;return b(f,S,v)?!0:(y.push(T.localize(3,null,f,h)),!1)}}),define(te[50],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class T{constructor(k,L=[],i=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=i}}e.SyncDescriptor=T}),define(te[77],ne([0,1,50]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const _=[];function k(i,R,b){R instanceof T.SyncDescriptor||(R=new T.SyncDescriptor(R,[],b)),_.push([i,R])}e.registerSingleton=k;function L(){return _}e.getSingletonServiceDescriptors=L}),define(te[157],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class T{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=T;class _{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(let i of this._nodes.values())i.outgoing.size===0&&L.push(i);return L}insertEdge(L,i){const R=this.lookupOrInsertNode(L),b=this.lookupOrInsertNode(i);R.outgoing.set(this._hashFn(i),b),b.incoming.set(this._hashFn(L),R)}removeNode(L){const i=this._hashFn(L);this._nodes.delete(i);for(let R of this._nodes.values())R.outgoing.delete(i),R.incoming.delete(i)}lookupOrInsertNode(L){const i=this._hashFn(L);let R=this._nodes.get(i);return R||(R=new T(L),this._nodes.set(i,R)),R}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){let L=[];for(let[i,R]of this._nodes)L.push(`${i}, (incoming)[${[...R.incoming.keys()].join(", ")}], (outgoing)[${[...R.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(let[L,i]of this._nodes){const R=new Set([L]),b=this._findCycle(i,R);if(b)return b}}_findCycle(L,i){for(let[R,b]of L.outgoing){if(i.has(R))return[...i,R].join(" -> ");i.add(R);const C=this._findCycle(b,i);if(C)return C;i.delete(R)}}}e.Graph=_}),define(te[6],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var T;(function(i){i.serviceIds=new Map,i.DI_TARGET="$di$target",i.DI_DEPENDENCIES="$di$dependencies";function R(b){return b[i.DI_DEPENDENCIES]||[]}i.getServiceDependencies=R})(T=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function _(i,R,b,C){R[T.DI_TARGET]===R?R[T.DI_DEPENDENCIES].push({id:i,index:b,optional:C}):(R[T.DI_DEPENDENCIES]=[{id:i,index:b,optional:C}],R[T.DI_TARGET]=R)}function k(i){if(T.serviceIds.has(i))return T.serviceIds.get(i);const R=function(b,C,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");_(R,b,I,!1)};return R.toString=()=>i,T.serviceIds.set(i,R),R}e.createDecorator=k;function L(i){return i}e.refineServiceDecorator=L}),define(te[158],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,T.createDecorator)("checksumService")}),define(te[21],ne([0,1,15,7,6]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(v){return v&&typeof v=="object"&&(!v.overrideIdentifier||typeof v.overrideIdentifier=="string")&&(!v.resource||v.resource instanceof _.URI)}e.isConfigurationOverrides=L;function i(v){return v&&typeof v=="object"&&(!v.overrideIdentifiers||T.isArray(v.overrideIdentifiers))&&!v.overrideIdentifier&&(!v.resource||v.resource instanceof _.URI)}e.isConfigurationUpdateOverrides=i;var R;(function(v){v[v.USER=1]="USER",v[v.USER_LOCAL=2]="USER_LOCAL",v[v.USER_REMOTE=3]="USER_REMOTE",v[v.WORKSPACE=4]="WORKSPACE",v[v.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",v[v.DEFAULT=6]="DEFAULT",v[v.MEMORY=7]="MEMORY"})(R=e.ConfigurationTarget||(e.ConfigurationTarget={}));function b(v){switch(v){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=b;function C(v,m){const w=Object.create(null);for(let g in v)I(w,g,v[g],m);return w}e.toValuesTree=C;function I(v,m,w,g){const l=m.split("."),u=l.pop();let r=v;for(let a=0;a<l.length;a++){let n=l[a],t=r[n];switch(typeof t){case"undefined":t=r[n]=Object.create(null);break;case"object":break;default:g(`Ignoring ${m} as ${l.slice(0,a+1).join(".")} is ${JSON.stringify(t)}`);return}r=t}if(typeof r=="object"&&r!==null)try{r[u]=w}catch(a){g(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${m} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=I;function E(v,m){const w=m.split(".");f(v,w)}e.removeFromValueTree=E;function f(v,m){const w=m.shift();if(m.length===0){delete v[w];return}if(Object.keys(v).indexOf(w)!==-1){const g=v[w];typeof g=="object"&&!Array.isArray(g)&&(f(g,m),Object.keys(g).length===0&&delete v[w])}}function S(v,m,w){function g(r,a){let n=r;for(const t of a){if(typeof n!="object"||n===null)return;n=n[t]}return n}const l=m.split("."),u=g(v,l);return typeof u=="undefined"?w:u}e.getConfigurationValue=S;function h(v,m,w){Object.keys(m).forEach(g=>{g!=="__proto__"&&(g in v?T.isObject(v[g])&&T.isObject(m[g])?h(v[g],m[g],w):w&&(v[g]=m[g]):v[g]=m[g])})}e.merge=h;function y(v,m,w){const g=v.inspect(m),l=v.inspect(w);return typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:g.defaultValue}e.getMigratedSettingValue=y}),define(te[159],ne([0,1,4,25,6]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let L=T.userAgent||"";const i=new Map;i.set("false",!1),i.set("true",!0),i.set("isMac",T.isMacintosh),i.set("isLinux",T.isLinux),i.set("isWindows",T.isWindows),i.set("isWeb",T.isWeb),i.set("isMacNative",T.isMacintosh&&!T.isWeb),i.set("isEdge",L.indexOf("Edg/")>=0),i.set("isFirefox",L.indexOf("Firefox")>=0),i.set("isChrome",L.indexOf("Chrome")>=0),i.set("isSafari",L.indexOf("Safari")>=0);const R=Object.prototype.hasOwnProperty;var b;(function($){$[$.False=0]="False",$[$.True=1]="True",$[$.Defined=2]="Defined",$[$.Not=3]="Not",$[$.Equals=4]="Equals",$[$.NotEquals=5]="NotEquals",$[$.And=6]="And",$[$.Regex=7]="Regex",$[$.NotRegex=8]="NotRegex",$[$.Or=9]="Or",$[$.In=10]="In",$[$.NotIn=11]="NotIn",$[$.Greater=12]="Greater",$[$.GreaterEquals=13]="GreaterEquals",$[$.Smaller=14]="Smaller",$[$.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return f.INSTANCE}static true(){return S.INSTANCE}static has(D){return h.create(D)}static equals(D,F){return y.create(D,F)}static notEquals(D,F){return w.create(D,F)}static regex(D,F){return t.create(D,F)}static in(D,F){return v.create(D,F)}static not(D){return g.create(D)}static and(...D){return c.create(D,null)}static or(...D){return d.create(D,null,!0)}static greater(D,F){return u.create(D,F)}static greaterEquals(D,F){return r.create(D,F)}static smaller(D,F){return a.create(D,F)}static smallerEquals(D,F){return n.create(D,F)}static deserialize(D,F=!1){if(!!D)return this._deserializeOrExpression(D,F)}static _deserializeOrExpression(D,F){let M=D.split("||");return d.create(M.map(U=>this._deserializeAndExpression(U,F)),null,!0)}static _deserializeAndExpression(D,F){let M=D.split("&&");return c.create(M.map(U=>this._deserializeOne(U,F)),null)}static _deserializeOne(D,F){if(D=D.trim(),D.indexOf("!=")>=0){let M=D.split("!=");return w.create(M[0].trim(),this._deserializeValue(M[1],F))}if(D.indexOf("==")>=0){let M=D.split("==");return y.create(M[0].trim(),this._deserializeValue(M[1],F))}if(D.indexOf("=~")>=0){let M=D.split("=~");return t.create(M[0].trim(),this._deserializeRegexValue(M[1],F))}if(D.indexOf(" in ")>=0){let M=D.split(" in ");return v.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(D)){const M=D.split(">=");return r.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(D)){const M=D.split(">");return u.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(D)){const M=D.split("<=");return n.create(M[0].trim(),M[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(D)){const M=D.split("<");return a.create(M[0].trim(),M[1].trim())}return/^\!\s*/.test(D)?g.create(D.substr(1).trim()):h.create(D)}static _deserializeValue(D,F){if(D=D.trim(),D==="true")return!0;if(D==="false")return!1;let M=/^'([^']*)'$/.exec(D);return M?M[1].trim():D}static _deserializeRegexValue(D,F){if((0,_.isFalsyOrWhitespace)(D)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let M=D.indexOf("/"),U=D.lastIndexOf("/");if(M===U||M<0){if(F)throw new Error(`bad regexp-value '${D}', missing /-enclosure`);return console.warn(`bad regexp-value '${D}', missing /-enclosure`),null}let G=D.slice(M+1,U),ee=D[U+1]==="i"?"i":"";try{return new RegExp(G,ee)}catch(V){if(F)throw new Error(`bad regexp-value '${D}', parse error: ${V}`);return console.warn(`bad regexp-value '${D}', parse error: ${V}`),null}}}e.ContextKeyExpr=C;function I($,D){const F=$?$.substituteConstants():void 0,M=D?D.substituteConstants():void 0;return!F&&!M?!0:!F||!M?!1:F.equals(M)}e.expressionsAreEqualWithConstantSubstitution=I;function E($,D){return $.cmp(D)}class f{constructor(){this.type=0}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!1}serialize(){return"false"}keys(){return[]}map(D){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class S{constructor(){this.type=1}cmp(D){return this.type-D.type}equals(D){return D.type===this.type}substituteConstants(){return this}evaluate(D){return!0}serialize(){return"true"}keys(){return[]}map(D){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class h{constructor(D,F){this.key=D,this.negated=F,this.type=2}static create(D,F=null){const M=i.get(D);return typeof M=="boolean"?M?S.INSTANCE:f.INSTANCE:new h(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=i.get(this.key);return typeof D=="boolean"?D?S.INSTANCE:f.INSTANCE:this}evaluate(D){return!!D.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(D){return D.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=h;class y{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=4}static create(D,F,M=null){if(typeof F=="boolean")return F?h.create(D,M):g.create(D,M);const U=i.get(D);return typeof U=="boolean"?F===(U?"true":"false")?S.INSTANCE:f.INSTANCE:new y(D,F,M)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=i.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?S.INSTANCE:f.INSTANCE}return this}evaluate(D){return D.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(D){return D.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=w.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=y;class v{constructor(D,F){this.key=D,this.valueKey=F,this.type=10,this.negated=null}static create(D,F){return new v(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.valueKey,D.key,D.valueKey)}equals(D){return D.type===this.type?this.key===D.key&&this.valueKey===D.valueKey:!1}substituteConstants(){return this}evaluate(D){const F=D.getValue(this.valueKey),M=D.getValue(this.key);return Array.isArray(F)?F.indexOf(M)>=0:typeof M=="string"&&typeof F=="object"&&F!==null?R.call(F,M):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(D){return D.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=m.create(this)),this.negated}}e.ContextKeyInExpr=v;class m{constructor(D){this._actual=D,this.type=11}static create(D){return new m(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new m(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotInExpr=m;class w{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=5}static create(D,F,M=null){if(typeof F=="boolean")return F?g.create(D,M):h.create(D,M);const U=i.get(D);return typeof U=="boolean"?F===(U?"true":"false")?f.INSTANCE:S.INSTANCE:new w(D,F,M)}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){const D=i.get(this.key);if(typeof D=="boolean"){const F=D?"true":"false";return this.value===F?f.INSTANCE:S.INSTANCE}return this}evaluate(D){return D.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(D){return D.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=y.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=w;class g{constructor(D,F){this.key=D,this.negated=F,this.type=3}static create(D,F=null){const M=i.get(D);return typeof M=="boolean"?M?f.INSTANCE:S.INSTANCE:new g(D,F)}cmp(D){return D.type!==this.type?this.type-D.type:P(this.key,D.key)}equals(D){return D.type===this.type?this.key===D.key:!1}substituteConstants(){const D=i.get(this.key);return typeof D=="boolean"?D?f.INSTANCE:S.INSTANCE:this}evaluate(D){return!D.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(D){return D.mapNot(this.key)}negate(){return this.negated||(this.negated=h.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function l($,D){if(typeof $=="string"){const F=parseFloat($);isNaN(F)||($=F)}return typeof $=="string"||typeof $=="number"?D($):f.INSTANCE}class u{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=12}static create(D,F,M=null){return l(F,U=>new u(D,U,M))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=n.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=u;class r{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=13}static create(D,F,M=null){return l(F,U=>new r(D,U,M))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(D){return D.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=r;class a{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=14}static create(D,F,M=null){return l(F,U=>new a(D,U,M))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class n{constructor(D,F,M){this.key=D,this.value=F,this.negated=M,this.type=15}static create(D,F,M=null){return l(F,U=>new n(D,U,M))}cmp(D){return D.type!==this.type?this.type-D.type:O(this.key,this.value,D.key,D.value)}equals(D){return D.type===this.type?this.key===D.key&&this.value===D.value:!1}substituteConstants(){return this}evaluate(D){return typeof this.value=="string"?!1:parseFloat(D.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(D){return D.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=n;class t{constructor(D,F){this.key=D,this.regexp=F,this.type=7,this.negated=null}static create(D,F){return new t(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.key<D.key)return-1;if(this.key>D.key)return 1;const F=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return F<M?-1:F>M?1:0}equals(D){if(D.type===this.type){const F=this.regexp?this.regexp.source:"",M=D.regexp?D.regexp.source:"";return this.key===D.key&&F===M}return!1}substituteConstants(){return this}evaluate(D){let F=D.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const D=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${D}`}keys(){return[this.key]}map(D){return D.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=s.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class s{constructor(D){this._actual=D,this.type=8}static create(D){return new s(D)}cmp(D){return D.type!==this.type?this.type-D.type:this._actual.cmp(D._actual)}equals(D){return D.type===this.type?this._actual.equals(D._actual):!1}substituteConstants(){return this}evaluate(D){return!this._actual.evaluate(D)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(D){return new s(this._actual.map(D))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;function o($){let D=null;for(let F=0,M=$.length;F<M;F++){const U=$[F].substituteConstants();if($[F]!==U&&D===null){D=[];for(let G=0;G<F;G++)D[G]=$[G]}D!==null&&(D[F]=U)}return D===null?$:D}class c{constructor(D,F){this.expr=D,this.negated=F,this.type=6}static create(D,F){return c._normalizeArr(D,F)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const U=E(this.expr[F],D.expr[F]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:c.create(D,this.negated)}evaluate(D){for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].evaluate(D))return!1;return!0}static _normalizeArr(D,F){const M=[];let U=!1;for(const G of D)if(!!G){if(G.type===1){U=!0;continue}if(G.type===0)return f.INSTANCE;if(G.type===6){M.push(...G.expr);continue}M.push(G)}if(M.length===0&&U)return S.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(E);for(let G=1;G<M.length;G++)M[G-1].equals(M[G])&&(M.splice(G,1),G--);if(M.length===1)return M[0];for(;M.length>1;){const G=M[M.length-1];if(G.type!==9)break;M.pop();const ee=M.pop(),V=M.length===0,j=d.create(G.expr.map(Z=>c.create([Z,ee],null)),null,V);j&&(M.push(j),M.sort(E))}return M.length===1?M[0]:new c(M,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" && ")}keys(){const D=[];for(let F of this.expr)D.push(...F.keys());return D}map(D){return new c(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){const D=[];for(let F of this.expr)D.push(F.negate());this.negated=d.create(D,this,!0)}return this.negated}}class d{constructor(D,F){this.expr=D,this.negated=F,this.type=9}static create(D,F,M){return d._normalizeArr(D,F,M)}cmp(D){if(D.type!==this.type)return this.type-D.type;if(this.expr.length<D.expr.length)return-1;if(this.expr.length>D.expr.length)return 1;for(let F=0,M=this.expr.length;F<M;F++){const U=E(this.expr[F],D.expr[F]);if(U!==0)return U}return 0}equals(D){if(D.type===this.type){if(this.expr.length!==D.expr.length)return!1;for(let F=0,M=this.expr.length;F<M;F++)if(!this.expr[F].equals(D.expr[F]))return!1;return!0}return!1}substituteConstants(){const D=o(this.expr);return D===this.expr?this:d.create(D,this.negated,!1)}evaluate(D){for(let F=0,M=this.expr.length;F<M;F++)if(this.expr[F].evaluate(D))return!0;return!1}static _normalizeArr(D,F,M){let U=[],G=!1;if(D){for(let ee=0,V=D.length;ee<V;ee++){const j=D[ee];if(!!j){if(j.type===0){G=!0;continue}if(j.type===1)return S.INSTANCE;if(j.type===9){U=U.concat(j.expr);continue}U.push(j)}}if(U.length===0&&G)return f.INSTANCE;U.sort(E)}if(U.length!==0){if(U.length===1)return U[0];for(let ee=1;ee<U.length;ee++)U[ee-1].equals(U[ee])&&(U.splice(ee,1),ee--);if(U.length===1)return U[0];if(M){for(let ee=0;ee<U.length;ee++)for(let V=ee+1;V<U.length;V++)A(U[ee],U[V])&&(U.splice(V,1),V--);if(U.length===1)return U[0]}return new d(U,F)}}serialize(){return this.expr.map(D=>D.serialize()).join(" || ")}keys(){const D=[];for(let F of this.expr)D.push(...F.keys());return D}map(D){return new d(this.expr.map(F=>F.map(D)),null)}negate(){if(!this.negated){let D=[];for(let F of this.expr)D.push(F.negate());for(;D.length>1;){const F=D.shift(),M=D.shift(),U=[];for(const ee of N(F))for(const V of N(M))U.push(c.create([ee,V],null));const G=D.length===0;D.unshift(d.create(U,null,G))}this.negated=D[0]}return this.negated}}class p extends h{constructor(D,F,M){super(D,null);this._defaultValue=F,typeof M=="object"?p._info.push({...M,key:D}):M!==!0&&p._info.push({key:D,description:M,type:F!=null?typeof F:void 0})}static all(){return p._info.values()}bindTo(D){return D.createKey(this.key,this._defaultValue)}getValue(D){return D.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(D){return y.create(this.key,D)}notEqualsTo(D){return w.create(this.key,D)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function P($,D){return $<D?-1:$>D?1:0}function O($,D,F,M){return $<F?-1:$>F?1:D<M?-1:D>M?1:0}function A($,D){if(D.type===6&&$.type!==9&&$.type!==6){for(const U of D.expr)if($.equals(U))return!0}const F=$.negate(),M=N(F).concat(N(D));M.sort(E);for(let U=0;U<M.length;U++){const ee=M[U].negate();for(let V=U+1;V<M.length;V++){const j=M[V];if(ee.equals(j))return!0}}return!1}e.implies=A;function N($){return $.type===9?$.expr:[$]}}),define(te[78],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,T.createDecorator)(e.ID);function _(k){return!!k.hostName&&!!k.errorMessage}e.isRemoteDiagnosticError=_}),define(te[79],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,T.createDecorator)("downloadService")}),define(te[11],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,T.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,T.refineServiceDecorator)(e.IEnvironmentService)}),define(te[29],ne([0,1,17,130,6]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var L;(function(g){g.WIN32_X64="win32-x64",g.WIN32_IA32="win32-ia32",g.WIN32_ARM64="win32-arm64",g.LINUX_X64="linux-x64",g.LINUX_ARM64="linux-arm64",g.LINUX_ARMHF="linux-armhf",g.ALPINE_X64="alpine-x64",g.ALPINE_ARM64="alpine-arm64",g.DARWIN_X64="darwin-x64",g.DARWIN_ARM64="darwin-arm64",g.WEB="web",g.UNIVERSAL="universal",g.UNKNOWN="unknown",g.UNDEFINED="undefined"})(L=e.TargetPlatform||(e.TargetPlatform={}));function i(g){switch(g){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=i;function R(g){switch(g){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function b(g,l){switch(g){case 3:return l==="x64"?"win32-x64":l==="ia32"?"win32-ia32":l==="arm64"?"win32-arm64":"unknown";case 2:return l==="x64"?"linux-x64":l==="arm64"?"linux-arm64":l==="arm"?"linux-armhf":"unknown";case"alpine":return l==="x64"?"alpine-x64":l==="arm64"?"alpine-arm64":"unknown";case 1:return l==="x64"?"darwin-x64":l==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=b;function C(g,l){return l==="web"&&!g.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function I(g,l,u){return C(l,u)?!1:g==="undefined"||g==="universal"?!0:g==="unknown"?!1:g===u?!0:E(u).includes(g)}e.isTargetPlatformCompatible=I;function E(g){switch(g){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=E;function f(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=f;var S;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=10]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(S=e.SortBy||(e.SortBy={}));var h;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(h=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Install="install",g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var v;(function(g){g[g.None=1]="None",g[g.Install=2]="Install",g[g.Update=3]="Update",g[g.Migrate=4]="Migrate"})(v=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,k.createDecorator)("extensionGalleryService");var m;(function(g){g.Unsupported="Unsupported",g.UnsupportedPreRelease="UnsupportedPreRelease",g.Malicious="Malicious",g.Incompatible="Incompatible",g.IncompatiblePreRelease="IncompatiblePreRelease",g.IncompatibleTargetPlatform="IncompatibleTargetPlatform",g.Invalid="Invalid",g.Download="Download",g.Extract="Extract",g.Delete="Delete",g.Rename="Rename",g.CorruptZip="CorruptZip",g.IncompleteZip="IncompleteZip",g.Internal="Internal"})(m=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(l,u){super(l);this.code=u,this.name=u}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,k.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,k.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,k.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",Q).toString(!0),e.ExtensionsLabel=(0,_.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,_.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,k.createDecorator)("IExtensionManagementCLIService")});var J=this&&this.__param||function(Q,e){return function(T,_){e(T,_,Q)}};define(te[160],ne([0,1,2,29]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;let k=class extends T.Disposable{constructor(i){super();i.removeDeprecatedExtensions(),i.migrateUnsupportedExtensions()}};k=de([J(0,_.IExtensionManagementService)],k),e.ExtensionsCleaner=k}),define(te[161],ne([0,1,3,2,28,7,109,29]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function b(y,v){return L.URI.revive(v?v.transformIncoming(y):y)}function C(y,v){return v?v.transformOutgoingURI(y):y}function I(y,v){v=v||i.DefaultURITransformer;const m=y.manifest;return{...(0,i.transformAndReviveIncomingURIs)({...y,manifest:void 0},v),manifest:m}}function E(y,v){return v?(0,k.cloneAndChange)(y,m=>m instanceof L.URI?v.transformOutgoingURI(m):void 0):y}class f{constructor(v,m){this.service=v,this.getUriTransformer=m,this.onInstallExtension=T.Event.buffer(v.onInstallExtension,!0),this.onDidInstallExtensions=T.Event.buffer(v.onDidInstallExtensions,!0),this.onUninstallExtension=T.Event.buffer(v.onUninstallExtension,!0),this.onDidUninstallExtension=T.Event.buffer(v.onDidUninstallExtension,!0)}listen(v,m){const w=this.getUriTransformer(v);switch(m){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return T.Event.map(this.onDidInstallExtensions,g=>g.map(l=>({...l,local:l.local?E(l.local,w):l.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(v,m,w){const g=this.getUriTransformer(v);switch(m){case"zip":return this.service.zip(I(w[0],g)).then(l=>C(l,g));case"unzip":return this.service.unzip(b(w[0],g));case"install":return this.service.install(b(w[0],g),w[1]);case"getManifest":return this.service.getManifest(b(w[0],g));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(I(w[0],g),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(I(w[0],g));case"getInstalled":return this.service.getInstalled(w[0]).then(l=>l.map(u=>E(u,g)));case"updateMetadata":return this.service.updateMetadata(I(w[0],g),w[1]).then(l=>E(l,g));case"updateExtensionScope":return this.service.updateExtensionScope(I(w[0],g),w[1]).then(l=>E(l,g));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class S extends _.Disposable{constructor(v){super();this.channel=v,this._onInstallExtension=this._register(new T.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new T.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new T.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new T.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(m=>this._onInstallExtension.fire({identifier:m.identifier,source:this.isUriComponents(m.source)?L.URI.revive(m.source):m.source}))),this._register(this.channel.listen("onDidInstallExtensions")(m=>this._onDidInstallExtensions.fire(m.map(w=>({...w,local:w.local?I(w.local,null):w.local,source:this.isUriComponents(w.source)?L.URI.revive(w.source):w.source}))))),this._register(this.channel.listen("onUninstallExtension")(m=>this._onUninstallExtension.fire(m))),this._register(this.channel.listen("onDidUninstallExtension")(m=>this._onDidUninstallExtension.fire(m)))}isUriComponents(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(v){const m=await this.getTargetPlatform();return v.allTargetPlatforms.some(w=>(0,R.isTargetPlatformCompatible)(w,v.allTargetPlatforms,m))}zip(v){return Promise.resolve(this.channel.call("zip",[v]).then(m=>L.URI.revive(m)))}unzip(v){return Promise.resolve(this.channel.call("unzip",[v]))}install(v,m){return Promise.resolve(this.channel.call("install",[v,m])).then(w=>I(w,null))}getManifest(v){return Promise.resolve(this.channel.call("getManifest",[v]))}installFromGallery(v,m){return Promise.resolve(this.channel.call("installFromGallery",[v,m])).then(w=>I(w,null))}uninstall(v,m){return Promise.resolve(this.channel.call("uninstall",[v,m]))}reinstallFromGallery(v){return Promise.resolve(this.channel.call("reinstallFromGallery",[v]))}getInstalled(v=null){return Promise.resolve(this.channel.call("getInstalled",[v])).then(m=>m.map(w=>I(w,null)))}updateMetadata(v,m){return Promise.resolve(this.channel.call("updateMetadata",[v,m])).then(w=>I(w,null))}updateExtensionScope(v,m){return Promise.resolve(this.channel.call("updateExtensionScope",[v,m])).then(w=>I(w,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=S;class h{constructor(v){this.service=v}listen(v,m){throw new Error("Invalid listen")}call(v,m,w){switch(m){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=h}),define(te[80],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var _;(function(i){i[i.FILE=1]="FILE",i[i.WORKSPACE=2]="WORKSPACE",i[i.EXE=3]="EXE"})(_=e.RecommendationSource||(e.RecommendationSource={}));function k(i){switch(i){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var L;(function(i){i.Ignored="ignored",i.Cancelled="cancelled",i.TooMany="toomany",i.IncompatibleWindow="incompatibleWindow",i.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,T.createDecorator)("IExtensionRecommendationNotificationService")}),define(te[14],ne([0,1,39,9,25,15,7,137,6]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,b.createDecorator)("fileService");function C(M){return M.create===!0}e.isFileOpenForWriteOptions=C;var I;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(I=e.FileType||(e.FileType={}));var E;(function(M){M[M.Readonly=1]="Readonly"})(E=e.FilePermission||(e.FilePermission={}));var f;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(f=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function S(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=S;function h(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=h;function y(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=y;function v(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=v;var m;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(m=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(U,G){super(U);this.code=G}}e.FileSystemProviderError=w;function g(M,U){const G=new w(M.toString(),U);return u(G,U),G}e.createFileSystemProviderError=g;function l(M){return M||g((0,R.localize)(0,null),m.Unknown)}e.ensureFileSystemProviderError=l;function u(M,U){return M.name=U?`${U} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=u;function r(M){if(!M)return m.Unknown;if(M instanceof w)return M.code;const U=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!U)return m.Unknown;switch(U[1]){case m.FileExists:return m.FileExists;case m.FileIsADirectory:return m.FileIsADirectory;case m.FileNotADirectory:return m.FileNotADirectory;case m.FileNotFound:return m.FileNotFound;case m.FileExceedsMemoryLimit:return m.FileExceedsMemoryLimit;case m.FileTooLarge:return m.FileTooLarge;case m.FileWriteLocked:return m.FileWriteLocked;case m.NoPermissions:return m.NoPermissions;case m.Unavailable:return m.Unavailable}return m.Unknown}e.toFileSystemProviderErrorCode=r;function a(M){if(M instanceof d)return M.fileOperationResult;switch(r(M)){case m.FileNotFound:return 1;case m.FileIsADirectory:return 0;case m.FileNotADirectory:return 10;case m.FileWriteLocked:return 5;case m.NoPermissions:return 6;case m.FileExists:return 4;case m.FileExceedsMemoryLimit:return 9;case m.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=a;var n;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(U,G,ee){this.resource=U,this.operation=G,this.target=ee}isOperation(U){return this.operation===U}}e.FileOperationEvent=t;var s;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(s=e.FileChangeType||(e.FileChangeType={}));class o{constructor(U,G){this.added=void 0,this.updated=void 0,this.deleted=void 0;const ee=new Map;for(const V of U){const j=ee.get(V.type);j?j.push([V.resource,V]):ee.set(V.type,[[V.resource,V]])}for(const[V,j]of ee)switch(V){case 1:this.added=T.TernarySearchTree.forUris(()=>G),this.added.fill(j);break;case 0:this.updated=T.TernarySearchTree.forUris(()=>G),this.updated.fill(j);break;case 2:this.deleted=T.TernarySearchTree.forUris(()=>G),this.deleted.fill(j);break}}contains(U,...G){return this.doContains(U,{includeChildren:!1},...G)}affects(U,...G){return this.doContains(U,{includeChildren:!0},...G)}doContains(U,G,...ee){if(!U)return!1;const V=ee.length>0;return!!((!V||ee.includes(1))&&(this.added?.get(U)||G.includeChildren&&this.added?.findSuperstr(U))||(!V||ee.includes(0))&&(this.updated?.get(U)||G.includeChildren&&this.updated?.findSuperstr(U))||(!V||ee.includes(2))&&(this.deleted?.findSubstr(U)||G.includeChildren&&this.deleted?.findSuperstr(U)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=o;function c(M,U,G){return!M||!U||M===U||U.length>M.length?!1:(U.charAt(U.length-1)!==_.sep&&(U+=_.sep),G?(0,k.startsWithIgnoreCase)(M,U):M.indexOf(U)===0)}e.isParent=c;class d extends Error{constructor(U,G,ee){super(U);this.fileOperationResult=G,this.options=ee}}e.FileOperationError=d;class p extends d{constructor(U,G,ee){super(U,2,ee);this.stat=G}}e.NotModifiedSinceFileOperationError=p;var P;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(P=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function A(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=A;async function N(M,U){if(!U.hasProvider(i.URI.from({scheme:M.scheme})))return new Promise(G=>{const ee=U.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===M.scheme&&V.added&&(ee.dispose(),G())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(U){return(0,L.isNumber)(U)||(U=0),U<$.KB?(0,R.localize)(1,null,U.toFixed(0)):U<$.MB?(0,R.localize)(2,null,(U/$.KB).toFixed(2)):U<$.GB?(0,R.localize)(3,null,(U/$.MB).toFixed(2)):U<$.TB?(0,R.localize)(4,null,(U/$.GB).toFixed(2)):(0,R.localize)(5,null,(U/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var D;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(D=e.Arch||(e.Arch={}));function F(M){return{maxFileSize:M===0?300*$.MB:16*$.GB,maxHeapSize:M===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=F}),define(te[162],ne([0,1,81,48,14]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(R){this.fileService=R}async checksum(R){const b=(await this.fileService.readFileStream(R)).value;return new Promise((C,I)=>{const E=(0,T.createHash)("md5");(0,_.listenStream)(b,{onData:f=>E.update(f.buffer),onError:f=>I(f),onEnd:()=>C(E.digest("base64").replace(/=+$/,""))})})}};L=de([J(0,k.IFileService)],L),e.ChecksumService=L}),define(te[163],ne([0,1,245,127,150,14]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function i(f,S){const h={onUnknownOption:v=>{console.warn((0,_.localize)(0,null,v))},onMultipleValues:(v,m)=>{console.warn((0,_.localize)(1,null,v,m))},onDeprecatedOption:(v,m)=>{console.warn((0,_.localize)(2,null,v,m))}},y=(0,k.parseArgs)(f,k.OPTIONS,S?h:void 0);return y.goto&&y._.forEach(v=>T(/^(\w:)?[^:]+(:\d*){0,2}$/.test(v),(0,_.localize)(3,null))),y["max-memory"]&&T(parseInt(y["max-memory"])>=L.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${L.MIN_MAX_MEMORY_SIZE_MB} MB.`),y}function R(f){const S=f.findIndex(h=>!/^-/.test(h));if(S>-1)return[...f.slice(0,S),...f.slice(S+1)]}function b(f){let[,...S]=f;process.env.VSCODE_DEV&&(S=R(S)||[]);const h=!E(process.env);return i(S,h)}e.parseMainProcessArgv=b;function C(f){const[,,...S]=f;return i(S,!0)}e.parseCLIProcessArgv=C;function I(f,...S){const h=f.indexOf("--");return h===-1?f.push(...S):f.splice(h,0,...S),f}e.addArg=I;function E(f){return f.VSCODE_CLI==="1"}e.isLaunchedFromCli=E}),define(te[164],ne([0,1,44,9,128,27,38,10,4,30,123,163,5]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const S=1e4;let h;async function y(m,w,g){return w["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.isLaunchedFromCli)(g)&&!w["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.isLaunchedFromCli)(g)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),h||(h=f.Promises.withAsyncBody(async(l,u)=>{const r=new L.CancellationTokenSource,a=setTimeout(()=>{r.dispose(!0),u(new Error((0,k.localize)(0,null)))},S);try{l(await v(m,r.token))}catch(n){!(0,R.isPromiseCanceledError)(n)&&!r.token.isCancellationRequested?u(new Error((0,k.localize)(1,null,(0,i.toErrorMessage)(n)))):l({})}finally{clearTimeout(a),r.dispose()}})),h)}e.getResolvedShellEnv=y;async function v(m,w){const g=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",g);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",l);const u=(0,C.generateUuid)().replace(/-/g,"").substr(0,12),r=new RegExp(u+"(.*)"+u),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",a);const n=await(0,I.getSystemShell)(b.OS,a);return m.trace("getUnixShellEnvironment#shell",n),new Promise((t,s)=>{if(w.isCancellationRequested)return s((0,R.canceled)());const o=(0,_.basename)(n);let c,d;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${p} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,d=["-Login","-Command"]):(c=`'${process.execPath}' ${p} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,o==="tcsh"?d=["-ic"]:d=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),c);const P=(0,T.spawn)(n,[...d,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});w.onCancellationRequested(()=>(P.kill(),s((0,R.canceled)()))),P.on("error",N=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,i.toErrorMessage)(N)),s(N)});const O=[];P.stdout.on("data",N=>O.push(N));const A=[];P.stderr.on("data",N=>A.push(N)),P.on("close",(N,$)=>{const D=Buffer.concat(O).toString("utf8");m.trace("getUnixShellEnvironment#raw",D);const F=Buffer.concat(A).toString("utf8");if(F.trim()&&m.trace("getUnixShellEnvironment#stderr",F),N||$)return s(new Error((0,k.localize)(2,null,N,$)));const M=r.exec(D),U=M?M[1]:"{}";try{const G=JSON.parse(U);g?G.ELECTRON_RUN_AS_NODE=g:delete G.ELECTRON_RUN_AS_NODE,l?G.ELECTRON_NO_ATTACH_CONSOLE=l:delete G.ELECTRON_NO_ATTACH_CONSOLE,delete G.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",G),t(G)}catch(G){m.error("getUnixShellEnvironment#errorCaught",(0,i.toErrorMessage)(G)),s(G)}})})}}),define(te[82],ne([0,1,19,10,138,14]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function i(I,E,f,S,h,y){let v;try{await R(I,E,f,S,h,y)}catch(m){v=m}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&f.error(v),f.end()}}e.readFileIntoStream=i;async function R(I,E,f,S,h,y){b(y);const v=await I.open(E,{create:!1});try{b(y);let m=0,w=0,g=h&&typeof h.length=="number"?h.length:void 0,l=T.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),u=h&&typeof h.position=="number"?h.position:0,r=0;do w=await I.read(v,u,l.buffer,r,l.byteLength-r),u+=w,r+=w,m+=w,typeof g=="number"&&(g-=w),r===l.byteLength&&(await f.write(S(l)),l=T.VSBuffer.alloc(Math.min(h.bufferSize,typeof g=="number"?g:h.bufferSize)),r=0);while(w>0&&(typeof g!="number"||g>0)&&b(y)&&C(m,h));if(r>0){let a=r;typeof g=="number"&&(a=Math.min(r,g)),f.write(S(l.slice(0,a)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await I.close(v)}}function b(I){if(I.isCancellationRequested)throw(0,_.canceled)();return!0}function C(I,E){if(E?.limits){if(typeof E.limits.memory=="number"&&I>E.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof E.limits.size=="number"&&I>E.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(te[57],ne([0,1,2,4,7,14]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class i extends T.Disposable{constructor(E,f,S){super();this.onFileChanges=E,this.onLogMessage=f,this.verboseLogging=S,this.watcherDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const E=new T.DisposableStore;this.watcherDisposables.value=E,this.watcher=this.createWatcher(E),this.watcher.setVerboseLogging(this.verboseLogging),E.add(this.watcher.onDidChangeFile(f=>this.onFileChanges(f))),E.add(this.watcher.onDidLogMessage(f=>this.onLogMessage(f))),E.add(this.watcher.onDidError(f=>this.onError(f)))}onError(E){this.restartCounter<i.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${E}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${E}`)}restart(E){this.restartCounter++,this.init(),this.watch(E)}async watch(E){this.requests=E,await this.watcher?.watch(E)}async setVerboseLogging(E){this.verboseLogging=E,await this.watcher?.setVerboseLogging(E)}error(E){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${E}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=i,i.MAX_RESTARTS=5;function R(I){return I.map(E=>({type:E.type,resource:k.URI.file(E.path)}))}e.toFileChanges=R;function b(I){const E=new C;for(const f of I)E.processEvent(f);return E.coalesce()}e.coalesceEvents=b;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(E){return _.isLinux?E.path:E.path.toLowerCase()}processEvent(E){const f=this.mapPathToChange.get(this.toKey(E));let S=!1;if(f){const h=f.type,y=E.type;f.path!==E.path&&E.type===2?S=!0:h===1&&y===2?(this.mapPathToChange.delete(this.toKey(E)),this.coalesced.delete(f)):h===2&&y===1?f.type=0:h===1&&y===0||(f.type=y)}else S=!0;S&&(this.coalesced.add(E),this.mapPathToChange.set(this.toKey(E),E))}coalesce(){const E=[],f=[];return Array.from(this.coalesced).filter(S=>S.type!==2?(E.push(S),!1):!0).sort((S,h)=>S.path.length-h.path.length).filter(S=>f.some(h=>(0,L.isParent)(S.path,h,!_.isLinux))?!1:(f.push(S.path),!0)).concat(E)}}}),define(te[165],ne([0,1,5,2,9,113,20,116,57]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class C extends _.Disposable{constructor(E,f,S,h){super();this.path=E,this.onDidFilesChange=f,this.onLogMessage=S,this.verboseLogging=h,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(R.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(E){this.verboseLogging=E}async startWatching(){try{const{stat:E,symbolicLink:f}=await i.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let S=this.path;if(f)try{S=await(0,L.realpath)(S)}catch(h){if(this.onError(h),f.dangling)return}E.isDirectory()?this._register((0,R.watchFolder)(S,(h,y)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:(0,k.join)(this.path,(0,k.basename)(y))})},h=>this.onError(h))):this._register((0,R.watchFile)(S,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(E){E.code!=="ENOENT"&&this.onError(E)}}onFileChange(E){this.fileChangesBuffer.push(E),this.verboseLogging&&this.onVerbose(`${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.path}`),this.fileChangesDelayer.trigger(async()=>{const f=this.fileChangesBuffer;this.fileChangesBuffer=[];const S=(0,b.coalesceEvents)(f);if(this.verboseLogging)for(const h of S)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);S.length>0&&this.onDidFilesChange(S)})}onError(E){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${E}`})}onVerbose(E){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${E}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=C}),define(te[166],ne([0,1,17,36,56,57]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class i extends L.AbstractRecursiveWatcherClient{constructor(b,C,I){super(b,C,I);this.init()}createWatcher(b){const C=b.add(new k.Client(T.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(C.onDidProcessExit(({code:I,signal:E})=>this.onError(`terminated by itself with code ${I}, signal: ${E}`))),_.ProxyChannel.toService((0,_.getNextTickChannel)(C.getChannel("watcher")))}}e.ParcelWatcherClient=i}),define(te[83],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class T{constructor(...k){this._entries=new Map;for(let[L,i]of k)this.set(L,i)}set(k,L){const i=this._entries.get(k);return this._entries.set(k,L),i}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=T}),define(te[167],ne([0,1,5,10,50,157,6,83]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const b=!1;class C extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class I{constructor(h=new R.ServiceCollection,y=!1,v){this._activeInstantiations=new Set,this._services=h,this._strict=y,this._parent=v,this._services.set(i.IInstantiationService,this)}createChild(h){return new I(h,this._strict,this)}invokeFunction(h,...y){let v=f.traceInvocation(h),m=!1;try{return h({get:g=>{if(m)throw(0,_.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(g,v);if(!l)throw new Error(`[invokeFunction] unknown service '${g}'`);return l}},...y)}finally{m=!0,v.stop()}}createInstance(h,...y){let v,m;return h instanceof k.SyncDescriptor?(v=f.traceCreation(h.ctor),m=this._createInstance(h.ctor,h.staticArguments.concat(y),v)):(v=f.traceCreation(h),m=this._createInstance(h,y,v)),v.stop(),m}_createInstance(h,y=[],v){let m=i._util.getServiceDependencies(h).sort((l,u)=>l.index-u.index),w=[];for(const l of m){let u=this._getOrCreateServiceInstance(l.id,v);if(!u&&this._strict&&!l.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${l.id}.`);w.push(u)}let g=m.length>0?m[0].index:y.length;if(y.length!==g){console.warn(`[createInstance] First service dependency of ${h.name} at position ${g+1} conflicts with ${y.length} static arguments`);let l=g-y.length;l>0?y=y.concat(new Array(l)):y=y.slice(0,g)}return new h(...[...y,...w])}_setServiceInstance(h,y){if(this._services.get(h)instanceof k.SyncDescriptor)this._services.set(h,y);else if(this._parent)this._parent._setServiceInstance(h,y);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let y=this._services.get(h);return!y&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):y}_getOrCreateServiceInstance(h,y){let v=this._getServiceInstanceOrDescriptor(h);return v instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,v,y.branch(h,!0)):(y.branch(h,!1),v)}_safeCreateAndCacheServiceInstance(h,y,v){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,y,v)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,y,v){const m=new L.Graph(l=>l.id.toString());let w=0;const g=[{id:h,desc:y,_trace:v}];for(;g.length;){const l=g.pop();if(m.lookupOrInsertNode(l),w++>1e3)throw new C(m);for(let u of i._util.getServiceDependencies(l.desc.ctor)){let r=this._getServiceInstanceOrDescriptor(u.id);if(!r&&!u.optional&&console.warn(`[createInstance] ${h} depends on ${u.id} which is NOT registered.`),r instanceof k.SyncDescriptor){const a={id:u.id,desc:r,_trace:l._trace.branch(u.id,!0)};m.insertEdge(l,a),g.push(a)}}}for(;;){const l=m.roots();if(l.length===0){if(!m.isEmpty())throw new C(m);break}for(const{data:u}of l){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const a=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,a)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,y,v=[],m,w){if(this._services.get(h)instanceof k.SyncDescriptor)return this._createServiceInstance(y,v,m,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,y,v,m,w);throw new Error(`illegalState - creating UNKNOWN service instance ${y.name}`)}_createServiceInstance(h,y=[],v,m){if(v){const w=new T.IdleValue(()=>this._createInstance(h,y,m));return new Proxy(Object.create(null),{get(g,l){if(l in g)return g[l];let u=w.value,r=u[l];return typeof r!="function"||(r=r.bind(u),g[l]=r),r},set(g,l,u){return w.value[l]=u,!0}})}else return this._createInstance(h,y,m)}}e.InstantiationService=I;var E;(function(S){S[S.Creation=0]="Creation",S[S.Invocation=1]="Invocation",S[S.Branch=2]="Branch"})(E||(E={}));class f{constructor(h,y){this.type=h,this.name=y,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return b?new f(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):f._None}static traceCreation(h){return b?new f(0,h.name):f._None}branch(h,y){let v=new f(2,h.toString());return this._dep.push([h,y,v]),v}stop(){let h=Date.now()-this._start;f._totals+=h;let y=!1;function v(w,g){let l=[],u=new Array(w+1).join("	");for(const[r,a,n]of g._dep)if(a&&n){y=!0,l.push(`${u}CREATES -> ${r}`);let t=v(w+1,n);t&&l.push(t)}else l.push(`${u}uses -> ${r}`);return l.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${f._totals.toFixed(2)}ms)`];(h>2||y)&&console.log(m.join(`
`))}}f._None=new class extends f{constructor(){super(-1,null)}stop(){}branch(){return this}},f._totals=0}),define(te[168],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class T{constructor(k,L){this.server=k,this.router=L}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,L){this.server.registerChannel(k,L)}}e.MessagePortMainProcessService=T}),define(te[169],ne([0,1,36,50,77,6]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class i{constructor(S,h,y){const v=y.getChannel(S);return R(h)?new h.channelClientCtor(v):T.ProxyChannel.toService(v,h?.proxyOptions)}}function R(f){return!!f?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let b=class extends i{constructor(S,h,y){super(S,h,y)}};b=de([J(2,e.IMainProcessService)],b);function C(f,S,h){(0,k.registerSingleton)(f,new _.SyncDescriptor(b,[S,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=C,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let I=class extends i{constructor(S,h,y){super(S,h,y)}};I=de([J(2,e.ISharedProcessService)],I);function E(f,S,h){(0,k.registerSingleton)(f,new _.SyncDescriptor(I,[S,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=E}),define(te[58],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,T.createDecorator)("localizationsService");function _(k){if(typeof k.languageId!="string"||!Array.isArray(k.translations)||k.translations.length===0)return!1;for(const L of k.translations)if(typeof L.id!="string"||typeof L.path!="string")return!1;return!(k.languageName&&typeof k.languageName!="string"||k.localizedLanguageName&&typeof k.localizedLanguageName!="string")}e.isValidLocalization=_}),define(te[170],ne([0,1,2,58]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends T.Disposable{constructor(i){super();this.localizationsService=i,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=de([J(0,_.ILocalizationsService)],k),e.LocalizationsUpdater=k}),define(te[8],ne([0,1,38,3,2,4,6]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,i.createDecorator)("logService"),e.ILoggerService=(0,i.createDecorator)("loggerService");function R(){return new Date().toISOString()}var b;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(b=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=b.Info;function C(a,n,t){switch(n){case b.Trace:a.trace(t);break;case b.Debug:a.debug(t);break;case b.Info:a.info(t);break;case b.Warning:a.warn(t);break;case b.Error:a.error(t);break;case b.Critical:a.critical(t);break;default:throw new Error("Invalid log level")}}e.log=C;function I(a){let n="";for(let t=0;t<a.length;t++){let s=a[t];if(typeof s=="object")try{s=JSON.stringify(s)}catch(o){}n+=(t>0?" ":"")+s}return n}e.format=I;class E extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new _.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=E;class f extends E{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...t){this.checkLogLevel(b.Trace)&&this.log(b.Trace,I([n,...t]))}debug(n,...t){this.checkLogLevel(b.Debug)&&this.log(b.Debug,I([n,...t]))}info(n,...t){this.checkLogLevel(b.Info)&&this.log(b.Info,I([n,...t]))}warn(n,...t){this.checkLogLevel(b.Warning)&&this.log(b.Warning,I([n,...t]))}error(n,...t){if(this.checkLogLevel(b.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(b.Error,I(s))}else this.log(b.Error,I([n,...t]))}critical(n,...t){this.checkLogLevel(b.Critical)&&this.log(b.Critical,I([n,...t]))}flush(){}}e.AbstractMessageLogger=f;class S extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...t){this.getLevel()<=b.Trace&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}debug(n,...t){this.getLevel()<=b.Debug&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}info(n,...t){this.getLevel()<=b.Info&&(this.useColors?console.log(`[90m[main ${R()}][0m`,n,...t):console.log(`[main ${R()}]`,n,...t))}warn(n,...t){this.getLevel()<=b.Warning&&(this.useColors?console.warn(`[93m[main ${R()}][0m`,n,...t):console.warn(`[main ${R()}]`,n,...t))}error(n,...t){this.getLevel()<=b.Error&&(this.useColors?console.error(`[91m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}critical(n,...t){this.getLevel()<=b.Critical&&(this.useColors?console.error(`[90m[main ${R()}][0m`,n,...t):console.error(`[main ${R()}]`,n,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class h extends E{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...t){this.getLevel()<=b.Trace&&console.log("%cTRACE","color: #888",n,...t)}debug(n,...t){this.getLevel()<=b.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...t)}info(n,...t){this.getLevel()<=b.Info&&console.log("%c INFO","color: #33f",n,...t)}warn(n,...t){this.getLevel()<=b.Warning&&console.log("%c WARN","color: #993",n,...t)}error(n,...t){this.getLevel()<=b.Error&&console.log("%c  ERR","color: #f33",n,...t)}critical(n,...t){this.getLevel()<=b.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...t)}dispose(){}flush(){}}e.ConsoleLogger=h;class y extends E{constructor(n,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(t)}trace(n,...t){this.getLevel()<=b.Trace&&this.adapter.log(b.Trace,[this.extractMessage(n),...t])}debug(n,...t){this.getLevel()<=b.Debug&&this.adapter.log(b.Debug,[this.extractMessage(n),...t])}info(n,...t){this.getLevel()<=b.Info&&this.adapter.log(b.Info,[this.extractMessage(n),...t])}warn(n,...t){this.getLevel()<=b.Warning&&this.adapter.log(b.Warning,[this.extractMessage(n),...t])}error(n,...t){this.getLevel()<=b.Error&&this.adapter.log(b.Error,[this.extractMessage(n),...t])}critical(n,...t){this.getLevel()<=b.Critical&&this.adapter.log(b.Critical,[this.extractMessage(n),...t])}extractMessage(n){return typeof n=="string"?n:(0,T.toErrorMessage)(n,this.getLevel()<=b.Trace)}dispose(){}flush(){}}e.AdapterLogger=y;class v extends E{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const t of this.logServices)t.setLevel(n);super.setLevel(n)}trace(n,...t){for(const s of this.logServices)s.trace(n,...t)}debug(n,...t){for(const s of this.logServices)s.debug(n,...t)}info(n,...t){for(const s of this.logServices)s.info(n,...t)}warn(n,...t){for(const s of this.logServices)s.warn(n,...t)}error(n,...t){for(const s of this.logServices)s.error(n,...t)}critical(n,...t){for(const s of this.logServices)s.critical(n,...t)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=v;class m extends k.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...t){this.logger.trace(n,...t)}debug(n,...t){this.logger.debug(n,...t)}info(n,...t){this.logger.info(n,...t)}warn(n,...t){this.logger.warn(n,...t)}error(n,...t){this.logger.error(n,...t)}critical(n,...t){this.logger.critical(n,...t)}flush(){this.logger.flush()}}e.LogService=m;class w extends k.Disposable{constructor(n,t){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(t(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,t){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,t?.always?b.Trace:this.logLevel,t),this.loggers.set(n.toString(),s),t?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class g{constructor(){this.onDidChangeLogLevel=new _.Emitter().event}setLevel(n){}getLevel(){return b.Info}trace(n,...t){}debug(n,...t){}info(n,...t){}warn(n,...t){}error(n,...t){}critical(n,...t){}dispose(){}flush(){}}e.NullLogService=g;function l(a){if(a.verbose)return b.Trace;if(typeof a.logLevel=="string"){const n=u(a.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function u(a){switch(a){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Critical;case"off":return b.Off}}e.parseLogLevel=u;function r(a){switch(a){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Critical:return"critical";case b.Off:return"off"}}e.LogLevelToString=r}),define(te[171],ne([0,1,5,10,2,9,20,11,8]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let C=class extends k.Disposable{constructor(E,f){super();this.environmentService=E,this.logService=f,this._register(new T.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const E=(0,L.basename)(this.environmentService.logsPath),f=(0,L.dirname)(this.environmentService.logsPath),y=(await i.Promises.readdir(f)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==E),v=y.slice(0,Math.max(0,y.length-9));v.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${v.join(", ")}'`),await Promise.all(v.map(m=>i.Promises.rm((0,L.join)(f,m)))))}catch(E){(0,_.onUnexpectedError)(E)}}};C=de([J(0,R.IEnvironmentService),J(1,b.ILogService)],C),e.LogsDataCleaner=C}),define(te[172],ne([0,1,5,10,2,9,20,11,8]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let C=class gt extends k.Disposable{constructor(E,f,S){super();this.backupWorkspacesPath=E,this.environmentService=f,this.logService=S,this._register(new T.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const E=await i.Promises.readFile(this.backupWorkspacesPath,"utf8"),S=JSON.parse(E).emptyWorkspaceInfos.map(y=>y.backupFolder),h=await i.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async y=>{y.length===gt.NON_EMPTY_WORKSPACE_ID_LENGTH||y===gt.EXTENSION_DEV_EMPTY_WINDOW_ID||S.indexOf(y)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${y}.`),await i.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,y)))}))}catch(E){(0,_.onUnexpectedError)(E)}}};C.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,C.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",C=de([J(1,R.INativeEnvironmentService),J(2,b.ILogService)],C),e.StorageDataCleaner=C}),define(te[84],ne([0,1,5,19,31,53,11,14,6,8]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var I;(function(f){f.ERROR_INVALID_FILE="ERROR_INVALID_FILE",f.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(I=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,b.createDecorator)(e.UserConfigurationFileServiceId);let E=class{constructor(S,h,y){this.environmentService=S,this.fileService=h,this.logService=y,this.queue=new T.Queue}async updateSettings(S,h){return this.queue.queue(()=>this.doWrite(S,h))}async doWrite(S,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),S);const{value:y,mtime:v,etag:m}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let w=y.toString();const g=[];if((0,k.parse)(w,g,{allowTrailingComma:!0,allowEmptyContent:!0}),g.length)throw new Error("ERROR_INVALID_FILE");const l=this.getEdits(S,w,h)[0];if(l){w=w.substring(0,l.offset)+l.content+w.substring(l.offset+l.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,_.VSBuffer.fromString(w),{etag:m,mtime:v})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(S,h){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,S,h)})}getEdits({value:S,path:h},y,v){return h.length?(0,L.setProperty)(y,h,S,v):[{content:JSON.stringify(S,null,v.insertSpaces&&v.tabSize?" ".repeat(v.tabSize):"	"),length:y.length,offset:0}]}};E=de([J(0,i.IEnvironmentService),J(1,R.IFileService),J(2,C.ILogService)],E),e.UserConfigurationFileService=E}),define(te[173],ne([0,1,44,5,38,3,2,17,9,20,11,8]),function(Q,e,T,_,k,L,i,R,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let f=class extends i.Disposable{constructor(h,y){super();this.environmentService=h,this.logService=y,this.processesLimiter=new _.Limiter(5)}async postUninstall(h){const y=this.parseScript(h,"uninstall");return y&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(y.script,"uninstall",y.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),v=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${v}`)))),C.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,v=>this.logService.error("Error while removing extension storage path",v))}parseScript(h,y){const v=`vscode:${y}`;if(h.location.scheme===R.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[v]=="string"){const m=h.manifest.scripts[v].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${v} should be a node script`),null):{script:(0,b.join)(h.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(h,y,v,m,w){return new Promise((g,l)=>{const u=this.start(h,y,v,w);let r;const a=n=>{r&&(clearTimeout(r),r=null),n?l(n):g(void 0)};u.on("error",n=>{a((0,k.toErrorMessage)(n)||"Unknown")}),u.on("exit",(n,t)=>{a(n?`post-${y} process exited with code ${n}`:void 0)}),m&&(r=setTimeout(()=>{r=null,u.kill(),l("timed out")},5e3))})}start(h,y,v,m){const w={silent:!0,execArgv:void 0},g=(0,T.fork)(h,[`--type=extension-post-${y}`,...v],w);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const l=L.Event.fromNodeEventEmitter(g.stdout,"data"),u=L.Event.fromNodeEventEmitter(g.stderr,"data");l(n=>this.logService.info(m.identifier.id,m.manifest.version,`post-${y}`,n)),u(n=>this.logService.error(m.identifier.id,m.manifest.version,`post-${y}`,n));const r=L.Event.any(L.Event.map(l,n=>({data:`%c${n}`,format:[""]})),L.Event.map(u,n=>({data:`%c${n}`,format:["color: red"]})));return L.Event.debounce(r,(n,t)=>n?{data:n.data+t.data,format:[...n.format,...t.format]}:{data:t.data,format:t.format},100)(n=>{console.group(m.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),g}getExtensionStoragePath(h){return(0,b.join)(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};f=de([J(0,I.IEnvironmentService),J(1,E.ILogService)],f),e.ExtensionsLifecycle=f}),define(te[174],ne([0,1,16,5,10,3,2,9,57,8]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class I extends i.Disposable{constructor(f){super();this.logService=f,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new _.ThrottledDelayer(0))}watch(f,S){return S.recursive?this.watchRecursive(f,S):this.watchNonRecursive(f)}watchRecursive(f,S){const h={path:this.toFilePath(f),excludes:S.excludes},y=(0,T.insert)(this.recursiveFoldersToWatch,h);return this.refreshRecursiveWatchers(),(0,i.toDisposable)(()=>{y(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(f=>(0,k.onUnexpectedError)(f))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(f=>this._onDidChangeFile.fire((0,b.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===C.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(f,S){return f.watch(S)}watchNonRecursive(f){const S=this.createNonRecursiveWatcher(this.toFilePath(f),y=>this._onDidChangeFile.fire((0,b.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===C.LogLevel.Trace),h=this.logService.onDidChangeLogLevel(()=>{S.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,i.combinedDisposable)(S,h)}onWatcherLogMessage(f){f.type==="error"&&this._onDidWatchError.fire(f.message),this.logService[f.type](f.message)}toFilePath(f){return(0,R.normalize)(f.fsPath)}}e.AbstractDiskFileSystemProvider=I}),define(te[175],ne([0,1,16,5,19,27,3,52,2,39,17,176,18,48,136,14,82,8]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let w=class Ke extends b.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new i.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new i.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new i.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new i.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new i.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new i.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new i.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new _.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new y.FileChangesEvent(u,!0)))),this.watchedResources=C.TernarySearchTree.forUris(u=>{const r=this.getProvider(u.scheme);return r?!this.isPathCaseSensitive(r):!1}),this.writeQueue=this._register(new _.ResourceQueue)}registerProvider(l,u){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,E.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:u});const r=new b.DisposableStore;return r.add(u.onDidChangeFile(a=>this.onDidChangeFile(a,this.isPathCaseSensitive(u)))),r.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:l}))),typeof u.onDidWatchError=="function"&&r.add(u.onDidWatchError(a=>this._onDidWatchError.fire(new Error(a)))),(0,b.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:u}),this.provider.delete(l),(0,b.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){u.push(r)}}),!this.provider.has(l)&&await _.Promises.settled(u)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,u){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&u)}listCapabilities(){return R.Iterable.map(this.provider,([l,u])=>({scheme:l,capabilities:u.capabilities}))}async withProvider(l){if(!(0,f.isAbsolutePath)(l))throw new y.FileOperationError((0,h.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const u=this.provider.get(l.scheme);if(!u){const r=new Error;throw r.name="ENOPRO",r.message=(0,h.localize)(1,null,l.toString()),r}return u}async withReadProvider(l){const u=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u)||(0,y.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const u=await this.withProvider(l);if((0,y.hasOpenReadWriteCloseCapability)(u)||(0,y.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,u){try{return await this.doResolveFile(l,u)}catch(r){throw(0,y.toFileSystemProviderErrorCode)(r)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,h.localize)(2,null,this.resourceForError(l)),1):(0,y.ensureFileSystemProviderError)(r)}}async doResolveFile(l,u){const r=await this.withProvider(l),a=this.isPathCaseSensitive(r),n=u?.resolveTo,t=u?.resolveSingleChildDescendants,s=u?.resolveMetadata,o=await r.stat(l);let c;return this.toFileStat(r,l,o,void 0,!!s,(d,p)=>(c||(c=C.TernarySearchTree.forUris(()=>!a),c.set(l,!0),n&&c.fill(!0,n)),c.get(d.resource)||c.findSuperstr(d.resource.with({query:null,fragment:null}))?!0:d.isDirectory&&t?p===1:!1))}async toFileStat(l,u,r,a,n,t){const{providerExtUri:s}=this.getExtUri(l),o={resource:u,name:s.basename(u),isFile:(r.type&y.FileType.File)!=0,isDirectory:(r.type&y.FileType.Directory)!=0,isSymbolicLink:(r.type&y.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&y.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,y.etag)({mtime:r.mtime,size:r.size})};if(o.isDirectory&&t(o,a)){try{const c=await l.readdir(u),d=await _.Promises.settled(c.map(async([p,P])=>{try{const O=s.joinPath(u,p),A=n?await l.stat(O):{type:P};return await this.toFileStat(l,O,A,c.length,n,t)}catch(O){return this.logService.trace(O),null}}));o.children=(0,T.coalesce)(d)}catch(c){this.logService.trace(c),o.children=[]}return o}return o}async resolveAll(l){return _.Promises.settled(l.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async exists(l){const u=await this.withProvider(l);try{return!!await u.stat(l)}catch(r){return!1}}async canCreateFile(l,u){try{await this.doValidateCreateFile(l,u)}catch(r){return r}return!0}async doValidateCreateFile(l,u){if(!u?.overwrite&&await this.exists(l))throw new y.FileOperationError((0,h.localize)(3,null,this.resourceForError(l)),3,u)}async createFile(l,u=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const a=await this.writeFile(l,u);return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,a)),a}async writeFile(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(a);try{await this.validateWriteFile(a,l,r)||await this.mkdirp(a,n.dirname(l));let s;if((0,y.hasReadWriteCapability)(a)&&!(u instanceof k.VSBuffer))if((0,S.isReadableStream)(u)){const o=await(0,S.peekStream)(u,3);o.ended?s=k.VSBuffer.concat(o.buffer):s=o}else s=(0,S.peekReadable)(u,o=>k.VSBuffer.concat(o),3);else s=u;!(0,y.hasOpenReadWriteCloseCapability)(a)||(0,y.hasReadWriteCapability)(a)&&s instanceof k.VSBuffer?await this.doWriteUnbuffered(a,l,r,s):await this.doWriteBuffered(a,l,r,s instanceof k.VSBuffer?(0,k.bufferToReadable)(s):s)}catch(t){throw new y.FileOperationError((0,h.localize)(4,null,this.resourceForError(l),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,u,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,h.localize)(5,null,this.resourceForError(u)));let n;try{n=await l.stat(u)}catch(t){return}if((n.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,h.localize)(6,null,this.resourceForError(u)),0,r);if(this.throwIfFileIsReadonly(u,n),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==y.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&r.mtime<n.mtime&&r.etag!==(0,y.etag)({mtime:r.mtime,size:n.size}))throw new y.FileOperationError((0,h.localize)(7,null),3,r);return n}async readFile(l,u){const r=await this.withReadProvider(l);return u?.atomic?this.doReadFileAtomic(r,l,u):this.doReadFile(r,l,u)}async doReadFileAtomic(l,u,r){return new Promise((a,n)=>{this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{try{const t=await this.doReadFile(l,u,r);a(t)}catch(t){n(t)}})})}async doReadFile(l,u,r){const a=await this.doReadFileStream(l,u,{...r,preferUnbuffered:!0});return{...a,value:await(0,k.streamToBuffer)(a.value)}}async readFileStream(l,u){const r=await this.withReadProvider(l);return this.doReadFileStream(r,l,u)}async doReadFileStream(l,u,r){const a=new L.CancellationTokenSource,n=this.validateReadFile(u,r).then(s=>s,s=>{throw a.cancel(),s});let t;try{return typeof r?.etag=="string"&&r.etag!==y.ETAG_DISABLED&&await n,!((0,y.hasOpenReadWriteCloseCapability)(l)||(0,y.hasFileReadStreamCapability)(l))||(0,y.hasReadWriteCapability)(l)&&r?.preferUnbuffered?t=this.readFileUnbuffered(l,u,r):(0,y.hasFileReadStreamCapability)(l)?t=this.readFileStreamed(l,u,a.token,r):t=this.readFileBuffered(l,u,a.token,r),{...await n,value:t}}catch(s){t&&await(0,S.consumeStream)(t);const o=(0,h.localize)(8,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(s).toString());throw s instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(o,s.stat,r):new y.FileOperationError(o,(0,y.toFileOperationResult)(s),r)}}readFileStreamed(l,u,r,a=Object.create(null)){const n=l.readFileStream(u,a,r);return(0,S.transform)(n,{data:t=>t instanceof k.VSBuffer?t:k.VSBuffer.wrap(t),error:t=>new y.FileOperationError((0,h.localize)(9,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},t=>k.VSBuffer.concat(t))}readFileBuffered(l,u,r,a=Object.create(null)){const n=(0,k.newWriteableBufferStream)();return(0,v.readFileIntoStream)(l,u,n,t=>t,{...a,bufferSize:this.BUFFER_SIZE,errorTransformer:t=>new y.FileOperationError((0,h.localize)(10,null,this.resourceForError(u),(0,y.ensureFileSystemProviderError)(t).toString()),(0,y.toFileOperationResult)(t),a)},r),n}readFileUnbuffered(l,u,r){const a=(0,S.newWriteableStream)(n=>k.VSBuffer.concat(n));return(async()=>{try{let n=await l.readFile(u);typeof r?.position=="number"&&(n=n.slice(r.position)),typeof r?.length=="number"&&(n=n.slice(0,r.length)),this.validateReadFileLimits(u,n.byteLength,r),a.end(k.VSBuffer.wrap(n))}catch(n){a.error(n),a.end()}})(),a}async validateReadFile(l,u){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new y.FileOperationError((0,h.localize)(11,null,this.resourceForError(l)),0,u);if(typeof u?.etag=="string"&&u.etag!==y.ETAG_DISABLED&&u.etag===r.etag)throw new y.NotModifiedSinceFileOperationError((0,h.localize)(12,null),r,u);return this.validateReadFileLimits(l,r.size,u),r}validateReadFileLimits(l,u,r){if(r?.limits){let a;if(typeof r.limits.memory=="number"&&u>r.limits.memory&&(a=9),typeof r.limits.size=="number"&&u>r.limits.size&&(a=7),typeof a=="number")throw new y.FileOperationError((0,h.localize)(13,null,this.resourceForError(l)),a)}}async canMove(l,u,r){return this.doCanMoveCopy(l,u,"move",r)}async canCopy(l,u,r){return this.doCanMoveCopy(l,u,"copy",r)}async doCanMoveCopy(l,u,r,a){if(l.toString()!==u.toString())try{const n=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(n,l,t,u,r,a)}catch(n){return n}return!0}async move(l,u,r){const a=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,n,u,"move",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,t==="move"?2:3,s)),s}async copy(l,u,r){const a=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),t=await this.doMoveCopy(a,l,n,u,"copy",!!r),s=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,t==="copy"?3:2,s)),s}async doMoveCopy(l,u,r,a,n,t){if(u.toString()===a.toString())return n;const{exists:s,isSameResourceWithDifferentPathCase:o}=await this.doValidateMoveCopy(l,u,r,a,n,t);if(s&&!o&&t&&await this.del(a,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(a)),n==="copy"){if(l===r&&(0,y.hasFileFolderCopyCapability)(l))await l.copy(u,a,{overwrite:t});else{const c=await this.resolve(u);c.isDirectory?await this.doCopyFolder(l,c,r,a):await this.doCopyFile(l,u,r,a)}return n}else return l===r?(await l.rename(u,a,{overwrite:t}),n):(await this.doMoveCopy(l,u,r,a,"copy",t),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(l,u,r,a){if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,u,r,a);if((0,y.hasOpenReadWriteCloseCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,u,r,a);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,u,r,a);if((0,y.hasReadWriteCapability)(l)&&(0,y.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,u,r,a)}async doCopyFolder(l,u,r,a){await r.mkdir(a),Array.isArray(u.children)&&await _.Promises.settled(u.children.map(async n=>{const t=this.getExtUri(r).providerExtUri.joinPath(a,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),r,t):this.doCopyFile(l,n.resource,r,t)}))}async doValidateMoveCopy(l,u,r,a,n,t){let s=!1;if(l===r){const{providerExtUri:c,isPathCaseSensitive:d}=this.getExtUri(l);if(d||(s=c.isEqual(u,a)),s&&n==="copy")throw new Error((0,h.localize)(14,null,this.resourceForError(u),this.resourceForError(a)));if(!s&&c.isEqualOrParent(a,u))throw new Error((0,h.localize)(15,null,this.resourceForError(u),this.resourceForError(a)))}const o=await this.exists(a);if(o&&!s){if(!t)throw new y.FileOperationError((0,h.localize)(16,null,this.resourceForError(u),this.resourceForError(a)),4);if(l===r){const{providerExtUri:c}=this.getExtUri(l);if(c.isEqualOrParent(u,a))throw new Error((0,h.localize)(17,null,this.resourceForError(u),this.resourceForError(a)))}}return{exists:o,isSameResourceWithDifferentPathCase:s}}getExtUri(l){const u=this.isPathCaseSensitive(l);return{providerExtUri:u?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(u,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(l,0,r)),r}async mkdirp(l,u){const r=[],{providerExtUri:a}=this.getExtUri(l);for(;!a.isEqual(u,a.dirname(u));)try{if(((await l.stat(u)).type&y.FileType.Directory)==0)throw new Error((0,h.localize)(18,null,this.resourceForError(u)));break}catch(n){if((0,y.toFileSystemProviderErrorCode)(n)!==y.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(a.basename(u)),u=a.dirname(u)}for(let n=r.length-1;n>=0;n--){u=a.joinPath(u,r[n]);try{await l.mkdir(u)}catch(t){if((0,y.toFileSystemProviderErrorCode)(t)!==y.FileSystemProviderErrorCode.FileExists)throw t}}}async canDelete(l,u){try{await this.doValidateDelete(l,u)}catch(r){return r}return!0}async doValidateDelete(l,u){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!u?.useTrash&&!(r.capabilities&4096))throw new Error((0,h.localize)(19,null,this.resourceForError(l)));let n;try{n=await r.stat(l)}catch(s){}if(n)this.throwIfFileIsReadonly(l,n);else throw new y.FileOperationError((0,h.localize)(20,null,this.resourceForError(l)),1);if(!!!u?.recursive){const s=await this.resolve(l);if(s.isDirectory&&Array.isArray(s.children)&&s.children.length>0)throw new Error((0,h.localize)(21,null,this.resourceForError(l)))}return r}async del(l,u){const r=await this.doValidateDelete(l,u),a=!!u?.useTrash,n=!!u?.recursive;await r.delete(l,{recursive:n,useTrash:a}),this._onDidRunOperation.fire(new y.FileOperationEvent(l,1))}onDidChangeFile(l,u){this._onDidChangeFilesRaw.fire({changes:l});let r,a;{for(const n of l)this.watchedResources.has(n.resource)?(r||(r=[]),r.push(n)):(a||(a=[]),a.push(n));r&&this._onDidFilesChange.fire(new y.FileChangesEvent(r,!u))}if(a){const n=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(a)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${a.length}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${a[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,u={recursive:!1,excludes:[]}){const r=new b.DisposableStore;let a=!1,n=()=>{a=!0};return r.add((0,b.toDisposable)(()=>n())),this.doWatch(l,u).then(t=>{a?(0,b.dispose)(t):n=()=>(0,b.dispose)(t)},t=>this.logService.error(t)),u.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),r.add((0,b.toDisposable)(()=>{const t=this.watchedResources.get(l);typeof t=="number"&&(t<=1?this.watchedResources.delete(l):this.watchedResources.set(l,t-1))}))),r}async doWatch(l,u){const r=await this.withProvider(l),a=this.toWatchKey(r,l,u);let n=this.activeWatchers.get(a);return n||(n={count:0,disposable:r.watch(l,u)},this.activeWatchers.set(a,n)),n.count+=1,(0,b.toDisposable)(()=>{n&&(n.count--,n.count===0&&((0,b.dispose)(n.disposable),this.activeWatchers.delete(a)))})}toWatchKey(l,u,r){const{providerExtUri:a}=this.getExtUri(l);return[a.getComparisonKey(u),String(r.recursive),r.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,b.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(async()=>{const n=await l.open(u,{create:!0,unlock:r?.unlock??!1});try{(0,S.isReadableStream)(a)||(0,S.isReadableBufferedStream)(a)?await this.doWriteStreamBufferedQueued(l,n,a):await this.doWriteReadableBufferedQueued(l,n,a)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await l.close(n)}})}async doWriteStreamBufferedQueued(l,u,r){let a=0,n;if((0,S.isReadableBufferedStream)(r)){if(r.buffer.length>0){const t=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,u,t,t.byteLength,a,0),a+=t.byteLength}if(r.ended)return;n=r.stream}else n=r;return new Promise((t,s)=>{(0,S.listenStream)(n,{onData:async o=>{n.pause();try{await this.doWriteBuffer(l,u,o,o.byteLength,a,0)}catch(c){return s(c)}a+=o.byteLength,setTimeout(()=>n.resume())},onError:o=>s(o),onEnd:()=>t()})})}async doWriteReadableBufferedQueued(l,u,r){let a=0,n;for(;(n=r.read())!==null;)await this.doWriteBuffer(l,u,n,n.byteLength,a,0),a+=n.byteLength}async doWriteBuffer(l,u,r,a,n,t){let s=0;for(;s<a;)s+=await l.write(u,n+s,r.buffer,t+s,a-s)}async doWriteUnbuffered(l,u,r,a){return this.writeQueue.queueFor(u,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,u,r,a))}async doWriteUnbufferedQueued(l,u,r,a){let n;a instanceof k.VSBuffer?n=a:(0,S.isReadableStream)(a)?n=await(0,k.streamToBuffer)(a):(0,S.isReadableBufferedStream)(a)?n=await(0,k.bufferedStreamToBuffer)(a):n=(0,k.readableToBuffer)(a),await l.writeFile(u,n.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,u,r,a))}async doPipeBufferedQueued(l,u,r,a){let n,t;try{n=await l.open(u,{create:!1}),t=await r.open(a,{create:!0,unlock:!1});const s=k.VSBuffer.alloc(this.BUFFER_SIZE);let o=0,c=0,d=0;do d=await l.read(n,o,s.buffer,c,s.byteLength-c),await this.doWriteBuffer(r,t,s,d,o,c),o+=d,c+=d,c===s.byteLength&&(c=0);while(d>0)}catch(s){throw(0,y.ensureFileSystemProviderError)(s)}finally{await _.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof t=="number"?r.close(t):Promise.resolve()])}}async doPipeUnbuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,u,r,a))}async doPipeUnbufferedQueued(l,u,r,a){return r.writeFile(a,await l.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,u,r,a){return this.writeQueue.queueFor(a,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,u,r,a))}async doPipeUnbufferedToBufferedQueued(l,u,r,a){const n=await r.open(a,{create:!0,unlock:!1});try{const t=await l.readFile(u);await this.doWriteBuffer(r,n,k.VSBuffer.wrap(t),t.byteLength,0,0)}catch(t){throw(0,y.ensureFileSystemProviderError)(t)}finally{await r.close(n)}}async doPipeBufferedToUnbuffered(l,u,r,a){const n=await(0,k.streamToBuffer)(this.readFileBuffered(l,u,L.CancellationToken.None));await this.doWriteUnbuffered(r,a,void 0,n)}throwIfFileSystemIsReadonly(l,u){if(l.capabilities&2048)throw new y.FileOperationError((0,h.localize)(22,null,this.resourceForError(u)),6);return l}throwIfFileIsReadonly(l,u){if((u.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,h.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===I.Schemas.file?l.fsPath:l.toString(!0)}};w.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},w=de([J(0,m.ILogService)],w),e.FileService=w}),define(te[177],ne([0,1,49,246,5,19,3,40,9,4,18,48,20,139,14,82,165,166,174,38]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,_.gracefulify)(T)}catch(u){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(u)}`)}})();class l extends w.AbstractDiskFileSystemProvider{constructor(r,a){super(r);this.options=a,this.onDidChangeCapabilities=i.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,C.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:n}=await f.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,n),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await f.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),n=[];return await Promise.all(a.map(async t=>{try{let s;t.isSymbolicLink()?s=(await this.stat((0,I.joinPath)(r,t.name))).type:s=this.toType(t),n.push([t.name,s])}catch(s){this.logService.trace(s)}})),n}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let n;return a?.dangling?n=h.FileType.Unknown:r.isFile()?n=h.FileType.File:r.isDirectory()?n=h.FileType.Directory:n=h.FileType.Unknown,a&&(n|=h.FileType.SymbolicLink),n}async readFile(r){try{const a=this.toFilePath(r);return await f.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,n){const t=(0,E.newWriteableStream)(s=>L.VSBuffer.concat(s.map(o=>L.VSBuffer.wrap(o))).buffer);return(0,y.readFileIntoStream)(this,r,t,s=>s.buffer,{...a,bufferSize:256*1024},n),t}async writeFile(r,a,n){let t;try{const s=this.toFilePath(r);if(!n.create||!n.overwrite){if(await f.Promises.exists(s)){if(!n.overwrite)throw(0,h.createFileSystemProviderError)((0,S.localize)(0,null),h.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,h.createFileSystemProviderError)((0,S.localize)(1,null),h.FileSystemProviderErrorCode.FileNotFound)}t=await this.open(r,{create:!0,unlock:n.unlock}),await this.write(t,0,a,0,a.byteLength)}catch(s){throw await this.toFileSystemProviderWriteError(r,s)}finally{typeof t=="number"&&await this.close(t)}}async open(r,a){try{const n=this.toFilePath(r);if((0,h.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:o}=await f.SymlinkSupport.stat(n);o.mode&128||await f.Promises.chmod(n,o.mode|128)}catch(o){this.logService.trace(o)}let t;if((0,h.isFileOpenForWriteOptions)(a)){if(C.isWindows)try{await f.Promises.truncate(n,0),t="r+"}catch(o){o.code!=="ENOENT"&&this.logService.trace(o)}t||(t="w")}else t="r";const s=await f.Promises.open(n,t);return this.mapHandleToPos.set(s,0),(0,h.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(s,r),s}catch(n){throw(0,h.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,n):this.toFileSystemProviderError(n)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await f.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await f.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,n,t,s){const o=this.normalizePos(r,a);let c=null;try{const d=await f.Promises.read(r,n,t,s,o);return typeof d=="number"?c=d:c=d.bytesRead,c}catch(d){throw this.toFileSystemProviderError(d)}finally{this.updatePos(r,o,c)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,n){const t=this.mapHandleToPos.get(r);typeof t=="number"&&(typeof a=="number"||(typeof n=="number"?this.mapHandleToPos.set(r,t+n):this.mapHandleToPos.delete(r)))}async write(r,a,n,t,s){return(0,k.retry)(()=>this.doWrite(r,a,n,t,s),100,3)}async doWrite(r,a,n,t,s){const o=this.normalizePos(r,a);let c=null;try{const d=await f.Promises.write(r,n,t,s,o);return typeof d=="number"?c=d:c=d.bytesWritten,c}catch(d){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),d)}finally{this.updatePos(r,o,c)}}async mkdir(r){try{await f.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const n=this.toFilePath(r);a.recursive?await f.Promises.rm(n,f.RimRafMode.MOVE):await f.Promises.unlink(n)}catch(n){throw this.toFileSystemProviderError(n)}}async rename(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"move",n.overwrite),await f.Promises.move(t,s)}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,S.localize)(2,null,(0,b.basename)(t),(0,b.basename)((0,b.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async copy(r,a,n){const t=this.toFilePath(r),s=this.toFilePath(a);if(t!==s)try{await this.validateTargetDeleted(r,a,"copy",n.overwrite),await f.Promises.copy(t,s,{preserveSymlinks:!0})}catch(o){throw(o.code==="EINVAL"||o.code==="EBUSY"||o.code==="ENAMETOOLONG")&&(o=new Error((0,S.localize)(3,null,(0,b.basename)(t),(0,b.basename)((0,b.dirname)(s)),o.toString()))),this.toFileSystemProviderError(o)}}async validateTargetDeleted(r,a,n,t){const s=this.toFilePath(r),o=this.toFilePath(a);let c=!1;if(!!(this.capabilities&1024)||(c=(0,R.isEqual)(s,o,!0)),c&&n==="copy")throw(0,h.createFileSystemProviderError)((0,S.localize)(4,null),h.FileSystemProviderErrorCode.FileExists);if(!c&&await f.Promises.exists(o)){if(!t)throw(0,h.createFileSystemProviderError)((0,S.localize)(5,null),h.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(r,a,n){return new m.ParcelWatcherClient(t=>r(t),t=>a(t),n)}doWatch(r,a){const n=this.options?.watcher?.usePolling;if(n===!0)for(const t of a)t.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const t of a)n.includes(t.path)&&(t.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(r,a)}createNonRecursiveWatcher(r,a,n,t){return new v.NodeJSFileWatcher(r,s=>a(s),s=>n(s),t)}toFileSystemProviderError(r){if(r instanceof h.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=h.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=h.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=h.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=h.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=h.FileSystemProviderErrorCode.NoPermissions;break;default:a=h.FileSystemProviderErrorCode.Unknown}return(0,h.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let n=this.toFileSystemProviderError(a);if(r&&n.code===h.FileSystemProviderErrorCode.NoPermissions)try{const{stat:t}=await f.SymlinkSupport.stat(this.toFilePath(r));t.mode&128||(n=(0,h.createFileSystemProviderError)(a,h.FileSystemProviderErrorCode.FileWriteLocked))}catch(t){this.logService.trace(t)}return n}}e.DiskFileSystemProvider=l}),define(te[85],ne([0,1,3,7,8]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(f){this.service=f,this.onDidChangeLogLevel=T.Event.buffer(f.onDidChangeLogLevel,!0)}listen(f,S){switch(S){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${S}`)}async call(f,S,h){switch(S){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${S}`)}}e.LogLevelChannel=L;class i{constructor(f){this.channel=f}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(f){i.setLevel(this.channel,f)}static setLevel(f,S){return f.call("setLevel",S)}}e.LogLevelChannelClient=i;class R{constructor(f){this.loggerService=f,this.loggers=new Map}listen(f,S){throw new Error(`Event not found: ${S}`)}async call(f,S,h){switch(S){case"createLogger":this.createLogger(_.URI.revive(h[0]),h[1]);return;case"log":return this.log(_.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${S}`)}createLogger(f,S){this.loggers.set(f.toString(),this.loggerService.createLogger(f,S))}consoleLog(f,S){let h=console.log;switch(f){case k.LogLevel.Error:h=console.error;break;case k.LogLevel.Warning:h=console.warn;break;case k.LogLevel.Info:h=console.info;break}h.call(console,...S)}log(f,S){const h=this.loggers.get(f.toString());if(!h)throw new Error("Create the logger before logging");for(const[y,v]of S)(0,k.log)(h,y,v)}}e.LoggerChannel=R;class b extends k.AbstractLoggerService{constructor(f,S,h){super(f,S);this.channel=h}createConsoleMainLogger(){return new k.AdapterLogger({log:(f,S)=>{this.channel.call("consoleLog",[f,S])}})}doCreateLogger(f,S,h){return new C(this.channel,f,S,h)}}e.LoggerChannelClient=b;class C extends k.AbstractMessageLogger{constructor(f,S,h,y){super(y?.always);this.channel=f,this.file=S,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[S,y]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(f,S){const h=[[f,S]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(f){this.channel.call("log",[this.file,f])}}class I extends k.LogService{constructor(f,S){super(S);this.parent=f,this._register(f.onDidChangeLogLevel(h=>S.setLevel(h)))}setLevel(f){super.setLevel(f),this.parent.setLevel(f)}}e.FollowerLogService=I}),define(te[59],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,T.createDecorator)("nativeHostService")}),define(te[86],ne([0,1,17,4,32,18]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let i;if(typeof _.globals.vscode!="undefined"&&typeof _.globals.vscode.context!="undefined"){const R=_.globals.vscode.context.configuration();if(R)i=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof Q?.__$__nodeRequire=="function"){const R=(0,L.dirname)(T.FileAccess.asFileUri("",Q));i=Q.__$__nodeRequire((0,L.joinPath)(R,"product.json").fsPath);const b=Q.__$__nodeRequire((0,L.joinPath)(R,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(i,{nameShort:`${i.nameShort} Dev`,nameLong:`${i.nameLong} Dev`,dataFolderName:`${i.dataFolderName}-dev`}),Object.assign(i,{version:b.version})}else i={},Object.keys(i).length===0&&Object.assign(i,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=i}),define(te[26],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,T.createDecorator)("productService")}),define(te[178],ne([0,1,5,10,2,9,20,8,26]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let C=class extends k.Disposable{constructor(E,f,S){super();this.productService=f,this.logService=S,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,E&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpCodeCaches(E)},30*1e3)).schedule()}async cleanUpCodeCaches(E){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const f=Date.now(),S=(0,L.dirname)(E),h=(0,L.basename)(E),y=await i.Promises.readdir(S);await Promise.all(y.map(async v=>{if(v===h)return;const m=(0,L.join)(S,v),w=await i.Promises.stat(m);if(w.isDirectory()&&f-w.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${v}.`),i.Promises.rm(m)}))}catch(f){(0,_.onUnexpectedError)(f)}}};C=de([J(1,b.IProductService),J(2,R.ILogService)],C),e.CodeCacheCleaner=C}),define(te[179],ne([0,1,5,10,2,9,20,11,8,26]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let I=class extends k.Disposable{constructor(f,S,h){super();this.environmentService=f,this.logService=S,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new T.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const f=Object.create(null),S=JSON.parse(await i.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let w of Object.keys(S)){const g=S[w];f[`${g.hash}.${w}`]=!0}const h=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await i.Promises.exists(h))return;const v=await i.Promises.readdir(h);for(const w of v){if(f[w]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${w}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${w}`),await i.Promises.rm((0,L.join)(h,w))}const m=Date.now();for(const w of Object.keys(f)){const g=(0,L.join)(h,w),l=await i.Promises.readdir(g);for(const u of l){if(u==="tcf.json")continue;const r=(0,L.join)(g,u),a=await i.Promises.stat(r);a.isDirectory()&&m-a.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(w,u)}`),await i.Promises.rm(r))}}}catch(f){(0,_.onUnexpectedError)(f)}}};I=de([J(0,R.INativeEnvironmentService),J(1,b.ILogService),J(2,C.IProductService)],I),e.LanguagePackCachedDataCleaner=I}),define(te[37],ne([0,1,99,15]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(i,R){T.ok(_.isString(i)),T.ok(_.isObject(R)),T.ok(!this.data.has(i),"There is already an extension with this id"),this.data.set(i,R)}knows(i){return this.data.has(i)}as(i){return this.data.get(i)||null}}e.Registry=new k}),define(te[87],ne([0,1,3,37]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(R){return R.length>0&&R.charAt(R.length-1)==="#"?R.substring(0,R.length-1):R}class L{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(b,C){this.schemasById[k(b)]=C,this._onDidChangeSchema.fire(b)}notifySchemaChanged(b){this._onDidChangeSchema.fire(b)}getSchemaContributions(){return{schemas:this.schemasById}}}const i=new L;_.Registry.add(e.Extensions.JSONContribution,i)}),define(te[41],ne([0,1,16,3,15,125,87,37]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=R.Registry.as(i.Extensions.JSONContribution);class E{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new _.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new _.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,r=!0){this.registerConfigurations([u],r)}registerConfigurations(u,r=!0){const a=this.doRegisterConfigurations(u,r);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}deregisterConfigurations(u){const r=this.doDeregisterConfigurations(u);I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:u,remove:r}){const a=[];a.push(...this.doDeregisterConfigurations(r)),a.push(...this.doRegisterConfigurations(u,!1)),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(a)})}registerDefaultConfigurations(u){const r=[],a=[];for(const{overrides:n,source:t}of u)for(const s in n)if(r.push(s),e.OVERRIDE_PROPERTY_REGEX.test(s)){const o={...this.configurationDefaultsOverrides.get(s)?.value||{},...n[s]};this.configurationDefaultsOverrides.set(s,{source:t,value:o});const c={type:"object",default:o,description:L.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:o,source:k.isString(t)?void 0:t};a.push(...h(s)),this.configurationProperties[s]=c,this.defaultLanguageConfigurationOverridesNode.properties[s]=c}else{this.configurationDefaultsOverrides.set(s,{value:n[s],source:t});const o=this.configurationProperties[s];o&&(this.updatePropertyDefaultValue(s,o),this.updateSchema(s,o))}this.registerOverrideIdentifiers(a),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const r=[];for(const{overrides:a,source:n}of u)for(const t in a){const s=this.configurationDefaultsOverrides.get(t),o=k.isString(n)?n:n?.id,c=k.isString(s?.source)?s?.source:s?.source?.id;if(o===c)if(r.push(t),this.configurationDefaultsOverrides.delete(t),e.OVERRIDE_PROPERTY_REGEX.test(t))delete this.configurationProperties[t],delete this.defaultLanguageConfigurationOverridesNode.properties[t];else{const d=this.configurationProperties[t];d&&(this.updatePropertyDefaultValue(t,d),this.updateSchema(t,d))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const r of u)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,r){const a=[];return u.forEach(n=>{a.push(...this.validateAndRegisterProperties(n,r,n.extensionInfo,n.restrictedProperties)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),a}doDeregisterConfigurations(u){const r=[],a=n=>{if(n.properties)for(const t in n.properties)r.push(t),delete this.configurationProperties[t],this.removeFromSchema(t,n.properties[t]);n.allOf&&n.allOf.forEach(t=>a(t))};for(const n of u){a(n);const t=this.configurationContributors.indexOf(n);t!==-1&&this.configurationContributors.splice(t,1)}return r}validateAndRegisterProperties(u,r=!0,a,n,t=3){t=k.isUndefinedOrNull(u.scope)?t:u.scope;let s=[],o=u.properties;if(o)for(let d in o){if(r&&w(d)){delete o[d];continue}const p=o[d];if(p.source=a,p.defaultDefaultValue=o[d].default,this.updatePropertyDefaultValue(d,p),e.OVERRIDE_PROPERTY_REGEX.test(d)?p.scope=void 0:(p.scope=k.isUndefinedOrNull(p.scope)?t:p.scope,p.restricted=k.isUndefinedOrNull(p.restricted)?!!n?.includes(d):p.restricted),o[d].hasOwnProperty("included")&&!o[d].included){this.excludedConfigurationProperties[d]=o[d],delete o[d];continue}else this.configurationProperties[d]=o[d];!o[d].deprecationMessage&&o[d].markdownDeprecationMessage&&(o[d].deprecationMessage=o[d].markdownDeprecationMessage),s.push(d)}let c=u.allOf;if(c)for(let d of c)s.push(...this.validateAndRegisterProperties(d,r,a,n,t));return s}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const r=a=>{let n=a.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let t=a.allOf;t&&t.forEach(r)};r(u)}updateSchema(u,r){switch(e.allSettings.properties[u]=r,r.scope){case 1:e.applicationSettings.properties[u]=r;break;case 2:e.machineSettings.properties[u]=r;break;case 6:e.machineOverridableSettings.properties[u]=r;break;case 3:e.windowSettings.properties[u]=r;break;case 4:e.resourceSettings.properties[u]=r;break;case 5:e.resourceSettings.properties[u]=r,this.resourceLanguageSettingsSchema.properties[u]=r;break}}removeFromSchema(u,r){switch(delete e.allSettings.properties[u],r.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const r=`[${u}]`,a={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,a),e.allSettings.properties[r]=a,e.applicationSettings.properties[r]=a,e.machineSettings.properties[r]=a,e.machineOverridableSettings.properties[r]=a,e.windowSettings.properties[r]=a,e.resourceSettings.properties[r]=a}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,r){const a=this.configurationDefaultsOverrides.get(u);let n=a?.value,t=a?.source;k.isUndefined(n)&&(n=r.defaultDefaultValue,t=void 0),k.isUndefined(n)&&(n=v(r.type)),r.default=n,r.defaultValueSource=t}}const f="\\[([^\\]]+)\\]",S=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(l){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=S.exec(l);for(;r?.length;){const a=r[1].trim();a&&u.push(a),r=S.exec(l)}}return(0,T.distinct)(u)}e.overrideIdentifiersFromKey=h;function y(l){return l.reduce((u,r)=>`${u}[${r}]`,"")}e.keyFromOverrideIdentifiers=y;function v(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const m=new E;R.Registry.add(e.Extensions.Configuration,m);function w(l){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?L.localize(7,null,l):m.getConfigurationProperties()[l]!==void 0?L.localize(8,null,l):null:L.localize(6,null)}e.validateProperty=w;function g(){const l=[],u=m.getConfigurationProperties();for(const r of Object.keys(u))l.push([r,u[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=g}),define(te[88],ne([0,1,16,3,31,2,39,28,15,7,21,41,37]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class S{constructor(n={},t=[],s=[]){this._contents=n,this._keys=t,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,I.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,t){const s=this.getContentsForOverrideIdentifer(t);return s?n?(0,I.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){const t=[];for(const s of this.overrides)s.identifiers.includes(n)&&t.push(...s.keys);return T.distinct(t)}getAllOverrideIdentifiers(){const n=[];for(const t of this.overrides)n.push(...t.identifiers);return T.distinct(n)}override(n){let t=this.overrideConfigurations.get(n);return t||(t=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,t)),t}merge(...n){const t=R.deepClone(this.contents),s=R.deepClone(this.overrides),o=[...this.keys];for(const c of n){this.mergeContents(t,c.contents);for(const d of c.overrides){const[p]=s.filter(P=>T.equals(P.identifiers,d.identifiers));p?(this.mergeContents(p.contents,d.contents),p.keys.push(...d.keys),p.keys=T.distinct(p.keys)):s.push(R.deepClone(d))}for(const d of c.keys)o.indexOf(d)===-1&&o.push(d)}return new S(t,o,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const t=this.getContentsForOverrideIdentifer(n);if(!t||typeof t!="object"||!Object.keys(t).length)return this;let s={};for(const o of T.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o],d=t[o];d&&(typeof c=="object"&&typeof d=="object"?(c=R.deepClone(c),this.mergeContents(c,d)):c=d),s[o]=c}return new S(s,this.keys,this.overrides)}mergeContents(n,t){for(const s of Object.keys(t)){if(s in n&&b.isObject(n[s])&&b.isObject(t[s])){this.mergeContents(n[s],t[s]);continue}n[s]=R.deepClone(t[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?R.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let t=null,s=null;const o=c=>{c&&(s?this.mergeContents(s,c):s=R.deepClone(c))};for(const c of this.overrides)T.equals(c.identifiers,[n])?t=c.contents:c.identifiers.includes(n)&&o(c.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,t){this.addKey(n),(0,I.addToValueTree)(this.contents,n,t,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,I.removeFromValueTree)(this.contents,n)}addKey(n){let t=this.keys.length;for(let s=0;s<t;s++)n.indexOf(this.keys[s])===0&&(t=s);this.keys.splice(t,1,n)}removeKey(n){let t=this.keys.indexOf(n);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=S;class h extends S{constructor(n={}){const t=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=Object.keys(t),o=Object.create(null),c=[];for(const d in t){const p=n[d],P=p!==void 0?p:t[d].default;(0,I.addToValueTree)(o,d,P,O=>console.error(`Conflict in default settings: ${O}`))}for(const d of Object.keys(o))E.OVERRIDE_PROPERTY_REGEX.test(d)&&c.push({identifiers:(0,E.overrideIdentifiersFromKey)(d),keys:Object.keys(o[d]),contents:(0,I.toValuesTree)(o[d],p=>console.error(`Conflict in default settings file: ${p}`))});super(o,s,c)}}e.DefaultConfigurationModel=h;class y{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new S}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,t){if(!b.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,t)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,t){this._raw=n;const{contents:s,keys:o,overrides:c,restricted:d}=this.doParseRaw(n,t);this._configurationModel=new S(s,o,c),this._restrictedConfigurations=d||[]}doParseContent(n){let t={},s=null,o=[],c=[],d=[];function p(O){Array.isArray(o)?o.push(O):s!==null&&(o[s]=O)}let P={onObjectBegin:()=>{let O={};p(O),c.push(o),o=O,s=null},onObjectProperty:O=>{s=O},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let O=[];p(O),c.push(o),o=O,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:p,onError:(O,A,N)=>{d.push({error:O,offset:A,length:N})}};if(n)try{k.visit(n,P),t=o[0]||{}}catch(O){console.error(`Error while parsing settings file ${this._name}: ${O}`),this._parseErrors=[O]}return t}doParseRaw(n,t){const s=f.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,s,!0,t);n=o.raw;const c=(0,I.toValuesTree)(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),d=Object.keys(n),p=this.toOverrides(n,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:c,keys:d,overrides:p,restricted:o.restricted}}filter(n,t,s,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const c={},d=[];for(let p in n)if(E.OVERRIDE_PROPERTY_REGEX.test(p)&&s){const P=this.filter(n[p],t,!1,o);c[p]=P.raw,d.push(...P.restricted)}else{const P=t[p],O=P?typeof P.scope!="undefined"?P.scope:3:void 0;P?.restricted&&d.push(p),(O===void 0||o.scopes===void 0||o.scopes.includes(O))&&(o.skipRestricted&&P?.restricted||(c[p]=n[p]))}return{raw:c,restricted:d}}toOverrides(n,t){const s=[];for(const o of Object.keys(n))if(E.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const d in n[o])c[d]=n[o][d];s.push({identifiers:(0,E.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,I.toValuesTree)(c,t)})}return s}}e.ConfigurationModelParser=y;class v extends L.Disposable{constructor(n,t,s,o){super();this.userSettingsResource=n,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new _.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new y(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(_.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new S}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class m{constructor(n,t,s=new S,o=new S,c=new i.ResourceMap,d=new S,p=new i.ResourceMap,P=!0){this._defaultConfiguration=n,this._localUserConfiguration=t,this._remoteUserConfiguration=s,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=d,this._memoryConfigurationByResource=p,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new i.ResourceMap,this._userConfiguration=null}getValue(n,t,s){return this.getConsolidateConfigurationModel(t,s).getValue(n)}updateValue(n,t,s={}){let o;s.resource?(o=this._memoryConfigurationByResource.get(s.resource),o||(o=new S,this._memoryConfigurationByResource.set(s.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(n):o.setValue(n,t),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,t,s){const o=this.getConsolidateConfigurationModel(t,s),c=this.getFolderConfigurationModelForResource(t.resource,s),d=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,p=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),P=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),N=s?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,$=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(n):c.freeze().getValue(n):void 0,D=t.overrideIdentifier?d.override(t.overrideIdentifier).getValue(n):d.getValue(n),F=o.getValue(n),M=T.distinct(T.flatten(o.overrides.map(U=>U.identifiers))).filter(U=>o.getOverrideValue(n,U)!==void 0);return{defaultValue:p,userValue:P,userLocalValue:O,userRemoteValue:A,workspaceValue:N,workspaceFolderValue:$,memoryValue:D,value:F,default:p!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspace:N!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,workspaceFolder:$!==void 0?{value:c?.freeze().getValue(n),override:t.overrideIdentifier?c?.freeze().getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,memory:D!==void 0?{value:d.getValue(n),override:t.overrideIdentifier?d.getOverrideValue(n,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:M.length?M:void 0}}keys(n){const t=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,t){this._folderConfigurations.set(n,t),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,t){const s=[];if(!t){const{added:o,updated:c,removed:d}=u(this._defaultConfiguration,n);t=[...o,...c,...d]}for(const o of t)for(const c of(0,E.overrideIdentifiersFromKey)(o)){const d=this._defaultConfiguration.getKeysForOverrideIdentifier(c),p=n.getKeysForOverrideIdentifier(c),P=[...p.filter(O=>d.indexOf(O)===-1),...d.filter(O=>p.indexOf(O)===-1),...d.filter(O=>!R.equals(this._defaultConfiguration.override(c).getValue(O),n.override(c).getValue(O)))];s.push([c,P])}return this.updateDefaultConfiguration(n),{keys:t,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:c}=u(this.localUserConfiguration,n),d=[...t,...s,...o];return d.length&&this.updateLocalUserConfiguration(n),{keys:d,overrides:c}}compareAndUpdateRemoteUserConfiguration(n){const{added:t,updated:s,removed:o,overrides:c}=u(this.remoteUserConfiguration,n);let d=[...t,...s,...o];return d.length&&this.updateRemoteUserConfiguration(n),{keys:d,overrides:c}}compareAndUpdateWorkspaceConfiguration(n){const{added:t,updated:s,removed:o,overrides:c}=u(this.workspaceConfiguration,n);let d=[...t,...s,...o];return d.length&&this.updateWorkspaceConfiguration(n),{keys:d,overrides:c}}compareAndUpdateFolderConfiguration(n,t){const s=this.folderConfigurations.get(n),{added:o,updated:c,removed:d,overrides:p}=u(s,t);let P=[...o,...c,...d];return(P.length||!s)&&this.updateFolderConfiguration(n,t),{keys:P,overrides:p}}compareAndDeleteFolderConfiguration(n){const t=this.folderConfigurations.get(n);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:o,removed:c,overrides:d}=u(t,void 0);return{keys:[...s,...o,...c],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,t){let s=this.getConsolidatedConfigurationModelForResource(n,t);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},t){let s=this.getWorkspaceConsolidatedConfiguration();if(t&&n){const o=t.getFolder(n);o&&(s=this.getFolderConsolidatedConfiguration(o.uri)||s);const c=this._memoryConfigurationByResource.get(n);c&&(s=s.merge(c))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let t=this._foldersConsolidatedConfigurations.get(n);if(!t){const s=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(t=s.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(n,t)):t=s}return t}getFolderConfigurationModelForResource(n,t){if(t&&n){const s=t.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,t)=>{const{contents:s,overrides:o,keys:c}=this._folderConfigurations.get(t);return n.push([t,{contents:s,overrides:o,keys:c}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>n.add(t)),this.userConfiguration.freeze().keys.forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>n.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>t.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(o=>t.add(o))),[...t.values()]}static parse(n){const t=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),o=this.parseConfigurationModel(n.workspace),c=n.folders.reduce((d,p)=>(d.set(C.URI.revive(p[0]),this.parseConfigurationModel(p[1])),d),new i.ResourceMap);return new m(t,s,new S,o,c,new S,new i.ResourceMap,!1)}static parseConfigurationModel(n){return new S(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=m;function w(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const n=new Set,t=new Map;for(const o of a)o.keys.forEach(c=>n.add(c)),o.overrides.forEach(([c,d])=>{const p=(0,i.getOrSet)(t,c,new Set);d.forEach(P=>p.add(P))});const s=[];return t.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=w;class g{constructor(n,t,s,o){this.change=n,this.previous=t,this.currentConfiguraiton=s,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;n.keys.forEach(p=>c.add(p)),n.overrides.forEach(([,p])=>p.forEach(P=>c.add(P))),this.affectedKeys=[...c.values()];const d=new S;this.affectedKeys.forEach(p=>d.setValue(p,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(t){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,t,this.currentWorkspace);return!R.equals(s,o)}return!0}return!1}doesAffectedKeysTreeContains(n,t){let s=(0,I.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof s=="object"&&(o=Object.keys(s)[0]);){if(n=n[o],!n)return!1;s=s[o]}return!0}}e.ConfigurationChangeEvent=g;class l extends g{constructor(n,t,s,o){super({keys:n.allKeys(),overrides:[]},void 0,n,t);this.source=s,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=l;function u(a,n){const{added:t,removed:s,updated:o}=r(n,a),c=[],d=a?.getAllOverrideIdentifiers()||[],p=n?.getAllOverrideIdentifiers()||[];if(n){const P=p.filter(O=>!d.includes(O));for(const O of P)c.push([O,n.getKeysForOverrideIdentifier(O)])}if(a){const P=d.filter(O=>!p.includes(O));for(const O of P)c.push([O,a.getKeysForOverrideIdentifier(O)])}if(n&&a){for(const P of d)if(p.includes(P)){const O=r({contents:a.getOverrideValue(void 0,P)||{},keys:a.getKeysForOverrideIdentifier(P)},{contents:n.getOverrideValue(void 0,P)||{},keys:n.getKeysForOverrideIdentifier(P)});c.push([P,[...O.added,...O.removed,...O.updated]])}}return{added:t,removed:s,updated:o,overrides:c}}function r(a,n){const t=a?n?a.keys.filter(c=>n.keys.indexOf(c)===-1):[...a.keys]:[],s=n?a?n.keys.filter(c=>a.keys.indexOf(c)===-1):[...n.keys]:[],o=[];if(a&&n){for(const c of n.keys)if(a.keys.indexOf(c)!==-1){const d=(0,I.getConfigurationValue)(n.contents,c),p=(0,I.getConfigurationValue)(a.contents,c);R.equals(d,p)||o.push(c)}}return{added:t,removed:s,updated:o}}}),define(te[180],ne([0,1,5,3,2,18,21,88,41,37]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class I extends k.Disposable{constructor(f,S){super();this.settingsResource=f,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new R.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,S)),this.configuration=new R.Configuration(new R.DefaultConfigurationModel,new R.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(C.Registry.as(b.Extensions.Configuration).onDidUpdateConfiguration(({properties:h})=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const f=await this.userConfiguration.loadConfiguration();this.configuration=new R.Configuration(new R.DefaultConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(f,S){const h=typeof f=="string"?f:void 0,y=(0,i.isConfigurationOverrides)(f)?f:(0,i.isConfigurationOverrides)(S)?S:{};return this.configuration.getValue(h,y,void 0)}updateValue(f,S,h,y){return Promise.reject(new Error("not supported"))}inspect(f){return this.configuration.inspect(f,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const f=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(f)}onDidChangeUserConfiguration(f){const S=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(f);this.trigger(h,S,1)}onDidDefaultConfigurationChange(f){const S=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new R.DefaultConfigurationModel,f);this.trigger(h,S,6)}trigger(f,S,h){const y=new R.ConfigurationChangeEvent(f,{data:S},this.configuration);y.source=h,y.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(y)}getTargetConfiguration(f){switch(f){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=I}),define(te[181],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,T.createDecorator)("remoteAuthorityResolverService");var _;(function(L){L.Unknown="Unknown",L.NotAvailable="NotAvailable",L.TemporarilyNotAvailable="TemporarilyNotAvailable",L.NoResolverFound="NoResolverFound"})(_=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class k extends Error{constructor(i,R=_.Unknown,b){super(i);this._message=i,this._code=R,this._detail=b,this.isHandled=R===_.NotAvailable&&b===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,k.prototype)}static isTemporarilyNotAvailable(i){return i instanceof k&&i._code===_.TemporarilyNotAvailable}static isNoResolverFound(i){return i instanceof k&&i._code===_.NoResolverFound}static isHandled(i){return i instanceof k&&i.isHandled}}e.RemoteAuthorityResolverError=k}),define(te[182],ne([0,1,5,19,27,10,3,2,30,71,181]),function(Q,e,T,_,k,L,i,R,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const E=30*1e3;var f;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function S(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(W){const z=new k.CancellationTokenSource;return setTimeout(()=>z.cancel(),W),z.token}function y(W,z){if(W.isCancellationRequested||z.isCancellationRequested)return k.CancellationToken.Cancelled;const B=new k.CancellationTokenSource;return W.onCancellationRequested(()=>B.cancel()),z.onCancellationRequested(()=>B.cancel()),B.token}class v{constructor(z){this._state="pending",this._disposables=new R.DisposableStore,this.promise=new Promise((B,q)=>{this._resolvePromise=B,this._rejectPromise=q}),z.isCancellationRequested?this._timeout():this._disposables.add(z.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(z){this._state==="pending"?this._disposables.add(z):z.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const z=new Error("Time limit reached");return z.code="ETIMEDOUT",z.syscall="connect",z}resolve(z){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(z))}reject(z){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(z))}}function m(W,z){const B=new v(z);return B.registerDisposable(W.onControlMessage(q=>{const H=JSON.parse(q.toString()),Y=G(H);Y?B.reject(Y):B.resolve(H)})),B.promise}function w(W,z,B,q,H,Y,x){const K=new v(x);return z.connect(B,q,H,Y,(re,se)=>{K.didTimeout?(re&&W.error(re),se?.dispose()):re||!se?K.reject(re):K.resolve(se)}),K.promise}function g(W,z){const B=new v(z);return W.then(q=>{B.didTimeout||B.resolve(q)},q=>{B.didTimeout||B.reject(q)}),B.promise}async function l(W,z,B,q){const H=j(W,z);W.logService.trace(`${H} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await w(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,`renderer-${S(z)}-${W.reconnectionToken}`,q)}catch(ce){throw W.logService.error(`${H} socketFactory.connect() failed or timed out. Error:`),W.logService.error(ce),ce}W.logService.trace(`${H} 2/6. socketFactory.connect() was successful.`);let x,K;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection(Y,null),x=W.reconnectionProtocol,K=!1):(x=new C.PersistentProtocol(Y,null),K=!0),W.logService.trace(`${H} 3/6. sending AuthRequest control message.`);const re=await g(W.signService.createNewMessage((0,b.generateUuid)()),q),se={type:"auth",auth:W.connectionToken||"00000000000000000000",data:re.data};x.sendControl(_.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await m(x,y(q,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(W.logService.trace(`${H} 4/6. received SignRequest control message.`),!await g(W.signService.validate(re,ce.signedData),q)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const me=await g(W.signService.sign(ce.data),q),ye={type:"connectionType",commit:W.commit,signedData:me,desiredConnectionType:z};return B&&(ye.args=B),W.logService.trace(`${H} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(_.VSBuffer.fromString(JSON.stringify(ye))),{protocol:x,ownsProtocol:K}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(W.logService.error(`${H} the handshake timed out. Error:`),W.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${H} received error control message when negotiating connection. Error:`),W.logService.error(ce)),K&&U(x),ce}}async function u(W,z,B,q){const H=Date.now(),Y=j(W,z),{protocol:x,ownsProtocol:K}=await l(W,z,B,q),re=new v(q);return re.registerDisposable(x.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=G(ce);he?(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(he),K&&U(x),re.reject(he)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${Z(H)}!`),re.resolve({protocol:x,firstMessage:ce}))})),re.promise}async function r(W,z){const{protocol:B}=await u(W,1,void 0,z);return{protocol:B}}async function a(W,z,B){const{protocol:q,firstMessage:H}=await u(W,2,z,B),Y=H&&H.debugPort;return{protocol:q,debugPort:Y}}async function n(W,z,B){const q=Date.now(),H=j(W,3),{protocol:Y}=await l(W,3,z,B);return W.logService.trace(`${H} 6/6. handshake finished, connection is up and running after ${Z(q)}!`),Y}async function t(W,z,B){const{host:q,port:H,connectionToken:Y}=await W.addressProvider.getAddress();return{commit:W.commit,host:q,port:H,connectionToken:Y,reconnectionToken:z,reconnectionProtocol:B,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function s(W,z,B){try{const q=(0,b.generateUuid)(),H=await t(W,q,null),{protocol:Y}=await r(H,k.CancellationToken.None);return new F(W,z,B,q,Y)}catch(q){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(q),D.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=s;async function o(W,z){try{const B=(0,b.generateUuid)(),q=await t(W,B,null),{protocol:H,debugPort:Y}=await a(q,z,k.CancellationToken.None);return new M(W,z,B,H,Y)}catch(B){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(B),D.triggerPermanentFailure(0,0,I.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=o;async function c(W,z,B){const q=await t(W,(0,b.generateUuid)(),null);return await n(q,{host:z,port:B},k.CancellationToken.None)}e.connectRemoteAgentTunnel=c;function d(W){return(0,T.createCancelablePromise)(z=>new Promise((B,q)=>{const H=setTimeout(B,W*1e3);z.onCancellationRequested(()=>{clearTimeout(H),B()})}))}var p;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(p=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class P{constructor(z,B){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=P;class O{constructor(z,B,q,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.durationSeconds=q,this.cancellableTimer=H,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class A{constructor(z,B,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=A;class N{constructor(z,B,q){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=q,this.type=4}}e.ConnectionGainEvent=N;class ${constructor(z,B,q,H){this.reconnectionToken=z,this.millisSinceLastIncomingData=B,this.attempt=q,this.handled=H,this.type=3}}e.ReconnectionPermanentFailureEvent=$;class D extends R.Disposable{constructor(z,B,q,H){super();this._connectionType=z,this._onDidStateChange=this._register(new i.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=q,this.protocol=H,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(H.onSocketClose(Y=>{const x=V(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${x} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${x} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${x} received socket close event.`),this._beginReconnecting()})),this._register(H.onSocketTimeout(()=>{const Y=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} received socket timeout event.`),this._beginReconnecting()})),D._instances.push(this),D._permanentFailure&&this._gotoPermanentFailure(D._permanentFailureMillisSinceLastIncomingData,D._permanentFailureAttempt,D._permanentFailureHandled)}static triggerPermanentFailure(z,B,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=z,this._permanentFailureAttempt=B,this._permanentFailureHandled=q,this._instances.forEach(H=>H._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(z=>z._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(z=>z._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(D._permanentFailure)return;const z=V(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${z} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new P(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const H=q<B.length?B[q]:B[B.length-1];try{if(H>0){const x=d(H);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),H,x)),this._options.logService.info(`${z} waiting for ${H} seconds before reconnecting...`);try{await x}catch{}}if(D._permanentFailure){this._options.logService.error(`${z} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${z} resolving connection...`);const Y=await t(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${z} connecting to ${Y.host}:${Y.port}...`),await this._reconnect(Y,h(E)),this._options.logService.info(`${z} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${z} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(Y),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${z} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(Y),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(I.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Y)){this._options.logService.info(`${z} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this._options.logService.info(`${z} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if((0,L.isPromiseCanceledError)(Y)){this._options.logService.info(`${z} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(Y);continue}if(Y instanceof I.RemoteAuthorityResolverError){this._options.logService.error(`${z} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(Y),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,I.RemoteAuthorityResolverError.isHandled(Y));break}this._options.logService.error(`${z} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(Y),D.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!D._permanentFailure)}_gotoPermanentFailure(z,B,q){this._onDidStateChange.fire(new $(this.reconnectionToken,z,B,q)),U(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=D,D._permanentFailure=!1,D._permanentFailureMillisSinceLastIncomingData=0,D._permanentFailureAttempt=0,D._permanentFailureHandled=!1,D._instances=[];class F extends D{constructor(z,B,q,H,Y){super(1,z,H,Y);this.client=this._register(new C.Client(Y,{remoteAuthority:B,clientId:q},z.ipcLogger))}async _reconnect(z,B){await r(z,B)}}e.ManagementPersistentConnection=F;class M extends D{constructor(z,B,q,H,Y){super(2,z,q,H);this._startArguments=B,this.debugPort=Y}async _reconnect(z,B){await a(z,this._startArguments,B)}}e.ExtensionHostPersistentConnection=M;function U(W){try{W.acceptDisconnect();const z=W.getSocket();W.dispose(),z.dispose()}catch(z){(0,L.onUnexpectedError)(z)}}function G(W){if(W&&W.type==="error"){const z=new Error(`Connection error: ${W.reason}`);return z.code="VSCODE_CONNECTION_ERROR",z}return null}function ee(W,z){for(;W.length<z;)W+=" ";return W}function V(W,z,B){return`[remote-connection][${ee(S(W),13)}][${z.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function j(W,z){return`${V(z,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function Z(W){return`${Date.now()-W} ms`}}),define(te[183],ne([0,1,17]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function _(C){return C.scheme===T.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=_;function k(C){if(!C)return;const I=C.indexOf("+");return I<0?C:C.substr(0,I)}e.getRemoteName=k;function L(C){return C.scheme!==T.Schemas.file&&C.scheme!==T.Schemas.vscodeRemote}e.isVirtualResource=L;function i(C){if(C.folders.length)return C.folders.every(I=>L(I.uri))?C.folders[0].uri:void 0;if(C.configuration&&L(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=i;function R(C){return i(C)?.scheme}e.getVirtualWorkspaceScheme=R;function b(C){return i(C)!==void 0}e.isVirtualWorkspace=b}),define(te[89],ne([0,1,25,6,183]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function i(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=i,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class b{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,h){if(typeof S=="undefined"||S===null)return typeof h=="undefined"||h===null;if(typeof h=="undefined"||h===null)return!1;if(typeof S=="string"||typeof h=="string"){let y=typeof S=="string"?S:S.value,v=typeof h=="string"?h:h.value;return T.equalsIgnoreCase(y,v)}return S._lower===h._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=b;function C(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=C;function I(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function E(f,S){if(S){const h=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return f.activationEvents?.indexOf(h)!==-1}return!1}e.isResolverExtension=E,e.IBuiltinExtensionsScannerService=(0,_.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[34],ne([0,1,25,89]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function k(h,y){return h.uuid&&y.uuid?h.uuid===y.uuid:h.id===y.id?!0:(0,T.compareIgnoreCase)(h.id,y.id)===0}e.areSameExtensions=k;class L{constructor(y,v){this.version=v,this.id=y.id,this.uuid=y.uuid}key(){return`${this.id}-${this.version}`}equals(y){return y instanceof L?k(this,y)&&this.version===y.version:!1}}e.ExtensionIdentifierWithVersion=L;function i(h,y){return`${h}.${y}`}e.getExtensionId=i;function R(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=R;function b(h,y){return R(i(h,y))}e.getGalleryExtensionId=b;function C(h,y){const v=[],m=w=>{for(const g of v)if(g.some(l=>k(y(l),y(w))))return g;return null};for(const w of h){const g=m(w);g?g.push(w):v.push([w])}return v}e.groupByExtension=C;function I(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=I;function E(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=E,e.BetterMergeId=new _.ExtensionIdentifier("pprice.better-merge");function f(h){const y=new Set;if(h.malicious)for(const v of h.malicious)y.add(v.id);return y}e.getMaliciousExtensionsSet=f;function S(h,y){const v=[],m=y.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const w=m.shift();if(w&&v.every(g=>!k(g.identifier,{id:w}))){const g=h.filter(l=>k(l.identifier,{id:w}));g.length===1&&(v.push(g[0]),m.push(...g[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=S}),define(te[184],ne([0,1,5,10,2,4,18,60,7,30,20,11,29,34,14,8]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends k.Disposable{constructor(g,l,u,r){super();this.fileService=l,this.extensionGalleryService=u,this.logService=r,this.extensionsDownloadDir=b.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,l){await this.cleanUpPromise;const u=this.getName(g),r=(0,i.joinPath)(this.extensionsDownloadDir,u);if(!await this.fileService.exists(r)){const a=(0,i.joinPath)(this.extensionsDownloadDir,`.${(0,C.generateUuid)()}`);await this.fileService.exists(a)||await this.extensionGalleryService.download(g,a,l);try{await this.rename(a,r,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(a)}catch(t){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,_.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,a.path),n}}return r}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,l,u){try{await I.Promises.rename(g.fsPath,l.fsPath)}catch(r){if(L.isWindows&&r&&r.code==="EPERM"&&Date.now()<u)return this.logService.info(`Failed renaming ${g} to ${l} with 'EPERM' error. Trying again...`),this.rename(g,l,u);throw r}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const l=[],u=[];for(const n of g.children){const t=this.parse(n.name);t&&u.push([t,n])}const r=(0,S.groupByExtension)(u,([n])=>n),a=[];for(const n of r)n.sort((t,s)=>R.rcompare(t[0].version,s[0].version)),l.push(...n.slice(1).map(t=>t[1].resource)),a.push(n[0][1]);a.sort((n,t)=>n.mtime-t.mtime),l.push(...a.slice(0,Math.max(0,a.length-this.cache)).map(n=>n.resource)),await T.Promises.settled(l.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?`${new S.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase()}${g.properties.targetPlatform!=="undefined"?`-${g.properties.targetPlatform}`:""}`:(0,C.generateUuid)()}parse(g){const l=v.exec(g);return l&&l[1]&&l[2]?new S.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};m=de([J(0,E.INativeEnvironmentService),J(1,h.IFileService),J(2,f.IExtensionGalleryService),J(3,y.ILogService)],m),e.ExtensionsDownloader=m}),define(te[185],ne([0,1,2,9,20,89]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class i extends T.Disposable{constructor(b,C){super();this.environmentService=b,this.extensionsManifestCache=(0,_.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(C.onDidInstallExtensions(I=>this.onDidInstallExtensions(I))),this._register(C.onDidUninstallExtension(I=>this.onDidUnInstallExtension(I)))}onDidInstallExtensions(b){b.some(C=>!!C.local)&&this.invalidate()}onDidUnInstallExtension(b){b.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=i}),define(te[186],ne([0,1,81,16,5,2,17,9,20,11,29,34,58,8]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let h=class extends L.Disposable{constructor(m,w,g){super();this.extensionManagementService=m,this.logService=g,this.cache=this._register(new y(w,g)),this.extensionManagementService.registerParticipant({postInstall:async l=>this.postInstallExtension(l),postUninstall:async l=>this.postUninstallExtension(l)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),w=["en",...Object.keys(m)];return(0,_.distinct)(w)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const w=await this.cache.getLanguagePacks();Object.keys(w).some(g=>w[g]&&w[g].extensions.some(l=>(0,E.areSameExtensions)(l.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,w]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),g=await this.cache.update(w);return!(0,_.equals)(Object.keys(m),Object.keys(g))}};h=de([J(0,I.IExtensionManagementService),J(1,C.INativeEnvironmentService),J(2,S.ILogService)],h),e.LocalizationsService=h;let y=class extends L.Disposable{constructor(m,w){super();this.logService=w,this.languagePacks={},this.languagePacksFilePath=(0,R.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(w=>{Object.keys(w).forEach(g=>delete w[g]),this.createLanguagePacksFromExtensions(w,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...w){for(const g of w)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,g);Object.keys(m).forEach(g=>this.updateHash(m[g]))}createLanguagePacksFromExtension(m,w){const g=w.identifier,l=w.manifest.contributes&&w.manifest.contributes.localizations?w.manifest.contributes.localizations:[];for(const u of l)if(w.location.scheme===i.Schemas.file&&(0,f.isValidLocalization)(u)){let r=m[u.languageId];r||(r={hash:"",extensions:[],translations:{}},m[u.languageId]=r);let a=r.extensions.filter(n=>(0,E.areSameExtensions)(n.extensionIdentifier,g))[0];a?a.version=w.manifest.version:r.extensions.push({extensionIdentifier:g,version:w.manifest.version});for(const n of u.translations)r.translations[n.id]=(0,R.join)(w.location.fsPath,n.path)}}updateHash(m){if(m){const w=(0,T.createHash)("md5");for(const g of m.extensions)w.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);m.hash=w.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let w=null;return b.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch(l){return{}}}).then(g=>(w=m(g),g)).then(g=>{for(const u of Object.keys(g))g[u]||delete g[u];this.languagePacks=g,this.initializedCache=!0;const l=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",l),b.Promises.writeFile(this.languagePacksFilePath,l)}).then(()=>w,g=>this.logService.error(g))})}};y=de([J(0,C.INativeEnvironmentService),J(1,S.ILogService)],y)}),define(te[187],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,T.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(te[61],ne([0,1,3,4,6,8]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var i;(function(h){h.Http="http",h.Https="https"})(i=e.TunnelProtocol||(e.TunnelProtocol={}));var R;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(R=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var b;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(b=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function C(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const y=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!y)return{address:y[1],port:+y[2]}}e.extractLocalHostUriMetaDataForPortMapping=C,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function I(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=I,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function E(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=E;function f(h,y){return y?y!==1&&h<1024:!_.isWindows&&h<1024}e.isPortPrivileged=f;let S=class{constructor(y){this.logService=y,this._onTunnelOpened=new T.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new T.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new T.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(y,v){return this._tunnelProvider=y,y?(this._canElevate=v.elevation,this._privacyOptions=v.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const y=[],v=Array.from(this._tunnels.values());for(let m of v){const w=Array.from(m.values());for(let g of w){const l=await g.value;l&&y.push(l)}}return y}async dispose(){for(const y of this._tunnels.values()){for(const{value:v}of y.values())await v.then(m=>m?.dispose());y.clear()}this._tunnels.clear()}openTunnel(y,v,m,w,g=!1,l=R.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${v}:${m} on local port ${w}.`),!y)return;v||(v="localhost");const r=this.retainOrCreateTunnel(y,v,m,w,g,l,u);return r?r.then(a=>{if(!a){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(v,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const n=this.makeTunnel(a);return(a.tunnelRemoteHost!==v||a.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(n),n}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(y){return{tunnelRemotePort:y.tunnelRemotePort,tunnelRemoteHost:y.tunnelRemoteHost,tunnelLocalPort:y.tunnelLocalPort,localAddress:y.localAddress,privacy:y.privacy,protocol:y.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${y.tunnelRemoteHost}:${y.tunnelRemotePort} `);const v=this._tunnels.get(y.tunnelRemoteHost);if(v){const m=v.get(y.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(y.tunnelRemoteHost,y.tunnelRemotePort,m))}}}}async tryDisposeTunnel(y,v,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${y}:${v}.`);const w=m.value.then(async g=>{g&&(await g.dispose(!0),this._onTunnelClosed.fire({host:g.tunnelRemoteHost,port:g.tunnelRemotePort}))});return this._tunnels.has(y)&&this._tunnels.get(y).delete(v),w}}async closeTunnel(y,v){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${y}:${v} `);const m=this._tunnels.get(y);if(m&&m.has(v)){const w=m.get(v);w.refcount=0,await this.tryDisposeTunnel(y,v,w)}}addTunnelToMap(y,v,m){this._tunnels.has(y)||this._tunnels.set(y,new Map),this._tunnels.get(y).set(v,{refcount:1,value:m})}async removeEmptyTunnelFromMap(y,v){const m=this._tunnels.get(y);m&&(await m.get(v)||m.delete(v),m.size===0&&this._tunnels.delete(y))}getTunnelFromMap(y,v){let m=[y];I(y)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):E(y)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const w=m.map(g=>this._tunnels.get(g));for(const g of w){const l=g?.get(v);if(l)return l}}canTunnel(y){return!!C(y)}createWithProvider(y,v,m,w,g,l,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${v}:${m} on local port ${w}.`);const a={elevationRequired:g?f(w===void 0?m:w):!1},n={remoteAddress:{host:v,port:m},localAddressPort:w,privacy:l,public:l!==R.Private,protocol:u},t=y.forwardPort(n,a);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(v,m,t),t}};S=de([J(0,L.ILogService)],S),e.AbstractTunnelService=S}),define(te[188],ne([0,1,8,61,2,10,5]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class R extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new i.DeferredPromise),this._addressPromise.p)}setAddress(I){this._address=I,this._addressPromise&&(this._addressPromise.complete(I),this._addressPromise=null)}setTunnel(I){this._register(I)}}let b=class Et extends k.Disposable{constructor(I,E){super();this._tunnelService=I,this._logService=E,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(I=>I.dispose())}async createTunnel(){return{id:String(++Et._lastId)}}async startTunnel(I,E,f,S,h,y){const v=new R,m=await Promise.resolve(this._tunnelService.openTunnel(I,v,f,S,h,y));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${f}:${S} (remote).`),v.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(E))throw this._disposedTunnels.delete(E),v.dispose(),await m.dispose(),(0,L.canceled)();return v.setTunnel(m),this._tunnels.set(E,v),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${E}: ${m.localAddress} (local) to ${f}:${S} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(I,E){const f=this._tunnels.get(I);!f||f.setAddress(E)}async destroyTunnel(I){const E=this._tunnels.get(I);if(E){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${I}.`),this._tunnels.delete(I),await E.dispose();return}this._disposedTunnels.add(I)}};b._lastId=0,b=de([J(0,_.ISharedTunnelsService),J(1,T.ILogService)],b),e.SharedProcessTunnelService=b}),define(te[189],ne([0,1,119,21,8]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(R,b){this.configurationService=R,this.logService=b}request(R,b){return this.logService.trace("RequestService#request",R.url),R.proxyAuthorization||(R.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,T.request)(R,b)}async resolveProxy(R){}};L=de([J(0,_.IConfigurationService),J(1,k.ILogService)],L),e.RequestService=L}),define(te[42],ne([0,1,19,140,41,6,37]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function R(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=R;function b(h){return h.res.statusCode===204}async function C(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);return b(h)?null:(await(0,T.streamToBuffer)(h.stream)).toString()}e.asText=C;async function I(h){if(!R(h))throw new Error("Server returned "+h.res.statusCode);if(b(h))return null;const v=(await(0,T.streamToBuffer)(h.stream)).toString();try{return JSON.parse(v)}catch(m){throw m.message+=`:
`+v,m}}e.asJson=I;function E(h){S(h)}e.updateProxyConfigurationsScope=E;let f;function S(h){const y=i.Registry.as(k.Extensions.Configuration),v=f;f={id:"http",order:15,title:(0,_.localize)(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,_.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,_.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,_.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,_.localize)(4,null),(0,_.localize)(5,null),(0,_.localize)(6,null),(0,_.localize)(7,null)],default:"override",description:(0,_.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,_.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[f],remove:v?[v]:[]})}S(2)}),define(te[190],ne([0,1,27,17,14,42]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let i=class{constructor(b,C){this.requestService=b,this.fileService=C}async download(b,C,I=T.CancellationToken.None){if(b.scheme===_.Schemas.file||b.scheme===_.Schemas.vscodeRemote){await this.fileService.copy(b,C);return}const E={type:"GET",url:b.toString()},f=await this.requestService.request(E,I);if(f.res.statusCode===200)await this.fileService.writeFile(C,f.stream);else{const S=await(0,L.asText)(f);throw new Error(`Expected 200, got back ${f.res.statusCode} instead.

${S}`)}}};i=de([J(0,L.IRequestService),J(1,k.IFileService)],i),e.DownloadService=i}),define(te[191],ne([0,1,16,27,65,2,18,154,14,8,26,42]),function(Q,e,T,_,k,L,i,R,b,C,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let f=class extends L.Disposable{constructor(h,y,v,m){super();this.fileService=h,this.productService=y,this.requestService=v,this.logService=m,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,k.forEach)(this.productService.configBasedExtensionTips,({value:w})=>this.allConfigBasedTips.set(w.configPath,w))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const y=[];for(const[v,m]of this.allConfigBasedTips)if(!(m.configScheme&&m.configScheme!==h.scheme))try{const w=await this.fileService.readFile((0,i.joinPath)(h,v)),g=new Map;(0,k.forEach)(m.recommendations,({key:u,value:r})=>{if((0,T.isNonEmptyArray)(r.remotes))for(const a of r.remotes)g.set(a,{extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack});else y.push({extensionId:u,extensionName:r.name,configName:m.configName,important:!!r.important,isExtensionPack:!!r.isExtensionPack})});const l=(0,R.getDomainsOfRemotes)(w.value.toString(),[...g.keys()]);for(const u of l){const r=g.get(u);r&&y.push(r)}}catch(w){}return y}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},_.CancellationToken.None);if(h.res.statusCode!==200)return[];const y=await(0,E.asJson)(h);return y?y.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};f=de([J(0,b.IFileService),J(1,I.IProductService),J(2,E.IRequestService),J(3,C.ILogService)],f),e.ExtensionTipsService=f}),define(te[45],ne([0,1,19,30]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,i,R){let b=R&&R.get("storage.serviceMachineId",0)||null;if(b)return b;try{const I=(await i.readFile(L.serviceMachineIdResource)).value.toString();b=(0,_.isUUID)(I)?I:null}catch(C){b=null}if(!b){b=(0,_.generateUuid)();try{await i.writeFile(L.serviceMachineIdResource,T.VSBuffer.fromString(b))}catch(C){}}return R&&R.store("storage.serviceMachineId",b,0,1),b}e.getServiceMachineId=k}),define(te[90],ne([0,1,104,6]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(L){return(0,T.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,_.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(te[192],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var T;(function(_){_.Spawn="vscode:shared-process->shared-process-worker=spawn",_.Terminate="vscode:shared-process->shared-process-worker=terminate",_.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",_.Ready="vscode:shared-process-worker->shared-process=ready",_.Ack="vscode:shared-process-worker->shared-process=ack",_.Trace="vscode:shared-process-worker->shared-process=trace",_.Info="vscode:shared-process-worker->shared-process=info",_.Warn="vscode:shared-process-worker->shared-process=warn",_.Error="vscode:shared-process-worker->shared-process=error"})(T=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(te[193],ne([0,1,72,152,5,27,3,2,17,4,30,11,8,26,90,192]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(g,l,u){this.logService=g,this.productService=l,this.environmentService=u,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(g){const l=`window: ${g.reply.windowId}, moduleId: ${g.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${l})`);const u=(0,h.hash)(g);this.processeDisposables.has(u)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${l})`),this.doDisposeWorker(g));const r=new L.CancellationTokenSource;let a,n,t;this.processeDisposables.set(u,d=>{r.dispose(!0),a?.terminate(g,L.CancellationToken.None),n?.close(),t?.close(),this.processeDisposables.delete(u);const p=this.processResolvers.get(u);p&&(this.processResolvers.delete(u),p({reason:d}))}),a=await this.getOrCreateWebWorker(g);const s=new Promise(d=>{this.processResolvers.set(u,d)});if(r.token.isCancellationRequested)return s;const{port1:o,port2:c}=new MessageChannel;return n=o,t=c,await a.spawn(g,t,r.token),r.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${l})`),T.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",g,[n])),s}getOrCreateWebWorker(g){let l=this.workers.get(g.process.moduleId);if(!l){this.logService.trace(`SharedProcess: creating new web worker (${g.process.moduleId})`);const u=new m(g.process.type,this.logService,this.productService,this.environmentService);l=u.init(),u.onDidProcessSelfTerminate(({configuration:r,reason:a})=>{this.doDisposeWorker(r,a)}),this.workers.set(g.process.moduleId,l)}return l}async disposeWorker(g){return this.doDisposeWorker(g)}doDisposeWorker(g,l){const u=this.processeDisposables.get((0,h.hash)(g));u&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${g.reply.windowId}, moduleId: ${g.process.moduleId})`),u(l))}};v=de([J(0,f.ILogService),J(1,S.IProductService),J(2,E.INativeEnvironmentService)],v),e.SharedProcessWorkerService=v;class m extends R.Disposable{constructor(g,l,u,r){super();this.type=g,this.logService=l,this.productService=u,this.environmentService=r,this._onDidProcessSelfTerminate=this._register(new i.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const g=new k.DeferredPromise,l=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return l.onerror=u=>{this.logService.error(`SharedProcess: worker error (${this.type})`,u.message)},l.onmessageerror=u=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,u)},l.onmessage=u=>{const{id:r,message:a,configuration:n,nonce:t}=u.data;switch(r){case y.SharedProcessWorkerMessages.Ready:g.complete(l);break;case y.SharedProcessWorkerMessages.Ack:if(t){const s=this.mapMessageNonceToPendingMessageResolve.get(t);s&&(this.mapMessageNonceToPendingMessageResolve.delete(t),s())}break;case y.SharedProcessWorkerMessages.SelfTerminated:n&&a&&this._onDidProcessSelfTerminate.fire({configuration:n,reason:JSON.parse(a)});break;case y.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Info:a&&this.logService.info(a);break;case y.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,a);break;case y.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,a);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,u)}},l.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),g.p}async send(g,l,u){const r=await this.workerReady;if(!l.isCancellationRequested)return new Promise(a=>{const n=(0,I.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(n,a);const t={...g,nonce:n};u?r.postMessage(t,[u]):r.postMessage(t),l.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(n)&&a()})})}spawn(g,l,u){const r={id:y.SharedProcessWorkerMessages.Spawn,configuration:g,environment:this.getSharedProcessWorkerEnvironment()};return this.send(r,u,l)}getSharedProcessWorkerEnvironment(){const g={bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,env:Object.create(null)};if(C.isLinux){const l={companyName:this.productService.crashReporter?.companyName||"Microsoft",productName:this.productService.crashReporter?.productName||this.productService.nameShort,submitURL:"",uploadToServer:!1},u=this.environmentService.args["crash-reporter-id"],r=this.productService.appCenter;if(!this.environmentService.args["crash-reporter-directory"]&&r&&u&&(0,I.isUUID)(u)){const t=r["linux-x64"];l.submitURL=t.concat("&uid=",u,"&iid=",u,"&sid=",u),l.uploadToServer=!0}const n=this.environmentService.args["crash-reporter-directory"]||this.environmentService.userDataPath;g.env.BREAKPAD_DUMP_LOCATION=(0,_.join)(n,this.type),g.env.VSCODE_CRASH_REPORTER_START_OPTIONS=JSON.stringify(l)}return g}terminate(g,l){const u={id:y.SharedProcessWorkerMessages.Terminate,configuration:g};return this.send(u,l)}}}),define(te[91],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,T.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[194],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class T{constructor(){this.validators=new Map}vsda(){return new Promise((k,L)=>Q(["vsda"],k,L))}async createNewMessage(k){try{const L=await this.vsda(),i=new L.validator;if(i){const R=String(T._nextId++);return this.validators.set(R,i),{id:R,data:i.createNewMessage(k)}}}catch(L){}return{id:"",data:k}}async validate(k,L){if(!k.id)return!0;const i=this.validators.get(k.id);if(!i)return!1;this.validators.delete(k.id);try{return i.validate(L)==="ok"}catch(R){return!1}}async sign(k){try{const L=await this.vsda(),i=new L.signer;if(i)return i.sign(k)}catch(L){}return k}}e.SignService=T,T._nextId=1}),define(te[23],ne([0,1,5,3,2,176,15,73,6]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var I;(function(v){v[v.NONE=0]="NONE",v[v.SHUTDOWN=1]="SHUTDOWN"})(I=e.WillSaveStateReason||(e.WillSaveStateReason={}));var E;(function(v){v[v.GLOBAL=0]="GLOBAL",v[v.WORKSPACE=1]="WORKSPACE"})(E=e.StorageScope||(e.StorageScope={}));var f;(function(v){v[v.USER=0]="USER",v[v.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class S extends k.Disposable{constructor(m={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new _.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new _.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new _.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,w){w===C?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:w,target:this.getKeyTargets(m)[w]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,w,g){return this.getStorage(w)?.get(m,g)}getBoolean(m,w,g){return this.getStorage(w)?.getBoolean(m,g)}getNumber(m,w,g){return this.getStorage(w)?.getNumber(m,g)}store(m,w,g,l){if((0,i.isUndefinedOrNull)(w)){this.remove(m,g);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,g,l),this.getStorage(g)?.set(m,w)})}remove(m,w){this.withPausedEmitters(()=>{this.updateKeyTarget(m,w,void 0),this.getStorage(w)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,w){const g=[],l=this.getKeyTargets(m);for(const u of Object.keys(l))l[u]===w&&g.push(u);return g}updateKeyTarget(m,w,g){const l=this.getKeyTargets(w);typeof g=="number"?l[m]!==g&&(l[m]=g,this.getStorage(w)?.set(C,JSON.stringify(l))):typeof l[m]=="number"&&(delete l[m],this.getStorage(w)?.set(C,JSON.stringify(l)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const w=this.get(C,m);if(w)try{return JSON.parse(w)}catch(g){}return Object.create(null)}isNew(m){return this.getBoolean(e.IS_NEW_KEY,m)===!0}async flush(m=I.NONE){this._onWillSaveState.fire({reason:m});const w=this.getStorage(0),g=this.getStorage(1);switch(m){case I.NONE:await T.Promises.settled([w?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve()]);break;case I.SHUTDOWN:await T.Promises.settled([w?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,w=this.getStorage(1)?.items??new Map;return y(m,w,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class h extends S{constructor(){super();this.globalStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new R.Storage(new R.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}e.InMemoryStorageService=h;async function y(v,m,w,g){const l=o=>{try{return JSON.parse(o)}catch(c){return o}},u=new Map,r=new Map;v.forEach((o,c)=>{u.set(c,o),r.set(c,l(o))});const a=new Map,n=new Map;m.forEach((o,c)=>{a.set(c,o),n.set(c,l(o))}),console.group(`Storage: Global (path: ${w})`);let t=[];u.forEach((o,c)=>{t.push({key:c,value:o})}),console.table(t),console.groupEnd(),console.log(r),console.group(`Storage: Workspace (path: ${g})`);let s=[];a.forEach((o,c)=>{s.push({key:c,value:o})}),console.table(s),console.groupEnd(),console.log(n)}e.logStorage=y}),define(te[195],ne([0,1,3,2,15,29,34,23]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let b=class extends _.Disposable{constructor(E,f){super();this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new C(E)),this._register(this.storageManger.onDidChange(S=>this._onDidChangeEnablement.fire({extensions:S,source:"storage"}))),this._register(f.onDidInstallExtensions(S=>S.forEach(({local:h,operation:y})=>{h&&y===4&&this._removeFromDisabledExtensions(h.identifier)})))}async enableExtension(E,f){return this._removeFromDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}async disableExtension(E,f){return this._addToDisabledExtensions(E)?(this._onDidChangeEnablement.fire({extensions:[E],source:f}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(E){let f=this.getDisabledExtensions();return f.every(S=>!(0,i.areSameExtensions)(S,E))?(f.push(E),this._setDisabledExtensions(f),!0):!1}_removeFromDisabledExtensions(E){let f=this.getDisabledExtensions();for(let S=0;S<f.length;S++){const h=f[S];if((0,i.areSameExtensions)(h,E))return f.splice(S,1),this._setDisabledExtensions(f),!0}return!1}_setDisabledExtensions(E){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,E)}_getExtensions(E){return this.storageManger.get(E,0)}_setExtensions(E,f){this.storageManger.set(E,f,0)}};b=de([J(0,R.IStorageService),J(1,L.IExtensionManagementService)],b),e.GlobalExtensionEnablementService=b;class C extends _.Disposable{constructor(E){super();this.storageService=E,this.storage=Object.create(null),this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this._register(E.onDidChangeValue(f=>this.onDidStorageChange(f)))}get(E,f){let S;return f===0?((0,k.isUndefinedOrNull)(this.storage[E])&&(this.storage[E]=this._get(E,f)),S=this.storage[E]):S=this._get(E,f),JSON.parse(S)}set(E,f,S){let h=JSON.stringify(f.map(({id:v,uuid:m})=>({id:v,uuid:m})));this._get(E,S)!==h&&(S===0&&(f.length?this.storage[E]=h:delete this.storage[E]),this._set(E,f.length?h:void 0,S))}onDidStorageChange(E){if(E.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[E.key])&&this._get(E.key,E.scope)!==this.storage[E.key]){const S=this.get(E.key,E.scope);delete this.storage[E.key];const h=this.get(E.key,E.scope),y=S.filter(m=>!h.some(w=>(0,i.areSameExtensions)(m,w))),v=h.filter(m=>!S.some(w=>(0,i.areSameExtensions)(w,m)));(y.length||v.length)&&this._onDidChange.fire([...y,...v])}}_get(E,f){return this.storageService.get(E,f,"[]")}_set(E,f,S){f?this.storageService.store(E,f,S,1):this.storageService.remove(E,S)}}e.StorageManager=C}),define(te[196],ne([0,1,3,2]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class k extends _.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I}async getItems(){const C={workspace:this.workspace},I=await this.channel.call("getItems",C);return new Map(I)}updateItems(C){const I={workspace:this.workspace};return C.insert&&(I.insert=Array.from(C.insert.entries())),C.delete&&(I.delete=Array.from(C.delete.values())),this.channel.call("updateItems",I)}}class L extends k{constructor(C){super(C,void 0);this._onDidChangeItemsExternal=this._register(new T.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(C=>this.onDidChangeGlobalStorage(C)))}onDidChangeGlobalStorage(C){(Array.isArray(C.changed)||Array.isArray(C.deleted))&&this._onDidChangeItemsExternal.fire({changed:C.changed?new Map(C.changed):void 0,deleted:C.deleted?new Set(C.deleted):void 0})}async close(){this.dispose()}}class i extends k{constructor(C,I){super(C,I);this.onDidChangeItemsExternal=T.Event.None}async close(){const C={workspace:this.workspace};return this.channel.call("close",C)}}class R extends _.Disposable{constructor(C,I){super();this.channel=C,this.workspace=I,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new L(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new i(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=R}),define(te[197],ne([0,1,5,2,18,73,23,196]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class b extends i.AbstractStorageService{constructor(I,E,f){super();this.mainProcessService=E,this.environmentService=f,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new _.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(I)}createGlobalStorage(){const I=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),E=new L.Storage(I.globalStorage);return this._register(E.onDidChangeStorage(f=>this.emitDidChangeValue(0,f))),E}createWorkspaceStorage(I){const E=new R.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),I);if(E.workspaceStorage){const f=new L.Storage(E.workspaceStorage);return this.workspaceStorageDisposable.value=f.onDidChangeStorage(S=>this.emitDidChangeValue(1,S)),this.workspaceStorageId=I?.id,f}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){await T.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(i.WillSaveStateReason.SHUTDOWN),await T.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(I){const E=this.workspaceStorage,f=E?.items??new Map;E&&(await E.close(),E.dispose()),this.workspaceStorage=this.createWorkspaceStorage(I),await this.workspaceStorage.init();for(const[S,h]of f)this.workspaceStorage.set(S,h)}}e.NativeStorageService=b}),define(te[198],ne([0,1,4,32,7,30]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function i(C){if(T.platform===2&&/^penguin(\.|$)/i.test(C))return"chromebook"}async function R(C,I,E,f,S,h,y,v,m,w){const g=Object.create(null);g["common.machineId"]=y,g.sessionID=(0,L.generateUuid)()+Date.now(),g.commitHash=S,g.version=h,g["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,T.PlatformToString)(T.platform),g["common.nodePlatform"]=_.platform,g["common.nodeArch"]=f,g["common.product"]=w||"desktop";const l=b(v||[]);l&&(g["common.msftInternal"]=l);let u=0;const r=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),T.isLinuxSnap&&(g["common.snap"]="true");const a=i(E);a&&(g["common.platformDetail"]=a);try{const n=await C.readFile(k.URI.file(m));g["common.source"]=n.value.toString().slice(0,30)}catch(n){}return g}e.resolveCommonProperties=R;function b(C){const I=_.env.USERDNSDOMAIN;if(!I)return!1;const E=I.toLowerCase();return C.some(f=>E===f)}e.verifyMicrosoftInternalDomain=b}),define(te[22],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,T.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var _;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(_=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(te[199],ne([0,1,33,52,5,31,17,9,4,7,112,20,115,78,14,26,22]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function m(r,a){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let t;const s=T.homedir().toLowerCase();switch(process.platform){case"win32":t=[{tag:"gdrive",matcher:A=>/^[a-z]:\\(my drive|shared drives)\\/.test(A)||A.startsWith(s+"\\my drive\\")},{tag:"dropbox",matcher:A=>A.startsWith(s+"\\dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"\\onedrive")},{tag:"box",matcher:A=>A.startsWith(s+"\\box\\")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"\\nextcloud\\")},{tag:"owncloud",matcher:A=>A.startsWith(s+"\\owncloud\\")}];break;case"darwin":t=[{tag:"gdrive",matcher:A=>A.startsWith("/volumes/googledrive/")||A.startsWith(s+"/my drive/")},{tag:"dropbox",matcher:A=>A.startsWith(s+"/dropbox")},{tag:"onedrive",matcher:A=>A.startsWith(s+"/onedrive")||A.startsWith(s+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:A=>A.startsWith(s+"/library/mobile documents/")},{tag:"box",matcher:A=>A.startsWith(s+"/box/")},{tag:"nextcloud",matcher:A=>A.startsWith(s+"/nextcloud/")},{tag:"owncloud",matcher:A=>A.startsWith(s+"/owncloud/")}];break}const o=new Map,c=new Map,d=2e4;function p(A,N,$,D){for(const M of t){const U=A.toLowerCase();M.matcher(U)&&c.set(M.tag,1)}const F=N.substring(A.length+1);return k.Promises.withAsyncBody(async M=>{let U;try{U=await E.Promises.readdir(N,{withFileTypes:!0})}catch(V){M();return}if(D.count>=d){D.count+=U.length,D.maxReached=!0,M();return}let G=U.length;if(G===0){M();return}let ee=U;D.count+U.length>d&&(D.maxReached=!0,G=d-D.count,ee=U.slice(0,G)),D.count+=U.length;for(const V of ee)if(V.isDirectory()){if($.includes(V.name)||await p(A,(0,R.join)(N,V.name),$,D),--G==0){M();return}}else{const j=V.name.lastIndexOf(".");if(j>=0){const Z=V.name.substring(j+1);Z&&o.set(Z,(o.get(Z)??0)+1)}for(const Z of n)Z.relativePathPattern?.test(F)!==!1&&Z.filePattern.test(V.name)&&c.set(Z.tag,(c.get(Z.tag)??0)+1);if(--G==0){M();return}}})}const P={count:0,maxReached:!1};await p(r,r,a,P);const O=await l(r);return{configFiles:w(c),fileTypes:w(o),fileCount:P.count,maxFilesReached:P.maxReached,launchConfigFiles:O}}e.collectWorkspaceStats=m;function w(r){return[..._.Iterable.map(r.entries(),([a,n])=>({name:a,count:n}))].sort((a,n)=>n.count-a.count)}function g(){const r={os:`${T.type()} ${T.arch()} ${T.release()}`,memory:`${(T.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(I.virtualMachineHint.value()*100)}%`},a=T.cpus();return a&&a.length>0&&(r.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),r}e.getMachineInfo=g;async function l(r){try{const a=new Map,n=(0,R.join)(r,".vscode","launch.json"),t=await E.Promises.readFile(n),s=[],o=(0,L.parse)(t.toString(),s);if(s.length)return console.log(`Unable to parse ${n}`),[];if((0,L.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const d=c.type;d&&(a.has(d)?a.set(d,a.get(d)+1):a.set(d,1))}return w(a)}catch(a){return[]}}e.collectLaunchConfigs=l;let u=class{constructor(a,n){this.telemetryService=a,this.productService=n}formatMachineInfo(a){const n=[];return n.push(`OS Version:       ${a.os}`),n.push(`CPUs:             ${a.cpus}`),n.push(`Memory (System):  ${a.memory}`),n.push(`VM:               ${a.vmHint}`),n.join(`
`)}formatEnvironment(a){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${T.type()} ${T.arch()} ${T.release()}`);const t=T.cpus();return t&&t.length>0&&n.push(`CPUs:             ${t[0].model} (${t.length} x ${t[0].speed})`),n.push(`Memory (System):  ${(T.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(T.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),b.isWindows||n.push(`Load (avg):       ${T.loadavg().map(s=>Math.round(s)).join(", ")}`),n.push(`VM:               ${Math.round(I.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${a.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(a.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(a,n){return Promise.all([(0,f.listProcesses)(a.mainPID),this.formatWorkspaceMetadata(a)]).then(async t=>{let[s,o]=t,c=this.formatProcessList(a,s);return n.forEach(d=>{if((0,S.isRemoteDiagnosticError)(d))c+=`
${d.errorMessage}`,o+=`
${d.errorMessage}`;else if(c+=`

Remote: ${d.hostName}`,d.processes&&(c+=`
${this.formatProcessList(a,d.processes)}`),d.workspaceMetadata){o+=`
|  Remote: ${d.hostName}`;for(const p of Object.keys(d.workspaceMetadata)){const P=d.workspaceMetadata[p];let O=`${P.fileCount} files`;P.maxFilesReached&&(O=`more than ${O}`),o+=`|    Folder (${p}): ${O}`,o+=this.formatWorkspaceStats(P)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(a,n){const{memory:t,vmHint:s,os:o,cpus:c}=g(),d={os:o,memory:t,cpus:c,vmHint:s,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:n};return b.isWindows||(d.load=`${T.loadavg().map(p=>Math.round(p)).join(", ")}`),b.isLinux&&(d.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(d)}async getDiagnostics(a,n){const t=[];return(0,f.listProcesses)(a.mainPID).then(async s=>(t.push(""),t.push(this.formatEnvironment(a)),t.push(""),t.push(this.formatProcessList(a,s)),a.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(t.push(""),t.push("Workspace Stats: "),t.push(await this.formatWorkspaceMetadata(a))),n.forEach(o=>{if((0,S.isRemoteDiagnosticError)(o))t.push(`
${o.errorMessage}`);else if(t.push(`

`),t.push(`Remote:           ${o.hostName}`),t.push(this.formatMachineInfo(o.machineInfo)),o.processes&&t.push(this.formatProcessList(a,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const d=o.workspaceMetadata[c];let p=`${d.fileCount} files`;d.maxFilesReached&&(p=`more than ${p}`),t.push(`Folder (${c}): ${p}`),t.push(this.formatWorkspaceStats(d))}}),t.push(""),t.push(""),t.join(`
`)))}formatWorkspaceStats(a){const n=[],t=60;let s=0;const o=(P,O)=>{const A=` ${P}(${O})`;s+A.length>t?(n.push(c),c="|                 ",s=c.length):s+=A.length,c+=A};let c="|      File types:";const d=10;let p=a.fileTypes.length>d?d:a.fileTypes.length;for(let P=0;P<p;P++){const O=a.fileTypes[P];o(O.name,O.count)}if(n.push(c),a.configFiles.length>=0&&(c="|      Conf files:",s=0,a.configFiles.forEach(P=>{o(P.name,P.count)}),n.push(c)),a.launchConfigFiles.length>0){let P="|      Launch Configs:";a.launchConfigFiles.forEach(O=>{P+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),n.push(P)}return n.join(`
`)}expandGPUFeatures(a){const n=Math.max(...Object.keys(a).map(t=>t.length));return Object.keys(a).map(t=>`${t}:  ${" ".repeat(n-t.length)}  ${a[t]}`).join(`
                  `)}formatWorkspaceMetadata(a){const n=[],t=[];return a.windows.forEach(s=>{s.folderURIs.length===0||!!s.remoteAuthority||(n.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=C.URI.revive(o);if(c.scheme===i.Schemas.file){const d=c.fsPath;t.push(m(d,["node_modules",".git"]).then(p=>{let P=`${p.fileCount} files`;p.maxFilesReached&&(P=`more than ${P}`),n.push(`|    Folder (${(0,R.basename)(d)}): ${P}`),n.push(this.formatWorkspaceStats(p))}).catch(p=>{n.push(`|      Error: Unable to collect workspace stats for folder ${d} (${p.toString()})`)}))}else n.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(t).then(s=>n.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}formatProcessList(a,n){const t=new Map;a.windows.forEach(o=>t.set(o.pid,o.title));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(a.mainPID,t,s,n,0),s.join(`
`)}formatProcessItem(a,n,t,s,o){const c=o===0;let d;c?d=s.pid===a?`${this.productService.applicationName} main`:"remote agent":(d=`${"  ".repeat(o)} ${s.name}`,s.name==="window"&&(d=`${d} (${n.get(s.pid)})`));const p=process.platform==="win32"?s.mem:T.totalmem()*(s.mem/100);t.push(`${s.load.toFixed(0).padStart(5," ")}	${(p/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${d}`),Array.isArray(s.children)&&s.children.forEach(P=>this.formatProcessItem(a,n,t,P,o+1))}async reportWorkspaceStats(a){for(const{uri:n}of a.folders){const t=C.URI.revive(n);if(t.scheme!==i.Schemas.file)continue;const s=t.fsPath;try{const o=await m(s,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),o.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};u=de([J(0,v.ITelemetryService),J(1,y.IProductService)],u),e.DiagnosticsService=u}),define(te[200],ne([0,1,16,5,27,10,3,2,4,15,7,129,29,34,8,26,22]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let m=class extends R.Disposable{constructor(a,n,t,s){super();this.galleryService=a,this.telemetryService=n,this.logService=t,this.productService=s,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new i.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new i.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new i.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new i.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,R.toDisposable)(()=>{this.installingExtensions.forEach(o=>o.cancel()),this.uninstallingExtensions.forEach(o=>o.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(a){const n=await this.getTargetPlatform();return a.allTargetPlatforms.some(t=>(0,f.isTargetPlatformCompatible)(t,a.allTargetPlatforms,n))}async installFromGallery(a,n={}){try{if(!this.galleryService.isEnabled())throw new f.ExtensionManagementError(E.localize(0,null),f.ExtensionManagementErrorCode.Internal);const t=await this.checkAndGetCompatibleVersion(a,!n.installGivenVersion,!!n.installPreReleaseVersion);return await this.installExtension(t.manifest,t.extension,n)}catch(t){throw l(this.telemetryService,"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(a),void 0,t),this.logService.error("Failed to install extension.",a.identifier.id),this.logService.error(t),g(t)}}async migrateUnsupportedExtensions(){try{const a=await this.getExtensionsControlManifest();if(!a.unsupportedPreReleaseExtensions)return;const n=await this.getInstalled(1);for(const[t,s]of Object.entries(a.unsupportedPreReleaseExtensions)){const o=n.find(p=>(0,S.areSameExtensions)(p.identifier,{id:t}));if(!o)continue;const c=await this.galleryService.getCompatibleExtension({id:s.id},!0,await this.getTargetPlatform());if(!c){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the comaptible target '${s.id}' extension is not found`);continue}const d=await this.galleryService.getManifest(c,k.CancellationToken.None);if(!d){this.logService.info(`Skipping migrating '${o.identifier.id}' extension because, the manifest for '${s.id}' extension is not found`);continue}try{this.logService.info(`Migrating '${o.identifier.id}' extension to '${s.id}' extension...`),await Promise.allSettled([this.uninstall(o),this.installExtension(d,c,{installPreReleaseVersion:!0,isMachineScoped:o.isMachineScoped,operation:4})]),this.logService.info(`Migrated '${o.identifier.id}' extension to '${s.id}' extension.`)}catch(p){this.logService.error(p)}}}catch(a){this.logService.error(a)}}async uninstall(a,n={}){return this.logService.trace("ExtensionManagementService#uninstall",a.identifier.id),this.unininstallExtension(a,n)}async reinstallFromGallery(a){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",a.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const n=await this.findGalleryExtension(a);if(!n)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(a,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(n)}getExtensionsControlManifest(){const a=new Date().getTime();return(!this.extensionsControlManifest||a-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=a),this.extensionsControlManifest}registerParticipant(a){this.participants.push(a)}async installExtension(a,n,t){if(!I.URI.isUri(n)){let p=this.installingExtensions.get(new S.ExtensionIdentifierWithVersion(n.identifier,n.version).key());if(p)return this.logService.info("Extensions is already requested to install",n.identifier.id),p.waitUntilTaskIsFinished();t={...t,installOnlyNewlyAddedFromExtensionPack:!0}}const s=[],o=[],c=this.createInstallExtensionTask(a,n,t);I.URI.isUri(n)||this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(c.identifier,a.version).key(),c),this._onInstallExtension.fire({identifier:c.identifier,source:n}),this.logService.info("Installing extension:",c.identifier.id),s.push({task:c,manifest:a});let d=!1;try{if(t.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",c.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(c.identifier,a,!!t.installOnlyNewlyAddedFromExtensionPack,!!t.installPreReleaseVersion);for(const{gallery:O,manifest:A}of P)if(d=d||!!A.extensionDependencies?.some(N=>(0,S.areSameExtensions)({id:N},c.identifier)),this.installingExtensions.has(new S.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const N=this.createInstallExtensionTask(A,O,{...t,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new S.ExtensionIdentifierWithVersion(N.identifier,A.version).key(),N),this._onInstallExtension.fire({identifier:N.identifier,source:O}),this.logService.info("Installing extension:",N.identifier.id),s.push({task:N,manifest:A})}}catch(P){if(I.URI.isUri(c.source))(0,T.isNonEmptyArray)(a.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",c.identifier.id,P.message),(0,T.isNonEmptyArray)(a.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",c.identifier.id,P.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",c.identifier.id),P}const p=s.reduce((P,{task:O,manifest:A})=>(P.set(O.identifier.id.toLowerCase(),{task:O,manifest:A}),P),new Map);for(;p.size;){let P;const O=[...p.values()].filter(({manifest:A})=>!A.extensionDependencies?.some(N=>p.has(N.toLowerCase())));O.length?P=p.size===1?O:O.filter(({task:A})=>!(A===c&&!d)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:A})=>A.identifier.id)),P=[...p.values()]),await this.joinAllSettled(P.map(async({task:A})=>{const N=new Date().getTime(),$=(0,C.isUndefined)(t.operation)?A.operation:t.operation;try{const D=await A.run();if(await this.joinAllSettled(this.participants.map(F=>F.postInstall(D,A.source,t,k.CancellationToken.None))),!I.URI.isUri(A.source)&&(l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,void 0),b.isWeb&&$!==3))try{await this.galleryService.reportStatistic(D.manifest.publisher,D.manifest.name,D.manifest.version,"install")}catch(F){}o.push({local:D,identifier:A.identifier,operation:$,source:A.source})}catch(D){throw I.URI.isUri(A.source)||l(this.telemetryService,$===3?"extensionGallery:update":"extensionGallery:install",(0,S.getGalleryExtensionTelemetryData)(A.source),new Date().getTime()-N,D),this.logService.error("Error while installing the extension:",A.identifier.id),D}finally{p.delete(A.identifier.id.toLowerCase())}}))}return o.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(o),o.filter(({identifier:P})=>(0,S.areSameExtensions)(P,c.identifier))[0].local}catch(p){if(s.forEach(({task:P})=>P.cancel()),o.length)try{const P=await Promise.allSettled(o.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<P.length;O++){const A=P[O],{identifier:N}=o[O];A.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,L.getErrorMessage)(A.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(P),o.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(s.map(({task:P})=>({identifier:P.identifier,operation:2,source:P.source}))),p}finally{for(const{task:p,manifest:P}of s)if(!I.URI.isUri(p.source)){const O=new S.ExtensionIdentifierWithVersion(p.identifier,P.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(a){const n=[],t=[],s=await Promise.allSettled(a);for(const o of s)o.status==="fulfilled"?n.push(o.value):t.push(o.reason);if(t.length)throw w(t);return n}async getAllDepsAndPackExtensionsToInstall(a,n,t,s){if(!this.galleryService.isEnabled())return[];let o=await this.getInstalled();const c=[a,...o.map(P=>P.identifier)],d=[],p=async(P,O)=>{const A=O.extensionDependencies||[],N=[...A];if(O.extensionPack){const $=t?o.find(D=>(0,S.areSameExtensions)(D.identifier,P)):void 0;for(const D of O.extensionPack)$&&$.manifest.extensionPack&&$.manifest.extensionPack.some(F=>(0,S.areSameExtensions)({id:F},{id:D}))||N.every(F=>!(0,S.areSameExtensions)({id:F},{id:D}))&&N.push(D)}if(N.length){const $=[...c,...d.map(F=>F.gallery.identifier)],D=N.filter(F=>$.every(M=>!(0,S.areSameExtensions)(M,{id:F})));if(D.length){const F=await this.galleryService.query({names:D,pageSize:N.length},k.CancellationToken.None);for(const M of F.firstPage){if($.find(ee=>(0,S.areSameExtensions)(ee,M.identifier)))continue;const U=A.some(ee=>(0,S.areSameExtensions)({id:ee},M.identifier));let G;try{G=await this.checkAndGetCompatibleVersion(M,!0,s)}catch(ee){if(ee instanceof f.ExtensionManagementError&&ee.code===f.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!U){this.logService.info("Skipping the packed extension as it cannot be installed",M.identifier.id);continue}else throw ee}d.push({gallery:G.extension,manifest:G.manifest}),await p(G.extension.identifier,O)}}}};return await p(a,n),o=await this.getInstalled(),d.filter(P=>!o.some(O=>(0,S.areSameExtensions)(O.identifier,P.gallery.identifier)))}async checkAndGetCompatibleVersion(a,n,t){const s=await this.getExtensionsControlManifest();if((0,S.getMaliciousExtensionsSet)(s).has(a.identifier.id))throw new f.ExtensionManagementError(E.localize(3,null,a.identifier.id),f.ExtensionManagementErrorCode.Malicious);if(!!s.unsupportedPreReleaseExtensions&&!!s.unsupportedPreReleaseExtensions[a.identifier.id])throw new f.ExtensionManagementError(E.localize(4,null,a.identifier.id,s.unsupportedPreReleaseExtensions[a.identifier.id].displayName),f.ExtensionManagementErrorCode.UnsupportedPreRelease);if(!await this.canInstall(a)){const d=await this.getTargetPlatform();throw new f.ExtensionManagementError(E.localize(5,null,a.identifier.id,this.productService.nameLong,(0,f.TargetPlatformToString)(d)),f.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const o=await this.getCompatibleVersion(a,n,t);if(o){if(t&&a.hasPreReleaseVersion&&!o.properties.isPreReleaseVersion)throw new f.ExtensionManagementError(E.localize(6,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new f.ExtensionManagementError(E.localize(7,null,a.identifier.id,this.productService.nameLong,this.productService.version),f.ExtensionManagementErrorCode.Incompatible);const c=await this.galleryService.getManifest(o,k.CancellationToken.None);if(c===null)throw new f.ExtensionManagementError(`Missing manifest for extension ${a.identifier.id}`,f.ExtensionManagementErrorCode.Invalid);if(c.version!==o.version)throw new f.ExtensionManagementError(`Cannot install '${a.identifier.id}' extension because of version mismatch in Marketplace`,f.ExtensionManagementErrorCode.Invalid);return{extension:o,manifest:c}}async getCompatibleVersion(a,n,t){const s=await this.getTargetPlatform();let o=null;return n&&a.hasPreReleaseVersion&&a.properties.isPreReleaseVersion!==t&&(o=await this.galleryService.getCompatibleExtension(a.identifier,t,s)),!o&&await this.galleryService.isExtensionCompatible(a,t,s)&&(o=a),!o&&n&&(o=await this.galleryService.getCompatibleExtension(a,t,s)),o}async unininstallExtension(a,n){const t=this.uninstallingExtensions.get(a.identifier.id.toLowerCase());if(t)return this.logService.info("Extensions is already requested to uninstall",a.identifier.id),t.waitUntilTaskIsFinished();const s=(p,P)=>{const O=this.createUninstallExtensionTask(p,P);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",p.identifier.id),this._onUninstallExtension.fire(p.identifier),O},o=(p,P)=>{P?this.logService.error("Failed to uninstall extension:",p.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",p.identifier.id),l(this.telemetryService,"extensionGallery:uninstall",(0,S.getLocalExtensionTelemetryData)(p),void 0,P),this._onDidUninstallExtension.fire({identifier:p.identifier,error:P?.code})},c=[],d=[];try{c.push(s(a,{}));const p=await this.getInstalled(1);if(n.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",a.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(a,p);for(const O of P)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):c.push(s(O,{}))}n.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",a.identifier.id):this.checkForDependents(c.map(P=>P.extension),p,a),await this.joinAllSettled(c.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(P.extension,n,k.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch(O){}o(P.extension)}catch(O){const A=O instanceof f.ExtensionManagementError?O:new f.ExtensionManagementError((0,L.getErrorMessage)(O),f.ExtensionManagementErrorCode.Internal);throw o(P.extension,A),A}finally{d.push(P)}}))}catch(p){const P=p instanceof f.ExtensionManagementError?p:new f.ExtensionManagementError((0,L.getErrorMessage)(p),f.ExtensionManagementErrorCode.Internal);for(const O of c){try{O.cancel()}catch(A){}d.includes(O)||o(O.extension,P)}throw P}finally{for(const p of c)this.uninstallingExtensions.delete(p.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",p.extension.identifier.id)}}checkForDependents(a,n,t){for(const s of a){const o=this.getDependents(s,n);if(o.length){const c=o.filter(d=>!a.some(p=>(0,S.areSameExtensions)(p.identifier,d.identifier)));if(c.length)throw new Error(this.getDependentsErrorMessage(s,c,t))}}}getDependentsErrorMessage(a,n,t){return t===a?n.length===1?E.localize(8,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(9,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(10,null,t.manifest.displayName||t.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?E.localize(11,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?E.localize(12,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):E.localize(13,null,t.manifest.displayName||t.manifest.name,a.manifest.displayName||a.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}getAllPackExtensionsToUninstall(a,n,t=[]){if(t.indexOf(a)!==-1)return[];t.push(a);const s=a.manifest.extensionPack?a.manifest.extensionPack:[];if(s.length){const o=n.filter(d=>!d.isBuiltin&&s.some(p=>(0,S.areSameExtensions)({id:p},d.identifier))),c=[];for(const d of o)c.push(...this.getAllPackExtensionsToUninstall(d,n,t));return[...o,...c]}return[]}getDependents(a,n){return n.filter(t=>t.manifest.extensionDependencies&&t.manifest.extensionDependencies.some(s=>(0,S.areSameExtensions)({id:s},a.identifier)))}async findGalleryExtension(a){if(a.identifier.uuid){const n=await this.findGalleryExtensionById(a.identifier.uuid);return n||this.findGalleryExtensionByName(a.identifier.id)}return this.findGalleryExtensionByName(a.identifier.id)}async findGalleryExtensionById(a){return(await this.galleryService.query({ids:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(a){return(await this.galleryService.query({names:[a],pageSize:1},k.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const a=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",a),a}catch(a){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};m=de([J(0,f.IExtensionGalleryService),J(1,v.ITelemetryService),J(2,h.ILogService),J(3,y.IProductService)],m),e.AbstractExtensionManagementService=m;function w(r){const a=Array.isArray(r)?r:[r];return a.length===1?a[0]instanceof Error?a[0]:new Error(a[0]):a.reduce((n,t)=>new Error(`${n.message}${n.message?",":""}${t instanceof Error?t.message:t}`),new Error(""))}e.joinErrors=w;function g(r){if(r instanceof f.ExtensionManagementError)return r;const a=new f.ExtensionManagementError(r.message,f.ExtensionManagementErrorCode.Internal);return a.stack=r.stack,a}function l(r,a,n,t,s){const o=s?s instanceof f.ExtensionManagementError?s.code:f.ExtensionManagementErrorCode.Internal:void 0;r.publicLogError(a,{...n,success:!s,duration:t,errorcode:o})}e.reportTelemetry=l;class u{constructor(){this.barrier=new _.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>this.doRun(a))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,_.createCancelablePromise)(a=>new Promise((n,t)=>{const s=a.onCancellationRequested(()=>{s.dispose(),t((0,L.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=u}),define(te[201],ne([0,1,16,5,65,3,9,4,32,7,131,11,29,191,80,14,8,59,26,42,23,22]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const r="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";let n=class extends S.ExtensionTipsService{constructor(s,o,c,d,p,P,O,A,N,$){super(O,A,N,$);this.environmentService=s,this.telemetryService=o,this.extensionManagementService=c,this.storageService=d,this.nativeHostService=p,this.extensionRecommendationNotificationService=P,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,A.exeBasedExtensionTips&&(0,k.forEach)(A.exeBasedExtensionTips,({key:D,value:F})=>{const M=[],U=[],G=[];(0,k.forEach)(F.recommendations,({key:ee,value:V})=>{V.important?F.important?M.push({extensionId:ee,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):U.push({extensionId:ee,extensionName:V.name,isExtensionPack:!!V.isExtensionPack}):G.push({extensionId:ee,extensionName:V.name,isExtensionPack:!!V.isExtensionPack})}),M.length&&this.highImportanceExecutableTips.set(D,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:M}),U.length&&this.mediumImportanceExecutableTips.set(D,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:U}),G.length&&this.allOtherExecutableTips.set(D,{exeFriendlyName:F.friendlyName,windowsPath:F.windowsPath,recommendations:G})}),(0,_.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...s,...o]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const s=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),o=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),c=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(s,c),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(o,c)}groupImportantTipsByExe(s,o){const c=new Map;s.forEach(A=>c.set(A.extensionId.toLowerCase(),A));const{installed:d,uninstalled:p}=this.groupByInstalled([...c.keys()],o);for(const A of d){const N=c.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:A,exeName:N.exeName})}for(const A of p){const N=c.get(A);N&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:A,exeName:N.exeName})}const P=this.getPromptedExecutableTips(),O=new Map;for(const A of p){const N=c.get(A);if(N&&(!P[N.exeName]||!P[N.exeName].includes(N.extensionId))){let $=O.get(N.exeName);$||($=[],O.set(N.exeName,$)),$.push(N)}}return O}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[s,o]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(o).then(c=>{switch(c){case"reacted":this.addToRecommendedExecutables(o[0].exeName,o);break;case"ignored":this.highImportanceTipsByExe.delete(s);break;case"incompatibleWindow":const d=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(d(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const p=this._register((0,_.disposableTimeout)(()=>{p.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const s=this.getLastPromptedMediumExeTime(),o=Date.now()-s,c=7*24*60*60*1e3;if(o<c){const P=this._register((0,_.disposableTimeout)(()=>{P.dispose(),this.promptMediumImportanceExeBasedTip()},c-o));return}const[d,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(P=>{switch(P){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(d),this.addToRecommendedExecutables(p[0].exeName,p);const O=this._register((0,_.disposableTimeout)(()=>{O.dispose(),this.promptMediumImportanceExeBasedTip()},c));break;case"ignored":this.mediumImportanceTipsByExe.delete(d),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const A=L.Event.once(L.Event.latch(L.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(A(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const N=this._register((0,_.disposableTimeout)(()=>{N.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(s){const o=s.map(({extensionId:d})=>d.toLowerCase()),c=(0,I.localize)(0,null,s[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(o,c,`@exe:"${s[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let s=this.storageService.getNumber(a,0);return s||(s=Date.now(),this.updateLastPromptedMediumExeTime(s)),s}updateLastPromptedMediumExeTime(s){this.storageService.store(a,s,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(r,0,"{}"))}addToRecommendedExecutables(s,o){const c=this.getPromptedExecutableTips();c[s]=o.map(({extensionId:d})=>d.toLowerCase()),this.storageService.store(r,JSON.stringify(c),0,0)}groupByInstalled(s,o){const c=[],d=[],p=o.reduce((P,O)=>(P.add(O.identifier.id.toLowerCase()),P),new Set);return s.forEach(P=>{p.has(P.toLowerCase())?c.push(P):d.push(P)}),{installed:c,uninstalled:d}}async getValidExecutableBasedExtensionTips(s){const o=[],c=new Map;for(const d of s.keys()){const p=s.get(d);if(!p||!(0,T.isNonEmptyArray)(p.recommendations))continue;const P=[];R.isWindows?p.windowsPath&&P.push(p.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(P.push((0,i.join)("/usr/local/bin",d)),P.push((0,i.join)("/usr/bin",d)),P.push((0,i.join)(this.environmentService.userHome.fsPath,d)));for(const O of P){let A=c.get(O);if(A===void 0&&(A=await this.fileService.exists(C.URI.file(O)),c.set(O,A)),A)for(const{extensionId:N,extensionName:$,isExtensionPack:D}of p.recommendations)o.push({extensionId:N,extensionName:$,isExtensionPack:D,exeName:d,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath})}}return o}};n=de([J(0,E.INativeEnvironmentService),J(1,u.ITelemetryService),J(2,f.IExtensionManagementService),J(3,l.IStorageService),J(4,m.INativeHostService),J(5,h.IExtensionRecommendationNotificationService),J(6,y.IFileService),J(7,w.IProductService),J(8,g.IRequestService),J(9,v.ILogService)],n),e.ExtensionTipsService=n}),define(te[92],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class T{constructor(L){this.appenders=L}listen(L,i){throw new Error(`Event not found: ${i}`)}call(L,i,{eventName:R,data:b}){return this.appenders.forEach(C=>C.log(R,b)),Promise.resolve(null)}}e.TelemetryAppenderChannel=T;class _{constructor(L){this.channel=L}log(L,i){return this.channel.call("log",{eventName:L,data:i}).then(void 0,R=>`Failed to log telemetry: ${console.warn(R)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=_}),define(te[43],ne([0,1,28,15,21,22]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class i{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,w){return Promise.resolve(void 0)}publicLog2(m,w){return this.publicLog(m,w)}publicLogError(m,w){return Promise.resolve(void 0)}publicLogError2(m,w){return this.publicLogError(m,w)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=i,e.NullTelemetryService=new i;class R{async publicLog(m,w,g){}async publicLogError(m,w,g){}}e.NullEndpointTelemetryService=R,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function b(v,m){return m.onDidChangeConfiguration(w=>{w.source!==6&&v.publicLog2("updateConfiguration",{configurationSource:(0,k.ConfigurationTargetToString)(w.source),configurationKeys:h(w.sourceConfig)})})}e.configurationTelemetry=b;function C(v,m){return!(m.disableTelemetry||!v.enableTelemetry)}e.supportsTelemetry=C;function I(v){const m=v.getValue(L.TELEMETRY_SETTING_ID),w=v.getValue("telemetry.enableCrashReporter");if(v.getValue(L.TELEMETRY_OLD_SETTING_ID)===!1||w===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=I;function E(v){const m=Object.create(null),w=Object.create(null),g=Object.create(null);S(v,g);for(let l in g){l=l.length>150?l.substr(l.length-149):l;const u=g[l];typeof u=="number"?w[l]=u:typeof u=="boolean"?w[l]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${l} has been trimmed to 8192, the original length is ${u.length}`),m[l]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(m[l]=u)}return{properties:m,measurements:w}}e.validateTelemetryData=E;function f(v){if(!v)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(g=>{v.indexOf(`${g}+`)===0&&(m=g)}),m}e.cleanRemoteAuthority=f;function S(v,m,w=0,g){if(!!v)for(let l of Object.getOwnPropertyNames(v)){const u=v[l],r=g?g+l:l;Array.isArray(u)?m[r]=(0,T.safeStringify)(u):u instanceof Date?m[r]=u.toISOString():(0,_.isObject)(u)?w<2?S(u,m,w+1,r+"."):m[r]=(0,T.safeStringify)(u):m[r]=u}}function h(v){if(!v)return[];const m=[];return y(m,"",v),m}function y(v,m,w){w&&typeof w=="object"&&!Array.isArray(w)?Object.keys(w).forEach(g=>y(v,m?`${m}.${g}`:g,w[g])):v.push(m)}}),define(te[202],ne([0,1,43,149]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AssignmentService=e.BaseAssignmentService=void 0;class k{constructor(){}setSharedProperty(b,C){}postEvent(b,C){}}class L{constructor(b,C,I,E,f){this.getMachineId=b,this.configurationService=C,this.productService=I,this.telemetry=E,this.keyValueStorage=f,this.networkInitialized=!1,I.tasConfig&&this.experimentsEnabled&&(0,T.getTelemetryLevel)(this.configurationService)===3&&(this.tasClient=this.setupTASClient());const S=this.configurationService.getValue("experiments.overrideDelay"),h=typeof S=="number"?S:0;this.overrideInitDelay=new Promise(y=>setTimeout(y,h))}get experimentsEnabled(){return!0}async getTreatment(b){await this.overrideInitDelay;const C=this.configurationService.getValue("experiments.override."+b);if(C!==void 0)return C;if(!this.tasClient||!this.experimentsEnabled)return;let I;const E=await this.tasClient;return this.networkInitialized?I=E.getTreatmentVariable("vscode",b):I=await E.getTreatmentVariableAsync("vscode",b,!0),I=E.getTreatmentVariable("vscode",b),I}async setupTASClient(){const b=this.productService.quality==="stable"?_.TargetPopulation.Public:_.TargetPopulation.Insiders,C=await this.getMachineId(),I=new _.AssignmentFilterProvider(this.productService.version,this.productService.nameLong,C,b),E=this.productService.tasConfig,f=new(await new Promise((S,h)=>{Q(["tas-client-umd"],S,h)})).ExperimentationService({filterProviders:[I],telemetry:this.telemetry,storageKey:_.ASSIGNMENT_STORAGE_KEY,keyValueStorage:this.keyValueStorage,featuresTelemetryPropertyName:E.featuresTelemetryPropertyName,assignmentContextTelemetryPropertyName:E.assignmentContextTelemetryPropertyName,telemetryEventName:E.telemetryEventName,endpoint:E.endpoint,refetchInterval:_.ASSIGNMENT_REFETCH_INTERVAL});return await f.initializePromise,f.initialFetch.then(()=>this.networkInitialized=!0),f}}e.BaseAssignmentService=L;class i extends L{constructor(b,C,I){super(()=>Promise.resolve(b),C,I,new k)}}e.AssignmentService=i}),define(te[203],ne([0,1,16,27,10,28,4,32,15,7,21,11,29,34,76,14,8,26,42,45,23,22,43]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const a=i.isWeb?"web":(0,f.getTargetPlatform)(i.platform,R.arch);var n;(function(x){x[x.None=0]="None",x[x.IncludeVersions=1]="IncludeVersions",x[x.IncludeFiles=2]="IncludeFiles",x[x.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",x[x.IncludeSharedAccounts=8]="IncludeSharedAccounts",x[x.IncludeVersionProperties=16]="IncludeVersionProperties",x[x.ExcludeNonValidated=32]="ExcludeNonValidated",x[x.IncludeInstallationTargets=64]="IncludeInstallationTargets",x[x.IncludeAssetUri=128]="IncludeAssetUri",x[x.IncludeStatistics=256]="IncludeStatistics",x[x.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",x[x.Unpublished=4096]="Unpublished"})(n||(n={}));function t(...x){return String(x.reduce((K,re)=>K|re,0))}var s;(function(x){x[x.Tag=1]="Tag",x[x.ExtensionId=4]="ExtensionId",x[x.Category=5]="Category",x[x.ExtensionName=7]="ExtensionName",x[x.Target=8]="Target",x[x.Featured=9]="Featured",x[x.SearchText=10]="SearchText",x[x.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},p={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class P{constructor(K=p){this.state=K}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(K,re=this.state.pageSize){return new P({...this.state,pageNumber:K,pageSize:re})}withFilter(K,...re){const se=[...this.state.criteria,...re.length?re.map(ce=>({filterType:K,value:ce})):[{filterType:K}]];return new P({...this.state,criteria:se})}withSortBy(K){return new P({...this.state,sortBy:K})}withSortOrder(K){return new P({...this.state,sortOrder:K})}withFlags(...K){return new P({...this.state,flags:K.reduce((re,se)=>re|se,0)})}withAssetTypes(...K){return new P({...this.state,assetTypes:K})}get raw(){const{criteria:K,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he,flags:me,assetTypes:ye}=this.state;return{filters:[{criteria:K,pageNumber:re,pageSize:se,sortBy:ce,sortOrder:he}],assetTypes:ye,flags:me}}get searchText(){const K=this.state.criteria.filter(re=>re.filterType===s.SearchText)[0];return K&&K.value?K.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(K=>String(K.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function O(x,K){const re=(x||[]).filter(se=>se.statisticName===K)[0];return re?re.value:0}function A(x){const K="Microsoft.VisualStudio.Code.Translation.";return x.files.filter(se=>se.assetType.indexOf(K)===0).reduce((se,ce)=>{const he=F(x,ce.assetType);return he&&se.push([ce.assetType.substring(K.length),he]),se},[])}function N(x){if(x.properties){const K=x.properties.filter(ce=>ce.key===o.Repository),re=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),se=K.filter(ce=>re.test(ce.value))[0];return se?{uri:se.value,fallbackUri:se.value}:null}return F(x,o.Repository)}function $(x){return{uri:`${x.fallbackAssetUri}/${o.VSIX}?redirect=true${x.targetPlatform?`&targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${o.VSIX}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}}function D(x){const K=F(x,o.Icon);if(K)return K;const re=f.DefaultIconPath;return{uri:re,fallbackUri:re}}function F(x,K){return x.files.filter(se=>se.assetType===K)[0]?{uri:`${x.assetUri}/${K}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`,fallbackUri:`${x.fallbackAssetUri}/${K}${x.targetPlatform?`?targetPlatform=${x.targetPlatform}`:""}`}:null}function M(x,K){const re=x.properties?x.properties.filter(ce=>ce.key===K):[],se=re.length>0&&re[0].value;return se?se.split(",").map(ce=>(0,S.adoptToGalleryExtensionId)(ce)):[]}function U(x){const K=x.properties?x.properties.filter(re=>re.key===c.Engine):[];return K.length>0&&K[0].value||""}function G(x){const K=x.properties?x.properties.filter(re=>re.key===c.PreRelease):[];return K.length>0&&K[0].value==="true"}function ee(x){const K=x.properties?x.properties.filter(se=>se.key===c.LocalizedLanguages):[],re=K.length>0&&K[0].value||"";return re?re.split(","):[]}function V(x){return x.indexOf("preview")!==-1}function j(x){return x.targetPlatform?(0,f.toTargetPlatform)(x.targetPlatform):"undefined"}function Z(x){const K=(0,T.distinct)(x.versions.map(j)),re=!!x.tags?.includes(f.WEB_EXTENSION_TAG),se=K.indexOf("web");return re?se===-1&&K.push("web"):se!==-1&&K.splice(se,1),K}function W(x,K){const re=(0,f.getFallbackTargetPlarforms)(K);for(let se=0;se<x.length;se++){const ce=x[se];if(ce.version===x[se-1]?.version){let he=se;const me=j(ce);if(me===K)for(;he>0&&x[he-1].version===ce.version;)he--;else if(re.includes(me))for(;he>0&&x[he-1].version===ce.version&&j(x[he-1])!==K;)he--;he!==se&&(x.splice(se,1),x.splice(he,0,ce))}}return x}e.sortExtensionVersions=W;function z(x,K,re,se,ce){const he=x.versions[0],me={manifest:F(K,o.Manifest),readme:F(K,o.Details),changelog:F(K,o.Changelog),license:F(K,o.License),repository:N(K),download:$(K),icon:D(K),coreTranslations:A(K)};return{identifier:{id:(0,S.getGalleryExtensionId)(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},name:x.extensionName,version:K.version,displayName:x.displayName,publisherId:x.publisher.publisherId,publisher:x.publisher.publisherName,publisherDisplayName:x.publisher.displayName,publisherDomain:x.publisher.domain?{link:x.publisher.domain,verified:!!x.publisher.isDomainVerified}:void 0,description:x.shortDescription||"",installCount:O(x.statistics,"install"),rating:O(x.statistics,"averagerating"),ratingCount:O(x.statistics,"ratingcount"),categories:x.categories||[],tags:x.tags||[],releaseDate:Date.parse(x.releaseDate),lastUpdated:Date.parse(x.lastUpdated),allTargetPlatforms:re,assets:me,properties:{dependencies:M(K,c.Dependency),extensionPack:M(K,c.ExtensionPack),engine:U(K),localizedLanguages:ee(K),targetPlatform:j(K),isPreReleaseVersion:G(K)},hasPreReleaseVersion:G(he),hasReleaseVersion:se,preview:V(x.flags),telemetryData:ce}}let B=class{constructor(K,re,se,ce,he,me,ye,we){this.requestService=re,this.logService=se,this.environmentService=ce,this.telemetryService=he,this.fileService=me,this.productService=ye,this.configurationService=we;const pe=ye.extensionsGallery;this.extensionsGalleryUrl=pe&&pe.serviceUrl,this.extensionsControlUrl=pe&&pe.controlUrl,this.commonHeadersPromise=Y(ye.version,ye,this.environmentService,this.configurationService,this.fileService,K)}api(K=""){return`${this.extensionsGalleryUrl}${K}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(K,re,se){const ce=(0,b.isBoolean)(re)?re:!1,he=(0,b.isBoolean)(re)?se:re;let me=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,K.length).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionName,...K.map(({id:pe})=>pe.toLowerCase()));K.every(pe=>!pe.version)&&(me=me.withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties,n.IncludeLatestVersionOnly));const{galleryExtensions:ye}=await this.queryGallery(me,a,_.CancellationToken.None),we=ye.map(pe=>{const Re=(0,S.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName);return{rawGalleryExtension:pe,version:K.find(Ee=>(0,S.areSameExtensions)(Ee,{id:Re}))?.version}});return this.converToGalleryExtensions(we,ce,a,()=>{},he)}async getCompatibleExtension(K,re,se){const ce=(0,f.isIExtensionIdentifier)(K)?null:K;if(ce){if((0,f.isNotWebExtensionInWebTargetPlatform)(ce.allTargetPlatforms,se))return null;if(await this.isExtensionCompatible(ce,re,se))return ce}const{id:he,uuid:me}=ce?ce.identifier:K;let ye=new P().withFlags(n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");me?ye=ye.withFilter(s.ExtensionId,me):ye=ye.withFilter(s.ExtensionName,he);const{galleryExtensions:we}=await this.queryGallery(ye,se,_.CancellationToken.None),[pe]=we;if(!pe||!pe.versions.length)return null;const Re=Z(pe);if((0,f.isNotWebExtensionInWebTargetPlatform)(Re,se))return null;for(let Ee of pe.versions){if(!U(Ee)){const De=await this.getEngine(Ee);Ee={...Ee,properties:[...Ee.properties||[],{key:c.Engine,value:De}]}}if(await this.isRawExtensionVersionCompatible(Ee,re,Re,se)){const De=pe.versions.some(Le=>!G(Le));return z(pe,Ee,Re,De)}}return null}async isExtensionCompatible(K,re,se){if(!(0,f.isTargetPlatformCompatible)(K.properties.targetPlatform,K.allTargetPlatforms,se)||!re&&K.properties.isPreReleaseVersion)return!1;let ce=K.properties.engine;if(!ce){const he=await this.getManifest(K,_.CancellationToken.None);if(!he)throw new Error("Manifest was not found");ce=he.engines.vscode}return(0,h.isEngineValid)(ce,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(K,re,se,ce){if(!(0,f.isTargetPlatformCompatible)(j(K),se,ce)||!re&&G(K))return!1;const he=await this.getEngine(K);return(0,h.isEngineValid)(he,this.productService.version,this.productService.date)}async query(K,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let se=K.text||"";const ce=(0,L.getOrDefault)(K,Ee=>Ee.pageSize,50);let he=new P().withFlags(n.IncludeLatestVersionOnly,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,ce).withFilter(s.Target,"Microsoft.VisualStudio.Code");se?(se=se.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Le)=>(he=he.withFilter(s.Category,Le||De),"")),se=se.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Ee,De,Le)=>(he=he.withFilter(s.Tag,Le||De),"")),se=se.replace(/\bfeatured(\s+|\b|$)/g,()=>(he=he.withFilter(s.Featured),"")),se=se.trim(),se&&(se=se.length<200?se:se.substring(0,200),he=he.withFilter(s.SearchText,se)),he=he.withSortBy(0)):K.ids?he=he.withFilter(s.ExtensionId,...K.ids):K.names?he=he.withFilter(s.ExtensionName,...K.names):he=he.withSortBy(4),typeof K.sortBy=="number"&&(he=he.withSortBy(K.sortBy)),typeof K.sortOrder=="number"&&(he=he.withSortOrder(K.sortOrder));const{galleryExtensions:me,total:ye}=await this.queryGallery(he,a,re),we=Ee=>({index:(he.pageNumber-1)*he.pageSize+Ee,querySource:K.source}),pe=await this.converToGalleryExtensions(me.map(Ee=>({rawGalleryExtension:Ee})),!!K.includePreRelease,a,we,re),Re=async(Ee,De)=>{if(De.isCancellationRequested)throw(0,k.canceled)();const Le=he.withPage(Ee+1),{galleryExtensions:Fe}=await this.queryGallery(Le,a,De);return await this.converToGalleryExtensions(Fe.map($e=>({rawGalleryExtension:$e})),!!K.includePreRelease,a,we,re)};return{firstPage:pe,total:ye,pageSize:he.pageSize,getPage:Re}}async converToGalleryExtensions(K,re,se,ce,he){const me=(pe,Re,Ee)=>{const De=Z(pe);let Le=pe.versions[0];return Le=pe.versions.find(Fe=>Fe.version===Le.version&&(0,f.isTargetPlatformCompatible)(j(Fe),De,se))||Le,G(Le)&&!re&&(Le=pe.versions.find(Fe=>Fe.version!==Le.version&&!G(Fe))||Le),z(pe,Le,De,Ee,ce(Re))},ye=[],we=new Map;for(let pe=0;pe<K.length;pe++){const{rawGalleryExtension:Re,version:Ee}=K[pe],De=Re.versions.some(Le=>!G(Le));if(Ee){const Le=Re.versions.find(Fe=>Fe.version===Ee);Le&&ye.push([pe,z(Re,Le,Z(Re),De)])}else{const Le=me(Re,pe,De);Le.properties.isPreReleaseVersion?we.set(Le.identifier.uuid,pe):ye.push([pe,Le])}}if(we.size){const pe=new Date().getTime(),Re=new P().withFlags(n.IncludeVersions,n.IncludeAssetUri,n.IncludeStatistics,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,we.size).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExtensionId,...we.keys()),{galleryExtensions:Ee}=await this.queryGallery(Re,se,he);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-pe,count:we.size}),Ee.length!==we.size)throw new Error("Not all extensions with latest versions are returned");for(const De of Ee){const Le=De.versions.some(ze=>!G(ze)),Fe=we.get(De.extensionId),$e=me(De,Fe,Le);ye.push([Fe,$e])}}return ye.sort((pe,Re)=>pe[0]-Re[0]).map(([,pe])=>pe)}async queryGallery(K,re,se){if(!this.isEnabled())throw new Error("No extension gallery service configured.");K=K.withFlags(K.flags,n.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,t(n.Unpublished));const ce=await this.commonHeadersPromise,he=JSON.stringify(K.raw),me={...ce,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(he.length)},ye=new Date().getTime();let we,pe,Re=0;try{if(we=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:he,headers:me},se),we.res.statusCode&&we.res.statusCode>=400&&we.res.statusCode<500)return{galleryExtensions:[],total:Re};const Ee=await(0,w.asJson)(we);if(Ee){const De=Ee.results[0],Le=De.extensions;Le.forEach($e=>W($e.versions,re));const Fe=De.resultMetadata&&De.resultMetadata.filter($e=>$e.metadataType==="ResultCount")[0];return Re=Fe&&Fe.metadataItems.filter($e=>$e.name==="TotalCount")[0].count||0,{galleryExtensions:Le,total:Re}}return{galleryExtensions:[],total:Re}}catch(Ee){throw pe=Ee,Ee}finally{this.telemetryService.publicLog2("galleryService:query",{...K.telemetryData,requestBodySize:String(he.length),duration:new Date().getTime()-ye,success:!!we&&(0,w.isSuccess)(we),responseBodySize:we?.res.headers["Content-Length"],statusCode:we?String(we.res.statusCode):void 0,errorCode:pe?(0,k.isPromiseCanceledError)(pe)?"canceled":(0,k.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Re)})}}async reportStatistic(K,re,se,ce){if(!this.isEnabled())return;const he=i.isWeb?this.api(`/itemName/${K}.${re}/version/${se}/statType/${ce==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${K}/extensions/${re}/${se}/stats?statType=${ce}`),me=i.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",we={...await this.commonHeadersPromise,Accept:me};try{await this.requestService.request({type:"POST",url:he,headers:we},_.CancellationToken.None)}catch(pe){}}async download(K,re,se){this.logService.trace("ExtensionGalleryService#download",K.identifier.id);const ce=(0,S.getGalleryExtensionTelemetryData)(K),he=new Date().getTime(),me=Re=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...ce,duration:Re}),ye=se===2?"install":se===3?"update":"",we=ye?{uri:`${K.assets.download.uri}${C.URI.parse(K.assets.download.uri).query?"&":"?"}${ye}=true`,fallbackUri:`${K.assets.download.fallbackUri}${C.URI.parse(K.assets.download.fallbackUri).query?"&":"?"}${ye}=true`}:K.assets.download,pe=await this.getAsset(we);await this.fileService.writeFile(re,pe.stream),me(new Date().getTime()-he)}async getReadme(K,re){if(K.assets.readme){const se=await this.getAsset(K.assets.readme,{},re);return await(0,w.asText)(se)||""}return""}async getManifest(K,re){if(K.assets.manifest){const se=await this.getAsset(K.assets.manifest,{},re),ce=await(0,w.asText)(se);return ce?JSON.parse(ce):null}return null}async getManifestFromRawExtensionVersion(K,re){const se=F(K,o.Manifest);if(!se)throw new Error("Manifest was not found");const ce={"Accept-Encoding":"gzip"},he=await this.getAsset(se,{headers:ce});return await(0,w.asJson)(he)}async getCoreTranslation(K,re){const se=K.assets.coreTranslations.filter(ce=>ce[0]===re.toUpperCase())[0];if(se){const ce=await this.getAsset(se[1]),he=await(0,w.asText)(ce);return he?JSON.parse(he):null}return null}async getChangelog(K,re){if(K.assets.changelog){const se=await this.getAsset(K.assets.changelog,{},re);return await(0,w.asText)(se)||""}return""}async getAllCompatibleVersions(K,re,se){let ce=new P().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");K.identifier.uuid?ce=ce.withFilter(s.ExtensionId,K.identifier.uuid):ce=ce.withFilter(s.ExtensionName,K.identifier.id);const{galleryExtensions:he}=await this.queryGallery(ce,se,_.CancellationToken.None);if(!he.length)return[];const me=Z(he[0]);if((0,f.isNotWebExtensionInWebTargetPlatform)(me,se))return[];const ye=[];for(const we of he[0].versions)try{ye[ye.length-1]?.version!==we.version&&await this.isRawExtensionVersionCompatible(we,re,me,se)&&ye.push({version:we.version,date:we.lastUpdated,isPreReleaseVersion:G(we)})}catch(pe){}return ye}async getAsset(K,re={},se=_.CancellationToken.None){const ce=await this.commonHeadersPromise,he={type:"GET"},me={...ce,...re.headers||{}};re={...re,...he,headers:me};const ye=K.uri,we=K.fallbackUri,pe={...re,url:ye};try{const Re=await this.requestService.request(pe,se);if(Re.res.statusCode===200)return Re;const Ee=await(0,w.asText)(Re);throw new Error(`Expected 200, got back ${Re.res.statusCode} instead.

${Ee}`)}catch(Re){if((0,k.isPromiseCanceledError)(Re))throw Re;const Ee=(0,k.getErrorMessage)(Re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ye,message:Ee});const De={...re,url:we};return this.requestService.request(De,se)}}async getEngine(K){let re=U(K);if(!re){const se=await this.getManifestFromRawExtensionVersion(K,_.CancellationToken.None);if(!se)throw new Error("Manifest was not found");re=se.engines.vscode}return re}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const K=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},_.CancellationToken.None);if(K.res.statusCode!==200)throw new Error("Could not get extensions report.");const re=await(0,w.asJson)(K),se=[],ce={};if(re){for(const he of re.malicious)se.push({id:he});if(re.unsupported)for(const he of Object.keys(re.unsupported)){const me=re.unsupported[he];(0,b.isBoolean)(me)||(ce[he.toLowerCase()]=me.preReleaseExtension)}}return{malicious:se,unsupportedPreReleaseExtensions:ce}}};B=de([J(1,w.IRequestService),J(2,v.ILogService),J(3,E.IEnvironmentService),J(4,u.ITelemetryService),J(5,y.IFileService),J(6,m.IProductService),J(7,I.IConfigurationService)],B);let q=class extends B{constructor(K,re,se,ce,he,me,ye,we){super(K,re,se,ce,he,me,ye,we)}};q=de([J(0,l.IStorageService),J(1,w.IRequestService),J(2,v.ILogService),J(3,E.IEnvironmentService),J(4,u.ITelemetryService),J(5,y.IFileService),J(6,m.IProductService),J(7,I.IConfigurationService)],q),e.ExtensionGalleryService=q;let H=class extends B{constructor(K,re,se,ce,he,me,ye){super(void 0,K,re,se,ce,he,me,ye)}};H=de([J(0,w.IRequestService),J(1,v.ILogService),J(2,E.IEnvironmentService),J(3,u.ITelemetryService),J(4,y.IFileService),J(5,m.IProductService),J(6,I.IConfigurationService)],H),e.ExtensionGalleryServiceWithNoStorageService=H;async function Y(x,K,re,se,ce,he){const me={"X-Market-Client-Id":`VSCode ${x}`,"User-Agent":`VSCode ${x} (${K.nameShort})`},ye=await(0,g.getServiceMachineId)(re,ce,he);return(0,r.supportsTelemetry)(K,re)&&(0,r.getTelemetryLevel)(se)===3&&(me["X-Market-User-Id"]=ye),me}e.resolveMarketplaceHeaders=Y}),define(te[93],ne([0,1,2,11,8,43]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let i=class extends T.Disposable{constructor(b,C,I=""){super();this.prefix=I;const E=b.getLogger(C.telemetryLogResource);E?this.logger=this._register(E):(this.logger=this._register(b.createLogger(C.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(b,C){this.logger.trace(`${this.prefix}telemetry/${b}`,(0,L.validateTelemetryData)(C))}};i=de([J(0,k.ILoggerService),J(1,_.IEnvironmentService)],i),e.TelemetryLogAppender=i}),define(te[94],ne([0,1,2,28,4,25,141,21,41,86,37,22,43]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(v,m){this._configurationService=m,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=v.appenders,this._commonProperties=v.commonProperties||Promise.resolve({}),this._piiPaths=v.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!v.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let w of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,L.escapeRegExpCharacters)(w),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(w=>{const g=/^[a-f0-9]+$/i.test(w["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!g})})}setExperimentProperty(v,m){this._experimentProperties[v]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,f.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const v=await this._commonProperties;let m=v.sessionID,w=v["common.machineId"],g=v["common.firstSessionDate"],l=v["common.msftInternal"];return{sessionId:m,machineId:w,firstSessionDate:g,msftInternal:l}}dispose(){this._disposables.dispose()}_log(v,m,w,g){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(l=>{w=(0,_.mixin)(w,l),w=(0,_.mixin)(w,this._experimentProperties),w=(0,_.cloneAndChange)(w,u=>{if(typeof u=="string")return this._cleanupInfo(u,g)}),this._appenders.forEach(u=>u.log(v,w))},l=>{console.error(l)})}publicLog(v,m,w){return this._log(v,3,m,w)}publicLog2(v,m,w){return this.publicLog(v,m,w)}publicLogError(v,m){return this.sendErrorTelemetry?this._log(v,2,m,!0):Promise.resolve(void 0)}publicLogError2(v,m){return this.publicLogError(v,m)}_anonymizeFilePaths(v){let m=v;const w=[];for(let r of this._cleanupPatterns)for(;;){const a=r.exec(v);if(!a)break;w.push([a.index,r.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(m="";;){const r=l.exec(v);if(!r)break;!g.test(r[0])&&w.every(([a,n])=>r.index<a||r.index>=n)&&(m+=v.substring(u,r.index)+"<REDACTED: user-file-path>",u=l.lastIndex)}return u<v.length&&(m+=v.substr(u)),m}_removePropertiesWithPossibleUserInfo(v){if(!v)return v;const m=v.toLowerCase(),w=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(m)?"<REDACTED: secret>":w.test(m)?"<REDACTED: email>":v}_cleanupInfo(v,m){let w=v;m&&(w=this._anonymizeFilePaths(w));for(let g of this._cleanupPatterns)w=w.replace(g,"");return w=this._removePropertiesWithPossibleUserInfo(w),w}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=de([J(1,R.IConfigurationService)],S),e.TelemetryService=S;function h(){const y=(0,i.localize)(0,null,C.default.nameLong),v=C.default.privacyStatementUrl?(0,i.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,i.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=k.isWeb?"":(0,i.localize)(3,null),w=(0,i.localize)(4,null),g=(0,i.localize)(5,null),l=(0,i.localize)(6,null),u=(0,i.localize)(7,null),r=`
|       | ${w} | ${g} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,a=(0,i.localize)(8,null);return`
${y} ${v} ${m}

&nbsp;

${u}
${r}

&nbsp;

${a}
`}I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(9,null),properties:{[E.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,i.localize)(10,null),(0,i.localize)(11,null),(0,i.localize)(12,null),(0,i.localize)(13,null)],markdownDescription:h(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(b.Extensions.Configuration).registerConfiguration({id:E.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,i.localize)(14,null),properties:{[E.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,i.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,i.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,i.localize)(17,null,`\`#${E.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[204],ne([0,1,10,28,43]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function L(R,b){const C=await new Promise((E,f)=>{Q(["applicationinsights"],E,f)});let I;return C.defaultClient?(I=new C.TelemetryClient(R),I.channel.setUseDiskRetryCaching(!0)):(C.setup(R).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),I=C.defaultClient),R.indexOf("AIF-")===0&&(I.config.endpointUrl=b?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),I}class i{constructor(b,C,I,E,f){this._eventPrefix=b,this._defaultData=C,this.testCollector=E,this.mirrored=f,this._defaultData||(this._defaultData=Object.create(null)),typeof I=="function"?this._aiClient=I():this._aiClient=I,this._asyncAIClient=null}_withAIClient(b){if(!!this._aiClient){if(typeof this._aiClient!="string"){b(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=L(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(C=>{b(C)},C=>{(0,T.onUnexpectedError)(C),console.error(C)})}}log(b,C){!this._aiClient||(C=(0,_.mixin)(C,this._defaultData),C=(0,k.validateTelemetryData)(C),this.testCollector&&(C.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(I=>I.trackEvent({name:this._eventPrefix+"/"+b,properties:C.properties,measurements:C.measurements})))}flush(){return this._aiClient?new Promise(b=>{this._withAIClient(C=>{C.flush({callback:()=>{this._aiClient=void 0,b(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=i}),define(te[205],ne([0,1,17,56,21,11,8,22,92,93,94]),function(Q,e,T,_,k,L,i,R,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let E=class{constructor(S,h,y,v){this.configurationService=S,this.telemetryService=h,this.loggerService=y,this.environmentService=v,this.customTelemetryServices=new Map}async getCustomTelemetryService(S){if(!this.customTelemetryServices.has(S.id)){const{machineId:h,sessionId:y}=await this.telemetryService.getTelemetryInfo(),v=Object.create(null);v["common.vscodemachineid"]=h,v["common.vscodesessionid"]=y;const m=[S.id,JSON.stringify(v),S.aiKey],g=new _.Client(T.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),l=[new b.TelemetryAppenderClient(g),new C.TelemetryLogAppender(this.loggerService,this.environmentService,`[${S.id}] `)];this.customTelemetryServices.set(S.id,new I.TelemetryService({appenders:l,sendErrorTelemetry:S.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(S.id)}async publicLog(S,h,y){await(await this.getCustomTelemetryService(S)).publicLog(h,y)}async publicLogError(S,h,y){await(await this.getCustomTelemetryService(S)).publicLogError(h,y)}};E=de([J(0,k.IConfigurationService),J(1,R.ITelemetryService),J(2,i.ILoggerService),J(3,L.IEnvironmentService)],E),e.CustomEndpointTelemetryService=E}),define(te[206],ne([0,1,5,27,3,2,8]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let R=class extends L.Disposable{constructor(C,I){super();this._logService=I,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=C===void 0?15e3:C}createRequest(C){return new Promise((I,E)=>{const f=++this._lastRequestId;this._pendingRequests.set(f,I),this._onCreateRequest.fire({requestId:f,...C});const S=new _.CancellationTokenSource;(0,T.timeout)(this._timeout,S.token).then(()=>E(`Request ${f} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(f,[(0,L.toDisposable)(()=>S.cancel())])})}acceptReply(C,I){const E=this._pendingRequests.get(C);E?(this._pendingRequests.delete(C),(0,L.dispose)(this._pendingRequestDisposables.get(C)||[]),this._pendingRequestDisposables.delete(C),E(I)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${C}`)}};R=de([J(1,i.ILogService)],R),e.RequestStore=R}),define(te[95],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.ProcessCapability=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var _;(function(v){v.Shell="terminal.integrated.shell.",v.ShellArgs="terminal.integrated.shellArgs.",v.DefaultProfile="terminal.integrated.defaultProfile.",v.Profiles="terminal.integrated.profiles."})(_=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(v){v.ShellLinux="terminal.integrated.shell.linux",v.ShellMacOs="terminal.integrated.shell.osx",v.ShellWindows="terminal.integrated.shell.windows",v.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",v.AutomationShellLinux="terminal.integrated.automationShell.linux",v.AutomationShellMacOs="terminal.integrated.automationShell.osx",v.AutomationShellWindows="terminal.integrated.automationShell.windows",v.AutomationProfileLinux="terminal.integrated.automationProfile.linux",v.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",v.AutomationProfileWindows="terminal.integrated.automationProfile.windows",v.ShellArgsLinux="terminal.integrated.shellArgs.linux",v.ShellArgsMacOs="terminal.integrated.shellArgs.osx",v.ShellArgsWindows="terminal.integrated.shellArgs.windows",v.ProfilesWindows="terminal.integrated.profiles.windows",v.ProfilesMacOs="terminal.integrated.profiles.osx",v.ProfilesLinux="terminal.integrated.profiles.linux",v.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",v.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",v.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",v.UseWslProfiles="terminal.integrated.useWslProfiles",v.TabsEnabled="terminal.integrated.tabs.enabled",v.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",v.TabsHideCondition="terminal.integrated.tabs.hideCondition",v.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",v.TabsShowActions="terminal.integrated.tabs.showActions",v.TabsLocation="terminal.integrated.tabs.location",v.TabsFocusMode="terminal.integrated.tabs.focusMode",v.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",v.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",v.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",v.CopyOnSelection="terminal.integrated.copyOnSelection",v.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",v.FontFamily="terminal.integrated.fontFamily",v.FontSize="terminal.integrated.fontSize",v.LetterSpacing="terminal.integrated.letterSpacing",v.LineHeight="terminal.integrated.lineHeight",v.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",v.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",v.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",v.BellDuration="terminal.integrated.bellDuration",v.FontWeight="terminal.integrated.fontWeight",v.FontWeightBold="terminal.integrated.fontWeightBold",v.CursorBlinking="terminal.integrated.cursorBlinking",v.CursorStyle="terminal.integrated.cursorStyle",v.CursorWidth="terminal.integrated.cursorWidth",v.Scrollback="terminal.integrated.scrollback",v.DetectLocale="terminal.integrated.detectLocale",v.DefaultLocation="terminal.integrated.defaultLocation",v.GpuAcceleration="terminal.integrated.gpuAcceleration",v.TerminalTitleSeparator="terminal.integrated.tabs.separator",v.TerminalTitle="terminal.integrated.tabs.title",v.TerminalDescription="terminal.integrated.tabs.description",v.RightClickBehavior="terminal.integrated.rightClickBehavior",v.Cwd="terminal.integrated.cwd",v.ConfirmOnExit="terminal.integrated.confirmOnExit",v.ConfirmOnKill="terminal.integrated.confirmOnKill",v.EnableBell="terminal.integrated.enableBell",v.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",v.AllowChords="terminal.integrated.allowChords",v.AllowMnemonics="terminal.integrated.allowMnemonics",v.EnvMacOs="terminal.integrated.env.osx",v.EnvLinux="terminal.integrated.env.linux",v.EnvWindows="terminal.integrated.env.windows",v.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",v.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",v.ShowExitAlert="terminal.integrated.showExitAlert",v.SplitCwd="terminal.integrated.splitCwd",v.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",v.WordSeparators="terminal.integrated.wordSeparators",v.EnableFileLinks="terminal.integrated.enableFileLinks",v.UnicodeVersion="terminal.integrated.unicodeVersion",v.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",v.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",v.LocalEchoEnabled="terminal.integrated.localEchoEnabled",v.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",v.LocalEchoStyle="terminal.integrated.localEchoStyle",v.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",v.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",v.CustomGlyphs="terminal.integrated.customGlyphs",v.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",v.InheritEnv="terminal.integrated.inheritEnv",v.ShowLinkHover="terminal.integrated.showLinkHover",v.IgnoreProcessNames="terminal.integrated.ignoreProcessNames"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(v){v.CommandPrompt="cmd",v.PowerShell="pwsh",v.Wsl="wsl",v.GitBash="gitbash"})(L=e.WindowsShellType||(e.WindowsShellType={}));var i;(function(v){v[v.Api=0]="Api",v[v.Process=1]="Process",v[v.Sequence=2]="Sequence",v[v.Config=3]="Config"})(i=e.TitleEventSource||(e.TitleEventSource={}));var R;(function(v){v.LocalPty="localPty",v.PtyHost="ptyHost",v.Log="log",v.Heartbeat="heartbeat"})(R=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,T.createDecorator)("ptyService");var b;(function(v){v.Cwd="cwd",v.InitialCwd="initialCwd",v.FixedDimensions="fixedDimensions",v.Title="title",v.ShellType="shellType",v.HasChildProcesses="hasChildProcesses",v.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",v.OverrideDimensions="overrideDimensions"})(b=e.ProcessPropertyType||(e.ProcessPropertyType={}));var C;(function(v){v[v.BeatInterval=5e3]="BeatInterval",v[v.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",v[v.SecondWaitMultiplier=1]="SecondWaitMultiplier",v[v.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(C=e.HeartbeatConstants||(e.HeartbeatConstants={}));var I;(function(v){v[v.Panel=1]="Panel",v[v.Editor=2]="Editor"})(I=e.TerminalLocation||(e.TerminalLocation={}));var E;(function(v){v.TerminalView="view",v.Editor="editor"})(E=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(v){v.CwdDetection="cwdDetection"})(f=e.ProcessCapability||(e.ProcessCapability={}));var S;(function(v){v[v.GraceTime=6e4]="GraceTime",v[v.ShortGraceTime=6e3]="ShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var h;(function(v){v[v.HighWatermarkChars=1e5]="HighWatermarkChars",v[v.LowWatermarkChars=5e3]="LowWatermarkChars",v[v.CharCountAckSize=5e3]="CharCountAckSize"})(h=e.FlowControlConstants||(e.FlowControlConstants={}));var y;(function(v){v.GitBash="Git Bash",v.Pwsh="PowerShell"})(y=e.ProfileSource||(e.ProfileSource={}))}),define(te[207],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,T.createDecorator)("localPtyService")}),define(te[208],ne([0,1,33,28,9,4,32,15,20]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function C(){const E=/(\d+)\.(\d+)\.(\d+)/g.exec(T.release());let f=0;return E&&E.length===4&&(f=parseInt(E[3])),f}e.getWindowsBuildNumber=C;async function I(E,f,S,h=i.env,y=b.Promises.exists){if(k.isAbsolute(E))return await y(E)?E:void 0;if(f===void 0&&(f=i.cwd()),k.dirname(E)!=="."){const g=k.join(f,E);return await y(g)?g:void 0}const m=(0,_.getCaseInsensitive)(h,"PATH");if(S===void 0&&(0,R.isString)(m)&&(S=m.split(k.delimiter)),S===void 0||S.length===0){const g=k.join(f,E);return await y(g)?g:void 0}for(let g of S){let l;if(k.isAbsolute(g)?l=k.join(g,E):l=k.join(f,g,E),await y(l))return l;if(L.isWindows){let u=l+".com";if(await y(u)||(u=l+".exe",await y(u)))return u}}const w=k.join(f,E);return await y(w)?w:void 0}e.findExecutable=I}),define(te[209],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var T;(function(_){_.DARK="dark",_.LIGHT="light",_.HIGH_CONTRAST="hc"})(T=e.ColorScheme||(e.ColorScheme={}))}),define(te[96],ne([0,1,47,3,2,6,37,209]),function(Q,e,T,_,k,L,i,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var b;(function(v){function m(w){return w&&typeof w=="object"&&typeof w.id=="string"}v.isThemeColor=m})(b=e.ThemeColor||(e.ThemeColor={}));function C(v){return{id:v}}e.themeColorFromId=C;var I;(function(v){function m(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||b.isThemeColor(n.color))}v.isThemeIcon=m;const w=new RegExp(`^\\$\\((${T.CSSIcon.iconNameExpression}(?:${T.CSSIcon.iconModifierExpression})?)\\)$`);function g(n){const t=w.exec(n);if(!t)return;let[,s]=t;return{id:s}}v.fromString=g;function l(n,t){let s=n.id;const o=s.lastIndexOf("~");return o!==-1&&(s=s.substring(0,o)),t&&(s=`${s}~${t}`),{id:s}}v.modify=l;function u(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}v.getModifier=u;function r(n,t){return n.id===t.id&&n.color?.id===t.color?.id}v.isEqual=r;function a(n,t){return{id:n.id,color:t?C(t):void 0}}v.asThemeIcon=a,v.asClassNameArray=T.CSSIcon.asClassNameArray,v.asClassName=T.CSSIcon.asClassName,v.asCSSSelector=T.CSSIcon.asCSSSelector})(I=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=T.Codicon.file,e.FolderThemeIcon=T.Codicon.folder;function E(v){switch(v){case R.ColorScheme.DARK:return"vs-dark";case R.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=E,e.Extensions={ThemingContribution:"base.contributions.theming"};class f{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new _.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const w=this.themingParticipants.indexOf(m);this.themingParticipants.splice(w,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let S=new f;i.Registry.add(e.Extensions.ThemingContribution,S);function h(v){return S.onColorThemeChange(v)}e.registerThemingParticipant=h;class y extends k.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(w=>this.onThemeChange(w)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,w){let g=this.theme.getColor(m);return g&&w&&(g=w(g,this.theme)),g?g.toString():null}}e.Themable=y}),define(te[210],ne([0,1,47,7,96]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function L(E,f){const S=E.map(h=>({name:h.profileName,description:i(h)}));return f&&S.push(...f.map(h=>({name:h.title,description:R(h)}))),{values:S.map(h=>h.name),markdownDescriptions:S.map(h=>h.description)}}e.createProfileSchemaEnums=L;function i(E){let f=`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:T.Codicon.terminal.id}) ${E.profileName}
- path: ${E.path}`;return E.args&&(typeof E.args=="string"?f+=`
- args: "${E.args}"`:f+=`
- args: [${E.args.length===0?"":`'${E.args.join("','")}'`}]`),E.overrideName!==void 0&&(f+=`
- overrideName: ${E.overrideName}`),E.color&&(f+=`
- color: ${E.color}`),E.env&&(f+=`
- env: ${JSON.stringify(E.env)}`),f}function R(E){return`$(${k.ThemeIcon.isThemeIcon(E.icon)?E.icon.id:E.icon?E.icon:T.Codicon.terminal.id}) ${E.title}
- extensionIdenfifier: ${E.extensionIdentifier}`}function b(E,f){if(!E&&!f)return!0;if(typeof E=="string"&&typeof f=="string")return E===f;if(Array.isArray(E)&&Array.isArray(f)){if(E.length!==f.length)return!1;for(let S=0;S<E.length;S++)if(E[S]!==f[S])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function C(E,f){if(!E&&!f)return!0;if(!E||!f)return!1;if(k.ThemeIcon.isThemeIcon(E)&&k.ThemeIcon.isThemeIcon(f))return E.id===f.id&&E.color===f.color;if(typeof E=="object"&&E&&"light"in E&&"dark"in E&&typeof f=="object"&&f&&"light"in f&&"dark"in f){const S=E,h=f;if((_.URI.isUri(S.light)||I(S.light))&&(_.URI.isUri(S.dark)||I(S.dark))&&(_.URI.isUri(h.light)||I(h.light))&&(_.URI.isUri(h.dark)||I(h.dark)))return S.light.path===h.light.path&&S.dark.path===h.dark.path}if(_.URI.isUri(E)&&_.URI.isUri(f)||I(E)||I(f)){const S=E,h=f;return S.path===h.path&&S.scheme===h.scheme}return!1}e.terminalIconsEqual=C;function I(E){return E?typeof E.path=="string"&&typeof E.scheme=="string":!1}e.isUriComponents=I}),define(te[211],ne([0,1,47,142,41,37,210]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const R={args:{description:(0,_.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,_.localize)(1,null),type:"boolean"},icon:{description:(0,_.localize)(2,null),type:"string",enum:Array.from(T.iconRegistry.all,l=>l.id),markdownEnumDescriptions:Array.from(T.iconRegistry.all,l=>`$(${l.id})`)},color:{description:(0,_.localize)(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:(0,_.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},b={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(5,null),type:["string","array"],items:{type:"string"}},...R}},C={type:"object",required:["path"],properties:{path:{description:(0,_.localize)(6,null),type:["string"],items:{type:"string"}},...R}},I=(0,_.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),E=(0,_.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),f=(0,_.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),S=(0,_.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),h=(0,_.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),y=(0,_.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),v={id:"terminal",order:100,title:(0,_.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:h},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(17,null,"#terminal.integrated.automationShell.linux#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,description:(0,_.localize)(18,null,"#terminal.integrated.automationShell.osx#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,description:(0,_.localize)(19,null,"#terminal.integrated.automationShell.windows#"),type:["object","null"],default:null,anyOf:[{type:"null"},C],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,_.localize)(26,null)}},{type:"string",markdownDescription:(0,_.localize)(27,null)}],default:[],markdownDeprecationMessage:f},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,_.localize)(29,null),enum:["PowerShell","Git Bash"]},...R}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(30,null),type:"string"},id:{description:(0,_.localize)(31,null),type:"string"},title:{description:(0,_.localize)(32,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(34,null),type:"string"},id:{description:(0,_.localize)(35,null),type:"string"},title:{description:(0,_.localize)(36,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,_.localize)(38,null),type:"string"},id:{description:(0,_.localize)(39,null),type:"string"},title:{description:(0,_.localize)(40,null),type:"string"},...R}},{type:"null"},b]}},["terminal.integrated.useWslProfiles"]:{description:(0,_.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,_.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,_.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,_.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,_.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){L.Registry.as(k.Extensions.Configuration).registerConfiguration(v),g()}e.registerTerminalPlatformConfiguration=m;let w;function g(l,u){const r=L.Registry.as(k.Extensions.Configuration);let a;l&&(a=(0,i.createProfileSchemaEnums)(l?.profiles,u));const n=w;w={id:"terminal",order:100,title:(0,_.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,_.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:l?.os===3?a?.values:void 0,markdownEnumDescriptions:l?.os===3?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,_.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:l?.os===2?a?.values:void 0,markdownEnumDescriptions:l?.os===2?a?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,_.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:l?.os===1?a?.values:void 0,markdownEnumDescriptions:l?.os===1?a?.markdownDescriptions:void 0}}},r.updateConfigurations({add:[w],remove:n?[n]:[]})}e.registerTerminalDefaultProfileConfiguration=g}),define(te[212],ne([0,1,44,47,9,4,20,70,208,96]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let I,E=!0;function f(a,n,t,s,o=process.env,c,d,p,P){return c=c||{existsFile:i.SymlinkSupport.existsFile,readFile:i.Promises.readFile},L.isWindows?S(t,c,o,d,s.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:s.getValue("terminal.integrated.profiles.windows"),typeof n=="string"?n:s.getValue("terminal.integrated.defaultProfile.windows"),P,p):l(c,d,t,a&&typeof a=="object"?{...a}:s.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof n=="string"?n:s.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),P,p,o)}e.detectAvailableProfiles=f;async function S(a,n,t,s,o,c,d,p,P){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),A=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let N=!1;(0,b.getWindowsBuildNumber)()>=16299&&(N=!0),await v(p);const $=new Map;a&&($.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Windows PowerShell",{path:`${A}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),$.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),$.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),$.set("Command Prompt",{path:`${A}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0})),u(c,$);const D=await h($.entries(),d,n,t,s,P);if(a||!a&&o)try{const F=await w(`${A}\\${N?"wsl":"bash"}.exe`,d);for(const M of F)(!c||!(M.profileName in c))&&D.push(M)}catch(F){E&&(s?.info("WSL is not installed, so could not detect WSL profiles"),E=!1)}return D}async function h(a,n,t,s=process.env,o,c){const d=[];for(const[p,P]of a){if(P===null)continue;let O,A,N;if("source"in P){const F=I?.get(P.source);if(!F)continue;O=F.paths,A=P.args||F.args,P.icon?N=y(P.icon):F.icon&&(N=F.icon)}else O=Array.isArray(P.path)?P.path:[P.path],A=L.isWindows||Array.isArray(P.args)?P.args:void 0,N=y(P.icon);const $=await c?.(O)||O.slice(),D=await r(p,n,$,t,s,A,P.env,P.overrideName,P.isAutoDetected,o);D?(D.isAutoDetected=P.isAutoDetected,D.icon=N,D.color=P.color,d.push(D)):o?.trace("profile not validated",p,O)}return d}function y(a){return typeof a=="string"?{id:a}:a}async function v(a){I&&!a||(I=new Map,I.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),I.set("PowerShell",{profileName:"PowerShell",paths:a||await m(),icon:C.ThemeIcon.asThemeIcon(_.Codicon.terminalPowershell)}))}async function m(){const a=[];for await(const n of(0,R.enumeratePowerShellInstallations)())a.push(n.exePath);return a}async function w(a,n){const t=[],s=await new Promise((d,p)=>{T.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(P,O)=>{if(P)return p("Problem occurred when getting wsl distros");d(O)})});if(!s)return[];const o=new RegExp(/[\r?\n]/),c=s.split(o).filter(d=>d.trim().length>0&&d!=="");for(const d of c){if(d===""||d.startsWith("docker-desktop"))continue;const p=`${d} (WSL)`,P={profileName:p,path:a,args:["-d",`${d}`],isDefault:p===n,icon:g(d),isAutoDetected:!0};t.push(P)}return t}function g(a){return a.includes("Ubuntu")?C.ThemeIcon.asThemeIcon(_.Codicon.terminalUbuntu):a.includes("Debian")?C.ThemeIcon.asThemeIcon(_.Codicon.terminalDebian):C.ThemeIcon.asThemeIcon(_.Codicon.terminalLinux)}async function l(a,n,t,s,o,c,d,p){const P=new Map;if(t){const O=(await a.readFile("/etc/shells")).toString(),A=c||O.split(`
`).filter($=>$.trim().indexOf("#")!==0&&$.trim().length>0),N=new Map;for(const $ of A){let D=(0,k.basename)($),F=N.get(D)||0;F++,F>1&&(D=`${D} (${F})`),N.set(D,F),P.set(D,{path:$,isAutoDetected:!0})}}return u(s,P),await h(P.entries(),o,a,p,n,d)}function u(a,n){if(!!a)for(const[t,s]of Object.entries(a))s===null||!("path"in s)&&!("source"in s)?n.delete(t):(s.icon=s.icon||n.get(t)?.icon,n.set(t,s))}async function r(a,n,t,s,o,c,d,p,P,O){if(t.length===0)return Promise.resolve(void 0);const A=t.shift();if(A==="")return r(a,n,t,s,o,c,d,p,P);const N={profileName:a,path:A,args:c,env:d,overrideName:p,isAutoDetected:P,isDefault:a===n};if((0,k.basename)(A)===A){const D=o.PATH?o.PATH.split(k.delimiter):void 0;return await(0,b.findExecutable)(A,void 0,D,void 0,s.existsFile)?N:r(a,n,t,s,o,c)}return await s.existsFile((0,k.normalize)(A))?N:r(a,n,t,s,o,c,d,p,P)}}),define(te[213],ne([0,1,3,2,17,4,36,56,21,11,75,164,8,85,22,206,95,211,212]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(r){r[r.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let l=0,u=class extends _.Disposable{constructor(a,n,t,s,o){super();this._reconnectConstants=a,this._configurationService=n,this._environmentService=t,this._logService=s,this._telemetryService=o,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new T.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new T.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new T.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new T.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new T.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new T.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new T.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new T.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new T.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new T.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new T.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new T.Emitter),this.onProcessExit=this._onProcessExit.event,(0,m.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,_.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new y.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}async initialize(){await this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,E.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(a){return this._logService.error("ptyHost was unable to resolve shell environment",a),{}}}_startPtyHost(){const a={serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:l,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},n=(0,I.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);n&&(n.break&&n.port?a.debugBrk=n.port:!n.break&&n.port&&(a.debug=n.port));const t=new R.Client(k.FileAccess.asFileUri("bootstrap-fork",Q).fsPath,a);this._onPtyHostStart.fire(),i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(d=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(d.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${d.code}, giving up`))}));const o=t.getChannel(v.TerminalIpcChannels.Log);S.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{S.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=i.ProxyChannel.toService(t.getChannel(v.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(d=>this._onProcessData.fire(d))),this._register(c.onProcessReady(d=>this._onProcessReady.fire(d))),this._register(c.onProcessExit(d=>this._onProcessExit.fire(d))),this._register(c.onDidChangeProperty(d=>this._onDidChangeProperty.fire(d))),this._register(c.onProcessReplay(d=>this._onProcessReplay.fire(d))),this._register(c.onProcessOrphanQuestion(d=>this._onProcessOrphanQuestion.fire(d))),this._register(c.onDidRequestDetach(d=>this._onDidRequestDetach.fire(d))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(a,n,t,s,o,c,d,p,P,O,A){const N=setTimeout(()=>this._handleUnresponsiveCreateProcess(),v.HeartbeatConstants.CreateProcessTimeout),$=await this._proxy.createProcess(a,n,t,s,o,c,d,p,P,O,A);return clearTimeout(N),l=Math.max(l,$),$}updateTitle(a,n,t){return this._proxy.updateTitle(a,n,t)}updateIcon(a,n,t){return this._proxy.updateIcon(a,n,t)}attachToProcess(a){return this._proxy.attachToProcess(a)}detachFromProcess(a){return this._proxy.detachFromProcess(a)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(a){return this._proxy.start(a)}shutdown(a,n){return this._proxy.shutdown(a,n)}input(a,n){return this._proxy.input(a,n)}processBinary(a,n){return this._proxy.processBinary(a,n)}resize(a,n,t){return this._proxy.resize(a,n,t)}acknowledgeDataEvent(a,n){return this._proxy.acknowledgeDataEvent(a,n)}setUnicodeVersion(a,n){return this._proxy.setUnicodeVersion(a,n)}getInitialCwd(a){return this._proxy.getInitialCwd(a)}getCwd(a){return this._proxy.getCwd(a)}getLatency(a){return this._proxy.getLatency(a)}orphanQuestionReply(a){return this._proxy.orphanQuestionReply(a)}getDefaultSystemShell(a){return this._proxy.getDefaultSystemShell(a)}async getProfiles(a,n,t,s=!1){const o=await this._shellEnv;return(0,w.detectAvailableProfiles)(n,t,s,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,a))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(a){return this._proxy.getWslPath(a)}setTerminalLayoutInfo(a){return this._proxy.setTerminalLayoutInfo(a)}async getTerminalLayoutInfo(a){return await this._proxy.getTerminalLayoutInfo(a)}async requestDetachInstance(a,n){return this._proxy.requestDetachInstance(a,n)}async acceptDetachInstanceReply(a,n){return this._proxy.acceptDetachInstanceReply(a,n)}async serializeTerminalState(a){return this._proxy.serializeTerminalState(a)}async reviveTerminalProcesses(a,n){return this._proxy.reviveTerminalProcesses(a,n)}async refreshProperty(a,n){return this._proxy.refreshProperty(a,n)}async updateProperty(a,n,t){return this._proxy.updateProperty(a,n,t)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(a,n){return this._resolveVariablesRequestStore.createRequest({workspaceId:a,originalText:n})}async acceptPtyHostResolvedVariables(a,n){this._resolveVariablesRequestStore.acceptReply(a,n)}};u=de([J(1,b.IConfigurationService),J(2,C.IEnvironmentService),J(3,f.ILogService),J(4,h.ITelemetryService)],u),e.PtyHostService=u}),define(te[35],ne([0,1,6]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(te[214],ne([0,1,3,2,7,11,34,14,8,35]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let I=class extends _.Disposable{constructor(f,S,h,y,v){super();this.extensionsManagementService=f,this.logService=y,this.uriIdentityService=v,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(w=>{this.installedExtensions=w.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(f.onInstallExtension(w=>this.onInstallExtension(w))),this._register(f.onDidInstallExtensions(w=>this.onDidInstallExtensions(w))),this._register(f.onDidUninstallExtension(w=>this.onDidUninstallExtension(w)));const m=k.URI.file(h.extensionsPath);this._register(S.watch(m)),this._register(T.Event.filter(S.onDidChangeFilesRaw,w=>w.changes.some(g=>this.doesChangeAffects(g,m)))(()=>this.onDidChange()))}doesChangeAffects(f,S){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(f.resource),S)?this.uriIdentityService.extUri.isEqual(f.resource,this.uriIdentityService.extUri.joinPath(S,".obsolete"))?!0:!(f.type!==1&&f.type!==2||this.uriIdentityService.extUri.basename(f.resource).startsWith(".")):!1}onInstallExtension(f){this.addInstallingExtension(f.identifier)}onDidInstallExtensions(f){for(const S of f)this.removeInstallingExtension(S.identifier),S.local&&this.addInstalledExtension(S.identifier)}onDidUninstallExtension(f){f.error||this.removeInstalledExtension(f.identifier)}addInstallingExtension(f){this.removeInstallingExtension(f),this.installingExtensions.push(f)}removeInstallingExtension(f){this.installingExtensions=this.installingExtensions.filter(S=>!(0,i.areSameExtensions)(S,f))}addInstalledExtension(f){this.installedExtensions&&(this.removeInstalledExtension(f),this.installedExtensions.push(f))}removeInstalledExtension(f){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(S=>!(0,i.areSameExtensions)(S,f)))}async onDidChange(){if(this.installedExtensions){const f=await this.extensionsManagementService.getInstalled(1),S=f.filter(y=>[...this.installingExtensions,...this.installedExtensions].some(v=>(0,i.areSameExtensions)(v,y.identifier))?!1:y.installedTimestamp&&y.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",y.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",y.identifier.id),!1)),h=this.installedExtensions.filter(y=>this.installingExtensions.some(v=>(0,i.areSameExtensions)(v,y))?!1:f.every(v=>!(0,i.areSameExtensions)(v.identifier,y))?(this.logService.info("Detected extension removed from another source",y.id),!0):!1);this.installedExtensions=f.map(y=>y.identifier),(S.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:S,removed:h})}}};I=de([J(1,R.IFileService),J(2,L.INativeEnvironmentService),J(3,b.ILogService),J(4,C.IUriIdentityService)],I),e.ExtensionsWatcher=I}),define(te[215],ne([0,1,35,77,14,18,102,3,2]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class C{constructor(f){this.uri=f,this.time=C._clock++}touch(){return this.time=C._clock++,this}}C._clock=0;let I=class{constructor(f){this._fileService=f,this._dispooables=new b.DisposableStore,this._limit=2**16;const S=new Map,h=y=>{let v=S.get(y.scheme);return v===void 0&&(v=f.hasProvider(y)&&!this._fileService.hasCapability(y,1024),S.set(y.scheme,v)),v};this._dispooables.add(R.Event.any(f.onDidChangeFileSystemProviderRegistrations,f.onDidChangeFileSystemProviderCapabilities)(y=>{S.delete(y.scheme)})),this.extUri=new L.ExtUri(h),this._canonicalUris=new i.SkipList((y,v)=>this.extUri.compare(y,v,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(f){this._fileService.hasProvider(f)&&(f=(0,L.normalizePath)(f));let S=this._canonicalUris.get(f);return S?S.touch().uri.with({fragment:f.fragment}):(this._canonicalUris.set(f,new C(f)),this._checkTrim(),f)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const f=[...this._canonicalUris.entries()].sort((h,y)=>h[1].touch<y[1].touch?1:h[1].touch>y[1].touch?-1:0);C._clock=0,this._canonicalUris.clear();const S=this._limit*.5;for(let h=0;h<S;h++)this._canonicalUris.set(f[h][0],f[h][1].touch())}};I=de([J(0,k.IFileService)],I),e.UriIdentityService=I,(0,_.registerSingleton)(T.IUriIdentityService,I,!0)}),define(te[51],ne([0,1,53]),function(Q,e,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function _(i,R,b,C){const I=(0,T.setProperty)(i,R,b,C)[0];return I&&(i=i.substring(0,I.offset)+I.content+i.substring(I.offset+I.length)),i}e.edit=_;function k(i,R,b){let C=b;for(;C>=0;){if(i.charAt(C)===R.charAt(R.length-1)&&R.length===1)return C+1;if(C--,R.length===2&&C>=0&&i.charAt(C)===R.charAt(0))return C+2}return 0}e.getLineStartOffset=k;function L(i,R,b){let C=b;for(;C>=0;)if(i.charAt(C)===R.charAt(R.length-1)&&R.length===1||(C++,R.length===2&&C>=0&&i.charAt(C)===R.charAt(1)))return C;return i.length-1}e.getLineEndOffset=L}),define(te[216],ne([0,1,28,60,15]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(f,S,h,y,v){const m=[],w=[],g=[];if(!S){const A=f.filter(({identifier:N})=>v.every($=>$.toLowerCase()!==N.id.toLowerCase()));return{local:{added:m,removed:w,updated:g},remote:A.length>0?{added:A,updated:[],removed:[],all:A}:null}}f=f.map(I),S=S.map(I),h=h?h.map(I):null;const l=new Map,u=A=>{A.uuid&&l.set(A.id.toLowerCase(),A.uuid)};f.forEach(({identifier:A})=>u(A)),S.forEach(({identifier:A})=>u(A)),h&&h.forEach(({identifier:A})=>u(A));const r=A=>{const N=A.identifier.uuid||l.get(A.identifier.id.toLowerCase());return N?`uuid:${N}`:`id:${A.identifier.id.toLowerCase()}`},a=(A,N)=>(A.set(r(N),N),A),n=f.reduce(a,new Map),t=S.reduce(a,new Map),s=S.reduce((A,N)=>{const $=r(N);N=(0,T.deepClone)(N);const D=n.get($);return D&&(D.installed&&(N.installed=!0),N.version||(N.version=D.version)),a(A,N)},new Map),o=h?h.reduce(a,new Map):null,c=y.reduce(a,new Map),d=v.reduce((A,N)=>{const $=l.get(N.toLowerCase());return A.add($?`uuid:${$}`:`id:${N.toLowerCase()}`)},new Set),p=i(n,t,d);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const A=i(o,n,d),N=i(o,t,d),$=(D,F)=>{const M=n.get(D);if(M){const U=t.get(D),G=F?U:M;return{...G,version:(U.version&&_.gt(U.version,M.version),M.version),state:R(M,U,o?.get(D)),preRelease:(0,k.isUndefined)(G.preRelease)?M.preRelease:G.preRelease}}};for(const D of N.removed.values()){const F=n.get(D);F&&w.push(F.identifier)}for(const D of N.added.values())if(A.added.has(D)){if(p.updated.has(D)){const F=$(D,!0);F&&(g.push(E(F,D)),s.set(D,F))}}else{const F=t.get(D);F.installed&&m.push(E(F,D))}for(const D of N.updated.values()){const F=$(D,!0);F&&(g.push(E(F,D)),s.set(D,F))}for(const D of A.added.values())N.added.has(D)||s.set(D,n.get(D));for(const D of A.updated.values())if(!N.removed.has(D)&&!N.updated.has(D)){const F=$(D,!1);F&&(s.get(D)?.installed&&(F.installed=!0),s.set(D,F))}for(const D of A.removed.values())!c.has(D)&&!N.updated.has(D)&&o?.get(D)?.installed&&s.delete(D)}const P=[],O=i(t,s,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(O.added.size>0||O.updated.size>0||O.removed.size>0)&&s.forEach((A,N)=>P.push(E(A,N))),{local:{added:m,removed:w,updated:g},remote:P.length?{added:[...O.added].map(A=>s.get(A)),updated:[...O.updated].map(A=>s.get(A)),removed:[...O.removed].map(A=>t.get(A)),all:P}:null}}e.merge=L;function i(f,S,h,{checkInstalledProperty:y,checkVersionProperty:v}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=f?[...f.keys()].filter(r=>!h.has(r)):[],w=[...S.keys()].filter(r=>!h.has(r)),g=w.filter(r=>m.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),l=m.filter(r=>w.indexOf(r)===-1).reduce((r,a)=>(r.add(a),r),new Set),u=new Set;for(const r of m){if(l.has(r))continue;const a=f.get(r),n=S.get(r);(!n||a.disabled!==n.disabled||a.preRelease!==n.preRelease||!C(a.state,n.state)||v&&a.version!==n.version||y&&a.installed!==n.installed)&&u.add(r)}return{added:g,removed:l,updated:u}}function R(f,S,h){const y=f.state,v=S.state,m=h?.state;if(!S.version||y&&_.gt(f.version,S.version))return y;if(v&&_.gt(S.version,f.version)||!y)return v;if(!v)return y;const w=(0,T.deepClone)(y),g=m?b(m,v):{added:Object.keys(v).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set},l=m?b(m,y):{added:Object.keys(y).reduce((u,r)=>(u.add(r),u),new Set),removed:new Set,updated:new Set};for(const u of[...g.added.values(),...g.updated.values()])w[u]=v[u];for(const u of g.removed.values())l.updated.has(u)||delete w[u];return w}function b(f,S){const h=Object.keys(f),y=Object.keys(S),v=y.filter(g=>h.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),m=h.filter(g=>y.indexOf(g)===-1).reduce((g,l)=>(g.add(l),g),new Set),w=new Set;for(const g of h){if(m.has(g))continue;const l=f[g],u=S[g];(0,T.equals)(l,u)||w.add(g)}return{added:v,removed:m,updated:w}}function C(f={},S={}){const{added:h,removed:y,updated:v}=b(f,S);return h.size===0&&y.size===0&&v.size===0}function I(f){return{...f,disabled:!!f.disabled,installed:!!f.installed}}function E(f,S){const h={identifier:{id:f.identifier.id,uuid:S.startsWith("uuid:")?S.substring("uuid:".length):void 0},preRelease:!!f.preRelease};return f.version&&(h.version=f.version),f.disabled&&(h.disabled=!0),f.installed&&(h.installed=!0),f.state&&(h.state=f.state),h}}),define(te[97],ne([0,1,16,3,2,34,6,26,23]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,i.createDecorator)("IExtensionsStorageSyncService");const C=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let I=class it extends k.Disposable{constructor(f,S){super();this.storageService=f,this.productService=S,this._onDidChangeExtensionsStorage=this._register(new _.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(f){return`extensionKeys/${(0,L.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const S=C.exec(f);if(S&&S[1])return{id:S[1],version:S[2]}}initialize(){const f=this.storageService.keys(0,1);for(const S of f){const h=it.fromKey(S);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const S=it.fromKey(f.key);if(S){this.extensionsWithKeysForSync.add(S.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(f,S){this.storageService.store(it.toKey(f),JSON.stringify(S),0,1)}getKeysForSync(f){const S=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],h=this.storageService.get(it.toKey(f),0),y=h?JSON.parse(h):void 0;return y&&S?(0,T.distinct)([...y,...S]):y||S}};I=de([J(0,b.IStorageService),J(1,R.IProductService)],I),e.ExtensionsStorageSyncService=I}),define(te[98],ne([0,1,16,21,6]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(R){this.configurationService=R}hasToNeverSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(R.toLowerCase())}hasToAlwaysSyncExtension(R){return this.getConfiguredIgnoredExtensions().includes(`-${R.toLowerCase()}`)}updateIgnoredExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==R&&I!==`-${R}`),b&&C.push(R.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}updateSynchronizedExtensions(R,b){let C=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(I=>I.toLowerCase());return C=C.filter(I=>I!==R&&I!==`-${R}`),b&&C.push(`-${R.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",C.length?C:void 0,1)}getIgnoredExtensions(R){const b=R.filter(f=>f.isMachineScoped).map(f=>f.identifier.id.toLowerCase()),C=this.getConfiguredIgnoredExtensions().map(f=>f.toLowerCase()),I=[],E=[];if(Array.isArray(C))for(const f of C)f.startsWith("-")?E.push(f.substring(1)):I.push(f);return(0,T.distinct)([...b,...I].filter(f=>E.indexOf(f)===-1))}getConfiguredIgnoredExtensions(){let R=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return R!==void 0||(R=this.configurationService.inspect("sync.ignoredExtensions").userValue,R!==void 0)?R:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(b=>b.toLowerCase())}};L=de([J(0,_.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(te[217],ne([0,1,16,31,28,159,51]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function R(l){return(0,_.parse)(l)||[]}e.parseKeybindings=R;async function b(l,u,r,a,n){const t=R(l),s=R(u),o=r?R(r):null,c=[...t,...s,...o||[]].map(U=>U.key),d=await n.resolveUserBindings(c);let p=I(t,s,o,d);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:l,hasChanges:!0,hasConflicts:!1};const P=f(t),O=f(s),A=o?f(o):null,N=h(P,O,d),$=A?h(A,P,d):{added:[...P.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},D=A?h(A,O,d):{added:[...O.keys()].reduce((U,G)=>(U.add(G),U),new Set),removed:new Set,updated:new Set},F=C(N,$,D);let M=l;for(const U of F.removed.values())F.conflicts.has(U)||(M=w(M,U,a));for(const U of F.added.values()){if(F.conflicts.has(U))continue;const G=O.get(U);if(G.some(ee=>ee.command!==`-${U}`&&p.conflicts.has(d[ee.key]))){F.conflicts.add(U);continue}M=m(M,G,a)}for(const U of F.updated.values()){if(F.conflicts.has(U))continue;const G=O.get(U);if(G.some(ee=>ee.command!==`-${U}`&&p.conflicts.has(d[ee.key]))){F.conflicts.add(U);continue}M=g(M,U,G,a)}return{mergeContent:M,hasChanges:!0,hasConflicts:F.conflicts.size>0}}e.merge=b;function C(l,u,r){const a=new Set,n=new Set,t=new Set,s=new Set;for(const o of u.removed.values())r.updated.has(o)&&s.add(o);for(const o of r.removed.values())s.has(o)||(u.updated.has(o)?s.add(o):n.add(o));for(const o of u.added.values())s.has(o)||r.added.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.added.values())s.has(o)||(u.added.has(o)?l.updated.has(o)&&s.add(o):a.add(o));for(const o of u.updated.values())s.has(o)||r.updated.has(o)&&l.updated.has(o)&&s.add(o);for(const o of r.updated.values())s.has(o)||(u.updated.has(o)?l.updated.has(o)&&s.add(o):t.add(o));return{added:a,removed:n,updated:t,conflicts:s}}function I(l,u,r,a){const n=new Set,t=E(l,a),s=E(u,a),o=r?E(r,a):null,c=S(t,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const d=o?S(o,t):{added:[...t.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const p=o?S(o,s):{added:[...s.keys()].reduce(($,D)=>($.add(D),$),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:P,removed:O,updated:A,conflicts:N}=C(c,d,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:P,removed:O,updated:A,conflicts:N}}function E(l,u){const r=new Map;for(const a of l){const n=u[a.key];let t=r.get(n);t||(t=[],r.set(n,t)),t.push(a)}return r}function f(l){const u=new Map;for(const r of l){const a=r.command[0]==="-"?r.command.substring(1):r.command;let n=u.get(a);n||(n=[],u.set(a,n)),n.push(r)}return u}function S(l,u){const r=[...l.keys()],a=[...u.keys()],n=a.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),t=r.filter(o=>a.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of r){if(t.has(o))continue;const c=l.get(o).map(p=>({...p,key:o})),d=u.get(o).map(p=>({...p,key:o}));(0,T.equals)(c,d,(p,P)=>v(p,P))||s.add(o)}return{added:n,removed:t,updated:s}}function h(l,u,r){const a=[...l.keys()],n=[...u.keys()],t=n.filter(c=>a.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),s=a.filter(c=>n.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),o=new Set;for(const c of a){if(s.has(c))continue;const d=l.get(c).map(P=>({...P,key:r[P.key]})),p=u.get(c).map(P=>({...P,key:r[P.key]}));y(d,p)||o.add(c)}return{added:t,removed:s,updated:o}}function y(l,u){return!(!(0,T.equals)(l.filter(({command:r})=>r[0]!=="-"),u.filter(({command:r})=>r[0]!=="-"),(r,a)=>v(r,a))||!(0,T.equals)(l.filter(({command:r})=>r[0]==="-"),u.filter(({command:r})=>r[0]==="-"),(r,a)=>v(r,a)))}function v(l,u){if(l.command!==u.command||l.key!==u.key)return!1;const r=L.ContextKeyExpr.deserialize(l.when),a=L.ContextKeyExpr.deserialize(u.when);return!(r&&!a||!r&&a||r&&a&&!r.equals(a)||!k.equals(l.args,u.args))}function m(l,u,r){for(const a of u)l=i.edit(l,[-1],a,r);return l}function w(l,u,r){const a=R(l);for(let n=a.length-1;n>=0;n--)(a[n].command===u||a[n].command===`-${u}`)&&(l=i.edit(l,[n],void 0,r));return l}function g(l,u,r,a){const n=R(l),t=n.findIndex(s=>s.command===u||s.command===`-${u}`);for(let s=n.length-1;s>=0;s--)(n[s].command===u||n[s].command===`-${u}`)&&(l=i.edit(l,[s],void 0,a));for(let s=r.length-1;s>=0;s--)l=i.edit(l,[t],r[s],a);return l}}),define(te[218],ne([0,1]),function(Q,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function T(L,i,R){const b={},C={},I=new Set;if(!i)return{local:{added:b,updated:C,removed:[...I.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const E=_(L,i);if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{local:{added:b,updated:C,removed:[...I.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const f=_(R,L),S=_(R,i),h={},y={},v=new Set,m=new Set;for(const w of f.removed.values())S.updated.has(w)?b[w]=i[w]:v.add(w);for(const w of S.removed.values())m.has(w)||(f.updated.has(w)?m.add(w):I.add(w));for(const w of f.updated.values())m.has(w)||(S.updated.has(w)?E.updated.has(w)&&m.add(w):y[w]=L[w]);for(const w of S.updated.values())m.has(w)||(f.updated.has(w)?E.updated.has(w)&&m.add(w):L[w]!==void 0&&(C[w]=i[w]));for(const w of f.added.values())m.has(w)||(S.added.has(w)?E.updated.has(w)&&m.add(w):h[w]=L[w]);for(const w of S.added.values())m.has(w)||(f.added.has(w)?E.updated.has(w)&&m.add(w):b[w]=i[w]);return{local:{added:b,removed:[...I.values()],updated:C},remote:{added:h,removed:[...v.values()],updated:y},conflicts:[...m.values()]}}e.merge=T;function _(L,i){const R=L?Object.keys(L):[],b=i?Object.keys(i):[],C=b.filter(f=>R.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),I=R.filter(f=>b.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),E=new Set;for(const f of R){if(I.has(f))continue;const S=L[f],h=i[f];S!==h&&E.add(f)}return{added:C,removed:I,updated:E}}function k(L,i){const{added:R,removed:b,updated:C}=_(L,i);return R.size===0&&b.size===0&&C.size===0}e.areSame=k}),define(te[24],ne([0,1,16,18,15,147,41,29,6,87,37]),function(Q,e,T,_,k,L,i,R,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function E(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties();return Object.keys(o).filter(c=>!!o[c].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=E;function f(){const o=I.Registry.as(i.Extensions.Configuration).getConfigurationProperties(),c=Object.keys(o).filter(P=>!!o[P].ignoreSync),d=Object.keys(o).filter(P=>o[P].scope===2||o[P].scope===6),p=E();return(0,T.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...c,...d,...p])}e.getDefaultIgnoredSettings=f,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function S(){const o="vscode://schemas/ignoredSettings",c=I.Registry.as(i.Extensions.Configuration);c.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:o,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const d=I.Registry.as(C.Extensions.JSONContribution),p=()=>{const P=E(),O=f().filter(D=>D!==e.CONFIGURATION_SYNC_STORE_KEY),A=Object.keys(i.allSettings.properties).filter(D=>O.indexOf(D)===-1),N=O.filter(D=>P.indexOf(D)===-1),$={items:{type:"string",enum:[...A,...N.map(D=>`-${D}`)]}};d.registerSchema(o,$)};return c.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=S;function h(o){return o&&(0,k.isObject)(o)&&(0,k.isString)(o.id)&&(0,k.isArray)(o.scopes)}e.isAuthenticationProvider=h;var y;(function(o){o.Settings="settings",o.Keybindings="keybindings",o.Snippets="snippets",o.Extensions="extensions",o.GlobalState="globalState"})(y=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function v(o,c,d){return d.joinPath(c.userDataSyncHome,o,`lastSync${o}.json`)}e.getLastSyncResourceUri=v,e.IUserDataSyncStoreManagementService=(0,b.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,b.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,b.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(o){const c={};return c[e.HEADER_EXECUTION_ID]=o,c}e.createSyncHeaders=m;var w;(function(o){o.Unauthorized="Unauthorized",o.Conflict="Conflict",o.Gone="Gone",o.PreconditionFailed="PreconditionFailed",o.TooLarge="TooLarge",o.UpgradeRequired="UpgradeRequired",o.PreconditionRequired="PreconditionRequired",o.TooManyRequests="RemoteTooManyRequests",o.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",o.RequestFailed="RequestFailed",o.RequestCanceled="RequestCanceled",o.RequestTimeout="RequestTimeout",o.RequestProtocolNotSupported="RequestProtocolNotSupported",o.RequestPathNotEscaped="RequestPathNotEscaped",o.RequestHeadersNotObject="RequestHeadersNotObject",o.NoRef="NoRef",o.EmptyResponse="EmptyResponse",o.TurnedOff="TurnedOff",o.SessionExpired="SessionExpired",o.ServiceChanged="ServiceChanged",o.DefaultServiceChanged="DefaultServiceChanged",o.LocalTooManyRequests="LocalTooManyRequests",o.LocalPreconditionFailed="LocalPreconditionFailed",o.LocalInvalidContent="LocalInvalidContent",o.LocalError="LocalError",o.IncompatibleLocalContent="IncompatibleLocalContent",o.IncompatibleRemoteContent="IncompatibleRemoteContent",o.UnresolvedConflicts="UnresolvedConflicts",o.Unknown="Unknown"})(w=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class g extends Error{constructor(c,d,p,P){super(c);this.code=d,this.resource=p,this.operationId=P,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=g;class l extends g{constructor(c,d,p,P,O){super(c,p,void 0,O);this.url=d,this.serverCode=P}}e.UserDataSyncStoreError=l;class u extends g{constructor(c,d){super(c,d)}}e.UserDataAutoSyncError=u,function(o){function c(d){if(d instanceof o)return d;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(d.name);if(p&&p[1]){const P=p[2]==="unknown"?void 0:p[2],O=p[3]==="unknown"?void 0:p[3];return new o(d.message,p[1],P,O)}return new o(d.message,"Unknown")}o.toUserDataSyncError=c}(g=e.UserDataSyncError||(e.UserDataSyncError={}));var r;(function(o){o.Uninitialized="uninitialized",o.Idle="idle",o.Syncing="syncing",o.HasConflicts="hasConflicts"})(r=e.SyncStatus||(e.SyncStatus={}));var a;(function(o){o[o.None=0]="None",o[o.Added=1]="Added",o[o.Modified=2]="Modified",o[o.Deleted=3]="Deleted"})(a=e.Change||(e.Change={}));var n;(function(o){o.Preview="preview",o.Conflict="conflict",o.Accepted="accepted"})(n=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function t(o){return`sync.enable.${o}`}e.getEnablementKey=t,e.IUserDataSyncEnablementService=(0,b.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,b.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,b.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,b.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,b.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function s(o,c){if(o.scheme!==e.USER_DATA_SYNC_SCHEME)return o=o.with({scheme:c.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(d=>(0,_.isEqualOrParent)(o,(0,_.joinPath)(c.userDataSyncHome,d,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=s}),define(te[46],ne([0,1,16,5,19,27,3,31,2,25,15,7,143,21,11,14,8,45,23,22,35,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(o){return!!(o&&o.version!==void 0&&typeof o.version=="number"&&o.content!==void 0&&typeof o.content=="string"&&(Object.keys(o).length===2||Object.keys(o).length===3&&o.machineId!==void 0&&typeof o.machineId=="string"))}e.isSyncData=r;let a=class extends b.Disposable{constructor(c,d,p,P,O,A,N,$,D,F,M){super();this.resource=c,this.fileService=d,this.environmentService=p,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=A,this.userDataSyncEnablementService=N,this.telemetryService=$,this.logService=D,this.configurationService=F,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new i.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new i.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new _.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new i.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,C.uppercaseFirstLetter)(this.resource),this.extUri=M.extUri,this.syncFolder=this.extUri.joinPath(p.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(c,p,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(p,d,P)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const d=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(d)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?await this.hasRemoteChanged(c):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const d=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),d==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,d={}){await this._sync(c,!0,this.getUserDataSyncConfiguration(),d)}async preview(c,d,p={}){return this._sync(c,!1,d,p)}async apply(c,d={}){try{this.syncHeaders={...d};const p=await this.doApply(c);return this.setStatus(p),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,d,p,P){try{if(this.syncHeaders={...P},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const A=await this.getLastSyncUserData(),N=await this.getLatestRemoteUserData(c,A);return O=await this.performSync(N,A,d,p),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(c){const d=await this.resolveContent(c);if(!d)return!1;const p=this.parseSyncData(d);if(!p)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const P=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,P),A=await this.isRemoteDataFromCurrentMachine(O),N=await this.generateSyncPreview({ref:O.ref,syncData:p},P,A,this.getUserDataSyncConfiguration(),L.CancellationToken.None),$=[];for(const D of N){const F=await this.getAcceptResult(D,D.remoteResource,void 0,L.CancellationToken.None),{remoteChange:M}=await this.getAcceptResult(D,D.previewResource,D.remoteContent,L.CancellationToken.None);$.push([D,{...F,remoteChange:M!==0?M:2}])}await this.applyResult(O,P,$,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const d=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===d}async getLatestRemoteUserData(c,d){if(d){const p=c&&c.latest?c.latest[this.resource]:void 0;if(d.ref===p||p===void 0&&d.syncData===null)return d}return this.getRemoteUserData(d)}async performSync(c,d,p,P){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,f.localize)(0,null,this.resource,this.version,c.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(c,d,p,P)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,d,p,P);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),d=await this.getLastSyncUserData(),this.performSync(c,d,p,P)}throw O}}async doSync(c,d,p,P){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,_.createCancelablePromise)(A=>this.doGenerateSyncResourcePreview(c,d,p,P,A)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:A})=>A==="conflict")?"hasConflicts":p?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(c){return await this.updateSyncResourcePreview(c,async d=>{const p=await this.getMergeResult(d,L.CancellationToken.None);await this.fileService.writeFile(d.previewResource,k.VSBuffer.fromString(p?.content||""));const P=p&&!p.hasConflicts?await this.getAcceptResult(d,d.previewResource,void 0,L.CancellationToken.None):void 0;return d.acceptResult=P,d.mergeState=p.hasConflicts?"conflict":P?"accepted":"preview",d.localChange=P?P.localChange:p.localChange,d.remoteChange=P?P.remoteChange:p.remoteChange,d}),this.syncPreviewPromise}async accept(c,d){return await this.updateSyncResourcePreview(c,async p=>{const P=await this.getAcceptResult(p,c,d,L.CancellationToken.None);return p.acceptResult=P,p.mergeState="accepted",p.localChange=P.localChange,p.remoteChange=P.remoteChange,p}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async d=>{const p=await this.getMergeResult(d,L.CancellationToken.None);return await this.fileService.writeFile(d.previewResource,k.VSBuffer.fromString(p.content||"")),d.acceptResult=void 0,d.mergeState="preview",d.localChange=p.localChange,d.remoteChange=p.remoteChange,d}),this.syncPreviewPromise}async updateSyncResourcePreview(c,d){if(!this.syncPreviewPromise)return;let p=await this.syncPreviewPromise;const P=p.resourcePreviews.findIndex(({localResource:O,remoteResource:A,previewResource:N})=>this.extUri.isEqual(O,c)||this.extUri.isEqual(A,c)||this.extUri.isEqual(N,c));P!==-1&&(this.syncPreviewPromise=(0,_.createCancelablePromise)(async O=>{const A=[...p.resourcePreviews];return A[P]=await d(A[P]),{...p,resourcePreviews:A}}),p=await this.syncPreviewPromise,this.updateConflicts(p.resourcePreviews),p.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const d=await this.syncPreviewPromise;return d.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":d.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.applyResult(d.remoteUserData,d.lastSyncUserData,d.resourcePreviews.map(p=>[p,p.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const d=c.filter(({mergeState:p})=>p==="conflict");(0,T.equals)(this._conflicts,d,(p,P)=>this.extUri.isEqual(p.previewResource,P.previewResource))||(this._conflicts=d,this._onDidChangeConflicts.fire(d))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:d,ref:p})=>({created:d,uri:this.toRemoteBackupResource(p)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:d,ref:p})=>({created:d,uri:this.toLocalBackupResource(p)}))}toRemoteBackupResource(c){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return E.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const d=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(d))){const{content:p}=await this.getUserData(d);if(p)return this.parseSyncData(p)?.machineId}}async resolveContent(c){const d=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(d))){const{content:p}=await this.getUserData(d);return p}return this.extUri.isEqual(c,this.toLocalBackupResource(d))?this.userDataSyncBackupStoreService.resolveContent(this.resource,d):null}async resolvePreviewContent(c){const d=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(d)for(const p of d.resourcePreviews){if(this.extUri.isEqual(p.acceptedResource,c))return p.acceptResult?p.acceptResult.content:null;if(this.extUri.isEqual(p.remoteResource,c))return p.remoteContent;if(this.extUri.isEqual(p.localResource,c))return p.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,d,p,P,O){const A=await this.isRemoteDataFromCurrentMachine(c),N=await this.generateSyncPreview(c,d,A,P,O),$=[];for(const D of N){const F=D.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(D.localChange===0&&D.remoteChange===0)$.push({...D,acceptedResource:F,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const M=p?await this.getMergeResult(D,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(D.previewResource,k.VSBuffer.fromString(M?.content||""));const U=M&&!M.hasConflicts?await this.getAcceptResult(D,D.previewResource,void 0,O):void 0;$.push({...D,acceptResult:U,mergeState:M?.hasConflicts?"conflict":U?"accepted":"preview",localChange:U?U.localChange:M?M.localChange:D.localChange,remoteChange:U?U.remoteChange:M?M.remoteChange:D.remoteChange})}}return{remoteUserData:c,lastSyncUserData:d,resourcePreviews:$,isLastSyncFromCurrentMachine:A}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),d=JSON.parse(c.value.toString()),p=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=d.version&&p&&d.version!==p,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${d.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;const P=d;if(P.content===null)return{ref:d.ref,syncData:null};const O=JSON.parse(P.content);if(r(O))return{...d,syncData:O,content:void 0}}catch(c){c instanceof y.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,d={}){if(d.ref||d.content||d.version)throw new Error("Cannot have core properties as additional");const p=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),P={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:p,...d};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(P)))}async getRemoteUserData(c){const{ref:d,content:p}=await this.getUserData(c);let P=null;return p!==null&&(P=this.parseSyncData(p)),{ref:d,syncData:P}}parseSyncData(c){try{const d=JSON.parse(c);if(r(d))return d}catch(d){this.logService.error(d)}throw new u.UserDataSyncError((0,f.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(c){if((0,I.isString)(c)){const d=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:d}}else{const d=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,d,this.syncHeaders)}}async updateRemoteUserData(c,d){const p=await this.currentMachineIdPromise,P={version:this.version,machineId:p,content:c};return d=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(P),d,this.syncHeaders),{ref:d,syncData:P}}async backupLocal(c){const d={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(d))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};a=de([J(1,y.IFileService),J(2,h.IEnvironmentService),J(3,w.IStorageService),J(4,u.IUserDataSyncStoreService),J(5,u.IUserDataSyncBackupStoreService),J(6,u.IUserDataSyncEnablementService),J(7,g.ITelemetryService),J(8,u.IUserDataSyncLogService),J(9,S.IConfigurationService),J(10,l.IUriIdentityService)],a),e.AbstractSynchroniser=a;let n=class extends a{constructor(c,d,p,P,O,A,N,$,D,F,M,U){super(d,p,P,O,A,N,$,D,F,M,U);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(G=>this.onFileChanges(G)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,d,p){try{d?await this.writeFileContent(c,d,p):await this.fileService.createFile(this.file,k.VSBuffer.fromString(c),{overwrite:p})}catch(P){throw P instanceof y.FileOperationError&&P.fileOperationResult===1||P instanceof y.FileOperationError&&P.fileOperationResult===3?new u.UserDataSyncError(P.message,"LocalPreconditionFailed"):P}}async writeFileContent(c,d,p){await this.fileService.writeFile(this.file,k.VSBuffer.fromString(c),p?void 0:d)}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};n=de([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,u.IUserDataSyncLogService),J(10,S.IConfigurationService),J(11,l.IUriIdentityService)],n),e.AbstractFileSynchroniser=n;let t=class extends n{constructor(c,d,p,P,O,A,N,$,D,F,M,U,G){super(c,d,p,P,O,A,N,$,D,F,U,G);this.userDataSyncUtilService=M,this._formattingOptions=void 0}hasErrors(c){const d=[];return(0,R.parse)(c,d,{allowEmptyContent:!0,allowTrailingComma:!0}),d.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};t=de([J(2,y.IFileService),J(3,h.IEnvironmentService),J(4,w.IStorageService),J(5,u.IUserDataSyncStoreService),J(6,u.IUserDataSyncBackupStoreService),J(7,u.IUserDataSyncEnablementService),J(8,g.ITelemetryService),J(9,u.IUserDataSyncLogService),J(10,u.IUserDataSyncUtilService),J(11,S.IConfigurationService),J(12,l.IUriIdentityService)],t),e.AbstractJsonFileSynchroniser=t;let s=class{constructor(c,d,p,P,O){this.resource=c,this.environmentService=d,this.logService=p,this.fileService=P,this.extUri=O.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,d,this.extUri)}async initialize({ref:c,content:d}){if(!d){this.logService.info("Remote content does not exist.",this.resource);return}const p=this.parseSyncData(d);if(!!p)try{await this.doInitialize({ref:c,syncData:p})}catch(P){this.logService.error(P)}}parseSyncData(c){try{const d=JSON.parse(c);if(r(d))return d}catch(d){this.logService.error(d)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,d={}){const p={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...d};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(p)))}};s=de([J(1,h.IEnvironmentService),J(2,v.ILogService),J(3,y.IFileService),J(4,l.IUriIdentityService)],s),e.AbstractInitializer=s}),define(te[219],ne([0,1,5,27,10,3,25,7,21,11,29,34,14,8,23,22,35,46,216,97,98,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function r(o,c){const d=JSON.parse(o.content);if(o.version===1||o.version===2){const p=(await c.getInstalled(0)).filter(P=>P.isBuiltin);for(const P of d)o.version===1&&(P.enabled===!1&&(P.disabled=!0),delete P.enabled),o.version===2&&p.every(O=>!(0,E.areSameExtensions)(O.identifier,P.identifier))&&(P.installed=!0)}return d}function a(o,c,d){const p=d.get((0,E.getExtensionId)(o,c),0)||"{}";return JSON.parse(p)}e.getExtensionStorageState=a;function n(o,c,d,p){p.store((0,E.getExtensionId)(o,c),JSON.stringify(d),0,1)}e.storeExtensionStorageState=n;let t=class mt extends m.AbstractSynchroniser{constructor(c,d,p,P,O,A,N,$,D,F,M,U,G,ee,V){super("extensions",d,c,p,P,O,U,G,D,M,V);this.storageService=p,this.extensionManagementService=A,this.extensionEnablementService=N,this.ignoredExtensionsManagementService=$,this.extensionGalleryService=F,this.extensionsStorageSyncService=ee,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,j=>j.some(({local:Z})=>!!Z)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,j=>!j.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}async generateSyncPreview(c,d){const p=c.syncData?await r(c.syncData,this.extensionManagementService):null,P=d?.skippedExtensions||[],O=d?.syncData?await r(d.syncData,this.extensionManagementService):null,A=await this.extensionManagementService.getInstalled(void 0,!0),N=this.getLocalExtensions(A),$=this.ignoredExtensionsManagementService.getIgnoredExtensions(A);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:D,remote:F}=(0,w.merge)(N,p,O,P,$),M={local:D,remote:F,content:this.getPreviewContent(N,D.added,D.updated,D.removed),localChange:D.added.length>0||D.removed.length>0||D.updated.length>0?2:0,remoteChange:F!==null?2:0};return[{skippedExtensions:P,localResource:this.localResource,localContent:this.stringify(N,!1),localExtensions:N,remoteResource:this.remoteResource,remoteContent:p?this.stringify(p,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(c){const d=c.syncData?await r(c.syncData,this.extensionManagementService):null,p=await this.extensionManagementService.getInstalled(void 0,!0),P=this.getLocalExtensions(p),O=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),{remote:A}=(0,w.merge)(P,d,d,c.skippedExtensions||[],O);return A!==null}getPreviewContent(c,d,p,P){const O=[...d,...p],A=new Set,N=$=>{A.add($.id.toLowerCase()),$.uuid&&A.add($.uuid)};O.forEach(({identifier:$})=>N($)),P.forEach(N);for(const $ of c)A.has($.identifier.id.toLowerCase())||$.identifier.uuid&&A.has($.identifier.uuid)||O.push($);return this.stringify(O,!1)}async getMergeResult(c,d){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,d,p,P){if(this.extUri.isEqual(d,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(d,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(d,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${d.toString()}`)}async acceptLocal(c){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),P=(0,w.merge)(c.localExtensions,null,null,c.skippedExtensions,p),{local:O,remote:A}=P;return{content:c.localContent,local:O,remote:A,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:A!==null?2:0}}async acceptRemote(c){const d=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(d),P=c.remoteContent?JSON.parse(c.remoteContent):null;if(P!==null){const O=(0,w.merge)(c.localExtensions,P,c.localExtensions,[],p),{local:A,remote:N}=O;return{content:c.remoteContent,local:A,remote:N,localChange:A.added.length>0||A.removed.length>0||A.updated.length>0?2:0,remoteChange:N!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,d,p,P){let{skippedExtensions:O,localExtensions:A}=p[0][0],{local:N,remote:$,localChange:D,remoteChange:F}=p[0][1];if(D===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),D!==0&&(await this.backupLocal(JSON.stringify(A)),O=await this.updateLocalExtensions(N.added,N.removed,N.updated,O)),$){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const M=JSON.stringify($.all);c=await this.updateRemoteUserData(M,P?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${$.added.length?` Added: ${JSON.stringify($.added.map(U=>U.identifier.id))}.`:""}${$.updated.length?` Updated: ${JSON.stringify($.updated.map(U=>U.identifier.id))}.`:""}${$.removed.length?` Removed: ${JSON.stringify($.removed.map(U=>U.identifier.id))}.`:""}`)}d?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:O}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${O.length?` Skipped: ${JSON.stringify(O.map(M=>M.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:mt.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,mt.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),P=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),O=this.getLocalExtensions(p).filter(A=>!P.some(N=>(0,E.areSameExtensions)({id:N},A.identifier)));return this.stringify(O,!0)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c)){const p=await this.resolvePreviewContent(c);return p&&this.stringify(JSON.parse(p),!0)}let d=await super.resolveContent(c);if(d)return d;if(d=await super.resolveContent(this.extUri.dirname(c)),d){const p=this.parseSyncData(d);if(p)switch(this.extUri.basename(c)){case"extensions.json":return this.stringify(this.parseExtensions(p),!0)}}return null}stringify(c,d){return c.sort((p,P)=>!p.identifier.uuid&&P.identifier.uuid?-1:p.identifier.uuid&&!P.identifier.uuid?1:(0,i.compare)(p.identifier.id,P.identifier.id)),d?JSON.stringify(c,null,"	"):JSON.stringify(c)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(p=>p.installed||p.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,d,p,P){const O=[],A=[],N=await this.extensionManagementService.getInstalled();if(d.length){const D=N.filter(({identifier:F,isBuiltin:M})=>!M&&d.some(U=>(0,E.areSameExtensions)(F,U)));await T.Promises.settled(D.map(async F=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,F.identifier.id),await this.extensionManagementService.uninstall(F,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,F.identifier.id),O.push(F.identifier)}))}(c.length||p.length)&&await T.Promises.settled([...c,...p].map(async D=>{const F=N.find(U=>(0,E.areSameExtensions)(U.identifier,D.identifier));if(F&&F.isBuiltin){D.state&&F.manifest.version===D.version&&this.updateExtensionState(D.state,F.manifest.publisher,F.manifest.name,F.manifest.version),this.extensionEnablementService.getDisabledExtensions().some(G=>(0,E.areSameExtensions)(G,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id),await this.extensionEnablementService.disableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id),await this.extensionEnablementService.enableExtension(D.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id))),O.push(D.identifier);return}const M=(await this.extensionGalleryService.getExtensions([D.identifier],!!D.preRelease,_.CancellationToken.None))[0];if(D.state&&(F?F.manifest.version===D.version:!!M)){const U=F?F.manifest.publisher:M.publisher,G=F?F.manifest.name:M.name;this.updateExtensionState(D.state,U,G,F?.manifest.version)}if(M)try{this.extensionEnablementService.getDisabledExtensions().some(G=>(0,E.areSameExtensions)(G,D.identifier))!==!!D.disabled&&(D.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,D.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,D.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,D.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,D.identifier.id,M.version))),(!F||F.preRelease!==D.preRelease)&&(await this.extensionManagementService.canInstall(M)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,D.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:D.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,D.identifier.id,M.version),O.push(M.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,M.displayName||M.identifier.id),A.push(D)))}catch(U){A.push(D),U instanceof I.ExtensionManagementError&&[I.ExtensionManagementErrorCode.Incompatible,I.ExtensionManagementErrorCode.IncompatiblePreRelease,I.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(U.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,M.displayName||M.identifier.id):(this.logService.error(U),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id))}else A.push(D),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,D.identifier.id)}));const $=[];for(const D of P)O.some(F=>(0,E.areSameExtensions)(F,D.identifier))||$.push(D);for(const D of A)$.some(F=>(0,E.areSameExtensions)(F.identifier,D.identifier))||$.push(D);return $}updateExtensionState(c,d,p,P){const O=a(d,p,this.storageService),A=P?this.extensionsStorageSyncService.getKeysForSync({id:(0,E.getGalleryExtensionId)(d,p),version:P}):void 0;A?A.forEach(N=>{O[N]=c[N]}):Object.keys(c).forEach(N=>O[N]=c[N]),n(d,p,O,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const d=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:p,isBuiltin:P,manifest:O,preRelease:A})=>{const N={identifier:p,preRelease:A,version:O.version};d.some($=>(0,E.areSameExtensions)($,p))&&(N.disabled=!0),P||(N.installed=!0);try{const $=this.extensionsStorageSyncService.getKeysForSync({id:p.id,version:O.version});if($){const D=a(O.publisher,O.name,this.storageService);N.state=Object.keys(D).reduce((F,M)=>($.includes(M)&&(F[M]=D[M]),F),{})}}catch($){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)($))}return N})}};t.EXTENSIONS_DATA_URI=R.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),t=de([J(0,C.IEnvironmentService),J(1,f.IFileService),J(2,h.IStorageService),J(3,u.IUserDataSyncStoreService),J(4,u.IUserDataSyncBackupStoreService),J(5,I.IExtensionManagementService),J(6,I.IGlobalExtensionEnablementService),J(7,l.IIgnoredExtensionsManagementService),J(8,u.IUserDataSyncLogService),J(9,I.IExtensionGalleryService),J(10,b.IConfigurationService),J(11,u.IUserDataSyncEnablementService),J(12,y.ITelemetryService),J(13,g.IExtensionsStorageSyncService),J(14,v.IUriIdentityService)],t),e.ExtensionsSynchroniser=t;let s=class extends m.AbstractInitializer{constructor(c,d,p,P,O,A){super("extensions",P,O,p,A);this.extensionManagementService=c,this.ignoredExtensionsManagementService=d}async parseExtensions(c){return c.syncData?await r(c.syncData,this.extensionManagementService):null}generatePreview(c,d){const p=[],P=[],O=[];for(const A of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(A.identifier.id))continue;const N=d.find($=>(0,E.areSameExtensions)($.identifier,A.identifier));N?(p.push(N),A.disabled&&O.push(A.identifier)):A.installed&&(P.push(A.identifier),A.disabled&&O.push(A.identifier))}return{installedExtensions:p,newExtensions:P,disabledExtensions:O,remoteExtensions:c}}};s=de([J(0,I.IExtensionManagementService),J(1,l.IIgnoredExtensionsManagementService),J(2,f.IFileService),J(3,C.IEnvironmentService),J(4,S.ILogService),J(5,v.IUriIdentityService)],s),e.AbstractExtensionsInitializer=s}),define(te[220],ne([0,1,28,24]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(R,b,C,I,E){if(!b)return{remote:Object.keys(R).length>0?R:null,local:{added:{},removed:[],updated:{}}};const f=L(R,b);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const S=C?L(C,b):{added:Object.keys(b).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},h=C?L(C,R):{added:Object.keys(R).reduce((w,g)=>(w.add(g),w),new Set),removed:new Set,updated:new Set},y={added:{},removed:[],updated:{}},v=T.deepClone(b),m=!C;for(const w of h.added.values())w!==_.SYNC_SERVICE_URL_TYPE&&m&&S.added.has(w)||(v[w]=R[w]);for(const w of h.updated.values())v[w]=R[w];for(const w of h.removed.values())I.unregistered.includes(w)||delete v[w];for(const w of S.added.values()){const g=b[w];if(I.machine.includes(w)){E.info(`GlobalState: Skipped adding ${w} in local storage because it is declared as machine scoped.`);continue}if(C&&h.added.has(w))continue;const l=R[w];l&&l.value===g.value||w===_.SYNC_SERVICE_URL_TYPE&&m&&h.added.has(w)||(l?y.updated[w]=g:y.added[w]=g)}for(const w of S.updated.values()){const g=b[w];if(I.machine.includes(w)){E.info(`GlobalState: Skipped updating ${w} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(w)||h.removed.has(w))continue;const l=R[w];l&&l.value===g.value||(y.updated[w]=g)}for(const w of S.removed.values()){if(I.machine.includes(w)){E.trace(`GlobalState: Skipped removing ${w} in local storage because it is declared as machine scoped.`);continue}h.updated.has(w)||h.removed.has(w)||y.removed.push(w)}return{local:y,remote:i(v,b)?null:v}}e.merge=k;function L(R,b){const C=Object.keys(R),I=Object.keys(b),E=I.filter(h=>C.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),f=C.filter(h=>I.indexOf(h)===-1).reduce((h,y)=>(h.add(y),h),new Set),S=new Set;for(const h of C){if(f.has(h))continue;const y=R[h],v=b[h];T.equals(y,v)||S.add(h)}return{added:E,removed:f,updated:S}}function i(R,b){const{added:C,removed:I,updated:E}=L(R,b);return C.size===0&&I.size===0&&E.size===0}}),define(te[221],ne([0,1,19,10,3,31,4,7,30,21,11,14,8,45,23,22,35,46,51,220,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const u="globalState.argv.",r=["locale"];function a(c,d){const p=c.storage?Object.keys(c.storage).sort():[],P={};return p.forEach(O=>P[O]=c.storage[O]),c.storage=P,d?JSON.stringify(c,null,"	"):JSON.stringify(c)}const n=1;let t=class vt extends m.AbstractSynchroniser{constructor(d,p,P,O,A,N,$,D,F,M){super("globalState",d,A,F,p,P,N,$,O,D,M);this.storageService=F,this.version=n,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:l.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(d.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(d.onDidFilesChange,U=>U.contains(this.environmentService.argvResource)),k.Event.filter(F.onDidChangeValue,U=>U.scope===0&&U.target!==void 0?U.target===0:F.keys(0,0).includes(U.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(d,p,P){const O=d.syncData?JSON.parse(d.syncData.content):null;p=p===null&&P?d:p;const A=p&&p.syncData?JSON.parse(p.syncData.content):null,N=await this.getLocalGlobalState();O?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const $=this.getStorageKeys(A),{local:D,remote:F}=(0,g.merge)(N.storage,O?O.storage:null,A?A.storage:null,$,this.logService),M={content:null,local:D,remote:F,localChange:Object.keys(D.added).length>0||Object.keys(D.updated).length>0||D.removed.length>0?2:0,remoteChange:F!==null?2:0};return[{localResource:this.localResource,localContent:a(N,!1),localUserData:N,remoteResource:this.remoteResource,remoteContent:O?a(O,!1):null,previewResource:this.previewResource,previewResult:M,localChange:M.localChange,remoteChange:M.remoteChange,acceptedResource:this.acceptedResource,storageKeys:$}]}async hasRemoteChanged(d){const p=d.syncData?JSON.parse(d.syncData.content):null;if(p===null)return!0;const P=await this.getLocalGlobalState(),O=this.getStorageKeys(p),{remote:A}=(0,g.merge)(P.storage,p.storage,p.storage,O,this.logService);return A!==null}async getMergeResult(d,p){return{...d.previewResult,hasConflicts:!1}}async getAcceptResult(d,p,P,O){if(this.extUri.isEqual(p,this.localResource))return this.acceptLocal(d);if(this.extUri.isEqual(p,this.remoteResource))return this.acceptRemote(d);if(this.extUri.isEqual(p,this.previewResource))return d.previewResult;throw new Error(`Invalid Resource: ${p.toString()}`)}async acceptLocal(d){return{content:d.localContent,local:{added:{},removed:[],updated:{}},remote:d.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(d){if(d.remoteContent!==null){const p=JSON.parse(d.remoteContent),{local:P,remote:O}=(0,g.merge)(d.localUserData.storage,p.storage,null,d.storageKeys,this.logService);return{content:d.remoteContent,local:P,remote:O,localChange:Object.keys(P.added).length>0||Object.keys(P.updated).length>0||P.removed.length>0?2:0,remoteChange:O!==null?2:0}}else return{content:d.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(d,p,P,O){let{localUserData:A}=P[0][0],{local:N,remote:$,localChange:D,remoteChange:F}=P[0][1];if(D===0&&F===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),D!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(A)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),F!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const M=JSON.stringify({storage:$});d=await this.updateRemoteUserData(M,O?null:d.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}p?.ref!==d.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(d),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:d}){return[{resource:this.extUri.joinPath(d,"globalState.json"),comparableResource:vt.GLOBAL_STATE_DATA_URI}]}async resolveContent(d){if(this.extUri.isEqual(d,vt.GLOBAL_STATE_DATA_URI)){const P=await this.getLocalGlobalState();return a(P,!0)}if(this.extUri.isEqual(this.remoteResource,d)||this.extUri.isEqual(this.localResource,d)||this.extUri.isEqual(this.acceptedResource,d)){const P=await this.resolvePreviewContent(d);return P&&a(JSON.parse(P),!0)}let p=await super.resolveContent(d);if(p)return p;if(p=await super.resolveContent(this.extUri.dirname(d)),p){const P=this.parseSyncData(p);if(P)switch(this.extUri.basename(d)){case"globalState.json":return a(JSON.parse(P.content),!0)}}return null}async hasLocalData(){try{const{storage:d}=await this.getLocalGlobalState();if(Object.keys(d).length>1||d[`${u}.locale`]?.value!=="en")return!0}catch(d){}return!1}async getLocalGlobalState(){const d={},p=await this.getLocalArgvContent(),P=(0,L.parse)(p);for(const O of r)P[O]!==void 0&&(d[`${u}${O}`]={version:1,value:P[O]});for(const O of this.storageService.keys(0,0)){const A=this.storageService.get(O,0);A&&(d[O]={version:1,value:A})}return{storage:d}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const d=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),d.value.toString()}catch(d){this.logService.debug((0,_.getErrorMessage)(d))}return"{}"}async writeLocalGlobalState({added:d,removed:p,updated:P}){const O={},A={},N=(D,F)=>{for(const M of D){if(M.startsWith(u)){O[M.substring(u.length)]=F?F[M].value:void 0;continue}if(F){const U=F[M];U.value!==String(this.storageService.get(M,0))&&(A[M]=U.value)}else this.storageService.get(M,0)!==void 0&&(A[M]=void 0)}};if(N(Object.keys(d),d),N(Object.keys(P),P),N(p),Object.keys(O).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(O),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(A).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const D of Object.keys(A))this.storageService.store(D,A[D],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(A))}}async updateArgv(d){const p=await this.getLocalArgvContent();let P=p;for(const O of Object.keys(d))P=(0,w.edit)(P,[O],d[O],{});p!==P&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(P)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(d){const p=this.storageService.keys(0,0),P=this.storageService.keys(0,1),O=[...p,...P],A=d?.storage?Object.keys(d.storage).filter(N=>!N.startsWith(u)&&!O.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!i.isWeb){const N=[...l.ALL_SYNC_RESOURCES.map($=>(0,l.getEnablementKey)($)),l.SYNC_SERVICE_URL_TYPE];A.push(...N),P.push(...N)}return{user:p,machine:P,unregistered:A}}};t.GLOBAL_STATE_DATA_URI=R.URI.from({scheme:l.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),t=de([J(0,E.IFileService),J(1,l.IUserDataSyncStoreService),J(2,l.IUserDataSyncBackupStoreService),J(3,l.IUserDataSyncLogService),J(4,I.IEnvironmentService),J(5,l.IUserDataSyncEnablementService),J(6,y.ITelemetryService),J(7,C.IConfigurationService),J(8,h.IStorageService),J(9,v.IUriIdentityService)],t),e.GlobalStateSynchroniser=t;let s=class extends m.AbstractInitializer{constructor(d,p,P,O,A){super("globalState",P,O,p,A);this.storageService=d}async doInitialize(d){const p=d.syncData?JSON.parse(d.syncData.content):null;if(!p){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const P={},O={};for(const A of Object.keys(p.storage))A.startsWith(u)?P[A.substring(u.length)]=p.storage[A].value:this.storageService.get(A,0)===void 0&&(O[A]=p.storage[A].value);if(Object.keys(P).length){let A="{}";try{A=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(N){}for(const N of Object.keys(P))A=(0,w.edit)(A,[N],P[N],{});await this.fileService.writeFile(this.environmentService.argvResource,T.VSBuffer.fromString(A))}if(Object.keys(O).length)for(const A of Object.keys(O))this.storageService.store(A,O[A],0,0)}};s=de([J(0,h.IStorageService),J(1,E.IFileService),J(2,I.IEnvironmentService),J(3,l.IUserDataSyncLogService),J(4,v.IUriIdentityService)],s),e.GlobalStateInitializer=s;let o=class{constructor(d,p,P,O,A){this.userDataSyncStoreClient=d,this.storageService=p,this.environmentService=P,this.fileService=O,this.logService=A}getSyncStoreType(d){return this.parseGlobalState(d)?.storage[l.SYNC_SERVICE_URL_TYPE]?.value}async sync(d){const p=(0,l.createSyncHeaders)((0,b.generateUuid)());try{return await this.doSync(d,p)}catch(P){if(P instanceof l.UserDataSyncError)switch(P.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(d,p)}throw P}}async doSync(d,p){const P=await this.userDataSyncStoreClient.read("globalState",null,p),O=this.parseGlobalState(P)||{storage:{}};O.storage[l.SYNC_SERVICE_URL_TYPE]={value:d,version:n};const A=await(0,S.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:n,machineId:A,content:a(O,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),P.ref,p)}parseGlobalState({content:d}){if(!d)return null;const p=JSON.parse(d);if((0,m.isSyncData)(p))return p?JSON.parse(p.content):null;throw new Error("Invalid remote data")}};o=de([J(1,h.IStorageService),J(2,I.IEnvironmentService),J(3,E.IFileService),J(4,f.ILogService)],o),e.UserDataSyncStoreTypeSynchronizer=o}),define(te[222],ne([0,1,16,19,3,31,4,15,144,21,11,14,23,22,35,46,217,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function w(u,r,a){try{const n=JSON.parse(u);if(!r)return(0,R.isUndefined)(n.all)?null:n.all;switch(i.OS){case 2:return(0,R.isUndefined)(n.mac)?null:n.mac;case 3:return(0,R.isUndefined)(n.linux)?null:n.linux;case 1:return(0,R.isUndefined)(n.windows)?null:n.windows}}catch(n){return a.error(n),null}}e.getKeybindingsContentFromSyncContent=w;let g=class extends y.AbstractJsonFileSynchroniser{constructor(r,a,n,t,s,o,c,d,p,P,O){super(c.keybindingsResource,"keybindings",o,c,d,r,a,s,P,n,p,t,O);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(t.onDidChangeConfiguration,A=>A.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,a,n,t){const s=r.syncData?w(r.syncData.content,t.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;a=a===null&&n?r:a;const o=a?this.getKeybindingsContentFromLastSyncUserData(a):null,c=await this.getLocalFileContent(),d=await this.getFormattingOptions();let p=null,P=!1,O=!1,A=!1;if(s){let $=c?c.value.toString():"[]";if($=$||"[]",this.hasErrors($))throw new m.UserDataSyncError((0,b.localize)(0,null),"LocalInvalidContent",this.resource);if(!o||o!==$||o!==s){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const D=await(0,v.merge)($,s,o,d,this.userDataSyncUtilService);D.hasChanges&&(p=D.mergeContent,A=D.hasConflicts,P=A||D.mergeContent!==$,O=A||D.mergeContent!==s)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),p=c.value.toString(),O=!0);const N={content:p,localChange:P?c?2:1:0,remoteChange:O?2:0,hasConflicts:A};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:N.localChange,remoteResource:this.remoteResource,remoteContent:s,remoteChange:N.remoteChange,previewResource:this.previewResource,previewResult:N,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const a=this.getKeybindingsContentFromLastSyncUserData(r);if(a===null)return!0;const n=await this.getLocalFileContent(),t=n?n.value.toString():"",s=await this.getFormattingOptions(),o=await(0,v.merge)(t||"[]",a,a,s,this.userDataSyncUtilService);return o.hasConflicts||o.mergeContent!==a}async getMergeResult(r,a){return r.previewResult}async getAcceptResult(r,a,n,t){if(this.extUri.isEqual(a,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(a,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(a,this.previewResource))return n===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:n,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${a.toString()}`)}async applyResult(r,a,n,t){const{fileContent:s}=n[0][0];let{content:o,localChange:c,remoteChange:d}=n[0][1];if(c===0&&d===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),o!==null&&(o=o.trim(),o=o||"[]",this.hasErrors(o)))throw new m.UserDataSyncError((0,b.localize)(1,null),"LocalInvalidContent",this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),s&&await this.backupLocal(this.toSyncContent(s.value.toString())),await this.updateLocalFileContent(o||"[]",s,t),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),d!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const p=this.toSyncContent(o||"[]",r.syncData?.content);r=await this.updateRemoteUserData(p,t?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(p){}a?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const a=(0,L.parse)(r.value.toString());if((0,T.isNonEmptyArray)(a))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const a=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:a}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let a=await super.resolveContent(r);if(a)return a;if(a=await super.resolveContent(this.extUri.dirname(r)),a){const n=this.parseSyncData(a);if(n)switch(this.extUri.basename(r)){case"keybindings.json":return w(n.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:w(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,a){let n={};try{n=JSON.parse(a||"{}")}catch(t){this.logService.error(t)}switch(this.syncKeybindingsPerPlatform()?delete n.all:n.all=r,i.OS){case 2:n.mac=r;break;case 3:n.linux=r;break;case 1:n.windows=r;break}return JSON.stringify(n)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};g=de([J(0,m.IUserDataSyncStoreService),J(1,m.IUserDataSyncBackupStoreService),J(2,m.IUserDataSyncLogService),J(3,C.IConfigurationService),J(4,m.IUserDataSyncEnablementService),J(5,E.IFileService),J(6,I.IEnvironmentService),J(7,f.IStorageService),J(8,m.IUserDataSyncUtilService),J(9,S.ITelemetryService),J(10,h.IUriIdentityService)],g),e.KeybindingsSynchroniser=g;let l=class extends y.AbstractInitializer{constructor(r,a,n,t){super("keybindings",a,n,r,t)}async doInitialize(r){const a=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!a){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,_.VSBuffer.fromString(a)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.environmentService.settingsResource),a=(0,L.parse)(r.value.toString());return!(0,T.isNonEmptyArray)(a)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return w(r,!0,this.logService)}catch(a){return this.logService.error(a),null}}};l=de([J(0,E.IFileService),J(1,I.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,h.IUriIdentityService)],l),e.KeybindingsInitializer=l}),define(te[223],ne([0,1,16,31,53,68,28,51,24]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function C(o,c,d){let p=[];d?p=E(d):p=I(c);const P=[],O=[...(0,b.getDisallowedIgnoredSettings)()];if(Array.isArray(p))for(const A of p)A.startsWith("-")?O.push(A.substring(1)):P.push(A);return(0,T.distinct)([...o,...P].filter(A=>O.indexOf(A)===-1))}e.getIgnoredSettings=C;function I(o){let c=o.inspect("settingsSync.ignoredSettings").userValue;return c!==void 0||(c=o.inspect("sync.ignoredSettings").userValue,c!==void 0)?c:o.getValue("settingsSync.ignoredSettings")||[]}function E(o){const c=(0,_.parse)(o);return c?c["settingsSync.ignoredSettings"]||c["sync.ignoredSettings"]||[]:[]}function f(o,c,d,p){if(d.length){const P=s(c),O=(0,_.parse)(c),A=(0,_.parse)(o),N=[];for(const $ of d){const D=O[$],F=A[$];D===void 0?o=R.edit(o,[$],void 0,p):F!==void 0?o=R.edit(o,[$],D,p):N.push(u($,P))}N.sort(($,D)=>$.startOffset-D.startOffset),N.forEach($=>o=m($.setting.key,c,o,p))}return o}e.updateIgnoredSettings=f;function S(o,c,d,p,P,O){const A=f(o,c,p,O),N=d!==A,$=d!==c;if(!N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(N&&!$)return{conflictsSettings:[],localContent:null,remoteContent:A,hasConflicts:!1};if($&&!N)return{conflictsSettings:[],localContent:f(c,o,p,O),remoteContent:null,hasConflicts:!1};if(d===null&&y(o)){const x=h(o,c,p)?null:f(c,o,p,O);return{conflictsSettings:[],localContent:x,remoteContent:null,hasConflicts:!1}}let D=o,F=c;const M=(0,_.parse)(o),U=(0,_.parse)(c),G=d?(0,_.parse)(d):null,ee=p.reduce((x,K)=>(x.add(K),x),new Set),V=v(M,U,ee),j=v(G,M,ee),Z=v(G,U,ee),W=new Map,z=new Set,B=x=>{z.add(x);const K=P.filter(({key:re})=>re===x)[0];K?(D=R.edit(D,[x],K.value,O),F=R.edit(F,[x],K.value,O)):W.set(x,{key:x,localValue:M[x],remoteValue:U[x]})};for(const x of j.removed.values())Z.updated.has(x)?B(x):F=R.edit(F,[x],void 0,O);for(const x of Z.removed.values())z.has(x)||(j.updated.has(x)?B(x):D=R.edit(D,[x],void 0,O));for(const x of j.updated.values())z.has(x)||(Z.updated.has(x)?V.updated.has(x)&&B(x):F=R.edit(F,[x],M[x],O));for(const x of Z.updated.values())z.has(x)||(j.updated.has(x)?V.updated.has(x)&&B(x):D=R.edit(D,[x],U[x],O));for(const x of j.added.values())z.has(x)||(Z.added.has(x)?V.updated.has(x)&&B(x):F=m(x,D,F,O));for(const x of Z.added.values())z.has(x)||(j.added.has(x)?V.updated.has(x)&&B(x):D=m(x,F,D,O));const q=W.size>0||!h(D,F,p),H=q||!h(D,o,[]),Y=q||!h(F,c,[]);return{localContent:H?D:null,remoteContent:Y?F:null,conflictsSettings:[...W.values()],hasConflicts:q}}e.merge=S;function h(o,c,d){if(o===c)return!0;const p=(0,_.parse)(o),P=(0,_.parse)(c),O=d.reduce(($,D)=>($.add(D),$),new Set),A=s(o).filter($=>!($.setting&&O.has($.setting.key))),N=s(c).filter($=>!($.setting&&O.has($.setting.key)));if(A.length!==N.length)return!1;for(let $=0;$<A.length;$++){const D=A[$],F=N[$];if(D.setting&&F.setting){if(D.setting.key!==F.setting.key||!i.equals(p[D.setting.key],P[D.setting.key]))return!1}else if(!D.setting&&!F.setting){if(D.value!==F.value)return!1}else return!1}return!0}e.areSame=h;function y(o){return o?s(o).length===0:!0}e.isEmpty=y;function v(o,c,d){const p=o?Object.keys(o).filter($=>!d.has($)):[],P=Object.keys(c).filter($=>!d.has($)),O=P.filter($=>p.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),A=p.filter($=>P.indexOf($)===-1).reduce(($,D)=>($.add(D),$),new Set),N=new Set;if(o)for(const $ of p){if(A.has($))continue;const D=o[$],F=c[$];i.equals(D,F)||N.add($)}return{added:O,removed:A,updated:N}}function m(o,c,d,p){const P=(0,_.parse)(c),O=s(c),A=s(d),N=w(o,O,A);return g(d,o,P[o],N,A,p)}e.addSetting=m;function w(o,c,d){const p=c.findIndex(O=>O.setting?.key===o),P=c[p-1];if(P){if(P.setting){const A=u(P.setting.key,d);if(A)return{index:d.indexOf(A),insertAfter:!0}}else{const A=r(p,c);if(A){const N=u(A.setting.key,d);if(N){const $=a(d.indexOf(N),d),D=n(c,A,c[p]);if($){const F=n(d,N,$),M=t(D,F);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.indexOf($),insertAfter:!1}}else{const F=n(d,N,d[d.length-1]),M=t(D,F);return M?{index:d.indexOf(M),insertAfter:!0}:{index:d.length-1,insertAfter:!0}}}}}const O=c[p+1];if(O)if(O.setting){const A=u(O.setting.key,d);if(A)return{index:d.indexOf(A),insertAfter:!1}}else{const A=a(p,c);if(A){const N=u(A.setting.key,d);if(N){const $=r(d.indexOf(N),d),D=n(c,c[p],A);if($){const F=n(d,$,N),M=t(D.reverse(),F.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:d.indexOf($),insertAfter:!0}}else{const F=n(d,d[0],N),M=t(D.reverse(),F.reverse());return M?{index:d.indexOf(M),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:d.length-1,insertAfter:!0}}function g(o,c,d,p,P,O){let A;return p.index===-1?A=(0,k.setProperty)(o,[c],d,O):A=l(o,c,d,p,P,O).map(N=>(0,k.withFormatting)(o,N,O)[0]),(0,k.applyEdits)(o,A)}function l(o,c,d,p,P,O){const A=`${JSON.stringify(c)}: ${JSON.stringify(d)}`,N=(0,L.getEOL)(O,o),$=P[p.index];if(p.insertAfter){const D=[];if($.setting)D.push({offset:$.endOffset,length:0,content:","+A});else{const F=a(p.index,P),M=r(p.index,P),U=M?.setting?.commaOffset;M&&U===void 0&&D.push({offset:M.endOffset,length:0,content:","});const G=U!==void 0&&U>$.endOffset;D.push({offset:G?U+1:$.endOffset,length:0,content:F?N+A+",":N+A})}return D}else{if($.setting)return[{offset:$.startOffset,length:0,content:A+","}];const D=(P[p.index-1]&&!P[p.index-1].setting?N:"")+A+(a(p.index,P)?",":"")+N;return[{offset:$.startOffset,length:0,content:D}]}}function u(o,c){return c.filter(d=>d.setting?.key===o)[0]}function r(o,c){for(let d=o-1;d>=0;d--)if(c[d].setting)return c[d]}function a(o,c){for(let d=o+1;d<c.length;d++)if(c[d].setting)return c[d]}function n(o,c,d){const p=o.indexOf(c),P=o.indexOf(d);return o.filter((O,A)=>p<A&&A<P)}function t(o,c){if(o.length&&c.length){let d=0;for(;d<c.length&&d<o.length;d++)if(o[d].value!==c[d].value)return c[d-1];return c[d-1]}}function s(o){const c=[];let d=-1,p,P;const O={onObjectBegin:A=>{d++},onObjectProperty:(A,N,$)=>{d===0&&(p=N,P=A)},onObjectEnd:(A,N)=>{d--,d===0&&c.push({startOffset:p,endOffset:A+N,value:o.substring(p,A+N),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(A,N)=>{d++},onArrayEnd:(A,N)=>{d--,d===0&&c.push({startOffset:p,endOffset:A+N,value:o.substring(p,A+N),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(A,N,$)=>{d===0&&c.push({startOffset:p,endOffset:N+$,value:o.substring(p,N+$),setting:{key:P,commaOffset:void 0}})},onSeparator:(A,N,$)=>{if(d===0&&A===","){let D=c.length-1;for(;D>=0&&!c[D].setting;D--);const F=c[D];F&&c.splice(D,1,{startOffset:F.startOffset,endOffset:F.endOffset,value:F.value,setting:{key:F.setting.key,commaOffset:N}})}},onComment:(A,N)=>{d===0&&c.push({startOffset:A,endOffset:A+N,value:o.substring(A,A+N)})}};return(0,_.visit)(o,O),c}}),define(te[224],ne([0,1,19,3,145,21,88,84,11,29,14,23,22,35,46,51,223,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function w(r){return r&&r.settings&&typeof r.settings=="string"&&Object.keys(r).length===1}function g(r){const a=JSON.parse(r);return w(a)?a:{settings:r}}e.parseSettingsSyncContent=g;let l=class extends h.AbstractJsonFileSynchroniser{constructor(a,n,t,s,o,c,d,p,P,O,A,N,$){super(n.settingsResource,"settings",a,n,t,s,o,P,O,c,d,p,$);this.extensionManagementService=A,this.userConfigurationFileService=N,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(a){const n=await this.getLastSyncUserData(),t=await this.getLatestRemoteUserData(a,n),s=this.getSettingsSyncContent(t),o=new i.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(a,n,t){const s=await this.getLocalFileContent(),o=await this.getFormattingOptions(),c=this.getSettingsSyncContent(a);n=n===null&&t?a:n;const d=n?this.getSettingsSyncContent(n):null,p=await this.getIgnoredSettings();let P=null,O=!1,A=!1,N=!1;if(c){let D=s?s.value.toString().trim():"{}";D=D||"{}",this.validateContent(D),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const F=(0,v.merge)(D,c.settings,d?d.settings:null,p,[],o);P=F.localContent||F.remoteContent,O=F.localContent!==null,A=F.remoteContent!==null,N=F.hasConflicts}else s&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),P=s.value.toString(),A=!0);const $={content:P,localChange:O?2:0,remoteChange:A?2:0,hasConflicts:N};return[{fileContent:s,localResource:this.localResource,localContent:s?s.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const n=this.getSettingsSyncContent(a);if(n===null)return!0;const t=await this.getLocalFileContent(),s=t?t.value.toString().trim():"",o=await this.getIgnoredSettings(),c=await this.getFormattingOptions();return(0,v.merge)(s||"{}",n.settings,n.settings,o,[],c).remoteContent!==null}async getMergeResult(a,n){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();return{...a.previewResult,content:a.previewResult.content?(0,v.updateIgnoredSettings)(a.previewResult.content,"{}",s,t):null}}async getAcceptResult(a,n,t,s){const o=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(n,this.localResource))return{content:a.fileContent?(0,v.updateIgnoredSettings)(a.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(n,this.remoteResource))return{content:a.remoteContent!==null?(0,v.updateIgnoredSettings)(a.remoteContent,a.fileContent?a.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(n,this.previewResource))return t===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:t!==null?(0,v.updateIgnoredSettings)(t,a.fileContent?a.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async applyResult(a,n,t,s){const{fileContent:o}=t[0][0];let{content:c,localChange:d,remoteChange:p}=t[0][1];if(d===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),d!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),o&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(o.value.toString()))),await this.updateLocalFileContent(c,o,s),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const P=await this.getFormattingOptions(),O=this.getSettingsSyncContent(a),A=await this.getIgnoredSettings(c);c=(0,v.updateIgnoredSettings)(c,O?O.settings:"{}",A,P),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),a=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),s?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(P){}n?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(a),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const n=await this.getFormattingOptions(),t=(0,y.edit)(a.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,n);return!(0,v.isEmpty)(t)}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const n=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"settings.json"),comparableResource:n}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let n=await super.resolveContent(a);if(n)return n;if(n=await super.resolveContent(this.extUri.dirname(a)),n){const t=this.parseSyncData(n);if(t){const s=this.parseSettingsSyncContent(t.content);if(s)switch(this.extUri.basename(a)){case"settings.json":return s.settings}}}return null}async resolvePreviewContent(a){let n=await super.resolvePreviewContent(a);if(n){const t=await this.getFormattingOptions(),s=await this.getIgnoredSettings();n=(0,v.updateIgnoredSettings)(n,"{}",s,t)}return n}getSettingsSyncContent(a){return a.syncData?this.parseSettingsSyncContent(a.syncData.content):null}parseSettingsSyncContent(a){try{return g(a)}catch(n){this.logService.error(n)}return null}toSettingsSyncContent(a){return{settings:a}}async getIgnoredSettings(a){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const t=_.Event.any(_.Event.filter(this.extensionManagementService.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),_.Event.filter(this.extensionManagementService.onDidUninstallExtension,s=>!s.error))(()=>{t.dispose(),this._defaultIgnoredSettings=void 0})}const n=await this._defaultIgnoredSettings;return(0,v.getIgnoredSettings)(n,this.configurationService,a)}async writeFileContent(a,n,t){await this.userConfigurationFileService.write(T.VSBuffer.fromString(a),t?void 0:{etag:n.etag,mtime:n.mtime})}validateContent(a){if(this.hasErrors(a))throw new m.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};l=de([J(0,I.IFileService),J(1,b.IEnvironmentService),J(2,E.IStorageService),J(3,m.IUserDataSyncStoreService),J(4,m.IUserDataSyncBackupStoreService),J(5,m.IUserDataSyncLogService),J(6,m.IUserDataSyncUtilService),J(7,L.IConfigurationService),J(8,m.IUserDataSyncEnablementService),J(9,f.ITelemetryService),J(10,C.IExtensionManagementService),J(11,R.IUserConfigurationFileService),J(12,S.IUriIdentityService)],l),e.SettingsSynchroniser=l;let u=class extends h.AbstractInitializer{constructor(a,n,t,s){super("settings",n,t,a,s)}async doInitialize(a){const n=a.syncData?this.parseSettingsSyncContent(a.syncData.content):null;if(!n){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,T.VSBuffer.fromString(n.settings)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource);return(0,v.isEmpty)(a.value.toString().trim())}catch(a){return a.fileOperationResult===1}}parseSettingsSyncContent(a){try{return g(a)}catch(n){this.logService.error(n)}return null}};u=de([J(0,I.IFileService),J(1,b.IEnvironmentService),J(2,m.IUserDataSyncLogService),J(3,S.IUriIdentityService)],u),e.SettingsInitializer=u}),define(te[225],ne([0,1,19,3,28,21,11,14,23,22,35,46,218,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let h=class extends E.AbstractSynchroniser{constructor(m,w,g,l,u,r,a,n,t,s){super("snippets",w,m,g,l,u,n,t,r,a,s);this.version=1,this.snippetsFolder=m.snippetsHome,this._register(this.fileService.watch(m.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(_.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(m,w,g){const l=await this.getSnippetsFileContents(),u=this.toSnippetsContents(l),r=m.syncData?this.parseSnippets(m.syncData):null;w=w===null&&g?m:w;const a=w&&w.syncData?this.parseSnippets(w.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const n=(0,f.merge)(u,r,a);return this.getResourcePreviews(n,l,r||{})}async hasRemoteChanged(m){const w=m.syncData?this.parseSnippets(m.syncData):null;if(w===null)return!0;const g=await this.getSnippetsFileContents(),l=this.toSnippetsContents(g),u=(0,f.merge)(l,w,w);return Object.keys(u.remote.added).length>0||Object.keys(u.remote.updated).length>0||u.remote.removed.length>0||u.conflicts.length>0}async getMergeResult(m,w){return m.previewResult}async getAcceptResult(m,w,g,l){if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:m.fileContent?m.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:m.remoteContent,localChange:m.remoteContent!==null?m.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(w,this.syncPreviewFolder))return g===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:g,localChange:g===null?m.fileContent!==null?3:0:2,remoteChange:g===null?m.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${w.toString()}`)}async applyResult(m,w,g,l){const u=g.map(([r,a])=>({...r,acceptResult:a}));u.every(({localChange:r,remoteChange:a})=>r===0&&a===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),u.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(u),await this.updateLocalSnippets(u,l)),u.some(({remoteChange:r})=>r!==0)&&(m=await this.updateRemoteSnippets(u,m,l)),w?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of u)try{await this.fileService.del(r)}catch(a){}}getResourcePreviews(m,w,g){const l=new Map;for(const u of Object.keys(m.local.added)){const r={content:m.local.added[u],hasConflicts:!1,localChange:1,remoteChange:0};l.set(u,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.local.updated)){const r={content:m.local.updated[u],hasConflicts:!1,localChange:2,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.local.removed){const r={content:null,hasConflicts:!1,localChange:3,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.added)){const r={content:m.remote.added[u],hasConflicts:!1,localChange:0,remoteChange:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(m.remote.updated)){const r={content:m.remote.updated[u],hasConflicts:!1,localChange:0,remoteChange:2};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u],localContent:w[u].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.remote.removed){const r={content:null,hasConflicts:!1,localChange:0,remoteChange:3};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u],previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of m.conflicts){const r={content:w[u]?w[u].value.toString():null,hasConflicts:!0,localChange:w[u]?2:1,remoteChange:g[u]?2:1};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u]||null,localContent:w[u]?w[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const u of Object.keys(w))if(!l.has(u)){const r={content:w[u]?w[u].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};l.set(u,{localResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:w[u]||null,localContent:w[u]?w[u].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:g[u]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,u),previewResult:r,localChange:r.localChange,remoteChange:r.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,u).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...l.values()]}async getAssociatedResources({uri:m}){let w=await super.resolveContent(m);if(w){const g=this.parseSyncData(w);if(g){const l=this.parseSnippets(g),u=[];for(const r of Object.keys(l)){const a=this.extUri.joinPath(m,r),n=this.extUri.joinPath(this.snippetsFolder,r),t=await this.fileService.exists(n);u.push({resource:a,comparableResource:t?n:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"})})}return u}}return[]}async resolveContent(m){if(this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(m,this.syncPreviewFolder.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(m);let w=await super.resolveContent(m);if(w)return w;if(w=await super.resolveContent(this.extUri.dirname(m)),w){const g=this.parseSyncData(w);if(g)return this.parseSnippets(g)[this.extUri.basename(m)]||null}return null}async hasLocalData(){try{const m=await this.getSnippetsFileContents();if(Object.keys(m).length)return!0}catch(m){}return!1}async updateLocalBackup(m){const w={};for(const g of m)g.fileContent&&(w[this.extUri.basename(g.localResource)]=g.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(w)))}async updateLocalSnippets(m,w){for(const{fileContent:g,acceptResult:l,localResource:u,remoteResource:r,localChange:a}of m)if(a!==0){const n=r?this.extUri.basename(r):this.extUri.basename(u),t=this.extUri.joinPath(this.snippetsFolder,n);a===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(t)),await this.fileService.del(t),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(t))):a===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(t)),await this.fileService.createFile(t,T.VSBuffer.fromString(l.content),{overwrite:w}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(t))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(t)),await this.fileService.writeFile(t,T.VSBuffer.fromString(l.content),w?void 0:g),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(t)))}}async updateRemoteSnippets(m,w,g){const l=w.syncData?this.parseSnippets(w.syncData):{},u=(0,k.deepClone)(l);for(const{acceptResult:r,localResource:a,remoteResource:n,remoteChange:t}of m)if(t!==0){const s=a?this.extUri.basename(a):this.extUri.basename(n);t===3?delete u[s]:u[s]=r.content}return(0,f.areSame)(l,u)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),w=await this.updateRemoteUserData(JSON.stringify(u),g?null:w.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),w}parseSnippets(m){return JSON.parse(m.content)}toSnippetsContents(m){const w={};for(const g of Object.keys(m))w[g]=m[g].value.toString();return w}async getSnippetsFileContents(){const m={};let w;try{w=await this.fileService.resolve(this.snippetsFolder)}catch(g){if(g instanceof R.FileOperationError&&g.fileOperationResult===1)return m;throw g}for(const g of w.children||[]){const l=g.resource,u=this.extUri.extname(l);if(u===".json"||u===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,l),a=await this.fileService.readFile(l);m[r]=a}}return m}};h=de([J(0,i.IEnvironmentService),J(1,R.IFileService),J(2,b.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncBackupStoreService),J(5,S.IUserDataSyncLogService),J(6,L.IConfigurationService),J(7,S.IUserDataSyncEnablementService),J(8,C.ITelemetryService),J(9,I.IUriIdentityService)],h),e.SnippetsSynchroniser=h;let y=class extends E.AbstractInitializer{constructor(m,w,g,l){super("snippets",w,g,m,l)}async doInitialize(m){const w=m.syncData?JSON.parse(m.syncData.content):null;if(!w){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const l of Object.keys(w)){const u=w[l];if(u){const r=this.extUri.joinPath(this.environmentService.snippetsHome,l);await this.fileService.createFile(r,T.VSBuffer.fromString(u)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(m)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(m){return m.fileOperationResult===1}}};y=de([J(0,R.IFileService),J(1,i.IEnvironmentService),J(2,S.IUserDataSyncLogService),J(3,I.IUriIdentityService)],y),e.SnippetsInitializer=y}),define(te[62],ne([0,1,3,2,6,24]),function(Q,e,T,_,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let i=class extends _.Disposable{constructor(b,C){super();this.userDataSyncStoreService=b,this.logService=C,this._onDidChangeAccount=this._register(new T.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(b.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(b.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(b){(b&&this._account?b.token!==this._account.token||b.authenticationProviderId!==this._account.authenticationProviderId:b!==this._account)&&(this._account=b,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(b))}};i=de([J(0,L.IUserDataSyncStoreService),J(1,L.IUserDataSyncLogService)],i),e.UserDataSyncAccountService=i}),define(te[226],ne([0,1,5,19,55,2,18,21,11,14,24]),function(Q,e,T,_,k,L,i,R,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let E=class extends L.Disposable{constructor(S,h,y,v){super();this.environmentService=S,this.fileService=h,this.configurationService=y,this.logService=v,I.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(S){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,S),y=await this.fileService.resolve(h);return y.children?y.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(S,h){if(!h){const y=await this.getAllRefs(S);y.length&&(h=y[y.length-1].ref)}if(h){const y=(0,i.joinPath)(this.environmentService.userDataSyncHome,S,h);return(await this.fileService.readFile(y)).value.toString()}return null}async backup(S,h){const y=(0,i.joinPath)(this.environmentService.userDataSyncHome,S),v=(0,i.joinPath)(y,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(v,_.VSBuffer.fromString(h))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(S)}catch(m){}}async cleanUpBackup(S){const h=(0,i.joinPath)(this.environmentService.userDataSyncHome,S);try{try{if(!await this.fileService.exists(h))return}catch(v){return}const y=await this.fileService.resolve(h);if(y.children){const v=y.children.filter(l=>l.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(l.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let w=v.filter(l=>Date.now()-this.getCreationTime(l)>m);const g=v.length-w.length;g<10&&(w=w.slice(10-g)),await T.Promises.settled(w.map(async l=>{this.logService.info("Deleting from backup",l.resource.path),await this.fileService.del(l.resource)}))}}catch(y){this.logService.error(y)}}getCreationTime(S){return S.ctime||new Date(parseInt(S.name.substring(0,4)),parseInt(S.name.substring(4,6))-1,parseInt(S.name.substring(6,8)),parseInt(S.name.substring(9,11)),parseInt(S.name.substring(11,13)),parseInt(S.name.substring(13,15))).getTime()}};E=de([J(0,b.IEnvironmentService),J(1,C.IFileService),J(2,R.IConfigurationService),J(3,I.IUserDataSyncLogService)],E),e.UserDataSyncBackupStoreService=E}),define(te[227],ne([0,1,3,2,4,11,23,22,24]),function(Q,e,T,_,k,L,i,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const C="sync.enable";let I=class extends _.Disposable{constructor(f,S,h,y){super();this.storageService=f,this.telemetryService=S,this.environmentService=h,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new T.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new T.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(C,0,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(f){f&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(C,{enabled:f}),this.storageService.store(C,f,0,1))}isResourceEnabled(f){return this.storageService.getBoolean((0,b.getEnablementKey)(f),0,!0)}setResourceEnablement(f,S){if(this.isResourceEnabled(f)!==S){const h=(0,b.getEnablementKey)(f);this.telemetryService.publicLog2(h,{enabled:S}),this.storeResourceEnablement(h,S)}}getResourceSyncStateVersion(f){}storeResourceEnablement(f,S){this.storageService.store(f,S,0,k.isWeb?0:1)}onDidStorageChange(f){if(f.scope!==0)return;if(C===f.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const S=b.ALL_SYNC_RESOURCES.filter(h=>(0,b.getEnablementKey)(h)===f.key)[0];if(S){this._onDidChangeResourceEnablement.fire([S,this.isResourceEnabled(S)]);return}}};I=de([J(0,i.IStorageService),J(1,R.ITelemetryService),J(2,L.IEnvironmentService),J(3,b.IUserDataSyncStoreManagementService)],I),e.UserDataSyncEnablementService=I}),define(te[228],ne([0,1,2,7]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(f){this.service=f}listen(f,S){switch(S){case"onError":return this.service.onError}throw new Error(`Event not found: ${S}`)}call(f,S,h){switch(S){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class L{constructor(f){this.service=f}listen(f,S){throw new Error(`Event not found: ${S}`)}call(f,S,h){switch(S){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(_.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class i{constructor(f){this.channel=f}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(f){return this.channel.call("resolveUserKeybindings",[f])}async resolveFormattingOptions(f){return this.channel.call("resolveFormattingOptions",[f])}}e.UserDataSyncUtilServiceClient=i;class R{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${S}`)}async call(f,S,h){switch(S){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=R;class b{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${S}`)}call(f,S,h){switch(S){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=b;class C{constructor(f){this.service=f}listen(f,S){switch(S){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${S}`)}call(f,S,h){switch(S){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=C;class I extends T.Disposable{constructor(f){super();this.channel=f,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(f){return this.channel.call("switch",[f])}async getPreviousUserDataSyncStore(){const f=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(f)}revive(f){return{url:_.URI.revive(f.url),type:f.type,defaultUrl:_.URI.revive(f.defaultUrl),insidersUrl:_.URI.revive(f.insidersUrl),stableUrl:_.URI.revive(f.stableUrl),canSwitch:f.canSwitch,authenticationProviders:f.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=I}),define(te[229],ne([0,1,11,8]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends _.AbstractLogger{constructor(i,R){super();this.logger=this._register(i.createLogger(R.userDataSyncLogResource,{name:"settingssync"}))}trace(i,...R){this.logger.trace(i,...R)}debug(i,...R){this.logger.debug(i,...R)}info(i,...R){this.logger.info(i,...R)}warn(i,...R){this.logger.warn(i,...R)}error(i,...R){this.logger.error(i,...R)}critical(i,...R){this.logger.critical(i,...R)}flush(){this.logger.flush()}};k=de([J(0,_.ILoggerService),J(1,T.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(te[63],ne([0,1,3,2,4,25,148,11,14,6,26,45,23,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,C.createDecorator)("IUserDataSyncMachinesService");const h="sync.currentMachineName";let y=class et extends _.Disposable{constructor(m,w,g,l,u,r){super();this.storageService=g,this.userDataSyncStoreService=l,this.logService=u,this.productService=r,this._onDidChange=this._register(new T.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,E.getServiceMachineId)(m,w,g)}async getMachines(m){const w=await this.currentMachineIdPromise;return(await this.readMachinesData(m)).machines.map(l=>({...l,isCurrent:l.id===w}))}async addCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m);g.machines.some(({id:l})=>l===w)||(g.machines.push({id:w,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(m){const w=await this.currentMachineIdPromise,g=await this.readMachinesData(m),l=g.machines.filter(({id:u})=>u!==w);l.length!==g.machines.length&&(g.machines=l,await this.writeMachinesData(g))}async renameMachine(m,w,g){const l=await this.currentMachineIdPromise,u=await this.readMachinesData(g),r=u.machines.find(({id:a})=>a===m);r&&(r.name=w,await this.writeMachinesData(u),u.machines.some(({id:a})=>a===l)&&this.storageService.store(h,w,0,1))}async setEnablement(m,w){const g=await this.readMachinesData(),l=g.machines.find(({id:u})=>u===m);l&&(l.disabled=w?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(m){const w=this.storageService.get(h,0);if(w)return w;const g=`${this.productService.nameLong} (${(0,k.PlatformToString)(k.isWeb?0:k.platform)})`,l=new RegExp(`${(0,L.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let u=0;for(const r of m){const a=l.exec(r.name),n=a?parseInt(a[1]):0;u=n>u?n:u}return`${g} #${u+1}`}async readMachinesData(m){this.userData=await this.readUserData(m);const w=this.parse(this.userData);if(w.version!==et.VERSION)throw new Error((0,i.localize)(0,null,this.productService.nameLong));return w}async writeMachinesData(m){const w=JSON.stringify(m),g=await this.userDataSyncStoreService.write(et.RESOURCE,w,this.userData?.ref||null);this.userData={ref:g,content:w},this._onDidChange.fire()}async readUserData(m){if(this.userData){const w=m&&m.latest?m.latest[et.RESOURCE]:void 0;if(this.userData.ref===w)return this.userData;if(w===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(et.RESOURCE,this.userData)}parse(m){if(m.content!==null)try{return JSON.parse(m.content)}catch(w){this.logService.error(w)}return{version:et.VERSION,machines:[]}}};y.VERSION=1,y.RESOURCE="machines",y=de([J(0,R.IEnvironmentService),J(1,b.IFileService),J(2,f.IStorageService),J(3,S.IUserDataSyncStoreService),J(4,S.IUserDataSyncLogService),J(5,I.IProductService)],y),e.UserDataSyncMachinesService=y}),define(te[230],ne([0,1,5,55,38,10,3,2,4,18,7,146,26,23,22,24,62,63]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const w="sync.disableMachineEventually",g="sync.sessionId",l="sync.storeUrl",u="sync.productQuality";let r=class extends R.Disposable{constructor(t,s,o,c,d,p,P,O,A,N){super();this.userDataSyncStoreManagementService=s,this.userDataSyncStoreService=o,this.userDataSyncEnablementService=c,this.userDataSyncService=d,this.logService=p,this.userDataSyncAccountService=P,this.telemetryService=O,this.userDataSyncMachinesService=A,this.storageService=N,this.autoSync=this._register(new R.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new i.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new T.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=t.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(s.onDidChangeUserDataSyncStore(()=>{(0,C.isEqual)(this.syncUrl,s.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=s.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(P.onDidChangeAccount(()=>this.updateAutoSync())),this._register(o.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(i.Event.debounce(d.onDidChangeLocal,($,D)=>$?[...$,D]:[D],1e3)($=>this.triggerSync($,!1,!1))),this._register(i.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,$])=>$)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const t=this.storageService.get(l,0);return t?I.URI.parse(t):void 0}set syncUrl(t){t?this.storageService.store(l,t.toString(),0,1):this.storageService.remove(l,0)}get productQuality(){return this.storageService.get(u,0)}set productQuality(t){t?this.storageService.store(u,t,0,1):this.storageService.remove(u,0)}updateAutoSync(){const{enabled:t,message:s}=this.isAutoSyncEnabled();t?this.autoSync.value===void 0&&(this.autoSync.value=new a(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(o=>this.onDidFinishSync(o))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(s&&this.logService.info(s),this.autoSync.clear()):s&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(s))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,_.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(t,s,o){try{this.userDataSyncAccountService.account&&!o&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(g,0),t?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(c){if(s)this.logService.error(c),this.updateEnablement(!1);else throw c}}updateEnablement(t){this.userDataSyncEnablementService.isEnabled()!==t&&(this.userDataSyncEnablementService.setEnablement(t),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(t){if(!t){this.successiveFailures=0;return}const s=y.UserDataSyncError.toUserDataSyncError(t);s instanceof y.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:s.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"||s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?b.isWeb&&s.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(s),this.successiveFailures++),this._onError.fire(s)}async disableMachineEventually(){this.storageService.store(w,!0,0,1),await(0,T.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(w,0,!1)}stopDisableMachineEventually(){this.storageService.remove(w,0)}async triggerSync(t,s,o){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(s&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...t),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",o)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([J(0,f.IProductService),J(1,y.IUserDataSyncStoreManagementService),J(2,y.IUserDataSyncStoreService),J(3,y.IUserDataSyncEnablementService),J(4,y.IUserDataSyncService),J(5,y.IUserDataSyncLogService),J(6,v.IUserDataSyncAccountService),J(7,h.ITelemetryService),J(8,m.IUserDataSyncMachinesService),J(9,S.IStorageService)],r),e.UserDataAutoSyncService=r;class a extends R.Disposable{constructor(t,s,o,c,d,p,P,O){super();this.lastSyncUrl=t,this.interval=s,this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncService=d,this.userDataSyncMachinesService=p,this.logService=P,this.storageService=O,this.intervalHandler=this._register(new R.MutableDisposable),this._onDidStartSync=this._register(new i.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new i.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,R.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(a.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,T.disposableTimeout)(()=>this.sync(a.INTERVAL_SYNCING,!1),this.interval)}sync(t,s){const o=(0,T.createCancelablePromise)(async c=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(d){if((0,L.isPromiseCanceledError)(d))return}return this.doSync(t,s,c)});return this.syncPromise=o,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,C.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const t=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),s=this.userDataSyncStoreManagementService.userDataSyncStore;return!!s&&!!t&&(!(0,C.isEqual)(s.defaultUrl,t.defaultUrl)||!(0,C.isEqual)(s.insidersUrl,t.insidersUrl)||!(0,C.isEqual)(s.stableUrl,t.stableUrl))}async doSync(t,s,o){this.logService.info(`Auto Sync: Triggered by ${t}`),this._onDidStartSync.fire();let c;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,s),o.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(0,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(1,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(2,null),"TurnedOff");const d=this.storageService.get(g,0);if(d&&this.manifest&&d!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new y.UserDataAutoSyncError((0,E.localize)(3,null),"DefaultServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(4,null),"ServiceChanged"):new y.UserDataAutoSyncError((0,E.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(o.isCancellationRequested)return;const P=p.find(O=>O.isCurrent);if(P?.disabled)throw new y.UserDataAutoSyncError((0,E.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(O){throw new y.UserDataAutoSyncError((0,k.toErrorMessage)(O),O instanceof y.UserDataSyncError?O.code:"Unknown")}if(this.manifest&&this.manifest.session!==d&&this.storageService.store(g,this.manifest.session,0,1),o.isCancellationRequested)return;P||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(d){this.logService.error(d),c=d}this._onDidFinishSync.fire(c)}register(t){return super._register(t)}}a.INTERVAL_SYNCING="Interval"}),define(te[231],ne([0,1,16,5,38,3,2,18,15,30,21,29,6,23,22,219,221,222,224,225,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const u="sync.lastSyncTime";let r=class extends i.Disposable{constructor(o,c,d,p,P,O,A,N){super();this.userDataSyncStoreService=o,this.userDataSyncStoreManagementService=c,this.instantiationService=d,this.configurationService=p,this.logService=P,this.telemetryService=O,this.storageService=A,this.userDataSyncEnablementService=N,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new i.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(u,0,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(o,c){this.checkEnablement();const d=(0,C.generateUuid)();try{const N=(0,l.createSyncHeaders)(d);c&&(N["Cache-Control"]="no-cache"),o=await this.userDataSyncStoreService.manifest(o,N)}catch(N){const $=l.UserDataSyncError.toUserDataSyncError(N);throw this.reportUserDataSyncError($,d),$}let p=!1;const P=this,O=this.getEnabledSynchronizers();let A;return{manifest:o,async run(){if(p)throw new Error("Can run a task only once");return A=(0,_.createCancelablePromise)(N=>P.sync(O,o,d,N)),A.finally(()=>A=void 0)},async stop(){if(A&&A.cancel(),P.status!=="idle")return P.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new l.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const o=(0,C.generateUuid)(),c=(0,l.createSyncHeaders)(o);let d;try{d=await this.userDataSyncStoreService.manifest(null,c)}catch(P){const O=l.UserDataSyncError.toUserDataSyncError(P);throw this.reportUserDataSyncError(O,o),O}await this.resetLocal();const p=this.getEnabledSynchronizers();return new a(o,d,c,p,()=>this.resetLocal(),this.configurationService,this.logService)}async sync(o,c,d,p){if(p.isCancellationRequested||!o.length)return;const P=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,l.createSyncHeaders)(d);for(const A of o){if(p.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(A.resource))return;try{await A.sync(c,O)}catch(N){let $=!1;if(N instanceof l.UserDataSyncError)switch(N.code){case"TooLarge":N=new l.UserDataSyncError(N.message,N.code,A.resource),$=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":$=!0;break}const D=l.UserDataSyncError.toUserDataSyncError(N);if(this.reportUserDataSyncError(D,d),$)throw D;this.logService.error(N),this.logService.error(`${A.resource}: ${(0,k.toErrorMessage)(N)}`),this._syncErrors.push([A.resource,D])}}this.logService.info(`Sync done. Took ${new Date().getTime()-P}ms`),this.updateLastSyncTime()}catch(O){const A=l.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(A,d),A}finally{this.updateStatus(o),this._onSyncErrors.fire(this._syncErrors)}}async stop(o){if(this.status!=="idle")for(const c of o)try{c.status!=="idle"&&await c.stop()}catch(d){this.logService.error(d)}}async replace(o){this.checkEnablement(),await this.performSynchronizerAction(async c=>{if(await c.replace(o))return!0})}async accept(o,c,d,p){this.checkEnablement(),await this.performSynchronizerAction(async P=>{if(P.resource===o)return await P.accept(c,d),p&&await P.apply(!1,(0,l.createSyncHeaders)((0,C.generateUuid)())),!0})}async resolveContent(o){return this.performSynchronizerAction(async c=>{const d=await c.resolveContent(o);if(d)return d})}async getRemoteSyncResourceHandles(o){return await this.performSynchronizerAction(async d=>{if(d.resource===o)return d.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(o){return await this.performSynchronizerAction(async d=>{if(d.resource===o)return d.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(o,c){return await this.performSynchronizerAction(async p=>{if(p.resource===o)return p.getAssociatedResources(c)})||[]}async getMachineId(o,c){return await this.performSynchronizerAction(async p=>{if(p.resource===o)return await p.getMachineId(c)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async c=>{if(c.resource!=="globalState"&&await c.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async c=>{if(await c.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(o){this.logService.error(o)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(u,0),this.synchronizers.value){for(const o of this.synchronizers.value.enabled)try{await o.resetLocal()}catch(c){this.logService.error(`${o.resource}: ${(0,k.toErrorMessage)(c)}`),this.logService.error(c)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(o){const c=new i.DisposableStore;try{const d=this.synchronizers.value||c.add(this.instantiationService.createInstance(n,()=>{},()=>{},()=>{})),p=[...d.enabled,...d.disabled.map(P=>c.add(d.createSynchronizer(P)))];for(const P of p){const O=await o(P);if(!(0,b.isUndefined)(O))return O}return null}finally{c.dispose()}}setStatus(o){const c=this._status;this._status!==o&&(this._status=o,this._onDidChangeStatus.fire(o),c==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(o){this.updateConflicts(o);const c=this.computeStatus(o);this.setStatus(c)}updateConflicts(o){const c=this.computeConflicts(o);(0,T.equals)(this._conflicts,c,([d,p],[P,O])=>d===d&&(0,T.equals)(p,O,(A,N)=>(0,R.isEqual)(A.previewResource,N.previewResource)))||(this._conflicts=this.computeConflicts(o),this._onDidChangeConflicts.fire(c))}computeConflicts(o){return o.filter(c=>c.status==="hasConflicts").map(c=>[c.resource,c.conflicts.map(t)])}computeStatus(o){return this.userDataSyncStoreManagementService.userDataSyncStore?o.some(c=>c.status==="hasConflicts")?"hasConflicts":o.some(c=>c.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(u,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(o,c){this.telemetryService.publicLog2("sync/error",{code:o.code,serverCode:o instanceof l.UserDataSyncStoreError?String(o.serverCode):void 0,url:o instanceof l.UserDataSyncStoreError?o.url:void 0,resource:o.resource,executionId:c,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(n,o=>this.updateStatus(o),o=>this.updateConflicts(o),o=>this._onDidChangeLocal.fire(o))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=de([J(0,l.IUserDataSyncStoreService),J(1,l.IUserDataSyncStoreManagementService),J(2,f.IInstantiationService),J(3,I.IConfigurationService),J(4,l.IUserDataSyncLogService),J(5,h.ITelemetryService),J(6,S.IStorageService),J(7,l.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class a extends i.Disposable{constructor(o,c,d,p,P,O,A){super();this.id=o,this.manifest=c,this.syncHeaders=d,this.synchronisers=p,this.onStop=P,this.configurationService=O,this.logService=A,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(o=>o.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(o=>o.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,_.createCancelablePromise)(o=>this.getPreviews(o))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(o){throw this.logService.error(o),o}}async accept(o,c){try{return await this.performAction(o,d=>d.accept(o,c))}catch(d){throw this.logService.error(d),d}}async merge(o){try{return o?await this.performAction(o,c=>c.merge(o)):await this.mergeAll()}catch(c){throw this.logService.error(c),c}}async discard(o){try{return await this.performAction(o,c=>c.discard(o))}catch(c){throw this.logService.error(c),c}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const o=[];for(const[,c]of this.previews)for(const d of c.resourcePreviews)d.mergeState==="conflict"&&o.push(d.previewResource);for(const c of o)await this.discard(c);return this.previews}catch(o){throw this.logService.error(o),o}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const o=[];for(const[c,d]of this.previews){this.synchronizingResources.push([c,d.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(O=>O.resource===c);for(const O of d.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await p.merge(O.previewResource);const P=await p.apply(!1,this.syncHeaders);P&&o.push(this.toSyncResourcePreview(p.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}catch(o){throw this.logService.error(o),o}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const d=this.synchronisers.find(p=>p.resource===o);for(const p of c.resourcePreviews)await d.accept(p.remoteResource);await d.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(p=>p.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const d=this.synchronisers.find(p=>p.resource===o);for(const p of c.resourcePreviews)await d.accept(p.localResource);await d.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(p=>p[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(o){throw this.logService.error(o),o}}async stop(){await this.onStop(),this.reset()}async performAction(o,c){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const d=this.previews.findIndex(([,F])=>F.resourcePreviews.some(({localResource:M,previewResource:U,remoteResource:G})=>(0,R.isEqual)(o,M)||(0,R.isEqual)(o,U)||(0,R.isEqual)(o,G)));if(d===-1)return this.previews;const[p,P]=this.previews[d],O=P.resourcePreviews.find(({localResource:F,remoteResource:M,previewResource:U})=>(0,R.isEqual)(F,o)||(0,R.isEqual)(M,o)||(0,R.isEqual)(U,o));if(!O)return this.previews;let A=this.synchronizingResources.find(F=>F[0]===p);A||(A=[p,[]],this.synchronizingResources.push(A)),A[1].some(F=>(0,R.isEqual)(F,O.localResource))||(A[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const N=this.synchronisers.find(F=>F.resource===this.previews[d][0]),$=await c(N);$?this.previews.splice(d,1,this.toSyncResourcePreview(N.resource,$)):this.previews.splice(d,1);const D=this.synchronizingResources.findIndex(F=>F[0]===p);return this.synchronizingResources[D][1].splice(A[1].findIndex(F=>(0,R.isEqual)(F,O.localResource)),1),A[1].length||(this.synchronizingResources.splice(D,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const o=[];for(const[c,d]of this.previews){this.synchronizingResources.push([c,d.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(O=>O.resource===c);let P=d;for(const O of d.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(P=await p.merge(O.previewResource));P&&o.push(this.toSyncResourcePreview(p.resource,P)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===c),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=o,this.previews}async getPreviews(o){const c=[],d=await this.getUserDataSyncConfiguration();for(const p of this.synchronisers){if(o.isCancellationRequested)return[];const P=await p.preview(this.manifest,d,this.syncHeaders);P&&c.push(this.toSyncResourcePreview(p.resource,P))}return c}async getUserDataSyncConfiguration(){const o=this.configurationService.getValue(l.USER_DATA_SYNC_CONFIGURATION_SCOPE),c=await this.synchronisers.find(d=>d instanceof w.SettingsSynchroniser).getRemoteUserDataSyncConfiguration(this.manifest);return{...o,...c}}toSyncResourcePreview(o,c){return[o,{isLastSyncFromCurrentMachine:c.isLastSyncFromCurrentMachine,resourcePreviews:c.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let n=class extends i.Disposable{constructor(o,c,d,p,P,O,A){super();this.onDidChangeStatus=o,this.onDidChangeConflicts=c,this.onDidChangeLocal=d,this.userDataSyncEnablementService=p,this.instantiationService=P,this.extensionGalleryService=O,this.logService=A,this._enabled=[],this._register(p.onDidChangeResourceEnablement(([N,$])=>this.onDidChangeResourceEnablement(N,$))),this._register((0,i.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,N])=>N.dispose())));for(const N of l.ALL_SYNC_RESOURCES)p.isResourceEnabled(N)&&this.registerSynchronizer(N)}get enabled(){return this._enabled.sort((o,c)=>o[1]-c[1]).map(([o])=>o)}get disabled(){return l.ALL_SYNC_RESOURCES.filter(o=>!this.userDataSyncEnablementService.isResourceEnabled(o))}onDidChangeResourceEnablement(o,c){c?this.registerSynchronizer(o):this.deRegisterSynchronizer(o)}registerSynchronizer(o){if(this._enabled.some(([P])=>P.resource===o))return;if(o==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const c=new i.DisposableStore,d=c.add(this.createSynchronizer(o));c.add(d.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),c.add(d.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),c.add(d.onDidChangeLocal(()=>this.onDidChangeLocal(o)));const p=this.getOrder(o);this._enabled.push([d,p,c])}deRegisterSynchronizer(o){const c=this._enabled.findIndex(([d])=>d.resource===o);if(c!==-1){const d=this._enabled.splice(c,1);for(const[p,,P]of d){if(p.status!=="idle"){const O=p.conflicts.length>0;p.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}P.dispose()}}}createSynchronizer(o){switch(o){case"settings":return this.instantiationService.createInstance(w.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(g.SnippetsSynchroniser);case"globalState":return this.instantiationService.createInstance(v.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(y.ExtensionsSynchroniser)}}getOrder(o){switch(o){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"globalState":return 3;case"extensions":return 4}}};n=de([J(3,l.IUserDataSyncEnablementService),J(4,f.IInstantiationService),J(5,E.IExtensionGalleryService),J(6,l.IUserDataSyncLogService)],n);function t(s){return{localResource:s.localResource,previewResource:s.previewResource,remoteResource:s.remoteResource,acceptedResource:s.acceptedResource,localChange:s.localChange,remoteChange:s.remoteChange,mergeState:s.mergeState}}}),define(te[232],ne([0,1,3,2,15,7,24]),function(Q,e,T,_,k,L,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class R{constructor(E,f){this.service=E,this.logService=f,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new T.Emitter}listen(E,f){switch(f){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${f}`)}async call(E,f,S){try{return await this._call(E,f,S)}catch(h){throw this.logService.error(h),h}}async _call(E,f,S){switch(f){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(S[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(S[0],L.URI.revive(S[1]),S[2],S[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(S[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(S[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(S[0]);case"getAssociatedResources":return this.service.getAssociatedResources(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"getMachineId":return this.service.getMachineId(S[0],{created:S[1].created,uri:L.URI.revive(S[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(f.startsWith("manualSync/")){const h=f.substring("manualSync/".length),y=S[0],v=this.getManualSyncTask(y);switch(S=S.slice(1),h){case"preview":return v.preview();case"accept":return v.accept(L.URI.revive(S[0]),S[1]);case"merge":return v.merge(L.URI.revive(S[0]));case"discard":return v.discard(L.URI.revive(S[0]));case"discardConflicts":return v.discardConflicts();case"apply":return v.apply();case"pull":return v.pull();case"push":return v.push();case"stop":return v.stop();case"_getStatus":return v.status;case"dispose":return this.disposeManualSyncTask(v)}}throw new Error("Invalid call")}getManualSyncTask(E){const f=this.manualSyncTasks.get(this.createKey(E));if(!f)throw new Error(`Manual sync taks not found: ${E}`);return f.manualSyncTask}async createManualSyncTask(){const E=new _.DisposableStore,f=E.add(await this.service.createManualSyncTask());return E.add(f.onSynchronizeResources(S=>this.onManualSynchronizeResources.fire({manualSyncTaskId:f.id,data:S}))),this.manualSyncTasks.set(this.createKey(f.id),{manualSyncTask:f,disposables:E}),{id:f.id,manifest:f.manifest,status:f.status}}disposeManualSyncTask(E){E.dispose();const f=this.createKey(E.id);this.manualSyncTasks.get(f)?.disposables.dispose(),this.manualSyncTasks.delete(f)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=R;class b extends _.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(f,S,h){return E.call(f,S,h).then(null,y=>{throw i.UserDataSyncError.toUserDataSyncError(y)})},listen(f,S){return E.listen(f,S)}},this.channel.call("_getInitialData").then(([f,S,h])=>{this.updateStatus(f),this.updateConflicts(S),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(y=>this.updateStatus(y))),this._register(this.channel.listen("onDidChangeLastSyncTime")(y=>this.updateLastSyncTime(y)))}),this._register(this.channel.listen("onDidChangeConflicts")(f=>this.updateConflicts(f))),this._register(this.channel.listen("onSyncErrors")(f=>this._onSyncErrors.fire(f.map(([S,h])=>[S,i.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:f,status:S}=await this.channel.call("createManualSyncTask"),h=this,y=new C(E,f,S,{async call(v,m,w){return h.channel.call(`manualSync/${v}`,[E,...(0,k.isArray)(m)?m:[m]],w)},listen(v,m){return T.Event.map(T.Event.filter(h.channel.listen(`manualSync/${v}`,m),w=>!y.isDiposed()&&w.manualSyncTaskId===E),w=>w.data)}});return y}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,f,S,h){return this.channel.call("accept",[E,f,S,h])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:S,uri:h})=>({created:S,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:S,uri:h})=>({created:S,uri:L.URI.revive(h)}))}async getAssociatedResources(E,f){return(await this.channel.call("getAssociatedResources",[E,f])).map(({resource:h,comparableResource:y})=>({resource:L.URI.revive(h),comparableResource:L.URI.revive(y)}))}async getMachineId(E,f){return this.channel.call("getMachineId",[E,f])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([f,S])=>[f,S.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class C extends _.Disposable{constructor(E,f,S,h){super();this.id=E,this.manifest=f,this._disposed=!1,this._status=S;const y=this;this.channel={async call(v,m,w){try{const g=await h.call(v,m,w);return y.isDiposed()||(y._status=await h.call("_getStatus")),g}catch(g){throw i.UserDataSyncError.toUserDataSyncError(g)}},listen(v,m){return h.listen(v,m)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,f){const S=await this.channel.call("accept",[E,f]);return this.deserializePreviews(S)}async merge(E){const f=await this.channel.call("merge",[E]);return this.deserializePreviews(f)}async discard(E){const f=await this.channel.call("discard",[E]);return this.deserializePreviews(f)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([f,S])=>[f,{isLastSyncFromCurrentMachine:S.isLastSyncFromCurrentMachine,resourcePreviews:S.resourcePreviews.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource),acceptedResource:L.URI.revive(h.acceptedResource)}))}])}}}),define(te[233],ne([0,1,5,27,10,3,2,108,4,18,15,7,30,21,11,14,26,42,45,23,24]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",r="sync.donot-make-requests-until",a="sync.user-session-id",n="sync.machine-session-id",t=100,s=1e3*60*5;let o=class extends i.Disposable{constructor(A,N,$){super();this.productService=A,this.configurationService=N,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter($.onDidChangeValue,D=>D.key===l.SYNC_SERVICE_URL_TYPE&&D.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(l.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(A){this.storageService.store(l.SYNC_SERVICE_URL_TYPE,A,0,b.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[l.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(l.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(A,N){A=b.isWeb&&A?.web?{...A,...A.web}:A;const $={...A||{},...N||{}};if($&&(0,I.isString)($.url)&&(0,I.isObject)($.authenticationProviders)&&Object.keys($.authenticationProviders).every(D=>(0,I.isArray)($.authenticationProviders[D].scopes))){const D=$,F=!!D.canSwitch&&!N?.url,M=D.url===D.insidersUrl?"insiders":"stable",U=(F?this.userDataSyncStoreType:void 0)||M,G=N?.url||(U==="insiders"?D.insidersUrl:U==="stable"?D.stableUrl:D.url);return{url:E.URI.parse(G),type:U,defaultType:M,defaultUrl:E.URI.parse(D.url),stableUrl:E.URI.parse(D.stableUrl),insidersUrl:E.URI.parse(D.insidersUrl),canSwitch:F,authenticationProviders:Object.keys(D.authenticationProviders).reduce((ee,V)=>(ee.push({id:V,scopes:D.authenticationProviders[V].scopes}),ee),[])}}}};o=de([J(0,v.IProductService),J(1,S.IConfigurationService),J(2,g.IStorageService)],o),e.AbstractUserDataSyncStoreManagementService=o;let c=class extends o{constructor(A,N,$){super(A,N,$);const D=this.storageService.get(u,0);D&&(this.previousConfigurationSyncStore=JSON.parse(D));const F=this.productService[l.CONFIGURATION_SYNC_STORE_KEY];F?this.storageService.store(u,JSON.stringify(F),0,1):this.storageService.remove(u,0)}async switch(A){A!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=A,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};c=de([J(0,v.IProductService),J(1,S.IConfigurationService),J(2,g.IStorageService)],c),e.UserDataSyncStoreManagementService=c;let d=class extends i.Disposable{constructor(A,N,$,D,F,M,U){super();this.requestService=$,this.logService=D,this.storageService=U,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(A),this.commonHeadersPromise=(0,w.getServiceMachineId)(F,M,U).then(G=>{const ee={"X-Client-Name":`${N.applicationName}${b.isWeb?"-web":""}`,"X-Client-Version":N.version};return N.commit&&(ee["X-Client-Commit"]=N.commit),ee}),this.session=new P(t,s,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,i.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(A,N){this.authToken={token:A,type:N}}updateUserDataSyncStoreUrl(A){this.userDataSyncStoreUrl=A?(0,C.joinPath)(A,"v1"):void 0}initDonotMakeRequestsUntil(){const A=this.storageService.getNumber(r,0);A&&Date.now()<A&&this.setDonotMakeRequestsUntil(new Date(A))}setDonotMakeRequestsUntil(A){this._donotMakeRequestsUntil?.getTime()!==A?.getTime()&&(this._donotMakeRequestsUntil=A,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(r,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,T.createCancelablePromise)(N=>(0,T.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),N).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,N=>null)):this.storageService.remove(r,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A),$={},D=await this.request(N.toString(),{type:"GET",headers:$},[],_.CancellationToken.None);return(await(0,m.asJson)(D)||[]).map(({url:M,created:U})=>({ref:(0,C.relativePath)(N,N.with({path:M})),created:U*1e3}))}async resolveContent(A,N){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A,N).toString(),D={};D["Cache-Control"]="no-cache";const F=await this.request($,{type:"GET",headers:D},[],_.CancellationToken.None);return await(0,m.asText)(F)}async delete(A){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString(),$={};await this.request(N,{type:"DELETE",headers:$},[],_.CancellationToken.None)}async read(A,N,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const D=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A,"latest").toString();$={...$},$["Cache-Control"]="no-cache",N&&($["If-None-Match"]=N.ref);const F=await this.request(D,{type:"GET",headers:$},[304],_.CancellationToken.None);let M=null;if(F.res.statusCode===304&&(M=N),M===null){const U=F.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",D,"NoRef",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);const G=await(0,m.asText)(F);if(!G&&F.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",D,"EmptyResponse",F.res.statusCode,F.res.headers[l.HEADER_OPERATION_ID]);M={ref:U,content:G}}return M}async write(A,N,$,D={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource",A).toString();D={...D},D["Content-Type"]=R.Mimes.text,$&&(D["If-Match"]=$);const M=await this.request(F,{type:"POST",data:N,headers:D},[],_.CancellationToken.None),U=M.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",F,"NoRef",M.res.statusCode,M.res.headers[l.HEADER_OPERATION_ID]);return U}async manifest(A,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=(0,C.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();N={...N},N["Content-Type"]="application/json",A&&(N["If-None-Match"]=A.ref);const D=await this.request($,{type:"GET",headers:N},[304],_.CancellationToken.None);let F=null;if(D.res.statusCode===304&&(F=A),!F){const U=D.res.headers.etag;if(!U)throw new l.UserDataSyncStoreError("Server did not return the ref",$,"NoRef",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);const G=await(0,m.asText)(D);if(!G&&D.res.statusCode===304)throw new l.UserDataSyncStoreError("Empty response",$,"EmptyResponse",D.res.statusCode,D.res.headers[l.HEADER_OPERATION_ID]);G&&(F={...JSON.parse(G),ref:U})}const M=this.storageService.get(a,0);return M&&F&&M!==F.session&&this.clearSession(),F===null&&M&&this.clearSession(),F&&this.storageService.store(a,F.session,0,1),F}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const A=(0,C.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),N={"Content-Type":R.Mimes.text};await this.request(A,{type:"DELETE",headers:N},[],_.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(a,0),this.storageService.remove(n,0)}async request(A,N,$,D){if(!this.authToken)throw new l.UserDataSyncStoreError("No Auth Token Available",A,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const F=await this.commonHeadersPromise;N.headers={...N.headers||{},...F,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(N.headers),this.logService.trace("Sending request to server",{url:A,type:N.type,headers:{...N.headers,authorization:void 0}});let M;try{M=await this.session.request(A,N,D)}catch(V){if(!(V instanceof l.UserDataSyncStoreError)){let j="RequestFailed";const Z=(0,k.getErrorMessage)(V).toLowerCase();Z.includes("xhr timeout")?j="RequestTimeout":Z.includes("protocol")&&Z.includes("not supported")?j="RequestProtocolNotSupported":Z.includes("request path contains unescaped characters")?j="RequestPathNotEscaped":Z.includes("headers must be an object")?j="RequestHeadersNotObject":(0,k.isPromiseCanceledError)(V)&&(j="RequestCanceled"),V=new l.UserDataSyncStoreError(`Connection refused for the request '${A}'.`,A,j,void 0,void 0)}throw this.logService.info("Request failed",A),V}const U=M.res.headers[l.HEADER_OPERATION_ID],G={url:A,status:M.res.statusCode,"execution-id":N.headers[l.HEADER_EXECUTION_ID],"operation-id":U},ee=(0,m.isSuccess)(M)||M.res.statusCode&&$.indexOf(M.res.statusCode)!==-1;if(ee?this.logService.trace("Request succeeded",G):this.logService.info("Request failed",G),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new l.UserDataSyncStoreError(`Request '${A}' failed because of Unauthorized (401).`,A,"Unauthorized",M.res.statusCode,U);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,A,"Conflict",M.res.statusCode,U);if(M.res.statusCode===410)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because the requested resource is not longer available (410).`,A,"Gone",M.res.statusCode,U);if(M.res.statusCode===412)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,A,"PreconditionFailed",M.res.statusCode,U);if(M.res.statusCode===413)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too large payload (413).`,A,"TooLarge",M.res.statusCode,U);if(M.res.statusCode===426)throw new l.UserDataSyncStoreError(`${N.type} request '${A}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,A,"UpgradeRequired",M.res.statusCode,U);if(M.res.statusCode===429){const V=M.res.headers["retry-after"];throw V?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(V)*1e3)),new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"TooManyRequestsAndRetryAfter",M.res.statusCode,U)):new l.UserDataSyncStoreError(`${N.type} request '${A}' failed because of too many requests (429).`,A,"RemoteTooManyRequests",M.res.statusCode,U)}if(!ee)throw new l.UserDataSyncStoreError("Server returned "+M.res.statusCode,A,"Unknown",M.res.statusCode,U);return M}addSessionHeaders(A){let N=this.storageService.get(n,0);N===void 0&&(N=(0,f.generateUuid)(),this.storageService.store(n,N,0,1)),A["X-Machine-Session-Id"]=N;const $=this.storageService.get(a,0);$!==void 0&&(A["X-User-Session-Id"]=$)}};d=de([J(1,v.IProductService),J(2,m.IRequestService),J(3,l.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,g.IStorageService)],d),e.UserDataSyncStoreClient=d;let p=class extends d{constructor(A,N,$,D,F,M,U){super(A.userDataSyncStore?.url,N,$,D,F,M,U);this._register(A.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(A.userDataSyncStore?.url)))}};p=de([J(0,l.IUserDataSyncStoreManagementService),J(1,v.IProductService),J(2,m.IRequestService),J(3,l.IUserDataSyncLogService),J(4,h.IEnvironmentService),J(5,y.IFileService),J(6,g.IStorageService)],p),e.UserDataSyncStoreService=p;class P{constructor(A,N,$,D){this.limit=A,this.interval=N,this.requestService=$,this.logService=D,this.requests=[],this.startTime=void 0}request(A,N,$){if(this.isExpired()&&this.reset(),N.url=A,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new l.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,A,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(A),this.requestService.request(N,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=P}),define(te[234],ne([0,1,3,59,26,23,22,230,24,62,63]),function(Q,e,T,_,k,L,i,R,b,C,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let E=class extends R.UserDataAutoSyncService{constructor(S,h,y,v,m,w,g,l,u,r,a){super(S,h,y,v,m,g,l,u,r,a);this._register(T.Event.debounce(T.Event.any(T.Event.map(w.onDidFocusWindow,()=>"windowFocus"),T.Event.map(w.onDidOpenWindow,()=>"windowOpen")),(n,t)=>n?[...n,t]:[t],1e3)(n=>this.triggerSync(n,!0,!1)))}};E=de([J(0,k.IProductService),J(1,b.IUserDataSyncStoreManagementService),J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncEnablementService),J(4,b.IUserDataSyncService),J(5,_.INativeHostService),J(6,b.IUserDataSyncLogService),J(7,C.IUserDataSyncAccountService),J(8,i.ITelemetryService),J(9,I.IUserDataSyncMachinesService),J(10,L.IStorageService)],E),e.UserDataAutoSyncService=E}),define(te[235],ne([0,1,5,3,2]),function(Q,e,T,_,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:R,onDidFocusWindow:b,getActiveWindowId:C}){super();this.disposables=this._register(new k.DisposableStore),_.Event.latch(_.Event.any(R,b))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,T.createCancelablePromise)(()=>C()),(async()=>{try{const E=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:E}catch(E){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(R){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=R}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(te[64],ne([0,1,49,5,9,15,20,124,247,248]),function(Q,e,T,_,k,L,i,R,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class I extends Error{constructor(r,a){let n=a.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=r,this.cause=a}}e.ExtractError=I;function E(u){const r=u.externalFileAttributes>>16||33188;return[448,56,7].map(a=>r&a).reduce((a,n)=>a+n,r&61440)}function f(u){if(u instanceof I)return u;let r;return/end of central directory record signature not found/.test(u.message)&&(r="CorruptZip"),new I(r,u)}function S(u,r,a,n,t,s){const o=k.dirname(r),c=k.join(n,o);if(!c.startsWith(n))return Promise.reject(new Error(R.localize(0,null,r)));const d=k.join(n,r);let p;return s.onCancellationRequested(()=>{p&&p.destroy()}),Promise.resolve(i.Promises.mkdir(c,{recursive:!0})).then(()=>new Promise((P,O)=>{if(!s.isCancellationRequested)try{p=(0,T.createWriteStream)(d,{mode:a}),p.once("close",()=>P()),p.once("error",O),u.once("error",O),u.pipe(p)}catch(A){O(A)}}))}function h(u,r,a,n){let t=(0,_.createCancelablePromise)(()=>Promise.resolve()),s=0;return n.onCancellationRequested(()=>{t.cancel(),u.close()}),new Promise((o,c)=>{const d=new _.Sequencer,p=P=>{P.isCancellationRequested||(s++,u.readEntry())};u.once("error",c),u.once("close",()=>t.then(()=>{n.isCancellationRequested||u.entryCount===s?o():c(new I("Incomplete",new Error(R.localize(1,null,s,u.entryCount))))},c)),u.readEntry(),u.on("entry",P=>{if(n.isCancellationRequested)return;if(!a.sourcePathRegex.test(P.fileName)){p(n);return}const O=P.fileName.replace(a.sourcePathRegex,"");if(/\/$/.test(O)){const $=k.join(r,O);t=(0,_.createCancelablePromise)(D=>i.Promises.mkdir($,{recursive:!0}).then(()=>p(D)).then(void 0,c));return}const A=v(u,P),N=E(P);t=(0,_.createCancelablePromise)($=>d.queue(()=>A.then(D=>S(D,O,N,r,a,$).then(()=>p($)))).then(null,c))})})}function y(u,r=!1){return new Promise((a,n)=>{(0,b.open)(u,r?{lazyEntries:!0}:void 0,(t,s)=>{t?n(f(t)):a((0,L.assertIsDefined)(s))})})}function v(u,r){return new Promise((a,n)=>{u.openReadStream(r,(t,s)=>{t?n(f(t)):a((0,L.assertIsDefined)(s))})})}function m(u,r){return new Promise((a,n)=>{const t=new C.ZipFile;r.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,T.createWriteStream)(u);t.outputStream.pipe(s),t.outputStream.once("error",n),s.once("error",n),s.once("finish",()=>a(u))})}e.zip=m;function w(u,r,a={},n){const t=new RegExp(a.sourcePath?`^${a.sourcePath}`:"");let s=y(u,!0);return a.overwrite&&(s=s.then(o=>i.Promises.rm(r).then(()=>o))),s.then(o=>h(o,r,{sourcePathRegex:t},n))}e.extract=w;function g(u,r){return y(u).then(a=>new Promise((n,t)=>{a.on("entry",s=>{s.fileName===r&&v(a,s).then(o=>n(o),o=>t(o))}),a.once("close",()=>t(new Error(R.localize(2,null,r))))}))}function l(u,r){return g(u,r).then(a=>new Promise((n,t)=>{const s=[];a.once("error",t),a.on("data",o=>s.push(o)),a.on("end",()=>n(Buffer.concat(s)))}))}e.buffer=l}),define(te[236],ne([0,1,64,133]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,T.buffer)(L,"extension/package.json").then(i=>{try{return JSON.parse(i.toString("utf8"))}catch(R){throw new Error((0,_.localize)(0,null))}})}e.getManifest=k}),define(te[237],ne([0,1,16,5,10,2,17,9,4,18,60,7,30,20,64,134,11,29,34,155,14,8,26]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;let a=class extends L.Disposable{constructor(t,s,o,c,d){super();this.beforeRemovingExtension=t,this.fileService=s,this.logService=o,this.environmentService=c,this.productService=d,this._devSystemExtensionsPath=null,this.systemExtensionsPath=c.builtinExtensionsPath,this.extensionsPath=c.extensionsPath,this.uninstalledPath=R.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new _.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(t){const s=[];(t===null||t===0)&&s.push(this.scanSystemExtensions().then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal)))),(t===null||t===1)&&s.push(this.scanUserExtensions(!0).then(null,o=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(o).message,m.ExtensionManagementErrorCode.Internal))));try{const o=await Promise.all(s);return(0,T.flatten)(o)}catch(o){throw this.joinErrors(o)}}async scanUserExtensions(t){this.logService.trace("Started scanning user extensions");let[s,o]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return o=o.filter(c=>!s[new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).key()]),t&&(o=(0,w.groupByExtension)(o,d=>d.identifier).map(d=>d.sort((p,P)=>I.rcompare(p.manifest.version,P.manifest.version))[0])),this.logService.trace("Scanned user extensions:",o.length),o}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(t,s,o,c){const d=t.key(),p=R.join(this.extensionsPath,`.${(0,f.generateUuid)()}`),P=R.join(this.extensionsPath,d);try{await S.Promises.rm(P)}catch(A){try{await S.Promises.rm(P)}catch(N){}throw new m.ExtensionManagementError((0,y.localize)(0,null,P,t.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(t,s,p,c);let O=await this.scanExtension(E.URI.file(p),1);if(!O)throw new Error((0,y.localize)(1,null,p));await this.storeMetadata(O,{...o,installedTimestamp:Date.now()});try{await this.rename(t,p,P,Date.now()+2*60*1e3),this.logService.info("Renamed to",P)}catch(A){try{await S.Promises.rm(p)}catch(N){}if(A.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",t.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(A)}. Deleted from extracted location`,p),A}try{O=await this.scanExtension(E.URI.file(P),1)}catch(A){}if(O)return O;throw new Error((0,y.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(t,s){return this.setMetadata(t,s),await this.storeMetadata(t,{...s,installedTimestamp:t.installedTimestamp}),t}async storeMetadata(t,s){s.isMachineScoped=s.isMachineScoped||void 0,s.isBuiltin=s.isBuiltin||void 0,s.installedTimestamp=s.installedTimestamp||void 0;const o=R.join(t.location.fsPath,"package.json"),c=await S.Promises.readFile(o,"utf8"),{manifest:d}=await this.parseManifest(c);return d.__metadata=s,await S.Promises.writeFile(o,JSON.stringify(d,null,"	")),t}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...t){const s=t.map(o=>new w.ExtensionIdentifierWithVersion(o.identifier,o.manifest.version));await this.withUninstalledExtensions(o=>{s.forEach(c=>o[c.key()]=!0)})}async setInstalled(t){await this.withUninstalledExtensions(c=>delete c[t.key()]);const o=(await this.scanExtensions(1)).find(c=>new w.ExtensionIdentifierWithVersion(c.identifier,c.manifest.version).equals(t))||null;return o?(await this.storeMetadata(o,{installedTimestamp:Date.now()}),this.scanExtension(o.location,1)):null}async withUninstalledExtensions(t){return this.uninstalledFileLimiter.queue(async()=>{let s;try{s=await S.Promises.readFile(this.uninstalledPath,"utf8")}catch(c){if(c.code!=="ENOENT")throw c}let o={};if(s)try{o=JSON.parse(s)}catch(c){}return t&&(t(o),Object.keys(o).length?await S.Promises.writeFile(this.uninstalledPath,JSON.stringify(o)):await S.Promises.rm(this.uninstalledPath)),o})}async removeExtension(t,s){this.logService.trace(`Deleting ${s} extension from disk`,t.identifier.id,t.location.fsPath),await S.Promises.rm(t.location.fsPath),this.logService.info("Deleted from disk",t.identifier.id,t.location.fsPath)}async removeUninstalledExtension(t){await this.removeExtension(t,"uninstalled"),await this.withUninstalledExtensions(s=>delete s[new w.ExtensionIdentifierWithVersion(t.identifier,t.manifest.version).key()])}async extractAtLocation(t,s,o,c){this.logService.trace(`Started extracting the extension from ${s} to ${o}`);try{await S.Promises.rm(o)}catch(d){throw new m.ExtensionManagementError(this.joinErrors(d).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,h.extract)(s,o,{sourcePath:"extension",overwrite:!0},c),this.logService.info(`Extracted extension to ${o}:`,t.id)}catch(d){try{await S.Promises.rm(o)}catch(P){}let p=m.ExtensionManagementErrorCode.Extract;throw d instanceof h.ExtractError&&(d.type==="CorruptZip"?p=m.ExtensionManagementErrorCode.CorruptZip:d.type==="Incomplete"&&(p=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(d.message,p)}}async rename(t,s,o,c){try{await S.Promises.rename(s,o)}catch(d){if(b.isWindows&&d&&d.code==="EPERM"&&Date.now()<c)return this.logService.info(`Failed renaming ${s} to ${o} with 'EPERM' error. Trying again...`,t.id),this.rename(t,s,o,c);throw new m.ExtensionManagementError(d.message||(0,y.localize)(3,null,s,o),d.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const t=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return t;const s=this.scanDevSystemExtensions(),[o,c]=await Promise.all([t,s]);return[...o,...c]}async scanExtensionsInDir(t,s){const o=new _.Limiter(10),c=await this.fileService.resolve(E.URI.file(t));return c.children?(await Promise.all(c.children.filter(p=>p.isDirectory).map(p=>o.queue(async()=>s===1&&(0,C.basename)(p.resource).indexOf(".")===0?null:this.scanExtension(p.resource,s))))).filter(p=>p&&p.identifier):[]}async scanExtension(t,s){try{const o=await this.fileService.resolve(t);if(o.children){const{manifest:c,metadata:d}=await this.readManifest(t.fsPath),p=o.children.find(({name:N})=>/^readme(\.txt|\.md|)$/i.test(N))?.resource,P=o.children.find(({name:N})=>/^changelog(\.txt|\.md|)$/i.test(N))?.resource,O={id:(0,w.getGalleryExtensionId)(c.publisher,c.name)},A={type:s,identifier:O,manifest:c,location:t,readmeUrl:p,changelogUrl:P,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:s===0};return this.setMetadata(A,d),A}}catch(o){s!==0&&this.logService.trace(o)}return null}async scanDefaultSystemExtensions(){const t=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",t.length),t}async scanDevSystemExtensions(){const t=this.getDevSystemExtensionsList();if(t.length){const s=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",s.length),s.filter(o=>t.some(c=>(0,w.areSameExtensions)(o.identifier,{id:c})))}else return[]}setMetadata(t,s){t.publisherDisplayName=s?.publisherDisplayName||null,t.publisherId=s?.publisherId||null,t.identifier.uuid=s?.id,t.isMachineScoped=!!s?.isMachineScoped,t.isPreReleaseVersion=!!s?.isPreReleaseVersion,t.preRelease=!!s?.preRelease,t.isBuiltin=t.type===0||!!s?.isBuiltin,t.installedTimestamp=s?.installedTimestamp}async removeUninstalledExtensions(){const t=await this.getUninstalledExtensions(),s=await this.scanAllUserExtensions(),o=new Set;for(const p of s)t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]||o.add(p.identifier.id.toLowerCase());const c=(0,w.groupByExtension)(s,p=>p.identifier);await _.Promises.settled(c.map(async p=>{const P=p.sort((O,A)=>I.rcompare(O.manifest.version,A.manifest.version))[0];o.has(P.identifier.id.toLowerCase())||await this.beforeRemovingExtension(P)}));const d=s.filter(p=>t[new w.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]);await _.Promises.settled(d.map(p=>this.removeUninstalledExtension(p)))}async removeOutdatedExtensions(){const t=await this.scanAllUserExtensions(),s=[],o=(0,w.groupByExtension)(t,c=>c.identifier);s.push(...(0,T.flatten)(o.map(c=>c.sort((d,p)=>I.rcompare(d.manifest.version,p.manifest.version)).slice(1)))),await _.Promises.settled(s.map(c=>this.removeExtension(c,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(t=>t.name)}joinErrors(t){const s=Array.isArray(t)?t:[t];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=R.normalize(R.join(i.FileAccess.asFileUri("",Q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(t){const s=[S.Promises.readFile(R.join(t,"package.json"),"utf8").then(p=>this.parseManifest(p)),S.Promises.readFile(R.join(t,"package.nls.json"),"utf8").then(void 0,p=>p.code!=="ENOENT"?Promise.reject(p):"{}").then(p=>JSON.parse(p))],[{manifest:o,metadata:c},d]=await Promise.all(s);return{manifest:(0,g.localizeManifest)(o,d),metadata:c}}parseManifest(t){return new Promise((s,o)=>{try{const c=JSON.parse(t),d=c.__metadata||null;s({manifest:c,metadata:d})}catch(c){o(new Error((0,y.localize)(4,null)))}})}};a=de([J(1,l.IFileService),J(2,u.ILogService),J(3,v.INativeEnvironmentService),J(4,r.IProductService)],a),e.ExtensionsScanner=a}),define(te[238],ne([0,1,38,10,17,9,4,32,18,60,7,30,20,64,132,79,11,200,29,34,184,173,236,185,237,214,76,14,6,8,26,22,35]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u,r,a,n,t,s,o,c,d,p,P,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;let A=class extends m.AbstractExtensionManagementService{constructor(U,G,ee,V,j,Z,W,z,B){super(U,G,ee,z);this.environmentService=V,this.downloadService=j,this.fileService=W;const q=this._register(Z.createInstance(u.ExtensionsLifecycle));this.extensionsScanner=this._register(Z.createInstance(n.ExtensionsScanner,Y=>q.postUninstall(Y))),this.manifestCache=this._register(new a.ExtensionsManifestCache(V,this)),this.extensionsDownloader=this._register(Z.createInstance(l.ExtensionsDownloader));const H=this._register(new t.ExtensionsWatcher(this,W,V,ee,B));this._register(H.onDidChangeExtensionsByAnotherSource(({added:Y,removed:x})=>{Y.length&&this._onDidInstallExtensions.fire(Y.map(K=>({identifier:K.identifier,operation:1,local:K}))),x.forEach(K=>this._onDidUninstallExtension.fire({identifier:K}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const U=await this.isAlpineLinux(),G=(0,w.getTargetPlatform)(U?"alpine":i.platform,R.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",G),G})()),this._targetPlatformPromise}async isAlpineLinux(){if(!i.isLinux)return!1;let U;try{U=(await this.fileService.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch(G){try{U=(await this.fileService.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(ee){this.logService.debug("Error while getting the os-release file.",(0,_.getErrorMessage)(ee))}}return!!U&&(U.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(U){this.logService.trace("ExtensionManagementService#zip",U.identifier.id);const G=await this.collectFiles(U),ee=await(0,S.zip)((0,b.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)()).fsPath,G);return I.URI.file(ee)}async unzip(U){return this.logService.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const G=await this.downloadVsix(U),ee=L.resolve(G.fsPath);return(0,r.getManifest)(ee)}getInstalled(U=null){return this.extensionsScanner.scanExtensions(U)}async install(U,G={}){this.logService.trace("ExtensionManagementService#install",U.toString());const ee=await this.downloadVsix(U),V=await(0,r.getManifest)(L.resolve(ee.fsPath));if(V.engines&&V.engines.vscode&&!(0,s.isEngineValid)(V.engines.vscode,this.productService.version,this.productService.date))throw new Error(h.localize(0,null,(0,g.getGalleryExtensionId)(V.publisher,V.name),this.productService.version));return this.installExtension(V,ee,G)}async updateMetadata(U,G){this.logService.trace("ExtensionManagementService#updateMetadata",U.identifier.id);const ee={...U.manifest.__metadata||{},...G};return G.isPreReleaseVersion&&(ee.preRelease=!0),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,ee),this.manifestCache.invalidate(),U}async updateExtensionScope(U,G){return this.logService.trace("ExtensionManagementService#updateExtensionScope",U.identifier.id),U=await this.extensionsScanner.saveMetadataForLocalExtension(U,{...U.manifest.__metadata||{},isMachineScoped:G}),this.manifestCache.invalidate(),U}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(U){if(U.scheme===k.Schemas.file)return U;const G=(0,b.joinPath)(this.environmentService.tmpDir,(0,E.generateUuid)());return await this.downloadService.download(U,G),G}createInstallExtensionTask(U,G,ee){return I.URI.isUri(G)?new D(U,G,ee,this.galleryService,this.extensionsScanner,this.logService):new $(G,ee,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(U,G){return new F(U,G,this.extensionsScanner)}async collectFiles(U){const G=async V=>{let j=await f.Promises.readdir(V);j=j.map(z=>L.join(V,z));const Z=await Promise.all(j.map(z=>f.Promises.stat(z)));let W=Promise.resolve([]);return Z.forEach((z,B)=>{const q=j[B];z.isFile()&&(W=W.then(H=>[...H,q])),z.isDirectory()&&(W=W.then(H=>G(q).then(Y=>[...H,...Y])))}),W};return(await G(U.location.fsPath)).map(V=>({path:`extension/${L.relative(U.location.fsPath,V)}`,localPath:V}))}};A=de([J(0,w.IExtensionGalleryService),J(1,P.ITelemetryService),J(2,d.ILogService),J(3,v.INativeEnvironmentService),J(4,y.IDownloadService),J(5,c.IInstantiationService),J(6,o.IFileService),J(7,p.IProductService),J(8,O.IUriIdentityService)],A),e.ExtensionManagementService=A;class N extends m.AbstractExtensionTask{constructor(U,G,ee,V){super();this.identifier=U,this.source=G,this.extensionsScanner=ee,this.logService=V,this._operation=2}get operation(){return this._operation}async installExtension(U,G){try{const ee=await this.unsetUninstalledAndGetLocal(U.identifierWithVersion);if(ee)return U.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ee,{...ee.manifest.__metadata||{},...U.metadata}):ee}catch(ee){throw i.isMacintosh?new w.ExtensionManagementError(h.localize(1,null),w.ExtensionManagementErrorCode.Internal):new w.ExtensionManagementError(h.localize(2,null),w.ExtensionManagementErrorCode.Internal)}return this.extract(U,G)}async unsetUninstalledAndGetLocal(U){if(!await this.isUninstalled(U))return null;this.logService.trace("Removing the extension from uninstalled list:",U.id);const ee=await this.extensionsScanner.setInstalled(U);return this.logService.info("Removed the extension from uninstalled list:",U.id),ee}async isUninstalled(U){return!!(await this.extensionsScanner.getUninstalledExtensions())[U.key()]}async extract({zipPath:U,identifierWithVersion:G,metadata:ee},V){let j=await this.extensionsScanner.extractUserExtension(G,U,ee,V);return this.logService.info("Extracting completed.",G.id),j}}class $ extends N{constructor(U,G,ee,V,j){super(U.identifier,U,V,j);this.gallery=U,this.options=G,this.extensionsDownloader=ee}async doRun(U){const ee=(await this.extensionsScanner.scanExtensions(null)).find(j=>(0,g.areSameExtensions)(j.identifier,this.gallery.identifier));ee&&(this._operation=3);const V=await this.downloadInstallableExtension(this.gallery,this._operation);V.metadata.isMachineScoped=this.options.isMachineScoped||ee?.isMachineScoped,V.metadata.isBuiltin=this.options.isBuiltin||ee?.isBuiltin,V.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,V.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ee?.preRelease;try{const j=await this.installExtension(V,U);return ee&&C.neq(ee.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ee),j}catch(j){throw await this.deleteDownloadedVSIX(V.zipPath),j}}async deleteDownloadedVSIX(U){try{await this.extensionsDownloader.delete(I.URI.file(U))}catch(G){this.logService.warn("Error while deleting the downloaded vsix",U.toString(),(0,_.getErrorMessage)(G))}}async downloadInstallableExtension(U,G){const ee={id:U.identifier.uuid,publisherId:U.publisherId,publisherDisplayName:U.publisherDisplayName};let V;try{this.logService.trace("Started downloading extension:",U.identifier.id),V=(await this.extensionsDownloader.downloadExtension(U,G)).fsPath,this.logService.info("Downloaded extension:",U.identifier.id,V)}catch(j){throw new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Download)}try{const j=await(0,r.getManifest)(V);return{zipPath:V,identifierWithVersion:new g.ExtensionIdentifierWithVersion(U.identifier,j.version),metadata:ee}}catch(j){throw await this.deleteDownloadedVSIX(V),new w.ExtensionManagementError((0,m.joinErrors)(j).message,w.ExtensionManagementErrorCode.Invalid)}}}class D extends N{constructor(U,G,ee,V,j,Z){super({id:(0,g.getGalleryExtensionId)(U.publisher,U.name)},G,j,Z);this.manifest=U,this.location=G,this.options=ee,this.galleryService=V}async doRun(U){const G=new g.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),V=(await this.extensionsScanner.scanExtensions(1)).find(Z=>(0,g.areSameExtensions)(this.identifier,Z.identifier)),j=await this.getMetadata(this.identifier.id,this.manifest.version,U);if(j.isMachineScoped=this.options.isMachineScoped||V?.isMachineScoped,j.isBuiltin=this.options.isBuiltin||V?.isBuiltin,V)if(this._operation=3,G.equals(new g.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version)))try{await this.extensionsScanner.removeExtension(V,"existing")}catch(Z){throw new Error(h.localize(3,null,this.manifest.displayName||this.manifest.name))}else C.gt(V.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(V);else{const Z=await this.unsetUninstalledAndGetLocal(G);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch(W){throw new Error(h.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:L.resolve(this.location.fsPath),identifierWithVersion:G,metadata:j},U)}async getMetadata(U,G,ee){try{let[V]=await this.galleryService.getExtensions([{id:U,version:G}],ee);if(V||([V]=await this.galleryService.getExtensions([{id:U}],ee)),V)return{id:V.identifier.uuid,publisherDisplayName:V.publisherDisplayName,publisherId:V.publisherId,isPreReleaseVersion:V.properties.isPreReleaseVersion,preRelease:V.properties.isPreReleaseVersion}}catch(V){}return{}}}class F extends m.AbstractExtensionTask{constructor(U,G,ee){super();this.extension=U,this.options=G,this.extensionsScanner=ee}async doRun(U){const G=[],ee=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const V=new g.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);G.push(...ee.filter(j=>V.equals(new g.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version))))}else G.push(...ee.filter(V=>(0,g.areSameExtensions)(V.identifier,this.extension.identifier)));if(!G.length)throw new Error(h.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...G),this.options.remove)for(const V of G)try{U.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(V)}catch(j){throw new Error(h.localize(6,null,(0,T.toErrorMessage)(j)))}}}}),define(te[239],ne([0,1,81,54,33,19,10,3,2,9,4,30,36,71,249]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class y{constructor(P,O=""){this.debugLabel=O,this.socket=P,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=A=>{if(this.traceSocketEvent("error",{code:A?.code,message:A?.message}),A){if(A.code==="EPIPE")return;(0,i.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}traceSocketEvent(P,O){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,P,O)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(P){const O=A=>{this.traceSocketEvent("read",A),P(L.VSBuffer.wrap(A))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(P){const O=A=>{this.traceSocketEvent("close",{hadError:A}),P({type:0,hadError:A,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(P){const O=()=>{this.traceSocketEvent("nodeEndReceived"),P()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(P){if(!this.socket.destroyed)try{this.traceSocketEvent("write",P),this.socket.write(P.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,i.onUnexpectedError)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,i.onUnexpectedError)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((P,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),P();return}const A=()=>{this.socket.off("close",A),this.socket.off("end",A),this.socket.off("error",A),this.socket.off("timeout",A),this.socket.off("drain",A),this.traceSocketEvent("nodeDrainEnd"),P()};this.socket.on("close",A),this.socket.on("end",A),this.socket.on("error",A),this.socket.on("timeout",A),this.socket.on("drain",A)})}}e.NodeSocket=y;var v;(function(p){p[p.MinHeaderByteSize=2]="MinHeaderByteSize"})(v||(v={}));var m;(function(p){p[p.PeekHeader=1]="PeekHeader",p[p.ReadHeader=2]="ReadHeader",p[p.ReadBody=3]="ReadBody",p[p.Fin=4]="Fin"})(m||(m={}));class w extends b.Disposable{constructor(P,O,A,N){super();this._onData=this._register(new R.Emitter),this._onClose=this._register(new R.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=P,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:A?.byteLength||0,recordInflateBytes:N}),this._flowManager=this._register(new g(this,O,A,N,this._onData,($,D)=>this._write($,D))),this._register(this._flowManager.onError($=>{console.error($),(0,i.onUnexpectedError)($),this._onClose.fire({type:0,hadError:!0,error:$})})),this._incomingData=new S.ChunkStream,this._register(this.socket.onData($=>this._acceptChunk($))),this._register(this.socket.onClose($=>this._onClose.fire($)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(P,O){this.socket.traceSocketEvent(P,O)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(P){return this._onData.event(P)}onClose(P){return this._onClose.event(P)}onEnd(P){return this.socket.onEnd(P)}write(P){this._flowManager.writeMessage(P)}_write(P,O){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",P);let A=2;P.byteLength<126?A+=0:P.byteLength<2**16?A+=2:A+=8;const N=L.VSBuffer.alloc(A);if(O?N.writeUInt8(194,0):N.writeUInt8(130,0),P.byteLength<126)N.writeUInt8(P.byteLength,1);else if(P.byteLength<2**16){N.writeUInt8(126,1);let $=1;N.writeUInt8(P.byteLength>>>8&255,++$),N.writeUInt8(P.byteLength>>>0&255,++$)}else{N.writeUInt8(127,1);let $=1;N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(0,++$),N.writeUInt8(P.byteLength>>>24&255,++$),N.writeUInt8(P.byteLength>>>16&255,++$),N.writeUInt8(P.byteLength>>>8&255,++$),N.writeUInt8(P.byteLength>>>0&255,++$)}this.socket.write(L.VSBuffer.concat([N,P]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(P){if(P.byteLength!==0){for(this._incomingData.acceptChunk(P);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const O=this._incomingData.peek(this._state.readLen),A=O.readUInt8(0),N=(A&128)>>>7,$=(A&64)>>>6,D=O.readUInt8(1),F=(D&128)>>>7,M=D&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(M===126?2:0)+(M===127?8:0),this._state.fin=N,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean($)),this._state.firstFrameOfMessage=Boolean(N),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const O=this._incomingData.read(this._state.readLen),A=O.readUInt8(1),N=(A&128)>>>7;let $=A&127,D=1;$===126?$=O.readUInt8(++D)*2**8+O.readUInt8(++D):$===127&&($=O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*0+O.readUInt8(++D)*2**24+O.readUInt8(++D)*2**16+O.readUInt8(++D)*2**8+O.readUInt8(++D));let F=0;N&&(F=O.readUInt8(++D)*2**24+O.readUInt8(++D)*2**16+O.readUInt8(++D)*2**8+O.readUInt8(++D)),this._state.state=3,this._state.readLen=$,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const O=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),r(O,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(O,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await R.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=w;class g extends b.Disposable{constructor(P,O,A,N,$,D){super();this._tracer=P,this._onData=$,this._writeFn=D,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new R.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,O?(this._zlibInflateStream=this._register(new l(this._tracer,N,A,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:L.VSBuffer.alloc(0)}writeMessage(P){this._writeQueue.push(P),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const P=this._writeQueue.shift();if(this._zlibDeflateStream){const O=await this._deflateMessage(this._zlibDeflateStream,P);this._writeFn(O,!0)}else this._writeFn(P,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(P,O){return new Promise((A,N)=>{P.write(O),P.flush($=>A($))})}acceptFrame(P,O,A){this._readQueue.push({data:P,isCompressed:O,isLastFrameOfMessage:A}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const P=this._readQueue.shift();if(this._zlibInflateStream&&P.isCompressed){const O=await this._inflateFrame(this._zlibInflateStream,P.data,P.isLastFrameOfMessage);this._onData.fire(O)}else this._onData.fire(P.data)}this._isProcessingReadQueue=!1}}_inflateFrame(P,O,A){return new Promise((N,$)=>{P.write(O),A&&P.write(L.VSBuffer.fromByteArray([0,0,255,255])),P.flush(D=>N(D))})}}class l extends b.Disposable{constructor(P,O,A,N){super();this._tracer=P,this._recordInflateBytes=O,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=h.createInflateRaw(N),this._zlibInflate.on("error",$=>{this._tracer.traceSocketEvent("zlibInflateError",{message:$?.message,code:$?.code}),this._onError.fire($)}),this._zlibInflate.on("data",$=>{this._tracer.traceSocketEvent("zlibInflateData",$),this._pendingInflateData.push(L.VSBuffer.wrap($))}),A&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",A.buffer),this._zlibInflate.write(A.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?L.VSBuffer.concat(this._recordedInflateBytes):L.VSBuffer.alloc(0)}write(P){this._recordInflateBytes&&this._recordedInflateBytes.push(P.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",P),this._zlibInflate.write(P.buffer)}flush(P){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const O=L.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,P(O)})}}class u extends b.Disposable{constructor(P,O){super();this._tracer=P,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=h.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",A=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:A?.message,code:A?.code}),this._onError.fire(A)}),this._zlibDeflate.on("data",A=>{this._tracer.traceSocketEvent("zlibDeflateData",A),this._pendingDeflateData.push(L.VSBuffer.wrap(A))})}write(P){this._tracer.traceSocketEvent("zlibDeflateWrite",P.buffer),this._zlibDeflate.write(P.buffer)}flush(P){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let O=L.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,O=O.slice(0,O.byteLength-4),P(O)})}}function r(p,P){if(P===0)return;let O=p.byteLength>>>2;for(let M=0;M<O;M++){const U=p.readUInt32BE(M*4);p.writeUInt32BE(U^P,M*4)}let A=O*4,N=p.byteLength-A;const $=P>>>24&255,D=P>>>16&255,F=P>>>8&255;N>=1&&p.writeUInt8(p.readUInt8(A)^$,A),N>=2&&p.writeUInt8(p.readUInt8(A+1)^D,A+1),N>=3&&p.writeUInt8(p.readUInt8(A+2)^F,A+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function n(){const p=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${p}-sock`;let P;return e.XDG_RUNTIME_DIR?P=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${p}.sock`):P=(0,C.join)((0,k.tmpdir)(),`vscode-ipc-${p}.sock`),s(P),P}e.createRandomIPCHandle=n;function t(p,P,O){const A=(0,T.createHash)("md5").update(p).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${A}-${O}-${P}-sock`;let N;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?N=(0,C.join)(e.XDG_RUNTIME_DIR,`vscode-${A.substr(0,8)}-${O}-${P}.sock`):N=(0,C.join)(p,`${O}-${P}.sock`),s(N),N}e.createStaticIPCHandle=t;function s(p){const P=a[I.platform];typeof P=="number"&&p.length>=P&&console.warn(`WARNING: IPC handle "${p}" is longer than ${P} chars, try a shorter --user-data-dir`)}class o extends f.IPCServer{constructor(P){super(o.toClientConnectionEvent(P));this.server=P}static toClientConnectionEvent(P){const O=R.Event.fromNodeEventEmitter(P,"connection");return R.Event.map(O,A=>({protocol:new S.Protocol(new y(A,"ipc-server-connection")),onDidClientDisconnect:R.Event.once(R.Event.fromNodeEventEmitter(A,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function c(p){return new Promise((P,O)=>{const A=(0,_.createServer)();A.on("error",O),A.listen(p,()=>{A.removeListener("error",O),P(new o(A))})})}e.serve=c;function d(p,P){return new Promise((O,A)=>{const N=(0,_.createConnection)(p,()=>{N.removeListener("error",A),O(S.Client.fromSocket(new y(N,`ipc-client${P}`),P))});N.once("error",A)})}e.connect=d}),define(te[240],ne([0,1,54,239]),function(Q,e,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,L,i,R,b){const C=E=>b(E,void 0),I=T.createConnection({host:k,port:L},()=>{I.removeListener("error",C);const E=Buffer.alloc(16);for(let y=0;y<16;y++)E[y]=Math.round(Math.random()*256);const f=E.toString("base64"),S=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${L}/?${i}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];I.write(S.join(`\r
`)+`\r
\r
`);const h=y=>{y.toString().indexOf(`\r
\r
`)>=0&&(I.off("data",h),b(void 0,new _.NodeSocket(I,R)))};I.on("data",h)});I.setNoDelay(!0),I.once("error",C)}}}),define(te[241],ne([0,1,54,114,240,5,2,21,8,26,182,61,91]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function S(w,g,l,u,r){let a;for(let n=3;n&&(a&&a.dispose(),a=await new h(w,g,l,u,r).waitForReady(),!(r&&_.BROWSER_RESTRICTED_PORTS[r]||!_.BROWSER_RESTRICTED_PORTS[a.tunnelLocalPort]));n--);return a}class h extends i.Disposable{constructor(g,l,u,r,a){super();this.defaultTunnelHost=l,this.suggestedLocalPort=a,this.privacy=E.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=T.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=r,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(l=>{l()})}async waitForReady(){let g=await(0,_.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),l=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address(),l||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),l=this._server.address()),this.tunnelLocalPort=l.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${l.port}`,this}async _onConnection(g){g.pause();const l=(0,E.isLocalhost)(this.tunnelRemoteHost)||(0,E.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,I.connectRemoteAgentTunnel)(this._options,l,this.tunnelRemotePort),r=u.getSocket().socket,a=u.readEntireBuffer();u.dispose(),a.byteLength>0&&g.write(a.buffer),g.on("end",()=>{this._socketsDispose.delete(g.localAddress),r.end()}),g.on("close",()=>r.end()),g.on("error",()=>{this._socketsDispose.delete(g.localAddress),r.destroy()}),r.on("end",()=>g.end()),r.on("close",()=>g.end()),r.on("error",()=>{g.destroy()}),g.pipe(r),r.pipe(g),this._socketsDispose.set(g.localAddress,()=>{g.end(),r.end()})}}let y=class extends E.AbstractTunnelService{constructor(g,l,u,r,a){super(l);this.socketFactory=g,this.signService=u,this.productService=r,this.configurationService=a}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,l,u,r,a,n,t){const s=this.getTunnelFromMap(l,u);if(s)return++s.refcount,s.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,l,u,r,a,n,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${l}:${u} on local port ${r}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=S(o,this.defaultTunnelHost,l,u,r);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(l,u,c),c}}};y=de([J(1,b.ILogService),J(2,f.ISignService),J(3,C.IProductService),J(4,R.IConfigurationService)],y),e.BaseTunnelService=y;let v=class extends y{constructor(g,l,u,r){super(k.nodeSocketFactory,g,l,u,r)}};v=de([J(0,b.ILogService),J(1,f.ISignService),J(2,C.IProductService),J(3,R.IConfigurationService)],v),e.TunnelService=v;let m=class extends i.Disposable{constructor(g,l,u,r){super();this.logService=g,this.productService=l,this.signService=u,this.configurationService=r,this._tunnelServices=new Map}async openTunnel(g,l,u,r,a,n,t,s){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${r} on local port ${a}.`),!this._tunnelServices.has(g)){const o=new v(this.logService,this.signService,this.productService,this.configurationService);this._register(o),this._tunnelServices.set(g,o),o.onTunnelClosed(async()=>{(await o.tunnels).length===0&&(o.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(l,u,r,a,n,t,s)}};m=de([J(0,b.ILogService),J(1,C.IProductService),J(2,f.ISignService),J(3,R.IConfigurationService)],m),e.SharedTunnelsService=m}),define(te[250],ne([0,1,72,33,38,10,2,17,18,7,36,118,178,160,179,170,171,172,158,162,21,180,78,199,79,190,11,153,195,203,29,161,201,238,80,156,14,175,177,50,6,167,83,168,169,58,186,8,85,59,86,26,189,42,23,197,198,22,92,93,94,43,204,205,95,207,213,97,98,24,62,226,228,229,63,227,231,232,233,234,235,91,194,61,241,187,188,90,193,84,202,35,215]),function(Q,e,T,_,k,L,i,R,b,C,I,E,f,S,h,y,v,m,w,g,l,u,r,a,n,t,s,o,c,d,p,P,O,A,N,$,D,F,M,U,G,ee,V,j,Z,W,z,B,q,H,Y,x,K,re,se,ce,he,me,ye,we,pe,Re,Ee,De,Le,Fe,$e,ze,ie,ae,le,be,Ie,Me,Te,Ne,Ae,Ue,X,oe,ue,fe,Se,ge,Ce,Pe,ke,_e,qe,He,Ye,Ct,It){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Pt extends i.Disposable{constructor(ve){super();this.configuration=ve,this.server=this._register(new E.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ve=()=>this.dispose();process.once("exit",ve),T.ipcRenderer.once("vscode:electron-main->shared-process=exit",ve);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ge,We)=>this.onDisposeWorker(We);T.ipcRenderer.on(Oe,je),this._register((0,i.toDisposable)(()=>T.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ve){this.sharedProcessWorkerService?.disposeWorker(ve)}async open(){const ve=await this.initServices();(0,ae.registerConfiguration)(),ve.invokeFunction(Oe=>{const je=Oe.get(B.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,i.combinedDisposable)(ve.createInstance(f.CodeCacheCleaner,this.configuration.codeCachePath),ve.createInstance(h.LanguagePackCachedDataCleaner),ve.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ve.createInstance(v.LogsDataCleaner),ve.createInstance(y.LocalizationsUpdater),ve.createInstance(S.ExtensionsCleaner)))}async initServices(){const ve=new V.ServiceCollection,Oe={_serviceBrand:void 0,...Y.default};ve.set(x.IProductService,Oe);const je=new I.StaticRouter(Be=>Be==="main"),Ge=new j.MessagePortMainProcessService(this.server,je);ve.set(Z.IMainProcessService,Ge);const We=new o.NativeEnvironmentService(this.configuration.args,Oe);ve.set(s.INativeEnvironmentService,We);const rt=new q.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Qe=new q.LoggerChannelClient(this.configuration.logLevel,rt.onDidChangeLogLevel,Ge.getChannel("logger"));ve.set(B.ILoggerService,Qe);const at=this._register(new B.MultiplexLogService([this._register(new B.ConsoleLogger(this.configuration.logLevel)),this._register(Qe.createLogger((0,b.joinPath)(C.URI.file(We.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Je=this._register(new q.FollowerLogService(rt,at));ve.set(B.ILogService,Je),this.sharedProcessWorkerService=new qe.SharedProcessWorkerService(Je,Oe,We),ve.set(_e.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Xe=this._register(new F.FileService(Je));ve.set(D.IFileService,Xe);const ct=this._register(new M.DiskFileSystemProvider(Je));Xe.registerProvider(R.Schemas.file,ct);const xe=this._register(new u.ConfigurationService(We.settingsResource,Xe));ve.set(l.IConfigurationService,xe);const tt=new ce.NativeStorageService(void 0,Ge,We);ve.set(se.IStorageService,tt),this._register((0,i.toDisposable)(()=>tt.flush())),await Promise.all([xe.initialize(),tt.initialize()]),ve.set(He.IUserConfigurationFileService,I.ProxyChannel.toService(Ge.getChannel(He.UserConfigurationFileServiceId))),ve.set(Ct.IUriIdentityService,new It.UriIdentityService(Xe)),ve.set(re.IRequestService,new U.SyncDescriptor(K.RequestService)),ve.set(w.IChecksumService,new U.SyncDescriptor(g.ChecksumService));const st=I.ProxyChannel.toService(Ge.getChannel("nativeHost"),{context:this.configuration.windowId});ve.set(H.INativeHostService,st),ve.set(n.IDownloadService,new U.SyncDescriptor(t.DownloadService));const lt=this._register(new ue.ActiveWindowManager(st)),ut=new I.StaticRouter(Be=>lt.getActiveClientId().then(dt=>Be===dt));ve.set(N.IExtensionRecommendationNotificationService,new $.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ut)));const ht=new Ye.AssignmentService(this.configuration.machineId,xe,Oe);let nt;const Ze=[];if((0,Re.supportsTelemetry)(Oe,We)){const Be=new we.TelemetryLogAppender(Qe,We);Ze.push(Be);const{appRoot:dt,extensionsPath:kt,installSourcePath:Tt}=We;if(Oe.aiConfig&&Oe.aiConfig.asimovKey){const ot=await ht.getTreatment("telemetryMigration")??!1,ft=Oe.quality!=="stable";if(ft&&ot){const wt=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ot,!0);this._register((0,i.toDisposable)(()=>wt.flush())),Ze.push(wt)}const yt=new Ee.AppInsightsAppender("monacoworkbench",null,Oe.aiConfig.asimovKey,ft?!1:ot,ot&&ft);this._register((0,i.toDisposable)(()=>yt.flush())),Ze.push(yt)}nt=new pe.TelemetryService({appenders:Ze,commonProperties:(0,he.resolveCommonProperties)(Xe,(0,_.release)(),(0,_.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,Oe.msftInternalDomains,Tt),sendErrorTelemetry:!0,piiPaths:[dt,kt]},xe)}else{nt=Re.NullTelemetryService;const Be=Re.NullAppender;Ze.push(Be)}this.server.registerChannel("telemetryAppender",new ye.TelemetryAppenderChannel(Ze)),ve.set(me.ITelemetryService,nt);const Dt=new De.CustomEndpointTelemetryService(xe,nt,Qe,We);ve.set(me.ICustomEndpointTelemetryService,Dt),ve.set(p.IExtensionManagementService,new U.SyncDescriptor(A.ExtensionManagementService)),ve.set(p.IExtensionGalleryService,new U.SyncDescriptor(d.ExtensionGalleryService)),ve.set(p.IExtensionTipsService,new U.SyncDescriptor(O.ExtensionTipsService)),ve.set(W.ILocalizationsService,new U.SyncDescriptor(z.LocalizationsService)),ve.set(r.IDiagnosticsService,new U.SyncDescriptor(a.DiagnosticsService)),ve.set(le.IUserDataSyncAccountService,new U.SyncDescriptor(le.UserDataSyncAccountService)),ve.set(ae.IUserDataSyncLogService,new U.SyncDescriptor(Me.UserDataSyncLogService)),ve.set(ae.IUserDataSyncUtilService,new Ie.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ve.set(p.IGlobalExtensionEnablementService,new U.SyncDescriptor(c.GlobalExtensionEnablementService)),ve.set(ie.IIgnoredExtensionsManagementService,new U.SyncDescriptor(ie.IgnoredExtensionsManagementService)),ve.set(ze.IExtensionsStorageSyncService,new U.SyncDescriptor(ze.ExtensionsStorageSyncService)),ve.set(ae.IUserDataSyncStoreManagementService,new U.SyncDescriptor(X.UserDataSyncStoreManagementService)),ve.set(ae.IUserDataSyncStoreService,new U.SyncDescriptor(X.UserDataSyncStoreService)),ve.set(Te.IUserDataSyncMachinesService,new U.SyncDescriptor(Te.UserDataSyncMachinesService)),ve.set(ae.IUserDataSyncBackupStoreService,new U.SyncDescriptor(be.UserDataSyncBackupStoreService)),ve.set(ae.IUserDataSyncEnablementService,new U.SyncDescriptor(Ne.UserDataSyncEnablementService)),ve.set(ae.IUserDataSyncService,new U.SyncDescriptor(Ae.UserDataSyncService));const St=new $e.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:xe.getValue("terminal.integrated.persistentSessionScrollback")??100},xe,We,Je,nt);return await St.initialize(),ve.set(Fe.ILocalPtyService,this._register(St)),ve.set(fe.ISignService,new U.SyncDescriptor(Se.SignService)),ve.set(ge.ISharedTunnelsService,new U.SyncDescriptor(Ce.SharedTunnelsService)),ve.set(Pe.ISharedProcessTunnelService,new U.SyncDescriptor(ke.SharedProcessTunnelService)),new ee.InstantiationService(ve)}initChannels(ve){const Oe=new P.ExtensionManagementChannel(ve.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=I.ProxyChannel.fromService(ve.get(W.ILocalizationsService));this.server.registerChannel("localizations",je);const Ge=I.ProxyChannel.fromService(ve.get(r.IDiagnosticsService));this.server.registerChannel("diagnostics",Ge);const We=new P.ExtensionTipsChannel(ve.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",We);const rt=I.ProxyChannel.fromService(ve.get(w.IChecksumService));this.server.registerChannel("checksum",rt);const Qe=new Ie.UserDataSyncMachinesServiceChannel(ve.get(Te.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Qe);const at=I.ProxyChannel.fromService(ve.get(me.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",at);const Je=new Ie.UserDataSyncAccountServiceChannel(ve.get(le.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Je);const Xe=new Ie.UserDataSyncStoreManagementServiceChannel(ve.get(ae.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Xe);const ct=new Ue.UserDataSyncChannel(ve.get(ae.IUserDataSyncService),ve.get(B.ILogService));this.server.registerChannel("userDataSync",ct);const xe=this._register(ve.get(G.IInstantiationService).createInstance(oe.UserDataAutoSyncService)),tt=new Ie.UserDataAutoSyncChannel(xe);this.server.registerChannel("userDataAutoSync",tt);const st=ve.get(Fe.ILocalPtyService),lt=I.ProxyChannel.fromService(st);this.server.registerChannel(Le.TerminalIpcChannels.LocalPty,lt);const ut=I.ProxyChannel.fromService(ve.get(Pe.ISharedProcessTunnelService));this.server.registerChannel(Pe.ipcSharedProcessTunnelChannelName,ut);const ht=I.ProxyChannel.fromService(ve.get(_e.ISharedProcessWorkerService));this.server.registerChannel(_e.ipcSharedProcessWorkerChannelName,ht)}registerErrorHandler(ve){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,k.toErrorMessage)(Oe,!0);!je||ve.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Rt(pt){const ve=new Pt(pt);T.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ve.open(),T.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Rt})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10791447894a9abc9f2ae4927bf92bcf30f3fdef/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
