/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","electron","vs/base/common/resources","vs/base/common/errors","vs/base/common/buffer","vs/platform/files/common/files","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","fs","vs/platform/telemetry/common/telemetry","vs/platform/workspaces/common/workspaces","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/extpath","vs/base/common/labels","vs/base/common/process","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/update/common/update","vs/base/common/functional","child_process","vs/base/common/errorMessage","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/objects","vs/platform/environment/common/environment","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/backup/electron-main/backup","vs/platform/environment/node/argvHelper","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/common/worker/simpleWorker","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/diskFileSystemProviderIpc","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/parcel/parcelWatcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/electron-main/diskFileSystemProviderIpc","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/extensions/electron-main/workerMainProcessExtensionHostStarter","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","graceful-fs","worker_threads","vs/code/electron-main/main"],x=function(j){for(var e=[],p=0,D=j.length;p<D;p++)e[p]=Z[j[p]];return e};define(Z[103],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(D,C){if(!D)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(Z[46],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(n){return(I,d,f)=>{let S=null,b=null;if(typeof f.value=="function"?(S="value",b=f.value):typeof f.get=="function"&&(S="get",b=f.get),!b)throw new Error("not supported");f[S]=n(b,d)}}e.createDecorator=p;function D(n,I,d){let f=null,S=null;if(typeof d.value=="function"?(f="value",S=d.value,S.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(f="get",S=d.get),!S)throw new Error("not supported");const b=`$memoize$${I}`;d[f]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:S.apply(this,m)}),this[b]}}e.memoize=D;function C(n,I,d){return p((f,S)=>{const b=`$debounce$${S}`,m=`$debounce$result$${S}`;return function(...y){this[m]||(this[m]=d?d():void 0),clearTimeout(this[b]),I&&(this[m]=I(this[m],...y),y=[this[m]]),this[b]=setTimeout(()=>{f.apply(this,y),this[m]=d?d():void 0},n)}})}e.debounce=C;function M(n,I,d){return p((f,S)=>{const b=`$throttle$timer$${S}`,m=`$throttle$result$${S}`,y=`$throttle$lastRun$${S}`,t=`$throttle$pending$${S}`;return function(...g){if(this[m]||(this[m]=d?d():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),I&&(this[m]=I(this[m],...g)),this[t])return;const E=this[y]+n;E<=Date.now()?(this[y]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0):(this[t]=!0,this[b]=setTimeout(()=>{this[t]=!1,this[y]=Date.now(),f.apply(this,[this[m]]),this[m]=d?d():void 0},E-Date.now()))}})}e.throttle=M}),define(Z[16],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(l=>{l(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=p,e.errorHandler=new p;function D(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=D;function C(u){d(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=C;function M(u){d(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=M;function n(u){if(u instanceof Error){let{name:s,message:l}=u;const r=u.stacktrace||u.stack;return{$isError:!0,name:s,message:l,stack:r}}return u}e.transformErrorForSerialization=n;const I="Canceled";function d(u){return u instanceof Error&&u.name===I&&u.message===I}e.isPromiseCanceledError=d;class f extends Error{constructor(){super(I);this.name=this.message}}e.CancellationError=f;function S(){const u=new Error(I);return u.name=u.message,u}e.canceled=S;function b(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=b;function m(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=m;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function t(u){const s=new Error(`${u} has been disposed`);return s.name="DISPOSED",s}e.disposed=t;function g(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=g;class E extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=E;class v extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=v;class P extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=P;function c(u){const s=u;return s instanceof Error&&Array.isArray(s.actions)}e.isErrorWithActions=c;function a(u,s=Object.create(null)){const l=new Error(u);return s.actions&&(l.actions=s.actions),l}e.createErrorWithActions=a}),define(Z[30],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.compareBy=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function D(F,N=0){return F[F.length-(1+N)]}e.tail=D;function C(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.tail2=C;function M(F,N,V=(U,z)=>U===z){if(F===N)return!0;if(!F||!N||F.length!==N.length)return!1;for(let U=0,z=F.length;U<z;U++)if(!V(F[U],N[U]))return!1;return!0}e.equals=M;function n(F,N,V){let U=0,z=F.length-1;for(;U<=z;){const te=(U+z)/2|0,re=V(F[te],N);if(re<0)U=te+1;else if(re>0)z=te-1;else return te}return-(U+1)}e.binarySearch=n;function I(F,N){let V=0,U=F.length;if(U===0)return 0;for(;V<U;){const z=Math.floor((V+U)/2);N(F[z])?U=z:V=z+1}return V}e.findFirstInSorted=I;function d(F,N,V){if(F=F|0,F>=N.length)throw new TypeError("invalid index");let U=N[Math.floor(N.length*Math.random())],z=[],te=[],re=[];for(let se of N){const J=V(se,U);J<0?z.push(se):J>0?te.push(se):re.push(se)}return F<z.length?d(F,z,V):F<z.length+re.length?re[0]:d(F-(z.length+re.length),te,V)}e.quickSelect=d;function f(F,N){const V=[];let U;for(const z of F.slice(0).sort(N))!U||N(U[0],z)!==0?(U=[z],V.push(U)):U.push(z);return V}e.groupBy=f;function S(F,N,V){const U=[];function z(se,J,ce){if(J===0&&ce.length===0)return;const le=U[U.length-1];le&&le.start+le.deleteCount===se?(le.deleteCount+=J,le.toInsert.push(...ce)):U.push({start:se,deleteCount:J,toInsert:ce})}let te=0,re=0;for(;;){if(te===F.length){z(te,0,N.slice(re));break}if(re===N.length){z(te,F.length-te,[]);break}const se=F[te],J=N[re],ce=V(se,J);ce===0?(te+=1,re+=1):ce<0?(z(te,1,[]),te+=1):ce>0&&(z(te,0,[J]),re+=1)}return U}e.sortedDiff=S;function b(F,N,V){const U=S(F,N,V),z=[],te=[];for(const re of U)z.push(...F.slice(re.start,re.start+re.deleteCount)),te.push(...re.toInsert);return{removed:z,added:te}}e.delta=b;function m(F,N,V){if(V===0)return[];const U=F.slice(0,V).sort(N);return t(F,N,U,V,F.length),U}e.top=m;function y(F,N,V,U,z){return V===0?Promise.resolve([]):new Promise((te,re)=>{(async()=>{const se=F.length,J=F.slice(0,V).sort(N);for(let ce=V,le=Math.min(V+U,se);ce<se;ce=le,le=Math.min(le+U,se)){if(ce>V&&await new Promise(he=>setTimeout(he)),z&&z.isCancellationRequested)throw(0,p.canceled)();t(F,N,J,ce,le)}return J})().then(te,re)})}e.topAsync=y;function t(F,N,V,U,z){for(const te=V.length;U<z;U++){const re=F[U];if(N(re,V[te-1])<0){V.pop();const se=I(V,J=>N(re,J)<0);V.splice(se,0,re)}}}function g(F){return F.filter(N=>!!N)}e.coalesce=g;function E(F){let N=0;for(let V=0;V<F.length;V++)F[V]&&(F[N]=F[V],N+=1);F.length=N}e.coalesceInPlace=E;function v(F,N,V){F.splice(V,0,F.splice(N,1)[0])}e.move=v;function P(F){return!Array.isArray(F)||F.length===0}e.isFalsyOrEmpty=P;function c(F){return Array.isArray(F)&&F.length>0}e.isNonEmptyArray=c;function a(F,N=V=>V){const V=new Set;return F.filter(U=>{const z=N(U);return V.has(z)?!1:(V.add(z),!0)})}e.distinct=a;function u(F){const N=Object.create(null);return V=>{const U=F(V);return N[U]?!1:(N[U]=!0,!0)}}e.uniqueFilter=u;function s(F,N){const V=l(F,N);if(V!==-1)return F[V]}e.findLast=s;function l(F,N){for(let V=F.length-1;V>=0;V--){const U=F[V];if(N(U))return V}return-1}e.lastIndex=l;function r(F,N){return F.length>0?F[0]:N}e.firstOrDefault=r;function i(F,N,V=(U,z)=>U===z){let U=0;for(let z=0,te=Math.min(F.length,N.length);z<te&&V(F[z],N[z]);z++)U++;return U}e.commonPrefixLength=i;function o(F){return[].concat(...F)}e.flatten=o;function h(F,N){let V=typeof N=="number"?F:0;typeof N=="number"?V=F:(V=0,N=F);const U=[];if(V<=N)for(let z=V;z<N;z++)U.push(z);else for(let z=V;z>N;z--)U.push(z);return U}e.range=h;function w(F,N,V){return F.reduce((U,z)=>(U[N(z)]=V?V(z):z,U),Object.create(null))}e.index=w;function k(F,N){return F.push(N),()=>A(F,N)}e.insert=k;function A(F,N){const V=F.indexOf(N);if(V>-1)return F.splice(V,1),N}e.remove=A;function R(F,N,V){const U=F.slice(0,N),z=F.slice(N);return U.concat(V,z)}e.arrayInsert=R;function T(F,N){let V;if(typeof N=="number"){let U=N;V=()=>{const z=Math.sin(U++)*179426549;return z-Math.floor(z)}}else V=Math.random;for(let U=F.length-1;U>0;U-=1){const z=Math.floor(V()*(U+1)),te=F[U];F[U]=F[z],F[z]=te}}e.shuffle=T;function _(F,N){const V=F.indexOf(N);V>-1&&(F.splice(V,1),F.unshift(N))}e.pushToStart=_;function Q(F,N){const V=F.indexOf(N);V>-1&&(F.splice(V,1),F.push(N))}e.pushToEnd=Q;function ne(F,N){return Array.isArray(F)?F.map(N):N(F)}e.mapArrayOrNot=ne;function oe(F){return Array.isArray(F)?F:[F]}e.asArray=oe;function X(F){return F[Math.floor(Math.random()*F.length)]}e.getRandomElement=X;function O(F,N){for(const V of F){const U=N(V);if(U!==void 0)return U}}e.mapFind=O;function H(F,N,V){const U=Y(F,N),z=F.length,te=V.length;F.length=z+te;for(let re=z-1;re>=U;re--)F[re+te]=F[re];for(let re=0;re<te;re++)F[re+U]=V[re]}e.insertInto=H;function q(F,N,V,U){const z=Y(F,N),te=F.splice(z,V);return H(F,z,U),te}e.splice=q;function Y(F,N){return N<0?Math.max(N+F.length,0):Math.min(N,F.length)}function $(F,N){return(V,U)=>N(F(V),F(U))}e.compareBy=$;const K=(F,N)=>F-N;e.numberComparator=K;function ee(F,N){if(F.length===0)return;let V=F[0];for(let U=1;U<F.length;U++){const z=F[U];N(z,V)>0&&(V=z)}return V}e.findMaxBy=ee;function B(F,N){if(F.length===0)return;let V=F[0];for(let U=1;U<F.length;U++){const z=F[U];N(z,V)>=0&&(V=z)}return V}e.findLastMaxBy=B;function L(F,N){return ee(F,(V,U)=>-N(V,U))}e.findMinBy=L;class W{constructor(N){this.items=N,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(N){let V=this.firstIdx;for(;V<this.items.length&&N(this.items[V]);)V++;const U=V===this.firstIdx?null:this.items.slice(this.firstIdx,V);return this.firstIdx=V,U}takeFromEndWhile(N){let V=this.lastIdx;for(;V>=0&&N(this.items[V]);)V--;const U=V===this.lastIdx?null:this.items.slice(V+1,this.lastIdx+1);return this.lastIdx=V,U}peek(){return this.items[this.firstIdx]}dequeue(){const N=this.items[this.firstIdx];return this.firstIdx++,N}takeCount(N){const V=this.items.slice(this.firstIdx,this.firstIdx+N);return this.firstIdx+=N,V}}e.ArrayQueue=W}),define(Z[42],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(D){const C=this;let M=!1,n;return function(){return M||(M=!0,n=D.apply(C,arguments)),n}}e.once=p}),define(Z[69],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(D){function C(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}D.is=C;const M=Object.freeze([]);function n(){return M}D.empty=n;function*I(u){yield u}D.single=I;function d(u){return u||M}D.from=d;function f(u){return!u||u[Symbol.iterator]().next().done===!0}D.isEmpty=f;function S(u){return u[Symbol.iterator]().next().value}D.first=S;function b(u,s){for(const l of u)if(s(l))return!0;return!1}D.some=b;function m(u,s){for(const l of u)if(s(l))return l}D.find=m;function*y(u,s){for(const l of u)s(l)&&(yield l)}D.filter=y;function*t(u,s){let l=0;for(const r of u)yield s(r,l++)}D.map=t;function*g(...u){for(const s of u)for(const l of s)yield l}D.concat=g;function*E(u){for(const s of u)for(const l of s)yield l}D.concatNested=E;function v(u,s,l){let r=l;for(const i of u)r=s(r,i);return r}D.reduce=v;function*P(u,s,l=u.length){for(s<0&&(s+=u.length),l<0?l+=u.length:l>u.length&&(l=u.length);s<l;s++)yield u[s]}D.slice=P;function c(u,s=Number.POSITIVE_INFINITY){const l=[];if(s===0)return[l,u];const r=u[Symbol.iterator]();for(let i=0;i<s;i++){const o=r.next();if(o.done)return[l,D.empty()];l.push(o.value)}return[l,{[Symbol.iterator](){return r}}]}D.consume=c;function a(u,s,l=(r,i)=>r===i){const r=u[Symbol.iterator](),i=s[Symbol.iterator]();for(;;){const o=r.next(),h=i.next();if(o.done!==h.done)return!1;if(o.done)return!0;if(!l(o.value,h.value))return!1}}D.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[38],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var D;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(D=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(s){s.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function n(s,l=!1){let r=0,i=s.length,o="",h=0,w=16,k=0;function A(X){let O=0,H=0;for(;O<X;){const q=s.charCodeAt(r);if(q>=48&&q<=57)H=H*16+q-48;else if(q>=65&&q<=70)H=H*16+q-65+10;else if(q>=97&&q<=102)H=H*16+q-97+10;else break;r++,O++}return O<X&&(H=-1),H}function R(X){r=X,o="",h=0,w=16,k=0}function T(){const X=r;if(s.charCodeAt(r)===48)r++;else for(r++;r<s.length&&f(s.charCodeAt(r));)r++;if(r<s.length&&s.charCodeAt(r)===46)if(r++,r<s.length&&f(s.charCodeAt(r)))for(r++;r<s.length&&f(s.charCodeAt(r));)r++;else return k=3,s.substring(X,r);let O=r;if(r<s.length&&(s.charCodeAt(r)===69||s.charCodeAt(r)===101))if(r++,(r<s.length&&s.charCodeAt(r)===43||s.charCodeAt(r)===45)&&r++,r<s.length&&f(s.charCodeAt(r))){for(r++;r<s.length&&f(s.charCodeAt(r));)r++;O=r}else k=3;return s.substring(X,O)}function _(){let X="",O=r;for(;;){if(r>=i){X+=s.substring(O,r),k=2;break}const H=s.charCodeAt(r);if(H===34){X+=s.substring(O,r),r++;break}if(H===92){if(X+=s.substring(O,r),r++,r>=i){k=2;break}switch(s.charCodeAt(r++)){case 34:X+='"';break;case 92:X+="\\";break;case 47:X+="/";break;case 98:X+="\b";break;case 102:X+="\f";break;case 110:X+=`
`;break;case 114:X+="\r";break;case 116:X+="	";break;case 117:const Y=A(4);Y>=0?X+=String.fromCharCode(Y):k=4;break;default:k=5}O=r;continue}if(H>=0&&H<=31)if(d(H)){X+=s.substring(O,r),k=2;break}else k=6;r++}return X}function Q(){if(o="",k=0,h=r,r>=i)return h=i,w=17;let X=s.charCodeAt(r);if(I(X)){do r++,o+=String.fromCharCode(X),X=s.charCodeAt(r);while(I(X));return w=15}if(d(X))return r++,o+=String.fromCharCode(X),X===13&&s.charCodeAt(r)===10&&(r++,o+=`
`),w=14;switch(X){case 123:return r++,w=1;case 125:return r++,w=2;case 91:return r++,w=3;case 93:return r++,w=4;case 58:return r++,w=6;case 44:return r++,w=5;case 34:return r++,o=_(),w=10;case 47:const O=r-1;if(s.charCodeAt(r+1)===47){for(r+=2;r<i&&!d(s.charCodeAt(r));)r++;return o=s.substring(O,r),w=12}if(s.charCodeAt(r+1)===42){r+=2;const H=i-1;let q=!1;for(;r<H;){if(s.charCodeAt(r)===42&&s.charCodeAt(r+1)===47){r+=2,q=!0;break}r++}return q||(r++,k=1),o=s.substring(O,r),w=13}return o+=String.fromCharCode(X),r++,w=16;case 45:if(o+=String.fromCharCode(X),r++,r===i||!f(s.charCodeAt(r)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),w=11;default:for(;r<i&&ne(X);)r++,X=s.charCodeAt(r);if(h!==r){switch(o=s.substring(h,r),o){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return o+=String.fromCharCode(X),r++,w=16}}function ne(X){if(I(X)||d(X))return!1;switch(X){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let X;do X=Q();while(X>=12&&X<=15);return X}return{setPosition:R,getPosition:()=>r,scan:l?oe:Q,getToken:()=>w,getTokenValue:()=>o,getTokenOffset:()=>h,getTokenLength:()=>r-h,getTokenError:()=>k}}e.createScanner=n;function I(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function f(s){return s>=48&&s<=57}var S;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(S||(S={}));function b(s,l){const r=[],i=new Object;let o;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(A,R,T,_){h.value=A,h.offset=R,h.length=T,h.type=_,h.colonOffset=void 0,o=h}try{c(s,{onObjectBegin:(A,R)=>{if(l<=A)throw i;o=void 0,w=l>A,r.push("")},onObjectProperty:(A,R,T)=>{if(l<R||(k(A,R,T,"property"),r[r.length-1]=A,l<=R+T))throw i},onObjectEnd:(A,R)=>{if(l<=A)throw i;o=void 0,r.pop()},onArrayBegin:(A,R)=>{if(l<=A)throw i;o=void 0,r.push(0)},onArrayEnd:(A,R)=>{if(l<=A)throw i;o=void 0,r.pop()},onLiteralValue:(A,R,T)=>{if(l<R||(k(A,R,T,u(A)),l<=R+T))throw i},onSeparator:(A,R,T)=>{if(l<=R)throw i;if(A===":"&&o&&o.type==="property")o.colonOffset=R,w=!1,o=void 0;else if(A===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(w=!0,r[r.length-1]=""),o=void 0}}})}catch(A){if(A!==i)throw A}return{path:r,previousNode:o,isAtPropertyKey:w,matches:A=>{let R=0;for(let T=0;R<A.length&&T<r.length;T++)if(A[R]===r[T]||A[R]==="*")R++;else if(A[R]!=="**")return!1;return R===A.length}}}e.getLocation=b;function m(s,l=[],r=M.DEFAULT){let i=null,o=[];const h=[];function w(A){Array.isArray(o)?o.push(A):i!==null&&(o[i]=A)}return c(s,{onObjectBegin:()=>{const A={};w(A),h.push(o),o=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const A=[];w(A),h.push(o),o=A,i=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:w,onError:(A,R,T)=>{l.push({error:A,offset:R,length:T})}},r),o[0]}e.parse=m;function y(s,l=[],r=M.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function h(A){return i.children.push(A),A}c(s,{onObjectBegin:A=>{i=h({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,R,T)=>{i=h({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:R,length:T,parent:i})},onObjectEnd:(A,R)=>{i.length=A+R-i.offset,i=i.parent,o(A+R)},onArrayBegin:(A,R)=>{i=h({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,R)=>{i.length=A+R-i.offset,i=i.parent,o(A+R)},onLiteralValue:(A,R,T)=>{h({type:u(A),offset:R,length:T,parent:i,value:A}),o(R+T)},onSeparator:(A,R,T)=>{i.type==="property"&&(A===":"?i.colonOffset=R:A===","&&o(R))},onError:(A,R,T)=>{l.push({error:A,offset:R,length:T})}},r);const k=i.children[0];return k&&delete k.parent,k}e.parseTree=y;function t(s,l){if(!s)return;let r=s;for(let i of l)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let o=!1;for(const h of r.children)if(Array.isArray(h.children)&&h.children[0].value===i){r=h.children[1],o=!0;break}if(!o)return}else{const o=i;if(r.type!=="array"||o<0||!Array.isArray(r.children)||o>=r.children.length)return;r=r.children[o]}return r}e.findNodeAtLocation=t;function g(s){if(!s.parent||!s.parent.children)return[];const l=g(s.parent);if(s.parent.type==="property"){const r=s.parent.children[0].value;l.push(r)}else if(s.parent.type==="array"){const r=s.parent.children.indexOf(s);r!==-1&&l.push(r)}return l}e.getNodePath=g;function E(s){switch(s.type){case"array":return s.children.map(E);case"object":const l=Object.create(null);for(let r of s.children){const i=r.children[1];i&&(l[r.children[0].value]=E(i))}return l;case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=E;function v(s,l,r=!1){return l>=s.offset&&l<s.offset+s.length||r&&l===s.offset+s.length}e.contains=v;function P(s,l,r=!1){if(v(s,l,r)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=l;o++){const h=P(i[o],l,r);if(h)return h}return s}}e.findNodeAtOffset=P;function c(s,l,r=M.DEFAULT){const i=n(s,!1);function o(W){return W?()=>W(i.getTokenOffset(),i.getTokenLength()):()=>!0}function h(W){return W?F=>W(F,i.getTokenOffset(),i.getTokenLength()):()=>!0}const w=o(l.onObjectBegin),k=h(l.onObjectProperty),A=o(l.onObjectEnd),R=o(l.onArrayBegin),T=o(l.onArrayEnd),_=h(l.onLiteralValue),Q=h(l.onSeparator),ne=o(l.onComment),oe=h(l.onError),X=r&&r.disallowComments,O=r&&r.allowTrailingComma;function H(){for(;;){const W=i.scan();switch(i.getTokenError()){case 4:q(14);break;case 5:q(15);break;case 3:q(13);break;case 1:X||q(11);break;case 2:q(12);break;case 6:q(16);break}switch(W){case 12:case 13:X?q(10):ne();break;case 16:q(1);break;case 15:case 14:break;default:return W}}}function q(W,F=[],N=[]){if(oe(W),F.length+N.length>0){let V=i.getToken();for(;V!==17;){if(F.indexOf(V)!==-1){H();break}else if(N.indexOf(V)!==-1)break;V=H()}}}function Y(W){const F=i.getTokenValue();return W?_(F):k(F),H(),!0}function $(){switch(i.getToken()){case 11:let W=0;try{W=JSON.parse(i.getTokenValue()),typeof W!="number"&&(q(2),W=0)}catch(F){q(2)}_(W);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return H(),!0}function K(){return i.getToken()!==10?(q(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(Q(":"),H(),L()||q(4,[],[2,5])):q(5,[],[2,5]),!0)}function ee(){w(),H();let W=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===2&&O)break}else W&&q(6,[],[]);K()||q(4,[],[2,5]),W=!0}return A(),i.getToken()!==2?q(7,[2],[]):H(),!0}function B(){R(),H();let W=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(W||q(4,[],[]),Q(","),H(),i.getToken()===4&&O)break}else W&&q(6,[],[]);L()||q(4,[],[4,5]),W=!0}return T(),i.getToken()!==4?q(8,[4],[]):H(),!0}function L(){switch(i.getToken()){case 3:return B();case 1:return ee();case 10:return Y(!0);default:return $()}}return H(),i.getToken()===17?r.allowEmptyContent?!0:(q(4,[],[]),!1):L()?(i.getToken()!==17&&q(9,[],[]),!0):(q(4,[],[]),!1)}e.visit=c;function a(s,l){let r=n(s),i=[],o,h=0,w;do switch(w=r.getPosition(),o=r.scan(),o){case 12:case 13:case 17:h!==w&&i.push(s.substring(h,w)),l!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,l)),h=r.getPosition();break}while(o!==17);return i.join("")}e.stripComments=a;function u(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(Z[104],x([0,1,38]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function D(f,S,b){let m,y,t,g,E;if(S){for(g=S.offset,E=g+S.length,t=g;t>0&&!d(f,t-1);)t--;let w=E;for(;w<f.length&&!d(f,w);)w++;y=f.substring(t,w),m=n(y,b)}else y=f,m=0,t=0,g=0,E=f.length;const v=I(b,f);let P=!1,c=0,a;b.insertSpaces?a=M(" ",b.tabSize||4):a="	";const u=(0,p.createScanner)(y,!1);let s=!1;function l(){return v+M(a,m+c)}function r(){let w=u.scan();for(P=!1;w===15||w===14;)P=P||w===14,w=u.scan();return s=w===16||u.getTokenError()!==0,w}const i=[];function o(w,k,A){!s&&k<E&&A>g&&f.substring(k,A)!==w&&i.push({offset:k,length:A-k,content:w})}let h=r();if(h!==17){const w=u.getTokenOffset()+t,k=M(a,m);o(k,t,w)}for(;h!==17;){let w=u.getTokenOffset()+u.getTokenLength()+t,k=r(),A="";for(;!P&&(k===12||k===13);){const T=u.getTokenOffset()+t;o(" ",w,T),w=u.getTokenOffset()+u.getTokenLength()+t,A=k===12?l():"",k=r()}if(k===2)h!==1&&(c--,A=l());else if(k===4)h!==3&&(c--,A=l());else{switch(h){case 3:case 1:c++,A=l();break;case 5:case 12:A=l();break;case 13:P?A=l():A=" ";break;case 6:A=" ";break;case 10:if(k===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?A=" ":k!==5&&k!==17&&(s=!0);break;case 16:s=!0;break}P&&(k===12||k===13)&&(A=l())}const R=u.getTokenOffset()+t;o(A,w,R),h=k}return i}e.format=D;function C(f,S){const b=JSON.stringify(f,void 0,S.insertSpaces?S.tabSize||4:"	");return S.eol!==void 0?b.replace(/\r\n|\r|\n/g,S.eol):b}e.toFormattedString=C;function M(f,S){let b="";for(let m=0;m<S;m++)b+=f;return b}function n(f,S){let b=0,m=0;const y=S.tabSize||4;for(;b<f.length;){const t=f.charAt(b);if(t===" ")m++;else if(t==="	")m+=y;else break;b++}return Math.floor(m/y)}function I(f,S){for(let b=0;b<S.length;b++){const m=S.charAt(b);if(m==="\r")return b+1<S.length&&S.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return f&&f.eol||`
`}e.getEOL=I;function d(f,S){return`\r
`.indexOf(f.charAt(S))!==-1}e.isEOL=d}),define(Z[78],x([0,1,38,104]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(f,S,b){return M(f,S,void 0,b)}e.removeProperty=C;function M(f,S,b,m,y){const t=S.slice(),g=[],E=(0,p.parseTree)(f,g);let v,P;for(;t.length>0&&(P=t.pop(),v=(0,p.findNodeAtLocation)(E,t),v===void 0&&b!==void 0);)typeof P=="string"?b={[P]:b}:b=[b];if(v)if(v.type==="object"&&typeof P=="string"&&Array.isArray(v.children)){const c=(0,p.findNodeAtLocation)(v,[P]);if(c!==void 0)if(b===void 0){if(!c.parent)throw new Error("Malformed AST");const a=v.children.indexOf(c.parent);let u,s=c.parent.offset+c.parent.length;if(a>0){const l=v.children[a-1];u=l.offset+l.length}else u=v.offset+1,v.children.length>1&&(s=v.children[1].offset);return n(f,{offset:u,length:s-u,content:""},m)}else return n(f,{offset:c.offset,length:c.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const a=`${JSON.stringify(P)}: ${JSON.stringify(b)}`,u=y?y(v.children.map(l=>l.children[0].value)):v.children.length;let s;if(u>0){const l=v.children[u-1];s={offset:l.offset+l.length,length:0,content:","+a}}else v.children.length===0?s={offset:v.offset+1,length:0,content:a}:s={offset:v.offset+1,length:0,content:a+","};return n(f,s,m)}}else if(v.type==="array"&&typeof P=="number"&&Array.isArray(v.children))if(b!==void 0){const c=`${JSON.stringify(b)}`;let a;if(v.children.length===0||P===0)a={offset:v.offset+1,length:0,content:v.children.length===0?c:c+","};else{const u=P===-1||P>v.children.length?v.children.length:P,s=v.children[u-1];a={offset:s.offset+s.length,length:0,content:","+c}}return n(f,a,m)}else{const c=P,a=v.children[c];let u;if(v.children.length===1)u={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===c){const s=v.children[c-1],l=s.offset+s.length,r=v.offset+v.length;u={offset:l,length:r-2-l,content:""}}else u={offset:a.offset,length:v.children[c+1].offset-a.offset,content:""};return n(f,u,m)}else throw new Error(`Can not add ${typeof P!="number"?"index":"property"} to parent of type ${v.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return n(f,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(b)},m)}}e.setProperty=M;function n(f,S,b){let m=I(f,S),y=S.offset,t=S.offset+S.content.length;if(S.length===0||S.content.length===0){for(;y>0&&!(0,D.isEOL)(m,y-1);)y--;for(;t<m.length&&!(0,D.isEOL)(m,t);)t++}const g=(0,D.format)(m,{offset:y,length:t-y},b);for(let v=g.length-1;v>=0;v--){const P=g[v];m=I(m,P),y=Math.min(y,P.offset),t=Math.max(t,P.offset+P.length),t+=P.content.length-P.length}const E=f.length-(m.length-t)-y;return[{offset:y,length:E,content:m.substring(y,t)}]}e.withFormatting=n;function I(f,S){return f.substring(0,S.offset)+S.content+f.substring(S.offset+S.length)}e.applyEdit=I;function d(f,S){let b=S.slice(0).sort((y,t)=>{const g=y.offset-t.offset;return g===0?y.length-t.length:g}),m=f.length;for(let y=b.length-1;y>=0;y--){let t=b[y];if(t.offset+t.length<=m)f=I(f,t);else throw new Error("Overlapping edit");m=t.offset}return f}e.applyEdits=d}),define(Z[79],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var D;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(D=e.ScanCode||(e.ScanCode={}));class C{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(g,E){this._keyCodeToStr[g]=E,this._strToKeyCode[E.toLowerCase()]=g}keyCodeToStr(g){return this._keyCodeToStr[g]}strToKeyCode(g){return this._strToKeyCode[g.toLowerCase()]||0}}const M=new C,n=new C,I=new C;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],f=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>S[t]||0,toEnum:t=>f[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",g=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let E=[],v=[];for(const P of g){const[c,a,u,s,l,r,i,o,h,w]=P;if(v[u]||(v[u]=!0,d[u]=s,f[s]=u,S[s.toLowerCase()]=u,a&&(e.IMMUTABLE_CODE_TO_KEY_CODE[u]=l,l!==0&&l!==3&&l!==5&&l!==4&&l!==6&&l!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[l]=u))),!E[l]){if(E[l]=!0,!r)throw new Error(`String representation missing for key code ${l} around scan code ${s}`);M.define(l,r),n.define(l,h||r),I.define(l,w||h||r)}i&&(e.EVENT_KEY_CODE_MAP[i]=l),o&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[o]=l)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var b;(function(t){function g(u){return M.keyCodeToStr(u)}t.toString=g;function E(u){return M.strToKeyCode(u)}t.fromString=E;function v(u){return n.keyCodeToStr(u)}t.toUserSettingsUS=v;function P(u){return I.keyCodeToStr(u)}t.toUserSettingsGeneral=P;function c(u){return n.strToKeyCode(u)||I.strToKeyCode(u)}t.fromUserSettings=c;function a(u){if(u>=93&&u<=108)return null;switch(u){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(u)}t.toElectronAccelerator=a})(b=e.KeyCodeUtils||(e.KeyCodeUtils={}));var m;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(m=e.KeyMod||(e.KeyMod={}));function y(t,g){const E=(g&65535)<<16>>>0;return(t|E)>>>0}e.KeyChord=y}),define(Z[58],x([0,1,16]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var D;(function(b){b[b.CtrlCmd=2048]="CtrlCmd",b[b.Shift=1024]="Shift",b[b.Alt=512]="Alt",b[b.WinCtrl=256]="WinCtrl",b[b.KeyCode=255]="KeyCode"})(D||(D={}));function C(b,m){if(b===0)return null;const y=(b&65535)>>>0,t=(b&4294901760)>>>16;return t!==0?new I([M(y,m),M(t,m)]):new I([M(y,m)])}e.createKeybinding=C;function M(b,m){const y=!!(b&2048),t=!!(b&256),g=m===2?t:y,E=!!(b&1024),v=!!(b&512),P=m===2?y:t,c=b&255;return new n(g,E,v,P,c)}e.createSimpleKeybinding=M;class n{constructor(m,y,t,g,E){this.ctrlKey=m,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.keyCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.keyCode===m.keyCode}getHashCode(){const m=this.ctrlKey?"1":"0",y=this.shiftKey?"1":"0",t=this.altKey?"1":"0",g=this.metaKey?"1":"0";return`${m}${y}${t}${g}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new I([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=n;class I{constructor(m){if(m.length===0)throw(0,p.illegalArgument)("parts");this.parts=m}getHashCode(){let m="";for(let y=0,t=this.parts.length;y<t;y++)y!==0&&(m+=";"),m+=this.parts[y].getHashCode();return m}equals(m){if(m===null||this.parts.length!==m.parts.length)return!1;for(let y=0;y<this.parts.length;y++)if(!this.parts[y].equals(m.parts[y]))return!1;return!0}}e.ChordKeybinding=I;class d{constructor(m,y,t,g,E){this.ctrlKey=m,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.scanCode=E}equals(m){return this.ctrlKey===m.ctrlKey&&this.shiftKey===m.shiftKey&&this.altKey===m.altKey&&this.metaKey===m.metaKey&&this.scanCode===m.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class f{constructor(m,y,t,g,E,v){this.ctrlKey=m,this.shiftKey=y,this.altKey=t,this.metaKey=g,this.keyLabel=E,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=f;class S{}e.ResolvedKeybinding=S}),define(Z[105],x([0,1,79,58]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class C{static _readModifiers(n){n=n.toLowerCase().trim();let I=!1,d=!1,f=!1,S=!1,b;do b=!1,/^ctrl(\+|\-)/.test(n)&&(I=!0,n=n.substr("ctrl-".length),b=!0),/^shift(\+|\-)/.test(n)&&(d=!0,n=n.substr("shift-".length),b=!0),/^alt(\+|\-)/.test(n)&&(f=!0,n=n.substr("alt-".length),b=!0),/^meta(\+|\-)/.test(n)&&(S=!0,n=n.substr("meta-".length),b=!0),/^win(\+|\-)/.test(n)&&(S=!0,n=n.substr("win-".length),b=!0),/^cmd(\+|\-)/.test(n)&&(S=!0,n=n.substr("cmd-".length),b=!0);while(b);let m;const y=n.indexOf(" ");return y>0?(m=n.substring(0,y),n=n.substring(y)):(m=n,n=""),{remains:n,ctrl:I,shift:d,alt:f,meta:S,key:m}}static parseSimpleKeybinding(n){const I=this._readModifiers(n),d=p.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,d),I.remains]}static parseKeybinding(n,I){if(!n)return null;const d=[];let f;do[f,n]=this.parseSimpleKeybinding(n),d.push(f);while(n.length>0);return new D.ChordKeybinding(d)}static parseSimpleUserBinding(n){const I=this._readModifiers(n),d=I.key.match(/^\[([^\]]+)\]$/);if(d){const S=d[1],b=p.ScanCodeUtils.lowerCaseToEnum(S);return[new D.ScanCodeBinding(I.ctrl,I.shift,I.alt,I.meta,b),I.remains]}const f=p.KeyCodeUtils.fromUserSettings(I.key);return[new D.SimpleKeybinding(I.ctrl,I.shift,I.alt,I.meta,f),I.remains]}static parseUserBinding(n){if(!n)return[];const I=[];let d;for(;n.length>0;)[d,n]=this.parseSimpleUserBinding(n),I.push(d);return I}}e.KeybindingParser=C}),define(Z[2],x([0,1,42,69]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const C=!1;let M=null;function n(i){M=i}if(e.setDisposableTracker=n,C){const i="__is_disposable_tracked__";n(new class{trackDisposable(o){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{o[i]||console.log(h)},3e3)}setParent(o,h){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsDisposed(o){if(o&&o!==P.None)try{o[i]=!0}catch{}}markAsSingleton(o){}})}function I(i){return M?.trackDisposable(i),i}function d(i){M?.markAsDisposed(i)}function f(i,o){M?.setParent(i,o)}function S(i,o){if(!!M)for(const h of i)M.setParent(h,o)}function b(i){return M?.markAsSingleton(i),i}e.markAsSingleton=b;class m extends Error{constructor(o){super(`Encountered errors while disposing of store. Errors: [${o.join(", ")}]`);this.errors=o}}e.MultiDisposeError=m;function y(i){return typeof i.dispose=="function"&&i.dispose.length===0}e.isDisposable=y;function t(i){if(D.Iterable.is(i)){let o=[];for(const h of i)if(h)try{h.dispose()}catch(w){o.push(w)}if(o.length===1)throw o[0];if(o.length>1)throw new m(o);return Array.isArray(i)?[]:i}else if(i)return i.dispose(),i}e.dispose=t;function g(...i){const o=E(()=>t(i));return S(i,o),o}e.combinedDisposable=g;function E(i){const o=I({dispose:(0,p.once)(()=>{d(o),i()})});return o}e.toDisposable=E;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,I(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(o){if(!o)return o;if(o===this)throw new Error("Cannot register a disposable on itself!");return f(o,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(o),o}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class P{constructor(){this._store=new v,I(this),f(this._store,this)}dispose(){d(this),this._store.dispose()}_register(o){if(o===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(o)}}e.Disposable=P,P.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,I(this)}get value(){return this._isDisposed?void 0:this._value}set value(o){this._isDisposed||o===this._value||(this._value?.dispose(),o&&f(o,this),this._value=o)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const o=this._value;return this._value=void 0,o&&f(o,null),o}}e.MutableDisposable=c;class a{constructor(o){this._disposable=o,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=a;class u{constructor(){this.references=new Map}acquire(o,...h){let w=this.references.get(o);w||(w={counter:0,object:this.createReferencedObject(o,...h)},this.references.set(o,w));const{object:k}=w,A=(0,p.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(o,w.object),this.references.delete(o))});return w.counter++,{object:k,dispose:A}}}e.ReferenceCollection=u;class s{constructor(o){this.referenceCollection=o}async acquire(o,...h){const w=this.referenceCollection.acquire(o,...h);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(k){throw w.dispose(),k}}}e.AsyncReferenceCollection=s;class l{constructor(o){this.object=o}dispose(){}}e.ImmortalReference=l;function r(i){const o=new v;try{i(o)}finally{o.dispose()}}e.disposeOnReturn=r}),define(Z[106],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class D{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const n=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=n}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,n){const I=new p(M);if(this._first===p.Undefined)this._first=I,this._last=I;else if(n){const f=this._last;this._last=I,I.prev=f,f.next=I}else{const f=this._first;this._first=I,I.next=f,f.prev=I}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(I))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const n=M.prev;n.next=M.next,M.next.prev=n}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=D}),function(){function j(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function n(d){M.push(d,Date.now())}function I(){const d=[];for(let f=0;f<M.length;f+=2)d.push({name:M[f],startTime:M[f+1]});return d}return{mark:n,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const n of performance.getEntriesByType("mark"))M.push({name:n.name,startTime:Math.round(C+n.startTime)});return M}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=p(D))}(),define(Z[3],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let D=!1,C=!1,M=!1,n=!1,I=!1,d=!1,f=!1,S=!1,b,m=p,y,t;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let g;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?g=e.globals.vscode.process:typeof process!="undefined"&&(g=process);const E=typeof g?.versions?.electron=="string",v=E&&g?.type==="renderer";if(e.isElectronSandboxed=v&&g?.sandboxed,typeof navigator=="object"&&!v)t=navigator.userAgent,D=t.indexOf("Windows")>=0,C=t.indexOf("Macintosh")>=0,S=(t.indexOf("Macintosh")>=0||t.indexOf("iPad")>=0||t.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=t.indexOf("Linux")>=0,d=!0,b=navigator.language,m=b;else if(typeof g=="object"){D=g.platform==="win32",C=g.platform==="darwin",M=g.platform==="linux",n=M&&!!g.env.SNAP&&!!g.env.SNAP_REVISION,f=E,b=p,m=p;const o=g.env.VSCODE_NLS_CONFIG;if(o)try{const h=JSON.parse(o),w=h.availableLanguages["*"];b=h.locale,m=w||p,y=h._translationsConfigFile}catch(h){}I=!0}else console.error("Unable to resolve platform.");var P;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(P=e.Platform||(e.Platform={}));function c(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=c;let a=0;C?a=1:D?a=3:M&&(a=2),e.isWindows=D,e.isMacintosh=C,e.isLinux=M,e.isLinuxSnap=n,e.isNative=I,e.isElectron=f,e.isWeb=d,e.isIOS=S,e.platform=a,e.userAgent=t,e.language=m;var u;(function(o){function h(){return e.language}o.value=h;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=w;function k(){return e.language==="en"}o.isDefault=k})(u=e.Language||(e.Language={})),e.locale=b,e.translationsConfigFile=y,e.setTimeout0=(()=>{if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let o=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeScheduleAsyncWork)for(let k=0,A=o.length;k<A;k++){const R=o[k];if(R.id===w.data.vscodeScheduleAsyncWork){o.splice(k,1),R.callback();return}}});let h=0;return w=>{const k=++h;o.push({id:k,callback:w}),e.globals.postMessage({vscodeScheduleAsyncWork:k},"*")}}return o=>setTimeout(o)})();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=C||S?2:D?1:3;let l=!0,r=!1;function i(){if(!r){r=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,l=new Uint16Array(o.buffer)[0]===(2<<8)+1}return l}e.isLittleEndian=i}),define(Z[34],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let D;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;D={get platform(){return C.platform},get arch(){return C.arch},get env(){return C.env},cwd(){return C.cwd()}}}else typeof process!="undefined"?D={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:D={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=D.cwd,e.env=D.env,e.platform=D.platform,e.arch=D.arch}),define(Z[8],x([0,1,34]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const D=65,C=97,M=90,n=122,I=46,d=47,f=92,S=58,b=63;class m extends Error{constructor(a,u,s){let l;typeof u=="string"&&u.indexOf("not ")===0?(l="must not be",u=u.replace(/^not /,"")):l="must be";const r=a.indexOf(".")!==-1?"property":"argument";let i=`The "${a}" ${r} ${l} of type ${u}`;i+=`. Received type ${typeof s}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function y(c,a){if(typeof c!="string")throw new m(a,"string",c)}function t(c){return c===d||c===f}function g(c){return c===d}function E(c){return c>=D&&c<=M||c>=C&&c<=n}function v(c,a,u,s){let l="",r=0,i=-1,o=0,h=0;for(let w=0;w<=c.length;++w){if(w<c.length)h=c.charCodeAt(w);else{if(s(h))break;h=d}if(s(h)){if(!(i===w-1||o===1))if(o===2){if(l.length<2||r!==2||l.charCodeAt(l.length-1)!==I||l.charCodeAt(l.length-2)!==I){if(l.length>2){const k=l.lastIndexOf(u);k===-1?(l="",r=0):(l=l.slice(0,k),r=l.length-1-l.lastIndexOf(u)),i=w,o=0;continue}else if(l.length!==0){l="",r=0,i=w,o=0;continue}}a&&(l+=l.length>0?`${u}..`:"..",r=2)}else l.length>0?l+=`${u}${c.slice(i+1,w)}`:l=c.slice(i+1,w),r=w-i-1;i=w,o=0}else h===I&&o!==-1?++o:o=-1}return l}function P(c,a){if(a===null||typeof a!="object")throw new m("pathObject","Object",a);const u=a.dir||a.root,s=a.base||`${a.name||""}${a.ext||""}`;return u?u===a.root?`${u}${s}`:`${u}${c}${s}`:s}e.win32={resolve(...c){let a="",u="",s=!1;for(let l=c.length-1;l>=-1;l--){let r;if(l>=0){if(r=c[l],y(r,"path"),r.length===0)continue}else a.length===0?r=p.cwd():(r=p.env[`=${a}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===f)&&(r=`${a}\\`));const i=r.length;let o=0,h="",w=!1;const k=r.charCodeAt(0);if(i===1)t(k)&&(o=1,w=!0);else if(t(k))if(w=!0,t(r.charCodeAt(1))){let A=2,R=A;for(;A<i&&!t(r.charCodeAt(A));)A++;if(A<i&&A!==R){const T=r.slice(R,A);for(R=A;A<i&&t(r.charCodeAt(A));)A++;if(A<i&&A!==R){for(R=A;A<i&&!t(r.charCodeAt(A));)A++;(A===i||A!==R)&&(h=`\\\\${T}\\${r.slice(R,A)}`,o=A)}}}else o=1;else E(k)&&r.charCodeAt(1)===S&&(h=r.slice(0,2),o=2,i>2&&t(r.charCodeAt(2))&&(w=!0,o=3));if(h.length>0)if(a.length>0){if(h.toLowerCase()!==a.toLowerCase())continue}else a=h;if(s){if(a.length>0)break}else if(u=`${r.slice(o)}\\${u}`,s=w,w&&a.length>0)break}return u=v(u,!s,"\\",t),s?`${a}\\${u}`:`${a}${u}`||"."},normalize(c){y(c,"path");const a=c.length;if(a===0)return".";let u=0,s,l=!1;const r=c.charCodeAt(0);if(a===1)return g(r)?"\\":c;if(t(r))if(l=!0,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){const w=c.slice(h,o);for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return`\\\\${w}\\${c.slice(h)}\\`;o!==h&&(s=`\\\\${w}\\${c.slice(h,o)}`,u=o)}}}else u=1;else E(r)&&c.charCodeAt(1)===S&&(s=c.slice(0,2),u=2,a>2&&t(c.charCodeAt(2))&&(l=!0,u=3));let i=u<a?v(c.slice(u),!l,"\\",t):"";return i.length===0&&!l&&(i="."),i.length>0&&t(c.charCodeAt(a-1))&&(i+="\\"),s===void 0?l?`\\${i}`:i:l?`${s}\\${i}`:`${s}${i}`},isAbsolute(c){y(c,"path");const a=c.length;if(a===0)return!1;const u=c.charCodeAt(0);return t(u)||a>2&&E(u)&&c.charCodeAt(1)===S&&t(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let a,u;for(let r=0;r<c.length;++r){const i=c[r];y(i,"path"),i.length>0&&(a===void 0?a=u=i:a+=`\\${i}`)}if(a===void 0)return".";let s=!0,l=0;if(typeof u=="string"&&t(u.charCodeAt(0))){++l;const r=u.length;r>1&&t(u.charCodeAt(1))&&(++l,r>2&&(t(u.charCodeAt(2))?++l:s=!1))}if(s){for(;l<a.length&&t(a.charCodeAt(l));)l++;l>=2&&(a=`\\${a.slice(l)}`)}return e.win32.normalize(a)},relative(c,a){if(y(c,"from"),y(a,"to"),c===a)return"";const u=e.win32.resolve(c),s=e.win32.resolve(a);if(u===s||(c=u.toLowerCase(),a=s.toLowerCase(),c===a))return"";let l=0;for(;l<c.length&&c.charCodeAt(l)===f;)l++;let r=c.length;for(;r-1>l&&c.charCodeAt(r-1)===f;)r--;const i=r-l;let o=0;for(;o<a.length&&a.charCodeAt(o)===f;)o++;let h=a.length;for(;h-1>o&&a.charCodeAt(h-1)===f;)h--;const w=h-o,k=i<w?i:w;let A=-1,R=0;for(;R<k;R++){const _=c.charCodeAt(l+R);if(_!==a.charCodeAt(o+R))break;_===f&&(A=R)}if(R!==k){if(A===-1)return s}else{if(w>k){if(a.charCodeAt(o+R)===f)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}i>k&&(c.charCodeAt(l+R)===f?A=R:R===2&&(A=3)),A===-1&&(A=0)}let T="";for(R=l+A+1;R<=r;++R)(R===r||c.charCodeAt(R)===f)&&(T+=T.length===0?"..":"\\..");return o+=A,T.length>0?`${T}${s.slice(o,h)}`:(s.charCodeAt(o)===f&&++o,s.slice(o,h))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const a=e.win32.resolve(c);if(a.length<=2)return c;if(a.charCodeAt(0)===f){if(a.charCodeAt(1)===f){const u=a.charCodeAt(2);if(u!==b&&u!==I)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(E(a.charCodeAt(0))&&a.charCodeAt(1)===S&&a.charCodeAt(2)===f)return`\\\\?\\${a}`;return c},dirname(c){y(c,"path");const a=c.length;if(a===0)return".";let u=-1,s=0;const l=c.charCodeAt(0);if(a===1)return t(l)?c:".";if(t(l)){if(u=s=1,t(c.charCodeAt(1))){let o=2,h=o;for(;o<a&&!t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&t(c.charCodeAt(o));)o++;if(o<a&&o!==h){for(h=o;o<a&&!t(c.charCodeAt(o));)o++;if(o===a)return c;o!==h&&(u=s=o+1)}}}}else E(l)&&c.charCodeAt(1)===S&&(u=a>2&&t(c.charCodeAt(2))?3:2,s=u);let r=-1,i=!0;for(let o=a-1;o>=s;--o)if(t(c.charCodeAt(o))){if(!i){r=o;break}}else i=!1;if(r===-1){if(u===-1)return".";r=u}return c.slice(0,r)},basename(c,a){a!==void 0&&y(a,"ext"),y(c,"path");let u=0,s=-1,l=!0,r;if(c.length>=2&&E(c.charCodeAt(0))&&c.charCodeAt(1)===S&&(u=2),a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=u;--r){const h=c.charCodeAt(r);if(t(h)){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(r=c.length-1;r>=u;--r)if(t(c.charCodeAt(r))){if(!l){u=r+1;break}}else s===-1&&(l=!1,s=r+1);return s===-1?"":c.slice(u,s)},extname(c){y(c,"path");let a=0,u=-1,s=0,l=-1,r=!0,i=0;c.length>=2&&c.charCodeAt(1)===S&&E(c.charCodeAt(0))&&(a=s=2);for(let o=c.length-1;o>=a;--o){const h=c.charCodeAt(o);if(t(h)){if(!r){s=o+1;break}continue}l===-1&&(r=!1,l=o+1),h===I?u===-1?u=o:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||l===-1||i===0||i===1&&u===l-1&&u===s+1?"":c.slice(u,l)},format:P.bind(null,"\\"),parse(c){y(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.length;let s=0,l=c.charCodeAt(0);if(u===1)return t(l)?(a.root=a.dir=c,a):(a.base=a.name=c,a);if(t(l)){if(s=1,t(c.charCodeAt(1))){let A=2,R=A;for(;A<u&&!t(c.charCodeAt(A));)A++;if(A<u&&A!==R){for(R=A;A<u&&t(c.charCodeAt(A));)A++;if(A<u&&A!==R){for(R=A;A<u&&!t(c.charCodeAt(A));)A++;A===u?s=A:A!==R&&(s=A+1)}}}}else if(E(l)&&c.charCodeAt(1)===S){if(u<=2)return a.root=a.dir=c,a;if(s=2,t(c.charCodeAt(2))){if(u===3)return a.root=a.dir=c,a;s=3}}s>0&&(a.root=c.slice(0,s));let r=-1,i=s,o=-1,h=!0,w=c.length-1,k=0;for(;w>=s;--w){if(l=c.charCodeAt(w),t(l)){if(!h){i=w+1;break}continue}o===-1&&(h=!1,o=w+1),l===I?r===-1?r=w:k!==1&&(k=1):r!==-1&&(k=-1)}return o!==-1&&(r===-1||k===0||k===1&&r===o-1&&r===i+1?a.base=a.name=c.slice(i,o):(a.name=c.slice(i,r),a.base=c.slice(i,o),a.ext=c.slice(r,o))),i>0&&i!==s?a.dir=c.slice(0,i-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let a="",u=!1;for(let s=c.length-1;s>=-1&&!u;s--){const l=s>=0?c[s]:p.cwd();y(l,"path"),l.length!==0&&(a=`${l}/${a}`,u=l.charCodeAt(0)===d)}return a=v(a,!u,"/",g),u?`/${a}`:a.length>0?a:"."},normalize(c){if(y(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d,u=c.charCodeAt(c.length-1)===d;return c=v(c,!a,"/",g),c.length===0?a?"/":u?"./":".":(u&&(c+="/"),a?`/${c}`:c)},isAbsolute(c){return y(c,"path"),c.length>0&&c.charCodeAt(0)===d},join(...c){if(c.length===0)return".";let a;for(let u=0;u<c.length;++u){const s=c[u];y(s,"path"),s.length>0&&(a===void 0?a=s:a+=`/${s}`)}return a===void 0?".":e.posix.normalize(a)},relative(c,a){if(y(c,"from"),y(a,"to"),c===a||(c=e.posix.resolve(c),a=e.posix.resolve(a),c===a))return"";const u=1,s=c.length,l=s-u,r=1,i=a.length-r,o=l<i?l:i;let h=-1,w=0;for(;w<o;w++){const A=c.charCodeAt(u+w);if(A!==a.charCodeAt(r+w))break;A===d&&(h=w)}if(w===o)if(i>o){if(a.charCodeAt(r+w)===d)return a.slice(r+w+1);if(w===0)return a.slice(r+w)}else l>o&&(c.charCodeAt(u+w)===d?h=w:w===0&&(h=0));let k="";for(w=u+h+1;w<=s;++w)(w===s||c.charCodeAt(w)===d)&&(k+=k.length===0?"..":"/..");return`${k}${a.slice(r+h)}`},toNamespacedPath(c){return c},dirname(c){if(y(c,"path"),c.length===0)return".";const a=c.charCodeAt(0)===d;let u=-1,s=!0;for(let l=c.length-1;l>=1;--l)if(c.charCodeAt(l)===d){if(!s){u=l;break}}else s=!1;return u===-1?a?"/":".":a&&u===1?"//":c.slice(0,u)},basename(c,a){a!==void 0&&y(a,"ext"),y(c,"path");let u=0,s=-1,l=!0,r;if(a!==void 0&&a.length>0&&a.length<=c.length){if(a===c)return"";let i=a.length-1,o=-1;for(r=c.length-1;r>=0;--r){const h=c.charCodeAt(r);if(h===d){if(!l){u=r+1;break}}else o===-1&&(l=!1,o=r+1),i>=0&&(h===a.charCodeAt(i)?--i==-1&&(s=r):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(r=c.length-1;r>=0;--r)if(c.charCodeAt(r)===d){if(!l){u=r+1;break}}else s===-1&&(l=!1,s=r+1);return s===-1?"":c.slice(u,s)},extname(c){y(c,"path");let a=-1,u=0,s=-1,l=!0,r=0;for(let i=c.length-1;i>=0;--i){const o=c.charCodeAt(i);if(o===d){if(!l){u=i+1;break}continue}s===-1&&(l=!1,s=i+1),o===I?a===-1?a=i:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||s===-1||r===0||r===1&&a===s-1&&a===u+1?"":c.slice(a,s)},format:P.bind(null,"/"),parse(c){y(c,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return a;const u=c.charCodeAt(0)===d;let s;u?(a.root="/",s=1):s=0;let l=-1,r=0,i=-1,o=!0,h=c.length-1,w=0;for(;h>=s;--h){const k=c.charCodeAt(h);if(k===d){if(!o){r=h+1;break}continue}i===-1&&(o=!1,i=h+1),k===I?l===-1?l=h:w!==1&&(w=1):l!==-1&&(w=-1)}if(i!==-1){const k=r===0&&u?1:r;l===-1||w===0||w===1&&l===i-1&&l===r+1?a.base=a.name=c.slice(k,i):(a.name=c.slice(k,l),a.base=c.slice(k,i),a.ext=c.slice(l,i))}return r>0?a.dir=c.slice(0,r-1):u&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Z[80],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var D;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(M,...n){const I=n.reduce((S,b)=>(S[b]=!0,S),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(S=>!I[S]).forEach(S=>{for(let b=0;b<d.length;b++)if(S.search(d[b])!==-1){delete M[S];break}})}e.sanitizeProcessEnvironment=C}),define(Z[107],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const D=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(n){this._highResolution=D&&n,this._startTime=this._now(),this._stopTime=-1}static create(n=!0){return new C(n)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(Z[4],x([0,1,16,42,2,106,107]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var I;(function(a){a.None=()=>C.Disposable.None;function u(H){return(q,Y=null,$)=>{let K=!1,ee;return ee=H(B=>{if(!K)return ee?ee.dispose():K=!0,q.call(Y,B)},null,$),K&&ee.dispose(),ee}}a.once=u;function s(H,q){return w((Y,$=null,K)=>H(ee=>Y.call($,q(ee)),null,K))}a.map=s;function l(H,q){return w((Y,$=null,K)=>H(ee=>{q(ee),Y.call($,ee)},null,K))}a.forEach=l;function r(H,q){return w((Y,$=null,K)=>H(ee=>q(ee)&&Y.call($,ee),null,K))}a.filter=r;function i(H){return H}a.signal=i;function o(...H){return(q,Y=null,$)=>(0,C.combinedDisposable)(...H.map(K=>K(ee=>q.call(Y,ee),null,$)))}a.any=o;function h(H,q,Y){let $=Y;return s(H,K=>($=q($,K),$))}a.reduce=h;function w(H){let q;const Y=new m({onFirstListenerAdd(){q=H(Y.fire,Y)},onLastListenerRemove(){q.dispose()}});return Y.event}function k(H,q,Y=100,$=!1,K){let ee,B,L,W=0;const F=new m({leakWarningThreshold:K,onFirstListenerAdd(){ee=H(N=>{W++,B=q(B,N),$&&!L&&(F.fire(B),B=void 0),clearTimeout(L),L=setTimeout(()=>{const V=B;B=void 0,L=void 0,(!$||W>1)&&F.fire(V),W=0},Y)})},onLastListenerRemove(){ee.dispose()}});return F.event}a.debounce=k;function A(H,q=(Y,$)=>Y===$){let Y=!0,$;return r(H,K=>{const ee=Y||!q(K,$);return Y=!1,$=K,ee})}a.latch=A;function R(H,q){return[a.filter(H,q),a.filter(H,Y=>!q(Y))]}a.split=R;function T(H,q=!1,Y=[]){let $=Y.slice(),K=H(L=>{$?$.push(L):B.fire(L)});const ee=()=>{$&&$.forEach(L=>B.fire(L)),$=null},B=new m({onFirstListenerAdd(){K||(K=H(L=>B.fire(L)))},onFirstListenerDidAdd(){$&&(q?setTimeout(ee):ee())},onLastListenerRemove(){K&&K.dispose(),K=null}});return B.event}a.buffer=T;class _{constructor(q){this.event=q}map(q){return new _(s(this.event,q))}forEach(q){return new _(l(this.event,q))}filter(q){return new _(r(this.event,q))}reduce(q,Y){return new _(h(this.event,q,Y))}latch(){return new _(A(this.event))}debounce(q,Y=100,$=!1,K){return new _(k(this.event,q,Y,$,K))}on(q,Y,$){return this.event(q,Y,$)}once(q,Y,$){return u(this.event)(q,Y,$)}}function Q(H){return new _(H)}a.chain=Q;function ne(H,q,Y=$=>$){const $=(...L)=>B.fire(Y(...L)),K=()=>H.on(q,$),ee=()=>H.removeListener(q,$),B=new m({onFirstListenerAdd:K,onLastListenerRemove:ee});return B.event}a.fromNodeEventEmitter=ne;function oe(H,q,Y=$=>$){const $=(...L)=>B.fire(Y(...L)),K=()=>H.addEventListener(q,$),ee=()=>H.removeEventListener(q,$),B=new m({onFirstListenerAdd:K,onLastListenerRemove:ee});return B.event}a.fromDOMEventEmitter=oe;function X(H){return new Promise(q=>u(H)(q))}a.toPromise=X;function O(H,q){return q(void 0),H(Y=>q(Y))}a.runAndSubscribe=O})(I=e.Event||(e.Event={}));class d{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${d._idPool++}`}start(u){this._stopWatch=new n.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let f=-1;function S(a){const u=f;return f=a,{dispose(){f=u}}}e.setGlobalLeakWarningThreshold=S;class b{constructor(u,s=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=s,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u){let s=f;if(typeof this.customThreshold=="number"&&(s=this.customThreshold),s<=0||u<s)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(l)||0;if(this._stacks.set(l,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=s*.5;let i,o=0;for(const[h,w]of this._stacks)(!i||o<w)&&(i=h,o=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(l)||0;this._stacks.set(l,i-1)}}}class m{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=f>0?new b(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(u,s,l)=>{this._listeners||(this._listeners=new M.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(s?[u,s]:u);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,s);const o=this._leakageMon?.check(this._listeners.size),h=(0,C.toDisposable)(()=>{o&&o(),this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return l instanceof C.DisposableStore?l.add(h):Array.isArray(l)&&l.push(h),h}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,u]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,l]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,l):s[0].call(s[1],l)}catch(r){(0,p.onUnexpectedError)(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=m;class y extends m{async fireAsync(u,s,l){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,u]);for(;this._asyncDeliveryQueue.size>0&&!s.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],h={...i,token:s,waitUntil:w=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");l&&(w=l(w,typeof r=="function"?r:r[0])),o.push(w)}};try{typeof r=="function"?r.call(void 0,h):r[0].call(r[1],h)}catch(w){(0,p.onUnexpectedError)(w);continue}Object.freeze(o),await Promise.allSettled(o).then(w=>{for(const k of w)k.status==="rejected"&&(0,p.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=y;class t extends m{constructor(u){super(u);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}e.PauseableEmitter=t;class g extends t{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}e.DebounceEmitter=g;class E extends m{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(s=>super.fire(s)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const s={event:u,listener:null};this.events.push(s),this.hasListeners&&this.hook(s);const l=()=>{this.hasListeners&&this.unhook(s);const r=this.events.indexOf(s);this.events.splice(r,1)};return(0,C.toDisposable)((0,D.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(s=>this.emitter.fire(s))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class P{constructor(){this.buffers=[]}wrapEvent(u){return(s,l,r)=>u(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>s.call(l,i)):s.call(l,i)},void 0,r)}bufferEvents(u){const s=[];this.buffers.push(s);const l=u();return this.buffers.pop(),s.forEach(r=>r()),l}}e.EventBufferer=P;class c{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=C.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=c}),define(Z[23],x([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const D=Object.freeze(function(I,d){const f=setTimeout(I.bind(d),0);return{dispose(){clearTimeout(f)}}});var C;(function(I){function d(f){return f===I.None||f===I.Cancelled||f instanceof M?!0:!f||typeof f!="object"?!1:typeof f.isCancellationRequested=="boolean"&&typeof f.onCancellationRequested=="function"}I.isCancellationToken=d,I.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),I.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:D})})(C=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?D:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class n{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=C.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=n}),define(Z[108],x([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.iconRegistry=void 0;class D{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(S){const b=this._icons.get(S.id);b?S.description?b.description=S.description:console.error(`Duplicate registration of codicon ${S.id}`):(this._icons.set(S.id,S),this._onDidRegister.fire(S))}get(S){return this._icons.get(S)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new D;e.iconRegistry=C;function M(f){return f?f.replace(/\$\((.*?)\)/g,(S,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=M;class n{constructor(S,b,m){this.id=S,this.definition=b,this.description=m,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=n,n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function I(f,S){const b=["codicon","codicon-"+f];return S&&b.push("codicon-modifier-"+S),b}e.getClassNamesArray=I;var d;(function(f){f.iconNameSegment="[A-Za-z0-9]+",f.iconNameExpression="[A-Za-z0-9-]+",f.iconModifierExpression="~[A-Za-z]+",f.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${f.iconNameExpression})(${f.iconModifierExpression})?$`);function b(t){if(t instanceof n)return["codicon","codicon-"+t.id];const g=S.exec(t.id);if(!g)return b(n.error);let[,E,v]=g;const P=["codicon","codicon-"+E];return v&&P.push("codicon-modifier-"+v.substr(1)),P}f.asClassNameArray=b;function m(t){return b(t).join(" ")}f.asClassName=m;function y(t){return"."+b(t).join(".")}f.asCSSSelector=y})(d=e.CSSIcon||(e.CSSIcon={}))}),define(Z[59],x([0,1,16,2]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(c){const a=c;return a?[a.on,a.pause,a.resume,a.destroy].every(u=>typeof u=="function"):!1}e.isReadableStream=C;function M(c){const a=c;return a?C(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=M;function n(c,a){return new I(c,a)}e.newWriteableStream=n;class I{constructor(a,u){this.reducer=a,this.options=u,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(u=>this.pendingWritePromises.push(u))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(u=>u(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(u=>u(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,u){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(u),this.resume();break;case"end":this.listeners.end.push(u),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(u),this.state.flowing&&this.flowErrors();break}}removeListener(a,u){if(this.state.destroyed)return;let s;switch(a){case"data":s=this.listeners.data;break;case"end":s=this.listeners.end;break;case"error":s=this.listeners.error;break}if(s){const l=s.indexOf(u);l>=0&&s.splice(l,1)}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const u=[...this.pendingWritePromises];this.pendingWritePromises.length=0,u.forEach(s=>s())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,a){const u=[];let s;for(;(s=c.read())!==null;)u.push(s);return a(u)}e.consumeReadable=d;function f(c,a,u){const s=[];let l;for(;(l=c.read())!==null&&s.length<u;)s.push(l);return l===null&&s.length>0?a(s):{read:()=>{if(s.length>0)return s.shift();if(typeof l!="undefined"){const r=l;return l=void 0,r}return c.read()}}}e.peekReadable=f;function S(c,a){return new Promise((u,s)=>{const l=[];b(c,{onData:r=>{a&&l.push(r)},onError:r=>{a?s(r):u(void 0)},onEnd:()=>{u(a?a(l):void 0)}})})}e.consumeStream=S;function b(c,a){c.on("error",u=>a.onError(u)),c.on("end",()=>a.onEnd()),c.on("data",u=>a.onData(u))}e.listenStream=b;function m(c,a){return new Promise((u,s)=>{const l=new D.DisposableStore,r=[],i=w=>{if(r.push(w),r.length>a)return l.dispose(),c.pause(),u({stream:c,buffer:r,ended:!1})},o=w=>s(w),h=()=>u({stream:c,buffer:r,ended:!0});l.add((0,D.toDisposable)(()=>c.removeListener("error",o))),c.on("error",o),l.add((0,D.toDisposable)(()=>c.removeListener("end",h))),c.on("end",h),l.add((0,D.toDisposable)(()=>c.removeListener("data",i))),c.on("data",i)})}e.peekStream=m;function y(c,a){const u=n(a);return u.end(c),u}e.toStream=y;function t(){const c=n(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=t;function g(c){let a=!1;return{read:()=>a?null:(a=!0,c)}}e.toReadable=g;function E(c,a,u){const s=n(u);return b(c,{onData:l=>s.write(a.data(l)),onError:l=>s.error(a.error?a.error(l):l),onEnd:()=>s.end()}),s}e.transform=E;function v(c,a,u){let s=!1;return{read:()=>{const l=a.read();return s?l:(s=!0,l!==null?u([c,l]):c)}}}e.prefixedReadable=v;function P(c,a,u){let s=!1;const l=n(u);return b(a,{onData:r=>s?l.write(r):(s=!0,l.write(u([c,r]))),onError:r=>l.error(r),onEnd:()=>{s||(s=!0,l.write(c)),l.end()}}),l}e.prefixedStream=P}),define(Z[17],x([0,1,59]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined";let C,M;class n{constructor(i){this.buffer=i,this.byteLength=this.buffer.byteLength}static alloc(i){return D?new n(Buffer.allocUnsafe(i)):new n(new Uint8Array(i))}static wrap(i){return D&&!Buffer.isBuffer(i)&&(i=Buffer.from(i.buffer,i.byteOffset,i.byteLength)),new n(i)}static fromString(i,o){return!(o?.dontUseNodeBuffer||!1)&&D?new n(Buffer.from(i)):(C||(C=new TextEncoder),new n(C.encode(i)))}static fromByteArray(i){const o=n.alloc(i.length);for(let h=0,w=i.length;h<w;h++)o.buffer[h]=i[h];return o}static concat(i,o){if(typeof o=="undefined"){o=0;for(let k=0,A=i.length;k<A;k++)o+=i[k].byteLength}const h=n.alloc(o);let w=0;for(let k=0,A=i.length;k<A;k++){const R=i[k];h.set(R,w),w+=R.byteLength}return h}clone(){const i=n.alloc(this.byteLength);return i.set(this),i}toString(){return D?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(i,o){return new n(this.buffer.subarray(i,o))}set(i,o){if(i instanceof n)this.buffer.set(i.buffer,o);else if(i instanceof Uint8Array)this.buffer.set(i,o);else if(i instanceof ArrayBuffer)this.buffer.set(new Uint8Array(i),o);else if(ArrayBuffer.isView(i))this.buffer.set(new Uint8Array(i.buffer,i.byteOffset,i.byteLength),o);else throw new Error("Unkown argument 'array'")}readUInt32BE(i){return f(this.buffer,i)}writeUInt32BE(i,o){S(this.buffer,i,o)}readUInt32LE(i){return b(this.buffer,i)}writeUInt32LE(i,o){m(this.buffer,i,o)}readUInt8(i){return y(this.buffer,i)}writeUInt8(i,o){t(this.buffer,i,o)}}e.VSBuffer=n;function I(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0}e.readUInt16LE=I;function d(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255}e.writeUInt16LE=d;function f(r,i){return r[i]*2**24+r[i+1]*2**16+r[i+2]*2**8+r[i+3]}e.readUInt32BE=f;function S(r,i,o){r[o+3]=i,i=i>>>8,r[o+2]=i,i=i>>>8,r[o+1]=i,i=i>>>8,r[o]=i}e.writeUInt32BE=S;function b(r,i){return r[i+0]<<0>>>0|r[i+1]<<8>>>0|r[i+2]<<16>>>0|r[i+3]<<24>>>0}e.readUInt32LE=b;function m(r,i,o){r[o+0]=i&255,i=i>>>8,r[o+1]=i&255,i=i>>>8,r[o+2]=i&255,i=i>>>8,r[o+3]=i&255}e.writeUInt32LE=m;function y(r,i){return r[i]}e.readUInt8=y;function t(r,i,o){r[o]=i}e.writeUInt8=t;function g(r){return p.consumeReadable(r,i=>n.concat(i))}e.readableToBuffer=g;function E(r){return p.toReadable(r)}e.bufferToReadable=E;function v(r){return p.consumeStream(r,i=>n.concat(i))}e.streamToBuffer=v;async function P(r){return r.ended?n.concat(r.buffer):n.concat([...r.buffer,await v(r.stream)])}e.bufferedStreamToBuffer=P;function c(r){return p.toStream(r,i=>n.concat(i))}e.bufferToStream=c;function a(r){return p.transform(r,{data:i=>typeof i=="string"?n.fromString(i):n.wrap(i)},i=>n.concat(i))}e.streamToBufferReadableStream=a;function u(r){return p.newWriteableStream(i=>n.concat(i),r)}e.newWriteableBufferStream=u;function s(r,i){return p.prefixedReadable(r,i,o=>n.concat(o))}e.prefixedBufferReadable=s;function l(r,i){return p.prefixedStream(r,i,o=>n.concat(o))}e.prefixedBufferStream=l}),define(Z[25],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function D(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=D;const C=/{(\d+)}/g;function M(G,...ae){return ae.length===0?G:G.replace(C,function(ue,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=ae.length?ue:ae[Ie]})}e.format=M;const n=/{([^}]+)}/g;function I(G,ae){return G.replace(n,(ue,ve)=>ae[ve]??ue)}e.format2=I;function d(G){return G.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}e.escape=d;function f(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=f;function S(G,ae){let ue=0;const ve=ae.charCodeAt(0);for(let Ie=G.length-1;Ie>=0;Ie--)G.charCodeAt(Ie)===ve&&ue++;return ue}e.count=S;function b(G,ae,ue="\u2026"){return G.length<=ae?G:`${G.substr(0,ae)}${ue}`}e.truncate=b;function m(G,ae=" "){const ue=y(G,ae);return t(ue,ae)}e.trim=m;function y(G,ae){if(!G||!ae)return G;const ue=ae.length;if(ue===0||G.length===0)return G;let ve=0;for(;G.indexOf(ae,ve)===ve;)ve=ve+ue;return G.substring(ve)}e.ltrim=y;function t(G,ae){if(!G||!ae)return G;const ue=ae.length,ve=G.length;if(ue===0||ve===0)return G;let Ie=ve,Ce=-1;for(;Ce=G.lastIndexOf(ae,Ie-1),!(Ce===-1||Ce+ue!==Ie);){if(Ce===0)return"";Ie=Ce}return G.substring(0,Ie)}e.rtrim=t;function g(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function E(G){return G.replace(/\*/g,"")}e.stripWildcards=E;function v(G,ae,ue={}){if(!G)throw new Error("Cannot create regex from empty string");ae||(G=f(G)),ue.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let ve="";return ue.global&&(ve+="g"),ue.matchCase||(ve+="i"),ue.multiline&&(ve+="m"),ue.unicode&&(ve+="u"),new RegExp(G,ve)}e.createRegExp=v;function P(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=P;function c(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=c;function a(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=a;function u(G){return G.split(/\r\n|\r|\n/)}e.splitLines=u;function s(G){for(let ae=0,ue=G.length;ae<ue;ae++){const ve=G.charCodeAt(ae);if(ve!==32&&ve!==9)return ae}return-1}e.firstNonWhitespaceIndex=s;function l(G,ae=0,ue=G.length){for(let ve=ae;ve<ue;ve++){const Ie=G.charCodeAt(ve);if(Ie!==32&&Ie!==9)return G.substring(ae,ve)}return G.substring(ae,ue)}e.getLeadingWhitespace=l;function r(G,ae=G.length-1){for(let ue=ae;ue>=0;ue--){const ve=G.charCodeAt(ue);if(ve!==32&&ve!==9)return ue}return-1}e.lastNonWhitespaceIndex=r;function i(G,ae){return G<ae?-1:G>ae?1:0}e.compare=i;function o(G,ae,ue=0,ve=G.length,Ie=0,Ce=ae.length){for(;ue<ve&&Ie<Ce;ue++,Ie++){let Oe=G.charCodeAt(ue),Ne=ae.charCodeAt(Ie);if(Oe<Ne)return-1;if(Oe>Ne)return 1}const Te=ve-ue,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstring=o;function h(G,ae){return w(G,ae,0,G.length,0,ae.length)}e.compareIgnoreCase=h;function w(G,ae,ue=0,ve=G.length,Ie=0,Ce=ae.length){for(;ue<ve&&Ie<Ce;ue++,Ie++){let Oe=G.charCodeAt(ue),Ne=ae.charCodeAt(Ie);if(Oe===Ne)continue;if(Oe>=128||Ne>=128)return o(G.toLowerCase(),ae.toLowerCase(),ue,ve,Ie,Ce);k(Oe)&&(Oe-=32),k(Ne)&&(Ne-=32);const je=Oe-Ne;if(je!==0)return je}const Te=ve-ue,We=Ce-Ie;return Te<We?-1:Te>We?1:0}e.compareSubstringIgnoreCase=w;function k(G){return G>=97&&G<=122}e.isLowerAsciiLetter=k;function A(G){return G>=65&&G<=90}e.isUpperAsciiLetter=A;function R(G,ae){return G.length===ae.length&&w(G,ae)===0}e.equalsIgnoreCase=R;function T(G,ae){const ue=ae.length;return ae.length>G.length?!1:w(G,ae,0,ue)===0}e.startsWithIgnoreCase=T;function _(G,ae){let ue,ve=Math.min(G.length,ae.length);for(ue=0;ue<ve;ue++)if(G.charCodeAt(ue)!==ae.charCodeAt(ue))return ue;return ve}e.commonPrefixLength=_;function Q(G,ae){let ue,ve=Math.min(G.length,ae.length);const Ie=G.length-1,Ce=ae.length-1;for(ue=0;ue<ve;ue++)if(G.charCodeAt(Ie-ue)!==ae.charCodeAt(Ce-ue))return ue;return ve}e.commonSuffixLength=Q;function ne(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ne;function oe(G){return 56320<=G&&G<=57343}e.isLowSurrogate=oe;function X(G,ae){return(G-55296<<10)+(ae-56320)+65536}e.computeCodePoint=X;function O(G,ae,ue){const ve=G.charCodeAt(ue);if(ne(ve)&&ue+1<ae){const Ie=G.charCodeAt(ue+1);if(oe(Ie))return X(ve,Ie)}return ve}e.getNextCodePoint=O;function H(G,ae){const ue=G.charCodeAt(ae-1);if(oe(ue)&&ae>1){const ve=G.charCodeAt(ae-2);if(ne(ve))return X(ve,ue)}return ue}function q(G,ae){const ue=ze.getInstance(),ve=ae,Ie=G.length,Ce=O(G,Ie,ae);ae+=Ce>=65536?2:1;let Te=ue.getGraphemeBreakType(Ce);for(;ae<Ie;){const We=O(G,Ie,ae),Oe=ue.getGraphemeBreakType(We);if(Fe(Te,Oe))break;ae+=We>=65536?2:1,Te=Oe}return ae-ve}e.nextCharLength=q;function Y(G,ae){const ue=ze.getInstance(),ve=ae,Ie=H(G,ae);ae-=Ie>=65536?2:1;let Ce=ue.getGraphemeBreakType(Ie);for(;ae>0;){const Te=H(G,ae),We=ue.getGraphemeBreakType(Te);if(Fe(We,Ce))break;ae-=Te>=65536?2:1,Ce=We}return ve-ae}e.prevCharLength=Y;function $(G,ae){const ue=ze.getInstance(),ve=G.length,Ie=ae,Ce=O(G,ve,ae),Te=ue.getGraphemeBreakType(Ce);ae+=Ce>=65536?2:1;let We=Te;for(;ae<ve;){const Ne=O(G,ve,ae),je=ue.getGraphemeBreakType(Ne);if(Fe(We,je))break;ae+=Ne>=65536?2:1,We=je}const Oe=ae;for(ae=Ie,We=Te;ae>0;){const Ne=H(G,ae),je=ue.getGraphemeBreakType(Ne);if(Fe(je,We))break;ae-=Ne>=65536?2:1,We=je}return[ae,Oe]}function K(G,ae){return ae>0&&oe(G.charCodeAt(ae))?$(G,ae-1):$(G,ae)}e.getCharContainingOffset=K;const ee=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function B(G){return ee.test(G)}e.containsRTL=B;const L=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFF0]|\uD83E[\uDD00-\uDDFF\uDE70-\uDEF6])/;function W(G){return L.test(G)}e.containsEmoji=W;const F=/^[\t\n\r\x20-\x7E]*$/;function N(G){return F.test(G)}e.isBasicASCII=N,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=V;function U(G){for(let ae=0,ue=G.length;ae<ue;ae++)if(z(G.charCodeAt(ae)))return!0;return!1}e.containsFullWidthCharacter=U;function z(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=z;function te(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=te;function re(G,ae){if(G.length<ae)return G;const ue=/\b/g;let ve=0;for(;ue.test(G)&&!(G.length-ue.lastIndex<ae);)ve=ue.lastIndex,ue.lastIndex+=1;return G.substring(ve).replace(/^\s/,"")}e.lcut=re;const se=/\x1B\x5B[12]?K/g,J=/\x1b\[\d+m/g,ce=/\x1b\[0?m/g;function le(G){return G&&(G=G.replace(se,""),G=G.replace(J,""),G=G.replace(ce,"")),G}e.removeAnsiEscapeCodes=le,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function he(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=he;function ge(G){return he(G)?G.substr(1):G}e.stripUTF8BOM=ge;function be(G,ae){if(!G||!ae||G.length<ae.length)return!1;const ue=ae.length,ve=G.toLowerCase();let Ie=0,Ce=-1;for(;Ie<ue;){const Te=ve.indexOf(ae[Ie],Ce+1);if(Te<0)return!1;Ce=Te,Ie++}return!0}e.fuzzyContains=be;function fe(G,ae=!1){return G?(ae&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=fe;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function pe(G,ae=1){if(ae===0)return"";let ue=-1;do ue=G.indexOf(`
`,ue+1),ae--;while(ae>0&&ue>=0);return ue===-1?G:(G[ue-1]==="\r"&&ue--,G.substr(0,ue))}e.getNLines=pe;function Pe(G){const ae=90-65+1;return G=G%(2*ae),G<ae?String.fromCharCode(97+G):String.fromCharCode(65+G-ae)}e.singleLetterHash=Pe;function Re(G){return ze.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Re;function Fe(G,ae){return G===0?ae!==5&&ae!==7:G===2&&ae===3?!1:G===4||G===2||G===3||ae===4||ae===2||ae===3?!0:!(G===8&&(ae===8||ae===9||ae===11||ae===12)||(G===11||G===9)&&(ae===9||ae===10)||(G===12||G===10)&&ae===10||ae===5||ae===13||ae===7||G===1||G===13&&ae===14||G===6&&ae===6)}e.breakBetweenGraphemeBreakType=Fe;var $e;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ze{constructor(){this._data=Qe()}static getInstance(){return ze._INSTANCE||(ze._INSTANCE=new ze),ze._INSTANCE}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const ue=this._data,ve=ue.length/3;let Ie=1;for(;Ie<=ve;)if(ae<ue[3*Ie])Ie=2*Ie;else if(ae>ue[3*Ie+1])Ie=2*Ie+1;else return ue[3*Ie+2];return 0}}ze._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(G,ae){if(G===0)return 0;const ue=gt(G,ae);if(ue!==void 0)return ue;const ve=H(ae,G);return G-=Je(ve),G}e.getLeftDeleteOffset=Ge;function gt(G,ae){let ue=H(ae,G);for(G-=Je(ue);at(ue)||ue===65039||ue===8419;){if(G===0)return;ue=H(ae,G),G-=Je(ue)}if(!!te(ue)){if(G>=0){const ve=H(ae,G);ve===8205&&(G-=Je(ve))}return G}}function Je(G){return G>=65536?2:1}function at(G){return 127995<=G&&G<=127999}var ct;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Ve{static getData(){return JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,40,10088,40,10098,40,12308,40,64830,40,65341,41,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,124,8739,124,9213,124,65512,124,1633,124,1777,124,66336,124,125127,124,120783,124,120793,124,120803,124,120813,124,120823,124,130033,124,65321,124,8544,124,8464,124,8465,124,119816,124,119868,124,119920,124,120024,124,120128,124,120180,124,120232,124,120284,124,120336,124,120388,124,120440,124,406,124,65356,124,8572,124,8467,124,119845,124,119897,124,119949,124,120001,124,120053,124,120105,124,120157,124,120209,124,120261,124,120313,124,120365,124,120417,124,120469,124,448,124,120496,124,120554,124,120612,124,120670,124,120728,124,11410,124,1030,124,1216,124,1493,124,1503,124,1575,124,126464,124,126592,124,65166,124,65165,124,1994,124,11599,124,5825,124,42226,124,93992,124,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90],"_default":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"cs":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"de":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89],"es":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"fr":[65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"it":[160,32,8211,45,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ko":[8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pl":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"pt-BR":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"qps-ploc":[160,32,8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"ru":[65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,124,1009,112,215,120],"tr":[160,32,8211,45,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hans":[65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89],"zh-hant":[8211,45,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,124,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89]}')}static getConfusablesForCurrentLocale(){if(!Ve.map){let ve=function(Te){const We=new Map;for(let Oe=0;Oe<Te.length;Oe+=2)We.set(Te[Oe],Te[Oe+1]);return We};const ae=Ve.getData();let ue=p.locale;(!ue||!(ue in ae))&&(ue=p.language),(!ue||!(ue in ae))&&(ue="_default");const Ie=ve(ae._common),Ce=ve(ae[ue]);for(const[Te,We]of Ce)Ie.set(Te,We);Ve.map=Ie}return Ve.map}static isAmbiguous(ae){return Ve.getConfusablesForCurrentLocale().has(ae)}static getPrimaryConfusable(ae){return Ve.getConfusablesForCurrentLocale().get(ae)}static getPrimaryConfusableCodePoints(){return new Set(Ve.getConfusablesForCurrentLocale().keys())}}e.AmbiguousCharacters=Ve;class He{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(He.getRawData())),this._data}static isInvisibleCharacter(ae){return He.getData().has(ae)}static get codePoints(){return He.getData()}}e.InvisibleCharacters=He,He._data=void 0}),define(Z[81],x([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function D(v){return C(v,0)}e.hash=D;function C(v,P){switch(typeof v){case"object":return v===null?M(349,P):Array.isArray(v)?d(v,P):f(v,P);case"string":return I(v,P);case"boolean":return n(v,P);case"number":return M(v,P);case"undefined":return M(937,P);default:return M(617,P)}}e.doHash=C;function M(v,P){return(P<<5)-P+v|0}e.numberHash=M;function n(v,P){return M(v?433:863,P)}function I(v,P){P=M(149417,P);for(let c=0,a=v.length;c<a;c++)P=M(v.charCodeAt(c),P);return P}e.stringHash=I;function d(v,P){return P=M(104579,P),v.reduce((c,a)=>C(a,c),P)}function f(v,P){return P=M(181387,P),Object.keys(v).sort().reduce((c,a)=>(c=I(a,c),C(v[a],c)),P)}class S{constructor(){this._value=0}get value(){return this._value}hash(P){return this._value=C(P,this._value),this._value}}e.Hasher=S;var b;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(v,P,c=32){const a=c-P,u=~((1<<a)-1);return(v<<P|(u&v)>>>a)>>>0}function y(v,P=0,c=v.byteLength,a=0){for(let u=0;u<c;u++)v[P+u]=a}function t(v,P,c="0"){for(;v.length<P;)v=c+v;return v}function g(v,P=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(c=>c.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),P/4)}e.toHexString=g;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(P){const c=P.length;if(c===0)return;const a=this._buff;let u=this._buffLen,s=this._leftoverHighSurrogate,l,r;for(s!==0?(l=s,r=-1,s=0):(l=P.charCodeAt(0),r=0);;){let i=l;if(p.isHighSurrogate(l))if(r+1<c){const o=P.charCodeAt(r+1);p.isLowSurrogate(o)?(r++,i=p.computeCodePoint(l,o)):i=65533}else{s=l;break}else p.isLowSurrogate(l)&&(i=65533);if(u=this._push(a,u,i),r++,r<c)l=P.charCodeAt(r);else break}this._buffLen=u,this._leftoverHighSurrogate=s}_push(P,c,a){return a<128?P[c++]=a:a<2048?(P[c++]=192|(a&1984)>>>6,P[c++]=128|(a&63)>>>0):a<65536?(P[c++]=224|(a&61440)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0):(P[c++]=240|(a&1835008)>>>18,P[c++]=128|(a&258048)>>>12,P[c++]=128|(a&4032)>>>6,P[c++]=128|(a&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,P[0]=P[64+0],P[1]=P[64+1],P[2]=P[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),g(this._h0)+g(this._h1)+g(this._h2)+g(this._h3)+g(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const P=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(P/4294967296),!1),this._buffDV.setUint32(60,P%4294967296,!1),this._step()}_step(){const P=E._bigBlock32,c=this._buffDV;for(let w=0;w<64;w+=4)P.setUint32(w,c.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)P.setUint32(w,m(P.getUint32(w-12,!1)^P.getUint32(w-32,!1)^P.getUint32(w-56,!1)^P.getUint32(w-64,!1),1),!1);let a=this._h0,u=this._h1,s=this._h2,l=this._h3,r=this._h4,i,o,h;for(let w=0;w<80;w++)w<20?(i=u&s|~u&l,o=1518500249):w<40?(i=u^s^l,o=1859775393):w<60?(i=u&s|u&l|s&l,o=2400959708):(i=u^s^l,o=3395469782),h=m(a,5)+i+r+o+P.getUint32(w*4,!1)&4294967295,r=l,l=s,s=m(u,30),u=a,a=h;this._h0=this._h0+a&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+l&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))});var kt=this&&this.__classPrivateFieldSet||function(j,e,p,D,C){if(D==="m")throw new TypeError("Private method is not writable");if(D==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!C:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return D==="a"?C.call(j,p):C?C.value=p:e.set(j,p),p},Ke=this&&this.__classPrivateFieldGet||function(j,e,p,D){if(p==="a"&&!D)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?D:p==="a"?D.call(j):D?D.value:e.get(j)};define(Z[39],x([0,1,30,25]),function(j,e,p,D){"use strict";var C,M,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(r,i,o){let h=r.get(i);return h===void 0&&(h=o,r.set(i,h)),h}e.getOrSet=I;function d(r){const i=[];return r.forEach((o,h)=>{i.push(`${h} => ${o}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=d;function f(r){const i=[];return r.forEach(o=>{i.push(o)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=f;class S{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),h=this._value.charCodeAt(this._pos);return o-h}value(){return this._value[this._pos]}}e.StringIterator=S;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class m{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const h=this._value.charCodeAt(o);if(!(h===47||this._splitOnBackslash&&h===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,D.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,D.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var y;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(y||(y={}));class t{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,D.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,D.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,D.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,D.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=t;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(E||(E={}));class v{constructor(i){this._iter=i}static forUris(i=()=>!1){return new v(new t(i))}static forPaths(){return new v(new m)}static forStrings(){return new v(new S)}static forConfigKeys(){return new v(new b)}clear(){this._root=void 0}fill(i,o){if(o){const h=o.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w,i)}else{const h=i.slice(0);(0,p.shuffle)(h);for(let w of h)this.set(w[0],w[1])}}set(i,o){const h=this._iter.reset(i);let w;this._root||(this._root=new g,this._root.segment=h.value());const k=[];for(w=this._root;;){const R=h.cmp(w.segment);if(R>0)w.left||(w.left=new g,w.left.segment=h.value()),k.push([-1,w]),w=w.left;else if(R<0)w.right||(w.right=new g,w.right.segment=h.value()),k.push([1,w]),w=w.right;else if(h.hasNext())h.next(),w.mid||(w.mid=new g,w.mid.segment=h.value()),k.push([0,w]),w=w.mid;else break}const A=w.value;w.value=o,w.key=i;for(let R=k.length-1;R>=0;R--){const T=k[R][1];T.updateHeight();const _=T.balanceFactor();if(_<-1||_>1){const Q=k[R][0],ne=k[R+1][0];if(Q===1&&ne===1)k[R][1]=T.rotateLeft();else if(Q===-1&&ne===-1)k[R][1]=T.rotateRight();else if(Q===1&&ne===-1)T.right=k[R+1][1]=k[R+1][1].rotateRight(),k[R][1]=T.rotateLeft();else if(Q===-1&&ne===1)T.left=k[R+1][1]=k[R+1][1].rotateLeft(),k[R][1]=T.rotateRight();else throw new Error;if(R>0)switch(k[R-1][0]){case-1:k[R-1][1].left=k[R][1];break;case 1:k[R-1][1].right=k[R][1];break;case 0:k[R-1][1].mid=k[R][1];break}else this._root=k[0][1]}}return A}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const w=o.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else break}return h}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const h=this._iter.reset(i),w=[];let k=this._root;for(;k;){const A=h.cmp(k.segment);if(A>0)w.push([-1,k]),k=k.left;else if(A<0)w.push([1,k]),k=k.right;else if(h.hasNext())h.next(),w.push([0,k]),k=k.mid;else break}if(!!k){if(o?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const A=this._min(k.right),{key:R,value:T,segment:_}=A;this._delete(A.key,!1),k.key=R,k.value=T,k.segment=_}else{const A=k.left??k.right;if(w.length>0){const[R,T]=w[w.length-1];switch(R){case-1:T.left=A;break;case 0:T.mid=A;break;case 1:T.right=A;break}}else this._root=A}for(let A=w.length-1;A>=0;A--){const R=w[A][1];R.updateHeight();const T=R.balanceFactor();if(T>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),w[A][1]=R.rotateLeft()):T<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),w[A][1]=R.rotateRight()),A>0)switch(w[A-1][0]){case-1:w[A-1][1].left=w[A][1];break;case 1:w[A-1][1].right=w[A][1];break;case 0:w[A-1][1].mid=w[A][1];break}else this._root=w[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let h=this._root,w;for(;h;){const k=o.cmp(h.segment);if(k>0)h=h.left;else if(k<0)h=h.right;else if(o.hasNext())o.next(),w=h.value||w,h=h.mid;else break}return h&&h.value||w}findSuperstr(i){const o=this._iter.reset(i);let h=this._root;for(;h;){const w=o.cmp(h.segment);if(w>0)h=h.left;else if(w<0)h=h.right;else if(o.hasNext())o.next(),h=h.mid;else return h.mid?this._entries(h.mid):void 0}}forEach(i){for(const[o,h]of this)i(h,o)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=o=>{if(!o)return!0;const h=o.balanceFactor();return h<-1||h>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=v;class P{constructor(i,o){this.uri=i,this.value=o}}class c{constructor(i,o){this[C]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new P(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(let[h,w]of this.map)i(w.value,w.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=r=>r.toString();var a;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(a=e.Touch||(e.Touch={}));class u{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const h=this._map.get(i);if(!!h)return o!==0&&this.touch(h,o),h.value}set(i,o,h=0){let w=this._map.get(i);if(w)w.value=o,h!==0&&this.touch(w,h);else{switch(w={key:i,value:o,next:void 0,previous:void 0},h){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(i,w),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const h=this._state;let w=this._head;for(;w;){if(o?i.bind(o)(w.value,w.key,this):i(w.value,w.key,this),this._state!==h)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.key,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return w}values(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:h.value,done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return w}entries(){const i=this,o=this._state;let h=this._head;const w={[Symbol.iterator](){return w},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(h){const k={value:[h.key,h.value],done:!1};return h=h.next,k}else return{value:void 0,done:!0}}};return w}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,h=this.size;for(;o&&h>i;)this._map.delete(o.key),o=o.next,h--;this._head=o,this._size=h,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,h=i.previous;if(!o||!h)throw new Error("Invalid list");o.previous=h,h.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const h=i.next,w=i.previous;i===this._tail?(w.next=void 0,this._tail=w):(h.previous=w,w.next=h),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const h=i.next,w=i.previous;i===this._head?(h.previous=void 0,this._head=h):(h.previous=w,w.next=h),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,h)=>{i.push([h,o])}),i}fromJSON(i){this.clear();for(const[o,h]of i)this.set(o,h)}}e.LinkedMap=u;class s extends u{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class l{constructor(i){n.set(this,void 0),kt(this,n,i,"f")}get size(){return Ke(this,n,"f").size}forEach(i,o){Ke(this,n,"f").forEach(i,o)}get(i){return Ke(this,n,"f").get(i)}has(i){return Ke(this,n,"f").has(i)}entries(){return Ke(this,n,"f").entries()}keys(){return Ke(this,n,"f").keys()}values(){return Ke(this,n,"f").values()}[(n=new WeakMap,Symbol.iterator)](){return Ke(this,n,"f").entries()}}e.ReadonlyMapView=l}),define(Z[70],x([0,1,39]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const D=new p.LRUCache(1e4);function C(f){return d(f,"NFC",D)}e.normalizeNFC=C;const M=new p.LRUCache(1e4);function n(f){return d(f,"NFD",M)}e.normalizeNFD=n;const I=/[^\u0000-\u0080]/;function d(f,S,b){if(!f)return f;const m=b.get(f);if(m)return m;let y;return I.test(f)?y=f.normalize(S):y=f,b.set(f,y),y}e.removeAccents=function(){const f=/[\u0300-\u036f]/g;return function(S){return n(S).replace(f,"")}}()}),define(Z[13],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(k){return Array.isArray(k)}e.isArray=p;function D(k){return typeof k=="string"}e.isString=D;function C(k){return Array.isArray(k)&&k.every(A=>D(A))}e.isStringArray=C;function M(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=M;function n(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=n;function I(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=I;function d(k){return k===!0||k===!1}e.isBoolean=d;function f(k){return typeof k=="undefined"}e.isUndefined=f;function S(k){return!b(k)}e.isDefined=S;function b(k){return f(k)||k===null}e.isUndefinedOrNull=b;function m(k,A){if(!k)throw new Error(A?`Unexpected type, expected '${A}'`:"Unexpected type")}e.assertType=m;function y(k){if(b(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=y;function t(...k){const A=[];for(let R=0;R<k.length;R++){const T=k[R];if(b(T))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);A.push(T)}return A}e.assertAllDefined=t;const g=Object.prototype.hasOwnProperty;function E(k){if(!M(k))return!1;for(let A in k)if(g.call(k,A))return!1;return!0}e.isEmptyObject=E;function v(k){return typeof k=="function"}e.isFunction=v;function P(...k){return k.length>0&&k.every(v)}e.areFunctions=P;function c(k,A){const R=Math.min(k.length,A.length);for(let T=0;T<R;T++)a(k[T],A[T])}e.validateConstraints=c;function a(k,A){if(D(A)){if(typeof k!==A)throw new Error(`argument does not match constraint: typeof ${A}`)}else if(v(A)){try{if(k instanceof A)return}catch{}if(!b(k)&&k.constructor===A||A.length===1&&A.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function u(k){let A=[],R=Object.getPrototypeOf(k);for(;Object.prototype!==R;)A=A.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return A}e.getAllPropertyNames=u;function s(k){const A=[];for(const R of u(k))typeof k[R]=="function"&&A.push(R);return A}e.getAllMethodNames=s;function l(k,A){const R=_=>function(){const Q=Array.prototype.slice.call(arguments,0);return A(_,Q)};let T={};for(const _ of k)T[_]=R(_);return T}e.createProxyObject=l;function r(k){return k===null?void 0:k}e.withNullAsUndefined=r;function i(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=i;function o(k){return class{constructor(){return new Proxy({},{get(A,R){if(A[R])return A[R];throw new Error(`Not Implemented: ${k}->${String(R)}`)}})}}}e.NotImplementedProxy=o;function h(k,A="Unreachable"){throw new Error(A)}e.assertNever=h;function w(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=w}),define(Z[32],x([0,1,8,3,25,13]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(r){return r===47||r===92}e.isPathSeparator=n;function I(r){return r.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=I;function d(r){return r.indexOf("/")===-1&&(r=I(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=d;function f(r,i=p.posix.sep){if(!r)return"";const o=r.length,h=r.charCodeAt(0);if(n(h)){if(n(r.charCodeAt(1))&&!n(r.charCodeAt(2))){let k=3;const A=k;for(;k<o&&!n(r.charCodeAt(k));k++);if(A!==k&&!n(r.charCodeAt(k+1))){for(k+=1;k<o;k++)if(n(r.charCodeAt(k)))return r.slice(0,k+1).replace(/[\\/]/g,i)}}return i}else if(v(h)&&r.charCodeAt(1)===58)return n(r.charCodeAt(2))?r.slice(0,2)+i:r.slice(0,2);let w=r.indexOf("://");if(w!==-1){for(w+=3;w<o;w++)if(n(r.charCodeAt(w)))return r.slice(0,w+1)}return""}e.getRoot=f;function S(r){if(!D.isWindows||!r||r.length<5)return!1;let i=r.charCodeAt(0);if(i!==92||(i=r.charCodeAt(1),i!==92))return!1;let o=2;const h=o;for(;o<r.length&&(i=r.charCodeAt(o),i!==92);o++);return!(h===o||(i=r.charCodeAt(o+1),isNaN(i)||i===92))}e.isUNC=S;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(r,i=D.isWindows){const o=i?b:m;return!(!r||r.length===0||/^\s+$/.test(r)||(o.lastIndex=0,o.test(r))||i&&y.test(r)||r==="."||r===".."||i&&r[r.length-1]==="."||i&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=t;function g(r,i,o){const h=r===i;return!o||h?h:!r||!i?!1:(0,C.equalsIgnoreCase)(r,i)}e.isEqual=g;function E(r,i,o,h=p.sep){if(r===i)return!0;if(!r||!i||i.length>r.length)return!1;if(o){if(!(0,C.startsWithIgnoreCase)(r,i))return!1;if(i.length===r.length)return!0;let k=i.length;return i.charAt(i.length-1)===h&&k--,r.charAt(k)===h}return i.charAt(i.length-1)!==h&&(i+=h),r.indexOf(i)===0}e.isEqualOrParent=E;function v(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=v;function P(r,i){return D.isWindows&&r.endsWith(":")&&(r+=p.sep),(0,p.isAbsolute)(r)||(r=(0,p.join)(i,r)),r=(0,p.normalize)(r),D.isWindows?(r=(0,C.rtrim)(r,p.sep),r.endsWith(":")&&(r+=p.sep)):(r=(0,C.rtrim)(r,p.sep),r||(r=p.sep)),r}e.sanitizeFilePath=P;function c(r){const i=(0,p.normalize)(r);return D.isWindows?r.length>3?!1:a(i)&&(r.length===2||i.charCodeAt(2)===92):i===p.posix.sep}e.isRootOrDriveLetter=c;function a(r,i){return(i!==void 0?i:D.isWindows)?v(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function u(r){return a(r)?r[0]:void 0}e.getDriveLetter=u;function s(r,i,o){return i.length>r.length?-1:r===i?0:(o&&(r=r.toLowerCase(),i=i.toLowerCase()),r.indexOf(i))}e.indexOfPath=s;function l(r){const i=r.split(":");let o,h,w;if(i.forEach(k=>{const A=Number(k);(0,M.isNumber)(A)?h===void 0?h=A:w===void 0&&(w=A):o=o?[o,k].join(":"):k}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:h!==void 0?h:void 0,column:w!==void 0?w:h!==void 0?1:void 0}}e.parseLineAndColumnAware=l}),define(Z[47],x([0,1,13]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function D(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const E=Array.isArray(g)?[]:{};return Object.keys(g).forEach(v=>{g[v]&&typeof g[v]=="object"?E[v]=D(g[v]):E[v]=g[v]}),E}e.deepClone=D;function C(g){if(!g||typeof g!="object")return g;const E=[g];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const P in v)if(M.call(v,P)){const c=v[P];typeof c=="object"&&!Object.isFrozen(c)&&E.push(c)}}return g}e.deepFreeze=C;const M=Object.prototype.hasOwnProperty;function n(g,E){return I(g,E,new Set)}e.cloneAndChange=n;function I(g,E,v){if((0,p.isUndefinedOrNull)(g))return g;const P=E(g);if(typeof P!="undefined")return P;if((0,p.isArray)(g)){const c=[];for(const a of g)c.push(I(a,E,v));return c}if((0,p.isObject)(g)){if(v.has(g))throw new Error("Cannot clone recursive data-structure");v.add(g);const c={};for(let a in g)M.call(g,a)&&(c[a]=I(g[a],E,v));return v.delete(g),c}return g}function d(g,E,v=!0){return(0,p.isObject)(g)?((0,p.isObject)(E)&&Object.keys(E).forEach(P=>{P in g?v&&((0,p.isObject)(g[P])&&(0,p.isObject)(E[P])?d(g[P],E[P],v):g[P]=E[P]):g[P]=E[P]}),g):E}e.mixin=d;function f(g,E){if(g===E)return!0;if(g==null||E===null||E===void 0||typeof g!=typeof E||typeof g!="object"||Array.isArray(g)!==Array.isArray(E))return!1;let v,P;if(Array.isArray(g)){if(g.length!==E.length)return!1;for(v=0;v<g.length;v++)if(!f(g[v],E[v]))return!1}else{const c=[];for(P in g)c.push(P);c.sort();const a=[];for(P in E)a.push(P);if(a.sort(),!f(c,a))return!1;for(v=0;v<c.length;v++)if(!f(g[c[v]],E[c[v]]))return!1}return!0}e.equals=f;function S(g){const E=new Set;return JSON.stringify(g,(v,P)=>{if((0,p.isObject)(P)||Array.isArray(P)){if(E.has(P))return"[Circular]";E.add(P)}return P})}e.safeStringify=S;function b(g,E,v){const P=E(g);return typeof P=="undefined"?v:P}e.getOrDefault=b;function m(g,E){const v=Object.create(null);return!g||!E||Object.keys(E).forEach(c=>{const a=g[c],u=E[c];f(a,u)||(v[c]=u)}),v}e.distinct=m;function y(g,E){const v=E.toLowerCase(),P=Object.keys(g).find(c=>c.toLowerCase()===v);return P?g[P]:g[E]}e.getCaseInsensitive=y;function t(g,E){const v=Object.create(null);for(const[P,c]of Object.entries(g))E(P,c)&&(v[P]=c);return v}e.filter=t}),define(Z[7],x([0,1,8,3]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,M=/^\//,n=/^\/\//;function I(r,i){if(!r.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!C.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!M.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(n.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(r,i){return!r&&!i?"file":r}function f(r,i){switch(r){case"https":case"http":case"file":i?i[0]!==b&&(i=b+i):i=b;break}return i}const S="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,o,h,w,k,A=!1){typeof i=="object"?(this.scheme=i.scheme||S,this.authority=i.authority||S,this.path=i.path||S,this.query=i.query||S,this.fragment=i.fragment||S):(this.scheme=d(i,A),this.authority=o||S,this.path=f(this.scheme,h||S),this.query=w||S,this.fragment=k||S,I(this,A))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:h,path:w,query:k,fragment:A}=i;return o===void 0?o=this.scheme:o===null&&(o=S),h===void 0?h=this.authority:h===null&&(h=S),w===void 0?w=this.path:w===null&&(w=S),k===void 0?k=this.query:k===null&&(k=S),A===void 0?A=this.fragment:A===null&&(A=S),o===this.scheme&&h===this.authority&&w===this.path&&k===this.query&&A===this.fragment?this:new g(o,h,w,k,A)}static parse(i,o=!1){const h=m.exec(i);return h?new g(h[2]||S,l(h[4]||S),l(h[5]||S),l(h[7]||S),l(h[9]||S),o):new g(S,S,S,S,S)}static file(i){let o=S;if(D.isWindows&&(i=i.replace(/\\/g,b)),i[0]===b&&i[1]===b){const h=i.indexOf(b,2);h===-1?(o=i.substring(2),i=b):(o=i.substring(2,h),i=i.substring(h)||b)}return new g("file",o,i,S,S)}static from(i){const o=new g(i.scheme,i.authority,i.path,i.query,i.fragment);return I(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let h;return D.isWindows&&i.scheme==="file"?h=y.file(p.win32.join(c(i,!0),...o)).path:h=p.posix.join(i.path,...o),i.with({path:h})}toString(i=!1){return a(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const o=new g(i);return o._formatted=i.external,o._fsPath=i._sep===t?i.fsPath:null,o}}else return i}}e.URI=y;const t=D.isWindows?1:void 0;class g extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=t),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(r,i){let o,h=-1;for(let w=0;w<r.length;w++){const k=r.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||i&&k===47)h!==-1&&(o+=encodeURIComponent(r.substring(h,w)),h=-1),o!==void 0&&(o+=r.charAt(w));else{o===void 0&&(o=r.substr(0,w));const A=E[k];A!==void 0?(h!==-1&&(o+=encodeURIComponent(r.substring(h,w)),h=-1),o+=A):h===-1&&(h=w)}}return h!==-1&&(o+=encodeURIComponent(r.substring(h))),o!==void 0?o:r}function P(r){let i;for(let o=0;o<r.length;o++){const h=r.charCodeAt(o);h===35||h===63?(i===void 0&&(i=r.substr(0,o)),i+=E[h]):i!==void 0&&(i+=r[o])}return i!==void 0?i:r}function c(r,i){let o;return r.authority&&r.path.length>1&&r.scheme==="file"?o=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?i?o=r.path.substr(1):o=r.path[1].toLowerCase()+r.path.substr(2):o=r.path,D.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=c;function a(r,i){const o=i?P:v;let h="",{scheme:w,authority:k,path:A,query:R,fragment:T}=r;if(w&&(h+=w,h+=":"),(k||w==="file")&&(h+=b,h+=b),k){let _=k.indexOf("@");if(_!==-1){const Q=k.substr(0,_);k=k.substr(_+1),_=Q.indexOf(":"),_===-1?h+=o(Q,!1):(h+=o(Q.substr(0,_),!1),h+=":",h+=o(Q.substr(_+1),!1)),h+="@"}k=k.toLowerCase(),_=k.indexOf(":"),_===-1?h+=o(k,!1):(h+=o(k.substr(0,_),!1),h+=k.substr(_))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const _=A.charCodeAt(1);_>=65&&_<=90&&(A=`/${String.fromCharCode(_+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const _=A.charCodeAt(0);_>=65&&_<=90&&(A=`${String.fromCharCode(_+32)}:${A.substr(2)}`)}h+=o(A,!0)}return R&&(h+="?",h+=o(R,!1)),T&&(h+="#",h+=i?T:v(T,!1)),h}function u(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+u(r.substr(3)):r}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function l(r){return r.match(s)?r.replace(s,i=>u(i)):r}}),define(Z[109],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function D(f){const S=f;return S&&typeof S.type=="string"&&typeof S.severity=="string"}e.isRemoteConsoleLog=D;function C(f){const S=[];let b;try{const m=JSON.parse(f.arguments),y=m[m.length-1];y&&y.__$stack&&(m.pop(),b=y.__$stack),S.push(...m)}catch(m){S.push("Unable to log remote console arguments",f.arguments)}return{args:S,stack:b}}e.parse=C;function M(f){if(typeof f!="string")return M(C(f).stack);const S=f;if(S){const b=n(S),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:p.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=M;function n(f){if(!f)return f;const S=f.indexOf(`
`);return S===-1?f:f.substring(0,S)}function I(f,S){const{args:b,stack:m}=C(f),y=typeof b[0]=="string"&&b.length===1;let t=n(m);t&&(t=`(${t.trim()})`);let g=[];if(typeof b[0]=="string"?t&&y?g=[`%c[${S}] %c${b[0]} %c${t}`,d("blue"),d(""),d("grey")]:g=[`%c[${S}] %c${b[0]}`,d("blue"),d(""),...b.slice(1)]:g=[`%c[${S}]%`,d("blue"),...b],t&&!y&&g.push(t),typeof console[f.severity]!="function")throw new Error("Unknown console method");console[f.severity].apply(console,g)}e.log=I;function d(f){return`color: ${f}`}}),define(Z[110],x([0,1,17,25,7]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(S){return JSON.stringify(S,d)}e.stringify=M;function n(S){let b=JSON.parse(S);return b=f(b),b}e.parse=n;var I;(function(S){S[S.Uri=1]="Uri",S[S.Regexp=2]="Regexp",S[S.ScmResource=3]="ScmResource",S[S.ScmResourceGroup=4]="ScmResourceGroup",S[S.ScmProvider=5]="ScmProvider",S[S.CommentController=6]="CommentController",S[S.CommentThread=7]="CommentThread",S[S.CommentThreadReply=8]="CommentThreadReply",S[S.CommentNode=9]="CommentNode",S[S.CommentThreadNode=10]="CommentThreadNode",S[S.TimelineActionContext=11]="TimelineActionContext",S[S.NotebookCellActionContext=12]="NotebookCellActionContext",S[S.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function d(S,b){return b instanceof RegExp?{$mid:2,source:b.source,flags:(0,D.regExpFlags)(b)}:b}function f(S,b=0){if(!S||b>200)return S;if(typeof S=="object"){switch(S.$mid){case 1:return C.URI.revive(S);case 2:return new RegExp(S.source,S.flags)}if(S instanceof p.VSBuffer||S instanceof Uint8Array)return S;if(Array.isArray(S))for(let m=0;m<S.length;++m)S[m]=f(S[m],b+1);else for(const m in S)Object.hasOwnProperty.call(S,m)&&(S[m]=f(S[m],b+1))}return S}e.revive=f}),define(Z[10],x([0,1,3,7]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls"})(C=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,f,S){this._hosts[d]=f,this._ports[d]=S}setConnectionToken(d,f){this._connectionTokens[d]=f}rewrite(d){if(this._delegate)return this._delegate(d);const f=d.authority;let S=this._hosts[f];S&&S.indexOf(":")!==-1&&(S=`[${S}]`);const b=this._ports[f],m=this._connectionTokens[f];let y=`path=${encodeURIComponent(d.path)}`;return typeof m=="string"&&(y+=`&tkn=${encodeURIComponent(m)}`),D.URI.from({scheme:p.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${S}:${b}`,path:"/vscode-remote-resource",query:y})}}e.RemoteAuthorities=new M;class n{asBrowserUri(d,f){const S=this.toUri(d,f);return S.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(S):S.scheme===C.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${C.vscodeFileResource}://${n.FALLBACK_AUTHORITY}`)?S.with({scheme:C.vscodeFileResource,authority:S.authority||n.FALLBACK_AUTHORITY,query:null,fragment:null}):S}asFileUri(d,f){const S=this.toUri(d,f);return S.scheme===C.vscodeFileResource?S.with({scheme:C.file,authority:S.authority!==n.FALLBACK_AUTHORITY?S.authority:null,query:null,fragment:null}):S}toUri(d,f){return D.URI.isUri(d)?d:D.URI.parse(f.toUrl(d))}}n.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new n}),define(Z[15],x([0,1,32,10,8,3,25,7]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(y){return(0,I.uriToFsPath)(y,!0)}e.originalFSPath=d;class f{constructor(t){this._ignorePathCasing=t}compare(t,g,E=!1){return t===g?0:(0,n.compare)(this.getComparisonKey(t,E),this.getComparisonKey(g,E))}isEqual(t,g,E=!1){return t===g?!0:!t||!g?!1:this.getComparisonKey(t,E)===this.getComparisonKey(g,E)}getComparisonKey(t,g=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,g,E=!1){if(t.scheme===g.scheme){if(t.scheme===D.Schemas.file)return p.isEqualOrParent(d(t),d(g),this._ignorePathCasing(t))&&t.query===g.query&&(E||t.fragment===g.fragment);if((0,e.isEqualAuthority)(t.authority,g.authority))return p.isEqualOrParent(t.path,g.path,this._ignorePathCasing(t),"/")&&t.query===g.query&&(E||t.fragment===g.fragment)}return!1}joinPath(t,...g){return I.URI.joinPath(t,...g)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return C.posix.basename(t.path)}extname(t){return C.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let g;return t.scheme===D.Schemas.file?g=I.URI.file(C.dirname(d(t))).path:(g=C.posix.dirname(t.path),t.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),g="/")),t.with({path:g})}normalizePath(t){if(!t.path.length)return t;let g;return t.scheme===D.Schemas.file?g=I.URI.file(C.normalize(d(t))).path:g=C.posix.normalize(t.path),t.with({path:g})}relativePath(t,g){if(t.scheme!==g.scheme||!(0,e.isEqualAuthority)(t.authority,g.authority))return;if(t.scheme===D.Schemas.file){const P=C.relative(d(t),d(g));return M.isWindows?p.toSlashes(P):P}let E=t.path||"/",v=g.path||"/";if(this._ignorePathCasing(t)){let P=0;for(const c=Math.min(E.length,v.length);P<c&&!(E.charCodeAt(P)!==v.charCodeAt(P)&&E.charAt(P).toLowerCase()!==v.charAt(P).toLowerCase());P++);E=v.substr(0,P)+E.substr(P)}return C.posix.relative(E,v)}resolvePath(t,g){if(t.scheme===D.Schemas.file){const E=I.URI.file(C.resolve(d(t),g));return t.with({authority:E.authority,path:E.path})}return g=p.toPosixPath(g),t.with({path:C.posix.resolve(t.path,g)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,g){return t===g||t!==void 0&&g!==void 0&&(0,n.equalsIgnoreCase)(t,g)}hasTrailingPathSeparator(t,g=C.sep){if(t.scheme===D.Schemas.file){const E=d(t);return E.length>p.getRoot(E).length&&E[E.length-1]===g}else{const E=t.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,g=C.sep){return(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,g=C.sep){let E=!1;if(t.scheme===D.Schemas.file){const v=d(t);E=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===g}else{g="/";const v=t.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(t,g)?t.with({path:t.path+"/"}):t}}e.ExtUri=f,e.extUri=new f(()=>!1),e.extUriBiasedIgnorePathCase=new f(y=>y.scheme===D.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new f(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function S(y,t){const g=[];for(let E=0;E<y.length;E++){const v=t(y[E]);y.some((P,c)=>c===E?!1:(0,e.isEqualOrParent)(v,t(P)))||g.push(y[E])}return g}e.distinctParents=S;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function t(g){const E=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(c=>{const[a,u]=c.split(":");a&&u&&E.set(a,u)});const P=g.path.substring(0,g.path.indexOf(";"));return P&&E.set(y.META_DATA_MIME,P),E}y.parseMetaData=t})(b=e.DataUri||(e.DataUri={}));function m(y,t,g){if(t){let E=y.path;return E&&E[0]!==C.posix.sep&&(E=C.posix.sep+E),y.with({scheme:g,authority:t,path:E})}return y.with({scheme:g})}e.toLocalResource=m}),define(Z[9],x([0,1,23,16,4,2,15,3]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(B){return!!B&&typeof B.then=="function"}e.isThenable=d;function f(B){const L=new p.CancellationTokenSource,W=B(L.token),F=new Promise((N,V)=>{const U=L.token.onCancellationRequested(()=>{U.dispose(),L.dispose(),V((0,D.canceled)())});Promise.resolve(W).then(z=>{U.dispose(),L.dispose(),N(z)},z=>{U.dispose(),L.dispose(),V(z)})});return new class{cancel(){L.cancel()}then(N,V){return F.then(N,V)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=f;function S(B,L,W){return Promise.race([B,new Promise(F=>L.onCancellationRequested(()=>F(W)))])}e.raceCancellation=S;async function b(B){let L=-1;const W=B.map((N,V)=>N.then(U=>(L=V,U))),F=await Promise.race(W);return B.forEach((N,V)=>{V!==L&&N.cancel()}),F}e.raceCancellablePromises=b;function m(B,L,W){let F;const N=setTimeout(()=>{F?.(void 0),W?.()},L);return Promise.race([B.finally(()=>clearTimeout(N)),new Promise(V=>F=V)])}e.raceTimeout=m;function y(B){return new Promise((L,W)=>{const F=B();d(F)?F.then(L,W):L(F)})}e.asPromise=y;class t{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(W,W).then(F)})}return new Promise((W,F)=>{this.queuedPromise.then(W,F)})}return this.activePromise=L(),new Promise((W,F)=>{this.activePromise.then(N=>{this.activePromise=null,W(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=t;class g{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=g;class E{constructor(){this.promiseMap=new Map}queue(L,W){const N=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(L)===N&&this.promiseMap.delete(L)});return this.promiseMap.set(L,N),N}}e.SequencerByKey=E;class v{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,W=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,D.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class P{constructor(L){this.delayer=new v(L),this.throttler=new t}trigger(L,W){return this.delayer.trigger(()=>this.throttler.queue(L),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=P;class c{constructor(){this._isOpen=!1,this._promise=new Promise((L,W)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class a extends c{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function u(B,L){return L?new Promise((W,F)=>{const N=setTimeout(()=>{V.dispose(),W()},B),V=L.onCancellationRequested(()=>{clearTimeout(N),V.dispose(),F((0,D.canceled)())})}):f(W=>u(B,W))}e.timeout=u;function s(B,L=0){const W=setTimeout(B,L);return(0,M.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=s;function l(B){const L=[];let W=0;const F=B.length;function N(){return W<F?B[W++]():null}function V(U){U!=null&&L.push(U);const z=N();return z?z.then(V):Promise.resolve(L)}return Promise.resolve(null).then(V)}e.sequence=l;function r(B,L=F=>!!F,W=null){let F=0;const N=B.length,V=()=>{if(F>=N)return Promise.resolve(W);const U=B[F++];return Promise.resolve(U()).then(te=>L(te)?Promise.resolve(te):V())};return V()}e.first=r;function i(B,L=F=>!!F,W=null){if(B.length===0)return Promise.resolve(W);let F=B.length;const N=()=>{F=-1;for(const V of B)V.cancel?.()};return new Promise((V,U)=>{for(const z of B)z.then(te=>{--F>=0&&L(te)?(N(),V(te)):F===0&&V(W)}).catch(te=>{--F>=0&&(N(),U(te))})})}e.firstParallel=i;class o{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((W,F)=>{this.outstandingPromises.push({factory:L,c:W,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const W=L.factory();W.then(L.c,L.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class h extends o{constructor(){super(1)}}e.Queue=h;class w{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const L=new H;return this.drainers.add(L),L.p}isDrained(){for(const[,L]of this.queues)if(L.size>0)return!1;return!0}queueFor(L,W=n.extUri){const F=W.getComparisonKey(L);let N=this.queues.get(F);return N||(N=new h,C.Event.once(N.onFinished)(()=>{N?.dispose(),this.queues.delete(F),this.onDidQueueFinish()}),this.queues.set(F,N)),N}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const L of this.drainers)L.complete();this.drainers.clear()}dispose(){for(const[,L]of this.queues)L.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=w;class k{constructor(L,W){this._token=-1,typeof L=="function"&&typeof W=="number"&&this.setIfNotSet(L,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},W)}setIfNotSet(L,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},W))}}e.TimeoutTimer=k;class A{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,W){this.cancel(),this._token=setInterval(()=>{L()},W)}}e.IntervalTimer=A;class R{constructor(L,W){this.timeoutToken=-1,this.runner=L,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class T{constructor(L,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=L,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(L=this.timeout){L%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${L}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(L/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=T;class _ extends R{constructor(L,W){super(L,W);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_;class Q extends M.Disposable{constructor(L,W,F,N){super();this.maxWorkChunkSize=L,this.maxPendingWork=W,this.throttleDelay=F,this.handler=N,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=Q,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,I.setTimeout0)(()=>{if(L)return;const W=Date.now()+3;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let L=!1;return{dispose(){L||(L=!0)}}}:e.runWhenIdle=(B,L)=>{const W=requestIdleCallback(B,typeof L=="number"?{timeout:L}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(W))}}}}();class ne{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ne;async function oe(B,L,W){let F;for(let N=0;N<W;N++)try{return await B()}catch(V){F=V,await u(L)}throw F}e.retry=oe;class X{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,W,F){return this._pending={taskId:L,cancel:()=>F?.(),promise:W},W.then(()=>this.donePending(L),()=>this.donePending(L)),W}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let W,F;const N=new Promise((V,U)=>{W=V,F=U});this._next={run:L,promise:N,promiseResolve:W,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=X;class O{constructor(L,W=()=>Date.now()){this.interval=L,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const L=this.nowFn();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=O;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,W)=>{this.completeCallback=L,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(W=>{this.completeCallback(L),this.resolved=!0,W()})}error(L){return new Promise(W=>{this.errorCallback(L),this.rejected=!0,W()})}cancel(){new Promise(L=>{this.errorCallback((0,D.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=H;var q;(function(B){async function L(F){let N;const V=await Promise.all(F.map(U=>U.then(z=>z,z=>{N||(N=z)})));if(typeof N!="undefined")throw N;return V}B.settled=L;function W(F){return new Promise(async(N,V)=>{try{await F(N,V)}catch(U){V(U)}})}B.withAsyncBody=W})(q=e.Promises||(e.Promises={}));var Y;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(Y||(Y={}));class ${constructor(L){this._state=0,this._results=[],this._error=null,this._onStateChanged=new C.Emitter,queueMicrotask(async()=>{const W={emitOne:F=>this.emitOne(F),emitMany:F=>this.emitMany(F),reject:F=>this.reject(F)};try{await Promise.resolve(L(W)),this.resolve()}catch(F){this.reject(F)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(L){return new $(W=>{W.emitMany(L)})}static fromPromise(L){return new $(async W=>{W.emitMany(await L)})}static fromPromises(L){return new $(async W=>{await Promise.all(L.map(async F=>W.emitOne(await F)))})}static merge(L){return new $(async W=>{await Promise.all(L.map(async F=>{for await(const N of F)W.emitOne(N)}))})}[Symbol.asyncIterator](){let L=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(L<this._results.length)return{done:!1,value:this._results[L++]};if(this._state===1)return{done:!0,value:void 0};await C.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(L,W){return new $(async F=>{for await(const N of L)F.emitOne(W(N))})}map(L){return $.map(this,L)}static filter(L,W){return new $(async F=>{for await(const N of L)W(N)&&F.emitOne(N)})}filter(L){return $.filter(this,L)}static coalesce(L){return $.filter(L,W=>!!W)}coalesce(){return $.coalesce(this)}static async toPromise(L){const W=[];for await(const F of L)W.push(F);return W}toPromise(){return $.toPromise(this)}emitOne(L){this._state===0&&(this._results.push(L),this._onStateChanged.fire())}emitMany(L){this._state===0&&(this._results=this._results.concat(L),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(L){this._state===0&&(this._state=2,this._error=L,this._onStateChanged.fire())}}e.AsyncIterableObject=$,$.EMPTY=$.fromArray([]);class K extends ${constructor(L,W){super(W);this._source=L}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=K;function ee(B){const L=new p.CancellationTokenSource,W=B(L.token);return new K(L,async F=>{const N=L.token.onCancellationRequested(()=>{N.dispose(),L.dispose(),F.reject((0,D.canceled)())});try{for await(const V of W){if(L.token.isCancellationRequested)return;F.emitOne(V)}N.dispose(),L.dispose()}catch(V){N.dispose(),L.dispose(),F.reject(V)}})}e.createCancelableAsyncIterable=ee}),define(Z[33],x([0,1,32,10,8,3,15,25,7]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function f(i,o,h){if(typeof i=="string"&&(i=d.URI.file(i)),h){const k=h.getWorkspaceFolder(i);if(k){const A=h.getWorkspace().folders.length>1;let R;if((0,n.isEqual)(k.uri,i)?R="":R=(0,n.relativePath)(k.uri,i),A){const T=k.name?k.name:(0,n.basename)(k.uri);R=R?T+" \u2022 "+R:T}return R}}if(i.scheme!==D.Schemas.file&&i.scheme!==D.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(i.fsPath))return(0,C.normalize)(b(i.fsPath));let w=(0,C.normalize)(i.fsPath);return!M.isWindows&&o?.userHome&&(w=y(w,o.userHome.fsPath)),w}e.getPathLabel=f;function S(i){if(!i)return;typeof i=="string"&&(i=d.URI.file(i));const o=(0,n.basename)(i)||(i.scheme===D.Schemas.file?i.fsPath:i.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(o)?b(o):o}e.getBaseLabel=S;function b(i,o){return(0,p.hasDriveLetter)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let m=Object.create(null);function y(i,o){if(M.isWindows||!i||!o)return i;let h=m.original===o?m.normalized:void 0;return h||(h=`${(0,I.rtrim)(o,C.posix.sep)}${C.posix.sep}`,m={original:o,normalized:h}),(M.isLinux?i.startsWith(h):(0,I.startsWithIgnoreCase)(i,h))&&(i=`~/${i.substr(h.length)}`),i}e.tildify=y;function t(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=t;const g="\u2026",E="\\\\",v="~";function P(i,o=C.sep){const h=new Array(i.length);let w=!1;for(let k=0;k<i.length;k++){let A=i[k];if(A===""){h[k]=`.${o}`;continue}if(!A){h[k]=A;continue}w=!0;let R="";A.indexOf(E)===0?(R=A.substr(0,A.indexOf(E)+E.length),A=A.substr(A.indexOf(E)+E.length)):A.indexOf(o)===0?(R=A.substr(0,A.indexOf(o)+o.length),A=A.substr(A.indexOf(o)+o.length)):A.indexOf(v)===0&&(R=A.substr(0,A.indexOf(v)+v.length),A=A.substr(A.indexOf(v)+v.length));const T=A.split(o);for(let _=1;w&&_<=T.length;_++)for(let Q=T.length-_;w&&Q>=0;Q--){w=!1;let ne=T.slice(Q,Q+_).join(o);for(let oe=0;!w&&oe<i.length;oe++)if(oe!==k&&i[oe]&&i[oe].indexOf(ne)>-1){const X=Q+_===T.length,O=Q>0&&i[oe].indexOf(o)>-1?o+ne:ne,H=i[oe].endsWith(O);w=!X||H}if(!w){let oe="";(T[0].endsWith(":")||R!=="")&&(Q===1&&(Q=0,_++,ne=T[0]+o+ne),Q>0&&(oe=T[0]+o),oe=R+oe),Q>0&&(oe=oe+g+o),oe=oe+ne,Q+_<T.length&&(oe=oe+o+g),h[k]=oe}}w&&(h[k]=A)}return h}e.shorten=P;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function a(i,o=Object.create(null)){const h=[];let w=!1,k="";for(const A of i)if(A==="$"||w&&A==="{")k&&h.push({value:k,type:c.TEXT}),k="",w=!0;else if(A==="}"&&w){const R=o[k];if(typeof R=="string")R.length&&h.push({value:R,type:c.VARIABLE});else if(R){const T=h[h.length-1];(!T||T.type!==c.SEPARATOR)&&h.push({value:R.label,type:c.SEPARATOR})}k="",w=!1}else k+=A;return k&&!w&&h.push({value:k,type:c.TEXT}),h.filter((A,R)=>{if(A.type===c.SEPARATOR){const T=h[R-1],_=h[R+1];return[T,_].every(Q=>Q&&(Q.type===c.VARIABLE||Q.type===c.TEXT)&&Q.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=a;function u(i,o){return M.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):i.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.mnemonicMenuLabel=u;function s(i,o){return M.isMacintosh||o?i.replace(/\(&&\w\)|&&/g,""):M.isWindows?i.replace(/&&|&/g,h=>h==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=s;function l(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=l;function r(i){const o=i.indexOf("/")!==-1?C.posix:C.win32,h=o.basename(i),w=o.dirname(i);return h.length?{name:h,parentPath:w}:{name:w,parentPath:""}}e.splitName=r}),define(Z[111],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function D(S){return S.toJSON()}class C{constructor(b){this._uriTransformer=b}transformIncoming(b){const m=this._uriTransformer.transformIncoming(b);return m===b?b:D(p.URI.from(m))}transformOutgoing(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:D(p.URI.from(m))}transformOutgoingURI(b){const m=this._uriTransformer.transformOutgoing(b);return m===b?b:p.URI.from(m)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function M(S,b,m){if(!S||m>200)return null;if(typeof S=="object"){if(S instanceof p.URI)return b.transformOutgoing(S);for(let y in S)if(Object.hasOwnProperty.call(S,y)){const t=M(S[y],b,m+1);t!==null&&(S[y]=t)}}return null}function n(S,b){const m=M(S,b,0);return m===null?S:m}e.transformOutgoingURIs=n;function I(S,b,m,y){if(!S||y>200)return null;if(typeof S=="object"){if(S.$mid===1)return m?p.URI.revive(b.transformIncoming(S)):b.transformIncoming(S);for(let t in S)if(Object.hasOwnProperty.call(S,t)){const g=I(S[t],b,m,y+1);g!==null&&(S[t]=g)}}return null}function d(S,b){const m=I(S,b,!1,0);return m===null?S:m}e.transformIncomingURIs=d;function f(S,b){const m=I(S,b,!0,0);return m===null?S:m}e.transformAndReviveIncomingURIs=f}),define(Z[31],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(d){return p.test(d)}e.isUUID=D;const C=new Uint8Array(16),M=[];for(let d=0;d<256;d++)M.push(d.toString(16).padStart(2,"0"));let n;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?n=crypto.getRandomValues.bind(crypto):n=function(d){for(let f=0;f<d.length;f++)d[f]=Math.floor(Math.random()*256);return d};function I(){n(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let d=0,f="";return f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f+="-",f+=M[C[d++]],f+=M[C[d++]],f+="-",f+=M[C[d++]],f+=M[C[d++]],f+="-",f+=M[C[d++]],f+=M[C[d++]],f+="-",f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f+=M[C[d++]],f}e.generateUuid=I}),define(Z[112],x([0,1,16,4,2,3,13,25]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.SimpleWorkerServer=e.SimpleWorkerClient=e.logOnceWebWorkerWarning=void 0;const d="$initialize";let f=!1;function S(r){!M.isWeb||(f||(f=!0,console.warn("Could not create web worker(s). Falling back to loading web worker code in main thread, which might cause UI freezes. Please see https://github.com/microsoft/monaco-editor#faq")),console.warn(r.message))}e.logOnceWebWorkerWarning=S;var b;(function(r){r[r.Request=0]="Request",r[r.Reply=1]="Reply",r[r.SubscribeEvent=2]="SubscribeEvent",r[r.Event=3]="Event",r[r.UnsubscribeEvent=4]="UnsubscribeEvent"})(b||(b={}));class m{constructor(i,o,h,w){this.vsWorker=i,this.req=o,this.method=h,this.args=w,this.type=0}}class y{constructor(i,o,h,w){this.vsWorker=i,this.seq=o,this.res=h,this.err=w,this.type=1}}class t{constructor(i,o,h,w){this.vsWorker=i,this.req=o,this.eventName=h,this.arg=w,this.type=2}}class g{constructor(i,o,h){this.vsWorker=i,this.req=o,this.event=h,this.type=3}}class E{constructor(i,o){this.vsWorker=i,this.req=o,this.type=4}}class v{constructor(i){this._workerId=-1,this._handler=i,this._lastSentReq=0,this._pendingReplies=Object.create(null),this._pendingEmitters=new Map,this._pendingEvents=new Map}setWorkerId(i){this._workerId=i}sendMessage(i,o){const h=String(++this._lastSentReq);return new Promise((w,k)=>{this._pendingReplies[h]={resolve:w,reject:k},this._send(new m(this._workerId,h,i,o))})}listen(i,o){let h=null;const w=new D.Emitter({onFirstListenerAdd:()=>{h=String(++this._lastSentReq),this._pendingEmitters.set(h,w),this._send(new t(this._workerId,h,i,o))},onLastListenerRemove:()=>{this._pendingEmitters.delete(h),this._send(new E(this._workerId,h)),h=null}});return w.event}handleMessage(i){!i||!i.vsWorker||this._workerId!==-1&&i.vsWorker!==this._workerId||this._handleMessage(i)}_handleMessage(i){switch(i.type){case 1:return this._handleReplyMessage(i);case 0:return this._handleRequestMessage(i);case 2:return this._handleSubscribeEventMessage(i);case 3:return this._handleEventMessage(i);case 4:return this._handleUnsubscribeEventMessage(i)}}_handleReplyMessage(i){if(!this._pendingReplies[i.seq]){console.warn("Got reply to unknown seq");return}let o=this._pendingReplies[i.seq];if(delete this._pendingReplies[i.seq],i.err){let h=i.err;i.err.$isError&&(h=new Error,h.name=i.err.name,h.message=i.err.message,h.stack=i.err.stack),o.reject(h);return}o.resolve(i.res)}_handleRequestMessage(i){let o=i.req;this._handler.handleMessage(i.method,i.args).then(w=>{this._send(new y(this._workerId,o,w,void 0))},w=>{w.detail instanceof Error&&(w.detail=(0,p.transformErrorForSerialization)(w.detail)),this._send(new y(this._workerId,o,void 0,(0,p.transformErrorForSerialization)(w)))})}_handleSubscribeEventMessage(i){const o=i.req,h=this._handler.handleEvent(i.eventName,i.arg)(w=>{this._send(new g(this._workerId,o,w))});this._pendingEvents.set(o,h)}_handleEventMessage(i){if(!this._pendingEmitters.has(i.req)){console.warn("Got event for unknown req");return}this._pendingEmitters.get(i.req).fire(i.event)}_handleUnsubscribeEventMessage(i){if(!this._pendingEvents.has(i.req)){console.warn("Got unsubscribe for unknown req");return}this._pendingEvents.get(i.req).dispose(),this._pendingEvents.delete(i.req)}_send(i){let o=[];if(i.type===0)for(let h=0;h<i.args.length;h++)i.args[h]instanceof ArrayBuffer&&o.push(i.args[h]);else i.type===1&&i.res instanceof ArrayBuffer&&o.push(i.res);this._handler.sendMessage(i,o)}}class P extends C.Disposable{constructor(i,o,h){super();let w=null;this._worker=this._register(i.create("vs/base/common/worker/simpleWorker",_=>{this._protocol.handleMessage(_)},_=>{w&&w(_)})),this._protocol=new v({sendMessage:(_,Q)=>{this._worker.postMessage(_,Q)},handleMessage:(_,Q)=>{if(typeof h[_]!="function")return Promise.reject(new Error("Missing method "+_+" on main thread host."));try{return Promise.resolve(h[_].apply(h,Q))}catch(ne){return Promise.reject(ne)}},handleEvent:(_,Q)=>{if(a(_)){const ne=h[_].call(h,Q);if(typeof ne!="function")throw new Error(`Missing dynamic event ${_} on main thread host.`);return ne}if(c(_)){const ne=h[_];if(typeof ne!="function")throw new Error(`Missing event ${_} on main thread host.`);return ne}throw new Error(`Malformed event name ${_}`)}}),this._protocol.setWorkerId(this._worker.getId());let k=null;typeof M.globals.require!="undefined"&&typeof M.globals.require.getConfig=="function"?k=M.globals.require.getConfig():typeof M.globals.requirejs!="undefined"&&(k=M.globals.requirejs.s.contexts._.config);const A=n.getAllMethodNames(h);this._onModuleLoaded=this._protocol.sendMessage(d,[this._worker.getId(),JSON.parse(JSON.stringify(k)),o,A]);const R=(_,Q)=>this._request(_,Q),T=(_,Q)=>this._protocol.listen(_,Q);this._lazyProxy=new Promise((_,Q)=>{w=Q,this._onModuleLoaded.then(ne=>{_(u(ne,R,T))},ne=>{Q(ne),this._onError("Worker failed to load "+o,ne)})})}getProxyObject(){return this._lazyProxy}_request(i,o){return new Promise((h,w)=>{this._onModuleLoaded.then(()=>{this._protocol.sendMessage(i,o).then(h,w)},w)})}_onError(i,o){console.error(i),console.info(o)}}e.SimpleWorkerClient=P;function c(r){return r[0]==="o"&&r[1]==="n"&&I.isUpperAsciiLetter(r.charCodeAt(2))}function a(r){return/^onDynamic/.test(r)&&I.isUpperAsciiLetter(r.charCodeAt(9))}function u(r,i,o){const h=A=>function(){const R=Array.prototype.slice.call(arguments,0);return i(A,R)},w=A=>function(R){return o(A,R)};let k={};for(const A of r){if(a(A)){k[A]=w(A);continue}if(c(A)){k[A]=o(A,void 0);continue}k[A]=h(A)}return k}class s{constructor(i,o){this._requestHandlerFactory=o,this._requestHandler=null,this._protocol=new v({sendMessage:(h,w)=>{i(h,w)},handleMessage:(h,w)=>this._handleMessage(h,w),handleEvent:(h,w)=>this._handleEvent(h,w)})}onmessage(i){this._protocol.handleMessage(i)}_handleMessage(i,o){if(i===d)return this.initialize(o[0],o[1],o[2],o[3]);if(!this._requestHandler||typeof this._requestHandler[i]!="function")return Promise.reject(new Error("Missing requestHandler or method: "+i));try{return Promise.resolve(this._requestHandler[i].apply(this._requestHandler,o))}catch(h){return Promise.reject(h)}}_handleEvent(i,o){if(!this._requestHandler)throw new Error("Missing requestHandler");if(a(i)){const h=this._requestHandler[i].call(this._requestHandler,o);if(typeof h!="function")throw new Error(`Missing dynamic event ${i} on request handler.`);return h}if(c(i)){const h=this._requestHandler[i];if(typeof h!="function")throw new Error(`Missing event ${i} on request handler.`);return h}throw new Error(`Malformed event name ${i}`)}initialize(i,o,h,w){this._protocol.setWorkerId(i);const R=u(w,(T,_)=>this._protocol.sendMessage(T,_),(T,_)=>this._protocol.listen(T,_));return this._requestHandlerFactory?(this._requestHandler=this._requestHandlerFactory(R),Promise.resolve(n.getAllMethodNames(this._requestHandler))):(o&&(typeof o.baseUrl!="undefined"&&delete o.baseUrl,typeof o.paths!="undefined"&&typeof o.paths.vs!="undefined"&&delete o.paths.vs,typeof o.trustedTypesPolicy!==void 0&&delete o.trustedTypesPolicy,o.catchError=!0,M.globals.require.config(o)),new Promise((T,_)=>{(M.globals.require||j)([h],ne=>{if(this._requestHandler=ne.create(R),!this._requestHandler){_(new Error("No RequestHandler!"));return}T(n.getAllMethodNames(this._requestHandler))},_)}))}}e.SimpleWorkerServer=s;function l(r){return new s(r,null)}e.create=l}),define(Z[113],x([0,1,60,27,42]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(n,I){if(await new Promise((S,b)=>{const m=D.createReadStream(n),y=p.createHash("sha1");m.pipe(y);const t=(0,C.once)((g,E)=>{m.removeAllListeners(),y.removeAllListeners(),g?b(g):S(E)});m.once("error",t),m.once("end",t),y.once("error",t),y.once("data",g=>t(void 0,g.toString("hex")))})!==I)throw new Error("Hash mismatch")}e.checksum=M}),define(Z[114],x([0,1,245]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class D{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const n=[],I=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(I.length<1)return n;let d=0,f,S=d;for(;S<I.length;)if(f=I.charCodeAt(S),f===13||f===10){if(n.push(I.substring(d,S)),S++,S<I.length){const b=f;f=I.charCodeAt(S),(b===13&&f===10||b===10&&f===13)&&S++}d=S}else S++;return this.remaining=d<I.length?I.substr(d):null,n}end(){return this.remaining}}e.LineDecoder=D}),define(Z[115],x([0,1,26]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function C(n){const I=n.replace(/\-/g,":").toLowerCase();return!D.has(I)}function M(){const n=(0,p.networkInterfaces)();for(let I in n){const d=n[I];if(d){for(const{mac:f}of d)if(C(f))return f}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=M}),define(Z[71],x([0,1,26,16,39,31,115]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(S){return this._virtualMachineOUIs||(this._virtualMachineOUIs=C.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(S)}value(){if(this._value===void 0){let S=0,b=0;const m=(0,p.networkInterfaces)();for(let y in m){const t=m[y];if(t)for(const{mac:g,internal:E}of t)E||(b+=1,this._isVirtualMachineMacAddress(g.toUpperCase())&&(S+=1))}this._value=b>0?S/b:0}return this._value}};let I;async function d(){return I||(I=(async()=>await f()||M.generateUuid())()),I}e.getMachineId=d;async function f(){try{const S=await new Promise((m,y)=>{j(["crypto"],m,y)}),b=(0,n.getMac)();return S.createHash("sha256").update(b,"utf8").digest("hex")}catch(S){D.onUnexpectedError(S);return}}}),define(Z[21],x([0,1,27,26,116,9,32,70,8,3,15,7,31]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var y;(function(O){O[O.UNLINK=0]="UNLINK",O[O.MOVE=1]="MOVE"})(y=e.RimRafMode||(e.RimRafMode={}));async function t(O,H=y.UNLINK){if((0,n.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");return H===y.UNLINK?E(O):g(O)}async function g(O){try{const H=(0,d.join)((0,D.tmpdir)(),(0,m.generateUuid)());try{await e.Promises.rename(O,H)}catch(q){return E(O)}E(H).catch(q=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function E(O){return e.Promises.rmdir(O,{recursive:!0,maxRetries:3})}function v(O){if((0,n.isRootOrDriveLetter)(O))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(O,{recursive:!0})}e.rimrafSync=v;async function P(O,H){return u(await(H?c(O):(0,C.promisify)(p.readdir)(O)))}async function c(O){try{return await(0,C.promisify)(p.readdir)(O,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const H=[],q=await P(O);for(const Y of q){let $=!1,K=!1,ee=!1;try{const B=await e.Promises.lstat((0,d.join)(O,Y));$=B.isFile(),K=B.isDirectory(),ee=B.isSymbolicLink()}catch(B){console.warn("[node.js fs] unexpected error from lstat after readdir: ",B)}H.push({name:Y,isFile:()=>$,isDirectory:()=>K,isSymbolicLink:()=>ee})}return H}function a(O){return u(p.readdirSync(O))}e.readdirSync=a;function u(O){return O.map(H=>typeof H=="string"?f.isMacintosh?(0,I.normalizeNFC)(H):H:(H.name=f.isMacintosh?(0,I.normalizeNFC)(H.name):H.name,H))}async function s(O){const H=await P(O),q=[];for(const Y of H)await r.existsDirectory((0,d.join)(O,Y))&&q.push(Y);return q}function l(O,H=1e3){return new Promise(q=>{let Y=!1;const $=setInterval(()=>{Y||(Y=!0,p.access(O,K=>{Y=!1,K&&(clearInterval($),q(void 0))}))},H)})}e.whenDeleted=l;var r;(function(O){async function H($){let K;try{if(K=await e.Promises.lstat($),!K.isSymbolicLink())return{stat:K}}catch(ee){}try{return{stat:await e.Promises.stat($),symbolicLink:K?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ee){if(ee.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};if(f.isWindows&&ee.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(B){if(B.code==="ENOENT"&&K)return{stat:K,symbolicLink:{dangling:!0}};throw B}throw ee}}O.stat=H;async function q($){try{const{stat:K,symbolicLink:ee}=await O.stat($);return K.isFile()&&ee?.dangling!==!0}catch(K){}return!1}O.existsFile=q;async function Y($){try{const{stat:K,symbolicLink:ee}=await O.stat($);return K.isDirectory()&&ee?.dangling!==!0}catch(K){}return!1}O.existsDirectory=Y})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new M.ResourceQueue;function o(O,H,q){return i.queueFor(b.URI.file(O),S.extUriBiasedIgnorePathCase).queue(()=>{const Y=A(q);return new Promise(($,K)=>w(O,H,Y,ee=>ee?K(ee):$()))})}let h=!0;function w(O,H,q,Y){if(!h)return p.writeFile(O,H,{mode:q.mode,flag:q.flag},Y);p.open(O,q.flag,q.mode,($,K)=>{if($)return Y($);p.writeFile(K,H,ee=>{if(ee)return p.close(K,()=>Y(ee));p.fdatasync(K,B=>(B&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",B),h=!1),p.close(K,L=>Y(L))))})})}function k(O,H,q){const Y=A(q);if(!h)return p.writeFileSync(O,H,{mode:Y.mode,flag:Y.flag});const $=p.openSync(O,Y.flag,Y.mode);try{p.writeFileSync($,H);try{p.fdatasyncSync($)}catch(K){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",K),h=!1}}finally{p.closeSync($)}}e.writeFileSync=k;function A(O){return O?{mode:typeof O.mode=="number"?O.mode:438,flag:typeof O.flag=="string"?O.flag:"w"}:{mode:438,flag:"w"}}async function R(O,H){if(O===H)return;async function q(Y){try{const $=await e.Promises.lstat(Y);if($.isDirectory()||$.isSymbolicLink())return;await e.Promises.utimes(Y,$.atime,new Date)}catch($){}}try{await e.Promises.rename(O,H),await q(H)}catch(Y){if(O.toLowerCase()!==H.toLowerCase()&&Y.code==="EXDEV"||O.endsWith("."))await T(O,H,{preserveSymlinks:!1}),await t(O,y.MOVE),await q(H);else throw Y}}async function T(O,H,q){return Q(O,H,{root:{source:O,target:H},options:q,handledSourcePaths:new Set})}const _=511;async function Q(O,H,q){if(q.handledSourcePaths.has(O))return;q.handledSourcePaths.add(O);const{stat:Y,symbolicLink:$}=await r.stat(O);if($){if(q.options.preserveSymlinks)try{return await X(O,H,q)}catch(K){console.warn("[node.js fs] copy of symlink failed: ",K)}if($.dangling)return}return Y.isDirectory()?ne(O,H,Y.mode&_,q):oe(O,H,Y.mode&_)}async function ne(O,H,q,Y){await e.Promises.mkdir(H,{recursive:!0,mode:q});const $=await P(O);for(const K of $)await Q((0,d.join)(O,K),(0,d.join)(H,K),Y)}async function oe(O,H,q){await e.Promises.copyFile(O,H),await e.Promises.chmod(H,q)}async function X(O,H,q){let Y=await e.Promises.readlink(O);(0,n.isEqualOrParent)(Y,q.root.source,!f.isLinux)&&(Y=(0,d.join)(q.root.target,Y.substr(q.root.source.length+1))),await e.Promises.symlink(Y,H)}e.Promises=new class{get access(){return(0,C.promisify)(p.access)}get stat(){return(0,C.promisify)(p.stat)}get lstat(){return(0,C.promisify)(p.lstat)}get utimes(){return(0,C.promisify)(p.utimes)}get read(){return(0,C.promisify)(p.read)}get readFile(){return(0,C.promisify)(p.readFile)}get write(){return(0,C.promisify)(p.write)}get appendFile(){return(0,C.promisify)(p.appendFile)}get fdatasync(){return(0,C.promisify)(p.fdatasync)}get truncate(){return(0,C.promisify)(p.truncate)}get rename(){return(0,C.promisify)(p.rename)}get copyFile(){return(0,C.promisify)(p.copyFile)}get open(){return(0,C.promisify)(p.open)}get close(){return(0,C.promisify)(p.close)}get symlink(){return(0,C.promisify)(p.symlink)}get readlink(){return(0,C.promisify)(p.readlink)}get chmod(){return(0,C.promisify)(p.chmod)}get mkdir(){return(0,C.promisify)(p.mkdir)}get unlink(){return(0,C.promisify)(p.unlink)}get rmdir(){return(0,C.promisify)(p.rmdir)}get realpath(){return(0,C.promisify)(p.realpath)}async exists(O){try{return await e.Promises.access(O),!0}catch{return!1}}get readdir(){return P}get readDirsInDir(){return s}get writeFile(){return o}get rm(){return t}get move(){return R}get copy(){return T}}}),define(Z[82],x([0,1,27,8,25,21]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(S){const b=(0,D.dirname)(S);if(S===b)return S;const m=((0,D.basename)(S)||S).toLowerCase();try{const t=(0,M.readdirSync)(b).filter(g=>g.toLowerCase()===m);if(t.length===1){const g=n(b);if(g)return(0,D.join)(g,t[0])}else if(t.length>1){const g=t.indexOf(m);if(g>=0){const E=n(b);if(E)return(0,D.join)(E,t[g])}}}catch(y){}return null}e.realcaseSync=n;async function I(S){try{return await M.Promises.realpath(S)}catch(b){const m=f(S);return await M.Promises.access(m,p.constants.R_OK),m}}e.realpath=I;function d(S){try{return p.realpathSync(S)}catch(b){const m=f(S);return p.accessSync(m,p.constants.R_OK),m}}e.realpathSync=d;function f(S){return(0,C.rtrim)((0,D.normalize)(S),D.sep)}}),define(Z[117],x([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function D(I,d,f,S=1){let b=!1;return new Promise(m=>{const y=setTimeout(()=>{if(!b)return b=!0,m(0)},f);C(I,d,S,t=>{if(!b)return b=!0,clearTimeout(y),m(t)})})}e.findFreePort=D;function C(I,d,f,S){if(d===0)return S(0);const b=new p.Socket;b.once("connect",()=>(n(b),C(I+f,d-1,f,S))),b.once("data",()=>{}),b.once("error",m=>(n(b),m.code!=="ECONNREFUSED"?C(I+f,d-1,f,S):S(I))),b.connect(I,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function M(I,d,f){let S=!1,b,m=1;const y=p.createServer({pauseOnConnect:!0});function t(g,E){S||(S=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),E(g))}return new Promise(g=>{b=setTimeout(()=>{t(0,g)},f),y.on("listening",()=>{t(I,g)}),y.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&m<d?(I++,m++,y.listen(I,"127.0.0.1")):t(0,g)}),y.on("close",()=>{t(0,g)}),y.listen(I,"127.0.0.1")})}e.findFreePortFaster=M;function n(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(d){console.error(d)}}}),define(Z[118],x([0,1,26,8,21]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,n=/^Microsoft.PowerShell_.*/,I=/^Microsoft.PowerShellPreview_.*/;var d;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(d||(d={}));let f;switch(process.arch){case"ia32":case"x32":f=1;break;case"arm":case"arm64":f=2;break;default:f=0;break}let S;process.env.PROCESSOR_ARCHITEW6432?S=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?S=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?S=1:S=0;class b{constructor(u,s,l){this.exePath=u,this.displayName=s,this.knownToExist=l}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await C.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:a=!1}={}){return a?f===0?process.env["ProgramFiles(x86)"]||null:S===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:a=!1,findPreview:u=!1}={}){const s=m({useAlternateBitness:a});if(!s)return null;const l=D.join(s,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(l))return null;let r=-1,i=null;for(const w of await C.Promises.readdir(l)){let k=-1;if(u){const R=w.indexOf("-");if(R<0)continue;const T=w.substring(0,R);if(!M.test(T)||w.substring(R+1)!=="preview")continue;k=parseInt(T,10)}else{if(!M.test(w))continue;k=parseInt(w,10)}if(k<=r)continue;const A=D.join(l,w,"pwsh.exe");!await C.SymlinkSupport.existsFile(A)||(i=A,r=k)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",h=u?" Preview":"";return new b(i,`PowerShell${h}${o}`,!0)}async function t({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const u=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:s,pwshMsixName:l}=a?{pwshMsixDirRegex:I,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:n,pwshMsixName:"PowerShell (Store)"};for(const r of await C.Promises.readdir(u))if(s.test(r)){const i=D.join(u,r,"pwsh.exe");return new b(i,l)}return null}function g(){const a=D.join(p.homedir(),".dotnet","tools","pwsh.exe");return new b(a,".NET Core PowerShell Global Tool")}function E(){const a=D.join(process.env.windir,f===1&&S!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(a,"Windows PowerShell",!0)}async function*v(){let a=await y();a&&(yield a),a=await y({useAlternateBitness:!0}),a&&(yield a),a=await t(),a&&(yield a),a=g(),a&&(yield a),a=await y({findPreview:!0}),a&&(yield a),a=await t({findPreview:!0}),a&&(yield a),a=await y({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=E(),a&&(yield a)}async function*P(){for await(const a of v())await a.exists()&&(yield a)}e.enumeratePowerShellInstallations=P;async function c(){for await(const a of P())return a;return null}e.getFirstAvailablePowerShellInstallation=c}),define(Z[83],x([0,1,43,10]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function C(n){return new Promise((I,d)=>{let f;const S=new Map;function b(y,t,g,E,v){const P=S.get(t);if(y===n||P){const c={name:m(g),cmd:g,pid:y,ppid:t,load:E,mem:v};S.set(y,c),y===n&&(f=c),P&&(P.children||(P.children=[]),P.children.push(c),P.children.length>1&&(P.children=P.children.sort((a,u)=>a.pid-u.pid)))}}function m(y){const t=/--vscode-window-kind=shared-process/,g=/--vscode-window-kind=issue-reporter/,E=/--vscode-window-kind=process-explorer/,v=/--utility-sub-type=network/,P=/--crashes-directory/,c=/\\pipe\\winpty-control/,a=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(P.exec(y))return"electron-crash-reporter";if(c.exec(y))return"winpty-process";if(a.exec(y))return"console-window-host (Windows internal process)";let s=u.exec(y);if(s&&s.length===2)return s[1]==="renderer"?t.exec(y)?"shared-process":g.exec(y)?"issue-reporter":E.exec(y)?"process-explorer":"window":s[1]==="utility"&&v.exec(y)?"utility-network-service":s[1];const l=/[a-zA-Z-]+\.js/g;let r="";do s=l.exec(y),s&&(r+=s+" ");while(s);return r&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${r}`:y}if(process.platform==="win32"){const y=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,g)=>{j(["windows-process-tree"],t,g)}).then(t=>{t.getProcessList(n,g=>{t.getProcessCpuUsage(g,E=>{const v=new Map;E.forEach(P=>{const c=y(P.commandLine||"");v.set(P.pid,{name:m(c),cmd:c,pid:P.pid,ppid:P.ppid,load:P.cpu||0,mem:P.memory||0})}),f=v.get(n),f?(v.forEach(P=>{const c=v.get(P.ppid);c&&(c.children||(c.children=[]),c.children.push(P))}),v.forEach(P=>{P.children&&(P.children=P.children.sort((c,a)=>c.pid-a.pid))}),I(f)):d(new Error(`Root process ${n} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let y=function(){let t=[f];const g=[];for(;t.length;){const v=t.shift();v&&(g.push(v.pid),v.children&&(t=t.concat(v.children)))}let E=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);E+=" "+g.join(" "),(0,p.exec)(E,{},(v,P,c)=>{if(v||c)d(v||new Error(c.toString()));else{const a=P.toString().split(`
`);for(let u=0;u<g.length;u++){const s=S.get(g[u]);s.load=parseFloat(a[u])}if(!f){d(new Error(`Root process ${n} not found`));return}I(f)}})};(0,p.exec)("which ps",{},(t,g,E)=>{if(t||E)if(process.platform!=="linux")d(t||new Error(E.toString()));else{const v=JSON.stringify(D.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(v,{},(P,c,a)=>{P||a?d(P||new Error(a.toString())):(M(c,b),y())})}else{const v=g.toString().trim(),P="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${P}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,a,u)=>{c||u&&!u.includes("screen size is bogus")?d(c||new Error(u.toString())):(M(a,b),process.platform==="linux"?y():f?I(f):d(new Error(`Root process ${n} not found`)))})}})}})}e.listProcesses=C;function M(n,I){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,f=n.toString().split(`
`);for(const S of f){const b=d.exec(S.trim());b&&b.length===6&&I(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(Z[119],x([0,1,27,23,32,2,70,8,3,21]),function(j,e,p,D,C,M,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(t,g,E){return m({path:t,isDirectory:!1},g,E)}e.watchFile=S;function b(t,g,E){return m({path:t,isDirectory:!0},g,E)}e.watchFolder=b,e.CHANGE_BUFFER_DELAY=100;function m(t,g,E){if(d.isMacintosh&&(0,C.isEqualOrParent)(t.path,"/Volumes/"))return E(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=(0,I.basename)(t.path),P=new Map;let c=!1,a=[(0,M.toDisposable)(()=>{P.forEach(u=>(0,M.dispose)(u)),P.clear()})];try{const u=(0,p.watch)(t.path);a.push((0,M.toDisposable)(()=>{u.removeAllListeners(),u.close()}));const s=new Set;t.isDirectory&&f.Promises.readdir(t.path).then(l=>l.forEach(r=>s.add(r))),u.on("error",(l,r)=>{c||E(`Failed to watch ${t.path} for changes using fs.watch() (${l}, ${r})`)}),u.on("change",(l,r)=>{if(c)return;let i="";if(r&&(i=r.toString(),d.isMacintosh&&(i=(0,n.normalizeNFC)(i))),!i||l!=="change"&&l!=="rename")return;const o=t.isDirectory?(0,I.join)(t.path,i):t.path;if(t.isDirectory)if(l==="rename"){const h=P.get(o);h&&(0,M.dispose)(h);const w=setTimeout(async()=>{P.delete(o);const k=await f.Promises.exists(o);if(c)return;let A;k?s.has(i)?A="changed":(A="added",s.add(i)):(s.delete(i),A="deleted"),g(A,o)},e.CHANGE_BUFFER_DELAY);P.set(o,(0,M.toDisposable)(()=>clearTimeout(w)))}else{let h;s.has(i)?h="changed":(h="added",s.add(i)),g(h,o)}else if(l==="rename"||i!==v){const h=setTimeout(async()=>{const w=await f.Promises.exists(o);c||(w?(g("changed",o),a=[m(t,g,E)]):g("deleted",o))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(a),a=[(0,M.toDisposable)(()=>clearTimeout(h))]}else g("changed",o)})}catch(u){f.Promises.exists(t.path).then(s=>{s&&!c&&E(`Failed to watch ${t.path} for changes using fs.watch() (${u.toString()})`)})}return(0,M.toDisposable)(()=>{c=!0,a=(0,M.dispose)(a)})}async function y(t,g,E,v=512){const P=await f.Promises.open(t,"r"),c=Buffer.allocUnsafe(v),a=new D.CancellationTokenSource(E);let u,s=!1;const l=S(t,async r=>{if(r==="changed"){if(s)return;s=!0;try{for(;!a.token.isCancellationRequested;){const{bytesRead:i}=await f.Promises.read(P,c,0,v,null);if(!i||a.token.isCancellationRequested)break;g(c.slice(0,i))}}catch(i){u=new Error(i),a.dispose(!0)}finally{s=!1}}},r=>{u=new Error(r),a.dispose(!0)});return new Promise((r,i)=>{a.token.onCancellationRequested(async()=>{l.dispose(),await f.Promises.close(P),u?i(u):r()})})}e.watchFileContents=y}),define(Z[120],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Z[121],x([0,1,14,13,120]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(C.CONTEXT_MENU_CHANNEL,(I,d,f,S,b)=>{const m=n(I,S,f);m.popup({window:(0,D.withNullAsUndefined)(p.BrowserWindow.fromWebContents(I.sender)),x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{m&&I.sender.send(C.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=M;function n(I,d,f){const S=new p.Menu;return f.forEach(b=>{let m;b.type==="separator"?m=new p.MenuItem({type:b.type}):Array.isArray(b.submenu)?m=new p.MenuItem({submenu:n(I,d,b.submenu),label:b.label}):m=new p.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(y,t,g)=>I.sender.send(d,b.id,g)}),S.append(m)}),S}});var de=this&&this.__decorate||function(j,e,p,D){var C=arguments.length,M=C<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,p):D,n;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,p,D);else for(var I=j.length-1;I>=0;I--)(n=j[I])&&(M=(C<3?n(M):C>3?n(e,p,M):n(e,p))||M);return C>3&&M&&Object.defineProperty(e,p,M),M};define(Z[36],x([0,1,30,9,17,23,46,16,4,2,110,25,13]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function($){$[$.Promise=100]="Promise",$[$.PromiseCancel=101]="PromiseCancel",$[$.EventListen=102]="EventListen",$[$.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function t($){switch($){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function($){$[$.Initialize=200]="Initialize",$[$.PromiseSuccess=201]="PromiseSuccess",$[$.PromiseError=202]="PromiseError",$[$.PromiseErrorObj=203]="PromiseErrorObj",$[$.EventFire=204]="EventFire"})(g=e.ResponseType||(e.ResponseType={}));function E($){switch($){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function($){$[$.Uninitialized=0]="Uninitialized",$[$.Idle=1]="Idle"})(v||(v={}));class P{constructor(K){this.buffer=K,this.pos=0}read(K){const ee=this.buffer.slice(this.pos,this.pos+K);return this.pos+=ee.byteLength,ee}}class c{constructor(){this.buffers=[]}get buffer(){return C.VSBuffer.concat(this.buffers)}write(K){this.buffers.push(K)}}var a;(function($){$[$.Undefined=0]="Undefined",$[$.String=1]="String",$[$.Buffer=2]="Buffer",$[$.VSBuffer=3]="VSBuffer",$[$.Array=4]="Array",$[$.Object=5]="Object"})(a||(a={}));function u($){const K=C.VSBuffer.alloc(4);return K.writeUInt32BE($,0),K}function s($){return $.read(4).readUInt32BE(0)}function l($){const K=C.VSBuffer.alloc(1);return K.writeUInt8($,0),K}const r={Undefined:l(a.Undefined),String:l(a.String),Buffer:l(a.Buffer),VSBuffer:l(a.VSBuffer),Array:l(a.Array),Object:l(a.Object)},i=typeof Buffer!="undefined";function o($,K){if(typeof K=="undefined")$.write(r.Undefined);else if(typeof K=="string"){const ee=C.VSBuffer.fromString(K);$.write(r.String),$.write(u(ee.byteLength)),$.write(ee)}else if(i&&Buffer.isBuffer(K)){const ee=C.VSBuffer.wrap(K);$.write(r.Buffer),$.write(u(ee.byteLength)),$.write(ee)}else if(K instanceof C.VSBuffer)$.write(r.VSBuffer),$.write(u(K.byteLength)),$.write(K);else if(Array.isArray(K)){$.write(r.Array),$.write(u(K.length));for(const ee of K)o($,ee)}else{const ee=C.VSBuffer.fromString(JSON.stringify(K));$.write(r.Object),$.write(u(ee.byteLength)),$.write(ee)}}function h($){switch($.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return $.read(s($)).toString();case a.Buffer:return $.read(s($)).buffer;case a.VSBuffer:return $.read(s($));case a.Array:{const ee=s($),B=[];for(let L=0;L<ee;L++)B.push(h($));return B}case a.Object:return JSON.parse($.read(s($)).toString())}}class w{constructor(K,ee,B=null,L=1e3){this.protocol=K,this.ctx=ee,this.logger=B,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(W=>this.onRawMessage(W)),this.sendResponse({type:200})}registerChannel(K,ee){this.channels.set(K,ee),setTimeout(()=>this.flushPendingRequests(K),0)}sendResponse(K){switch(K.type){case 200:{const ee=this.send([K.type]);this.logger&&this.logger.logOutgoing(ee,0,1,E(K.type));return}case 201:case 202:case 204:case 203:{const ee=this.send([K.type,K.id],K.data);this.logger&&this.logger.logOutgoing(ee,K.id,1,E(K.type),K.data);return}}}send(K,ee=void 0){const B=new c;return o(B,K),o(B,ee),this.sendBuffer(B.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch(ee){return 0}}onRawMessage(K){const ee=new P(K),B=h(ee),L=h(ee),W=B[0];switch(W){case 100:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}: ${B[2]}.${B[3]}`,L),this.onPromise({type:W,id:B[1],channelName:B[2],name:B[3],arg:L});case 102:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}: ${B[2]}.${B[3]}`,L),this.onEventListen({type:W,id:B[1],channelName:B[2],name:B[3],arg:L});case 101:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:B[1]});case 103:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],1,`${t(W)}`),this.disposeActiveRequest({type:W,id:B[1]})}}onPromise(K){const ee=this.channels.get(K.channelName);if(!ee){this.collectPendingRequest(K);return}const B=new M.CancellationTokenSource;let L;try{L=ee.call(this.ctx,K.name,K.arg,B.token)}catch(N){L=Promise.reject(N)}const W=K.id;L.then(N=>{this.sendResponse({id:W,data:N,type:201}),this.activeRequests.delete(K.id)},N=>{N instanceof Error?this.sendResponse({id:W,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.sendResponse({id:W,data:N,type:203}),this.activeRequests.delete(K.id)});const F=(0,f.toDisposable)(()=>B.cancel());this.activeRequests.set(K.id,F)}onEventListen(K){const ee=this.channels.get(K.channelName);if(!ee){this.collectPendingRequest(K);return}const B=K.id,W=ee.listen(this.ctx,K.name,K.arg)(F=>this.sendResponse({id:B,data:F,type:204}));this.activeRequests.set(K.id,W)}disposeActiveRequest(K){const ee=this.activeRequests.get(K.id);ee&&(ee.dispose(),this.activeRequests.delete(K.id))}collectPendingRequest(K){let ee=this.pendingRequests.get(K.channelName);ee||(ee=[],this.pendingRequests.set(K.channelName,ee));const B=setTimeout(()=>{console.error(`Unknown channel: ${K.channelName}`),K.type===100&&this.sendResponse({id:K.id,data:{name:"Unknown channel",message:`Channel name '${K.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);ee.push({request:K,timeoutTimer:B})}flushPendingRequests(K){const ee=this.pendingRequests.get(K);if(ee){for(const B of ee)switch(clearTimeout(B.timeoutTimer),B.request.type){case 100:this.onPromise(B.request);break;case 102:this.onEventListen(B.request);break}this.pendingRequests.delete(K)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(K=>K.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var k;(function($){$[$.LocalSide=0]="LocalSide",$[$.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(K,ee=null){this.protocol=K,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(B=>this.onBuffer(B)),this.logger=ee}getChannel(K){const ee=this;return{call(B,L,W){return ee.isDisposed?Promise.reject(I.canceled()):ee.requestPromise(K,B,L,W)},listen(B,L){return ee.isDisposed?Promise.reject(I.canceled()):ee.requestEvent(K,B,L)}}}requestPromise(K,ee,B,L=M.CancellationToken.None){const W=this.lastRequestId++,N={id:W,type:100,channelName:K,name:ee,arg:B};if(L.isCancellationRequested)return Promise.reject(I.canceled());let V;return new Promise((z,te)=>{if(L.isCancellationRequested)return te(I.canceled());const re=()=>{const le=he=>{switch(he.type){case 201:this.handlers.delete(W),z(he.data);break;case 202:this.handlers.delete(W);const ge=new Error(he.data.message);ge.stack=he.data.stack,ge.name=he.data.name,te(ge);break;case 203:this.handlers.delete(W),te(he.data);break}};this.handlers.set(W,le),this.sendRequest(N)};let se=null;this.state===v.Idle?re():(se=(0,D.createCancelablePromise)(le=>this.whenInitialized()),se.then(()=>{se=null,re()}));const J=()=>{se?(se.cancel(),se=null):this.sendRequest({id:W,type:101}),te(I.canceled())},ce=L.onCancellationRequested(J);V=(0,f.combinedDisposable)((0,f.toDisposable)(J),ce),this.activeRequests.add(V)}).finally(()=>{this.activeRequests.delete(V)})}requestEvent(K,ee,B){const L=this.lastRequestId++,F={id:L,type:102,channelName:K,name:ee,arg:B};let N=null;const V=new d.Emitter({onFirstListenerAdd:()=>{N=(0,D.createCancelablePromise)(z=>this.whenInitialized()),N.then(()=>{N=null,this.activeRequests.add(V),this.sendRequest(F)})},onLastListenerRemove:()=>{N?(N.cancel(),N=null):(this.activeRequests.delete(V),this.sendRequest({id:L,type:103}))}}),U=z=>V.fire(z.data);return this.handlers.set(L,U),V.event}sendRequest(K){switch(K.type){case 100:case 102:{const ee=this.send([K.type,K.id,K.channelName,K.name],K.arg);this.logger&&this.logger.logOutgoing(ee,K.id,0,`${t(K.type)}: ${K.channelName}.${K.name}`,K.arg);return}case 101:case 103:{const ee=this.send([K.type,K.id]);this.logger&&this.logger.logOutgoing(ee,K.id,0,t(K.type));return}}}send(K,ee=void 0){const B=new c;return o(B,K),o(B,ee),this.sendBuffer(B.buffer)}sendBuffer(K){try{return this.protocol.send(K),K.byteLength}catch(ee){return 0}}onBuffer(K){const ee=new P(K),B=h(ee),L=h(ee),W=B[0];switch(W){case 200:return this.logger&&this.logger.logIncoming(K.byteLength,0,0,E(W)),this.onResponse({type:B[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(K.byteLength,B[1],0,E(W),L),this.onResponse({type:B[0],id:B[1],data:L})}}onResponse(K){if(K.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const ee=this.handlers.get(K.id);ee&&ee(K)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(K=>K.dispose()),this.activeRequests.clear()}}de([n.memoize],A.prototype,"onDidInitializePromise",null),e.ChannelClient=A;class R{constructor(K){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,K(({protocol:ee,onDidClientDisconnect:B})=>{d.Event.once(ee.onMessage)(W=>{const F=new P(W),N=h(F),V=new w(ee,N),U=new A(ee);this.channels.forEach((te,re)=>V.registerChannel(re,te));const z={channelServer:V,channelClient:U,ctx:N};this._connections.add(z),this._onDidAddConnection.fire(z),B(()=>{V.dispose(),U.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const K=[];return this._connections.forEach(ee=>K.push(ee)),K}getChannel(K,ee){const B=this;return{call(L,W,F){let N;if((0,m.isFunction)(ee)){let U=(0,p.getRandomElement)(B.connections.filter(ee));N=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(B.onDidAddConnection,ee))}else N=ee.routeCall(B,L,W);const V=N.then(U=>U.channelClient.getChannel(K));return _(V).call(L,W,F)},listen(L,W){if((0,m.isFunction)(ee))return B.getMulticastEvent(K,ee,L,W);const F=ee.routeEvent(B,L,W).then(N=>N.channelClient.getChannel(K));return _(F).listen(L,W)}}}getMulticastEvent(K,ee,B,L){const W=this;let F=new f.DisposableStore;const N=new d.Emitter({onFirstListenerAdd:()=>{F=new f.DisposableStore;const V=new d.EventMultiplexer,U=new Map,z=re=>{const J=re.channelClient.getChannel(K).listen(B,L),ce=V.add(J);U.set(re,ce)},te=re=>{const se=U.get(re);!se||(se.dispose(),U.delete(re))};W.connections.filter(ee).forEach(z),d.Event.filter(W.onDidAddConnection,ee)(z,void 0,F),W.onDidRemoveConnection(te,void 0,F),V.event(N.fire,N,F),F.add(V)},onLastListenerRemove:()=>{F.dispose()}});return N.event}registerChannel(K,ee){this.channels.set(K,ee),this._connections.forEach(B=>{B.channelServer.registerChannel(K,ee)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class T{constructor(K,ee,B=null){const L=new c;o(L,ee),K.send(L.buffer),this.channelClient=new A(K,B),this.channelServer=new w(K,ee,B)}getChannel(K){return this.channelClient.getChannel(K)}registerChannel(K,ee){this.channelServer.registerChannel(K,ee)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function _($){return{call(K,ee,B){return $.then(L=>L.call(K,ee,B))},listen(K,ee){const B=new d.Relay;return $.then(L=>B.input=L.listen(K,ee)),B.event}}}e.getDelayedChannel=_;function Q($){let K=!1;return{call(ee,B,L){return K?$.call(ee,B,L):(0,D.timeout)(0).then(()=>K=!0).then(()=>$.call(ee,B,L))},listen(ee,B){if(K)return $.listen(ee,B);const L=new d.Relay;return(0,D.timeout)(0).then(()=>K=!0).then(()=>L.input=$.listen(ee,B)),L.event}}}e.getNextTickChannel=Q;class ne{constructor(K){this.fn=K}routeCall(K){return this.route(K)}routeEvent(K){return this.route(K)}async route(K){for(const ee of K.connections)if(await Promise.resolve(this.fn(ee.ctx)))return Promise.resolve(ee);return await d.Event.toPromise(K.onDidAddConnection),await this.route(K)}}e.StaticRouter=ne;var oe;(function($){function K(W,F){const N=W,V=F&&F.disableMarshalling,U=new Map;for(const z in N)B(z)&&U.set(z,d.Event.buffer(N[z],!0));return new class{listen(z,te,re){const se=U.get(te);if(se)return se;if(L(te)){const J=N[te];if(typeof J=="function")return J.call(N,re)}throw new Error(`Event not found: ${te}`)}call(z,te,re){const se=N[te];if(typeof se=="function"){if(!V&&Array.isArray(re))for(let J=0;J<re.length;J++)re[J]=(0,S.revive)(re[J]);return se.apply(N,re)}throw new Error(`Method not found: ${te}`)}}}$.fromService=K;function ee(W,F){const N=F&&F.disableMarshalling;return new Proxy({},{get(V,U){if(typeof U=="string")return F?.properties?.has(U)?F.properties.get(U):L(U)?function(z){return W.listen(U,z)}:B(U)?W.listen(U):async function(...z){let te;F&&!(0,m.isUndefinedOrNull)(F.context)?te=[F.context,...z]:te=z;const re=await W.call(U,te);return N?re:(0,S.revive)(re)};throw new Error(`Property not found: ${String(U)}`)}})}$.toService=ee;function B(W){return W[0]==="o"&&W[1]==="n"&&b.isUpperAsciiLetter(W.charCodeAt(2))}function L(W){return/^onDynamic/.test(W)&&b.isUpperAsciiLetter(W.charCodeAt(9))}})(oe=e.ProxyChannel||(e.ProxyChannel={}));const X=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function O($){if(Array.isArray($))return $;if($&&typeof $=="object"&&typeof $.toString=="function"){let K=$.toString();if(K!=="[object Object]")return K}return $}function H($){return Array.isArray($)?$.map(O):O($)}function q($,K,ee,B,L,W,F){F=H(F);const N=X[L],V=N[B%N.length];let U=[`%c[${$}]%c[${String(K).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(B).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test(W)?(U=U.concat(F),U.push(")")):U.push(F),console.log.apply(console,U)}e.logWithColors=q;class Y{constructor(K,ee){this._outgoingPrefix=K,this._incomingPrefix=ee,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(K,ee,B,L,W){this._totalOutgoing+=K,q(this._outgoingPrefix,this._totalOutgoing,K,ee,B,L,W)}logIncoming(K,ee,B,L,W){this._totalIncoming+=K,q(this._incomingPrefix,this._totalIncoming,K,ee,B,L,W)}}e.IPCLogger=Y}),define(Z[122],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(C,M){this.sender=C,this.onMessage=M}send(C){try{this.sender.send("vscode:message",C.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Z[123],x([0,1,17,4,36]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(d){this.port=d,this.onMessage=D.Event.fromDOMEventEmitter(this.port,"message",f=>p.VSBuffer.wrap(f.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class n extends C.IPCClient{constructor(d,f){const S=new M(d);super(S,f);this.protocol=S}dispose(){this.protocol.disconnect()}}e.Client=n}),define(Z[84],x([0,1,17,4,2,36]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var n;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(n=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var I;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let h=0;function w(A,R){if(!o.has(A)){const T=String(++h);o.set(A,T)}return o.get(A)}function k(A,R,T,_){if(!i.enableDiagnostics)return;const Q=w(A,R);if(_ instanceof p.VSBuffer||_ instanceof Uint8Array||_ instanceof ArrayBuffer||ArrayBuffer.isView(_)){const ne=p.VSBuffer.alloc(_.byteLength);ne.set(_),i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,buff:ne})}else i.records.push({timestamp:Date.now(),id:Q,label:R,type:T,data:_})}i.traceSocketEvent=k})(I=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let f=null;function S(){return f||(f=p.VSBuffer.alloc(0)),f}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,h){if(o===0)return S();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return h&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return h&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}let w=p.VSBuffer.alloc(o),k=0,A=0;for(;o>0;){const R=this._chunks[A];if(R.byteLength>o){const T=R.slice(0,o);w.set(T,k),k+=o,h&&(this._chunks[A]=R.slice(o),this._totalLength-=o),o-=o}else w.set(R,k),k+=R.byteLength,h?(this._chunks.shift(),this._totalLength-=R.byteLength):A++,o-=R.byteLength}return w}}e.ChunkStream=b;var m;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(m||(m={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var t;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(t=e.ProtocolConstants||(e.ProtocolConstants={}));class g{constructor(o,h,w,k){this.type=o,this.id=h,this.ack=w,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class E extends C.Disposable{constructor(o){super();this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(h=>this.acceptChunk(h))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const h=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=h.readUInt32BE(9),this._state.messageType=h.readUInt8(0),this._state.id=h.readUInt32BE(1),this._state.ack=h.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const w=this._state.messageType,k=this._state.id,A=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",h),this._onMessage.fire(new g(w,k,A,h)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class v{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const h=p.VSBuffer.alloc(13);h.writeUInt8(o.type,0),h.writeUInt32BE(o.id,1),h.writeUInt32BE(o.ack,5),h.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(h,o.data)}_bufferAdd(o,h){const w=this._totalLength===0;return this._data.push(o,h),this._totalLength+=o.byteLength+h.byteLength,w}_bufferTake(){const o=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,h){this._bufferAdd(o,h)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class P extends C.Disposable{constructor(o){super();this._onMessage=new D.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new D.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new v(this._socket)),this._socketReader=this._register(new E(this._socket)),this._register(this._socketReader.onMessage(h=>{h.type===1&&this._onMessage.fire(h.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new g(1,0,0,o))}}e.Protocol=P;class c extends M.IPCClient{constructor(o,h,w=null){super(o,h,w);this.protocol=o}static fromSocket(o,h){return new c(new P(o),h)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new D.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class u{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],h=0,w=this._first;for(;w;)o[h++]=w.data,w=w.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const h=new u(o);if(!this._first){this._first=h,this._last=h;return}this._last.next=h,this._last=h}}class l{constructor(){this.lastRuns=[];const o=Date.now();for(let h=0;h<l._HISTORY_LENGTH;h++)this.lastRuns[h]=o-1e3*h;setInterval(()=>{for(let h=l._HISTORY_LENGTH;h>=1;h--)this.lastRuns[h]=this.lastRuns[h-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return l._INSTANCE||(l._INSTANCE=new l),l._INSTANCE}load(){const o=Date.now(),h=(1+l._HISTORY_LENGTH)*1e3;let w=0;for(let k=0;k<l._HISTORY_LENGTH;k++)o-this.lastRuns[k]<=h&&w++;return 1-w/l._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}l._HISTORY_LENGTH=10,l._INSTANCE=null;class r{constructor(o,h=null,w=l.getInstance()){this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=w,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(k=>this._receiveMessage(k))),this._socketDisposables.push(this._socket.onClose(k=>this._onSocketClose.fire(k))),h&&this._socketReader.acceptChunk(h)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,C.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new g(5,0,0,S());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new g(7,0,0,S());this._socketWriter.write(o)}sendResume(){const o=new g(8,0,0,S());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,h){this._isReconnecting=!0,this._socketDisposables=(0,C.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new v(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new E(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),this._socketReader.acceptChunk(h)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,S());this._socketWriter.write(o);const h=this._outgoingUnackMsg.toArray();for(let w=0,k=h.length;w<k;w++)this._socketWriter.write(h[w]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const h=this._outgoingUnackMsg.peek();if(h&&h.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const h=Date.now();h-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=h,this._socketWriter.write(new g(6,0,0,S())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const h=this._outgoingUnackMsg.toArray();for(let w=0,k=h.length;w<k;w++)this._socketWriter.write(h[w]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const h=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const w=new g(1,h,this._incomingAckId,o);this._outgoingUnackMsg.push(w),this._isReconnecting||(this._socketWriter.write(w),this._recvAckCheck())}sendControl(o){const h=new g(2,0,0,o);this._socketWriter.write(h)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),h=Date.now()-o.writtenTime,w=Date.now()-this._socketReader.lastReadTime,k=Date.now()-this._lastSocketTimeoutTime;if(h>=2e4&&w>=2e4&&k>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const A=Math.max(2e4-h,2e4-w,2e4-k,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},A)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new g(3,0,this._incomingAckId,S());this._socketWriter.write(o)}}e.PersistentProtocol=r}),define(Z[124],x([0,1,14,17,4,2,36,122]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(S,b){const m=C.Event.fromNodeEventEmitter(p.ipcMain,b,(t,g)=>({event:t,message:g})),y=C.Event.filter(m,({event:t})=>t.sender.id===S);return C.Event.map(y,({message:t})=>t&&D.VSBuffer.wrap(t))}class f extends n.IPCServer{constructor(){super(f.getOnDidClientConnect())}static getOnDidClientConnect(){const b=C.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:m})=>m);return C.Event.map(b,m=>{const y=m.id,t=f.Clients.get(y);t&&t.dispose();const g=new C.Emitter;f.Clients.set(y,(0,M.toDisposable)(()=>g.fire()));const E=d(y,"vscode:message"),v=C.Event.any(C.Event.signal(d(y,"vscode:disconnect")),g.event);return{protocol:new I.Protocol(m,E),onDidClientDisconnect:v}})}}e.Server=f,f.Clients=new Map}),define(Z[85],x([0,1,14,4,31,123]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class n extends M.Client{constructor(f,S){super({addEventListener:(b,m)=>f.addListener(b,m),removeEventListener:(b,m)=>f.removeListener(b,m),postMessage:b=>f.postMessage(b),start:()=>f.start(),close:()=>f.close()},S)}}e.Client=n;async function I(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const f=(0,C.generateUuid)();d.webContents.send("vscode:createMessageChannel",f);const S=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(m,y)=>({nonce:y,port:m.ports[0]})),{port:b}=await D.Event.toPromise(D.Event.once(D.Event.filter(S,m=>m.nonce===f)));return b}e.connect=I}),define(Z[86],x([0,1,9,4,2,13]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var n;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(n=e.StorageHint||(e.StorageHint={}));function I(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=I;var d;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(d||(d={}));class f extends C.Disposable{constructor(m,y=Object.create(null)){super();this.database=m,this.options=y,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(f.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((y,t)=>this.accept(t,y)),m.deleted?.forEach(y=>this.accept(y,void 0))}accept(m,y){if(this.state===d.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(y)?t=this.cache.delete(m):this.cache.get(m)!==y&&(this.cache.set(m,y),t=!0),t&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==n.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,y){const t=this.cache.get(m);return(0,M.isUndefinedOrNull)(t)?y:t}getBoolean(m,y){const t=this.get(m);return(0,M.isUndefinedOrNull)(t)?y:t==="true"}getNumber(m,y){const t=this.get(m);return(0,M.isUndefinedOrNull)(t)?y:parseInt(t,10)}async set(m,y){if(this.state===d.Closed)return;if((0,M.isUndefinedOrNull)(y))return this.delete(m);const t=String(y);if(this.cache.get(m)!==t)return this.cache.set(m,t),this.pendingInserts.set(m,t),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async delete(m){if(!(this.state===d.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(m){if(!!this.hasPending)return this.doFlush(m)}async doFlush(m){return this.flushDelayer.trigger(()=>this.flushPending(),m)}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=f,f.DEFAULT_FLUSH_DELAY=100;class S{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((y,t)=>this.items.set(t,y)),m.delete&&m.delete.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=S}),define(Z[125],x([0,1,9,4,39,8,21]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class I{constructor(S,b=Object.create(null)){this.path=S,this.options=b,this.name=(0,M.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return D.Event.None}async getItems(){const S=await this.whenConnected,b=new Map;return(await this.all(S,"SELECT * FROM ItemTable")).forEach(y=>b.set(y.key,y.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${b.size} rows`),b}async updateItems(S){const b=await this.whenConnected;return this.doUpdateItems(b,S)}doUpdateItems(S,b){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${b.insert?(0,C.mapToString)(b.insert):"0"}), delete(${b.delete?(0,C.setToString)(b.delete):"0"})`),this.transaction(S,()=>{const m=b.insert,y=b.delete;if(m&&m.size>0){const t=[];t.push([]);let g=0;m.forEach((E,v)=>{let P=t[g];P.length>I.MAX_HOST_PARAMETERS&&(g++,P=[],t.push(P)),P.push(v,E)}),t.forEach(E=>{this.prepare(S,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,v=>v.run(E),()=>{const v=[];let P=0;return m.forEach((c,a)=>{v.push(a),P+=c.length}),`Keys: ${v.join(", ")} Length: ${P}`})})}if(y&&y.size){const t=[];t.push([]);let g=0;y.forEach(E=>{let v=t[g];v.length>I.MAX_HOST_PARAMETERS&&(g++,v=[],t.push(v)),v.push(E)}),t.forEach(E=>{this.prepare(S,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,v=>v.run(E),()=>{const v=[];return y.forEach(P=>{v.push(P)}),`Keys: ${v.join(", ")}`})})}})}async close(S){this.logger.trace(`[storage ${this.name}] close()`);const b=await this.whenConnected;return this.doClose(b,S)}doClose(S,b){return new Promise((m,y)=>{S.db.close(t=>(t&&this.handleSQLiteError(S,`[storage ${this.name}] close(): ${t}`),this.path===I.IN_MEMORY_PATH?m():!S.isErroneous&&!S.isInMemory?this.backup().then(m,g=>(this.logger.error(`[storage ${this.name}] backup(): ${g}`),m())):typeof b=="function"?n.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(g=>{const E=()=>this.doClose(g,void 0);return this.doUpdateItems(g,{insert:b()}).then(()=>E(),v=>(E(),Promise.reject(v)))})).then(m,y):y(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const S=this.toBackupPath(this.path);return n.Promises.copy(this.path,S,{preserveSymlinks:!1})}toBackupPath(S){return`${S}.backup`}async checkIntegrity(S){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${S})`);const b=await this.whenConnected,m=await this.get(b,S?"PRAGMA integrity_check":"PRAGMA quick_check"),y=S?m.integrity_check:m.quick_check;return b.isErroneous?`${y} (last error: ${b.lastError})`:b.isInMemory?`${y} (in-memory!)`:y}async connect(S,b=!0){this.logger.trace(`[storage ${this.name}] open(${S}, retryOnBusy: ${b})`);try{return await this.doConnect(S)}catch(m){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${m}`),m.code==="SQLITE_BUSY"&&b)return await(0,p.timeout)(I.BUSY_OPEN_TIMEOUT),this.connect(S,!1);try{await n.Promises.unlink(S);try{await n.Promises.rename(this.toBackupPath(S),S)}catch(y){}return await this.doConnect(S)}catch(y){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${y}`),this.doConnect(I.IN_MEMORY_PATH)}}}handleSQLiteError(S,b){S.isErroneous=!0,S.lastError=b,this.logger.error(b)}doConnect(S){return new Promise((b,m)=>{new Promise((y,t)=>{j(["@vscode/sqlite3"],y,t)}).then(y=>{const t={db:new(this.logger.isTracing?y.verbose().Database:y.Database)(S,g=>g?t.db?t.db.close(()=>m(g)):m(g):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(t),E=>t.db.close(()=>m(E)))),isInMemory:S===I.IN_MEMORY_PATH};t.db.on("error",g=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${g}`)),this.logger.isTracing&&t.db.on("trace",g=>this.logger.trace(`[storage ${this.name}] Trace (event): ${g}`))},m)})}exec(S,b){return new Promise((m,y)=>{S.db.exec(b,t=>t?(this.handleSQLiteError(S,`[storage ${this.name}] exec(): ${t}`),y(t)):m())})}get(S,b){return new Promise((m,y)=>{S.db.get(b,(t,g)=>t?(this.handleSQLiteError(S,`[storage ${this.name}] get(): ${t}`),y(t)):m(g))})}all(S,b){return new Promise((m,y)=>{S.db.all(b,(t,g)=>t?(this.handleSQLiteError(S,`[storage ${this.name}] all(): ${t}`),y(t)):m(g))})}transaction(S,b){return new Promise((m,y)=>{S.db.serialize(()=>{S.db.run("BEGIN TRANSACTION"),b(),S.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(S,`[storage ${this.name}] transaction(): ${t}`),y(t)):m())})})}prepare(S,b,m,y){const t=S.db.prepare(b),g=E=>{this.handleSQLiteError(S,`[storage ${this.name}] prepare(): ${E} (${b}). Details: ${y()}`)};t.on("error",g),m(t),t.finalize(E=>{E&&g(E),t.removeListener("error",g)})}}e.SQLiteStorageDatabase=I,I.IN_MEMORY_PATH=":memory:",I.BUSY_OPEN_TIMEOUT=2e3,I.MAX_HOST_PARAMETERS=256;class d{constructor(S){S&&typeof S.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=S.logTrace),S&&typeof S.logError=="function"&&(this.logError=S.logError)}get isTracing(){return!!this.logTrace}trace(S){this.logTrace&&this.logTrace(S)}error(S){this.logError&&this.logError(S)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Z[126],x([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Z[127],x([0,1,126]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const D=60,C=D*60,M=C*24,n=M*7,I=M*30,d=M*365;function f(b,m){typeof b!="number"&&(b=b.getTime());const y=Math.round((new Date().getTime()-b)/1e3);if(y<-30)return(0,p.localize)(0,null,f(new Date().getTime()+y*1e3,!1));if(y<30)return(0,p.localize)(1,null);let t;return y<D?(t=y,m?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):y<C?(t=Math.floor(y/D),m?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):y<M?(t=Math.floor(y/C),m?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):y<n?(t=Math.floor(y/M),m?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):y<I?(t=Math.floor(y/n),m?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):y<d?(t=Math.floor(y/I),m?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(y/d),m?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=f;function S(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=S}),define(Z[128],x([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Z[44],x([0,1,30,13,128]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(f,S){return S&&(f.stack||f.stacktrace)?C.localize(0,null,I(f),n(f.stack)||n(f.stacktrace)):I(f)}function n(f){return Array.isArray(f)?f.join(`
`):f}function I(f){return typeof f.code=="string"&&typeof f.errno=="number"&&typeof f.syscall=="string"?C.localize(1,null,f.message):f.message||C.localize(2,null)}function d(f=null,S=!1){if(!f)return C.localize(3,null);if(Array.isArray(f)){const b=p.coalesce(f),m=d(b[0],S);return b.length>1?C.localize(4,null,m,b.length):m}if(D.isString(f))return f;if(f.detail){const b=f.detail;if(b.error)return M(b.error,S);if(b.exception)return M(b.exception,S)}return f.stack?M(f,S):f.message?f.message:C.localize(5,null)}e.toErrorMessage=d}),define(Z[129],x([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Z[130],x([0,1,129]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class D{constructor(n,I,d=I){this.modifierLabels=[null],this.modifierLabels[2]=n,this.modifierLabels[1]=I,this.modifierLabels[3]=d}toLabel(n,I,d){if(I.length===0)return null;const f=[];for(let S=0,b=I.length;S<b;S++){const m=I[S],y=d(m);if(y===null)return null;f[S]=C(m,y,this.modifierLabels[n])}return f.join(" ")}}e.ModifierLabelProvider=D,e.UILabelProvider=new D({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new D({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new D({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new D({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function C(M,n,I){if(n===null)return"";const d=[];return M.ctrlKey&&d.push(I.ctrlKey),M.shiftKey&&d.push(I.shiftKey),M.altKey&&d.push(I.altKey),M.metaKey&&d.push(I.metaKey),n!==""&&d.push(n),d.join(I.separator)}}),define(Z[131],x([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Z[72],x([0,1,43,32,10,47,8,3,34,80,13,114,21,131]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return f.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return f.TerminateResponseCode}});function t(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function g(s,l){if(I.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};l&&(r.cwd=l);const i=p.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(o=>{i.once("error",h=>{o({success:!1,error:h})}),i.once("exit",(h,w)=>{o(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?t(r.status):1})}else if(I.isLinux||I.isMacintosh)try{const r=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(i=>{p.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,h,w)=>{i(o?{success:!1,error:o}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function E(s){!s||(delete s.DEBUG,I.isMacintosh&&delete s.DYLD_LIBRARY_PATH,I.isLinux&&delete s.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function v(s=d.env){return s.comspec||"cmd.exe"}e.getWindowsShell=v;class P{constructor(l,r,i,o){if(r!==void 0&&i!==void 0&&o!==void 0)this.cmd=l,this.args=r,this.shell=i,this.options=o;else{const h=l;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(d.env).forEach(w=>{h[w]=d.env[w]}),Object.keys(this.options.env).forEach(w=>{h[w]=this.options.env[w]}),this.options.env=h}}getSanitizedCommand(){let l=this.cmd.toLowerCase();const r=l.lastIndexOf(n.sep);return r!==-1&&(l=l.substring(r+1)),P.WellKnowCommands[l]?l:"other"}start(l){return I.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(d.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(r=>{let i,o;const h=new Promise((w,k)=>{i=w,o=k});if(r){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=p.exec(w,this.options,(k,A,R)=>{this.childProcess=null;const T=k;T&&T.killed?o({killed:this.terminateRequested,stdout:A.toString(),stderr:R.toString()}):this.handleExec(i,l,k,A,R)})}else{let w=null;const k=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,i,l,o);const R={terminated:this.terminateRequested};S.isNumber(A)&&(R.cmdCode=A),i(R)};if(this.shell&&I.isWindows){const A=M.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let R=!1,T=!1;const _=[];let Q=this.ensureQuotes(this.cmd);_.push(Q.value),R=Q.quoted,this.args&&this.args.forEach(oe=>{Q=this.ensureQuotes(oe),_.push(Q.value),T=T&&Q.quoted});const ne=["/s","/c"];R?T?ne.push('"'+_.join(" ")+'"'):_.length>1?ne.push('"'+_[0]+'" '+_.slice(1).join(" ")):ne.push('"'+_[0]+'"'):ne.push(_.join(" ")),w=p.spawn(v(),ne,A)}else this.cmd&&(w=p.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(S.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",A=>{this.childProcess=null,o({terminated:this.terminateRequested,error:A})}),w.pid&&(this.childProcess.on("close",k),this.handleSpawn(w,i,l,o,!0)))}return h})}handleClose(l,r,i,o){}ensureQuotes(l){return P.regexp.test(l)?{value:'"'+l+'"',quoted:!0}:{value:l,quoted:l.length>0&&l[0]==='"'&&l[l.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(l=>l.pid,l=>-1):new Promise(l=>{this.pidResolve=l})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(l=>(this.terminateRequested=!0,g(l,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),l=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(l=>{if(!this.shell||!I.isWindows)return l(!1);const r=p.spawn(v(),["/s","/c"]);r.on("error",i=>l(!0)),r.on("exit",i=>l(!1))})}}e.AbstractProcess=P,P.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},P.regexp=/^[^"].* .*[^"]/;class c extends P{constructor(l,r,i,o){super(l,r,i,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(l,r,i,o,h){[o,h].forEach((w,k)=>{const A=new b.LineDecoder;A.write(w).forEach(_=>{r({line:_,source:k===0?0:1})});const T=A.end();T&&r({line:T,source:k===0?0:1})}),l({terminated:this.terminateRequested,error:i})}handleSpawn(l,r,i,o,h){const w=new b.LineDecoder,k=new b.LineDecoder;l.stdout.on("data",A=>{w.write(A).forEach(T=>i({line:T,source:0}))}),l.stderr.on("data",A=>{k.write(A).forEach(T=>i({line:T,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=k}handleClose(l,r,i,o){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&i({line:h,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&i({line:w,source:1})}}e.LineProcess=c;function a(s){let l=[],r=!1;const i=function(o){if(r){l.push(o);return}(!s.send(o,w=>{if(w&&console.error(w),r=!1,l.length>0){const k=l.slice(0);l=[],k.forEach(A=>i(A))}})||I.isWindows)&&(r=!0)};return{send:i}}e.createQueuedSender=a;var u;(function(s){async function l(r,i,o){if(n.isAbsolute(r))return r;if(i===void 0&&(i=d.cwd()),n.dirname(r)!=="."||(o===void 0&&S.isString(d.env.PATH)&&(o=d.env.PATH.split(n.delimiter)),o===void 0||o.length===0))return n.join(i,r);async function w(k){if(await m.Promises.exists(k)){let A;try{A=await m.Promises.stat(k)}catch(R){R.message.startsWith("EACCES")&&(A=await m.Promises.lstat(k))}return A?!A.isDirectory():!1}return!1}for(let k of o){let A;if(n.isAbsolute(k)?A=n.join(k,r):A=n.join(i,k,r),await w(A))return A;let R=A+".com";if(await w(R)||(R=A+".exe",await w(R)))return R}return n.join(i,r)}s.findExecutable=l})(u=e.win32||(e.win32={}))}),define(Z[132],x([0,1,26,3,118,72]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function n(y,t){return y===1?D.isWindows?b():M.getWindowsShell(t):f(y,t)}e.getSystemShell=n;function I(y,t){return y===1?D.isWindows?m(t):M.getWindowsShell(t):f(y,t)}e.getSystemShellSync=I;let d=null;function f(y,t){if(D.isLinux&&y===2||D.isMacintosh&&y===3)return"/bin/bash";if(!d){let g;if(D.isWindows)g="/bin/bash";else{if(g=t.SHELL,!g)try{g=(0,p.userInfo)().shell}catch(E){}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}d=g}return d}let S=null;async function b(){return S||(S=(await(0,C.getFirstAvailablePowerShellInstallation)()).exePath),S}function m(y){if(S)return S;const t=D.isWindows&&parseFloat((0,p.release)())>=10,g=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${y.windir}\\${g?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?E:M.getWindowsShell(y)}}),define(Z[133],x([0,1,43,9,17,23,109,16,4,2,47,72,36]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends m.ChannelServer{constructor(E){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(P){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",v=>C.VSBuffer.wrap(Buffer.from(v,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=y;class t{constructor(E,v){this.modulePath=E,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const P=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new D.Delayer(P),this.child=null,this._client=null}getChannel(E){const v=this;return{call(P,c,a){return v.requestPromise(E,P,c,a)},listen(P,c){return v.requestEvent(E,P,c)}}}requestPromise(E,v,P,c=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(I.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(E),u=(0,D.createCancelablePromise)(r=>a.call(v,P,r)),s=c.onCancellationRequested(()=>u.cancel()),l=(0,f.toDisposable)(()=>u.cancel());return this.activeRequests.add(l),u.finally(()=>{s.dispose(),this.activeRequests.delete(l),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),u}requestEvent(E,v,P){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let c;const a=new d.Emitter({onFirstListenerAdd:()=>{c=this.getCachedChannel(E).listen(v,P)(a.fire,a),this.activeRequests.add(c)},onLastListenerRemove:()=>{this.activeRequests.delete(c),c.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,S.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(i=>!/^--inspect(-brk)?=/.test(i))),(0,b.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,E,v);const P=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",i=>i)(i=>{if((0,n.isRemoteConsoleLog)(i)){(0,n.log)(i,`IPC Library: ${this.options.serverName}`);return}P.fire(C.VSBuffer.wrap(Buffer.from(i,"base64")))});const a=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,u=i=>this.child&&this.child.connected&&a.send(i.buffer.toString("base64")),s=P.event,l={send:u,onMessage:s};this._client=new m.ChannelClient(l);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",i=>console.warn('IPC "'+this.options.serverName+'" errored with '+i)),this.child.on("exit",(i,o)=>{process.removeListener("exit",r),this.activeRequests.forEach(h=>(0,f.dispose)(h)),this.activeRequests.clear(),i!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+i+" and signal "+o),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:i,signal:o})})}return this._client}getCachedChannel(E){let v=this.channels.get(E);return v||(v=this.client.getChannel(E),this.channels.set(E,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Z[134],x([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Z[135],x([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[136],x([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Z[137],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Z[138],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Z[139],x([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Z[140],x([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[141],x([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[142],x([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Z[143],x([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Z[144],x([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Z[145],x([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Z[146],x([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderIpc",e)}),define(Z[147],x([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[148],x([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Z[149],x([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Z[150],x([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Z[151],x([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Z[152],x([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[153],x([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Z[154],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Z[155],x([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Z[156],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Z[157],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Z[158],x([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Z[159],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function p(D){return typeof D?.backupFolder=="string"}e.isEmptyWindowBackupInfo=p}),define(Z[160],x([0,1,4,2]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class C{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(I,d,f){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:f[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:f[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:f[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:f[0],port:f[1],subId:f[2]}))}throw new Error("Method not implemented.")}listen(I,d,f){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=C,C.ChannelName="extensionhostdebugservice";class M extends D.Disposable{constructor(I){super();this.channel=I}reload(I){this.channel.call("reload",[I])}get onReload(){return this.channel.listen("reload")}close(I){this.channel.call("close",[I])}get onClose(){return this.channel.listen("close")}attachSession(I,d,f){this.channel.call("attach",[I,d,f])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(I,d){this.channel.call("terminate",[I,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(I,d){return this.channel.call("openExtensionDevelopmentHostWindow",[I,d])}}e.ExtensionHostDebugChannelClient=M}),define(Z[161],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(n){this.driver=n}listen(n,I){throw new Error(`No event found: ${I}`)}call(n,I,d){switch(I){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${I}`)}}e.WindowDriverChannel=p;class D{constructor(n){this.channel=n}click(n,I,d){return this.channel.call("click",[n,I,d])}doubleClick(n){return this.channel.call("doubleClick",n)}setValue(n,I){return this.channel.call("setValue",[n,I])}getTitle(){return this.channel.call("getTitle")}isActiveElement(n){return this.channel.call("isActiveElement",n)}getElements(n,I){return this.channel.call("getElements",[n,I])}getElementXY(n,I,d){return this.channel.call("getElementXY",[n,I,d])}typeInEditor(n,I){return this.channel.call("typeInEditor",[n,I])}getTerminalBuffer(n){return this.channel.call("getTerminalBuffer",n)}writeInTerminal(n,I){return this.channel.call("writeInTerminal",[n,I])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=D;class C{constructor(n){this.channel=n}registerWindowDriver(n){return this.channel.call("registerWindowDriver",n)}reloadWindowDriver(n){return this.channel.call("reloadWindowDriver",n)}}e.WindowDriverRegistryChannelClient=C}),define(Z[162],x([0,1,127,46,10,8,34,15,7]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class f{constructor(g,E,v){this._args=g,this.paths=E,this.productService=v}get appRoot(){return(0,M.dirname)(C.FileAccess.asFileUri("",j).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,I.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const g=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",g)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.joinPath)(d.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,I.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=n.env.VSCODE_PORTABLE;return g?d.URI.file((0,M.join)(g,"argv.json")):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,I.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,M.resolve)(g):(0,M.normalize)((0,M.join)(C.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const g=this.args["extensions-download-dir"];return g?(0,M.resolve)(g):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,M.resolve)(g);const E=n.env.VSCODE_EXTENSIONS;if(E)return E;const v=n.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,I.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,M.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?d.URI.parse(g):d.URI.file((0,M.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return S(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!n.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,I.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([D.memoize],f.prototype,"appRoot",null),de([D.memoize],f.prototype,"userHome",null),de([D.memoize],f.prototype,"userDataPath",null),de([D.memoize],f.prototype,"appSettingsHome",null),de([D.memoize],f.prototype,"tmpDir",null),de([D.memoize],f.prototype,"cacheHome",null),de([D.memoize],f.prototype,"userRoamingDataHome",null),de([D.memoize],f.prototype,"settingsResource",null),de([D.memoize],f.prototype,"userDataSyncHome",null),de([D.memoize],f.prototype,"userDataSyncLogResource",null),de([D.memoize],f.prototype,"sync",null),de([D.memoize],f.prototype,"machineSettingsResource",null),de([D.memoize],f.prototype,"globalStorageHome",null),de([D.memoize],f.prototype,"workspaceStorageHome",null),de([D.memoize],f.prototype,"keybindingsResource",null),de([D.memoize],f.prototype,"keyboardLayoutResource",null),de([D.memoize],f.prototype,"argvResource",null),de([D.memoize],f.prototype,"snippetsHome",null),de([D.memoize],f.prototype,"isExtensionDevelopment",null),de([D.memoize],f.prototype,"untitledWorkspacesHome",null),de([D.memoize],f.prototype,"installSourcePath",null),de([D.memoize],f.prototype,"builtinExtensionsPath",null),de([D.memoize],f.prototype,"extensionsPath",null),de([D.memoize],f.prototype,"extensionDevelopmentLocationURI",null),de([D.memoize],f.prototype,"extensionDevelopmentKind",null),de([D.memoize],f.prototype,"extensionTestsLocationURI",null),de([D.memoize],f.prototype,"debugExtensionHost",null),de([D.memoize],f.prototype,"serviceMachineIdResource",null),de([D.memoize],f.prototype,"telemetryLogResource",null),de([D.memoize],f.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=f;function S(t,g){return y(t["inspect-extensions"],t["inspect-brk-extensions"],5870,g,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=S;function b(t,g){return y(t["inspect-search"],t["inspect-brk-search"],5876,g,t.extensionEnvironment)}e.parseSearchPort=b;function m(t,g){return y(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,g,t.extensionEnvironment)}e.parsePtyHostPort=m;function y(t,g,E,v,P,c){const u=Number(g||t)||(v?null:E),s=u?Boolean(!!g):!1;let l;if(c)try{l=JSON.parse(c)}catch{}return{port:u,break:s,debugId:P,env:l}}}),define(Z[87],x([0,1,246,3,137]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,C.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(14,null)},category:{type:"string",cat:"e",description:(0,C.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,C.localize)(16,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(18,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,C.localize)(19,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(20,null)},verbose:{type:"boolean",cat:"t",description:(0,C.localize)(21,null)},log:{type:"string",cat:"t",args:"level",description:(0,C.localize)(22,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(23,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(24,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,C.localize)(25,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,C.localize)(26,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(27,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,C.localize)(28,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,C.localize)(29,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(30,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,C.localize)(31,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(32,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const n={onUnknownOption:()=>{},onMultipleValues:()=>{},onDeprecatedOption:()=>{}};function I(t,g,E=n){const v={},P=[],c=[];for(let l in g){const r=g[l];r.alias&&(v[l]=r.alias),r.type==="string"||r.type==="string[]"?(P.push(l),r.deprecates&&P.push(r.deprecates)):r.type==="boolean"&&(c.push(l),r.deprecates&&c.push(r.deprecates))}const a=p(t,{string:P,boolean:c,alias:v}),u={},s=a;u._=a._.map(l=>String(l)).filter(l=>l.length>0),delete s._;for(let l in g){const r=g[l];r.alias&&delete s[r.alias];let i=s[l];r.deprecates&&s.hasOwnProperty(r.deprecates)&&(i||(i=s[r.deprecates],i&&E.onDeprecatedOption(r.deprecates,l)),delete s[r.deprecates]),typeof i!="undefined"&&(r.type==="string[]"?i&&!Array.isArray(i)&&(i=[i]):r.type==="string"&&Array.isArray(i)&&(i=i.pop(),E.onMultipleValues(l,i)),u[l]=i),delete s[l]}for(let l in s)E.onUnknownOption(l);return u}e.parseArgs=I;function d(t,g){let E="";return g.args&&(Array.isArray(g.args)?E=` <${g.args.join("> <")}>`:E=` <${g.args}>`),g.alias?`-${g.alias} --${t}${E}`:`--${t}${E}`}function f(t,g){let E=0,v=[];for(const u in t){const s=t[u],l=d(u,s);E=Math.max(E,l.length),v.push([l,s.description])}let P=E+2+1;if(g-P<25)return v.reduce((u,s)=>u.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);let c=g-P-1,a=[];for(const u of v){let s=u[0],l=b(u[1],c),r=S(P-s.length-2);a.push("  "+s+r+l[0]);for(let i=1;i<l.length;i++)a.push(S(P)+l[i])}return a}e.formatOptions=f;function S(t){return" ".repeat(t)}function b(t,g){let E=[];for(;t.length;){let v=t.length<g?t.length:t.lastIndexOf(" ",g),P=t.slice(0,v).trim();t=t.slice(v),E.push(P)}return E}function m(t,g,E,v,P){const c=process.stdout.isTTY&&process.stdout.columns||80,a=P?.noInputFiles!==!0?`[${(0,C.localize)(33,null)}...]`:"",u=[`${t} ${E}`];u.push(""),u.push(`${(0,C.localize)(34,null)}: ${g} [${(0,C.localize)(35,null)}]${a}`),u.push(""),P?.noPipe!==!0&&(D.isWindows?u.push((0,C.localize)(36,null,g)):u.push((0,C.localize)(37,null,g)),u.push(""));const s={};for(const l in v){const r=v[l];if(r.description&&r.cat){let i=s[r.cat];i||(s[r.cat]=i={}),i[l]=r}}for(let l in s){const r=l;let i=s[r];i&&(u.push(M[r]),u.push(...f(i,c)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=m;function y(t,g){return`${t||(0,C.localize)(38,null)}
${g||(0,C.localize)(39,null)}
${process.arch}`}e.buildVersionMessage=y}),define(Z[163],x([0,1,61,160,87]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends D.ExtensionHostDebugBroadcastChannel{constructor(I){super();this.windowsMainService=I}call(I,d,f){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(f[0],f[1]):super.call(I,d,f)}async openExtensionDevelopmentHostWindow(I,d){const f=(0,C.parseArgs)(I,C.OPTIONS);f.debugRenderer=d;const S=f.extensionDevelopmentPath;if(!S)return{success:!1};const[b]=this.windowsMainService.openExtensionDevelopmentHostWindow(S,{context:5,cli:f});if(!d)return{success:!0};const m=b.win;if(!m)return{success:!0};const y=m.webContents.debugger;let t=y.isAttached()?Infinity:0;const g=(0,p.createServer)(E=>{t++==0&&y.attach();let v=!1;const P=u=>{v||E.write(JSON.stringify(u)+"\0")},c=(u,s,l,r)=>P({method:s,params:l,sessionId:r});m.on("close",()=>{y.removeListener("message",c),E.end(),v=!0}),y.addListener("message",c);let a=Buffer.alloc(0);E.on("data",u=>{a=Buffer.concat([a,u]);for(let s=a.indexOf(0);s!==-1;s=a.indexOf(0)){let l;try{const r=a.slice(0,s).toString("utf8");a=a.slice(s+1),l=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}y.sendCommand(l.method,l.params,l.sessionId).then(r=>P({id:l.id,sessionId:l.sessionId,result:r})).catch(r=>P({id:l.id,sessionId:l.sessionId,error:{code:0,message:r.message}}))}}),E.on("error",u=>{console.error("error on cdp pipe:",u)}),E.on("close",()=>{v=!0,--t==0&&y.detach()})});return await new Promise(E=>g.listen(0,E)),m.on("close",()=>g.close()),{rendererDebugPort:g.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,p,D,C){function M(I){const d=n(I),f=[d];return e.isAbsolute(d)||f.unshift(C),e.resolve(...f)}function n(I){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let f=process.env.VSCODE_APPDATA;if(f)return e.join(f,D);const S=I["user-data-dir"];if(S)return S;switch(process.platform){case"win32":if(f=process.env.APPDATA,!f){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");f=e.join(b,"AppData","Roaming")}break;case"darwin":f=e.join(p.homedir(),"Library","Application Support");break;case"linux":f=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(f,D)}return{getUserDataPath:M}}if(typeof define=="function")define(Z[164],x([0,247,26,10,15,34]),function(e,p,D,C,M,n){const I=M.dirname(C.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(M.joinPath(I,"package.json").fsPath);return j(p,D,d.name,n.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),D=require("os");module.exports=j(p,D,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[165],x([0,1,26,162,164]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends D.AbstractNativeEnvironmentService{constructor(I,d){super(I,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,C.getUserDataPath)(I)},d)}}e.NativeEnvironmentService=M}),define(Z[166],x([0,1,27,26,8]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(n){const I=(0,C.join)((0,D.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(I,""),n&&console.log(`Marker file for --wait created: ${I}`),I}catch(d){n&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=M}),define(Z[167],x([0,1,141]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function M(m){return m=m.trim(),m==="*"||D.test(m)}e.isValidVersionStr=M;function n(m){if(!M(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=m.match(D);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}e.parseVersion=n;function I(m){if(!m)return null;let y=m.majorBase,t=m.majorMustEqual,g=m.minorBase,E=m.minorMustEqual,v=m.patchBase,P=m.patchMustEqual;m.hasCaret&&(y===0||(E=!1),P=!1);let c=0;if(m.preRelease){const a=C.exec(m.preRelease);if(a){const[,u,s,l]=a;c=Date.UTC(Number(u),Number(s)-1,Number(l))}}return{majorBase:y,majorMustEqual:t,minorBase:g,minorMustEqual:E,patchBase:v,patchMustEqual:P,isMinimum:m.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function d(m,y,t){let g;typeof m=="string"?g=I(n(m)):g=m;let E;y instanceof Date?E=y.getTime():typeof y=="string"&&(E=new Date(y).getTime());let v;if(typeof t=="string"?v=I(n(t)):v=t,!g||!v)return!1;let P=g.majorBase,c=g.minorBase,a=g.patchBase,u=v.majorBase,s=v.minorBase,l=v.patchBase,r=v.notBefore,i=v.majorMustEqual,o=v.minorMustEqual,h=v.patchMustEqual;return v.isMinimum?P>u?!0:P<u?!1:c>s?!0:c<s||E&&E<r?!1:a>=l:(P===1&&u===0&&(!i||!o||!h)&&(u=1,s=0,l=0,i=!0,o=!1,h=!1),P<u?!1:P>u?!i:c<s?!1:c>s?!o:a<l?!1:a>l?!h:!(E&&E<r))}e.isValidVersion=d;function f(m,y,t,g){return t.isBuiltin||typeof t.main=="undefined"?!0:b(m,y,t.engines.vscode,g)}e.isValidExtensionVersion=f;function S(m,y,t){return m==="*"||b(y,t,m)}e.isEngineValid=S;function b(m,y,t,g=[]){let E=I(n(t));if(!E)return g.push(p.localize(0,null,t)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return g.push(p.localize(1,null,t)),!1}else if(!E.majorMustEqual)return g.push(p.localize(2,null,t)),!1;return d(m,y,E)?!0:(g.push(p.localize(3,null,m,t)),!1)}}),define(Z[168],x([0,1,4,2,17,59,23]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProviderChannel=void 0;class I extends D.Disposable{constructor(f,S){super();this.provider=f,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(f,S,b){const m=this.getUriTransformer(f);switch(S){case"stat":return this.stat(m,b[0]);case"readdir":return this.readdir(m,b[0]);case"open":return this.open(m,b[0],b[1]);case"close":return this.close(b[0]);case"read":return this.read(b[0],b[1],b[2]);case"readFile":return this.readFile(m,b[0]);case"write":return this.write(b[0],b[1],b[2],b[3],b[4]);case"writeFile":return this.writeFile(m,b[0],b[1],b[2]);case"rename":return this.rename(m,b[0],b[1],b[2]);case"copy":return this.copy(m,b[0],b[1],b[2]);case"mkdir":return this.mkdir(m,b[0]);case"delete":return this.delete(m,b[0],b[1]);case"watch":return this.watch(m,b[0],b[1],b[2],b[3]);case"unwatch":return this.unwatch(b[0],b[1])}throw new Error(`IPC Command ${S} not found`)}listen(f,S,b){const m=this.getUriTransformer(f);switch(S){case"fileChange":return this.onFileChange(m,b[0]);case"readFileStream":return this.onReadFileStream(m,b[0],b[1])}throw new Error(`Unknown event ${S}`)}stat(f,S){const b=this.transformIncoming(f,S,!0);return this.provider.stat(b)}readdir(f,S){const b=this.transformIncoming(f,S);return this.provider.readdir(b)}async readFile(f,S){const b=this.transformIncoming(f,S,!0),m=await this.provider.readFile(b);return C.VSBuffer.wrap(m)}onReadFileStream(f,S,b){const m=this.transformIncoming(f,S,!0),y=new n.CancellationTokenSource,t=new p.Emitter({onLastListenerRemove:()=>{y.cancel()}}),g=this.provider.readFileStream(m,b,y.token);return(0,M.listenStream)(g,{onData:E=>t.fire(C.VSBuffer.wrap(E)),onError:E=>t.fire(E),onEnd:()=>{t.fire("end"),t.dispose(),y.dispose()}}),t.event}writeFile(f,S,b,m){const y=this.transformIncoming(f,S);return this.provider.writeFile(y,b.buffer,m)}open(f,S,b){const m=this.transformIncoming(f,S,!0);return this.provider.open(m,b)}close(f){return this.provider.close(f)}async read(f,S,b){const m=C.VSBuffer.alloc(b),y=0,t=await this.provider.read(f,S,m.buffer,y,b);return[m,t]}write(f,S,b,m,y){return this.provider.write(f,S,b.buffer,m,y)}mkdir(f,S){const b=this.transformIncoming(f,S);return this.provider.mkdir(b)}delete(f,S,b){const m=this.transformIncoming(f,S);return this.provider.delete(m,b)}rename(f,S,b,m){const y=this.transformIncoming(f,S),t=this.transformIncoming(f,b);return this.provider.rename(y,t,m)}copy(f,S,b,m){const y=this.transformIncoming(f,S),t=this.transformIncoming(f,b);return this.provider.copy(y,t,m)}onFileChange(f,S){const b=new p.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(f,b))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return b.event}async watch(f,S,b,m,y){const t=this.sessionToWatcher.get(S);if(t){const g=this.transformIncoming(f,m),E=t.watch(b,g,y);this.watchRequests.set(S+b,E)}}async unwatch(f,S){const b=f+S,m=this.watchRequests.get(b);m&&((0,D.dispose)(m),this.watchRequests.delete(b))}dispose(){super.dispose(),this.watchRequests.forEach(f=>(0,D.dispose)(f)),this.watchRequests.clear(),this.sessionToWatcher.forEach(f=>(0,D.dispose)(f)),this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=I}),define(Z[73],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(C,M=[],n=!1){this.ctor=C,this.staticArguments=M,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=p}),define(Z[169],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class D{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let n of this._nodes.values())n.outgoing.size===0&&M.push(n);return M}insertEdge(M,n){const I=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(n);I.outgoing.set(this._hashFn(n),d),d.incoming.set(this._hashFn(M),I)}removeNode(M){const n=this._hashFn(M);this._nodes.delete(n);for(let I of this._nodes.values())I.outgoing.delete(n),I.incoming.delete(n)}lookupOrInsertNode(M){const n=this._hashFn(M);let I=this._nodes.get(n);return I||(I=new p(M),this._nodes.set(n,I)),I}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[n,I]of this._nodes)M.push(`${n}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,n]of this._nodes){const I=new Set([M]),d=this._findCycle(n,I);if(d)return d}}_findCycle(M,n){for(let[I,d]of M.outgoing){if(n.has(I))return[...n,I].join(" -> ");n.add(I);const f=this._findCycle(d,n);if(f)return f;n.delete(I)}}}e.Graph=D}),define(Z[5],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function I(d){return d[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=I})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function D(n,I,d,f){I[p.DI_TARGET]===I?I[p.DI_DEPENDENCIES].push({id:n,index:d,optional:f}):(I[p.DI_DEPENDENCIES]=[{id:n,index:d,optional:f}],I[p.DI_TARGET]=I)}function C(n){if(p.serviceIds.has(n))return p.serviceIds.get(n);const I=function(d,f,S){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");D(I,d,S,!1)};return I.toString=()=>n,p.serviceIds.set(n,I),I}e.createDecorator=C;function M(n){return n}e.refineServiceDecorator=M}),define(Z[52],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService")}),define(Z[19],x([0,1,13,7,5]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,C.createDecorator)("configurationService");function M(E){return E&&typeof E=="object"&&(!E.overrideIdentifier||typeof E.overrideIdentifier=="string")&&(!E.resource||E.resource instanceof D.URI)}e.isConfigurationOverrides=M;function n(E){return E&&typeof E=="object"&&(!E.overrideIdentifiers||p.isArray(E.overrideIdentifiers))&&!E.overrideIdentifier&&(!E.resource||E.resource instanceof D.URI)}e.isConfigurationUpdateOverrides=n;var I;(function(E){E[E.USER=1]="USER",E[E.USER_LOCAL=2]="USER_LOCAL",E[E.USER_REMOTE=3]="USER_REMOTE",E[E.WORKSPACE=4]="WORKSPACE",E[E.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",E[E.DEFAULT=6]="DEFAULT",E[E.MEMORY=7]="MEMORY"})(I=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(E){switch(E){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=d;function f(E,v){const P=Object.create(null);for(let c in E)S(P,c,E[c],v);return P}e.toValuesTree=f;function S(E,v,P,c){const a=v.split("."),u=a.pop();let s=E;for(let l=0;l<a.length;l++){let r=a[l],i=s[r];switch(typeof i){case"undefined":i=s[r]=Object.create(null);break;case"object":break;default:c(`Ignoring ${v} as ${a.slice(0,l+1).join(".")} is ${JSON.stringify(i)}`);return}s=i}if(typeof s=="object"&&s!==null)try{s[u]=P}catch(l){c(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(s)}`)}else c(`Ignoring ${v} as ${a.join(".")} is ${JSON.stringify(s)}`)}e.addToValueTree=S;function b(E,v){const P=v.split(".");m(E,P)}e.removeFromValueTree=b;function m(E,v){const P=v.shift();if(v.length===0){delete E[P];return}if(Object.keys(E).indexOf(P)!==-1){const c=E[P];typeof c=="object"&&!Array.isArray(c)&&(m(c,v),Object.keys(c).length===0&&delete E[P])}}function y(E,v,P){function c(s,l){let r=s;for(const i of l){if(typeof r!="object"||r===null)return;r=r[i]}return r}const a=v.split("."),u=c(E,a);return typeof u=="undefined"?P:u}e.getConfigurationValue=y;function t(E,v,P){Object.keys(v).forEach(c=>{c!=="__proto__"&&(c in E?p.isObject(E[c])&&p.isObject(v[c])?t(E[c],v[c],P):P&&(E[c]=v[c]):E[c]=v[c])})}e.merge=t;function g(E,v,P){const c=E.inspect(v),a=E.inspect(P);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:c.defaultValue}e.getMigratedSettingValue=g}),define(Z[74],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function D(C){return!!C.hostName&&!!C.errorMessage}e.isRemoteDiagnosticError=D}),define(Z[88],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class D{constructor(M){this.machineId=M}encryption(){return new Promise((M,n)=>j(["vscode-encrypt"],M,n))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(n){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(n){return M}}}e.EncryptionMainService=D}),define(Z[48],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Z[170],x([0,1,10,140,5]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(c){c.WIN32_X64="win32-x64",c.WIN32_IA32="win32-ia32",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function n(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=n;function I(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=I;function d(c,a){switch(c){case 3:return a==="x64"?"win32-x64":a==="ia32"?"win32-ia32":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function f(c,a){return a==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=f;function S(c,a,u){return f(a,u)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===u?!0:b(u).includes(c)}e.isTargetPlatformCompatible=S;function b(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=m;var y;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var t;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var g;(function(c){c.Install="install",c.Uninstall="uninstall"})(g=e.StatisticType||(e.StatisticType={}));var E;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,C.createDecorator)("extensionGalleryService");var v;(function(c){c.Unsupported="Unsupported",c.UnsupportedPreRelease="UnsupportedPreRelease",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Internal="Internal"})(v=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class P extends Error{constructor(a,u){super(a);this.code=u,this.name=u}}e.ExtensionManagementError=P,e.IExtensionManagementService=(0,C.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,C.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,C.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,C.createDecorator)("IExtensionManagementCLIService")}),define(Z[171],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Z[172],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,p.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(Z[89],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Z[173],x([0,1,43,10,8,3,80,21,72,142,89]),function(j,e,p,D,C,M,n,I,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const b=f.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends m{openTerminal(a,u){return this.spawnTerminal(p,a,d.getWindowsShell(),u)}spawnTerminal(a,u,s,l){const r=u.windowsExec||y.getDefaultTerminalWindows();l&&l[1]===":"&&(l=l[0].toUpperCase()+l.substr(1));const i=C.basename(r).toLowerCase();if(i==="cmder"||i==="cmder.exe")return a.spawn(r,l?[l]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return r.indexOf(" ")>=0&&o.push('""'),o.push(r),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((h,w)=>{const k=E(process),A=a.spawn(s,o,{cwd:l,env:k});A.on("error",w),A.on("exit",()=>h())})}runInTerminal(a,u,s,l,r){const i="windowsExec"in r&&r.windowsExec?r.windowsExec:y.getDefaultTerminalWindows();return new Promise((o,h)=>{const w=`"${u} - ${b}"`,k=`""${s.join('" "')}" & pause"`,A=["/c","start",w,"/wait",i,"/c",k],R=Object.assign({},E(process),l);Object.keys(R).filter(Q=>R[Q]===null).forEach(Q=>delete R[Q]);const T={cwd:u,env:R,windowsVerbatimArguments:!0};p.spawn(y.CMD,A,T).on("error",Q=>{h(v(Q))}),o(void 0)})}static getDefaultTerminalWindows(){if(!y._DEFAULT_TERMINAL_WINDOWS){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return y._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=y,y.CMD="cmd.exe";class t extends m{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,s,l,r){const i=r.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((o,h)=>{if(i===S.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const w=i===S.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,j).fsPath,"-t",a||b,"-w",u];for(let _ of s)A.push("-a"),A.push(_);if(l){const _=Object.assign({},E(process),l);for(let Q in _){const ne=_[Q];ne===null?(A.push("-u"),A.push(Q)):(A.push("-e"),A.push(`${Q}=${ne}`))}}let R="";const T=p.spawn(t.OSASCRIPT,A);T.on("error",_=>{h(v(_))}),T.stderr.on("data",_=>{R+=_.toString()}),T.on("exit",_=>{if(_===0)o(void 0);else if(R){const Q=R.split(`
`,1);h(new Error(Q[0]))}else h(new Error(f.localize(1,null,w,_)))})}else h(new Error(f.localize(2,null,i)))})}spawnTerminal(a,u,s){const l=u.osxExec||S.DEFAULT_TERMINAL_OSX;return new Promise((r,i)=>{const o=["-a",l];s&&o.push(s);const h=E(process),w=a.spawn("/usr/bin/open",o,{cwd:s,env:h});w.on("error",i),w.on("exit",()=>r())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class g extends m{openTerminal(a,u){return this.spawnTerminal(p,a,u)}runInTerminal(a,u,s,l,r){const i=r.linuxExec?Promise.resolve(r.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((o,h)=>{let w=[];i.then(k=>{k.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const A=`${P(s)}; echo; read -p "${g.WAIT_MESSAGE}" -n1;`;w.push(`''${A}''`);const R=Object.assign({},E(process),l);Object.keys(R).filter(ne=>R[ne]===null).forEach(ne=>delete R[ne]);const T={cwd:u,env:R};let _="";const Q=p.spawn(k,w,T);Q.on("error",ne=>{h(v(ne))}),Q.stderr.on("data",ne=>{_+=ne.toString()}),Q.on("exit",ne=>{if(ne===0)o(void 0);else if(_){const oe=_.split(`
`,1);h(new Error(oe[0]))}else h(new Error(f.localize(4,null,k,ne)))})})})}static async getDefaultTerminalLinuxReady(){if(!g._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)g._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const a=await I.Promises.exists("/etc/debian_version");g._DEFAULT_TERMINAL_LINUX_READY=new Promise(u=>{a?u("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?u("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?u("konsole"):process.env.COLORTERM?u(process.env.COLORTERM):process.env.TERM?u(process.env.TERM):u("xterm")})}return g._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(a,u,s){const l=u.linuxExec?Promise.resolve(u.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((r,i)=>{l.then(o=>{const h=E(process),w=a.spawn(o,[],{cwd:s,env:h});w.on("error",i),w.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=g,g.WAIT_MESSAGE=f.localize(3,null);function E(c){const a={...c.env};return(0,n.sanitizeProcessEnvironment)(a),a}function v(c){return"errno"in c&&c.errno==="ENOENT"&&"path"in c&&typeof c.path=="string"?new Error(f.localize(5,null,c.path)):c}function P(c){let a="";for(let u of c)u.indexOf(" ")>=0?a+='"'+u+'"':a+=u,a+=" ";return a}}),define(Z[18],x([0,1,39,8,25,13,7,144,5]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function f(O){return O.create===!0}e.isFileOpenForWriteOptions=f;var S;(function(O){O[O.Unknown=0]="Unknown",O[O.File=1]="File",O[O.Directory=2]="Directory",O[O.SymbolicLink=64]="SymbolicLink"})(S=e.FileType||(e.FileType={}));var b;(function(O){O[O.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var m;(function(O){O[O.FileReadWrite=2]="FileReadWrite",O[O.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",O[O.FileReadStream=16]="FileReadStream",O[O.FileFolderCopy=8]="FileFolderCopy",O[O.PathCaseSensitive=1024]="PathCaseSensitive",O[O.Readonly=2048]="Readonly",O[O.Trash=4096]="Trash",O[O.FileWriteUnlock=8192]="FileWriteUnlock"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y(O){return!!(O.capabilities&2)}e.hasReadWriteCapability=y;function t(O){return!!(O.capabilities&8)}e.hasFileFolderCopyCapability=t;function g(O){return!!(O.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function E(O){return!!(O.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(O){O.FileExists="EntryExists",O.FileNotFound="EntryNotFound",O.FileNotADirectory="EntryNotADirectory",O.FileIsADirectory="EntryIsADirectory",O.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",O.FileTooLarge="EntryTooLarge",O.FileWriteLocked="EntryWriteLocked",O.NoPermissions="NoPermissions",O.Unavailable="Unavailable",O.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class P extends Error{constructor(H,q){super(H);this.code=q}}e.FileSystemProviderError=P;function c(O,H){const q=new P(O.toString(),H);return u(q,H),q}e.createFileSystemProviderError=c;function a(O){return O||c((0,I.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=a;function u(O,H){return O.name=H?`${H} (FileSystemError)`:"FileSystemError",O}e.markAsFileSystemProviderError=u;function s(O){if(!O)return v.Unknown;if(O instanceof P)return O.code;const H=/^(.+) \(FileSystemError\)$/.exec(O.name);if(!H)return v.Unknown;switch(H[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=s;function l(O){if(O instanceof k)return O.fileOperationResult;switch(s(O)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=l;var r;(function(O){O[O.CREATE=0]="CREATE",O[O.DELETE=1]="DELETE",O[O.MOVE=2]="MOVE",O[O.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class i{constructor(H,q,Y){this.resource=H,this.operation=q,this.target=Y}isOperation(H){return this.operation===H}}e.FileOperationEvent=i;var o;(function(O){O[O.UPDATED=0]="UPDATED",O[O.ADDED=1]="ADDED",O[O.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class h{constructor(H,q){this.added=void 0,this.updated=void 0,this.deleted=void 0;const Y=new Map;for(const $ of H){const K=Y.get($.type);K?K.push([$.resource,$]):Y.set($.type,[[$.resource,$]])}for(const[$,K]of Y)switch($){case 1:this.added=p.TernarySearchTree.forUris(()=>q),this.added.fill(K);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>q),this.updated.fill(K);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>q),this.deleted.fill(K);break}}contains(H,...q){return this.doContains(H,{includeChildren:!1},...q)}affects(H,...q){return this.doContains(H,{includeChildren:!0},...q)}doContains(H,q,...Y){if(!H)return!1;const $=Y.length>0;return!!((!$||Y.includes(1))&&(this.added?.get(H)||q.includeChildren&&this.added?.findSuperstr(H))||(!$||Y.includes(0))&&(this.updated?.get(H)||q.includeChildren&&this.updated?.findSuperstr(H))||(!$||Y.includes(2))&&(this.deleted?.findSubstr(H)||q.includeChildren&&this.deleted?.findSuperstr(H)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=h;function w(O,H,q){return!O||!H||O===H||H.length>O.length?!1:(H.charAt(H.length-1)!==D.sep&&(H+=D.sep),q?(0,C.startsWithIgnoreCase)(O,H):O.indexOf(H)===0)}e.isParent=w;class k extends Error{constructor(H,q,Y){super(H);this.fileOperationResult=q,this.options=Y}}e.FileOperationError=k;class A extends k{constructor(H,q,Y){super(H,2,Y);this.stat=q}}e.NotModifiedSinceFileOperationError=A;var R;(function(O){O[O.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",O[O.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",O[O.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",O[O.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",O[O.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",O[O.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",O[O.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",O[O.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",O[O.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",O[O.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",O[O.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",O[O.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(R=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(O){O[O.FILE=0]="FILE",O[O.FOLDER=1]="FOLDER",O[O.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function _(O){if(!(typeof O.size!="number"||typeof O.mtime!="number"))return O.mtime.toString(29)+O.size.toString(31)}e.etag=_;async function Q(O,H){if(!H.hasProvider(n.URI.from({scheme:O.scheme})))return new Promise(q=>{const Y=H.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===O.scheme&&$.added&&(Y.dispose(),q())})})}e.whenProviderRegistered=Q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ne{static formatSize(H){return(0,M.isNumber)(H)||(H=0),H<ne.KB?(0,I.localize)(1,null,H.toFixed(0)):H<ne.MB?(0,I.localize)(2,null,(H/ne.KB).toFixed(2)):H<ne.GB?(0,I.localize)(3,null,(H/ne.MB).toFixed(2)):H<ne.TB?(0,I.localize)(4,null,(H/ne.GB).toFixed(2)):(0,I.localize)(5,null,(H/ne.TB).toFixed(2))}}e.ByteSize=ne,ne.KB=1024,ne.MB=ne.KB*ne.KB,ne.GB=ne.MB*ne.KB,ne.TB=ne.GB*ne.KB;var oe;(function(O){O[O.IA32=0]="IA32",O[O.OTHER=1]="OTHER"})(oe=e.Arch||(e.Arch={}));function X(O){return{maxFileSize:O===0?300*ne.MB:16*ne.GB,maxHeapSize:O===0?700*ne.MB:2*700*ne.MB}}e.getPlatformLimits=X}),define(Z[53],x([0,1,248,138,87,18]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function n(m,y){const t={onUnknownOption:E=>{console.warn((0,D.localize)(0,null,E))},onMultipleValues:(E,v)=>{console.warn((0,D.localize)(1,null,E,v))},onDeprecatedOption:(E,v)=>{console.warn((0,D.localize)(2,null,E,v))}},g=(0,C.parseArgs)(m,C.OPTIONS,y?t:void 0);return g.goto&&g._.forEach(E=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,D.localize)(3,null))),g["max-memory"]&&p(parseInt(g["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),g}function I(m){const y=m.findIndex(t=>!/^-/.test(t));if(y>-1)return[...m.slice(0,y),...m.slice(y+1)]}function d(m){let[,...y]=m;process.env.VSCODE_DEV&&(y=I(y)||[]);const t=!b(process.env);return n(y,t)}e.parseMainProcessArgv=d;function f(m){const[,,...y]=m;return n(y,!0)}e.parseCLIProcessArgv=f;function S(m,...y){const t=m.indexOf("--");return t===-1?m.push(...y):m.splice(t,0,...y),m}e.addArg=S;function b(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),define(Z[90],x([0,1,43,8,139,23,44,16,3,31,132,53,9]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let t;async function g(v,P,c){return P["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(c)&&!P["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(c)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=m.Promises.withAsyncBody(async(a,u)=>{const s=new M.CancellationTokenSource,l=setTimeout(()=>{s.dispose(!0),u(new Error((0,C.localize)(0,null)))},y);try{a(await E(v,s.token))}catch(r){!(0,I.isPromiseCanceledError)(r)&&!s.token.isCancellationRequested?u(new Error((0,C.localize)(1,null,(0,n.toErrorMessage)(r)))):a({})}finally{clearTimeout(l),s.dispose()}})),t)}e.getResolvedShellEnv=g;async function E(v,P){const c=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",c);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",a);const u=(0,f.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(u+"(.*)"+u),l={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",l);const r=await(0,S.getSystemShell)(d.OS,l);return v.trace("getUnixShellEnvironment#shell",r),new Promise((i,o)=>{if(P.isCancellationRequested)return o((0,I.canceled)());const h=(0,D.basename)(r);let w,k;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(w=`& '${process.execPath}' ${A} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,k=["-Login","-Command"]):(w=`'${process.execPath}' ${A} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,h==="tcsh"?k=["-ic"]:k=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),w);const R=(0,p.spawn)(r,[...k,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});P.onCancellationRequested(()=>(R.kill(),o((0,I.canceled)()))),R.on("error",Q=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,n.toErrorMessage)(Q)),o(Q)});const T=[];R.stdout.on("data",Q=>T.push(Q));const _=[];R.stderr.on("data",Q=>_.push(Q)),R.on("close",(Q,ne)=>{const oe=Buffer.concat(T).toString("utf8");v.trace("getUnixShellEnvironment#raw",oe);const X=Buffer.concat(_).toString("utf8");if(X.trim()&&v.trace("getUnixShellEnvironment#stderr",X),Q||ne)return o(new Error((0,C.localize)(2,null,Q,ne)));const O=s.exec(oe),H=O?O[1]:"{}";try{const q=JSON.parse(H);c?q.ELECTRON_RUN_AS_NODE=c:delete q.ELECTRON_RUN_AS_NODE,a?q.ELECTRON_NO_ATTACH_CONSOLE=a:delete q.ELECTRON_NO_ATTACH_CONSOLE,delete q.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",q),i(q)}catch(q){v.error("getUnixShellEnvironment#errorCaught",(0,n.toErrorMessage)(q)),o(q)}})})}}),define(Z[91],x([0,1,17,16,145,18]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function n(S,b,m,y,t,g){let E;try{await I(S,b,m,y,t,g)}catch(v){E=v}finally{E&&t.errorTransformer&&(E=t.errorTransformer(E)),typeof E!="undefined"&&m.error(E),m.end()}}e.readFileIntoStream=n;async function I(S,b,m,y,t,g){d(g);const E=await S.open(b,{create:!1});try{d(g);let v=0,P=0,c=t&&typeof t.length=="number"?t.length:void 0,a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),u=t&&typeof t.position=="number"?t.position:0,s=0;do P=await S.read(E,u,a.buffer,s,a.byteLength-s),u+=P,s+=P,v+=P,typeof c=="number"&&(c-=P),s===a.byteLength&&(await m.write(y(a)),a=p.VSBuffer.alloc(Math.min(t.bufferSize,typeof c=="number"?c:t.bufferSize)),s=0);while(P>0&&(typeof c!="number"||c>0)&&d(g)&&f(v,t));if(s>0){let l=s;typeof c=="number"&&(l=Math.min(s,c)),m.write(y(a.slice(0,l)))}}catch(v){throw(0,M.ensureFileSystemProviderError)(v)}finally{await S.close(E)}}function d(S){if(S.isCancellationRequested)throw(0,D.canceled)();return!0}function f(S,b){if(b?.limits){if(typeof b.limits.memory=="number"&&S>b.limits.memory)throw(0,M.createFileSystemProviderError)((0,C.localize)(0,null),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&S>b.limits.size)throw(0,M.createFileSystemProviderError)((0,C.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[62],x([0,1,2,3,7,18]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.coalesceEvents=e.toFileChanges=e.AbstractRecursiveWatcherClient=void 0;class n extends p.Disposable{constructor(b,m,y){super();this.onFileChanges=b,this.onLogMessage=m,this.verboseLogging=y,this.watcherDisposables=this._register(new p.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const b=new p.DisposableStore;this.watcherDisposables.value=b,this.watcher=this.createWatcher(b),this.watcher.setVerboseLogging(this.verboseLogging),b.add(this.watcher.onDidChangeFile(m=>this.onFileChanges(m))),b.add(this.watcher.onDidLogMessage(m=>this.onLogMessage(m))),b.add(this.watcher.onDidError(m=>this.onError(m)))}onError(b){this.restartCounter<n.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${b}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${b}`)}restart(b){this.restartCounter++,this.init(),this.watch(b)}async watch(b){this.requests=b,await this.watcher?.watch(b)}async setVerboseLogging(b){this.verboseLogging=b,await this.watcher?.setVerboseLogging(b)}error(b){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${b}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractRecursiveWatcherClient=n,n.MAX_RESTARTS=5;function I(S){return S.map(b=>({type:b.type,resource:C.URI.file(b.path)}))}e.toFileChanges=I;function d(S){const b=new f;for(const m of S)b.processEvent(m);return b.coalesce()}e.coalesceEvents=d;class f{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(b){return D.isLinux?b.path:b.path.toLowerCase()}processEvent(b){const m=this.mapPathToChange.get(this.toKey(b));let y=!1;if(m){const t=m.type,g=b.type;m.path!==b.path&&b.type===2?y=!0:t===1&&g===2?(this.mapPathToChange.delete(this.toKey(b)),this.coalesced.delete(m)):t===2&&g===1?m.type=0:t===1&&g===0||(m.type=g)}else y=!0;y&&(this.coalesced.add(b),this.mapPathToChange.set(this.toKey(b),b))}coalesce(){const b=[],m=[];return Array.from(this.coalesced).filter(y=>y.type!==2?(b.push(y),!1):!0).sort((y,t)=>y.path.length-t.path.length).filter(y=>m.some(t=>(0,M.isParent)(y.path,t,!D.isLinux))?!1:(m.push(y.path),!0)).concat(b)}}}),define(Z[92],x([0,1,9,2,8,82,21,119,62]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSFileWatcher=void 0;class f extends D.Disposable{constructor(b,m,y,t){super();this.path=b,this.onDidFilesChange=m,this.onLogMessage=y,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(b){this.verboseLogging=b}async startWatching(){try{const{stat:b,symbolicLink:m}=await n.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(m)try{y=await(0,M.realpath)(y)}catch(t){if(this.onError(t),m.dangling)return}b.isDirectory()?this._register((0,I.watchFolder)(y,(t,g)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,C.join)(this.path,(0,C.basename)(g))})},t=>this.onError(t))):this._register((0,I.watchFile)(y,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(b){b.code!=="ENOENT"&&this.onError(b)}}onFileChange(b){this.fileChangesBuffer.push(b),this.verboseLogging&&this.onVerbose(`${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,d.coalesceEvents)(m);if(this.verboseLogging)for(const t of y)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(b){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${b}`})}onVerbose(b){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${b}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.NodeJSFileWatcher=f}),define(Z[174],x([0,1,10,36,133,62]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParcelWatcherClient=void 0;class n extends M.AbstractRecursiveWatcherClient{constructor(d,f,S){super(d,f,S);this.init()}createWatcher(d){const f=d.add(new C.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=parcelWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/parcelWatcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(f.onDidProcessExit(({code:S,signal:b})=>this.onError(`terminated by itself with code ${S}, signal: ${b}`))),D.ProxyChannel.toService((0,D.getNextTickChannel)(f.getChannel("watcher")))}}e.ParcelWatcherClient=n}),define(Z[75],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[M,n]of C)this.set(M,n)}set(C,M){const n=this._entries.get(C);return this._entries.set(C,M),n}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(Z[175],x([0,1,9,16,73,169,5,75]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class f extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class S{constructor(t=new I.ServiceCollection,g=!1,E){this._activeInstantiations=new Set,this._services=t,this._strict=g,this._parent=E,this._services.set(n.IInstantiationService,this)}createChild(t){return new S(t,this._strict,this)}invokeFunction(t,...g){let E=m.traceInvocation(t),v=!1;try{return t({get:c=>{if(v)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(c,E);if(!a)throw new Error(`[invokeFunction] unknown service '${c}'`);return a}},...g)}finally{v=!0,E.stop()}}createInstance(t,...g){let E,v;return t instanceof C.SyncDescriptor?(E=m.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(g),E)):(E=m.traceCreation(t),v=this._createInstance(t,g,E)),E.stop(),v}_createInstance(t,g=[],E){let v=n._util.getServiceDependencies(t).sort((a,u)=>a.index-u.index),P=[];for(const a of v){let u=this._getOrCreateServiceInstance(a.id,E);if(!u&&this._strict&&!a.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${a.id}.`);P.push(u)}let c=v.length>0?v[0].index:g.length;if(g.length!==c){console.warn(`[createInstance] First service dependency of ${t.name} at position ${c+1} conflicts with ${g.length} static arguments`);let a=c-g.length;a>0?g=g.concat(new Array(a)):g=g.slice(0,c)}return new t(...[...g,...P])}_setServiceInstance(t,g){if(this._services.get(t)instanceof C.SyncDescriptor)this._services.set(t,g);else if(this._parent)this._parent._setServiceInstance(t,g);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let g=this._services.get(t);return!g&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):g}_getOrCreateServiceInstance(t,g){let E=this._getServiceInstanceOrDescriptor(t);return E instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,E,g.branch(t,!0)):(g.branch(t,!1),E)}_safeCreateAndCacheServiceInstance(t,g,E){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,g,E)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,g,E){const v=new M.Graph(a=>a.id.toString());let P=0;const c=[{id:t,desc:g,_trace:E}];for(;c.length;){const a=c.pop();if(v.lookupOrInsertNode(a),P++>1e3)throw new f(v);for(let u of n._util.getServiceDependencies(a.desc.ctor)){let s=this._getServiceInstanceOrDescriptor(u.id);if(!s&&!u.optional&&console.warn(`[createInstance] ${t} depends on ${u.id} which is NOT registered.`),s instanceof C.SyncDescriptor){const l={id:u.id,desc:s,_trace:a._trace.branch(u.id,!0)};v.insertEdge(a,l),c.push(l)}}}for(;;){const a=v.roots();if(a.length===0){if(!v.isEmpty())throw new f(v);break}for(const{data:u}of a){if(this._getServiceInstanceOrDescriptor(u.id)instanceof C.SyncDescriptor){const l=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,l)}v.removeNode(u)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,g,E=[],v,P){if(this._services.get(t)instanceof C.SyncDescriptor)return this._createServiceInstance(g,E,v,P);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,g,E,v,P);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}_createServiceInstance(t,g=[],E,v){if(E){const P=new p.IdleValue(()=>this._createInstance(t,g,v));return new Proxy(Object.create(null),{get(c,a){if(a in c)return c[a];let u=P.value,s=u[a];return typeof s!="function"||(s=s.bind(u),c[a]=s),s},set(c,a,u){return P.value[a]=u,!0}})}else return this._createInstance(t,g,v)}}e.InstantiationService=S;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class m{constructor(t,g){this.type=t,this.name=g,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new m(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(t){return d?new m(0,t.name):m._None}branch(t,g){let E=new m(2,t.toString());return this._dep.push([t,g,E]),E}stop(){let t=Date.now()-this._start;m._totals+=t;let g=!1;function E(P,c){let a=[],u=new Array(P+1).join("	");for(const[s,l,r]of c._dep)if(l&&r){g=!0,a.push(`${u}CREATES -> ${s}`);let i=E(P+1,r);i&&a.push(i)}else a.push(`${u}uses -> ${s}`);return a.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(t>2||g)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Z[176],x([0,1,16,130,58]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends C.ResolvedKeybinding{constructor(I,d){super();if(d.length===0)throw(0,p.illegalArgument)("parts");this._os=I,this._parts=d}getLabel(){return D.UILabelProvider.toLabel(this._os,this._parts,I=>this._getLabel(I))}getAriaLabel(){return D.AriaLabelProvider.toLabel(this._os,this._parts,I=>this._getAriaLabel(I))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:D.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,I=>this._getElectronAccelerator(I))}getUserSettingsLabel(){return D.UserSettingsLabelProvider.toLabel(this._os,this._parts,I=>this._getUserSettingsLabel(I))}isWYSIWYG(){return this._parts.every(I=>this._isWYSIWYG(I))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(I=>this._getPart(I))}_getPart(I){return new C.ResolvedKeybindingPart(I.ctrlKey,I.shiftKey,I.altKey,I.metaKey,this._getLabel(I),this._getAriaLabel(I))}getDispatchParts(){return this._parts.map(I=>this._getDispatchPart(I))}getSingleModifierDispatchParts(){return this._parts.map(I=>this._getSingleModifierDispatchPart(I))}}e.BaseResolvedKeybinding=M}),define(Z[177],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(M,n,I,d,f,S,b){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?D(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=D(M.getSingleModifierDispatchParts())),this.bubble=n?n.charCodeAt(0)===94:!1,this.command=this.bubble?n.substr(1):n,this.commandArgs=I,this.when=d,this.isDefault=f,this.extensionId=S,this.isBuiltinExtension=b}}e.ResolvedKeybindingItem=p;function D(C){let M=[];for(let n=0,I=C.length;n<I;n++){const d=C[n];if(!d)return M;M.push(d)}return M}e.removeElementsAfterNulls=D}),define(Z[178],x([0,1,79,58,176,177]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class n extends C.BaseResolvedKeybinding{constructor(d,f){super(f,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return p.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const f=p.KeyCodeUtils.toUserSettingsUS(d.keyCode);return f&&f.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return n.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let f="";return d.ctrlKey&&(f+="ctrl+"),d.shiftKey&&(f+="shift+"),d.altKey&&(f+="alt+"),d.metaKey&&(f+="meta+"),f+=p.KeyCodeUtils.toString(d.keyCode),f}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const f=p.IMMUTABLE_CODE_TO_KEY_CODE[d];if(f!==-1)return f;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof D.SimpleKeybinding)return d;const f=this._scanCodeToKeyCode(d.scanCode);return f===0?null:new D.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,f)}static resolveUserBinding(d,f){const S=(0,M.removeElementsAfterNulls)(d.map(b=>this._resolveSimpleUserBinding(b)));return S.length>0?[new n(new D.ChordKeybinding(S),f)]:[]}}e.USLayoutResolvedKeybinding=n}),define(Z[179],x([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function D(C,M){if(C.length===0)return Promise.resolve(!1);const n=[];let I=!1;for(let d of C){if(d===!0)return Promise.resolve(!0);(0,p.isThenable)(d)&&n.push(d.then(f=>{f&&(I=!0)},f=>{M(f),I=!0}))}return p.Promises.settled(n).then(()=>I)}e.handleVetos=D}),define(Z[6],x([0,1,44,4,2,3,5]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,n.createDecorator)("logService"),e.ILoggerService=(0,n.createDecorator)("loggerService");function I(){return new Date().toISOString()}var d;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function f(l,r,i){switch(r){case d.Trace:l.trace(i);break;case d.Debug:l.debug(i);break;case d.Info:l.info(i);break;case d.Warning:l.warn(i);break;case d.Error:l.error(i);break;case d.Critical:l.critical(i);break;default:throw new Error("Invalid log level")}}e.log=f;function S(l){let r="";for(let i=0;i<l.length;i++){let o=l[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(h){}r+=(i>0?" ":"")+o}return r}e.format=S;class b extends C.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class m extends b{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,S([r,...i]))}debug(r,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,S([r,...i]))}info(r,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,S([r,...i]))}warn(r,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,S([r,...i]))}error(r,...i){if(this.checkLogLevel(d.Error))if(r instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=r.stack,this.log(d.Error,S(o))}else this.log(d.Error,S([r,...i]))}critical(r,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,S([r,...i]))}flush(){}}e.AbstractMessageLogger=m;class y extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!M.isWindows}trace(r,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}debug(r,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}info(r,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,r,...i):console.log(`[main ${I()}]`,r,...i))}warn(r,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,r,...i):console.warn(`[main ${I()}]`,r,...i))}error(r,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}critical(r,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,r,...i):console.error(`[main ${I()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class t extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=t;class g extends b{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,p.toErrorMessage)(r,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class E extends b{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const o of this.logServices)o.trace(r,...i)}debug(r,...i){for(const o of this.logServices)o.debug(r,...i)}info(r,...i){for(const o of this.logServices)o.info(r,...i)}warn(r,...i){for(const o of this.logServices)o.warn(r,...i)}error(r,...i){for(const o of this.logServices)o.error(r,...i)}critical(r,...i){for(const o of this.logServices)o.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=E;class v extends C.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=v;class P extends C.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(o))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let o=this.loggers.get(r.toString());return o||(o=this.doCreateLogger(r,i?.always?d.Trace:this.logLevel,i),this.loggers.set(r.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=P;class c{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(r){}getLevel(){return d.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=c;function a(l){if(l.verbose)return d.Trace;if(typeof l.logLevel=="string"){const r=u(l.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=a;function u(l){switch(l){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=u;function s(l){switch(l){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var ie=this&&this.__param||function(j,e){return function(p,D){e(p,D,j)}};define(Z[180],x([0,1,9,17,38,78,48,18,5,6]),function(j,e,p,D,C,M,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var S;(function(m){m.ERROR_INVALID_FILE="ERROR_INVALID_FILE",m.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(S=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let b=class{constructor(y,t,g){this.environmentService=y,this.fileService=t,this.logService=g,this.queue=new p.Queue}async updateSettings(y,t){return this.queue.queue(()=>this.doWrite(y,t))}async doWrite(y,t){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,this.environmentService.settingsResource.toString(),y);const{value:g,mtime:E,etag:v}=await this.fileService.readFile(this.environmentService.settingsResource,{atomic:!0});let P=g.toString();const c=[];if((0,C.parse)(P,c,{allowTrailingComma:!0,allowEmptyContent:!0}),c.length)throw new Error("ERROR_INVALID_FILE");const a=this.getEdits(y,P,t)[0];if(a){P=P.substring(0,a.offset)+a.content+P.substring(a.offset+a.length);try{await this.fileService.writeFile(this.environmentService.settingsResource,D.VSBuffer.fromString(P),{etag:v,mtime:E})}catch(u){if(u.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}async write(y,t){return this.queue.queue(async()=>{await this.fileService.writeFile(this.environmentService.settingsResource,y,t)})}getEdits({value:y,path:t},g,E){return t.length?(0,M.setProperty)(g,t,y,E):[{content:JSON.stringify(y,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:g.length,offset:0}]}};b=de([ie(0,n.IEnvironmentService),ie(1,I.IFileService),ie(2,f.ILogService)],b),e.UserConfigurationFileService=b}),define(Z[181],x([0,1,30,9,16,4,2,8,62,6]),function(j,e,p,D,C,M,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class S extends n.Disposable{constructor(m){super();this.logService=m,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}watch(m,y){return y.recursive?this.watchRecursive(m,y):this.watchNonRecursive(m)}watchRecursive(m,y){const t={path:this.toFilePath(m),excludes:y.excludes},g=(0,p.insert)(this.recursiveFoldersToWatch,t);return this.refreshRecursiveWatchers(),(0,n.toDisposable)(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(m=>(0,C.onUnexpectedError)(m))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(m=>this._onDidChangeFile.fire((0,d.toFileChanges)(m)),m=>this.onWatcherLogMessage(m),this.logService.getLevel()===f.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(m,y){return m.watch(y)}watchNonRecursive(m){const y=this.createNonRecursiveWatcher(this.toFilePath(m),g=>this._onDidChangeFile.fire((0,d.toFileChanges)(g)),g=>this.onWatcherLogMessage(g),this.logService.getLevel()===f.LogLevel.Trace),t=this.logService.onDidChangeLogLevel(()=>{y.setVerboseLogging(this.logService.getLevel()===f.LogLevel.Trace)});return(0,n.combinedDisposable)(y,t)}onWatcherLogMessage(m){m.type==="error"&&this._onDidWatchError.fire(m.message),this.logService[m.type](m.message)}toFilePath(m){return(0,I.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=S}),define(Z[182],x([0,1,30,9,17,23,4,69,2,39,10,63,15,59,143,18,91,6]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let P=class Ye extends d.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new n.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new n.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new n.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new n.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new n.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new n.Emitter),this.onDidWatchError=this._onDidWatchError.event,this._onDidChangeFilesRaw=this._register(new n.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ye.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ye.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ye.FILE_EVENTS_THROTTLING.coolDownDelay,u=>this._onDidFilesChange.fire(new g.FileChangesEvent(u,!0)))),this.watchedResources=f.TernarySearchTree.forUris(u=>{const s=this.getProvider(u.scheme);return s?!this.isPathCaseSensitive(s):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(a,u){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,u),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:u});const s=new d.DisposableStore;return s.add(u.onDidChangeFile(l=>this.onDidChangeFile(l,this.isPathCaseSensitive(u)))),s.add(u.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:u,scheme:a}))),typeof u.onDidWatchError=="function"&&s.add(u.onDidWatchError(l=>this._onDidWatchError.fire(new Error(l)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:u}),this.provider.delete(a),(0,d.dispose)(s)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const u=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(s){u.push(s)}}),!this.provider.has(a)&&await D.Promises.settled(u)}async canHandleResource(a){return await this.activateProvider(a.scheme),this.hasProvider(a)}hasProvider(a){return this.provider.has(a.scheme)}hasCapability(a,u){const s=this.provider.get(a.scheme);return!!(s&&s.capabilities&u)}listCapabilities(){return I.Iterable.map(this.provider,([a,u])=>({scheme:a,capabilities:u.capabilities}))}async withProvider(a){if(!(0,m.isAbsolutePath)(a))throw new g.FileOperationError((0,t.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const u=this.provider.get(a.scheme);if(!u){const s=new Error;throw s.name="ENOPRO",s.message=(0,t.localize)(1,null,a.toString()),s}return u}async withReadProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u)||(0,g.hasFileReadStreamCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const u=await this.withProvider(a);if((0,g.hasOpenReadWriteCloseCapability)(u)||(0,g.hasReadWriteCapability)(u))return u;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,u){try{return await this.doResolveFile(a,u)}catch(s){throw(0,g.toFileSystemProviderErrorCode)(s)===g.FileSystemProviderErrorCode.FileNotFound?new g.FileOperationError((0,t.localize)(2,null,this.resourceForError(a)),1):(0,g.ensureFileSystemProviderError)(s)}}async doResolveFile(a,u){const s=await this.withProvider(a),l=this.isPathCaseSensitive(s),r=u?.resolveTo,i=u?.resolveSingleChildDescendants,o=u?.resolveMetadata,h=await s.stat(a);let w;return this.toFileStat(s,a,h,void 0,!!o,(k,A)=>(w||(w=f.TernarySearchTree.forUris(()=>!l),w.set(a,!0),r&&w.fill(!0,r)),w.get(k.resource)||w.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&i?A===1:!1))}async toFileStat(a,u,s,l,r,i){const{providerExtUri:o}=this.getExtUri(a),h={resource:u,name:o.basename(u),isFile:(s.type&g.FileType.File)!=0,isDirectory:(s.type&g.FileType.Directory)!=0,isSymbolicLink:(s.type&g.FileType.SymbolicLink)!=0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:Boolean((s.permissions??0)&g.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,g.etag)({mtime:s.mtime,size:s.size})};if(h.isDirectory&&i(h,l)){try{const w=await a.readdir(u),k=await D.Promises.settled(w.map(async([A,R])=>{try{const T=o.joinPath(u,A),_=r?await a.stat(T):{type:R};return await this.toFileStat(a,T,_,w.length,r,i)}catch(T){return this.logService.trace(T),null}}));h.children=(0,p.coalesce)(k)}catch(w){this.logService.trace(w),h.children=[]}return h}return h}async resolveAll(a){return D.Promises.settled(a.map(async u=>{try{return{stat:await this.doResolveFile(u.resource,u.options),success:!0}}catch(s){return this.logService.trace(s),{stat:void 0,success:!1}}}))}async exists(a){const u=await this.withProvider(a);try{return!!await u.stat(a)}catch(s){return!1}}async canCreateFile(a,u){try{await this.doValidateCreateFile(a,u)}catch(s){return s}return!0}async doValidateCreateFile(a,u){if(!u?.overwrite&&await this.exists(a))throw new g.FileOperationError((0,t.localize)(3,null,this.resourceForError(a)),3,u)}async createFile(a,u=C.VSBuffer.fromString(""),s){await this.doValidateCreateFile(a,s);const l=await this.writeFile(a,u);return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,l)),l}async writeFile(a,u,s){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(l);try{await this.validateWriteFile(l,a,s)||await this.mkdirp(l,r.dirname(a));let o;if((0,g.hasReadWriteCapability)(l)&&!(u instanceof C.VSBuffer))if((0,y.isReadableStream)(u)){const h=await(0,y.peekStream)(u,3);h.ended?o=C.VSBuffer.concat(h.buffer):o=h}else o=(0,y.peekReadable)(u,h=>C.VSBuffer.concat(h),3);else o=u;!(0,g.hasOpenReadWriteCloseCapability)(l)||(0,g.hasReadWriteCapability)(l)&&o instanceof C.VSBuffer?await this.doWriteUnbuffered(l,a,s,o):await this.doWriteBuffered(l,a,s,o instanceof C.VSBuffer?(0,C.bufferToReadable)(o):o)}catch(i){throw new g.FileOperationError((0,t.localize)(4,null,this.resourceForError(a),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),s)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,u,s){if(!!s?.unlock&&!(a.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(u)));let r;try{r=await a.stat(u)}catch(i){return}if((r.type&g.FileType.Directory)!=0)throw new g.FileOperationError((0,t.localize)(6,null,this.resourceForError(u)),0,s);if(this.throwIfFileIsReadonly(u,r),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==g.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&s.mtime<r.mtime&&s.etag!==(0,g.etag)({mtime:s.mtime,size:r.size}))throw new g.FileOperationError((0,t.localize)(7,null),3,s);return r}async readFile(a,u){const s=await this.withReadProvider(a);return u?.atomic?this.doReadFileAtomic(s,a,u):this.doReadFile(s,a,u)}async doReadFileAtomic(a,u,s){return new Promise((l,r)=>{this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{try{const i=await this.doReadFile(a,u,s);l(i)}catch(i){r(i)}})})}async doReadFile(a,u,s){const l=await this.doReadFileStream(a,u,{...s,preferUnbuffered:!0});return{...l,value:await(0,C.streamToBuffer)(l.value)}}async readFileStream(a,u){const s=await this.withReadProvider(a);return this.doReadFileStream(s,a,u)}async doReadFileStream(a,u,s){const l=new M.CancellationTokenSource,r=this.validateReadFile(u,s).then(o=>o,o=>{throw l.cancel(),o});let i;try{return typeof s?.etag=="string"&&s.etag!==g.ETAG_DISABLED&&await r,!((0,g.hasOpenReadWriteCloseCapability)(a)||(0,g.hasFileReadStreamCapability)(a))||(0,g.hasReadWriteCapability)(a)&&s?.preferUnbuffered?i=this.readFileUnbuffered(a,u,s):(0,g.hasFileReadStreamCapability)(a)?i=this.readFileStreamed(a,u,l.token,s):i=this.readFileBuffered(a,u,l.token,s),{...await r,value:i}}catch(o){i&&await(0,y.consumeStream)(i);const h=(0,t.localize)(8,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(o).toString());throw o instanceof g.NotModifiedSinceFileOperationError?new g.NotModifiedSinceFileOperationError(h,o.stat,s):new g.FileOperationError(h,(0,g.toFileOperationResult)(o),s)}}readFileStreamed(a,u,s,l=Object.create(null)){const r=a.readFileStream(u,l,s);return(0,y.transform)(r,{data:i=>i instanceof C.VSBuffer?i:C.VSBuffer.wrap(i),error:i=>new g.FileOperationError((0,t.localize)(9,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),l)},i=>C.VSBuffer.concat(i))}readFileBuffered(a,u,s,l=Object.create(null)){const r=(0,C.newWriteableBufferStream)();return(0,E.readFileIntoStream)(a,u,r,i=>i,{...l,bufferSize:this.BUFFER_SIZE,errorTransformer:i=>new g.FileOperationError((0,t.localize)(10,null,this.resourceForError(u),(0,g.ensureFileSystemProviderError)(i).toString()),(0,g.toFileOperationResult)(i),l)},s),r}readFileUnbuffered(a,u,s){const l=(0,y.newWriteableStream)(r=>C.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(u);typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.validateReadFileLimits(u,r.byteLength,s),l.end(C.VSBuffer.wrap(r))}catch(r){l.error(r),l.end()}})(),l}async validateReadFile(a,u){const s=await this.resolve(a,{resolveMetadata:!0});if(s.isDirectory)throw new g.FileOperationError((0,t.localize)(11,null,this.resourceForError(a)),0,u);if(typeof u?.etag=="string"&&u.etag!==g.ETAG_DISABLED&&u.etag===s.etag)throw new g.NotModifiedSinceFileOperationError((0,t.localize)(12,null),s,u);return this.validateReadFileLimits(a,s.size,u),s}validateReadFileLimits(a,u,s){if(s?.limits){let l;if(typeof s.limits.memory=="number"&&u>s.limits.memory&&(l=9),typeof s.limits.size=="number"&&u>s.limits.size&&(l=7),typeof l=="number")throw new g.FileOperationError((0,t.localize)(13,null,this.resourceForError(a)),l)}}async canMove(a,u,s){return this.doCanMoveCopy(a,u,"move",s)}async canCopy(a,u,s){return this.doCanMoveCopy(a,u,"copy",s)}async doCanMoveCopy(a,u,s,l){if(a.toString()!==u.toString())try{const r=s==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u);await this.doValidateMoveCopy(r,a,i,u,s,l)}catch(r){return r}return!0}async move(a,u,s){const l=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=await this.doMoveCopy(l,a,r,u,"move",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="move"?2:3,o)),o}async copy(a,u,s){const l=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=await this.doMoveCopy(l,a,r,u,"copy",!!s),o=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,i==="copy"?3:2,o)),o}async doMoveCopy(a,u,s,l,r,i){if(u.toString()===l.toString())return r;const{exists:o,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(a,u,s,l,r,i);if(o&&!h&&i&&await this.del(l,{recursive:!0}),await this.mkdirp(s,this.getExtUri(s).providerExtUri.dirname(l)),r==="copy"){if(a===s&&(0,g.hasFileFolderCopyCapability)(a))await a.copy(u,l,{overwrite:i});else{const w=await this.resolve(u);w.isDirectory?await this.doCopyFolder(a,w,s,l):await this.doCopyFile(a,u,s,l)}return r}else return a===s?(await a.rename(u,l,{overwrite:i}),r):(await this.doMoveCopy(a,u,s,l,"copy",i),await this.del(u,{recursive:!0}),"copy")}async doCopyFile(a,u,s,l){if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeBuffered(a,u,s,l);if((0,g.hasOpenReadWriteCloseCapability)(a)&&(0,g.hasReadWriteCapability)(s))return this.doPipeBufferedToUnbuffered(a,u,s,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasOpenReadWriteCloseCapability)(s))return this.doPipeUnbufferedToBuffered(a,u,s,l);if((0,g.hasReadWriteCapability)(a)&&(0,g.hasReadWriteCapability)(s))return this.doPipeUnbuffered(a,u,s,l)}async doCopyFolder(a,u,s,l){await s.mkdir(l),Array.isArray(u.children)&&await D.Promises.settled(u.children.map(async r=>{const i=this.getExtUri(s).providerExtUri.joinPath(l,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),s,i):this.doCopyFile(a,r.resource,s,i)}))}async doValidateMoveCopy(a,u,s,l,r,i){let o=!1;if(a===s){const{providerExtUri:w,isPathCaseSensitive:k}=this.getExtUri(a);if(k||(o=w.isEqual(u,l)),o&&r==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(u),this.resourceForError(l)));if(!o&&w.isEqualOrParent(l,u))throw new Error((0,t.localize)(15,null,this.resourceForError(u),this.resourceForError(l)))}const h=await this.exists(l);if(h&&!o){if(!i)throw new g.FileOperationError((0,t.localize)(16,null,this.resourceForError(u),this.resourceForError(l)),4);if(a===s){const{providerExtUri:w}=this.getExtUri(a);if(w.isEqualOrParent(u,l))throw new Error((0,t.localize)(17,null,this.resourceForError(u),this.resourceForError(l)))}}return{exists:h,isSameResourceWithDifferentPathCase:o}}getExtUri(a){const u=this.isPathCaseSensitive(a);return{providerExtUri:u?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:u}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const u=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(u,a);const s=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new g.FileOperationEvent(a,0,s)),s}async mkdirp(a,u){const s=[],{providerExtUri:l}=this.getExtUri(a);for(;!l.isEqual(u,l.dirname(u));)try{if(((await a.stat(u)).type&g.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(u)));break}catch(r){if((0,g.toFileSystemProviderErrorCode)(r)!==g.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(l.basename(u)),u=l.dirname(u)}for(let r=s.length-1;r>=0;r--){u=l.joinPath(u,s[r]);try{await a.mkdir(u)}catch(i){if((0,g.toFileSystemProviderErrorCode)(i)!==g.FileSystemProviderErrorCode.FileExists)throw i}}}async canDelete(a,u){try{await this.doValidateDelete(a,u)}catch(s){return s}return!0}async doValidateDelete(a,u){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!u?.useTrash&&!(s.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(a)));let r;try{r=await s.stat(a)}catch(o){}if(r)this.throwIfFileIsReadonly(a,r);else throw new g.FileOperationError((0,t.localize)(20,null,this.resourceForError(a)),1);if(!!!u?.recursive){const o=await this.resolve(a);if(o.isDirectory&&Array.isArray(o.children)&&o.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(a)))}return s}async del(a,u){const s=await this.doValidateDelete(a,u),l=!!u?.useTrash,r=!!u?.recursive;await s.delete(a,{recursive:r,useTrash:l}),this._onDidRunOperation.fire(new g.FileOperationEvent(a,1))}onDidChangeFile(a,u){this._onDidChangeFilesRaw.fire({changes:a});let s,l;{for(const r of a)this.watchedResources.has(r.resource)?(s||(s=[]),s.push(r)):(l||(l=[]),l.push(r));s&&this._onDidFilesChange.fire(new g.FileChangesEvent(s,!u))}if(l){const r=u?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!r.work(l)&&Ye.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${l.length}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),r.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${r.pending}, most recent change: ${l[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(a,u={recursive:!1,excludes:[]}){const s=new d.DisposableStore;let l=!1,r=()=>{l=!0};return s.add((0,d.toDisposable)(()=>r())),this.doWatch(a,u).then(i=>{l?(0,d.dispose)(i):r=()=>(0,d.dispose)(i)},i=>this.logService.error(i)),u.recursive||(this.watchedResources.set(a,(this.watchedResources.get(a)??0)+1),s.add((0,d.toDisposable)(()=>{const i=this.watchedResources.get(a);typeof i=="number"&&(i<=1?this.watchedResources.delete(a):this.watchedResources.set(a,i-1))}))),s}async doWatch(a,u){const s=await this.withProvider(a),l=this.toWatchKey(s,a,u);let r=this.activeWatchers.get(l);return r||(r={count:0,disposable:s.watch(a,u)},this.activeWatchers.set(l,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(l)))})}toWatchKey(a,u,s){const{providerExtUri:l}=this.getExtUri(a);return[l.getComparisonKey(u),String(s.recursive),s.excludes.join()].join()}dispose(){super.dispose();for(const[,a]of this.activeWatchers)(0,d.dispose)(a.disposable);this.activeWatchers.clear()}async doWriteBuffered(a,u,s,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(async()=>{const r=await a.open(u,{create:!0,unlock:s?.unlock??!1});try{(0,y.isReadableStream)(l)||(0,y.isReadableBufferedStream)(l)?await this.doWriteStreamBufferedQueued(a,r,l):await this.doWriteReadableBufferedQueued(a,r,l)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await a.close(r)}})}async doWriteStreamBufferedQueued(a,u,s){let l=0,r;if((0,y.isReadableBufferedStream)(s)){if(s.buffer.length>0){const i=C.VSBuffer.concat(s.buffer);await this.doWriteBuffer(a,u,i,i.byteLength,l,0),l+=i.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((i,o)=>{(0,y.listenStream)(r,{onData:async h=>{r.pause();try{await this.doWriteBuffer(a,u,h,h.byteLength,l,0)}catch(w){return o(w)}l+=h.byteLength,setTimeout(()=>r.resume())},onError:h=>o(h),onEnd:()=>i()})})}async doWriteReadableBufferedQueued(a,u,s){let l=0,r;for(;(r=s.read())!==null;)await this.doWriteBuffer(a,u,r,r.byteLength,l,0),l+=r.byteLength}async doWriteBuffer(a,u,s,l,r,i){let o=0;for(;o<l;)o+=await a.write(u,r+o,s.buffer,i+o,l-o)}async doWriteUnbuffered(a,u,s,l){return this.writeQueue.queueFor(u,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,u,s,l))}async doWriteUnbufferedQueued(a,u,s,l){let r;l instanceof C.VSBuffer?r=l:(0,y.isReadableStream)(l)?r=await(0,C.streamToBuffer)(l):(0,y.isReadableBufferedStream)(l)?r=await(0,C.bufferedStreamToBuffer)(l):r=(0,C.readableToBuffer)(l),await a.writeFile(u,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1})}async doPipeBuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,u,s,l))}async doPipeBufferedQueued(a,u,s,l){let r,i;try{r=await a.open(u,{create:!1}),i=await s.open(l,{create:!0,unlock:!1});const o=C.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,w=0,k=0;do k=await a.read(r,h,o.buffer,w,o.byteLength-w),await this.doWriteBuffer(s,i,o,k,h,w),h+=k,w+=k,w===o.byteLength&&(w=0);while(k>0)}catch(o){throw(0,g.ensureFileSystemProviderError)(o)}finally{await D.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof i=="number"?s.close(i):Promise.resolve()])}}async doPipeUnbuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,u,s,l))}async doPipeUnbufferedQueued(a,u,s,l){return s.writeFile(l,await a.readFile(u),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,u,s,l){return this.writeQueue.queueFor(l,this.getExtUri(s).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,u,s,l))}async doPipeUnbufferedToBufferedQueued(a,u,s,l){const r=await s.open(l,{create:!0,unlock:!1});try{const i=await a.readFile(u);await this.doWriteBuffer(s,r,C.VSBuffer.wrap(i),i.byteLength,0,0)}catch(i){throw(0,g.ensureFileSystemProviderError)(i)}finally{await s.close(r)}}async doPipeBufferedToUnbuffered(a,u,s,l){const r=await(0,C.streamToBuffer)(this.readFileBuffered(a,u,M.CancellationToken.None));await this.doWriteUnbuffered(s,l,void 0,r)}throwIfFileSystemIsReadonly(a,u){if(a.capabilities&2048)throw new g.FileOperationError((0,t.localize)(22,null,this.resourceForError(u)),6);return a}throwIfFileIsReadonly(a,u){if((u.permissions??0)&g.FilePermission.Readonly)throw new g.FileOperationError((0,t.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===S.Schemas.file?a.fsPath:a.toString(!0)}};P.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},P=de([ie(0,v.ILogService)],P),e.FileService=P}),define(Z[183],x([0,1,14,146,3,7,18,92,8,2,62,6,168,111]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class t extends m.AbstractDiskFileSystemProviderChannel{constructor(v,P){super(v,P)}getUriTransformer(v){return y.DefaultURITransformer}transformIncoming(v,P){return M.URI.revive(P)}async delete(v,P,c){if(!c.useTrash)return super.delete(v,P,c);const a=this.transformIncoming(v,P),u=(0,d.normalize)(a.fsPath);try{await p.shell.trashItem(u)}catch(s){throw(0,n.createFileSystemProviderError)(C.isWindows?(0,D.localize)(0,null,(0,d.basename)(u)):(0,D.localize)(1,null,(0,d.basename)(u)),n.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(v,P){return new g(P,this.logService)}}e.DiskFileSystemProviderChannel=t;class g extends f.Disposable{constructor(v,P){super();this.sessionEmitter=v,this.logService=P,this.watcherRequests=new Map}watch(v,P,c){if(c.recursive)throw(0,n.createFileSystemProviderError)("Recursive watcher is not supported from main process",n.FileSystemProviderErrorCode.Unavailable);const a=new f.DisposableStore;this.watcherRequests.set(v,a),a.add((0,f.toDisposable)(()=>this.watcherRequests.delete(v)));const u=a.add(new I.NodeJSFileWatcher((0,d.normalize)(P.fsPath),s=>this.sessionEmitter.fire((0,S.toFileChanges)(s)),s=>this.onWatcherLogMessage(s),this.logService.getLevel()===b.LogLevel.Trace));return a.add(this.logService.onDidChangeLogLevel(()=>{u.setVerboseLogging(this.logService.getLevel()===b.LogLevel.Trace)})),a}onWatcherLogMessage(v){v.type==="error"&&this.sessionEmitter.fire(v.message),this.logService[v.type](v.message)}dispose(){super.dispose(),this.watcherRequests.forEach(v=>(0,f.dispose)(v)),this.watcherRequests.clear()}}}),define(Z[93],x([0,1,27,249,9,17,4,32,8,3,15,59,21,147,18,91,92,174,181,44]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,D.gracefulify)(p)}catch(u){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(u)}`)}})();class a extends P.AbstractDiskFileSystemProvider{constructor(s,l){super(s);this.options=l,this.onDidChangeCapabilities=n.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,f.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:l,symbolicLink:r}=await m.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(l,r),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(s){try{const l=await m.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),r=[];return await Promise.all(l.map(async i=>{try{let o;i.isSymbolicLink()?o=(await this.stat((0,S.joinPath)(s,i.name))).type:o=this.toType(i),r.push([i.name,o])}catch(o){this.logService.trace(o)}})),r}catch(l){throw this.toFileSystemProviderError(l)}}toType(s,l){let r;return l?.dangling?r=t.FileType.Unknown:s.isFile()?r=t.FileType.File:s.isDirectory()?r=t.FileType.Directory:r=t.FileType.Unknown,l&&(r|=t.FileType.SymbolicLink),r}async readFile(s){try{const l=this.toFilePath(s);return await m.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(s,l,r){const i=(0,b.newWriteableStream)(o=>M.VSBuffer.concat(o.map(h=>M.VSBuffer.wrap(h))).buffer);return(0,g.readFileIntoStream)(this,s,i,o=>o.buffer,{...l,bufferSize:256*1024},r),i}async writeFile(s,l,r){let i;try{const o=this.toFilePath(s);if(!r.create||!r.overwrite){if(await m.Promises.exists(o)){if(!r.overwrite)throw(0,t.createFileSystemProviderError)((0,y.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!r.create)throw(0,t.createFileSystemProviderError)((0,y.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}i=await this.open(s,{create:!0,unlock:r.unlock}),await this.write(i,0,l,0,l.byteLength)}catch(o){throw await this.toFileSystemProviderWriteError(s,o)}finally{typeof i=="number"&&await this.close(i)}}async open(s,l){try{const r=this.toFilePath(s);if((0,t.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:h}=await m.SymlinkSupport.stat(r);h.mode&128||await m.Promises.chmod(r,h.mode|128)}catch(h){this.logService.trace(h)}let i;if((0,t.isFileOpenForWriteOptions)(l)){if(f.isWindows)try{await m.Promises.truncate(r,0),i="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}i||(i="w")}else i="r";const o=await m.Promises.open(r,i);return this.mapHandleToPos.set(o,0),(0,t.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(o,s),o}catch(r){throw(0,t.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(s,r):this.toFileSystemProviderError(r)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await m.Promises.fdatasync(s)}catch(l){this.canFlush=!1,this.logService.error(l)}return await m.Promises.close(s)}catch(l){throw this.toFileSystemProviderError(l)}}async read(s,l,r,i,o){const h=this.normalizePos(s,l);let w=null;try{const k=await m.Promises.read(s,r,i,o,h);return typeof k=="number"?w=k:w=k.bytesRead,w}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(s,h,w)}}normalizePos(s,l){return l===this.mapHandleToPos.get(s)?null:l}updatePos(s,l,r){const i=this.mapHandleToPos.get(s);typeof i=="number"&&(typeof l=="number"||(typeof r=="number"?this.mapHandleToPos.set(s,i+r):this.mapHandleToPos.delete(s)))}async write(s,l,r,i,o){return(0,C.retry)(()=>this.doWrite(s,l,r,i,o),100,3)}async doWrite(s,l,r,i,o){const h=this.normalizePos(s,l);let w=null;try{const k=await m.Promises.write(s,r,i,o,h);return typeof k=="number"?w=k:w=k.bytesWritten,w}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),k)}finally{this.updatePos(s,h,w)}}async mkdir(s){try{await m.Promises.mkdir(this.toFilePath(s))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(s,l){try{const r=this.toFilePath(s);l.recursive?await m.Promises.rm(r,m.RimRafMode.MOVE):await m.Promises.unlink(r)}catch(r){throw this.toFileSystemProviderError(r)}}async rename(s,l,r){const i=this.toFilePath(s),o=this.toFilePath(l);if(i!==o)try{await this.validateTargetDeleted(s,l,"move",r.overwrite),await m.Promises.move(i,o)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(2,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(s,l,r){const i=this.toFilePath(s),o=this.toFilePath(l);if(i!==o)try{await this.validateTargetDeleted(s,l,"copy",r.overwrite),await m.Promises.copy(i,o,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,y.localize)(3,null,(0,d.basename)(i),(0,d.basename)((0,d.dirname)(o)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(s,l,r,i){const o=this.toFilePath(s),h=this.toFilePath(l);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(o,h,!0)),w&&r==="copy")throw(0,t.createFileSystemProviderError)((0,y.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!w&&await m.Promises.exists(h)){if(!i)throw(0,t.createFileSystemProviderError)((0,y.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,l,r){return new v.ParcelWatcherClient(i=>s(i),i=>l(i),r)}doWatch(s,l){const r=this.options?.watcher?.usePolling;if(r===!0)for(const i of l)i.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(r))for(const i of l)r.includes(i.path)&&(i.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,l)}createNonRecursiveWatcher(s,l,r,i){return new E.NodeJSFileWatcher(s,o=>l(o),o=>r(o),i)}toFileSystemProviderError(s){if(s instanceof t.FileSystemProviderError)return s;let l;switch(s.code){case"ENOENT":l=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=t.FileSystemProviderErrorCode.NoPermissions;break;default:l=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(s,l)}async toFileSystemProviderWriteError(s,l){let r=this.toFileSystemProviderError(l);if(s&&r.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:i}=await m.SymlinkSupport.stat(this.toFilePath(s));i.mode&128||(r=(0,t.createFileSystemProviderError)(l,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(i){this.logService.trace(i)}return r}}e.DiskFileSystemProvider=a}),define(Z[94],x([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function D(M,n){switch(n){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class C extends p.AbstractLogger{constructor(n=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(n),this._register(this.onDidChangeLogLevel(I=>{this._logger&&this._logger.setLevel(I)}))}set logger(n){this._logger=n;for(const{level:I,args:d}of this.buffer)D(n,I).apply(n,d);this.buffer=[]}_log(n,...I){this._logger?D(this._logger,n).apply(this._logger,I):this.getLevel()<=n&&this.buffer.push({level:n,args:I})}trace(n,...I){this._log(p.LogLevel.Trace,n,...I)}debug(n,...I){this._log(p.LogLevel.Debug,n,...I)}info(n,...I){this._log(p.LogLevel.Info,n,...I)}warn(n,...I){this._log(p.LogLevel.Warning,n,...I)}error(n,...I){this._log(p.LogLevel.Error,n,...I)}critical(n,...I){this._log(p.LogLevel.Critical,n,...I)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=C}),define(Z[184],x([0,1,9,17,15,18,5,94,6]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const f=5*M.ByteSize.MB;let S=class extends d.AbstractLogger{constructor(y,t,g,E,v){super();this.name=y,this.resource=t,this.donotUseFormatters=E,this.fileService=v,this.backupIndex=1,this.setLevel(g),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const y=arguments[0];if(y instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=y.stack,this._log(d.LogLevel.Error,(0,d.format)(t))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(y){if(y.fileOperationResult!==3)throw y}}_log(y,t){this.queue.queue(async()=>{await this.initializePromise;let g=await this.loadContent();g.length>f&&(await this.fileService.writeFile(this.getBackupResource(),D.VSBuffer.fromString(g)),g=""),this.donotUseFormatters?g+=t:g+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(y)}] ${t}
`,await this.fileService.writeFile(this.resource,D.VSBuffer.fromString(g))})}getCurrentTimestamp(){const y=E=>E<10?`0${E}`:E,t=E=>E<10?`00${E}`:E<100?`0${E}`:E,g=new Date;return`${g.getFullYear()}-${y(g.getMonth()+1)}-${y(g.getDate())} ${y(g.getHours())}:${y(g.getMinutes())}:${y(g.getSeconds())}.${t(g.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,C.joinPath)((0,C.dirname)(this.resource),`${(0,C.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(y){return""}}stringifyLogLevel(y){switch(y){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};S=de([ie(4,M.IFileService)],S),e.FileLogger=S;let b=class extends d.AbstractLoggerService{constructor(y,t,g){super(y.getLevel(),y.onDidChangeLogLevel);this.instantiationService=t,this.fileService=g}doCreateLogger(y,t,g){const E=new I.BufferLogService(t);return(0,M.whenProviderRegistered)(y,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(S,g?.name||(0,C.basename)(y),y,E.getLevel(),!!g?.donotUseFormatters)),E}};b=de([ie(0,d.ILogService),ie(1,n.IInstantiationService),ie(2,M.IFileService)],b),e.FileLoggerService=b}),define(Z[185],x([0,1,4,7,6]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(m){this.service=m,this.onDidChangeLogLevel=p.Event.buffer(m.onDidChangeLogLevel,!0)}listen(m,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(m,y,t){switch(y){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=M;class n{constructor(m){this.channel=m}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(m){n.setLevel(this.channel,m)}static setLevel(m,y){return m.call("setLevel",y)}}e.LogLevelChannelClient=n;class I{constructor(m){this.loggerService=m,this.loggers=new Map}listen(m,y){throw new Error(`Event not found: ${y}`)}async call(m,y,t){switch(y){case"createLogger":this.createLogger(D.URI.revive(t[0]),t[1]);return;case"log":return this.log(D.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${y}`)}createLogger(m,y){this.loggers.set(m.toString(),this.loggerService.createLogger(m,y))}consoleLog(m,y){let t=console.log;switch(m){case C.LogLevel.Error:t=console.error;break;case C.LogLevel.Warning:t=console.warn;break;case C.LogLevel.Info:t=console.info;break}t.call(console,...y)}log(m,y){const t=this.loggers.get(m.toString());if(!t)throw new Error("Create the logger before logging");for(const[g,E]of y)(0,C.log)(t,g,E)}}e.LoggerChannel=I;class d extends C.AbstractLoggerService{constructor(m,y,t){super(m,y);this.channel=t}createConsoleMainLogger(){return new C.AdapterLogger({log:(m,y)=>{this.channel.call("consoleLog",[m,y])}})}doCreateLogger(m,y,t){return new f(this.channel,m,y,t)}}e.LoggerChannelClient=d;class f extends C.AbstractMessageLogger{constructor(m,y,t,g){super(g?.always);this.channel=m,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[y,g]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(m,y){const t=[[m,y]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(m){this.channel.call("log",[this.file,m])}}class S extends C.LogService{constructor(m,y){super(y);this.parent=m,this._register(m.onDidChangeLogLevel(t=>y.setLevel(t)))}setLevel(m){super.setLevel(m),this.parent.setLevel(m)}}e.FollowerLogService=S}),define(Z[95],x([0,1,18,6]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function C(I,d,f,S,b){try{const m=await new Promise((t,g)=>{j(["spdlog"],t,g)});m.setFlushOn(D.LogLevel.Trace);const y=await m.createAsyncRotatingLogger(I,d,f,S);return b&&y.clearFormatters(),y}catch(m){console.error(m)}return null}function M(I,d,f){switch(d){case D.LogLevel.Trace:I.trace(f);break;case D.LogLevel.Debug:I.debug(f);break;case D.LogLevel.Info:I.info(f);break;case D.LogLevel.Warning:I.warn(f);break;case D.LogLevel.Error:I.error(f);break;case D.LogLevel.Critical:I.critical(f);break;default:throw new Error("Invalid log level")}}class n extends D.AbstractMessageLogger{constructor(d,f,S,b,m){super();this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(d,f,S,b),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(d,f,S,b){const m=S?6:1,y=30/m*p.ByteSize.MB,t=await C(d,f,y,m,b);if(t){this._logger=t,this._logger.setLevel(this.getLevel());for(const{level:g,message:E}of this.buffer)M(this._logger,g,E);this.buffer=[]}}log(d,f){this._logger?M(this._logger,d,f):this.getLevel()<=d&&this.buffer.push({level:d,message:f})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(Z[186],x([0,1,10,15,31,18,184,6,95]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let f=class extends I.AbstractLoggerService{constructor(b,m){super(b.getLevel(),b.onDidChangeLogLevel);this.fileService=m}doCreateLogger(b,m,y){return b.scheme===p.Schemas.file?new d.SpdLogLogger(y?.name||(0,C.generateUuid)(),b.fsPath,!y?.donotRotate,!!y?.donotUseFormatters,m):new n.FileLogger(y?.name??(0,D.basename)(b),b,m,!!y?.donotUseFormatters,this.fileService)}};f=de([ie(0,I.ILogService),ie(1,M.IFileService)],f),e.LoggerService=f}),define(Z[187],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(n){return n.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function D(n){return n.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=D;function C(n){return n.uri!==void 0}e.isMenubarMenuItemRecentAction=C;function M(n){return!p(n)&&!D(n)&&!C(n)}e.isMenubarMenuItemAction=M}),define(Z[54],x([0,1,10,3,34,15]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.context!="undefined"){const I=D.globals.vscode.context.configuration();if(I)n=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const I=(0,M.dirname)(p.FileAccess.asFileUri("",j));n=j.__$__nodeRequire((0,M.joinPath)(I,"product.json").fsPath);const d=j.__$__nodeRequire((0,M.joinPath)(I,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(n,{nameShort:`${n.nameShort} Dev`,nameLong:`${n.nameLong} Dev`,dataFolderName:`${n.dataFolderName}-dev`}),Object.assign(n,{version:d.version})}else n={},Object.keys(n).length===0&&Object.assign(n,{version:"1.63.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=n}),define(Z[22],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[188],x([0,1,60,6,22]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(I,d){this.productService=I,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(I,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const f=/^(.*)#([^#]+)$/.exec(d);if(!f)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,S,b]=f;let m=this.trustedExtensionUrlPublicKeys.get(I);if(!m){if(m=this.productService.trustedExtensionUrlPublicKeys[I],!m||m.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",I),!1;this.trustedExtensionUrlPublicKeys.set(I,[...m])}const y=Buffer.from(decodeURIComponent(b),"base64");if(y.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=y.slice(0,6),g=y.readUIntBE(0,6),E=Date.now()-g;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const v=y.slice(6),P=p.createVerify("SHA256");P.write(t),P.write(Buffer.from(S)),P.end();for(let c=0;c<m.length;c++){let a=m[c];if(a!==null){if(typeof a=="string")try{a=p.createPublicKey({key:Buffer.from(a,"base64"),format:"der",type:"spki"}),m[c]=a}catch(u){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${I}:`,u),m[c]=null;continue}if(P.verify(a,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};M=de([ie(0,C.IProductService),ie(1,D.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Z[55],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Z[189],x([0,1,14,2,39,10,3,15,7,31,48,6]),function(j,e,p,D,C,M,n,I,d,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let m=class extends D.Disposable{constructor(t,g){super();this.logService=g,this.validRoots=C.TernarySearchTree.forUris(()=>!n.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(g,E)=>this.handleResourceRequest(g,E)),t.protocol.interceptFileProtocol(M.Schemas.file,(g,E)=>this.handleFileRequest(g,E)),this._register((0,D.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?D.Disposable.None:(this.validRoots.set(t,!0),(0,D.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,g){const E=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),g({error:-3})}handleResourceRequest(t,g){const E=d.URI.parse(t.url),v=M.FileAccess.asFileUri(E);return this.validRoots.findSubstr(v)?g({path:v.fsPath}):this.validExtensions.has((0,I.extname)(v))?g({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),g({error:-3}))}createIPCObjectUrl(){let t;const g=d.URI.from({scheme:"vscode",path:(0,f.generateUuid)()}),E=g.toString(),v=async()=>t;return p.ipcMain.handle(E,v),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:g,update:P=>t=P,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),p.ipcMain.removeHandler(E)}}}};m=de([ie(0,S.INativeEnvironmentService),ie(1,b.ILogService)],m),e.ProtocolMainService=m}),define(Z[40],x([0,1,103,13]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(n,I){p.ok(D.isString(n)),p.ok(D.isObject(I)),p.ok(!this.data.has(n),"There is already an extension with this id"),this.data.set(n,I)}knows(n){return this.data.has(n)}as(n){return this.data.get(n)||null}}e.Registry=new C}),define(Z[190],x([0,1,4,40]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,f){this.schemasById[C(d)]=f,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const n=new M;D.Registry.add(e.Extensions.JSONContribution,n)}),define(Z[56],x([0,1,30,4,13,135,190,40]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var f;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(f=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const S=I.Registry.as(n.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new D.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new D.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(u,s=!0){this.registerConfigurations([u],s)}registerConfigurations(u,s=!0){const l=this.doRegisterConfigurations(u,s);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:l})}deregisterConfigurations(u){const s=this.doDeregisterConfigurations(u);S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}updateConfigurations({add:u,remove:s}){const l=[];l.push(...this.doDeregisterConfigurations(s)),l.push(...this.doRegisterConfigurations(u,!1)),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,p.distinct)(l)})}registerDefaultConfigurations(u){const s=[],l=[];for(const{overrides:r,source:i}of u)for(const o in r)if(s.push(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const h={...this.configurationDefaultsOverrides.get(o)?.value||{},...r[o]};this.configurationDefaultsOverrides.set(o,{source:i,value:h});const w={type:"object",default:h,description:M.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:C.isString(i)?void 0:i};l.push(...t(o)),this.configurationProperties[o]=w,this.defaultLanguageConfigurationOverridesNode.properties[o]=w}else{this.configurationDefaultsOverrides.set(o,{value:r[o],source:i});const h=this.configurationProperties[o];h&&(this.updatePropertyDefaultValue(o,h),this.updateSchema(o,h))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}deregisterDefaultConfigurations(u){const s=[];for(const{overrides:l,source:r}of u)for(const i in l){const o=this.configurationDefaultsOverrides.get(i),h=C.isString(r)?r:r?.id,w=C.isString(o?.source)?o?.source:o?.source?.id;if(h===w)if(s.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const k=this.configurationProperties[i];k&&(this.updatePropertyDefaultValue(i,k),this.updateSchema(i,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const s of u)this.overrideIdentifiers.add(s);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,s){const l=[];return u.forEach(r=>{l.push(...this.validateAndRegisterProperties(r,s,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),l}doDeregisterConfigurations(u){const s=[],l=r=>{if(r.properties)for(const i in r.properties)s.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>l(i))};for(const r of u){l(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return s}validateAndRegisterProperties(u,s=!0,l,r,i=3){i=C.isUndefinedOrNull(u.scope)?i:u.scope;let o=[],h=u.properties;if(h)for(let k in h){if(s&&P(k)){delete h[k];continue}const A=h[k];if(A.source=l,A.defaultDefaultValue=h[k].default,this.updatePropertyDefaultValue(k,A),e.OVERRIDE_PROPERTY_REGEX.test(k)?A.scope=void 0:(A.scope=C.isUndefinedOrNull(A.scope)?i:A.scope,A.restricted=C.isUndefinedOrNull(A.restricted)?!!r?.includes(k):A.restricted),h[k].hasOwnProperty("included")&&!h[k].included){this.excludedConfigurationProperties[k]=h[k],delete h[k];continue}else this.configurationProperties[k]=h[k];!h[k].deprecationMessage&&h[k].markdownDeprecationMessage&&(h[k].deprecationMessage=h[k].markdownDeprecationMessage),o.push(k)}let w=u.allOf;if(w)for(let k of w)o.push(...this.validateAndRegisterProperties(k,s,l,r,i));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(u){const s=l=>{let r=l.properties;if(r)for(const o in r)this.updateSchema(o,r[o]);let i=l.allOf;i&&i.forEach(s)};s(u)}updateSchema(u,s){switch(e.allSettings.properties[u]=s,s.scope){case 1:e.applicationSettings.properties[u]=s;break;case 2:e.machineSettings.properties[u]=s;break;case 6:e.machineOverridableSettings.properties[u]=s;break;case 3:e.windowSettings.properties[u]=s;break;case 4:e.resourceSettings.properties[u]=s;break;case 5:e.resourceSettings.properties[u]=s,this.resourceLanguageSettingsSchema.properties[u]=s;break}}removeFromSchema(u,s){switch(delete e.allSettings.properties[u],s.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u],delete this.resourceLanguageSettingsSchema.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const s=`[${u}]`,l={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(s,l),e.allSettings.properties[s]=l,e.applicationSettings.properties[s]=l,e.machineSettings.properties[s]=l,e.machineOverridableSettings.properties[s]=l,e.windowSettings.properties[s]=l,e.resourceSettings.properties[s]=l}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const u={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=u,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,s){const l=this.configurationDefaultsOverrides.get(u);let r=l?.value,i=l?.source;C.isUndefined(r)&&(r=s.defaultDefaultValue,i=void 0),C.isUndefined(r)&&(r=E(s.type)),s.default=r,s.defaultValueSource=i}}const m="\\[([^\\]]+)\\]",y=new RegExp(m,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${m})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function t(a){const u=[];if(e.OVERRIDE_PROPERTY_REGEX.test(a)){let s=y.exec(a);for(;s?.length;){const l=s[1].trim();l&&u.push(l),s=y.exec(a)}}return(0,p.distinct)(u)}e.overrideIdentifiersFromKey=t;function g(a){return a.reduce((u,s)=>`${u}[${s}]`,"")}e.keyFromOverrideIdentifiers=g;function E(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const v=new b;I.Registry.add(e.Extensions.Configuration,v);function P(a){return a.trim()?e.OVERRIDE_PROPERTY_REGEX.test(a)?M.localize(7,null,a):v.getConfigurationProperties()[a]!==void 0?M.localize(8,null,a):null:M.localize(6,null)}e.validateProperty=P;function c(){const a=[],u=v.getConfigurationProperties();for(const s of Object.keys(u))a.push([s,u[s].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.getScopes=c}),define(Z[191],x([0,1,30,4,38,2,39,47,13,7,19,56,40]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class y{constructor(r={},i=[],o=[]){this._contents=r,this._keys=i,this._overrides=o,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,S.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const o=this.getContentsForOverrideIdentifer(i);return o?r?(0,S.getConfigurationValue)(o,r):o:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const o of this.overrides)o.identifiers.includes(r)&&i.push(...o.keys);return p.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return p.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=I.deepClone(this.contents),o=I.deepClone(this.overrides),h=[...this.keys];for(const w of r){this.mergeContents(i,w.contents);for(const k of w.overrides){const[A]=o.filter(R=>p.equals(R.identifiers,k.identifiers));A?(this.mergeContents(A.contents,k.contents),A.keys.push(...k.keys),A.keys=p.distinct(A.keys)):o.push(I.deepClone(k))}for(const k of w.keys)h.indexOf(k)===-1&&h.push(k)}return new y(i,h,o)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let o={};for(const h of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let w=this.contents[h],k=i[h];k&&(typeof w=="object"&&typeof k=="object"?(w=I.deepClone(w),this.mergeContents(w,k)):w=k),o[h]=w}return new y(o,this.keys,this.overrides)}mergeContents(r,i){for(const o of Object.keys(i)){if(o in r&&d.isObject(r[o])&&d.isObject(i[o])){this.mergeContents(r[o],i[o]);continue}r[o]=I.deepClone(i[o])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?I.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,o=null;const h=w=>{w&&(o?this.mergeContents(o,w):o=I.deepClone(w))};for(const w of this.overrides)p.equals(w.identifiers,[r])?i=w.contents:w.identifiers.includes(r)&&h(w.contents);return h(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,S.addToValueTree)(this.contents,r,i,o=>{throw new Error(o)})}removeValue(r){this.removeKey(r)&&(0,S.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let o=0;o<i;o++)r.indexOf(this.keys[o])===0&&(i=o);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=y;class t extends y{constructor(r={}){const i=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(i),h=Object.create(null),w=[];for(const k in i){const A=r[k],R=A!==void 0?A:i[k].default;(0,S.addToValueTree)(h,k,R,T=>console.error(`Conflict in default settings: ${T}`))}for(const k of Object.keys(h))b.OVERRIDE_PROPERTY_REGEX.test(k)&&w.push({identifiers:(0,b.overrideIdentifiersFromKey)(k),keys:Object.keys(h[k]),contents:(0,S.toValuesTree)(h[k],A=>console.error(`Conflict in default settings file: ${A}`))});super(h,o,w)}}e.DefaultConfigurationModel=t;class g{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!d.isUndefinedOrNull(r)){const o=this.doParseContent(r);this.parseRaw(o,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:o,keys:h,overrides:w,restricted:k}=this.doParseRaw(r,i);this._configurationModel=new y(o,h,w),this._restrictedConfigurations=k||[]}doParseContent(r){let i={},o=null,h=[],w=[],k=[];function A(T){Array.isArray(h)?h.push(T):o!==null&&(h[o]=T)}let R={onObjectBegin:()=>{let T={};A(T),w.push(h),h=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{h=w.pop()},onArrayBegin:()=>{let T=[];A(T),w.push(h),h=T,o=null},onArrayEnd:()=>{h=w.pop()},onLiteralValue:A,onError:(T,_,Q)=>{k.push({error:T,offset:_,length:Q})}};if(r)try{C.visit(r,R),i=h[0]||{}}catch(T){console.error(`Error while parsing settings file ${this._name}: ${T}`),this._parseErrors=[T]}return i}doParseRaw(r,i){const o=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),h=this.filter(r,o,!0,i);r=h.raw;const w=(0,S.toValuesTree)(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`)),k=Object.keys(r),A=this.toOverrides(r,R=>console.error(`Conflict in settings file ${this._name}: ${R}`));return{contents:w,keys:k,overrides:A,restricted:h.restricted}}filter(r,i,o,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:r,restricted:[]};const w={},k=[];for(let A in r)if(b.OVERRIDE_PROPERTY_REGEX.test(A)&&o){const R=this.filter(r[A],i,!1,h);w[A]=R.raw,k.push(...R.restricted)}else{const R=i[A],T=R?typeof R.scope!="undefined"?R.scope:3:void 0;R?.restricted&&k.push(A),(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&(h.skipRestricted&&R?.restricted||(w[A]=r[A]))}return{raw:w,restricted:k}}toOverrides(r,i){const o=[];for(const h of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(h)){const w={};for(const k in r[h])w[k]=r[h][k];o.push({identifiers:(0,b.overrideIdentifiersFromKey)(h),keys:Object.keys(w),contents:(0,S.toValuesTree)(w,i)})}return o}}e.ConfigurationModelParser=g;class E extends M.Disposable{constructor(r,i,o,h){super();this.userSettingsResource=r,this.scopes=i,this.fileService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new g(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,w=>w.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(r){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(r,i,o=new y,h=new y,w=new n.ResourceMap,k=new y,A=new n.ResourceMap,R=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=o,this._workspaceConfiguration=h,this._folderConfigurations=w,this._memoryConfiguration=k,this._memoryConfigurationByResource=A,this._freeze=R,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(r,i,o){return this.getConsolidateConfigurationModel(i,o).getValue(r)}updateValue(r,i,o={}){let h;o.resource?(h=this._memoryConfigurationByResource.get(o.resource),h||(h=new y,this._memoryConfigurationByResource.set(o.resource,h))):h=this._memoryConfiguration,i===void 0?h.removeValue(r):h.setValue(r,i),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,o){const h=this.getConsolidateConfigurationModel(i,o),w=this.getFolderConfigurationModelForResource(i.resource,o),k=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,A=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),R=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),T=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),_=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),Q=o?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,ne=w?i.overrideIdentifier?w.freeze().override(i.overrideIdentifier).getValue(r):w.freeze().getValue(r):void 0,oe=i.overrideIdentifier?k.override(i.overrideIdentifier).getValue(r):k.getValue(r),X=h.getValue(r),O=p.distinct(p.flatten(h.overrides.map(H=>H.identifiers))).filter(H=>h.getOverrideValue(r,H)!==void 0);return{defaultValue:A,userValue:R,userLocalValue:T,userRemoteValue:_,workspaceValue:Q,workspaceFolderValue:ne,memoryValue:oe,value:X,default:A!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:R!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:T!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:_!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:Q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:ne!==void 0?{value:w?.freeze().getValue(r),override:i.overrideIdentifier?w?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:oe!==void 0?{value:k.getValue(r),override:i.overrideIdentifier?k.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:O.length?O:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const o=[];if(!i){const{added:h,updated:w,removed:k}=u(this._defaultConfiguration,r);i=[...h,...w,...k]}for(const h of i)for(const w of(0,b.overrideIdentifiersFromKey)(h)){const k=this._defaultConfiguration.getKeysForOverrideIdentifier(w),A=r.getKeysForOverrideIdentifier(w),R=[...A.filter(T=>k.indexOf(T)===-1),...k.filter(T=>A.indexOf(T)===-1),...k.filter(T=>!I.equals(this._defaultConfiguration.override(w).getValue(T),r.override(w).getValue(T)))];o.push([w,R])}return this.updateDefaultConfiguration(r),{keys:i,overrides:o}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:w}=u(this.localUserConfiguration,r),k=[...i,...o,...h];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:w}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:o,removed:h,overrides:w}=u(this.remoteUserConfiguration,r);let k=[...i,...o,...h];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:w}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:o,removed:h,overrides:w}=u(this.workspaceConfiguration,r);let k=[...i,...o,...h];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:w}}compareAndUpdateFolderConfiguration(r,i){const o=this.folderConfigurations.get(r),{added:h,updated:w,removed:k,overrides:A}=u(o,i);let R=[...h,...w,...k];return(R.length||!o)&&this.updateFolderConfiguration(r,i),{keys:R,overrides:A}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:o,updated:h,removed:w,overrides:k}=u(i,void 0);return{keys:[...o,...h,...w],overrides:k}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let o=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?o.override(r.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:r},i){let o=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const h=i.getFolder(r);h&&(o=this.getFolderConsolidatedConfiguration(h.uri)||o);const w=this._memoryConfigurationByResource.get(r);w&&(o=o.merge(w))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const o=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(r);h?(i=o.merge(h),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=o}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const o=i.getFolder(r);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:o,overrides:h,keys:w}=this._folderConfigurations.get(i);return r.push([i,{contents:o,overrides:h,keys:w}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(o=>r.add(o))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(o=>r.add(o))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(o=>i.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(r).forEach(h=>i.add(h))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),o=this.parseConfigurationModel(r.user),h=this.parseConfigurationModel(r.workspace),w=r.folders.reduce((k,A)=>(k.set(f.URI.revive(A[0]),this.parseConfigurationModel(A[1])),k),new n.ResourceMap);return new v(i,o,new y,h,w,new y,new n.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=v;function P(...l){if(l.length===0)return{keys:[],overrides:[]};if(l.length===1)return l[0];const r=new Set,i=new Map;for(const h of l)h.keys.forEach(w=>r.add(w)),h.overrides.forEach(([w,k])=>{const A=(0,n.getOrSet)(i,w,new Set);k.forEach(R=>A.add(R))});const o=[];return i.forEach((h,w)=>o.push([w,[...h.values()]])),{keys:[...r.values()],overrides:o}}e.mergeChanges=P;class c{constructor(r,i,o,h){this.change=r,this.previous=i,this.currentConfiguraiton=o,this.currentWorkspace=h,this._previousConfiguration=void 0;const w=new Set;r.keys.forEach(A=>w.add(A)),r.overrides.forEach(([,A])=>A.forEach(R=>w.add(R))),this.affectedKeys=[...w.values()];const k=new y;this.affectedKeys.forEach(A=>k.setValue(A,{})),this.affectedKeysTree=k.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!I.equals(o,h)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let o=(0,S.toValuesTree)({[i]:!0},()=>{}),h;for(;typeof o=="object"&&(h=Object.keys(o)[0]);){if(r=r[h],!r)return!1;o=o[h]}return!0}}e.ConfigurationChangeEvent=c;class a extends c{constructor(r,i,o,h){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=o,this.sourceConfig=h}}e.AllKeysConfigurationChangeEvent=a;function u(l,r){const{added:i,removed:o,updated:h}=s(r,l),w=[],k=l?.getAllOverrideIdentifiers()||[],A=r?.getAllOverrideIdentifiers()||[];if(r){const R=A.filter(T=>!k.includes(T));for(const T of R)w.push([T,r.getKeysForOverrideIdentifier(T)])}if(l){const R=k.filter(T=>!A.includes(T));for(const T of R)w.push([T,l.getKeysForOverrideIdentifier(T)])}if(r&&l){for(const R of k)if(A.includes(R)){const T=s({contents:l.getOverrideValue(void 0,R)||{},keys:l.getKeysForOverrideIdentifier(R)},{contents:r.getOverrideValue(void 0,R)||{},keys:r.getKeysForOverrideIdentifier(R)});w.push([R,[...T.added,...T.removed,...T.updated]])}}return{added:i,removed:o,updated:h,overrides:w}}function s(l,r){const i=l?r?l.keys.filter(w=>r.keys.indexOf(w)===-1):[...l.keys]:[],o=r?l?r.keys.filter(w=>l.keys.indexOf(w)===-1):[...r.keys]:[],h=[];if(l&&r){for(const w of r.keys)if(l.keys.indexOf(w)!==-1){const k=(0,S.getConfigurationValue)(r.contents,w),A=(0,S.getConfigurationValue)(l.contents,w);I.equals(k,A)||h.push(w)}}return{added:i,removed:o,updated:h}}}),define(Z[192],x([0,1,9,4,2,15,19,191,56,40]),function(j,e,p,D,C,M,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class S extends C.Disposable{constructor(m,y){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,y)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(f.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:t})=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,y){const t=typeof m=="string"?m:void 0,g=(0,n.isConfigurationOverrides)(m)?m:(0,n.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(t,g,void 0)}updateValue(m,y,t,g){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(t,y,1)}onDidDefaultConfigurationChange(m){const y=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,m);this.trigger(t,y,6)}trigger(m,y,t){const g=new I.ConfigurationChangeEvent(m,{data:y},this.configuration);g.source=t,g.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(g)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=S}),define(Z[193],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var D;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(n,I=D.Unknown,d){super(n);this._message=n,this._code=I,this._detail=d,this.isHandled=I===D.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(n){return n instanceof C&&n._code===D.TemporarilyNotAvailable}static isNoResolverFound(n){return n instanceof C&&n._code===D.NoResolverFound}static isHandled(n){return n instanceof C&&n.isHandled}}e.RemoteAuthorityResolverError=C}),define(Z[194],x([0,1,9,17,23,16,4,2,31,84,193]),function(j,e,p,D,C,M,n,I,d,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const b=30*1e3;var m;(function(B){B[B.Management=1]="Management",B[B.ExtensionHost=2]="ExtensionHost",B[B.Tunnel=3]="Tunnel"})(m=e.ConnectionType||(e.ConnectionType={}));function y(B){switch(B){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(B){const L=new C.CancellationTokenSource;return setTimeout(()=>L.cancel(),B),L.token}function g(B,L){if(B.isCancellationRequested||L.isCancellationRequested)return C.CancellationToken.Cancelled;const W=new C.CancellationTokenSource;return B.onCancellationRequested(()=>W.cancel()),L.onCancellationRequested(()=>W.cancel()),W.token}class E{constructor(L){this._state="pending",this._disposables=new I.DisposableStore,this.promise=new Promise((W,F)=>{this._resolvePromise=W,this._rejectPromise=F}),L.isCancellationRequested?this._timeout():this._disposables.add(L.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(L){this._state==="pending"?this._disposables.add(L):L.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const L=new Error("Time limit reached");return L.code="ETIMEDOUT",L.syscall="connect",L}resolve(L){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(L))}reject(L){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(L))}}function v(B,L){const W=new E(L);return W.registerDisposable(B.onControlMessage(F=>{const N=JSON.parse(F.toString()),V=q(N);V?W.reject(V):W.resolve(N)})),W.promise}function P(B,L,W,F,N,V,U){const z=new E(U);return L.connect(W,F,N,V,(te,re)=>{z.didTimeout?(te&&B.error(te),re?.dispose()):te||!re?z.reject(te):z.resolve(re)}),z.promise}function c(B,L){const W=new E(L);return B.then(F=>{W.didTimeout||W.resolve(F)},F=>{W.didTimeout||W.reject(F)}),W.promise}async function a(B,L,W,F){const N=K(B,L);B.logService.trace(`${N} 1/6. invoking socketFactory.connect().`);let V;try{V=await P(B.logService,B.socketFactory,B.host,B.port,`reconnectionToken=${B.reconnectionToken}&reconnection=${B.reconnectionProtocol?"true":"false"}`,`renderer-${y(L)}-${B.reconnectionToken}`,F)}catch(se){throw B.logService.error(`${N} socketFactory.connect() failed or timed out. Error:`),B.logService.error(se),se}B.logService.trace(`${N} 2/6. socketFactory.connect() was successful.`);let U,z;B.reconnectionProtocol?(B.reconnectionProtocol.beginAcceptReconnection(V,null),U=B.reconnectionProtocol,z=!1):(U=new f.PersistentProtocol(V,null),z=!0),B.logService.trace(`${N} 3/6. sending AuthRequest control message.`);const te=await c(B.signService.createNewMessage((0,d.generateUuid)()),F),re={type:"auth",auth:B.connectionToken||"00000000000000000000",data:te.data};U.sendControl(D.VSBuffer.fromString(JSON.stringify(re)));try{const se=await v(U,g(F,t(1e4)));if(se.type!=="sign"||typeof se.data!="string"){const he=new Error("Unexpected handshake message");throw he.code="VSCODE_CONNECTION_ERROR",he}if(B.logService.trace(`${N} 4/6. received SignRequest control message.`),!await c(B.signService.validate(te,se.signedData),F)){const he=new Error("Refused to connect to unsupported server");throw he.code="VSCODE_CONNECTION_ERROR",he}const ce=await c(B.signService.sign(se.data),F),le={type:"connectionType",commit:B.commit,signedData:ce,desiredConnectionType:L};return W&&(le.args=W),B.logService.trace(`${N} 5/6. sending ConnectionTypeRequest control message.`),U.sendControl(D.VSBuffer.fromString(JSON.stringify(le))),{protocol:U,ownsProtocol:z}}catch(se){throw se&&se.code==="ETIMEDOUT"&&(B.logService.error(`${N} the handshake timed out. Error:`),B.logService.error(se)),se&&se.code==="VSCODE_CONNECTION_ERROR"&&(B.logService.error(`${N} received error control message when negotiating connection. Error:`),B.logService.error(se)),z&&H(U),se}}async function u(B,L,W,F){const N=Date.now(),V=K(B,L),{protocol:U,ownsProtocol:z}=await a(B,L,W,F),te=new E(F);return te.registerDisposable(U.onControlMessage(re=>{const se=JSON.parse(re.toString()),J=q(se);J?(B.logService.error(`${V} received error control message when negotiating connection. Error:`),B.logService.error(J),z&&H(U),te.reject(J)):(B.reconnectionProtocol&&B.reconnectionProtocol.endAcceptReconnection(),B.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${ee(N)}!`),te.resolve({protocol:U,firstMessage:se}))})),te.promise}async function s(B,L){const{protocol:W}=await u(B,1,void 0,L);return{protocol:W}}async function l(B,L,W){const{protocol:F,firstMessage:N}=await u(B,2,L,W),V=N&&N.debugPort;return{protocol:F,debugPort:V}}async function r(B,L,W){const F=Date.now(),N=K(B,3),{protocol:V}=await a(B,3,L,W);return B.logService.trace(`${N} 6/6. handshake finished, connection is up and running after ${ee(F)}!`),V}async function i(B,L,W){const{host:F,port:N,connectionToken:V}=await B.addressProvider.getAddress();return{commit:B.commit,host:F,port:N,connectionToken:V,reconnectionToken:L,reconnectionProtocol:W,socketFactory:B.socketFactory,signService:B.signService,logService:B.logService}}async function o(B,L,W){try{const F=(0,d.generateUuid)(),N=await i(B,F,null),{protocol:V}=await s(N,C.CancellationToken.None);return new X(B,L,W,F,V)}catch(F){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(F),oe.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(F)),F}}e.connectRemoteAgentManagement=o;async function h(B,L){try{const W=(0,d.generateUuid)(),F=await i(B,W,null),{protocol:N,debugPort:V}=await l(F,L,C.CancellationToken.None);return new O(B,L,W,N,V)}catch(W){throw B.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),B.logService.error(W),oe.triggerPermanentFailure(0,0,S.RemoteAuthorityResolverError.isHandled(W)),W}}e.connectRemoteAgentExtensionHost=h;async function w(B,L,W){const F=await i(B,(0,d.generateUuid)(),null);return await r(F,{host:L,port:W},C.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function k(B){return(0,p.createCancelablePromise)(L=>new Promise((W,F)=>{const N=setTimeout(W,B*1e3);L.onCancellationRequested(()=>{clearTimeout(N),W()})}))}var A;(function(B){B[B.ConnectionLost=0]="ConnectionLost",B[B.ReconnectionWait=1]="ReconnectionWait",B[B.ReconnectionRunning=2]="ReconnectionRunning",B[B.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",B[B.ConnectionGain=4]="ConnectionGain"})(A=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class R{constructor(L,W){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.type=0}}e.ConnectionLostEvent=R;class T{constructor(L,W,F,N){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.durationSeconds=F,this.cancellableTimer=N,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=T;class _{constructor(L,W,F){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=2}}e.ReconnectionRunningEvent=_;class Q{constructor(L,W,F){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.type=4}}e.ConnectionGainEvent=Q;class ne{constructor(L,W,F,N){this.reconnectionToken=L,this.millisSinceLastIncomingData=W,this.attempt=F,this.handled=N,this.type=3}}e.ReconnectionPermanentFailureEvent=ne;class oe extends I.Disposable{constructor(L,W,F,N){super();this._connectionType=L,this._onDidStateChange=this._register(new n.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=W,this.reconnectionToken=F,this.protocol=N,this._isReconnecting=!1,this._onDidStateChange.fire(new Q(this.reconnectionToken,0,0)),this._register(N.onSocketClose(V=>{const U=$(this._connectionType,this.reconnectionToken,!0);V?V.type===0?(this._options.logService.info(`${U} received socket close event (hadError: ${V.hadError}).`),V.error&&this._options.logService.error(V.error)):(this._options.logService.info(`${U} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this._options.logService.error(V.event)):this._options.logService.info(`${U} received socket close event.`),this._beginReconnecting()})),this._register(N.onSocketTimeout(()=>{const V=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${V} received socket timeout event.`),this._beginReconnecting()})),oe._instances.push(this),oe._permanentFailure&&this._gotoPermanentFailure(oe._permanentFailureMillisSinceLastIncomingData,oe._permanentFailureAttempt,oe._permanentFailureHandled)}static triggerPermanentFailure(L,W,F){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=L,this._permanentFailureAttempt=W,this._permanentFailureHandled=F,this._instances.forEach(N=>N._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(L=>L._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(L=>L._pauseSocketWriting())}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(oe._permanentFailure)return;const L=$(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${L} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new R(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const W=[0,5,5,10,10,10,10,10,30];let F=-1;do{F++;const N=F<W.length?W[F]:W[W.length-1];try{if(N>0){const U=k(N);this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),N,U)),this._options.logService.info(`${L} waiting for ${N} seconds before reconnecting...`);try{await U}catch{}}if(oe._permanentFailure){this._options.logService.error(`${L} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new _(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1)),this._options.logService.info(`${L} resolving connection...`);const V=await i(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${L} connecting to ${V.host}:${V.port}...`),await this._reconnect(V,t(b)),this._options.logService.info(`${L} reconnected!`),this._onDidStateChange.fire(new Q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),F+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${L} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(F>360){this._options.logService.error(`${L} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}if(S.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this._options.logService.info(`${L} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this._options.logService.info(`${L} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if((0,M.isPromiseCanceledError)(V)){this._options.logService.info(`${L} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(V);continue}if(V instanceof S.RemoteAuthorityResolverError){this._options.logService.error(`${L} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,S.RemoteAuthorityResolverError.isHandled(V));break}this._options.logService.error(`${L} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(V),oe.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),F+1,!1);break}}while(!oe._permanentFailure)}_gotoPermanentFailure(L,W,F){this._onDidStateChange.fire(new ne(this.reconnectionToken,L,W,F)),H(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=oe,oe._permanentFailure=!1,oe._permanentFailureMillisSinceLastIncomingData=0,oe._permanentFailureAttempt=0,oe._permanentFailureHandled=!1,oe._instances=[];class X extends oe{constructor(L,W,F,N,V){super(1,L,N,V);this.client=this._register(new f.Client(V,{remoteAuthority:W,clientId:F},L.ipcLogger))}async _reconnect(L,W){await s(L,W)}}e.ManagementPersistentConnection=X;class O extends oe{constructor(L,W,F,N,V){super(2,L,F,N);this._startArguments=W,this.debugPort=V}async _reconnect(L,W){await l(L,this._startArguments,W)}}e.ExtensionHostPersistentConnection=O;function H(B){try{B.acceptDisconnect();const L=B.getSocket();B.dispose(),L.dispose()}catch(L){(0,M.onUnexpectedError)(L)}}function q(B){if(B&&B.type==="error"){const L=new Error(`Connection error: ${B.reason}`);return L.code="VSCODE_CONNECTION_ERROR",L}return null}function Y(B,L){for(;B.length<L;)B+=" ";return B}function $(B,L,W){return`[remote-connection][${Y(y(B),13)}][${L.substr(0,5)}\u2026][${W?"reconnect":"initial"}]`}function K(B,L){return`${$(L,B.reconnectionToken,!!B.reconnectionProtocol)}[${B.host}:${B.port}]`}function ee(B){return`${Date.now()-B} ms`}}),define(Z[64],x([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function D(f){return f.scheme===p.Schemas.vscodeRemote?f.authority:void 0}e.getRemoteAuthority=D;function C(f){if(!f)return;const S=f.indexOf("+");return S<0?f:f.substr(0,S)}e.getRemoteName=C;function M(f){return f.scheme!==p.Schemas.file&&f.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function n(f){if(f.folders.length)return f.folders.every(S=>M(S.uri))?f.folders[0].uri:void 0;if(f.configuration&&M(f.configuration))return f.configuration}e.getVirtualWorkspaceLocation=n;function I(f){return n(f)?.scheme}e.getVirtualWorkspaceScheme=I;function d(f){return n(f)!==void 0}e.isVirtualWorkspace=d}),define(Z[195],x([0,1,25,5,64]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(m){if(typeof m=="object"&&m!==null&&m.supported!==!0)return m.description}e.getWorkspaceSupportTypeMessage=M;function n(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=n,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(m){m[m.System=0]="System",m[m.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class d{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,t){if(typeof y=="undefined"||y===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof y=="string"||typeof t=="string"){let g=typeof y=="string"?y:y.value,E=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(g,E)}return y._lower===t._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}e.ExtensionIdentifier=d;function f(m){return m.contributes&&m.contributes.localizations?m.contributes.localizations.length>0:!1}e.isLanguagePackExtension=f;function S(m){return m.contributes&&m.contributes.authentication?m.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function b(m,y){if(y){const t=`onResolveRemoteAuthority:${(0,C.getRemoteName)(y)}`;return m.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[196],x([0,1,25,195]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(t,g){return t.uuid&&g.uuid?t.uuid===g.uuid:t.id===g.id?!0:(0,p.compareIgnoreCase)(t.id,g.id)===0}e.areSameExtensions=C;class M{constructor(g,E){this.version=E,this.id=g.id,this.uuid=g.uuid}key(){return`${this.id}-${this.version}`}equals(g){return g instanceof M?C(this,g)&&this.version===g.version:!1}}e.ExtensionIdentifierWithVersion=M;function n(t,g){return`${t}.${g}`}e.getExtensionId=n;function I(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function d(t,g){return I(n(t,g))}e.getGalleryExtensionId=d;function f(t,g){const E=[],v=P=>{for(const c of E)if(c.some(a=>C(g(a),g(P))))return c;return null};for(const P of t){const c=v(P);c?c.push(P):E.push([P])}return E}e.groupByExtension=f;function S(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=S;function b(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function m(t){const g=new Set;if(t.malicious)for(const E of t.malicious)g.add(E.id);return g}e.getMaliciousExtensionsSet=m;function y(t,g){const E=[],v=g.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const P=v.shift();if(P&&E.every(c=>!C(c.identifier,{id:P}))){const c=t.filter(a=>C(a.identifier,{id:P}));c.length===1&&(E.push(c[0]),v.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=y}),define(Z[96],x([0,1,4,3,5,6]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,C.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,C.createDecorator)("sharedTunnelsService");var n;(function(t){t.Http="http",t.Https="https"})(n=e.TunnelProtocol||(e.TunnelProtocol={}));var I;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(I=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function f(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const g=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!g)return{address:g[1],port:+g[2]}}e.extractLocalHostUriMetaDataForPortMapping=f,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=S,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=b;function m(t,g){return g?g!==1&&t<1024:!D.isWindows&&t<1024}e.isPortPrivileged=m;let y=class{constructor(g){this.logService=g,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(g,E){return this._tunnelProvider=g,g?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const g=[],E=Array.from(this._tunnels.values());for(let v of E){const P=Array.from(v.values());for(let c of P){const a=await c.value;a&&g.push(a)}}return g}async dispose(){for(const g of this._tunnels.values()){for(const{value:E}of g.values())await E.then(v=>v?.dispose());g.clear()}this._tunnels.clear()}openTunnel(g,E,v,P,c=!1,a=I.Private,u){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${v} on local port ${P}.`),!g)return;E||(E="localhost");const s=this.retainOrCreateTunnel(g,E,v,P,c,a,u);return s?s.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(l);return(l.tunnelRemoteHost!==E||l.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),s)}makeTunnel(g){return{tunnelRemotePort:g.tunnelRemotePort,tunnelRemoteHost:g.tunnelRemoteHost,tunnelLocalPort:g.tunnelLocalPort,localAddress:g.localAddress,privacy:g.privacy,protocol:g.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${g.tunnelRemoteHost}:${g.tunnelRemotePort} `);const E=this._tunnels.get(g.tunnelRemoteHost);if(E){const v=E.get(g.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(g.tunnelRemoteHost,g.tunnelRemotePort,v))}}}}async tryDisposeTunnel(g,E,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${g}:${E}.`);const P=v.value.then(async c=>{c&&(await c.dispose(!0),this._onTunnelClosed.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this._tunnels.has(g)&&this._tunnels.get(g).delete(E),P}}async closeTunnel(g,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${g}:${E} `);const v=this._tunnels.get(g);if(v&&v.has(E)){const P=v.get(E);P.refcount=0,await this.tryDisposeTunnel(g,E,P)}}addTunnelToMap(g,E,v){this._tunnels.has(g)||this._tunnels.set(g,new Map),this._tunnels.get(g).set(E,{refcount:1,value:v})}async removeEmptyTunnelFromMap(g,E){const v=this._tunnels.get(g);v&&(await v.get(E)||v.delete(E),v.size===0&&this._tunnels.delete(g))}getTunnelFromMap(g,E){let v=[g];S(g)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):b(g)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const P=v.map(c=>this._tunnels.get(c));for(const c of P){const a=c?.get(E);if(a)return a}}canTunnel(g){return!!f(g)}createWithProvider(g,E,v,P,c,a,u){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${v} on local port ${P}.`);const l={elevationRequired:c?m(P===void 0?v:P):!1},r={remoteAddress:{host:E,port:v},localAddressPort:P,privacy:a,public:a!==I.Private,protocol:u},i=g.forwardPort(r,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(E,v,i),i}};y=de([ie(0,M.ILogService)],y),e.AbstractTunnelService=y}),define(Z[49],x([0,1,17,151,56,5,40]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function I(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=I;function d(t){return t.res.statusCode===204}async function f(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=f;async function S(t){if(!I(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const E=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(E)}catch(v){throw v.message+=`:
`+E,v}}e.asJson=S;function b(t){y(t)}e.updateProxyConfigurationsScope=b;let m;function y(t){const g=n.Registry.as(C.Extensions.Configuration),E=m;m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},g.updateConfigurations({add:[m],remove:E?[E]:[]})}y(2)}),define(Z[197],x([0,1,198,13]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function C(n,I){return n.protocol==="http:"?I.HTTP_PROXY||I.http_proxy||null:n.protocol==="https:"&&(I.HTTPS_PROXY||I.https_proxy||I.HTTP_PROXY||I.http_proxy)||null}async function M(n,I,d={}){const f=(0,p.parse)(n),S=d.proxyUrl||C(f,I);if(!S)return null;const b=(0,p.parse)(S);if(!/^https?:$/.test(b.protocol||""))return null;const m={host:b.hostname||"",port:b.port||(b.protocol==="https"?"443":"80"),auth:b.auth,rejectUnauthorized:(0,D.isBoolean)(d.strictSSL)?d.strictSSL:!0};return f.protocol==="http:"?new(await new Promise((y,t)=>{j(["http-proxy-agent"],y,t)}))(m):new(await new Promise((y,t)=>{j(["https-proxy-agent"],y,t)}))(m)}e.getProxyAgent=M}),define(Z[199],x([0,1,17,31]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function C(M,n,I){let d=I&&I.get("storage.serviceMachineId",0)||null;if(d)return d;try{const S=(await n.readFile(M.serviceMachineIdResource)).value.toString();d=(0,D.isUUID)(S)?S:null}catch(f){d=null}if(!d){d=(0,D.generateUuid)();try{await n.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(d))}catch(f){}}return I&&I.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=C}),define(Z[76],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Z[200],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{constructor(){this.validators=new Map}vsda(){return new Promise((C,M)=>j(["vsda"],C,M))}async createNewMessage(C){try{const M=await this.vsda(),n=new M.validator;if(n){const I=String(p._nextId++);return this.validators.set(I,n),{id:I,data:n.createNewMessage(C)}}}catch(M){}return{id:"",data:C}}async validate(C,M){if(!C.id)return!0;const n=this.validators.get(C.id);if(!n)return!1;this.validators.delete(C.id);try{return n.validate(M)==="ok"}catch(I){return!1}}async sign(C){try{const M=await this.vsda(),n=new M.signer;if(n)return n.sign(C)}catch(M){}return C}}e.SignService=p,p._nextId=1}),define(Z[37],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Z[20],x([0,1,14,9,4,2,3,34,13,5,179,6,37]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,f.createDecorator)("lifecycleMainService");var y;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen"})(y=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class dt extends M.Disposable{constructor(E,v){super();this.logService=E,this.stateMainService=v,this._onBeforeShutdown=this._register(new C.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new C.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new C.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new C.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new C.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(dt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(dt.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),n.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown())};p.app.addListener("before-quit",E);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!n.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",P=>{this.logService.trace("Lifecycle#app.on(will-quit)"),P.preventDefault(),this.fireOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",E),p.app.removeListener("window-all-closed",v),p.app.quit()})})}fireOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(v){E.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(E)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let v=this.phaseWhen.get(E);v||(v=new D.Barrier,this.phaseWhen.set(E,v)),await v.wait()}registerWindow(E){const v=new M.DisposableStore;this.windowCounter++,v.add(E.onWillLoad(c=>this._onWillLoadWindow.fire({window:E,workspace:c.workspace,reason:c.reason})));const P=(0,d.assertIsDefined)(E.win);P.on("close",c=>{const a=E.id;if(this.windowToCloseRequest.has(a)){this.windowToCloseRequest.delete(a);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),c.preventDefault(),this.unload(E,1).then(u=>{if(u){this.windowToCloseRequest.delete(a);return}this.windowToCloseRequest.add(a),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${a}`),this._onBeforeCloseWindow.fire(E),E.close()})}),P.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!n.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown()})}async reload(E,v){await this.unload(E,3)||E.reload(v)}async unload(E,v){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const P=this._quitRequested?2:v;let c=await this.onBeforeUnloadWindowInRenderer(E,P);return c?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(c=await this.onBeforeUnloadWindowInMain(E,P),c?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(c)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,P),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,v){return new Promise(P=>{const c=this.oneTimeListenerTokenGenerator++,a=`vscode:ok${c}`,u=`vscode:cancel${c}`;p.ipcMain.once(a,()=>{P(!1)}),p.ipcMain.once(u,()=>{P(!0)}),E.send("vscode:onBeforeUnload",{okChannel:a,cancelChannel:u,reason:v})})}onBeforeUnloadWindowInMain(E,v){const P=[];return this._onBeforeUnloadWindow.fire({reason:v,window:E,veto(c){P.push(c)}}),(0,S.handleVetos)(P,c=>this.logService.error(c))}onWillUnloadWindowInRenderer(E,v){return new Promise(P=>{const a=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(a,()=>P()),E.send("vscode:onWillUnload",{replyChannel:a,reason:v})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(dt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(E?.addArgs&&v.push(...E.addArgs),E?.removeArgs)for(const a of E.removeArgs){const u=v.indexOf(a);u>=0&&v.splice(u,1)}const P=()=>{try{if(n.isWindows){const a=(0,I.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.logService.error(a)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",P),await this.quit(!0)&&p.app.removeListener("quit",P)}async kill(E){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let P;v.webContents&&!v.webContents.isDestroyed()?P=new Promise(c=>v.once("closed",c)):P=Promise.resolve(),v.destroy(),await P}})()]),p.app.exit(E)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=de([ie(0,b.ILogService),ie(1,m.IStateMainService)],t),e.LifecycleMainService=t}),define(Z[201],x([0,1,4,2,5,20]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,C.createDecorator)("keyboardLayoutMainService");let n=class extends D.Disposable{constructor(f){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,f.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const f=await new Promise((S,b)=>{j(["native-keymap"],S,b)});this._keyboardLayoutData=I(f),f.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=I(f),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};n=de([ie(0,M.ILifecycleMainService)],n),e.KeyboardLayoutMainService=n;function I(d){const f=d.getKeyMap(),S=d.getCurrentKeyboardLayout();return{keyboardMapping:f,keyboardLayoutInfo:S}}}),define(Z[97],x([0,1,9,4,2,63,13,86,5]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const f="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var S;(function(E){E[E.NONE=0]="NONE",E[E.SHUTDOWN=1]="SHUTDOWN"})(S=e.WillSaveStateReason||(e.WillSaveStateReason={}));var b;(function(E){E[E.GLOBAL=0]="GLOBAL",E[E.WORKSPACE=1]="WORKSPACE"})(b=e.StorageScope||(e.StorageScope={}));var m;(function(E){E[E.USER=0]="USER",E[E.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class y extends C.Disposable{constructor(v={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=v,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new C.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,C.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,M.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,M.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(v,P){P===f?(v===0?this._globalKeyTargets=void 0:v===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:v})):this._onDidChangeValue.fire({scope:v,key:P,target:this.getKeyTargets(v)[P]})}emitWillSaveState(v){this._onWillSaveState.fire({reason:v})}get(v,P,c){return this.getStorage(P)?.get(v,c)}getBoolean(v,P,c){return this.getStorage(P)?.getBoolean(v,c)}getNumber(v,P,c){return this.getStorage(P)?.getNumber(v,c)}store(v,P,c,a){if((0,n.isUndefinedOrNull)(P)){this.remove(v,c);return}this.withPausedEmitters(()=>{this.updateKeyTarget(v,c,a),this.getStorage(c)?.set(v,P)})}remove(v,P){this.withPausedEmitters(()=>{this.updateKeyTarget(v,P,void 0),this.getStorage(P)?.delete(v)})}withPausedEmitters(v){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{v()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(v,P){const c=[],a=this.getKeyTargets(v);for(const u of Object.keys(a))a[u]===P&&c.push(u);return c}updateKeyTarget(v,P,c){const a=this.getKeyTargets(P);typeof c=="number"?a[v]!==c&&(a[v]=c,this.getStorage(P)?.set(f,JSON.stringify(a))):typeof a[v]=="number"&&(delete a[v],this.getStorage(P)?.set(f,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(v){return v===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(v){const P=this.get(f,v);if(P)try{return JSON.parse(P)}catch(c){}return Object.create(null)}isNew(v){return this.getBoolean(e.IS_NEW_KEY,v)===!0}async flush(v=S.NONE){this._onWillSaveState.fire({reason:v});const P=this.getStorage(0),c=this.getStorage(1);switch(v){case S.NONE:await p.Promises.settled([P?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve()]);break;case S.SHUTDOWN:await p.Promises.settled([P?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve()]);break}}async logStorage(){const v=this.getStorage(0)?.items??new Map,P=this.getStorage(1)?.items??new Map;return g(v,P,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class t extends y{constructor(){super();this.globalStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new I.Storage(new I.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(v=>this.emitDidChangeValue(1,v))),this._register(this.globalStorage.onDidChangeStorage(v=>this.emitDidChangeValue(0,v)))}getStorage(v){return v===0?this.globalStorage:this.workspaceStorage}getLogDetails(v){return v===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(v){}}e.InMemoryStorageService=t;async function g(E,v,P,c){const a=h=>{try{return JSON.parse(h)}catch(w){return h}},u=new Map,s=new Map;E.forEach((h,w)=>{u.set(w,h),s.set(w,a(h))});const l=new Map,r=new Map;v.forEach((h,w)=>{l.set(w,h),r.set(w,a(h))}),console.group(`Storage: Global (path: ${P})`);let i=[];u.forEach((h,w)=>{i.push({key:w,value:h})}),console.table(i),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${c})`);let o=[];l.forEach((h,w)=>{o.push({key:w,value:h})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=g}),define(Z[202],x([0,1,3,34,7,31]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function n(f){if(p.platform===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}async function I(f,S,b,m,y,t,g,E,v,P){const c=Object.create(null);c["common.machineId"]=g,c.sessionID=(0,M.generateUuid)()+Date.now(),c.commitHash=y,c.version=t,c["common.platformVersion"]=(S||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,p.PlatformToString)(p.platform),c["common.nodePlatform"]=D.platform,c["common.nodeArch"]=m,c["common.product"]=P||"desktop";const a=d(E||[]);a&&(c["common.msftInternal"]=a);let u=0;const s=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),p.isLinuxSnap&&(c["common.snap"]="true");const l=n(b);l&&(c["common.platformDetail"]=l);try{const r=await f.readFile(C.URI.file(v));c["common.source"]=r.value.toString().slice(0,30)}catch(r){}return c}e.resolveCommonProperties=I;function d(f){const S=D.env.USERDNSDOMAIN;if(!S)return!1;const b=S.toLowerCase();return f.some(m=>b===m)}e.verifyMicrosoftInternalDomain=d}),define(Z[28],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var D;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(D=e.TelemetryLevel||(e.TelemetryLevel={}));var C;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(C=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Z[203],x([0,1,26,69,9,38,10,8,3,7,71,21,83,74,18,22,28]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(s,l){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}];let i;const o=p.homedir().toLowerCase();switch(process.platform){case"win32":i=[{tag:"gdrive",matcher:_=>/^[a-z]:\\(my drive|shared drives)\\/.test(_)||_.startsWith(o+"\\my drive\\")},{tag:"dropbox",matcher:_=>_.startsWith(o+"\\dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(o+"\\onedrive")},{tag:"box",matcher:_=>_.startsWith(o+"\\box\\")},{tag:"nextcloud",matcher:_=>_.startsWith(o+"\\nextcloud\\")},{tag:"owncloud",matcher:_=>_.startsWith(o+"\\owncloud\\")}];break;case"darwin":i=[{tag:"gdrive",matcher:_=>_.startsWith("/volumes/googledrive/")||_.startsWith(o+"/my drive/")},{tag:"dropbox",matcher:_=>_.startsWith(o+"/dropbox")},{tag:"onedrive",matcher:_=>_.startsWith(o+"/onedrive")||_.startsWith(o+"/library/cloudstorage/onedrive")},{tag:"icloud",matcher:_=>_.startsWith(o+"/library/mobile documents/")},{tag:"box",matcher:_=>_.startsWith(o+"/box/")},{tag:"nextcloud",matcher:_=>_.startsWith(o+"/nextcloud/")},{tag:"owncloud",matcher:_=>_.startsWith(o+"/owncloud/")}];break}const h=new Map,w=new Map,k=2e4;function A(_,Q,ne,oe){for(const O of i){const H=_.toLowerCase();O.matcher(H)&&w.set(O.tag,1)}const X=Q.substring(_.length+1);return C.Promises.withAsyncBody(async O=>{let H;try{H=await b.Promises.readdir(Q,{withFileTypes:!0})}catch($){O();return}if(oe.count>=k){oe.count+=H.length,oe.maxReached=!0,O();return}let q=H.length;if(q===0){O();return}let Y=H;oe.count+H.length>k&&(oe.maxReached=!0,q=k-oe.count,Y=H.slice(0,q)),oe.count+=H.length;for(const $ of Y)if($.isDirectory()){if(ne.includes($.name)||await A(_,(0,I.join)(Q,$.name),ne,oe),--q==0){O();return}}else{const K=$.name.lastIndexOf(".");if(K>=0){const ee=$.name.substring(K+1);ee&&h.set(ee,(h.get(ee)??0)+1)}for(const ee of r)ee.relativePathPattern?.test(X)!==!1&&ee.filePattern.test($.name)&&w.set(ee.tag,(w.get(ee.tag)??0)+1);if(--q==0){O();return}}})}const R={count:0,maxReached:!1};await A(s,s,l,R);const T=await a(s);return{configFiles:P(w),fileTypes:P(h),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:T}}e.collectWorkspaceStats=v;function P(s){return[...D.Iterable.map(s.entries(),([l,r])=>({name:l,count:r}))].sort((l,r)=>r.count-l.count)}function c(){const s={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(S.virtualMachineHint.value()*100)}%`},l=p.cpus();return l&&l.length>0&&(s.cpus=`${l[0].model} (${l.length} x ${l[0].speed})`),s}e.getMachineInfo=c;async function a(s){try{const l=new Map,r=(0,I.join)(s,".vscode","launch.json"),i=await b.Promises.readFile(r),o=[],h=(0,M.parse)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if((0,M.getNodeType)(h)==="object"&&h.configurations)for(const w of h.configurations){const k=w.type;k&&(l.has(k)?l.set(k,l.get(k)+1):l.set(k,1))}return P(l)}catch(l){return[]}}e.collectLaunchConfigs=a;let u=class{constructor(l,r){this.telemetryService=l,this.productService=r}formatMachineInfo(l){const r=[];return r.push(`OS Version:       ${l.os}`),r.push(`CPUs:             ${l.cpus}`),r.push(`Memory (System):  ${l.memory}`),r.push(`VM:               ${l.vmHint}`),r.join(`
`)}formatEnvironment(l){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const i=p.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||r.push(`Load (avg):       ${p.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(S.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${l.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${l.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(l.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(l,r){return Promise.all([(0,m.listProcesses)(l.mainPID),this.formatWorkspaceMetadata(l)]).then(async i=>{let[o,h]=i,w=this.formatProcessList(l,o);return r.forEach(k=>{if((0,y.isRemoteDiagnosticError)(k))w+=`
${k.errorMessage}`,h+=`
${k.errorMessage}`;else if(w+=`

Remote: ${k.hostName}`,k.processes&&(w+=`
${this.formatProcessList(l,k.processes)}`),k.workspaceMetadata){h+=`
|  Remote: ${k.hostName}`;for(const A of Object.keys(k.workspaceMetadata)){const R=k.workspaceMetadata[A];let T=`${R.fileCount} files`;R.maxFilesReached&&(T=`more than ${T}`),h+=`|    Folder (${A}): ${T}`,h+=this.formatWorkspaceStats(R)}}}),{processInfo:w,workspaceInfo:h}})}async getSystemInfo(l,r){const{memory:i,vmHint:o,os:h,cpus:w}=c(),k={os:h,memory:i,cpus:w,vmHint:o,processArgs:`${l.mainArguments.join(" ")}`,gpuStatus:l.gpuFeatureStatus,screenReader:`${l.screenReader?"yes":"no"}`,remoteData:r};return d.isWindows||(k.load=`${p.loadavg().map(A=>Math.round(A)).join(", ")}`),d.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(l,r){const i=[];return(0,m.listProcesses)(l.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(l)),i.push(""),i.push(this.formatProcessList(l,o)),l.windows.some(h=>h.folderURIs&&h.folderURIs.length>0&&!h.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(l))),r.forEach(h=>{if((0,y.isRemoteDiagnosticError)(h))i.push(`
${h.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${h.hostName}`),i.push(this.formatMachineInfo(h.machineInfo)),h.processes&&i.push(this.formatProcessList(l,h.processes)),h.workspaceMetadata)for(const w of Object.keys(h.workspaceMetadata)){const k=h.workspaceMetadata[w];let A=`${k.fileCount} files`;k.maxFilesReached&&(A=`more than ${A}`),i.push(`Folder (${w}): ${A}`),i.push(this.formatWorkspaceStats(k))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(l){const r=[],i=60;let o=0;const h=(R,T)=>{const _=` ${R}(${T})`;o+_.length>i?(r.push(w),w="|                 ",o=w.length):o+=_.length,w+=_};let w="|      File types:";const k=10;let A=l.fileTypes.length>k?k:l.fileTypes.length;for(let R=0;R<A;R++){const T=l.fileTypes[R];h(T.name,T.count)}if(r.push(w),l.configFiles.length>=0&&(w="|      Conf files:",o=0,l.configFiles.forEach(R=>{h(R.name,R.count)}),r.push(w)),l.launchConfigFiles.length>0){let R="|      Launch Configs:";l.launchConfigFiles.forEach(T=>{R+=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`}),r.push(R)}return r.join(`
`)}expandGPUFeatures(l){const r=Math.max(...Object.keys(l).map(i=>i.length));return Object.keys(l).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${l[i]}`).join(`
                  `)}formatWorkspaceMetadata(l){const r=[],i=[];return l.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(h=>{const w=f.URI.revive(h);if(w.scheme===n.Schemas.file){const k=w.fsPath;i.push(v(k,["node_modules",".git"]).then(A=>{let R=`${A.fileCount} files`;A.maxFilesReached&&(R=`more than ${R}`),r.push(`|    Folder (${(0,I.basename)(k)}): ${R}`),r.push(this.formatWorkspaceStats(A))}).catch(A=>{r.push(`|      Error: Unable to collect workspace stats for folder ${k} (${A.toString()})`)}))}else r.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(l,r){const i=new Map;l.windows.forEach(h=>i.set(h.pid,h.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(l.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(l,r,i,o,h){const w=h===0;let k;w?k=o.pid===l?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(h)} ${o.name}`,o.name==="window"&&(k=`${k} (${r.get(o.pid)})`));const A=process.platform==="win32"?o.mem:p.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(A/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(o.children)&&o.children.forEach(R=>this.formatProcessItem(l,r,i,R,h+1))}async reportWorkspaceStats(l){for(const{uri:r}of l.folders){const i=f.URI.revive(r);if(i.scheme!==n.Schemas.file)continue;const o=i.fsPath;try{const h=await v(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":l.telemetryId,rendererSessionId:l.rendererSessionId}),h.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),h.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})}),h.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:l.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};u=de([ie(0,E.ITelemetryService),ie(1,g.IProductService)],u),e.DiagnosticsService=u}),define(Z[204],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appenders=M}listen(M,n){throw new Error(`Event not found: ${n}`)}call(M,n,{eventName:I,data:d}){return this.appenders.forEach(f=>f.log(I,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class D{constructor(M){this.channel=M}log(M,n){return this.channel.call("log",{eventName:M,data:n}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=D}),define(Z[65],x([0,1,47,13,19,28]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class n{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,P){return Promise.resolve(void 0)}publicLog2(v,P){return this.publicLog(v,P)}publicLogError(v,P){return Promise.resolve(void 0)}publicLogError2(v,P){return this.publicLogError(v,P)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=n,e.NullTelemetryService=new n;class I{async publicLog(v,P,c){}async publicLogError(v,P,c){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(E,v){return v.onDidChangeConfiguration(P=>{P.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,C.ConfigurationTargetToString)(P.source),configurationKeys:t(P.sourceConfig)})})}e.configurationTelemetry=d;function f(E,v){return!(v.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=f;function S(E){const v=E.getValue(M.TELEMETRY_SETTING_ID),P=E.getValue("telemetry.enableCrashReporter");if(E.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||P===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function b(E){const v=Object.create(null),P=Object.create(null),c=Object.create(null);y(E,c);for(let a in c){a=a.length>150?a.substr(a.length-149):a;const u=c[a];typeof u=="number"?P[a]=u:typeof u=="boolean"?P[a]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${a} has been trimmed to 8192, the original length is ${u.length}`),v[a]=u.substring(0,8191)):typeof u!="undefined"&&u!==null&&(v[a]=u)}return{properties:v,measurements:P}}e.validateTelemetryData=b;function m(E){if(!E)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(c=>{E.indexOf(`${c}+`)===0&&(v=c)}),v}e.cleanRemoteAuthority=m;function y(E,v,P=0,c){if(!!E)for(let a of Object.getOwnPropertyNames(E)){const u=E[a],s=c?c+a:a;Array.isArray(u)?v[s]=(0,p.safeStringify)(u):u instanceof Date?v[s]=u.toISOString():(0,D.isObject)(u)?P<2?y(u,v,P+1,s+"."):v[s]=(0,p.safeStringify)(u):v[s]=u}}function t(E){if(!E)return[];const v=[];return g(v,"",E),v}function g(E,v,P){P&&typeof P=="object"&&!Array.isArray(P)?Object.keys(P).forEach(c=>g(E,v?`${v}.${c}`:c,P[c])):E.push(v)}}),define(Z[205],x([0,1,30,23,16,47,3,34,13,7,19,48,170,196,167,18,6,22,49,199,97,28,65]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const l=n.isWeb?"web":(0,m.getTargetPlatform)(n.platform,I.arch);var r;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(r||(r={}));function i(...U){return String(U.reduce((z,te)=>z|te,0))}var o;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(o||(o={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},w={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},A={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class R{constructor(z=A){this.state=z}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(z,te=this.state.pageSize){return new R({...this.state,pageNumber:z,pageSize:te})}withFilter(z,...te){const re=[...this.state.criteria,...te.length?te.map(se=>({filterType:z,value:se})):[{filterType:z}]];return new R({...this.state,criteria:re})}withSortBy(z){return new R({...this.state,sortBy:z})}withSortOrder(z){return new R({...this.state,sortOrder:z})}withFlags(...z){return new R({...this.state,flags:z.reduce((te,re)=>te|re,0)})}withAssetTypes(...z){return new R({...this.state,assetTypes:z})}get raw(){const{criteria:z,pageNumber:te,pageSize:re,sortBy:se,sortOrder:J,flags:ce,assetTypes:le}=this.state;return{filters:[{criteria:z,pageNumber:te,pageSize:re,sortBy:se,sortOrder:J}],assetTypes:le,flags:ce}}get searchText(){const z=this.state.criteria.filter(te=>te.filterType===o.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(z=>String(z.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function T(U,z){const te=(U||[]).filter(re=>re.statisticName===z)[0];return te?te.value:0}function _(U){const z="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(re=>re.assetType.indexOf(z)===0).reduce((re,se)=>{const J=X(U,se.assetType);return J&&re.push([se.assetType.substring(z.length),J]),re},[])}function Q(U){if(U.properties){const z=U.properties.filter(se=>se.key===h.Repository),te=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),re=z.filter(se=>te.test(se.value))[0];return re?{uri:re.value,fallbackUri:re.value}:null}return X(U,h.Repository)}function ne(U){return{uri:`${U.fallbackAssetUri}/${h.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${h.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function oe(U){const z=X(U,h.Icon);if(z)return z;const te=m.DefaultIconPath;return{uri:te,fallbackUri:te}}function X(U,z){return U.files.filter(re=>re.assetType===z)[0]?{uri:`${U.assetUri}/${z}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${z}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}:null}function O(U,z){const te=U.properties?U.properties.filter(se=>se.key===z):[],re=te.length>0&&te[0].value;return re?re.split(",").map(se=>(0,y.adoptToGalleryExtensionId)(se)):[]}function H(U){const z=U.properties?U.properties.filter(te=>te.key===w.Engine):[];return z.length>0&&z[0].value||""}function q(U){const z=U.properties?U.properties.filter(te=>te.key===w.PreRelease):[];return z.length>0&&z[0].value==="true"}function Y(U){const z=U.properties?U.properties.filter(re=>re.key===w.LocalizedLanguages):[],te=z.length>0&&z[0].value||"";return te?te.split(","):[]}function $(U){return U.indexOf("preview")!==-1}function K(U){return U.targetPlatform?(0,m.toTargetPlatform)(U.targetPlatform):"undefined"}function ee(U){const z=(0,p.distinct)(U.versions.map(K)),te=!!U.tags?.includes(m.WEB_EXTENSION_TAG),re=z.indexOf("web");return te?re===-1&&z.push("web"):re!==-1&&z.splice(re,1),z}function B(U,z){const te=(0,m.getFallbackTargetPlarforms)(z);for(let re=0;re<U.length;re++){const se=U[re];if(se.version===U[re-1]?.version){let J=re;const ce=K(se);if(ce===z)for(;J>0&&U[J-1].version===se.version;)J--;else if(te.includes(ce))for(;J>0&&U[J-1].version===se.version&&K(U[J-1])!==z;)J--;J!==re&&(U.splice(re,1),U.splice(J,0,se))}}return U}e.sortExtensionVersions=B;function L(U,z,te,re,se){const J=U.versions[0],ce={manifest:X(z,h.Manifest),readme:X(z,h.Details),changelog:X(z,h.Changelog),license:X(z,h.License),repository:Q(z),download:ne(z),icon:oe(z),coreTranslations:_(z)};return{identifier:{id:(0,y.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:z.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:T(U.statistics,"install"),rating:T(U.statistics,"averagerating"),ratingCount:T(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:te,assets:ce,properties:{dependencies:O(z,w.Dependency),extensionPack:O(z,w.ExtensionPack),engine:H(z),localizedLanguages:Y(z),targetPlatform:K(z),isPreReleaseVersion:q(z)},hasPreReleaseVersion:q(J),hasReleaseVersion:re,preview:$(U.flags),telemetryData:se}}let W=class{constructor(z,te,re,se,J,ce,le,he){this.requestService=te,this.logService=re,this.environmentService=se,this.telemetryService=J,this.fileService=ce,this.productService=le,this.configurationService=he;const ge=le.extensionsGallery;this.extensionsGalleryUrl=ge&&ge.serviceUrl,this.extensionsControlUrl=ge&&ge.controlUrl,this.commonHeadersPromise=V(le.version,le,this.environmentService,this.configurationService,this.fileService,z)}api(z=""){return`${this.extensionsGalleryUrl}${z}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(z,te,re){const se=(0,d.isBoolean)(te)?te:!1,J=(0,d.isBoolean)(te)?re:te;let ce=new R().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,z.length).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionName,...z.map(({id:ge})=>ge.toLowerCase()));z.every(ge=>!ge.version)&&(ce=ce.withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties,r.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(ce,l,D.CancellationToken.None),he=le.map(ge=>{const be=(0,y.getGalleryExtensionId)(ge.publisher.publisherName,ge.extensionName);return{rawGalleryExtension:ge,version:z.find(fe=>(0,y.areSameExtensions)(fe,{id:be}))?.version}});return this.converToGalleryExtensions(he,se,l,()=>{},J)}async getCompatibleExtension(z,te,re){const se=(0,m.isIExtensionIdentifier)(z)?null:z;if(se){if((0,m.isNotWebExtensionInWebTargetPlatform)(se.allTargetPlatforms,re))return null;if(await this.isExtensionCompatible(se,te,re))return se}const{id:J,uuid:ce}=se?se.identifier:z;let le=new R().withFlags(r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");ce?le=le.withFilter(o.ExtensionId,ce):le=le.withFilter(o.ExtensionName,J);const{galleryExtensions:he}=await this.queryGallery(le,re,D.CancellationToken.None),[ge]=he;if(!ge||!ge.versions.length)return null;const be=ee(ge);if((0,m.isNotWebExtensionInWebTargetPlatform)(be,re))return null;for(let fe of ge.versions){if(!H(fe)){const me=await this.getEngine(fe);fe={...fe,properties:[...fe.properties||[],{key:w.Engine,value:me}]}}if(await this.isRawExtensionVersionCompatible(fe,te,be,re)){const me=ge.versions.some(pe=>!q(pe));return L(ge,fe,be,me)}}return null}async isExtensionCompatible(z,te,re){if(!(0,m.isTargetPlatformCompatible)(z.properties.targetPlatform,z.allTargetPlatforms,re)||!te&&z.properties.isPreReleaseVersion)return!1;let se=z.properties.engine;if(!se){const J=await this.getManifest(z,D.CancellationToken.None);if(!J)throw new Error("Manifest was not found");se=J.engines.vscode}return(0,t.isEngineValid)(se,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(z,te,re,se){if(!(0,m.isTargetPlatformCompatible)(K(z),re,se)||!te&&q(z))return!1;const J=await this.getEngine(z);return(0,t.isEngineValid)(J,this.productService.version,this.productService.date)}async query(z,te){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let re=z.text||"";const se=(0,M.getOrDefault)(z,fe=>fe.pageSize,50);let J=new R().withFlags(r.IncludeLatestVersionOnly,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,se).withFilter(o.Target,"Microsoft.VisualStudio.Code");re?(re=re.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,pe)=>(J=J.withFilter(o.Category,pe||me),"")),re=re.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,pe)=>(J=J.withFilter(o.Tag,pe||me),"")),re=re.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(o.Featured),"")),re=re.trim(),re&&(re=re.length<200?re:re.substring(0,200),J=J.withFilter(o.SearchText,re)),J=J.withSortBy(0)):z.ids?J=J.withFilter(o.ExtensionId,...z.ids):z.names?J=J.withFilter(o.ExtensionName,...z.names):J=J.withSortBy(4),typeof z.sortBy=="number"&&(J=J.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(J=J.withSortOrder(z.sortOrder));const{galleryExtensions:ce,total:le}=await this.queryGallery(J,l,te),he=fe=>({index:(J.pageNumber-1)*J.pageSize+fe,querySource:z.source}),ge=await this.converToGalleryExtensions(ce.map(fe=>({rawGalleryExtension:fe})),!!z.includePreRelease,l,he,te),be=async(fe,me)=>{if(me.isCancellationRequested)throw(0,C.canceled)();const pe=J.withPage(fe+1),{galleryExtensions:Pe}=await this.queryGallery(pe,l,me);return await this.converToGalleryExtensions(Pe.map(Re=>({rawGalleryExtension:Re})),!!z.includePreRelease,l,he,te)};return{firstPage:ge,total:le,pageSize:J.pageSize,getPage:be}}async converToGalleryExtensions(z,te,re,se,J){const ce=(ge,be,fe)=>{const me=ee(ge);let pe=ge.versions[0];return pe=ge.versions.find(Pe=>Pe.version===pe.version&&(0,m.isTargetPlatformCompatible)(K(Pe),me,re))||pe,q(pe)&&!te&&(pe=ge.versions.find(Pe=>Pe.version!==pe.version&&!q(Pe))||pe),L(ge,pe,me,fe,se(be))},le=[],he=new Map;for(let ge=0;ge<z.length;ge++){const{rawGalleryExtension:be,version:fe}=z[ge],me=be.versions.some(pe=>!q(pe));if(fe){const pe=be.versions.find(Pe=>Pe.version===fe);pe&&le.push([ge,L(be,pe,ee(be),me)])}else{const pe=ce(be,ge,me);pe.properties.isPreReleaseVersion?he.set(pe.identifier.uuid,ge):le.push([ge,pe])}}if(he.size){const ge=new Date().getTime(),be=new R().withFlags(r.IncludeVersions,r.IncludeAssetUri,r.IncludeStatistics,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,he.size).withFilter(o.Target,"Microsoft.VisualStudio.Code").withFilter(o.ExtensionId,...he.keys()),{galleryExtensions:fe}=await this.queryGallery(be,re,J);if(this.telemetryService.publicLog2("galleryService:preReleasesQuery",{duration:new Date().getTime()-ge,count:he.size}),fe.length!==he.size)throw new Error("Not all extensions with latest versions are returned");for(const me of fe){const pe=me.versions.some(Fe=>!q(Fe)),Pe=he.get(me.extensionId),Re=ce(me,Pe,pe);le.push([Pe,Re])}}return le.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge)}async queryGallery(z,te,re){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,r.ExcludeNonValidated).withFilter(o.ExcludeWithFlags,i(r.Unpublished));const se=await this.commonHeadersPromise,J=JSON.stringify(z.raw),ce={...se,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(J.length)},le=new Date().getTime();let he,ge,be=0;try{if(he=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:J,headers:ce},re),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:be};const fe=await(0,P.asJson)(he);if(fe){const me=fe.results[0],pe=me.extensions;pe.forEach(Re=>B(Re.versions,te));const Pe=me.resultMetadata&&me.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return be=Pe&&Pe.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:be}}return{galleryExtensions:[],total:be}}catch(fe){throw ge=fe,fe}finally{this.telemetryService.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(J.length),duration:new Date().getTime()-le,success:!!he&&(0,P.isSuccess)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:ge?(0,C.isPromiseCanceledError)(ge)?"canceled":(0,C.getErrorMessage)(ge).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(be)})}}async reportStatistic(z,te,re,se){if(!this.isEnabled())return;const J=n.isWeb?this.api(`/itemName/${z}.${te}/version/${re}/statType/${se==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${z}/extensions/${te}/${re}/stats?statType=${se}`),ce=n.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",he={...await this.commonHeadersPromise,Accept:ce};try{await this.requestService.request({type:"POST",url:J,headers:he},D.CancellationToken.None)}catch(ge){}}async download(z,te,re){this.logService.trace("ExtensionGalleryService#download",z.identifier.id);const se=(0,y.getGalleryExtensionTelemetryData)(z),J=new Date().getTime(),ce=be=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...se,duration:be}),le=re===2?"install":re===3?"update":"",he=le?{uri:`${z.assets.download.uri}${f.URI.parse(z.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${z.assets.download.fallbackUri}${f.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:z.assets.download,ge=await this.getAsset(he);await this.fileService.writeFile(te,ge.stream),ce(new Date().getTime()-J)}async getReadme(z,te){if(z.assets.readme){const re=await this.getAsset(z.assets.readme,{},te);return await(0,P.asText)(re)||""}return""}async getManifest(z,te){if(z.assets.manifest){const re=await this.getAsset(z.assets.manifest,{},te),se=await(0,P.asText)(re);return se?JSON.parse(se):null}return null}async getManifestFromRawExtensionVersion(z,te){const re=X(z,h.Manifest);if(!re)throw new Error("Manifest was not found");const se={"Accept-Encoding":"gzip"},J=await this.getAsset(re,{headers:se});return await(0,P.asJson)(J)}async getCoreTranslation(z,te){const re=z.assets.coreTranslations.filter(se=>se[0]===te.toUpperCase())[0];if(re){const se=await this.getAsset(re[1]),J=await(0,P.asText)(se);return J?JSON.parse(J):null}return null}async getChangelog(z,te){if(z.assets.changelog){const re=await this.getAsset(z.assets.changelog,{},te);return await(0,P.asText)(re)||""}return""}async getAllCompatibleVersions(z,te,re){let se=new R().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1).withFilter(o.Target,"Microsoft.VisualStudio.Code");z.identifier.uuid?se=se.withFilter(o.ExtensionId,z.identifier.uuid):se=se.withFilter(o.ExtensionName,z.identifier.id);const{galleryExtensions:J}=await this.queryGallery(se,re,D.CancellationToken.None);if(!J.length)return[];const ce=ee(J[0]);if((0,m.isNotWebExtensionInWebTargetPlatform)(ce,re))return[];const le=[];for(const he of J[0].versions)try{le[le.length-1]?.version!==he.version&&await this.isRawExtensionVersionCompatible(he,te,ce,re)&&le.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:q(he)})}catch(ge){}return le}async getAsset(z,te={},re=D.CancellationToken.None){const se=await this.commonHeadersPromise,J={type:"GET"},ce={...se,...te.headers||{}};te={...te,...J,headers:ce};const le=z.uri,he=z.fallbackUri,ge={...te,url:le};try{const be=await this.requestService.request(ge,re);if(be.res.statusCode===200)return be;const fe=await(0,P.asText)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${fe}`)}catch(be){if((0,C.isPromiseCanceledError)(be))throw be;const fe=(0,C.getErrorMessage)(be);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:fe});const me={...te,url:he};return this.requestService.request(me,re)}}async getEngine(z){let te=H(z);if(!te){const re=await this.getManifestFromRawExtensionVersion(z,D.CancellationToken.None);if(!re)throw new Error("Manifest was not found");te=re.engines.vscode}return te}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const z=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const te=await(0,P.asJson)(z),re=[],se={};if(te){for(const J of te.malicious)re.push({id:J});if(te.unsupported)for(const J of Object.keys(te.unsupported)){const ce=te.unsupported[J];(0,d.isBoolean)(ce)||(se[J.toLowerCase()]=ce.preReleaseExtension)}}return{malicious:re,unsupportedPreReleaseExtensions:se}}};W=de([ie(1,P.IRequestService),ie(2,E.ILogService),ie(3,b.IEnvironmentService),ie(4,u.ITelemetryService),ie(5,g.IFileService),ie(6,v.IProductService),ie(7,S.IConfigurationService)],W);let F=class extends W{constructor(z,te,re,se,J,ce,le,he){super(z,te,re,se,J,ce,le,he)}};F=de([ie(0,a.IStorageService),ie(1,P.IRequestService),ie(2,E.ILogService),ie(3,b.IEnvironmentService),ie(4,u.ITelemetryService),ie(5,g.IFileService),ie(6,v.IProductService),ie(7,S.IConfigurationService)],F),e.ExtensionGalleryService=F;let N=class extends W{constructor(z,te,re,se,J,ce,le){super(void 0,z,te,re,se,J,ce,le)}};N=de([ie(0,P.IRequestService),ie(1,E.ILogService),ie(2,b.IEnvironmentService),ie(3,u.ITelemetryService),ie(4,g.IFileService),ie(5,v.IProductService),ie(6,S.IConfigurationService)],N),e.ExtensionGalleryServiceWithNoStorageService=N;async function V(U,z,te,re,se,J){const ce={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U} (${z.nameShort})`},le=await(0,c.getServiceMachineId)(te,se,J);return(0,s.supportsTelemetry)(z,te)&&(0,s.getTelemetryLevel)(re)===3&&(ce["X-Market-User-Id"]=le),ce}e.resolveMarketplaceHeaders=V}),define(Z[206],x([0,1,2,47,3,25,152,19,56,54,40,28,65]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=class{constructor(E,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let P of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(P),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(P=>{const c=/^[a-f0-9]+$/i.test(P["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!c})})}setExperimentProperty(E,v){this._experimentProperties[E]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,m.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let v=E.sessionID,P=E["common.machineId"],c=E["common.firstSessionDate"],a=E["common.msftInternal"];return{sessionId:v,machineId:P,firstSessionDate:c,msftInternal:a}}dispose(){this._disposables.dispose()}_log(E,v,P,c){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(a=>{P=(0,D.mixin)(P,a),P=(0,D.mixin)(P,this._experimentProperties),P=(0,D.cloneAndChange)(P,u=>{if(typeof u=="string")return this._cleanupInfo(u,c)}),this._appenders.forEach(u=>u.log(E,P))},a=>{console.error(a)})}publicLog(E,v,P){return this._log(E,3,v,P)}publicLog2(E,v,P){return this.publicLog(E,v,P)}publicLogError(E,v){return this.sendErrorTelemetry?this._log(E,2,v,!0):Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}_anonymizeFilePaths(E){let v=E;const P=[];for(let s of this._cleanupPatterns)for(;;){const l=s.exec(E);if(!l)break;P.push([l.index,s.lastIndex])}const c=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(v="";;){const s=a.exec(E);if(!s)break;!c.test(s[0])&&P.every(([l,r])=>s.index<l||s.index>=r)&&(v+=E.substring(u,s.index)+"<REDACTED: user-file-path>",u=a.lastIndex)}return u<E.length&&(v+=E.substr(u)),v}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const v=E.toLowerCase(),P=/@[a-zA-Z0-9-.]+/;return/(key|token|sig|signature|password|passwd|pwd)[="':\s]/.test(v)?"<REDACTED: secret>":P.test(v)?"<REDACTED: email>":E}_cleanupInfo(E,v){let P=E;v&&(P=this._anonymizeFilePaths(P));for(let c of this._cleanupPatterns)P=P.replace(c,"");return P=this._removePropertiesWithPossibleUserInfo(P),P}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=de([ie(1,I.IConfigurationService)],y),e.TelemetryService=y;function t(){const g=(0,n.localize)(0,null,f.default.nameLong),E=f.default.privacyStatementUrl?(0,n.localize)(2,null,"https://aka.ms/vscode-telemetry",f.default.privacyStatementUrl):(0,n.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=C.isWeb?"":(0,n.localize)(3,null),P=(0,n.localize)(4,null),c=(0,n.localize)(5,null),a=(0,n.localize)(6,null),u=(0,n.localize)(7,null),s=`
|       | ${P} | ${c} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,l=(0,n.localize)(8,null);return`
${g} ${E} ${v}

&nbsp;

${u}
${s}

&nbsp;

${l}
`}S.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(9,null),properties:{[b.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,n.localize)(10,null),(0,n.localize)(11,null),(0,n.localize)(12,null),(0,n.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(d.Extensions.Configuration).registerConfiguration({id:b.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,n.localize)(14,null),properties:{[b.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:f.default.privacyStatementUrl?(0,n.localize)(16,null,f.default.nameLong,f.default.privacyStatementUrl):(0,n.localize)(15,null,f.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,n.localize)(17,null,`\`#${b.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[207],x([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(D){D.DARK="dark",D.LIGHT="light",D.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[208],x([0,1,108,4,2,5,40,207]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var d;(function(E){function v(P){return P&&typeof P=="object"&&typeof P.id=="string"}E.isThemeColor=v})(d=e.ThemeColor||(e.ThemeColor={}));function f(E){return{id:E}}e.themeColorFromId=f;var S;(function(E){function v(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||d.isThemeColor(r.color))}E.isThemeIcon=v;const P=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function c(r){const i=P.exec(r);if(!i)return;let[,o]=i;return{id:o}}E.fromString=c;function a(r,i){let o=r.id;const h=o.lastIndexOf("~");return h!==-1&&(o=o.substring(0,h)),i&&(o=`${o}~${i}`),{id:o}}E.modify=a;function u(r){const i=r.id.lastIndexOf("~");if(i!==-1)return r.id.substring(i+1)}E.getModifier=u;function s(r,i){return r.id===i.id&&r.color?.id===i.color?.id}E.isEqual=s;function l(r,i){return{id:r.id,color:i?f(i):void 0}}E.asThemeIcon=l,E.asClassNameArray=p.CSSIcon.asClassNameArray,E.asClassName=p.CSSIcon.asClassName,E.asCSSSelector=p.CSSIcon.asCSSSelector})(S=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function b(E){switch(E){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,C.toDisposable)(()=>{const P=this.themingParticipants.indexOf(v);this.themingParticipants.splice(P,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let y=new m;n.Registry.add(e.Extensions.ThemingContribution,y);function t(E){return y.onColorThemeChange(E)}e.registerThemingParticipant=t;class g extends C.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(P=>this.onThemeChange(P)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,P){let c=this.theme.getColor(v);return c&&P&&(c=P(c,this.theme)),c?c.toString():null}}e.Themable=g}),define(Z[66],x([0,1,14,3,5,37]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const n="#FFFFFF",I="#1E1E1E",d="#000000",f="theme",S="themeBackground",b="windowSplash";e.IThemeMainService=(0,C.createDecorator)("themeMainService");let m=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((D.isWindows||D.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(S,null);if(!t){let g;(D.isWindows||D.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?g="hc-black":g=this.stateMainService.getItem(f,"vs-dark").split(" ")[0],t=g==="hc-black"?d:g==="vs"?n:I}return D.isMacintosh&&t.toUpperCase()===I&&(t="#171717"),t}saveWindowSplash(t,g){this.stateMainService.setItems([{key:f,data:g.baseTheme},{key:S,data:g.colorInfo.background},{key:b,data:g}]),typeof t=="number"&&this.updateBackgroundColor(t,g)}updateBackgroundColor(t,g){for(const E of p.BrowserWindow.getAllWindows())if(E.id===t){E.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(b)}};m=de([ie(0,M.IStateMainService)],m),e.ThemeMainService=m}),define(Z[41],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var D;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(D=e.StateType||(e.StateType={}));var C;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(C=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,n)=>({type:"idle",updateType:M,error:n}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Z[209],x([0,1,3,153,56,40]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(C.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Z[210],x([0,1,4,41]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class C{constructor(I){this.service=I}listen(I,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"checkForUpdates":return this.service.checkForUpdates(f);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=C;class M{constructor(I){this.channel=I,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=D.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(I){this._state=I,this._onStateChange.fire(I)}checkForUpdates(I){return this.channel.call("checkForUpdates",I)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Z[98],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Z[211],x([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class D{constructor(I){this.handler=I}listen(I,d){throw new Error(`Event not found: ${d}`)}call(I,d,f){switch(d){case"handleURL":return this.handler.handleURL(p.URI.revive(f[0]),f[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=D;class C{constructor(I){this.channel=I}handleURL(I,d){return this.channel.call("handleURL",[I.toJSON(),d])}}e.URLHandlerChannelClient=C;class M{constructor(I){this.next=I}async routeCall(I,d,f,S){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(f){const b=p.URI.revive(f);if(b&&b.query){const m=/\bwindowId=(\d+)/.exec(b.query);if(m){const y=m[1],t=new RegExp(`window:${y}`),g=I.connections.find(E=>t.test(E.ctx));if(g)return g}}}return this.next.routeCall(I,d,f,S)}routeEvent(I,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=M}),define(Z[212],x([0,1,9,2,7,22]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class n extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(f,S){const b=[...this.handlers.values()];return(0,p.first)(b.map(m=>()=>m.handleURL(f,S)),void 0,!1).then(m=>m||!1)}registerHandler(f){return this.handlers.add(f),(0,D.toDisposable)(()=>this.handlers.delete(f))}}e.AbstractURLService=n;let I=class extends n{constructor(f){super();this.productService=f}create(f){let{authority:S,path:b,query:m,fragment:y}=f||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return S&&b&&b.indexOf("/")!==0&&(b=`/${b}`),C.URI.from({scheme:this.productService.urlProtocol,authority:S,path:b,query:m,fragment:y})}};I=de([ie(0,M.IProductService)],I),e.NativeURLService=I}),define(Z[213],x([0,1,14,9,4,2,3,7]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(S){try{return I.URI.parse(S)}catch(b){return null}}class f{constructor(b,m,y,t,g){if(this.urlService=m,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=b,n.isWindows){const P=t.isBuilt?[]:[`"${t.appRoot}"`];P.push("--open-url","--"),p.app.setAsDefaultProtocolClient(g.urlProtocol,process.execPath,P)}const E=C.Event.map(C.Event.fromNodeEventEmitter(p.app,"open-url",(P,c)=>({event:P,url:c})),({event:P,url:c})=>(P.preventDefault(),c));this.disposables.add(E(P=>{const c=d(P);!c||this.urlService.open(c,{originalUrl:P})})),y.getWindows().filter(P=>P.isReady).length>0?this.flush():C.Event.once(y.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const b=[];for(const m of this.uris)await this.urlService.open(m.uri,{originalUrl:m.url})||b.push(m);b.length!==0&&(this.uris=b,this.flushDisposable=(0,D.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=f}),define(Z[214],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Z[215],x([0,1,14,2,10,7]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class n extends D.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(C.Schemas.vscodeWebview,d)}handleWebviewRequest(d,f){try{const S=M.URI.parse(d.url),b=n.validWebviewFilePaths.get(S.path);if(typeof b=="string"){const m=`vs/workbench/contrib/webview/browser/pre/${b}`,y=C.FileAccess.asFileUri(m,j);return f(decodeURIComponent(y.fsPath))}else return f({error:-10})}catch{}return f({error:-2})}}e.WebviewProtocolProvider=n,n.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Z[67],x([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function D(f){return!!f.workspaceUri}e.isWorkspaceToOpen=D;function C(f){return!!f.folderUri}e.isFolderToOpen=C;function M(f){return!!f.fileUri}e.isFileToOpen=M;function n(f){const S=I(f),b=f.getValue("window.menuBarVisibility");return b==="default"||S==="native"&&b==="compact"||p.isMacintosh&&p.isNative?"classic":b}e.getMenuBarVisibility=n;function I(f){if(p.isWeb)return"custom";const S=f.getValue("window");if(S){if(p.isMacintosh&&S.nativeTabs===!0||p.isMacintosh&&S.nativeFullScreen===!1)return"native";const y=f.getValue("workbench.colorCustomizations");if(y?.["window.activeBorder"]||y?.["window.inactiveBorder"])return"custom";const t=S.titleBarStyle;if(t==="native"||t==="custom")return t}return p.isLinux?"native":"custom"}e.getTitleBarStyle=I;function d(f=0){return Math.pow(1.2,f)}e.zoomLevelToZoomFactor=d}),define(Z[35],x([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var D;(function(f){f[f.INITIAL=1]="INITIAL",f[f.LOAD=2]="LOAD",f[f.RELOAD=3]="RELOAD"})(D=e.LoadReason||(e.LoadReason={}));var C;(function(f){f[f.CLOSE=1]="CLOSE",f[f.QUIT=2]="QUIT",f[f.RELOAD=3]="RELOAD",f[f.LOAD=4]="LOAD"})(C=e.UnloadReason||(e.UnloadReason={}));var M;(function(f){f[f.CLI=0]="CLI",f[f.DOCK=1]="DOCK",f[f.MENU=2]="MENU",f[f.DIALOG=3]="DIALOG",f[f.DESKTOP=4]="DESKTOP",f[f.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const n=function(f=1){return{width:1024,height:768,mode:f}};e.defaultWindowState=n;var I;(function(f){f[f.Maximized=0]="Maximized",f[f.Normal=1]="Normal",f[f.Minimized=2]="Minimized",f[f.Fullscreen=3]="Fullscreen"})(I=e.WindowMode||(e.WindowMode={}));var d;(function(f){f[f.UNRESPONSIVE=1]="UNRESPONSIVE",f[f.CRASHED=2]="CRASHED",f[f.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Z[216],x([0,1,14,4,2,215,35]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let I=class extends C.Disposable{constructor(f){super();this.windowsMainService=f,this._onFoundInFrame=this._register(new D.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(f,S){let b;if(typeof f.windowId=="number"){const{windowId:m}=f,y=this.windowsMainService.getWindowById(m);if(!y?.win)throw new Error(`Invalid windowId: ${m}`);b=y.win.webContents}else{const{webContentsId:m}=f;if(b=p.webContents.fromId(m),!b)throw new Error(`Invalid webContentsId: ${m}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(S)}async findInFrame(f,S,b,m){const y=this.getFrameByName(f,S),t=y;if(typeof t.findInFrame=="function"){t.findInFrame(b,{findNext:m.findNext,forward:m.forward});const g=(E,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),y.removeListener("found-in-frame",g))};y.on("found-in-frame",g)}}async stopFindInFrame(f,S,b){const y=this.getFrameByName(f,S);typeof y.stopFindInFrame=="function"&&y.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}getFrameByName(f,S){const b=this.windowsMainService.getWindowById(f.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${f}`);const m=b.win.webContents.mainFrame.framesInSubtree.find(y=>y.name===S);if(!m)throw new Error(`Unknown frame: ${S}`);return m}};I=de([ie(0,n.IWindowsMainService)],I),e.WebviewMainService=I}),define(Z[217],x([0,1,9,4,2]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends C.Disposable{constructor({onDidOpenWindow:I,onDidFocusWindow:d,getActiveWindowId:f}){super();this.disposables=this._register(new C.DisposableStore),D.Event.latch(D.Event.any(I,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>f()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch(b){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(I){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=I}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Z[218],x([0,1,39,15,7,5]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var n;(function(m){m[m.EMPTY=1]="EMPTY",m[m.FOLDER=2]="FOLDER",m[m.WORKSPACE=3]="WORKSPACE"})(n=e.WorkbenchState||(e.WorkbenchState={}));function I(m){const y=m;return!!(y&&typeof y=="object"&&typeof y.id=="string"&&Array.isArray(y.folders))}e.isWorkspace=I;function d(m){const y=m;return!!(y&&typeof y=="object"&&C.URI.isUri(y.uri)&&typeof y.name=="string"&&typeof y.toResource=="function")}e.isWorkspaceFolder=d;class f{constructor(y,t,g,E,v){this._id=y,this._transient=g,this._configuration=E,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(y){this._id=y.id,this._configuration=y.configuration,this._transient=y.transient,this._ignorePathCasing=y._ignorePathCasing,this.folders=y.folders}get folders(){return this._folders}set folders(y){this._folders=y,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(y){this._configuration=y}getFolder(y){return y&&this._foldersMap.findSubstr(y.with({scheme:y.scheme,authority:y.authority,path:y.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const y of this.folders)this._foldersMap.set(y.uri,y)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=f;class S{constructor(y,t){this.raw=t,this.uri=y.uri,this.index=y.index,this.name=y.name}toResource(y){return(0,D.joinPath)(this.uri,y)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=S;function b(m){return new S({uri:m,index:0,name:(0,D.basenameOrAuthority)(m)},{uri:m.toString()})}e.toWorkspaceFolder=b}),define(Z[29],x([0,1,32,38,78,33,10,8,3,15,7,156,5,64,218]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isWorkspaceBackupInfo=e.isFolderBackupInfo=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,b.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(q){return(typeof q=="string"?(0,I.extname)(q):(0,f.extname)(q))===g}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function v(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function P(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=P;function c(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=c;function a(q){return q&&q.hasOwnProperty("folderUri")}e.isFolderBackupInfo=a;function u(q){return q&&q.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=u;function s(q){const Y=q;return typeof Y?.id=="string"&&S.URI.isUri(Y.uri)}e.isSingleFolderWorkspaceIdentifier=s;function l(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=l;function r(q){const Y=q;return typeof Y?.id=="string"&&S.URI.isUri(Y.configPath)}e.isWorkspaceIdentifier=r;function i(q){const Y=q;if(Y?.uri)return{id:Y.id,uri:S.URI.revive(Y.uri)};const $=q;if($?.configPath)return{id:$.id,configPath:S.URI.revive($.configPath)};if(q?.id)return{id:q.id}}e.reviveIdentifier=i;function o(q,Y){return f.extUriBiasedIgnorePathCase.isEqualOrParent(q,Y.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function h(q){return w(q)||k(q)}e.isStoredWorkspaceFolder=h;function w(q){const Y=q;return typeof Y?.path=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawFileWorkspaceFolder=w;function k(q){const Y=q;return typeof Y?.uri=="string"&&(!Y.name||typeof Y.name=="string")}e.isRawUriWorkspaceFolder=k;function A(q,Y,$,K,ee=!d.isWindows,B){if(q.scheme!==K.scheme)return{name:$,uri:q.toString(!0)};let L=Y?void 0:B.relativePath(K,q);if(L!==void 0)L.length===0?L=".":d.isWindows&&q.scheme===n.Schemas.file&&!ee&&(L=L.replace(/\//g,"\\"));else if(q.scheme===n.Schemas.file)L=q.fsPath,d.isWindows&&(L=(0,M.normalizeDriveLetter)(L),ee&&(L=(0,p.toSlashes)(L)));else{if(!B.isEqualAuthority(q.authority,K.authority))return{name:$,uri:q.toString(!0)};L=q.path}return{name:$,path:L}}e.getStoredWorkspaceFolder=A;function R(q,Y,$){let K=[],ee=new Set;const B=$.dirname(Y);for(let L of q){let W;if(w(L))L.path&&(W=$.resolvePath(B,L.path));else if(k(L))try{W=S.URI.parse(L.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(F){console.warn(F)}if(W){let F=$.getComparisonKey(W);if(!ee.has(F)){ee.add(F);const N=L.name||$.basenameOrAuthority(W);K.push(new t.WorkspaceFolder({uri:W,name:N,index:K.length},L))}}}return K}e.toWorkspaceFolders=R;function T(q,Y,$,K,ee){let B=_(Y,q);const L=ee.dirname(Y),W=ee.dirname(K),F=[],N=Q(B.folders);for(const te of B.folders){const re=w(te)?ee.resolvePath(L,te.path):S.URI.parse(te.uri);let se;$?se=!1:se=!w(te)||(0,I.isAbsolute)(te.path),F.push(A(re,se,te.name,W,N,ee))}const V={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},U=C.setProperty(q,["folders"],F,V);let z=C.applyEdits(q,U);return(0,f.isEqualAuthority)(B.remoteAuthority,(0,y.getRemoteAuthority)(K))&&(z=C.applyEdits(z,C.removeProperty(z,["remoteAuthority"],V))),z}e.rewriteWorkspaceFileForNewLocation=T;function _(q,Y){let $=D.parse(Y);if($&&Array.isArray($.folders))$.folders=$.folders.filter(K=>h(K));else throw new Error(`${q} looks like an invalid workspace file.`);return $}function Q(q){return d.isWindows?q.some(Y=>w(Y)&&Y.path.indexOf("/")>=0):!0}e.useSlashForPath=Q;function ne(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function oe(q){return typeof q.folderUri=="string"}function X(q){return typeof q.fileUri=="string"}function O(q,Y){const $={workspaces:[],files:[]};if(q){const K=function(B,L){for(let W=0;W<B.length;W++)try{L(B[W],W)}catch(F){Y.warn(`Error restoring recent entry ${JSON.stringify(B[W])}: ${F.toString()}. Skip entry.`)}},ee=q;if(Array.isArray(ee.entries))K(ee.entries,B=>{const L=B.label,W=B.remoteAuthority;ne(B)?$.workspaces.push({label:L,remoteAuthority:W,workspace:{id:B.workspace.id,configPath:S.URI.parse(B.workspace.configPath)}}):oe(B)?$.workspaces.push({label:L,remoteAuthority:W,folderUri:S.URI.parse(B.folderUri)}):X(B)&&$.files.push({label:L,remoteAuthority:W,fileUri:S.URI.parse(B.fileUri)})});else{const B=q;Array.isArray(B.workspaces3)&&K(B.workspaces3,(L,W)=>{const F=Array.isArray(B.workspaceLabels)&&B.workspaceLabels[W]||void 0;typeof L=="object"&&typeof L.id=="string"&&typeof L.configURIPath=="string"?$.workspaces.push({label:F,workspace:{id:L.id,configPath:S.URI.parse(L.configURIPath)}}):typeof L=="string"&&$.workspaces.push({label:F,folderUri:S.URI.parse(L)})}),Array.isArray(B.files2)&&K(B.files2,(L,W)=>{const F=Array.isArray(B.fileLabels)&&B.fileLabels[W]||void 0;typeof L=="string"&&$.files.push({label:F,fileUri:S.URI.parse(L)})})}}return $}e.restoreRecentlyOpened=O;function H(q){const Y={entries:[]};for(const $ of q.workspaces)P($)?Y.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):Y.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of q.files)Y.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return Y}e.toStoreData=H}),define(Z[50],x([0,1,14,9,81,33,2,70,8,3,13,21,136,5,6,37,29]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,y.createDecorator)("dialogMainService");let v=class vt{constructor(c,a){this.stateMainService=c,this.logService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(c,a){return this.doPick({...c,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},a)}pickFolder(c,a){return this.doPick({...c,pickFolders:!0,title:(0,m.localize)(1,null)},a)}pickFile(c,a){return this.doPick({...c,pickFiles:!0,title:(0,m.localize)(2,null)},a)}pickWorkspace(c,a){const u=(0,m.localize)(3,null),s=(0,M.mnemonicButtonLabel)((0,m.localize)(4,null)),l=E.WORKSPACE_FILTER;return this.doPick({...c,pickFiles:!0,title:u,filters:l,buttonLabel:s},a)}async doPick(c,a){const u={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters};u.defaultPath=c.defaultPath||this.stateMainService.getItem(vt.workingDirPickerStorageKey),(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(u.properties=void 0,c.pickFiles&&c.pickFolders&&(u.properties=["multiSelections","openDirectory","openFile","createDirectory"])),u.properties||(u.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),f.isMacintosh&&u.properties.push("treatPackageAsDirectory");const s=a||p.BrowserWindow.getFocusedWindow(),l=await this.showOpenDialog(u,(0,S.withNullAsUndefined)(s));if(l&&l.filePaths&&l.filePaths.length>0)return this.stateMainService.setItem(vt.workingDirPickerStorageKey,(0,d.dirname)(l.filePaths[0])),l.filePaths}getWindowDialogQueue(c){if(c){let a=this.windowDialogQueues.get(c.id);return a||(a=new D.Queue,this.windowDialogQueues.set(c.id,a)),a}else return this.noWindowDialogueQueue}showMessageBox(c,a){return this.getWindowDialogQueue(a).queue(async()=>a?p.dialog.showMessageBox(a,c):p.dialog.showMessageBox(c))}async showSaveDialog(c,a){const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await p.dialog.showSaveDialog(a,c):s=await p.dialog.showSaveDialog(c),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,n.dispose)(u)}}normalizePath(c){return c&&f.isMacintosh&&(c=(0,I.normalizeNFC)(c)),c}normalizePaths(c){return c.map(a=>this.normalizePath(a))}async showOpenDialog(c,a){c.defaultPath&&(await b.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const u=this.acquireFileDialogLock(c,a);if(!u)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(a).queue(async()=>{let s;return a?s=await p.dialog.showOpenDialog(a,c):s=await p.dialog.showOpenDialog(c),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,n.dispose)(u)}}acquireFileDialogLock(c,a){if(!a)return n.Disposable.None;let u=this.windowFileDialogLocks.get(a.id);u||(u=new Set,this.windowFileDialogLocks.set(a.id,u));const s=(0,C.hash)(c);if(!u.has(s))return u.add(s),(0,n.toDisposable)(()=>{u?.delete(s),u?.size===0&&this.windowFileDialogLocks.delete(a.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=de([ie(0,g.IStateMainService),ie(1,t.ILogService)],v),e.DialogMainService=v}),define(Z[219],x([0,1,4,2,29]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends D.Disposable{constructor(I,d){super();this.logService=I,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(I,d)=>(I?I.push(d):I=[d],I),M.STORAGE_CHANGE_DEBOUNCE_TIME)(I=>{I.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(I))}))}serializeGlobalStorageEvents(I){const d=new Map,f=new Set;return I.forEach(S=>{const b=this.storageMainService.globalStorage.get(S.key);typeof b=="string"?d.set(S.key,b):f.add(S.key)}),{changed:Array.from(d.entries()),deleted:Array.from(f.values())}}listen(I,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(I,d,f){const S=(0,C.reviveIdentifier)(f.workspace),b=await this.withStorageInitialized(S);switch(d){case"getItems":return Array.from(b.items.entries());case"updateItems":{const m=f;if(m.insert)for(const[y,t]of m.insert)b.set(y,t);m.delete&&m.delete.forEach(y=>b.delete(y));break}case"close":{if(S)return b.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(I){const d=I?this.storageMainService.workspaceStorage(I):this.storageMainService.globalStorage;try{await d.init()}catch(f){this.logService.error(`StorageIPC#init: Unable to init ${I?"workspace":"global"} storage due to ${f}`)}return d}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Z[220],x([0,1,9,4,2,8,21,86,125,6,97,28,29]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class y extends C.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new I.Storage(new I.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new p.DeferredPromise,this.whenInit=this.whenInitPromise.p}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(c=>this._onDidChangeStorage.fire({key:c}))),await this.doInit(v);const P=v.getBoolean(S.IS_NEW_KEY);P===void 0?v.set(S.IS_NEW_KEY,!0):P&&v.set(S.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}finally{this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===f.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,P){return this.storage.get(v,P)}set(v,P){return this.storage.set(v,P)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends y{constructor(v,P,c){super(P);this.options=v,this.environmentService=c}async doCreate(){let v;return this.options.useInMemoryStorage?v=d.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,M.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new I.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(b.firstSessionDateStorageKey,void 0)===void 0&&v.set(b.firstSessionDateStorageKey,new Date().toUTCString());const c=v.get(b.currentSessionDateStorageKey,void 0),a=new Date().toUTCString();v.set(b.lastSessionDateStorageKey,typeof c=="undefined"?null:c),v.set(b.currentSessionDateStorageKey,a)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class g extends y{constructor(v,P,c,a){super(c);this.workspace=v,this.options=P,this.environmentService=a}async doCreate(){const{storageFilePath:v,wasCreated:P}=await this.prepareWorkspaceStorageFolder();return new I.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:P?I.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),P=(0,M.join)(v,g.WORKSPACE_STORAGE_NAME);return await n.Promises.exists(v)?{storageFilePath:P,wasCreated:!1}:(await n.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:P,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let P;if((0,m.isSingleFolderWorkspaceIdentifier)(this.workspace)?P={folder:this.workspace.uri.toString()}:(0,m.isWorkspaceIdentifier)(this.workspace)&&(P={workspace:this.workspace.configPath.toString()}),P)try{const c=(0,M.join)(v,g.WORKSPACE_META_NAME);await n.Promises.exists(c)||await n.Promises.writeFile(c,JSON.stringify(P,void 0,2))}catch(c){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${c}`)}}}e.WorkspaceStorageMain=g,g.WORKSPACE_STORAGE_NAME="state.vscdb",g.WORKSPACE_META_NAME="workspace.json"}),define(Z[99],x([0,1,42,2,48,5,20,6,220]),function(j,e,p,D,C,M,n,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let f=class extends D.Disposable{constructor(b,m,y){super();this.logService=b,this.environmentService=m,this.lifecycleMainService=y,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async b=>{b.workspace&&this.workspaceStorage(b.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(b=>{b.join(this.globalStorage.close());for(const[,m]of this.mapWorkspaceToStorage)b.join(m.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const b=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(b.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),b}createWorkspaceStorage(b){return new d.WorkspaceStorageMain(b,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(b){let m=this.mapWorkspaceToStorage.get(b.id);return m||(this.logService.trace(`StorageMainService: creating workspace storage (${b.id})`),m=this.createWorkspaceStorage(b),this.mapWorkspaceToStorage.set(b.id,m),(0,p.once)(m.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${b.id})`),this.mapWorkspaceToStorage.delete(b.id)})),m}};f=de([ie(0,I.ILogService),ie(1,C.IEnvironmentService),ie(2,n.ILifecycleMainService)],f),e.StorageMainService=f}),define(Z[100],x([0,1,15,7,29]),function(j,e,p,D,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(d,f,S){for(const m of d){const y=m.openedWorkspace;if((0,C.isWorkspaceIdentifier)(y)){const t=S(y);if(t){if(t.folders.some(g=>p.extUriBiasedIgnorePathCase.isEqualOrParent(f,g.uri)))return m}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(f,y.configPath))return m}}const b=d.filter(m=>(0,C.isSingleFolderWorkspaceIdentifier)(m.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(f,m.openedWorkspace.uri));if(b.length)return b.sort((m,y)=>-(m.openedWorkspace.uri.path.length-y.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function n(d,f){for(const S of d)if((0,C.isWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.configPath,f)||(0,C.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(S.openedWorkspace.uri,f))return S}e.findWindowOnWorkspaceOrFolder=n;function I(d,f){const S=b=>f.some(m=>p.extUriBiasedIgnorePathCase.isEqual(D.URI.file(m),D.URI.file(b)));for(const b of d)if(b.config?.extensionDevelopmentPath?.some(m=>S(m)))return b}e.findWindowOnExtensionDevelopmentPath=I}),define(Z[221],x([0,1,14,2,3,15,7,19,20,6,37,35,29]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=class St extends D.Disposable{constructor(c,a,u,s,l){super();this.windowsMainService=c,this.stateMainService=a,this.lifecycleMainService=u,this.logService=s,this.configurationService=l,this._state=t(this.stateMainService.getItem(St.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let s=this.windowsMainService.getLastActiveWindow();(!s||s.isExtensionDevelopmentHost)&&(s=this.windowsMainService.getWindows().find(l=>!l.isExtensionDevelopmentHost)),s&&(c.lastActiveWindow=this.toWindowState(s))}const a=this.windowsMainService.getWindows().find(s=>s.isExtensionDevelopmentHost&&!s.isExtensionTestHost);a&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(a)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(s=>!s.isExtensionDevelopmentHost).map(s=>this.toWindowState(s)));const u=E(c);this.stateMainService.setItem(St.windowsStateStorageKey,u),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",u)}onBeforeCloseWindow(c){if(this.lifecycleMainService.quitRequested)return;const a=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=a:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(u=>{const s=(0,m.isWorkspaceIdentifier)(c.openedWorkspace)&&u.workspace?.id===c.openedWorkspace.id,l=(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&u.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(u.folderUri,c.openedWorkspace.uri);(s||l)&&(u.uiState=a.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=a)}toWindowState(c){return{workspace:(0,m.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,m.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const a=this.doGetNewWindowState(c),u=this.configurationService.getValue("window");let s;return a.hasDefaultState?s=!!(u?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(u.newWindowDimensions)>=0):(s=!!(this.lifecycleMainService.wasRestarted||u?.restoreFullscreen),s&&C.isMacintosh&&this.windowsMainService.getWindows().some(l=>l.isFullScreen)&&(s=!1)),a.mode===3&&!s&&(a.mode=1),a}doGetNewWindowState(c){const a=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const o=c.workspace;if((0,m.isWorkspaceIdentifier)(o)){const w=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===o.id).map(k=>k.uiState);if(w.length)return w[0]}if((0,m.isSingleFolderWorkspaceIdentifier)(o)){const w=this.state.openedWindows.filter(k=>k.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(k.folderUri,o.uri)).map(k=>k.uiState);if(w.length)return w[0]}else if(c.backupPath){const w=this.state.openedWindows.filter(k=>k.backupPath===c.backupPath).map(k=>k.uiState);if(w.length)return w[0]}const h=this.lastClosedState||this.state.lastActiveWindow;if(!a&&h)return h.uiState}let u;const s=p.screen.getAllDisplays();if(s.length===1)u=s[0];else{if(C.isMacintosh){const o=p.screen.getCursorScreenPoint();u=p.screen.getDisplayNearestPoint(o)}!u&&a&&(u=p.screen.getDisplayMatching(a.getBounds())),u||(u=p.screen.getPrimaryDisplay()||s[0])}let l=(0,b.defaultWindowState)();l.x=Math.round(u.bounds.x+u.bounds.width/2-l.width/2),l.y=Math.round(u.bounds.y+u.bounds.height/2-l.height/2);const r=this.configurationService.getValue("window");let i=!0;if(r?.newWindowDimensions){if(r.newWindowDimensions==="maximized")l.mode=0,i=!1;else if(r.newWindowDimensions==="fullscreen")l.mode=3,i=!1;else if((r.newWindowDimensions==="inherit"||r.newWindowDimensions==="offset")&&a){const o=a.serializeWindowState();o.mode===3?l.mode=3:l=o,i=l.mode!==3&&r.newWindowDimensions==="offset"}}return i&&(l=this.ensureNoOverlap(l)),l.hasDefaultState=!0,l}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const a=this.windowsMainService.getWindows().map(u=>u.getBounds());for(;a.some(u=>u.x===c.x||u.y===c.y);)c.x+=30,c.y+=30;return c}};y.windowsStateStorageKey="windowsState",y=de([ie(0,b.IWindowsMainService),ie(1,S.IStateMainService),ie(2,d.ILifecycleMainService),ie(3,f.ILogService),ie(4,I.IConfigurationService)],y),e.WindowsStateHandler=y;function t(P){const c={openedWindows:[]},a=P||{openedWindows:[]};return a.lastActiveWindow&&(c.lastActiveWindow=g(a.lastActiveWindow)),a.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=g(a.lastPluginDevelopmentHostWindow)),Array.isArray(a.openedWindows)&&(c.openedWindows=a.openedWindows.map(u=>g(u))),c}e.restoreWindowsState=t;function g(P){const c={uiState:P.uiState};return P.backupPath&&(c.backupPath=P.backupPath),P.remoteAuthority&&(c.remoteAuthority=P.remoteAuthority),P.folder&&(c.folderUri=n.URI.parse(P.folder)),P.workspaceIdentifier&&(c.workspace={id:P.workspaceIdentifier.id,configPath:n.URI.parse(P.workspaceIdentifier.configURIPath)}),c}function E(P){return{lastActiveWindow:P.lastActiveWindow&&v(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&v(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(c=>v(c))}}e.getWindowsStateStoreData=E;function v(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(Z[101],x([0,1,60,27,10,3,15]),function(j,e,p,D,C,M,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function I(f){function S(){let b=f.scheme===C.Schemas.file?(0,n.originalFSPath)(f):f.toString();return M.isLinux||(b=b.toLowerCase()),(0,p.createHash)("md5").update(b).digest("hex")}return{id:S(),configPath:f}}e.getWorkspaceIdentifier=I;function d(f,S){function b(){if(f.scheme!==C.Schemas.file)return(0,p.createHash)("md5").update(f.toString()).digest("hex");if(!S)try{S=(0,D.statSync)(f.fsPath)}catch(t){return}let y;return M.isLinux?y=S.ino:M.isMacintosh?y=S.birthtime.getTime():M.isWindows&&(typeof S.birthtimeMs=="number"?y=Math.floor(S.birthtimeMs):y=S.birthtime.getTime()),(0,p.createHash)("md5").update(f.fsPath).update(y?String(y):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:f}}e.getSingleFolderWorkspaceIdentifier=d}),define(Z[222],x([0,1,16,10,6,250,112,20]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerMainProcessExtensionHostStarter=void 0;class d{constructor(m,y){this._worker=new M.Worker(D.FileAccess.asFileUri("vs/platform/extensions/node/extensionHostStarterWorkerMain.js",j).fsPath),this._worker.on("message",m),this._worker.on("error",y)}getId(){return 1}postMessage(m,y){this._worker.postMessage(m,y)}dispose(){this._worker.terminate()}}let f=class{constructor(m){this._logService=m}async logInfo(m){this._logService.info(m)}};f=de([ie(0,C.ILogService)],f);let S=class{constructor(m,y){this._logService=m,this._shutdown=!1,this._proxy=null;const t={create:(g,E,v)=>{const P=new d(E,v);return P.postMessage(g,[]),P}};this._worker=new n.SimpleWorkerClient(t,"vs/platform/extensions/node/extensionHostStarterWorker",new f(this._logService)),this._initialize(),y.onWillShutdown(g=>{this._shutdown=!0,this._proxy&&g.join(this._proxy.waitForAllExit(6e3))})}dispose(){}async _initialize(){this._proxy=await this._worker.getProxyObject(),this._logService.info("ExtensionHostStarterWorker created")}onDynamicStdout(m){return this._proxy.onDynamicStdout(m)}onDynamicStderr(m){return this._proxy.onDynamicStderr(m)}onDynamicMessage(m){return this._proxy.onDynamicMessage(m)}onDynamicError(m){return this._proxy.onDynamicError(m)}onDynamicExit(m){return this._proxy.onDynamicExit(m)}async createExtensionHost(){const m=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return m.createExtensionHost()}async start(m,y){const t=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return t.start(m,y)}async enableInspectPort(m){const y=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return y.enableInspectPort(m)}async kill(m){const y=await this._worker.getProxyObject();if(this._shutdown)throw(0,p.canceled)();return y.kill(m)}};S=de([ie(0,C.ILogService),ie(1,I.ILifecycleMainService)],S),e.WorkerMainProcessExtensionHostStarter=S}),define(Z[57],x([0,1,60,61,26,17,16,4,2,8,3,31,36,84,223]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class g{constructor(R,T=""){this.debugLabel=T,this.socket=R,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=_=>{if(this.traceSocketEvent("error",{code:_?.code,message:_?.message}),_){if(_.code==="EPIPE")return;(0,n.onUnexpectedError)(_)}},this.socket.on("error",this._errorListener)}traceSocketEvent(R,T){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,R,T)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(R){const T=_=>{this.traceSocketEvent("read",_),R(M.VSBuffer.wrap(_))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(R){const T=_=>{this.traceSocketEvent("close",{hadError:_}),R({type:0,hadError:_,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(R){const T=()=>{this.traceSocketEvent("nodeEndReceived"),R()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(R){if(!this.socket.destroyed)try{this.traceSocketEvent("write",R),this.socket.write(R.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,n.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,n.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((R,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),R();return}const _=()=>{this.socket.off("close",_),this.socket.off("end",_),this.socket.off("error",_),this.socket.off("timeout",_),this.socket.off("drain",_),this.traceSocketEvent("nodeDrainEnd"),R()};this.socket.on("close",_),this.socket.on("end",_),this.socket.on("error",_),this.socket.on("timeout",_),this.socket.on("drain",_)})}}e.NodeSocket=g;var E;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(v||(v={}));class P extends d.Disposable{constructor(R,T,_,Q){super();this._onData=this._register(new I.Emitter),this._onClose=this._register(new I.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=R,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:_?.byteLength||0,recordInflateBytes:Q}),this._flowManager=this._register(new c(this,T,_,Q,this._onData,(ne,oe)=>this._write(ne,oe))),this._register(this._flowManager.onError(ne=>{console.error(ne),(0,n.onUnexpectedError)(ne),this._onClose.fire({type:0,hadError:!0,error:ne})})),this._incomingData=new y.ChunkStream,this._register(this.socket.onData(ne=>this._acceptChunk(ne))),this._register(this.socket.onClose(ne=>this._onClose.fire(ne)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(R,T){this.socket.traceSocketEvent(R,T)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(R){return this._onData.event(R)}onClose(R){return this._onClose.event(R)}onEnd(R){return this.socket.onEnd(R)}write(R){this._flowManager.writeMessage(R)}_write(R,T){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",R);let _=2;R.byteLength<126?_+=0:R.byteLength<2**16?_+=2:_+=8;const Q=M.VSBuffer.alloc(_);if(T?Q.writeUInt8(194,0):Q.writeUInt8(130,0),R.byteLength<126)Q.writeUInt8(R.byteLength,1);else if(R.byteLength<2**16){Q.writeUInt8(126,1);let ne=1;Q.writeUInt8(R.byteLength>>>8&255,++ne),Q.writeUInt8(R.byteLength>>>0&255,++ne)}else{Q.writeUInt8(127,1);let ne=1;Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(0,++ne),Q.writeUInt8(R.byteLength>>>24&255,++ne),Q.writeUInt8(R.byteLength>>>16&255,++ne),Q.writeUInt8(R.byteLength>>>8&255,++ne),Q.writeUInt8(R.byteLength>>>0&255,++ne)}this.socket.write(M.VSBuffer.concat([Q,R]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(R){if(R.byteLength!==0){for(this._incomingData.acceptChunk(R);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),_=T.readUInt8(0),Q=(_&128)>>>7,ne=(_&64)>>>6,oe=T.readUInt8(1),X=(oe&128)>>>7,O=oe&127;this._state.state=2,this._state.readLen=2+(X?4:0)+(O===126?2:0)+(O===127?8:0),this._state.fin=Q,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(ne)),this._state.firstFrameOfMessage=Boolean(Q),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),_=T.readUInt8(1),Q=(_&128)>>>7;let ne=_&127,oe=1;ne===126?ne=T.readUInt8(++oe)*2**8+T.readUInt8(++oe):ne===127&&(ne=T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*0+T.readUInt8(++oe)*2**24+T.readUInt8(++oe)*2**16+T.readUInt8(++oe)*2**8+T.readUInt8(++oe));let X=0;Q&&(X=T.readUInt8(++oe)*2**24+T.readUInt8(++oe)*2**16+T.readUInt8(++oe)*2**8+T.readUInt8(++oe)),this._state.state=3,this._state.readLen=ne,this._state.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),s(T,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(T,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await I.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=P;class c extends d.Disposable{constructor(R,T,_,Q,ne,oe){super();this._tracer=R,this._onData=ne,this._writeFn=oe,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new I.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,T?(this._zlibInflateStream=this._register(new a(this._tracer,Q,_,{windowBits:15})),this._zlibDeflateStream=this._register(new u(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(X=>this._onError.fire(X))),this._register(this._zlibDeflateStream.onError(X=>this._onError.fire(X)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:M.VSBuffer.alloc(0)}writeMessage(R){this._writeQueue.push(R),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const R=this._writeQueue.shift();if(this._zlibDeflateStream){const T=await this._deflateMessage(this._zlibDeflateStream,R);this._writeFn(T,!0)}else this._writeFn(R,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(R,T){return new Promise((_,Q)=>{R.write(T),R.flush(ne=>_(ne))})}acceptFrame(R,T,_){this._readQueue.push({data:R,isCompressed:T,isLastFrameOfMessage:_}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const R=this._readQueue.shift();if(this._zlibInflateStream&&R.isCompressed){const T=await this._inflateFrame(this._zlibInflateStream,R.data,R.isLastFrameOfMessage);this._onData.fire(T)}else this._onData.fire(R.data)}this._isProcessingReadQueue=!1}}_inflateFrame(R,T,_){return new Promise((Q,ne)=>{R.write(T),_&&R.write(M.VSBuffer.fromByteArray([0,0,255,255])),R.flush(oe=>Q(oe))})}}class a extends d.Disposable{constructor(R,T,_,Q){super();this._tracer=R,this._recordInflateBytes=T,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=t.createInflateRaw(Q),this._zlibInflate.on("error",ne=>{this._tracer.traceSocketEvent("zlibInflateError",{message:ne?.message,code:ne?.code}),this._onError.fire(ne)}),this._zlibInflate.on("data",ne=>{this._tracer.traceSocketEvent("zlibInflateData",ne),this._pendingInflateData.push(M.VSBuffer.wrap(ne))}),_&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",_.buffer),this._zlibInflate.write(_.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.concat(this._recordedInflateBytes):M.VSBuffer.alloc(0)}write(R){this._recordInflateBytes&&this._recordedInflateBytes.push(R.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",R),this._zlibInflate.write(R.buffer)}flush(R){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const T=M.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,R(T)})}}class u extends d.Disposable{constructor(R,T){super();this._tracer=R,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",_=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:_?.message,code:_?.code}),this._onError.fire(_)}),this._zlibDeflate.on("data",_=>{this._tracer.traceSocketEvent("zlibDeflateData",_),this._pendingDeflateData.push(M.VSBuffer.wrap(_))})}write(R){this._tracer.traceSocketEvent("zlibDeflateWrite",R.buffer),this._zlibDeflate.write(R.buffer)}flush(R){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let T=M.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.byteLength-4),R(T)})}}function s(A,R){if(R===0)return;let T=A.byteLength>>>2;for(let O=0;O<T;O++){const H=A.readUInt32BE(O*4);A.writeUInt32BE(H^R,O*4)}let _=T*4,Q=A.byteLength-_;const ne=R>>>24&255,oe=R>>>16&255,X=R>>>8&255;Q>=1&&A.writeUInt8(A.readUInt8(_)^ne,_),Q>=2&&A.writeUInt8(A.readUInt8(_+1)^oe,_+1),Q>=3&&A.writeUInt8(A.readUInt8(_+2)^X,_+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function r(){const A=(0,b.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;let R;return e.XDG_RUNTIME_DIR?R=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${A}.sock`):R=(0,f.join)((0,C.tmpdir)(),`vscode-ipc-${A}.sock`),o(R),R}e.createRandomIPCHandle=r;function i(A,R,T){const _=(0,p.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${_}-${T}-${R}-sock`;let Q;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?Q=(0,f.join)(e.XDG_RUNTIME_DIR,`vscode-${_.substr(0,8)}-${T}-${R}.sock`):Q=(0,f.join)(A,`${T}-${R}.sock`),o(Q),Q}e.createStaticIPCHandle=i;function o(A){const R=l[S.platform];typeof R=="number"&&A.length>=R&&console.warn(`WARNING: IPC handle "${A}" is longer than ${R} chars, try a shorter --user-data-dir`)}class h extends m.IPCServer{constructor(R){super(h.toClientConnectionEvent(R));this.server=R}static toClientConnectionEvent(R){const T=I.Event.fromNodeEventEmitter(R,"connection");return I.Event.map(T,_=>({protocol:new y.Protocol(new g(_,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(_,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=h;function w(A){return new Promise((R,T)=>{const _=(0,D.createServer)();_.on("error",T),_.listen(A,()=>{_.removeListener("error",T),R(new h(_))})})}e.serve=w;function k(A,R){return new Promise((T,_)=>{const Q=(0,D.createConnection)(A,()=>{Q.removeListener("error",_),T(y.Client.fromSocket(new g(Q,`ipc-client${R}`),R))});Q.once("error",_)})}e.connect=k}),define(Z[224],x([0,1,57]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class D{constructor(d){this.driver=d}listen(d,f){throw new Error("No event found")}call(d,f,S){switch(f){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(S);case"startTracing":return this.driver.startTracing(S[0],S[1]);case"stopTracing":return this.driver.stopTracing(S[0],S[1],S[2]);case"reloadWindow":return this.driver.reloadWindow(S);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(S[0],S[1]);case"click":return this.driver.click(S[0],S[1],S[2],S[3]);case"doubleClick":return this.driver.doubleClick(S[0],S[1]);case"setValue":return this.driver.setValue(S[0],S[1],S[2]);case"getTitle":return this.driver.getTitle(S[0]);case"isActiveElement":return this.driver.isActiveElement(S[0],S[1]);case"getElements":return this.driver.getElements(S[0],S[1],S[2]);case"getElementXY":return this.driver.getElementXY(S[0],S[1],S[2]);case"typeInEditor":return this.driver.typeInEditor(S[0],S[1],S[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(S[0],S[1]);case"writeInTerminal":return this.driver.writeInTerminal(S[0],S[1],S[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(S);case"getLocalizedStrings":return this.driver.getLocalizedStrings(S)}throw new Error(`Call not found: ${f}`)}}e.DriverChannel=D;class C{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}startTracing(d,f){return this.channel.call("startTracing",[d,f])}stopTracing(d,f,S){return this.channel.call("stopTracing",[d,f,S])}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,f){return this.channel.call("dispatchKeybinding",[d,f])}click(d,f,S,b){return this.channel.call("click",[d,f,S,b])}doubleClick(d,f){return this.channel.call("doubleClick",[d,f])}setValue(d,f,S){return this.channel.call("setValue",[d,f,S])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,f){return this.channel.call("isActiveElement",[d,f])}getElements(d,f,S){return this.channel.call("getElements",[d,f,S])}getElementXY(d,f,S,b){return this.channel.call("getElementXY",[d,f,S,b])}typeInEditor(d,f,S){return this.channel.call("typeInEditor",[d,f,S])}getTerminalBuffer(d,f){return this.channel.call("getTerminalBuffer",[d,f])}writeInTerminal(d,f,S){return this.channel.call("writeInTerminal",[d,f,S])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=C;class M{constructor(d){this.registry=d}listen(d,f){throw new Error(`Event not found: ${f}`)}call(d,f,S){switch(f){case"registerWindowDriver":return this.registry.registerWindowDriver(S);case"reloadWindowDriver":return this.registry.reloadWindowDriver(S)}throw new Error(`Call not found: ${f}`)}}e.WindowDriverRegistryChannel=M;async function n(I){const d=await(0,p.connect)(I,"driverClient"),f=d.getChannel("driver"),S=new C(f);return{client:d,driver:S}}e.connect=n}),define(Z[24],x([0,1,46,8,57,48,165,5]),function(j,e,p,D,C,M,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,I.refineServiceDecorator)(M.IEnvironmentService);class d extends n.NativeEnvironmentService{get cachedLanguagesPath(){return(0,D.join)(this.userDataPath,"clp")}get backupHome(){return(0,D.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,D.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,C.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,D.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}de([p.memoize],d.prototype,"cachedLanguagesPath",null),de([p.memoize],d.prototype,"backupHome",null),de([p.memoize],d.prototype,"backupWorkspacesPath",null),de([p.memoize],d.prototype,"mainIPCHandle",null),de([p.memoize],d.prototype,"mainLockfile",null),de([p.memoize],d.prototype,"sandbox",null),de([p.memoize],d.prototype,"driverVerbose",null),de([p.memoize],d.prototype,"disableUpdates",null),de([p.memoize],d.prototype,"disableKeytar",null),de([p.memoize],d.prototype,"codeCachePath",null),de([p.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Z[225],x([0,1,60,27,32,10,8,3,15,7,21,159,19,24,18,6,29]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(c,a,u){this.configurationService=a,this.logService=u,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(s,l)=>(0,C.isEqual)(s,l,!I.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await S.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(s){c=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos);let a=[];try{Array.isArray(c.rootURIWorkspaces)&&(a=c.rootURIWorkspaces.map(s=>({workspace:{id:s.id,configPath:f.URI.parse(s.configURIPath)},remoteAuthority:s.remoteAuthority})))}catch(s){}this.workspaces=await this.validateWorkspaces(a);let u=[];try{Array.isArray(c.folderWorkspaceInfos)?u=c.folderWorkspaceInfos.map(s=>({folderUri:f.URI.parse(s.folderUri),remoteAuthority:s.remoteAuthority})):Array.isArray(c.folderURIWorkspaces)&&(u=c.folderURIWorkspaces.map(s=>({folderUri:f.URI.parse(s),remoteAuthority:void 0})))}catch(s){}this.folders=await this.validateFolders(u),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,a){this.workspaces.some(s=>c.workspace.id===s.workspace.id)||(this.workspaces.push(c),this.saveSync());const u=this.getBackupPath(c.workspace.id);return a&&this.moveBackupFolderSync(u,a),u}moveBackupFolderSync(c,a){if(D.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),D.existsSync(a))try{D.renameSync(a,c)}catch(u){this.logService.error(`Backup: Could not move backup folder to new location: ${u.toString()}`)}}unregisterWorkspaceBackupSync(c){const a=c.id,u=this.workspaces.findIndex(s=>s.workspace.id===a);u!==-1&&(this.workspaces.splice(u,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(a=>this.backupUriComparer.isEqual(c.folderUri,a.folderUri))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const a=this.folders.findIndex(u=>this.backupUriComparer.isEqual(c,u.folderUri));a!==-1&&(this.folders.splice(a,1),this.saveSync())}registerEmptyWindowBackupSync(c,a){const u=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,u))||(this.emptyWindows.push({backupFolder:u,remoteAuthority:a}),this.saveSync()),this.getBackupPath(u)}unregisterEmptyWindowBackupSync(c){const a=this.emptyWindows.findIndex(u=>!!u.backupFolder&&this.backupPathComparer.isEqual(u.backupFolder,c));a!==-1&&(this.emptyWindows.splice(a,1),this.saveSync())}getBackupPath(c){return(0,n.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const a=new Set,u=[];for(let s of c){const l=s.workspace;if(!(0,E.isWorkspaceIdentifier)(l))return[];if(!a.has(l.id)){a.add(l.id);const r=this.getBackupPath(l.id);await this.doHasBackups(r)?l.configPath.scheme!==M.Schemas.file||await S.Promises.exists(l.configPath.fsPath)?u.push(s):await this.convertToEmptyWindowBackup(r):await this.deleteStaleBackup(r)}}return u}async validateFolders(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let s of c){const l=s.folderUri,r=this.backupUriComparer.getComparisonKey(l);if(!u.has(r)){u.add(r);const i=this.getBackupPath(this.getFolderHash(s));await this.doHasBackups(i)?l.scheme!==M.Schemas.file||await S.Promises.exists(l.fsPath)?a.push(s):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return a}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const a=[],u=new Set;for(let s of c){const l=s.backupFolder;if(typeof l!="string")return[];if(!u.has(l)){u.add(l);const r=this.getBackupPath(l);await this.doHasBackups(r)?a.push(s):await this.deleteStaleBackup(r)}}return a}async deleteStaleBackup(c){try{await S.Promises.exists(c)&&await S.Promises.rm(c,S.RimRafMode.MOVE)}catch(a){this.logService.error(`Backup: Could not delete stale backup: ${a.toString()}`)}}async convertToEmptyWindowBackup(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{await S.Promises.rename(c,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}convertToEmptyWindowBackupSync(c){let a=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,a));)a=this.getRandomEmptyWindowId();const u=this.getBackupPath(a);try{D.renameSync(c,u)}catch(s){return this.logService.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.emptyWindows.push({backupFolder:a}),!0}async getDirtyWorkspaces(){const c=[];for(const a of this.workspaces)await this.hasBackups(a)&&c.push(a);for(const a of this.folders)await this.hasBackups(a)&&c.push(a);return c}hasBackups(c){let a;return(0,b.isEmptyWindowBackupInfo)(c)?a=c.backupFolder:(0,E.isFolderBackupInfo)(c)?a=this.getBackupPath(this.getFolderHash(c)):a=this.getBackupPath(c.workspace.id),this.doHasBackups(a)}async doHasBackups(c){try{const a=await S.Promises.readdir(c);for(const u of a)try{if((await S.Promises.readdir((0,n.join)(c,u))).length>0)return!0}catch(s){}}catch(a){}return!1}saveSync(){try{(0,S.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await S.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderWorkspaceInfos:this.folders.map(c=>({folderUri:c.folderUri.toString(),remoteAuthority:c.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){const a=c.folderUri;let u;return a.scheme===M.Schemas.file?u=I.isLinux?a.fsPath:a.fsPath.toLowerCase():u=a.toString().toLowerCase(),(0,p.createHash)("md5").update(u).digest("hex")}};v=de([ie(0,y.IEnvironmentMainService),ie(1,m.IConfigurationService),ie(2,g.ILogService)],v),e.BackupMainService=v}),define(Z[226],x([0,1,9,4,105,58,2,3,36,57,161,224,24,178,20,35,18,7,8,17]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function a(l){return l<21}let u=class{constructor(r,i,o,h,w,k){this.windowServer=r,this.options=i,this.windowsMainService=o,this.lifecycleMainService=h,this.fileService=w,this.environmentMainService=k,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new D.Emitter}async registerWindowDriver(r){return this.registeredWindowIds.add(r),this.reloadingWindowIds.delete(r),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(r){this.reloadingWindowIds.add(r)}async getWindowIds(){return this.windowsMainService.getWindows().map(r=>r.id).filter(r=>this.registeredWindowIds.has(r)&&!this.reloadingWindowIds.has(r))}async capturePage(r){await this.whenUnfrozen(r);const i=this.windowsMainService.getWindowById(r);if(!i?.win)throw new Error("Invalid window");return(await i.win.webContents.capturePage()).toPNG().toString("base64")}async startTracing(r,i){}async stopTracing(r,i,o){if(!o)return;const h=await this.capturePage(r),w=Buffer.from(h,"base64");await this.fileService.writeFile(v.URI.file((0,P.join)(this.environmentMainService.logsPath,`${i}.png`)),c.VSBuffer.wrap(w))}async reloadWindow(r){await this.whenUnfrozen(r);const i=this.windowsMainService.getWindowById(r);if(!i)throw new Error("Invalid window");this.reloadingWindowIds.add(r),this.lifecycleMainService.reload(i)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(r,i){await this.whenUnfrozen(r);const o=C.KeybindingParser.parseUserBinding(i);for(let h of o)await this._dispatchKeybinding(r,h)}async _dispatchKeybinding(r,i){if(i instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const o=this.windowsMainService.getWindowById(r);if(!o?.win)throw new Error("Invalid window");const h=o.win.webContents,w=new M.SimpleKeybinding(!1,!1,!1,!1,i.keyCode),A=new y.USLayoutResolvedKeybinding(w.toChord(),I.OS).getElectronAccelerator(),R=[];i.ctrlKey&&R.push("ctrl"),i.metaKey&&R.push("meta"),i.shiftKey&&R.push("shift"),i.altKey&&R.push("alt"),h.sendInputEvent({type:"keyDown",keyCode:A,modifiers:R}),a(i.keyCode)||h.sendInputEvent({type:"char",keyCode:A,modifiers:R}),h.sendInputEvent({type:"keyUp",keyCode:A,modifiers:R}),await(0,p.timeout)(100)}async click(r,i,o,h){await(await this.getWindowDriver(r)).click(i,o,h)}async doubleClick(r,i){await(await this.getWindowDriver(r)).doubleClick(i)}async setValue(r,i,o){await(await this.getWindowDriver(r)).setValue(i,o)}async getTitle(r){return await(await this.getWindowDriver(r)).getTitle()}async isActiveElement(r,i){return await(await this.getWindowDriver(r)).isActiveElement(i)}async getElements(r,i,o){return await(await this.getWindowDriver(r)).getElements(i,o)}async getElementXY(r,i,o,h){return await(await this.getWindowDriver(r)).getElementXY(i,o,h)}async typeInEditor(r,i,o){await(await this.getWindowDriver(r)).typeInEditor(i,o)}async getTerminalBuffer(r,i){return await(await this.getWindowDriver(r)).getTerminalBuffer(i)}async writeInTerminal(r,i,o){await(await this.getWindowDriver(r)).writeInTerminal(i,o)}async getLocaleInfo(r){return await(await this.getWindowDriver(r)).getLocaleInfo()}async getLocalizedStrings(r){return await(await this.getWindowDriver(r)).getLocalizedStrings()}async getWindowDriver(r){await this.whenUnfrozen(r);const i=`window:${r}`,o=new d.StaticRouter(w=>w===i),h=this.windowServer.getChannel("windowDriver",o);return new S.WindowDriverChannelClient(h)}async whenUnfrozen(r){for(;this.reloadingWindowIds.has(r);)await D.Event.toPromise(this.onDidReloadingChange.event)}};u=de([ie(2,g.IWindowsMainService),ie(3,t.ILifecycleMainService),ie(4,E.IFileService),ie(5,m.IEnvironmentMainService)],u),e.Driver=u;async function s(l,r,i,o){const h=i.driverVerbose,w=o.createInstance(u,l,{verbose:h}),k=new b.WindowDriverRegistryChannel(w);l.registerChannel("windowDriverRegistry",k);const A=await(0,f.serve)(r),R=new b.DriverChannel(w);return A.registerChannel("driver",R),(0,n.combinedDisposable)(A,l)}e.serve=s}),define(Z[227],x([0,1,61,57]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(C,M,n,I,d){const f=b=>d(b,void 0),S=p.createConnection({host:C,port:M},()=>{S.removeListener("error",f);const b=Buffer.alloc(16);for(let g=0;g<16;g++)b[g]=Math.round(Math.random()*256);const m=b.toString("base64"),y=[`GET ws://${/:/.test(C)?`[${C}]`:C}:${M}/?${n}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${m}`];S.write(y.join(`\r
`)+`\r
\r
`);const t=g=>{g.toString().indexOf(`\r
\r
`)>=0&&(S.off("data",t),d(void 0,new D.NodeSocket(S,I)))};S.on("data",t)});S.setNoDelay(!0),S.once("error",f)}}}),define(Z[228],x([0,1,61,117,227,9,2,19,6,22,194,96,76]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(P,c,a,u,s){let l;for(let r=3;r&&(l&&l.dispose(),l=await new t(P,c,a,u,s).waitForReady(),!(s&&D.BROWSER_RESTRICTED_PORTS[s]||!D.BROWSER_RESTRICTED_PORTS[l.tunnelLocalPort]));r--);return l}class t extends n.Disposable{constructor(c,a,u,s,l){super();this.defaultTunnelHost=a,this.suggestedLocalPort=l,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=r=>this._onConnection(r),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){let c=await(0,D.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),a=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address(),a||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),a=this._server.address()),this.tunnelLocalPort=a.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${a.port}`,this}async _onConnection(c){c.pause();const a=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,S.connectRemoteAgentTunnel)(this._options,a,this.tunnelRemotePort),s=u.getSocket().socket,l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&c.write(l.buffer),c.on("end",()=>{this._socketsDispose.delete(c.localAddress),s.end()}),c.on("close",()=>s.end()),c.on("error",()=>{this._socketsDispose.delete(c.localAddress),s.destroy()}),s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),c.pipe(s),s.pipe(c),this._socketsDispose.set(c.localAddress,()=>{c.end(),s.end()})}}let g=class extends b.AbstractTunnelService{constructor(c,a,u,s,l){super(a);this.socketFactory=c,this.signService=u,this.productService=s,this.configurationService=l}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,a,u,s,l,r,i){const o=this.getTunnelFromMap(a,u);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,u,s,l,r,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${u} on local port ${s}.`);const h={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},w=y(h,this.defaultTunnelHost,a,u,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,u,w),w}}};g=de([ie(1,d.ILogService),ie(2,m.ISignService),ie(3,f.IProductService),ie(4,I.IConfigurationService)],g),e.BaseTunnelService=g;let E=class extends g{constructor(c,a,u,s){super(C.nodeSocketFactory,c,a,u,s)}};E=de([ie(0,d.ILogService),ie(1,m.ISignService),ie(2,f.IProductService),ie(3,I.IConfigurationService)],E),e.TunnelService=E;let v=class extends n.Disposable{constructor(c,a,u,s){super();this.logService=c,this.productService=a,this.signService=u,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(c,a,u,s,l,r,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${s} on local port ${l}.`),!this._tunnelServices.has(c)){const h=new E(this.logService,this.signService,this.productService,this.configurationService);this._register(h),this._tunnelServices.set(c,h),h.onTunnelClosed(async()=>{(await h.tunnels).length===0&&(h.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(a,u,s,l,r,i,o)}};v=de([ie(0,d.ILogService),ie(1,f.IProductService),ie(2,m.ISignService),ie(3,I.IConfigurationService)],v),e.SharedTunnelsService=v}),define(Z[229],x([0,1,198,9,17,16,2,13,19,48,90,6,197,223]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let t=class extends n.Disposable{constructor(E,v,P){super();this.environmentService=v,this.logService=P,this.configure(E.getValue()),this._register(E.onDidChangeConfiguration(()=>this.configure(E.getValue()),this))}configure(E){this.proxyUrl=E.http&&E.http.proxy,this.strictSSL=!!(E.http&&E.http.proxyStrictSSL),this.authorization=E.http&&E.http.proxyAuthorization}async request(E,v){this.logService.trace("RequestService#request",E.url);const{proxyUrl:P,strictSSL:c}=this;let a;try{a=await(0,S.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(l){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request resolving shell environment failed",l))}const u={...process.env,...a},s=E.agent?E.agent:await(0,m.getProxyAgent)(E.url||"",u,{proxyUrl:P,strictSSL:c});return E.agent=s,E.strictSSL=c,this.authorization&&(E.headers={...E.headers||{},"Proxy-Authorization":this.authorization}),this._request(E,v)}async getNodeRequest(E){return((0,p.parse)(E.url).protocol==="https:"?await new Promise((c,a)=>{j(["https"],c,a)}):await new Promise((c,a)=>{j(["http"],c,a)})).request}_request(E,v){return D.Promises.withAsyncBody(async(P,c)=>{let a;const u=(0,p.parse)(E.url),s=E.getRawRequest?E.getRawRequest(E):await this.getNodeRequest(E),l={hostname:u.hostname,port:u.port?parseInt(u.port):u.protocol==="https:"?443:80,protocol:u.protocol,path:u.path,method:E.type||"GET",headers:E.headers,agent:E.agent,rejectUnauthorized:(0,I.isBoolean)(E.strictSSL)?E.strictSSL:!0};E.user&&E.password&&(l.auth=E.user+":"+E.password),a=s(l,r=>{const i=(0,I.isNumber)(E.followRedirects)?E.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&i>0&&r.headers.location)this._request({...E,url:r.headers.location,followRedirects:i-1},v).then(P,c);else{let o=r;r.headers["content-encoding"]==="gzip"&&(o=r.pipe((0,y.createGunzip)())),P({res:r,stream:(0,C.streamToBufferReadableStream)(o)})}}),a.on("error",c),E.timeout&&a.setTimeout(E.timeout),E.data&&typeof E.data=="string"&&a.write(E.data),a.end(),v.onCancellationRequested(()=>{a.abort(),c((0,M.canceled)())})})}async resolveProxy(E){}};t=de([ie(0,d.IConfigurationService),ie(1,f.INativeEnvironmentService),ie(2,b.ILogService)],t),e.RequestService=t}),define(Z[230],x([0,1,14,229]),function(j,e,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function C(n){return p.net.request}class M extends D.RequestService{request(I,d){return super.request({...I||{},getRawRequest:C},d)}}e.RequestMainService=M}),define(Z[231],x([0,1,14,9,4,2,10,13,85,24,20,6,54,55,66,44]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let E=class extends M.Disposable{constructor(P,c,a,u,s,l,r){super();this.machineId=P,this.userEnv=c,this.environmentMainService=a,this.lifecycleMainService=u,this.logService=s,this.themeMainService=l,this.protocolMainService=r,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new C.Emitter),this.onDidError=C.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(P,c)=>this.onWindowConnection(P,c)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(P,c)=>this.onWorkerConnection(P,c)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(P,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const a=await this.connect();if(P.sender.isDestroyed())return a.close();P.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[a])}onWorkerConnection(P,c){this.logService.trace("SharedProcess: onWorkerConnection",c);const a=new M.DisposableStore,u=l=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${l}')`,c),a.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",c))},s=p.BrowserWindow.fromId(c.reply.windowId);if(!s||s.isDestroyed()||s.webContents.isDestroyed()||!c.reply.channel){u("unavailable");return}a.add(C.Event.filter(this.lifecycleMainService.onWillLoadWindow,l=>l.window.win===s)(()=>u("load"))),a.add(C.Event.fromNodeEventEmitter(s,"closed")(()=>u("closed"))),s.webContents.postMessage(c.reply.channel,c.reply.nonce,P.ports)}onWillShutdown(){const P=this.window;!P||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(P.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{P.close()}catch(c){}this.window=void 0},0))}send(P,...c){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${P}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(P,...c)}catch(a){this.logService.warn(`Error sending IPC message to channel '${P}' of shared process: ${(0,g.toErrorMessage)(a)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),P()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(P=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),P()}))})()),this._whenIpcReady}createWindow(){const P=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${P.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1}}),P.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:m.default}),this.window.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=P=>{this.logService.trace("SharedProcess#close prevented"),P.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(P,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(P,c,a)=>this._onDidError.fire({type:3,details:{reason:a,exitCode:c}})))}async connect(){await this.whenIpcReady;const P=(0,I.assertIsDefined)(this.window);return(0,d.connect)(P)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const P=this.window;return P?!P.isDestroyed()&&!P.webContents.isDestroyed():!1}};E=de([ie(2,f.IEnvironmentMainService),ie(3,S.ILifecycleMainService),ie(4,b.ILogService),ie(5,t.IThemeMainService),ie(6,y.IProtocolMainService)],E),e.SharedProcess=E}),define(Z[232],x([0,1,9,17,8,13,7,24,18,6]),function(j,e,p,D,C,M,n,I,d,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class S{constructor(y,t,g){this.storagePath=y,this.logService=t,this.fileService=g,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}}getItem(y,t){const g=this.storage[y];return(0,M.isUndefinedOrNull)(g)?t:g}setItem(y,t){this.setItems([{key:y,data:t}])}setItems(y){let t=!1;for(const{key:g,data:E}of y)this.storage[g]!==E&&((0,M.isUndefinedOrNull)(E)?(0,M.isUndefined)(this.storage[g])||(this.storage[g]=void 0,t=!0):(this.storage[g]=E,t=!0));t&&this.save()}removeItem(y){(0,M.isUndefined)(this.storage[y])||(this.storage[y]=void 0,this.save())}async save(y){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),y)}async doSave(){if(!this.initializing)return;await this.initializing;const y=JSON.stringify(this.storage,null,4);if(y!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,D.VSBuffer.fromString(y)),this.lastSavedStorageContents=y}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=S;let b=class It{constructor(y,t,g){this.fileStorage=new S(n.URI.file((0,C.join)(y.userDataPath,It.STATE_FILE)),t,g)}async init(){return this.fileStorage.init()}getItem(y,t){return this.fileStorage.getItem(y,t)}setItem(y,t){this.fileStorage.setItem(y,t)}setItems(y){this.fileStorage.setItems(y)}removeItem(y){this.fileStorage.removeItem(y)}close(){return this.fileStorage.close()}};b.STATE_FILE="storage.json",b=de([ie(0,I.IEnvironmentMainService),ie(1,f.ILogService),ie(2,d.IFileService)],b),e.StateMainService=b}),define(Z[77],x([0,1,9,23,4,19,24,20,6,22,49,41]),function(j,e,p,D,C,M,n,I,d,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function m(t,g,E){return`${E.updateUrl}/api/update/${t}/${g}/${E.commit}`}e.createUpdateURL=m;let y=class{constructor(g,E,v,P,c,a){this.lifecycleMainService=g,this.configurationService=E,this.environmentMainService=v,this.requestService=P,this.logService=c,this.productService=a,this._state=b.State.Uninitialized,this._onStateChange=new C.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const g=this.getUpdateMode(),E=this.getProductQuality(g);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(b.State.Idle(this.getUpdateType())),g==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}g==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(g){return g==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(g=60*60*1e3){return(0,p.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(g){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},D.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};y=de([ie(0,I.ILifecycleMainService),ie(1,M.IConfigurationService),ie(2,n.IEnvironmentMainService),ie(3,S.IRequestService),ie(4,d.ILogService),ie(5,f.IProductService)],y),e.AbstractUpdateService=y}),define(Z[233],x([0,1,14,46,4,2,19,24,20,6,22,49,28,41,77]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let g=class extends t.AbstractUpdateService{constructor(v,P,c,a,u,s,l){super(v,P,a,u,s,l);this.telemetryService=c,this.disposables=new M.DisposableStore}get onRawError(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,P)=>P)}get onRawUpdateNotAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,P,c)=>({url:P,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return C.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,P,c,a)=>({releaseNotes:P,version:c,productVersion:c,date:a}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const c=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(y.State.Idle(1,c))}buildUpdateFeedUrl(v){let P;this.productService.darwinUniversalAssetId?P=this.productService.darwinUniversalAssetId:P=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,t.createUpdateURL)(P,v,this.productService);try{p.autoUpdater.setFeedURL({url:c})}catch(a){this.logService.error("Failed to set update feed URL",a);return}return c}doCheckForUpdates(v){this.setState(y.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(y.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};de([D.memoize],g.prototype,"onRawError",null),de([D.memoize],g.prototype,"onRawUpdateNotAvailable",null),de([D.memoize],g.prototype,"onRawUpdateAvailable",null),de([D.memoize],g.prototype,"onRawUpdateDownloaded",null),g=de([ie(0,d.ILifecycleMainService),ie(1,n.IConfigurationService),ie(2,m.ITelemetryService),ie(3,I.IEnvironmentMainService),ie(4,b.IRequestService),ie(5,f.ILogService),ie(6,S.IProductService)],g),e.DarwinUpdateService=g}),define(Z[234],x([0,1,43,27,9,4,8,24,20,6,28,41]),function(j,e,p,D,C,M,n,I,d,f,S,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let m=class{constructor(g,E,v){if(this.lifecycleMainService=g,this.logService=v,this._state=b.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(b.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,P=>this.logService.error(P))}get state(){return this._state}setState(g){this.logService.info("update#setState",g.type),this._state=g,this._onStateChange.fire(g)}scheduleCheckForUpdates(g=60*60*1e3){return(0,C.timeout)(g).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(g){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(g)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(g){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(g=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${g}`),!g&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};m=de([ie(0,d.ILifecycleMainService),ie(1,I.IEnvironmentMainService),ie(2,f.ILogService)],m);let y=class extends m{constructor(g,E,v,P,c,a){super(v,P,c);this.snap=g,this.snapRevision=E,this.telemetryService=a;const u=(0,D.watch)(n.dirname(this.snap)),s=M.Event.fromNodeEventEmitter(u,"change",(o,h)=>h),l=M.Event.filter(s,o=>o==="current"),i=M.Event.debounce(l,(o,h)=>h,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{i.dispose(),u.close()})}doCheckForUpdates(){this.setState(b.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(g=>{g?this.setState(b.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2)))},g=>{this.logService.error(g),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(b.State.Idle(2,g.message||g))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+n.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const g=await new Promise((v,P)=>(0,D.realpath)(`${n.dirname(this.snap)}/current`,(c,a)=>c?P(c):v(a))),E=n.basename(g);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,g=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};y=de([ie(2,d.ILifecycleMainService),ie(3,I.IEnvironmentMainService),ie(4,f.ILogService),ie(5,S.ITelemetryService)],y),e.SnapUpdateService=y}),define(Z[45],x([0,1,14,27,4,38,33,2,10,8,3,15,13,21,158,52,50,24,5,6,22,100,29,101]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,P.createDecorator)("workspacesManagementMainService");let r=class extends I.Disposable{constructor(o,h,w,k,A){super();this.environmentMainService=o,this.logService=h,this.backupMainService=w,this.dialogMainService=k,this.productService=A,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new C.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new C.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(o){return this.doResolveLocalWorkspace(o,h=>(0,D.readFileSync)(h,"utf8"))}resolveLocalWorkspace(o){return this.doResolveLocalWorkspace(o,h=>y.Promises.readFile(h,"utf8"))}doResolveLocalWorkspace(o,h){if(!!this.isWorkspacePath(o)&&o.scheme===d.Schemas.file)try{const w=h(o.fsPath);return w instanceof Promise?w.then(k=>this.doResolveWorkspace(o,k),k=>{}):this.doResolveWorkspace(o,w)}catch{return}}isWorkspacePath(o){return(0,s.isUntitledWorkspace)(o,this.environmentMainService)||(0,s.hasWorkspaceFileExtension)(o)}doResolveWorkspace(o,h){try{const w=this.doParseStoredWorkspace(o,h),k=(0,l.getWorkspaceIdentifier)(o);return{id:k.id,configPath:k.configPath,folders:(0,s.toWorkspaceFolders)(w.folders,k.configPath,b.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(o,h){const w=(0,M.parse)(h);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(k=>(0,s.isStoredWorkspaceFolder)(k));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(o,h){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(o,h),A=w.configPath.fsPath;return await y.Promises.mkdir((0,f.dirname)(A),{recursive:!0}),await y.Promises.writeFile(A,JSON.stringify(k,null,"	")),w}createUntitledWorkspaceSync(o,h){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(o,h),A=w.configPath.fsPath;return(0,D.mkdirSync)((0,f.dirname)(A),{recursive:!0}),(0,y.writeFileSync)(A,JSON.stringify(k,null,"	")),w}newUntitledWorkspace(o=[],h){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,b.joinPath)(this.untitledWorkspacesHome,w),A=(0,b.joinPath)(k,s.UNTITLED_WORKSPACE_NAME),R=[];for(const T of o)R.push((0,s.getStoredWorkspaceFolder)(T.uri,!0,T.name,k,!S.isWindows,b.extUriBiasedIgnorePathCase));return{workspace:(0,l.getWorkspaceIdentifier)(A),storedWorkspace:{folders:R,remoteAuthority:h}}}async getWorkspaceIdentifier(o){return(0,l.getWorkspaceIdentifier)(o)}isUntitledWorkspace(o){return(0,s.isUntitledWorkspace)(o.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(o){!this.isUntitledWorkspace(o)||(this.doDeleteUntitledWorkspaceSync(o),this._onDidDeleteUntitledWorkspace.fire(o))}async deleteUntitledWorkspace(o){this.deleteUntitledWorkspaceSync(o)}doDeleteUntitledWorkspaceSync(o){const h=(0,b.originalFSPath)(o.configPath);try{(0,y.rimrafSync)((0,f.dirname)(h));const w=(0,f.join)(this.environmentMainService.workspaceStorageHome.fsPath,o.id);(0,D.existsSync)(w)&&(0,y.writeFileSync)((0,f.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${h} (${w}).`)}}getUntitledWorkspacesSync(){const o=[];try{const h=(0,y.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,b.joinPath)(this.untitledWorkspacesHome,w,s.UNTITLED_WORKSPACE_NAME));for(const w of h){const k=(0,l.getWorkspaceIdentifier)(w),A=this.resolveLocalWorkspaceSync(w);A?o.push({workspace:k,remoteAuthority:A.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(h){h.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${h}).`)}return o}async enterWorkspace(o,h,w){if(!o||!o.win||!o.isReady||!await this.isValidTargetWorkspacePath(o,h,w))return;const A=this.doEnterWorkspace(o,(0,l.getWorkspaceIdentifier)(w));if(!!A)return this._onDidEnterWorkspace.fire({window:o,workspace:A.workspace}),A}async isValidTargetWorkspacePath(o,h,w){if(!w)return!0;if((0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&b.extUriBiasedIgnorePathCase.isEqual(o.openedWorkspace.configPath,w))return!1;if((0,u.findWindowOnWorkspaceOrFolder)(h,w)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,n.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,b.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,m.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(o,h){if(!o.config)return;o.focus();let w;return o.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:h,remoteAuthority:o.remoteAuthority},o.config.backupPath)),(0,s.isWorkspaceIdentifier)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&this.deleteUntitledWorkspaceSync(o.openedWorkspace),o.config.workspace=h,o.config.backupPath=w,{workspace:h,backupPath:w}}};r=de([ie(0,v.IEnvironmentMainService),ie(1,c.ILogService),ie(2,g.IBackupMainService),ie(3,E.IDialogMainService),ie(4,a.IProductService)],r),e.WorkspacesManagementMainService=r}),define(Z[102],x([0,1,14,30,23,3,13,7,21,19,53,5,6,98,35,29,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,b.createDecorator)(e.ID);let v=class{constructor(c,a,u,s,l){this.logService=c,this.windowsMainService=a,this.urlService=u,this.workspacesManagementMainService=s,this.configurationService=l}async start(c,a){this.logService.trace("Received data from other instance: ",c,a),M.isMacintosh&&p.app.focus({steal:!0});const u=this.parseOpenUrl(c);if(u.length){let s=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(s=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),s.then(()=>{for(const{uri:l,url:r}of u)this.urlService.open(l,{originalUrl:r})})}else return this.startOpenWindow(c,a)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,D.coalesce)(c._urls.map(a=>{try{return{uri:I.URI.parse(a),url:a}}catch(u){return null}})):[]}async startOpenWindow(c,a){const u=(0,S.isLaunchedFromCli)(a)?0:4;let s=[];const l=c.wait&&c.waitMarkerFilePath?I.URI.file(c.waitMarkerFilePath):void 0,r=c.remote||void 0,i={context:u,cli:c,userEnv:a,waitMarkerFileURI:l,remoteAuthority:r};if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,i);else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let o=!1;if(c["new-window"]||c["unity-launch"])o=!0;else if(c["reuse-window"])o=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":o=!0;break;case"off":o=!1;break;default:o=!M.isMacintosh}if(o)s=this.windowsMainService.open({...i,forceNewWindow:!0,forceEmpty:!0});else{const h=this.windowsMainService.getLastActiveWindow();h?(this.windowsMainService.openExistingWindow(h,i),s=[h]):s=this.windowsMainService.open({...i,forceEmpty:!0})}}else s=this.windowsMainService.open({...i,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],gotoLineMode:c.goto});if(l&&s.length===1&&s[0])return Promise.race([s[0].whenClosedOrLoaded,(0,d.whenDeleted)(l.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return p.BrowserWindow.getAllWindows().forEach(a=>{const u=this.windowsMainService.getWindowById(a.id);u?c.push(this.codeWindowToInfo(u)):c.push(this.browserWindowToInfo(a))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const a=this.windowsMainService.getWindows();return(await Promise.all(a.map(s=>new Promise(l=>{const r=s.remoteAuthority;if(r){const i=`vscode:getDiagnosticInfoResponse${s.id}`,o={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(s):void 0};s.sendWhenReady("vscode:getDiagnosticInfo",C.CancellationToken.None,{replyChannel:i,args:o}),p.ipcMain.once(i,(h,w)=>{w||l({hostName:r,errorMessage:`Unable to resolve connection to '${r}'.`}),l(w)}),setTimeout(()=>{l({hostName:r,errorMessage:`Fetching remote diagnostics for '${r}' timed out.`})},5e3)}else l(void 0)})))).filter(s=>!!s)}getFolderURIs(c){const a=[],u=c.openedWorkspace;if((0,g.isSingleFolderWorkspaceIdentifier)(u))a.push(u.uri);else if((0,g.isWorkspaceIdentifier)(u)){const s=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.configPath);s&&s.folders.forEach(r=>{a.push(r.uri)})}return a}codeWindowToInfo(c){const a=this.getFolderURIs(c),u=(0,n.assertIsDefined)(c.win);return this.browserWindowToInfo(u,a,c.remoteAuthority)}browserWindowToInfo(c,a=[],u){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:a,remoteAuthority:u}}};v=de([ie(0,m.ILogService),ie(1,t.IWindowsMainService),ie(2,y.IURLService),ie(3,E.IWorkspacesManagementMainService),ie(4,f.IConfigurationService)],v),e.LaunchMainService=v}),define(Z[51],x([0,1,43,14,26,116,46,4,33,2,10,8,3,7,82,71,21,150,50,24,5,20,6,22,28,66,35,29,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l,r,i,o,h,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,a.createDecorator)("nativeHostMainService");let k=class ft extends f.Disposable{constructor(R,T,_,Q,ne,oe,X,O,H,q){super();this.sharedProcess=R,this.windowsMainService=T,this.dialogMainService=_,this.lifecycleMainService=Q,this.environmentMainService=ne,this.telemetryService=oe,this.logService=X,this.productService=O,this.themeMainService=H,this.workspacesManagementMainService=q,this.onDidOpenWindow=I.Event.map(this.windowsMainService.onDidOpenWindow,Y=>Y.id),this.onDidMaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidUnmaximizeWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidBlurWindow=I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y)),this.onDidFocusWindow=I.Event.any(I.Event.map(I.Event.filter(I.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),Y=>!!Y),Y=>Y.id),I.Event.filter(I.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(Y,$)=>$.id),Y=>!!this.windowsMainService.getWindowById(Y))),this.onDidResumeOS=I.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new I.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new I.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=I.Event.debounce(I.Event.any(I.Event.filter(I.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(Y,$,K)=>K),Y=>!(Array.isArray(Y)&&Y.length===1&&Y[0]==="workArea")),I.Event.fromNodeEventEmitter(D.screen,"display-added"),I.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(T=>({id:T.id,workspace:T.openedWorkspace,title:T.win?.getTitle()??"",filename:T.getRepresentedFilename(),dirty:T.isDocumentEdited()}))}async getWindowCount(R){return this.windowsMainService.getWindowCount()}async getActiveWindowId(R){const T=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(T)return T.id}openWindow(R,T,_){return Array.isArray(T)?this.doOpenWindow(R,T,_):this.doOpenEmptyWindow(R,T)}async doOpenWindow(R,T,_=Object.create(null)){T.length>0&&this.windowsMainService.open({context:5,contextWindowId:R,urisToOpen:T,cli:this.environmentMainService.args,forceNewWindow:_.forceNewWindow,forceReuseWindow:_.forceReuseWindow,preferNewWindow:_.preferNewWindow,diffMode:_.diffMode,addMode:_.addMode,gotoLineMode:_.gotoLineMode,noRecentEntry:_.noRecentEntry,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:_.remoteAuthority||void 0})}async doOpenEmptyWindow(R,T){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:R},T)}async toggleFullScreen(R){const T=this.windowById(R);T&&T.toggleFullScreen()}async handleTitleDoubleClick(R){const T=this.windowById(R);T&&T.handleTitleDoubleClick()}async isMaximized(R){const T=this.windowById(R);return T?.win?T.win.isMaximized():!1}async maximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.maximize()}async unmaximizeWindow(R){const T=this.windowById(R);T?.win&&T.win.unmaximize()}async minimizeWindow(R){const T=this.windowById(R);T?.win&&T.win.minimize()}async focusWindow(R,T){T&&typeof T.windowId=="number"&&(R=T.windowId);const _=this.windowById(R);_&&_.focus({force:T?.force??!1})}async setMinimumSize(R,T,_){const Q=this.windowById(R);if(Q?.win){const[ne,oe]=Q.win.getSize(),[X,O]=Q.win.getMinimumSize(),[H,q]=[T??X,_??O],[Y,$]=[Math.max(ne,H),Math.max(oe,q)];(X!==H||O!==q)&&Q.win.setMinimumSize(H,q),(ne!==Y||oe!==$)&&Q.win.setSize(Y,$)}}async saveWindowSplash(R,T){this.themeMainService.saveWindowSplash(R,T)}async installShellCommand(R){const{source:T,target:_}=await this.getShellCommandLink();try{const{symbolicLink:Q}=await E.SymlinkSupport.stat(T);if(Q&&!Q.dangling){const ne=await(0,t.realpath)(T);if(_===ne)return}await E.Promises.unlink(T)}catch(Q){if(Q.code!=="ENOENT")throw Q}try{await E.Promises.symlink(_,T)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="ENOENT")throw Q;const{response:ne}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(ne===0)try{const oe=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${_}' '${T}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(oe)}catch(oe){throw new Error((0,v.localize)(3,null,T))}}}async uninstallShellCommand(R){const{source:T}=await this.getShellCommandLink();try{await E.Promises.unlink(T)}catch(_){switch(_.code){case"EACCES":const{response:Q}=await this.showMessageBox(R,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(Q===0)try{const ne=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(ne)}catch(ne){throw new Error((0,v.localize)(7,null,T))}break;case"ENOENT":break;default:throw _}}}async getShellCommandLink(){const R=(0,b.resolve)(this.environmentMainService.appRoot,"bin","code"),T=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(R))throw new Error((0,v.localize)(8,null,R));return{source:T,target:R}}async showMessageBox(R,T){return this.dialogMainService.showMessageBox(T,this.toBrowserWindow(R))}async showSaveDialog(R,T){return this.dialogMainService.showSaveDialog(T,this.toBrowserWindow(R))}async showOpenDialog(R,T){return this.dialogMainService.showOpenDialog(T,this.toBrowserWindow(R))}toBrowserWindow(R){const T=this.windowById(R);if(T?.win)return T.win}async pickFileFolderAndOpen(R,T){const _=await this.dialogMainService.pickFileFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFileFolder",T.telemetryExtraData),this.doOpenPicked(await Promise.all(_.map(async Q=>await E.SymlinkSupport.existsDirectory(Q)?{folderUri:y.URI.file(Q)}:{fileUri:y.URI.file(Q)})),T,R))}async pickFolderAndOpen(R,T){const _=await this.dialogMainService.pickFolder(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFolder",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({folderUri:y.URI.file(Q)})),T,R))}async pickFileAndOpen(R,T){const _=await this.dialogMainService.pickFile(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openFile",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({fileUri:y.URI.file(Q)})),T,R))}async pickWorkspaceAndOpen(R,T){const _=await this.dialogMainService.pickWorkspace(T);_&&(this.sendPickerTelemetry(_,T.telemetryEventName||"openWorkspace",T.telemetryExtraData),this.doOpenPicked(_.map(Q=>({workspaceUri:y.URI.file(Q)})),T,R))}doOpenPicked(R,T,_){this.windowsMainService.open({context:3,contextWindowId:_,cli:this.environmentMainService.args,urisToOpen:R,forceNewWindow:T.forceNewWindow})}sendPickerTelemetry(R,T,_){const Q=R?R.length:0;this.telemetryService.publicLog(T,{..._,outcome:Q?"success":"canceled",numberOfPaths:Q})}async showItemInFolder(R,T){D.shell.showItemInFolder(T)}async setRepresentedFilename(R,T){const _=this.windowById(R);_&&_.setRepresentedFilename(T)}async setDocumentEdited(R,T){const _=this.windowById(R);_&&_.setDocumentEdited(T)}async openExternal(R,T){return m.isLinuxSnap?this.safeSnapOpenExternal(T):D.shell.openExternal(T),!0}safeSnapOpenExternal(R){const T=process.env.GDK_PIXBUF_MODULE_FILE,_=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(R),process.env.GDK_PIXBUF_MODULE_FILE=T,process.env.GDK_PIXBUF_MODULEDIR=_}moveItemToTrash(R,T){return D.shell.trashItem(T)}async isAdmin(){let R;return m.isWindows?R=(await new Promise((T,_)=>{j(["native-is-elevated"],T,_)}))():R=process.getuid()===0,R}async writeElevated(R,T,_,Q){const ne=await new Promise((oe,X)=>{j(["@vscode/sudo-prompt"],oe,X)});return new Promise((oe,X)=>{const O=[`"${this.cliPath}"`];Q?.unlock&&O.push("--file-chmod"),O.push("--file-write",`"${T.fsPath}"`,`"${_.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:m.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};ne.exec(O.join(" "),H,(q,Y,$)=>{Y&&this.logService.trace(`[sudo-prompt] received stdout: ${Y}`),$&&this.logService.trace(`[sudo-prompt] received stderr: ${$}`),q?X(q):oe(void 0)})})}get cliPath(){return m.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):m.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,C.totalmem)(),freemem:(0,C.freemem)(),loadavg:(0,C.loadavg)()}}async getOSProperties(){return{arch:(0,C.arch)(),platform:(0,C.platform)(),release:(0,C.release)(),type:(0,C.type)(),cpus:(0,C.cpus)()}}async getOSVirtualMachineHint(){return g.virtualMachineHint.value()}get osColorScheme(){return{highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(R,T,_){process.kill(T,_)}async readClipboardText(R,T){return D.clipboard.readText(T)}async writeClipboardText(R,T,_){return D.clipboard.writeText(T,_)}async readClipboardFindText(R){return D.clipboard.readFindText()}async writeClipboardFindText(R,T){return D.clipboard.writeFindText(T)}async writeClipboardBuffer(R,T,_,Q){return D.clipboard.writeBuffer(T,Buffer.from(_),Q)}async readClipboardBuffer(R,T){return D.clipboard.readBuffer(T)}async hasClipboard(R,T,_){return D.clipboard.has(T,_)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(R,T){const _=this.windowById(R);_&&_.updateTouchBar(T)}async notifyReady(R){const T=this.windowById(R);T&&T.setReady()}async relaunch(R,T){return this.lifecycleMainService.relaunch(T)}async reload(R,T){const _=this.windowById(R);if(_){if((0,h.isWorkspaceIdentifier)(_.openedWorkspace)){const Q=_.openedWorkspace.configPath;if(Q.scheme===S.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(Q))?.transient)return this.openWindow(_.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(_,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(R){this.closeWindowById(R,R)}async closeWindowById(R,T){const _=this.windowById(T);if(_?.win)return _.win.close()}async quit(R){const T=this.windowsMainService.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&T.win?T.win.close():this.lifecycleMainService.quit()}async exit(R,T){await this.lifecycleMainService.kill(T)}async resolveProxy(R,T){const Q=this.windowById(R)?.win?.webContents?.session;if(Q)return Q.resolveProxy(T)}async openDevTools(R,T){const _=this.windowById(R);_?.win&&_.win.webContents.openDevTools(T)}async toggleDevTools(R){const T=this.windowById(R);T?.win&&T.win.webContents.toggleDevTools()}async sendInputEvent(R,T){const _=this.windowById(R);_?.win&&(T.type==="mouseDown"||T.type==="mouseUp")&&_.win.webContents.sendInputEvent(T)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(R,T,_,Q){if(!m.isWindows)return;const ne=await new Promise((oe,X)=>{j(["vscode-windows-registry"],oe,X)});try{return ne.GetStringRegKey(T,_,Q)}catch{return}}async getPassword(R,T,_){const Q=await this.withKeytar(),ne=await Q.getPassword(T,_);if(ne)try{let{content:oe,hasNextChunk:X}=JSON.parse(ne);if(!oe||!X)return ne;let O=1;for(;X;){const H=await Q.getPassword(T,`${_}-${O}`),q=JSON.parse(H);oe+=q.content,X=q.hasNextChunk,O++}return oe}catch{return ne}return ne}async setPassword(R,T,_,Q){const ne=await this.withKeytar(),oe=3,X=async(O,H,q)=>{let Y=0,$;for(;Y<oe;)try{await ne.setPassword(O,H,q);return}catch(K){$=K,this.logService.warn("Error attempting to set a password: ",K),Y++,await new Promise(ee=>setTimeout(ee,200))}throw $};if(m.isWindows&&Q.length>ft.MAX_PASSWORD_LENGTH){let O=0,H=0,q=!0;for(;q;){const Y=Q.substring(O,O+ft.PASSWORD_CHUNK_SIZE);O+=ft.PASSWORD_CHUNK_SIZE,q=Q.length-O>0;const $={content:Y,hasNextChunk:q};await X(T,H?`${_}-${H}`:_,JSON.stringify($)),H++}}else await X(T,_,Q);this._onDidChangePassword.fire({service:T,account:_})}async deletePassword(R,T,_){const ne=await(await this.withKeytar()).deletePassword(T,_);return ne&&this._onDidChangePassword.fire({service:T,account:_}),ne}async findPassword(R,T){return(await this.withKeytar()).findPassword(T)}async findCredentials(R,T){return(await this.withKeytar()).findCredentials(T)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((R,T)=>{j(["keytar"],R,T)})}windowById(R){if(typeof R=="number")return this.windowsMainService.getWindowById(R)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,de([n.memoize],k.prototype,"cliPath",null),k=de([ie(1,o.IWindowsMainService),ie(2,P.IDialogMainService),ie(3,u.ILifecycleMainService),ie(4,c.IEnvironmentMainService),ie(5,r.ITelemetryService),ie(6,s.ILogService),ie(7,l.IProductService),ie(8,i.IThemeMainService),ie(9,w.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Z[235],x([0,1,14,23,4,81,2,31,88,6,51,22,35]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var y;(function(g){g[g.Initial=1]="Initial",g[g.StoredCredentialsUsed=2]="StoredCredentialsUsed",g[g.LoginDialogShown=3]="LoginDialogShown"})(y||(y={}));let t=class extends n.Disposable{constructor(E,v,P,c,a){super();this.logService=E,this.windowsMainService=v,this.nativeHostMainService=P,this.encryptionMainService=c,this.productService=a,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=y.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=C.Event.fromNodeEventEmitter(p.app,"login",(v,P,c,a,u)=>({event:v,webContents:P,req:c,authInfo:a,callback:u}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:v,req:P,callback:c}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===y.LoginDialogShown&&P.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let a;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),a=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{a=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(a?.username,a?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(E);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const v=String((0,M.hash)({scheme:E.scheme,host:E.host,port:E.port}));let P,c;try{const l=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(l){const r=JSON.parse(await this.encryptionMainService.decrypt(l));P=r.username,c=r.password}}catch(l){this.logService.error(l)}if(this.state!==y.StoredCredentialsUsed&&typeof P=="string"&&typeof c=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=y.StoredCredentialsUsed,{username:P,password:c};const a=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!a){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${a.id} to handle proxy login`);const u={authInfo:E,username:this.sessionCredentials?.username??P,password:this.sessionCredentials?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,I.generateUuid)()}`};a.sendWhenReady("vscode:openProxyAuthenticationDialog",D.CancellationToken.None,u),this.state=y.LoginDialogShown;const s=await new Promise(l=>{const r=async(i,o,h)=>{if(o===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${a.id}`),a.win?.webContents.off("ipc-message",r),h){const w={username:h.username,password:h.password};try{if(h.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(k){this.logService.error(k)}l({username:w.username,password:w.password})}else l(void 0)};a.win?.webContents.on("ipc-message",r)});return this.sessionCredentials=s,s}};t=de([ie(0,f.ILogService),ie(1,m.IWindowsMainService),ie(2,S.INativeHostMainService),ie(3,d.IEncryptionMainService),ie(4,b.IProductService)],t),e.ProxyAuthHandler=t}),define(Z[236],x([0,1,14,26,33,2,10,3,83,148,74,50,24,5,102,6,51,54,22,55,67]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,y.createDecorator)("issueMainService");let u=class Pt{constructor(l,r,i,o,h,w,k,A,R){this.userEnv=l,this.environmentMainService=r,this.launchMainService=i,this.logService=o,this.diagnosticsService=h,this.dialogMainService=w,this.nativeHostMainService=k,this.protocolMainService=A,this.productService=R,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async l=>{const[r,i]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(r,i);this.safeSend(l,"vscode:issueSystemInfoResponse",o)}),p.ipcMain.on("vscode:listProcesses",async l=>{const r=[];try{const i=await this.launchMainService.getMainProcessId();r.push({name:(0,f.localize)(0,null),rootProcess:await(0,d.listProcesses)(i)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(h=>{(0,S.isRemoteDiagnosticError)(h)?r.push({name:h.hostName,rootProcess:h}):h.processes&&r.push({name:h.hostName,rootProcess:h.processes})})}catch(i){this.logService.error(`Listing processes failed: ${i}`)}this.safeSend(l,"vscode:listProcessesResponse",r)}),p.ipcMain.on("vscode:issueReporterClipboard",async l=>{const r={title:this.productService.nameLong,message:(0,f.localize)(1,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(2,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const i=await this.dialogMainService.showMessageBox(r,this.issueReporterWindow);this.safeSend(l,"vscode:issueReporterClipboardResponse",i.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async l=>{const r=await this.getPerformanceInfo();this.safeSend(l,"vscode:issuePerformanceInfoResponse",r)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const l={title:this.productService.nameLong,message:(0,f.localize)(4,null),type:"warning",buttons:[(0,C.mnemonicButtonLabel)((0,f.localize)(5,null)),(0,C.mnemonicButtonLabel)((0,f.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(l,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(l,r)=>{const{id:i,from:o,args:h}=r;let w;switch(o){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}w&&w.webContents.send("vscode:runAction",{id:i,from:o,args:h})}),p.ipcMain.on("vscode:openExternal",(l,r)=>{this.nativeHostMainService.openExternal(void 0,r)}),p.ipcMain.on("vscode:closeIssueReporter",l=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",l=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async l=>{const r=await this.launchMainService.getMainProcessInfo();this.safeSend(l,"vscode:windowsInfoResponse",r.windows)})}safeSend(l,r,...i){l.sender.isDestroyed()||l.sender.send(r,...i)}async openReporter(l){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new M.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(o,i,{backgroundColor:l.styles.backgroundColor,title:(0,f.localize)(7,null),zoomLevel:l.zoomLevel,alwaysOnTop:!1},"issue-reporter"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:l,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:v.default}),this.issueReporterWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(l){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new M.DisposableStore,i=r.add(this.protocolMainService.createIPCObjectUrl()),o=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(o,i,{backgroundColor:l.styles.backgroundColor,title:(0,f.localize)(8,null),zoomLevel:l.zoomLevel,alwaysOnTop:!0},"process-explorer"),i.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:l,product:v.default}),this.processExplorerWindow.loadURL(n.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(l){l.isMinimized()&&l.restore(),l.focus()}createBrowserWindow(l,r,i,o){const h=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:l.width,height:l.height,minWidth:300,minHeight:200,x:l.x,y:l.y,title:i.title,backgroundColor:i.backgroundColor||Pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:n.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${r.resource.toString()}`,`--vscode-window-kind=${o}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,a.zoomLevelToZoomFactor)(i.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:i.alwaysOnTop});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(l,r)}getWindowPosition(l,r,i){let o;const h=p.screen.getAllDisplays();if(h.length===1)o=h[0];else{if(I.isMacintosh){const A=p.screen.getCursorScreenPoint();o=p.screen.getDisplayNearestPoint(A)}!o&&l&&(o=p.screen.getDisplayMatching(l.getBounds())),o||(o=p.screen.getPrimaryDisplay()||h[0])}const w={width:r,height:i},k=o.bounds;return w.x=k.x+k.width/2-w.width/2,w.y=k.y+k.height/2-w.height/2,k.width>0&&k.height>0&&(w.x<k.x&&(w.x=k.x),w.y<k.y&&(w.y=k.y),w.x>k.x+k.width&&(w.x=k.x),w.y>k.y+k.height&&(w.y=k.y),w.width>k.width&&(w.width=k.width),w.height>k.height&&(w.height=k.height)),w}async getPerformanceInfo(){try{const[l,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(l,r)}catch(l){throw this.logService.warn("issueService#getPerformanceInfo ",l.message),l}}};u.DEFAULT_BACKGROUND_COLOR="#1E1E1E",u=de([ie(1,m.IEnvironmentMainService),ie(2,t.ILaunchMainService),ie(3,g.ILogService),ie(4,S.IDiagnosticsService),ie(5,b.IDialogMainService),ie(6,E.INativeHostMainService),ie(7,c.IProtocolMainService),ie(8,P.IProductService)],u),e.IssueMainService=u}),define(Z[237],x([0,1,23,19,24,20,6,51,22,49,28,41,77]),function(j,e,p,D,C,M,n,I,d,f,S,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let y=class extends m.AbstractUpdateService{constructor(g,E,v,P,c,a,u,s){super(g,E,P,c,a,s);this.telemetryService=v,this.nativeHostMainService=u}buildUpdateFeedUrl(g){return(0,m.createUpdateURL)(`linux-${process.arch}`,g,this.productService)}doCheckForUpdates(g){!this.url||(this.setState(b.State.CheckingForUpdates(g)),this.requestService.request({url:this.url},p.CancellationToken.None).then(f.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g}),this.setState(b.State.Idle(1))):this.setState(b.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!g});const v=g?E.message||E:void 0;this.setState(b.State.Idle(1,v))}))}async doDownloadUpdate(g){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):g.update.url&&this.nativeHostMainService.openExternal(void 0,g.update.url),this.setState(b.State.Idle(1))}};y=de([ie(0,M.ILifecycleMainService),ie(1,D.IConfigurationService),ie(2,S.ITelemetryService),ie(3,C.IEnvironmentMainService),ie(4,f.IRequestService),ie(5,n.ILogService),ie(6,I.INativeHostMainService),ie(7,d.IProductService)],y),e.LinuxUpdateService=y}),define(Z[238],x([0,1,43,27,26,9,23,46,8,7,113,21,19,24,18,20,6,51,22,49,28,41,77]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function l(h,w=1e3){for(;!h();)await(0,M.timeout)(w)}let r;function i(){return typeof r=="undefined"&&(r=D.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),r}let o=class extends s.AbstractUpdateService{constructor(w,k,A,R,T,_,Q,ne,oe){super(w,k,R,T,_,oe);this.telemetryService=A,this.fileService=Q,this.nativeHostMainService=ne}get cachePath(){const w=d.join((0,C.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return b.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),i()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),i()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,s.createUpdateURL)(k,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(u.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},n.CancellationToken.None).then(c.asJson).then(k=>{const A=i();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(u.State.Idle(A)),Promise.resolve(null)):A===1?(this.setState(u.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(u.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(R=>b.Promises.exists(R).then(T=>{if(T)return Promise.resolve(R);const _=k.url,Q=k.hash,ne=`${R}.tmp`;return this.requestService.request({url:_},n.CancellationToken.None).then(oe=>this.fileService.writeFile(f.URI.file(ne),oe.stream)).then(Q?()=>(0,S.checksum)(ne,k.hash):()=>{}).then(()=>b.Promises.rename(ne,R)).then(()=>R)})).then(R=>{const T=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:R},T&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(u.State.Downloaded(k)):this.setState(u.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const A=w?k.message||k:void 0;this.setState(u.State.Idle(i(),A))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(u.State.Idle(i()))}async getUpdatePackagePath(w){const k=await this.cachePath;return d.join(k,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const k=w?_=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(_):()=>!0,A=await this.cachePath,T=(await b.Promises.readdir(A)).filter(k).map(async _=>{try{await b.Promises.unlink(d.join(A,_))}catch(Q){}});await Promise.all(T)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(u.State.Updating(w));const k=await this.cachePath;this.availableUpdate.updateFilePath=d.join(k,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await b.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(u.State.Idle(i()))});const R=`${this.productService.win32MutexName}-ready`,T=await new Promise((_,Q)=>{j(["windows-mutex"],_,Q)});l(()=>T.isActive(R)).then(()=>this.setState(u.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?D.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}};de([I.memoize],o.prototype,"cachePath",null),o=de([ie(0,g.ILifecycleMainService),ie(1,m.IConfigurationService),ie(2,a.ITelemetryService),ie(3,y.IEnvironmentMainService),ie(4,c.IRequestService),ie(5,E.ILogService),ie(6,t.IFileService),ie(7,v.INativeHostMainService),ie(8,P.IProductService)],o),e.Win32UpdateService=o}),define(Z[239],x([0,1,14,9,23,44,4,33,2,10,8,63,3,7,154,52,19,50,24,53,205,18,20,6,22,55,99,28,208,66,67,35,29,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l,r,i,o,h,w,k,A,R,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var Q;(function(oe){oe[oe.NONE=0]="NONE",oe[oe.LOADING=1]="LOADING",oe[oe.NAVIGATING=2]="NAVIGATING",oe[oe.READY=3]="READY"})(Q||(Q={}));let ne=class extends d.Disposable{constructor(X,O,H,q,Y,$,K,ee,B,L,W,F,N,V,U){super();this.logService=O,this.environmentMainService=H,this.fileService=q,this.storageMainService=Y,this.configurationService=$,this.themeMainService=K,this.workspacesManagementMainService=ee,this.backupMainService=B,this.telemetryService=L,this.dialogMainService=W,this.lifecycleMainService=F,this.productService=N,this.protocolMainService=V,this.windowsMainService=U,this._onWillLoad=this._register(new n.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new n.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new n.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new n.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[z,te]=this.restoreWindowState(X.state);this.windowState=z,this.logService.trace("window#ctor: using window state",z);const re=this.windowState.mode===0||this.windowState.mode===3,se=this.configurationService.getValue("window"),J={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:A.WindowMinimumSize.WIDTH,minHeight:A.WindowMinimumSize.HEIGHT,show:!re,title:this.productService.nameLong,webPreferences:{preload:f.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,A.zoomLevelToZoomFactor)(se?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};m.isLinux?J.icon=(0,S.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(J.icon=(0,S.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(J.fullscreenable=!1),m.isMacintosh&&(J.acceptFirstMouse=!0,se?.clickThroughInactive===!1&&(J.acceptFirstMouse=!1));const ce=m.isMacintosh&&se?.nativeTabs===!0;ce&&(J.tabbingIdentifier=this.productService.nameShort);const le=(0,A.getTitleBarStyle)(this.configurationService)==="custom";if(le&&(J.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(J.frame=!1)),(0,b.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(J),(0,b.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&le&&this._win.setSheetOffset(22),m.isMacintosh&&te&&(!ce||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(he=>typeof he=="number")){const he=this.windowState;this._win.setBounds({width:he.width,height:he.height,x:he.x,y:he.y})}re&&((0,b.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,b.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(X){m.isMacintosh?this._win.setRepresentedFilename(X):this.representedFilename=X}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(X){m.isMacintosh&&this._win.setDocumentEdited(X),this.documentEdited=X}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(X){m.isMacintosh&&X?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(X=>{if(this.isReady)return X(this);this.whenReadyCallbacks.push(X)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(X=>{function O(){H.dispose(),q.dispose(),X()}const H=this.onDidClose(()=>O()),q=this.onWillLoad(()=>O())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(Y,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(Y,$,K)=>this.onWindowError(3,{reason:K,exitCode:$})),this._win.webContents.on("will-prevent-unload",Y=>{Y.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const X=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,"devtools"]),O=Y=>{for(let $=Y;$;$=$.parent)if($.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},H=Y=>Y.resourceType==="xhr"||O(Y.frame);this._win.webContents.session.webRequest.onBeforeRequest((Y,$)=>{const K=y.URI.parse(Y.url);return K.path.endsWith(".svg")&&!X.has(K.scheme)?$({cancel:!H(Y)}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((Y,$)=>{const K=Y.responseHeaders,ee=K["content-type"]||K["Content-Type"];if(ee&&Array.isArray(ee)){const B=y.URI.parse(Y.url);if(B.path.endsWith(".svg")&&X.has(B.scheme))return K["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:K});if(!B.path.includes(f.Schemas.vscodeRemoteResource)&&ee.some(L=>L.toLowerCase().includes("image/svg")))return $({cancel:!H(Y)})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",Y,this._win)}),this._win.on("unmaximize",Y=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",Y,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",C.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",C.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(Y=>this.onDidDeleteUntitledWorkspace(Y)));const q=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:q},async(Y,$)=>{const K=await this.getMarketplaceHeaders();$({cancel:!1,requestHeaders:Object.assign(Y.requestHeaders,K)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,a.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:X=>this.storageMainService.globalStorage.get(X),store:(X,O)=>this.storageMainService.globalStorage.set(X,O)})),this.marketplaceHeadersPromise}async onWindowError(X,O){switch(X){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${O?.reason||"<unknown>"}, code: ${O?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:X,reason:O?.reason,code:O?.exitCode}),X){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.driverHandle){this.destroyWindow(!1);return}if(X===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const H=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(1,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(2,null))],message:(0,t.localize)(3,null),detail:(0,t.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(H.response!==1){const q=H.response===0;this.destroyWindow(q)}}else if(X===2){let H;O?H=(0,t.localize)(6,null,O.reason,O.exitCode??"<unknown>"):H=(0,t.localize)(5,null);const Y=(await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,I.mnemonicButtonLabel)((0,t.localize)(7,null)),(0,I.mnemonicButtonLabel)((0,t.localize)(8,null))],message:H,detail:(0,t.localize)(9,null),noLink:!0,defaultId:0},this._win)).response===0;this.destroyWindow(Y)}break}}destroyWindow(X){if(this._onDidDestroy.fire(),this._win?.destroy(),X&&this.config){let O,H;(0,T.isSingleFolderWorkspaceIdentifier)(this.openedWorkspace)?O={folderUri:this.openedWorkspace.uri}:(0,T.isWorkspaceIdentifier)(this.openedWorkspace)?O={workspaceUri:this.openedWorkspace.configPath}:H=!0;const[q]=this.windowsMainService.open({context:5,userEnv:this.config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:O?[O]:void 0,forceEmpty:H,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});q.focus()}}onDidDeleteUntitledWorkspace(X){this.openedWorkspace?.id===X.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const X=this.getMenuBarVisibility();X!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=X,this.setMenuBarVisibility(X));let O=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;O?.endsWith("/")&&(O=O.substr(0,O.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((O||"").indexOf("@")===-1&&(O!==this.currentHttpProxy||H!==this.currentNoProxy)){this.currentHttpProxy=O,this.currentNoProxy=H;const q=O||"",Y=H?`${H},<local>`:"<local>";this.logService.trace(`Setting proxy to '${q}', bypassing '${Y}'`),this._win.webContents.session.setProxy({proxyRules:q,proxyBypassRules:Y,pacScript:""})}}addTabbedWindow(X){m.isMacintosh&&X.win&&this._win.addTabbedWindow(X.win)}load(X,O=Object.create(null)){this.isDocumentEdited()&&(!O.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),O.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(X,O),this.readyState===0?this.currentConfig=X:(this.pendingLoadConfig=X,this.readyState=2),this._win.loadURL(f.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const H=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new D.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:X.workspace,reason:O.isReload?3:H?2:1})}updateConfiguration(X,O){const H=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(H){const q=(0,c.isLaunchedFromCli)(H)&&!(0,c.isLaunchedFromCli)(X.userEnv),Y=this.isExtensionDevelopmentHost;(q||Y)&&(X.userEnv={...H,...X.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(X.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),O.disableExtensions!==void 0&&(X["disable-extensions"]=O.disableExtensions),X.fullscreen=this.isFullScreen,X.maximized=this._win.isMaximized(),X.partsSplash=this.themeMainService.getWindowSplash(),(0,b.mark)("code/willOpenNewWindow"),X.perfMarks=(0,b.getMarks)(),this.configObjectUrl.update(X)}async reload(X){const O=Object.assign({},this.currentConfig);O.workspace=await this.validateWorkspaceBeforeReload(O),delete O.filesToOpenOrCreate,delete O.filesToDiff,delete O.filesToWait,this.isExtensionDevelopmentHost&&X&&(O.verbose=X.verbose,O.debugId=X.debugId,O.extensionEnvironment=X.extensionEnvironment,O["inspect-extensions"]=X["inspect-extensions"],O["inspect-brk-extensions"]=X["inspect-brk-extensions"],O["extensions-dir"]=X["extensions-dir"]),O.isInitialStartup=!1,this.load(O,{isReload:!0,disableExtensions:X?.["disable-extensions"]})}async validateWorkspaceBeforeReload(X){if((0,T.isWorkspaceIdentifier)(X.workspace)){const O=X.workspace.configPath;if(O.scheme===f.Schemas.file&&!await this.fileService.exists(O))return}else if((0,T.isSingleFolderWorkspaceIdentifier)(X.workspace)){const O=X.workspace.uri;if(O.scheme===f.Schemas.file&&!await this.fileService.exists(O))return}return X.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let H;try{H=p.screen.getDisplayMatching(this.getBounds())}catch($){}const q=(0,R.defaultWindowState)();return{mode:3,display:H?H.id:void 0,width:this.windowState.width||q.width,height:this.windowState.height||q.height,x:this.windowState.x||0,y:this.windowState.y||0}}const X=Object.create(null);let O;if(!m.isMacintosh&&this._win.isMaximized()?O=0:O=1,O===0?X.mode=0:X.mode=1,O===1||O===0){let H;O===1?H=this.getBounds():H=this._win.getNormalBounds(),X.x=H.x,X.y=H.y,X.width=H.width,X.height=H.height}return X}restoreWindowState(X){(0,b.mark)("code/willRestoreCodeWindowState");let O=!1;if(X)try{const H=p.screen.getAllDisplays();O=H.length>1,X=this.validateWindowState(X,H)}catch(H){this.logService.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}return(0,b.mark)("code/didRestoreCodeWindowState"),[X||(0,R.defaultWindowState)(),O]}validateWindowState(X,O){if(this.logService.trace(`window#validateWindowState: validating window state on ${O.length} display(s)`,X),typeof X.x!="number"||typeof X.y!="number"||typeof X.width!="number"||typeof X.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(X.width<=0||X.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(O.length===1){const Y=this.getWorkingArea(O[0]);if(Y){let $=function(){!X||typeof X.x!="number"||typeof X.y!="number"||!Y||(X.x<Y.x&&(X.x=Y.x),X.y<Y.y&&(X.y=Y.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",Y),$(),X.width>Y.width&&(X.width=Y.width),X.height>Y.height&&(X.height=Y.height),X.x>Y.x+Y.width-128&&(X.x=Y.x+Y.width-X.width),X.y>Y.y+Y.height-128&&(X.y=Y.y+Y.height-X.height),$()}return X}if(X.display&&X.mode===3){const Y=O.find($=>$.id===X.display);if(Y&&typeof Y.bounds?.x=="number"&&typeof Y.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const $=(0,R.defaultWindowState)(3);return $.x=Y.bounds.x,$.y=Y.bounds.y,$}}let H,q;try{H=p.screen.getDisplayMatching({x:X.x,y:X.y,width:X.width,height:X.height}),q=this.getWorkingArea(H)}catch(Y){}if(H&&q&&X.x+X.width>q.x&&X.y+X.height>q.y&&X.x<q.x+q.width&&X.y<q.y+q.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",q),X}getWorkingArea(X){if(X.workArea.width>0&&X.workArea.height>0)return X.workArea;if(X.bounds.width>0&&X.bounds.height>0)return X.bounds}getBounds(){const[X,O]=this._win.getPosition(),[H,q]=this._win.getSize();return{x:X,y:O,width:H,height:q}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(X){this.useNativeFullScreen()?this.setNativeFullScreen(X):this.setSimpleFullScreen(X),this.sendWhenReady(X?"vscode:enterFullScreen":"vscode:leaveFullScreen",C.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(X){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(X)}setSimpleFullScreen(X){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(X),this._win.webContents.focus()}useNativeFullScreen(){const X=this.configurationService.getValue("window");return!X||typeof X.nativeFullScreen!="boolean"||X.nativeTabs?!0:X.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let X=(0,A.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(X)<0&&(X="classic"),X}setMenuBarVisibility(X,O=!0){m.isMacintosh||(X==="toggle"&&O&&this.send("vscode:showInfoMessage",(0,t.localize)(10,null)),X==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(X)}):this.doSetMenuBarVisibility(X))}doSetMenuBarVisibility(X){const O=this.isFullScreen;switch(X){case"classic":this._win.setMenuBarVisibility(!O),this._win.autoHideMenuBar=O;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(X,O,...H){this.isReady?this.send(X,...H):this.ready().then(()=>{O.isCancellationRequested||this.send(X,...H)})}send(X,...O){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${X}' for window that is destroyed`);return}try{this._win.webContents.send(X,...O)}catch(H){this.logService.warn(`Error sending IPC message to channel '${X}' of window ${this._id}: ${(0,M.toErrorMessage)(H)}`)}}}updateTouchBar(X){!m.isMacintosh||this.touchBarGroups.forEach((O,H)=>{const q=X[H];O.segments=this.createTouchBarGroupSegments(q)})}createTouchBar(){if(!!m.isMacintosh){for(let X=0;X<10;X++){const O=this.createTouchBarGroup();this.touchBarGroups.push(O)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(X=[]){const O=this.createTouchBarGroupSegments(X),H=new p.TouchBar.TouchBarSegmentedControl({segments:O,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",C.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}createTouchBarGroupSegments(X=[]){return X.map(H=>{let q;H.icon&&!w.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(q=p.nativeImage.createFromPath(y.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let Y;return typeof H.title=="string"?Y=H.title:Y=H.title.value,{id:H.id,label:q?void 0:Y,icon:q}})}dispose(){super.dispose(),this._win=null}};ne=de([ie(1,l.ILogService),ie(2,P.IEnvironmentMainService),ie(3,u.IFileService),ie(4,o.IStorageMainService),ie(5,E.IConfigurationService),ie(6,k.IThemeMainService),ie(7,_.IWorkspacesManagementMainService),ie(8,g.IBackupMainService),ie(9,h.ITelemetryService),ie(10,v.IDialogMainService),ie(11,s.ILifecycleMainService),ie(12,r.IProductService),ie(13,i.IProtocolMainService),ie(14,R.IWindowsMainService)],ne),e.CodeWindow=ne}),define(Z[68],x([0,1,14,30,9,4,33,2,10,3,15,7,21,157,5,20,6,37,29,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let a=class qe extends I.Disposable{constructor(s,l,r,i){super();this.stateMainService=s,this.logService=l,this.workspacesManagementMainService=r,this.lifecycleMainService=i,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new C.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(s=>this.addRecentlyOpened([{workspace:s.workspace,remoteAuthority:s.window.remoteAuthority}])))}handleWindowsJumpList(){!f.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(s){const l=[],r=[];for(let i of s)if((0,P.isRecentWorkspace)(i))!this.workspacesManagementMainService.isUntitledWorkspace(i.workspace)&&this.indexOfWorkspace(l,i.workspace)===-1&&l.push(i);else if((0,P.isRecentFolder)(i))this.indexOfFolder(l,i.folderUri)===-1&&l.push(i);else{const o=this.indexOfFile(r,i.fileUri)>=0,h=i.fileUri.scheme===d.Schemas.file&&qe.COMMON_FILES_FILTER.indexOf((0,S.basename)(i.fileUri))>=0;!o&&!h&&(r.push(i),f.isWindows&&i.fileUri.scheme===d.Schemas.file&&p.app.addRecentDocument(i.fileUri.fsPath))}this.addEntriesFromStorage(l,r),l.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(l.length=qe.MAX_TOTAL_RECENT_ENTRIES),r.length>qe.MAX_TOTAL_RECENT_ENTRIES&&(r.length=qe.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:l,files:r}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(s){const l=h=>{const w=this.location(h);for(const k of s)if(S.extUriBiasedIgnorePathCase.isEqual(k,w))return!1;return!0},r=this.getRecentlyOpened(),i=r.workspaces.filter(l),o=r.files.filter(l);(i.length!==r.workspaces.length||o.length!==r.files.length)&&(this.saveRecentlyOpened({files:o,workspaces:i}),this._onDidChangeRecentlyOpened.fire(),f.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!f.isMacintosh)return;p.app.clearRecentDocuments();const s=this.getRecentlyOpened(),l=[];let r=0;for(let o=0;o<s.workspaces.length&&r<qe.MAX_MACOS_DOCK_RECENT_WORKSPACES;o++){const h=this.location(s.workspaces[o]);if(h.scheme===d.Schemas.file){const w=(0,S.originalFSPath)(h);await m.Promises.exists(w)&&(l.push(w),r++)}}const i=[];for(let o=0;o<s.files.length&&r<qe.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;o++){const h=this.location(s.files[o]);if(h.scheme===d.Schemas.file){const w=(0,S.originalFSPath)(h);if(qe.COMMON_FILES_FILTER.includes((0,S.basename)(h))||l.includes(w))continue;await m.Promises.exists(w)&&(i.push(w),r++)}}i.reverse().forEach(o=>p.app.addRecentDocument(o)),l.reverse().forEach(o=>p.app.addRecentDocument(o))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(s){const l=[],r=[];if(s){const o=s.config?.workspace;(0,P.isWorkspaceIdentifier)(o)&&!this.workspacesManagementMainService.isUntitledWorkspace(o)?l.push({workspace:o,remoteAuthority:s.remoteAuthority}):(0,P.isSingleFolderWorkspaceIdentifier)(o)&&l.push({folderUri:o.uri,remoteAuthority:s.remoteAuthority})}const i=s?.config?.filesToOpenOrCreate;if(i)for(let o of i){const h=o.fileUri;h&&this.indexOfFile(r,h)===-1&&r.push({fileUri:h})}return this.addEntriesFromStorage(l,r),{workspaces:l,files:r}}addEntriesFromStorage(s,l){let r=this.getRecentlyOpenedFromStorage();for(let i of r.workspaces){let o=(0,P.isRecentFolder)(i)?this.indexOfFolder(s,i.folderUri):this.indexOfWorkspace(s,i.workspace);o>=0?s[o].label=s[o].label||i.label:s.push(i)}for(let i of r.files){let o=this.indexOfFile(l,i.fileUri);o>=0?l[o].label=l[o].label||i.label:l.push(i)}}getRecentlyOpenedFromStorage(){const s=this.stateMainService.getItem(qe.recentlyOpenedStorageKey);return(0,P.restoreRecentlyOpened)(s,this.logService)}saveRecentlyOpened(s){const l=(0,P.toStoreData)(s);this.stateMainService.setItem(qe.recentlyOpenedStorageKey,l)}updateWindowsJumpList(){if(!f.isWindows)return;const s=[];if(s.push({type:"tasks",items:[{type:"task",title:(0,y.localize)(0,null),description:(0,y.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let l=[];for(let o of p.app.getJumpListSettings().removedItems){const h=o.args;if(h){const w=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(h);w&&l.push(b.URI.parse(w[2]))}}this.removeRecentlyOpened(l);let r=!1;const i=(0,D.coalesce)(this.getRecentlyOpened().workspaces.slice(0,qe.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(o=>{const h=(0,P.isRecentWorkspace)(o)?o.workspace:o.folderUri,{title:w,description:k}=this.getWindowsJumpListLabel(h,o.label);let A;return b.URI.isUri(h)?A=`--folder-uri "${h.toString()}"`:(r=!0,A=`--file-uri "${h.configPath.toString()}"`),{type:"task",title:w.substr(0,255),description:k.substr(0,255),program:process.execPath,args:A,iconPath:"explorer.exe",iconIndex:0}}));i.length>0&&s.push({type:"custom",name:r?(0,y.localize)(2,null):(0,y.localize)(3,null),items:i})}s.push({type:"recent"});try{p.app.setJumpList(s)}catch(l){this.logService.warn("updateWindowsJumpList#setJumpList",l)}}getWindowsJumpListLabel(s,l){if(l)return{title:(0,n.splitName)(l).name,description:l};if(b.URI.isUri(s))return{title:(0,S.basename)(s),description:this.renderJumpListPathDescription(s)};if(this.workspacesManagementMainService.isUntitledWorkspace(s))return{title:(0,y.localize)(4,null),description:""};let r=(0,S.basename)(s.configPath);return r.endsWith(P.WORKSPACE_EXTENSION)&&(r=r.substr(0,r.length-P.WORKSPACE_EXTENSION.length-1)),{title:(0,y.localize)(5,null,r),description:this.renderJumpListPathDescription(s.configPath)}}renderJumpListPathDescription(s){return s.scheme==="file"?(0,n.normalizeDriveLetter)(s.fsPath):s.toString()}location(s){return(0,P.isRecentFolder)(s)?s.folderUri:(0,P.isRecentFile)(s)?s.fileUri:s.workspace.configPath}indexOfWorkspace(s,l){return s.findIndex(r=>(0,P.isRecentWorkspace)(r)&&r.workspace.id===l.id)}indexOfFolder(s,l){return s.findIndex(r=>(0,P.isRecentFolder)(r)&&S.extUriBiasedIgnorePathCase.isEqual(r.folderUri,l))}indexOfFile(s,l){return s.findIndex(r=>S.extUriBiasedIgnorePathCase.isEqual(r.fileUri,l))}};a.MAX_TOTAL_RECENT_ENTRIES=500,a.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,a.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,a.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,a.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],a.recentlyOpenedStorageKey="openedPathsList",a=de([ie(0,v.IStateMainService),ie(1,E.ILogService),ie(2,c.IWorkspacesManagementMainService),ie(3,g.ILifecycleMainService)],a),e.WorkspacesHistoryMainService=a}),define(Z[240],x([0,1,14,9,23,33,3,7,149,19,24,20,6,187,51,22,37,28,41,67,35,68]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let l=class yt{constructor(o,h,w,k,A,R,T,_,Q,ne,oe){this.updateService=o,this.configurationService=h,this.windowsMainService=w,this.environmentMainService=k,this.telemetryService=A,this.workspacesHistoryMainService=R,this.stateMainService=T,this.lifecycleMainService=_,this.logService=Q,this.nativeHostMainService=ne,this.productService=oe,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new D.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new D.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(n.isMacintosh||(0,c.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(yt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(R,T,_)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:T?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(R,T,_)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(R,T,_)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(_),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const h=this.productService.requestFeatureUrl;h&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(h,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(n.language){const R=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${R}lang=${n.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const A=this.productService.privacyStatementUrl;A&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(A,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!n.isMacintosh)return!1;let o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,h){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(yt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!n.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!n.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=p.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(n.isMacintosh?new p.Menu:null);return}const h=new p.Menu;let w;if(n.isMacintosh){const A=new p.Menu;w=new p.MenuItem({label:this.productService.nameShort,submenu:A}),this.setMacApplicationMenu(A),h.append(w)}if(n.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const A=new p.Menu;A.append(new p.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(A)}if(this.shouldDrawMenu("File")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:A});this.setMenuById(A,"File"),h.append(R)}if(this.shouldDrawMenu("Edit")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:A});this.setMenuById(A,"Edit"),h.append(R)}if(this.shouldDrawMenu("Selection")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:A});this.setMenuById(A,"Selection"),h.append(R)}if(this.shouldDrawMenu("View")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:A});this.setMenuById(A,"View"),h.append(R)}if(this.shouldDrawMenu("Go")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:A});this.setMenuById(A,"Go"),h.append(R)}if(this.shouldDrawMenu("Run")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:A});this.setMenuById(A,"Run"),h.append(R)}if(this.shouldDrawMenu("Terminal")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:A});this.setMenuById(A,"Terminal"),h.append(R)}let k;if(this.shouldDrawMenu("Window")){const A=new p.Menu;k=new p.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:A,role:"window"}),this.setMacWindowMenu(A)}if(k&&h.append(k),this.shouldDrawMenu("Help")){const A=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:A,role:"help"});this.setMenuById(A,"Help"),h.append(R)}h.items&&h.items.length>0?p.Menu.setApplicationMenu(h):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const h=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const X=new p.Menu;this.setMenuById(X,"Preferences"),k=new p.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:X})}const A=new p.Menu,R=new p.MenuItem({label:d.localize(12,null),role:"services",submenu:A}),T=new p.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),_=new p.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),Q=new p.MenuItem({label:d.localize(15,null),role:"unhide"}),ne=new p.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const X=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||X?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),oe=[h];oe.push(...w),k&&oe.push(r(),k),oe.push(r(),R,r(),T,_,Q,r(),ne),oe.forEach(X=>o.append(X))}shouldDrawMenu(o){if(!n.isMacintosh&&(0,c.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(n.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,h){h.forEach(w=>{if((0,y.isMenubarMenuItemSeparator)(w))o.append(r());else if((0,y.isMenubarMenuItemSubmenu)(w)){const k=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(w.label),submenu:k});this.setMenu(k,w.submenu.items),o.append(A)}else(0,y.isMenubarMenuItemRecentAction)(w)?o.append(this.createOpenRecentMenuItem(w)):(0,y.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),n.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?o.append(new p.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):o.append(this.createMenuItem(w.label,w.id,!1,w.checked)):o.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):o.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(o,h){this.menubarMenus&&this.menubarMenus[h]&&this.setMenu(o,this.menubarMenus[h].items)}insertCheckForUpdatesItems(o){const h=this.getUpdateMenuItems();h.length&&(h.forEach(w=>o.append(w)),o.append(r()))}createOpenRecentMenuItem(o){const h=I.URI.revive(o.uri),w=o.id,k=w==="openRecentFile"?{fileUri:h}:w==="openRecentWorkspace"?{workspaceUri:h}:{folderUri:h};return new p.MenuItem(this.likeAction(w,{label:o.label,click:(A,R,T)=>{const _=this.isOptionClick(T);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:_,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([h])}},!1))}isOptionClick(o){return!!(o&&(!n.isMacintosh&&(o.ctrlKey||o.shiftKey)||n.isMacintosh&&(o.metaKey||o.altKey)))}createRoleMenuItem(o,h,w){const k={label:this.mnemonicLabel(o),role:w,enabled:!0};return new p.MenuItem(this.withKeybinding(h,k))}setMacWindowMenu(o){const h=new p.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new p.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new p.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),A=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),R=[];this.currentEnableNativeTabs&&(R.push(r()),R.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),R.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),R.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),R.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),R.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[h,w,r(),A,...R,r(),k].forEach(T=>o.append(T))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,h,w,k){const A=this.mnemonicLabel(o),R=typeof h=="function"?h:(oe,X,O)=>{const H=oe?oe.userSettingsLabel:null;let q=h;Array.isArray(h)&&(q=this.isOptionClick(O)?h[1]:h[0]),H&&O.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:H}):this.runActionInRenderer({type:"commandId",commandId:q})},T=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,_=typeof k=="boolean"?k:!1,Q={label:A,click:R,enabled:T};_&&(Q.type="checkbox",Q.checked=_);let ne;return typeof h=="string"?ne=h:Array.isArray(h)&&(ne=h[0]),n.isMacintosh&&(ne==="editor.action.clipboardCutAction"?Q.role="cut":ne==="editor.action.clipboardCopyAction"?Q.role="copy":ne==="editor.action.clipboardPasteAction"&&(Q.role="paste"),ne==="undo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):ne==="redo"?Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):ne==="editor.action.selectAll"&&(Q.click=this.makeContextAwareClickHandler(R,{inDevTools:oe=>oe.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(ne,Q))}makeContextAwareClickHandler(o,h){return(w,k,A)=>{const R=p.BrowserWindow.getFocusedWindow();if(!R)return h.inNoWindow();if(R.webContents.isDevToolsFocused()&&R.webContents.devToolsWebContents)return h.inDevTools(R.webContents.devToolsWebContents);o(w,k||R,A)}}runActionInRenderer(o){let h=p.BrowserWindow.getFocusedWindow();if(!h){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(h=k.win)}const w=h?this.windowsMainService.getWindowById(h.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",o),n.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const k={id:o.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",C.CancellationToken.None,k)}else{const k={userSettingsLabel:o.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",C.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,h){const w=typeof o=="string"?this.keybindings[o]:void 0;if(w?.label){if(w.isNative!==!1)h.accelerator=w.label,h.userSettingsLabel=w.userSettingsLabel;else if(typeof h.label=="string"){const k=h.label.indexOf("[");k>=0?h.label=`${h.label.substr(0,k)} [${w.label}]`:h.label=`${h.label} [${w.label}]`}}else h.accelerator=void 0;return h}likeAction(o,h,w=!h.accelerator){w&&(h=this.withKeybinding(o,h));const k=h.click;return h.click=(A,R,T)=>{this.reportMenuActionTelemetry(o),k&&k(A,R,T)},h}openUrl(o,h){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(h)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,M.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};l.lastKnownMenubarStorageKey="lastKnownMenubarData",l=de([ie(0,P.IUpdateService),ie(1,f.IConfigurationService),ie(2,a.IWindowsMainService),ie(3,S.IEnvironmentMainService),ie(4,v.ITelemetryService),ie(5,u.IWorkspacesHistoryMainService),ie(6,E.IStateMainService),ie(7,b.ILifecycleMainService),ie(8,m.ILogService),ie(9,t.INativeHostMainService),ie(10,g.IProductService)],l),e.Menubar=l;function r(){return new p.MenuItem({type:"separator"})}}),define(Z[241],x([0,1,5,20,6,240]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let n=class{constructor(d,f,S){this.instantiationService=d,this.lifecycleMainService=f,this.logService=S,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(d,f){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(f,d)}};n=de([ie(0,p.IInstantiationService),ie(1,D.ILifecycleMainService),ie(2,C.ILogService)],n),e.MenubarMainService=n}),define(Z[242],x([0,1,14,27,26,30,23,4,32,42,33,2,10,8,63,3,34,15,13,7,155,52,19,50,24,18,5,20,6,54,22,55,64,37,67,239,100,221,29,101,68,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l,r,i,o,h,w,k,A,R,T,_,Q,ne,oe,X,O,H,q,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function $(B){return(0,O.isWorkspaceIdentifier)(B?.workspace)}function K(B){return(0,O.isSingleFolderWorkspaceIdentifier)(B?.workspace)}let ee=class it extends b.Disposable{constructor(L,W,F,N,V,U,z,te,re,se,J,ce,le,he,ge){super();this.machineId=L,this.initialUserEnv=W,this.logService=F,this.stateMainService=N,this.environmentMainService=V,this.lifecycleMainService=U,this.backupMainService=z,this.configurationService=te,this.workspacesHistoryMainService=re,this.workspacesManagementMainService=se,this.instantiationService=J,this.dialogMainService=ce,this.fileService=le,this.productService=he,this.protocolMainService=ge,this._onDidOpenWindow=this._register(new I.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new I.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new I.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new I.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new X.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(L=>this._onDidSignalReadyWindow.fire(L.window))),this._register(this.onDidSignalReadyWindow(L=>{if(L.config?.extensionDevelopmentPath||L.config?.extensionTestsPath){const W=new b.DisposableStore;if(W.add(I.Event.any(L.onDidClose,L.onDidDestroy)(()=>W.dispose())),L.config.extensionDevelopmentPath)for(const F of L.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(c.URI.file(F)));L.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(c.URI.file(L.config.extensionTestsPath)))}}))}openEmptyWindow(L,W){let F=this.environmentMainService.args;const N=W?.remoteAuthority||void 0,V=!0,U=W?.forceReuseWindow,z=!U;return this.open({...L,cli:F,forceEmpty:V,forceNewWindow:z,forceReuseWindow:U,remoteAuthority:N})}openExistingWindow(L,W){L.focus(),this.handleWaitMarkerFile(W,[L])}open(L){this.logService.trace("windowsManager#open"),L.addMode&&(L.initialStartup||!this.getLastActiveWindow())&&(L.addMode=!1);const W=[],F=[],N=[],V=[],U=[];let z,te=0;const re=this.getPathsToOpen(L);this.logService.trace("windowsManager#open pathsToOpen",re);for(const le of re)K(le)?L.addMode?W.push(le):F.push(le):$(le)?N.push(le):le.fileUri?(z||(z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:le.remoteAuthority}),z.filesToOpenOrCreate.push(le)):le.backupPath?U.push({backupFolder:(0,y.basename)(le.backupPath),remoteAuthority:le.remoteAuthority}):te++;L.diffMode&&z&&z.filesToOpenOrCreate.length>=2&&(z.filesToDiff=z.filesToOpenOrCreate.slice(0,2),z.filesToOpenOrCreate=[]),z&&L.waitMarkerFileURI&&(z.filesToWait={paths:[...z.filesToDiff,...z.filesToOpenOrCreate],waitMarkerFileUri:L.waitMarkerFileURI}),L.initialStartup?(V.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),N.push(...V),U.push(...this.backupMainService.getEmptyWindowBackupPaths())):U.length=0;const{windows:se,filesOpenedInWindow:J}=this.doOpen(L,N,F,U,te,z,W);if(this.logService.trace(`windowsManager#open used window count ${se.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${F.length}, emptyToRestore: ${U.length}, emptyToOpen: ${te})`),se.length>1)if(J)J.focus();else{const le=this.windowsStateHandler.state.lastActiveWindow&&!L.forceEmpty&&!L.cli._.length&&!L.cli["file-uri"]&&!L.cli["folder-uri"]&&!(L.urisToOpen&&L.urisToOpen.length);let he=!0,ge=!0;if(le){const be=se.filter(fe=>this.windowsStateHandler.state.lastActiveWindow&&fe.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);be.length&&(be[0].focus(),he=!1,ge=!1)}if(he)for(let be=se.length-1;be>=0;be--){const fe=se[be];if(!(fe.openedWorkspace&&V.some(me=>fe.openedWorkspace&&me.workspace.id===fe.openedWorkspace.id)||fe.backupPath&&U.some(me=>fe.backupPath&&me.backupFolder===(0,y.basename)(fe.backupPath)))){fe.focus(),ge=!1;break}}ge&&se[se.length-1].focus()}const ce=z&&z.filesToDiff.length>0;if(!se.some(le=>le.isExtensionDevelopmentHost)&&!ce&&!L.noRecentEntry){const le=[];for(const he of re)$(he)&&!he.transient?le.push({label:he.label,workspace:he.workspace,remoteAuthority:he.remoteAuthority}):K(he)?le.push({label:he.label,folderUri:he.workspace.uri,remoteAuthority:he.remoteAuthority}):he.fileUri&&le.push({label:he.label,fileUri:he.fileUri,remoteAuthority:he.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(le)}return this.handleWaitMarkerFile(L,se),se}handleWaitMarkerFile(L,W){const F=L.waitMarkerFileURI;L.context===0&&F&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(F)}catch(N){}})()}doOpen(L,W,F,N,V,U,z){const te=[];let re;function se(fe,me){te.push(fe),me&&(re=fe,U=void 0)}let{openFolderInNewWindow:J,openFilesInNewWindow:ce}=this.shouldOpenNewWindow(L);if(!L.initialStartup&&z.length>0){const fe=z[0].remoteAuthority,me=this.getLastActiveWindowForAuthority(fe);me&&se(this.doAddFoldersToExistingWindow(me,z.map(pe=>pe.workspace.uri)))}const le=F.length+W.length+N.length;if(U&&le===0){const fe=U.filesToOpenOrCreate[0]||U.filesToDiff[0],me=this.getWindows().filter(Pe=>U&&(0,v.isEqualAuthority)(Pe.remoteAuthority,U.remoteAuthority));let pe;fe?.fileUri&&!ce&&((L.context===4||L.context===0||L.context===1)&&(pe=(0,oe.findWindowOnFile)(me,fe.fileUri,Pe=>Pe.configPath.scheme===m.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Pe.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(me))),pe?(0,O.isWorkspaceIdentifier)(pe.openedWorkspace)?W.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,O.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?F.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):se(this.doOpenFilesInExistingWindow(L,pe,U),!0):se(this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:L.forceNewTabbedWindow}),!0)}const he=(0,M.distinct)(W,fe=>fe.workspace.id);if(he.length>0){const fe=(0,M.coalesce)(he.map(me=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.configPath)));if(fe.length>0){const me=fe[0],pe=(0,v.isEqualAuthority)(U?.remoteAuthority,me.remoteAuthority)?U:void 0;se(this.doOpenFilesInExistingWindow(L,me,pe),!!pe),J=!0}he.forEach(me=>{if(fe.some(Re=>Re.openedWorkspace&&Re.openedWorkspace.id===me.workspace.id))return;const pe=me.remoteAuthority,Pe=(0,v.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;se(this.doOpenFolderOrWorkspace(L,me,J,Pe),!!Pe),J=!0})}const ge=(0,M.distinct)(F,fe=>v.extUriBiasedIgnorePathCase.getComparisonKey(fe.workspace.uri));if(ge.length>0){const fe=(0,M.coalesce)(ge.map(me=>(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),me.workspace.uri)));if(fe.length>0){const me=fe[0],pe=(0,v.isEqualAuthority)(U?.remoteAuthority,me.remoteAuthority)?U:void 0;se(this.doOpenFilesInExistingWindow(L,me,pe),!!pe),J=!0}ge.forEach(me=>{if(fe.some(Re=>(0,O.isSingleFolderWorkspaceIdentifier)(Re.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Re.openedWorkspace.uri,me.workspace.uri)))return;const pe=me.remoteAuthority,Pe=(0,v.isEqualAuthority)(U?.remoteAuthority,pe)?U:void 0;se(this.doOpenFolderOrWorkspace(L,me,J,Pe),!!Pe),J=!0})}const be=(0,M.distinct)(N,fe=>fe.backupFolder);if(be.length>0&&be.forEach(fe=>{const me=fe.remoteAuthority,pe=(0,v.isEqualAuthority)(U?.remoteAuthority,me)?U:void 0;se(this.doOpenEmpty(L,!0,me,pe,fe),!!pe),J=!0}),te.length===0||U){U&&!V&&V++;const fe=U?U.remoteAuthority:L.remoteAuthority;for(let me=0;me<V;me++)se(this.doOpenEmpty(L,J,fe,U),!!U),J=!0}return{windows:(0,M.distinct)(te),filesOpenedInWindow:re}}doOpenFilesInExistingWindow(L,W,F){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),W.focus();const N={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToWait:F?.filesToWait,termProgram:L?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",n.CancellationToken.None,N),W}doAddFoldersToExistingWindow(L,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),L.focus();const F={foldersToAdd:W};return L.sendWhenReady("vscode:addFolders",n.CancellationToken.None,F),L}doOpenEmpty(L,W,F,N,V){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!V,remoteAuthority:F,filesToOpen:N,forceNewWindow:W});let U;return!W&&typeof L.contextWindowId=="number"&&(U=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:F,forceNewWindow:W,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:N,windowToUse:U,emptyWindowBackupInfo:V})}doOpenFolderOrWorkspace(L,W,F,N,V){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:N}),!F&&!V&&typeof L.contextWindowId=="number"&&(V=this.getWindowById(L.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:L.userEnv,cli:L.cli,initialStartup:L.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:L.forceNewTabbedWindow,filesToOpen:N,windowToUse:V})}getPathsToOpen(L){let W,F=!1,N=!1;if(L.urisToOpen&&L.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(L),F=!0):L.forceEmpty?W=[Object.create(null)]:L.cli._.length||L.cli["folder-uri"]||L.cli["file-uri"]?(W=this.doExtractPathsFromCLI(L.cli),W.length===0&&W.push(Object.create(null)),F=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),N=!0),!L.addMode&&F){const V=W.filter(U=>K(U));if(V.length>1){const U=V[0].remoteAuthority;if(V.every(z=>(0,v.isEqualAuthority)(z.remoteAuthority,U))){const z=this.workspacesManagementMainService.createUntitledWorkspaceSync(V.map(te=>({uri:te.workspace.uri})));W.push({workspace:z,remoteAuthority:U}),W=W.filter(te=>!K(te))}}}return L.initialStartup&&!N&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(V=>$(V)||K(V)||V.backupPath)),W}doExtractPathsFromAPI(L){const W=[],F={gotoLineMode:L.gotoLineMode,remoteAuthority:L.remoteAuthority};for(const N of(0,M.coalesce)(L.urisToOpen||[])){const V=this.resolveOpenable(N,F);if(V)V.label=N.label,W.push(V);else{const U=this.resourceFromOpenable(N),z={title:this.productService.nameLong,type:"info",buttons:[(0,S.mnemonicButtonLabel)((0,a.localize)(0,null))],defaultId:0,message:U.scheme===m.Schemas.file?(0,a.localize)(1,null):(0,a.localize)(2,null),detail:U.scheme===m.Schemas.file?(0,a.localize)(3,null,(0,S.getPathLabel)(U.fsPath,this.environmentMainService)):(0,a.localize)(4,null,U.toString()),noLink:!0};this.dialogMainService.showMessageBox(z,(0,P.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(L){const W=[],F={ignoreFileNotFound:!0,gotoLineMode:L.goto,remoteAuthority:L.remote||void 0,forceOpenWorkspaceAsFile:!1},N=L["folder-uri"];if(N)for(const z of N){const te=this.cliArgToUri(z);if(te){const re=this.resolveOpenable({folderUri:te},F);re&&W.push(re)}}const V=L["file-uri"];if(V)for(const z of V){const te=this.cliArgToUri(z);if(te){const re=this.resolveOpenable((0,O.hasWorkspaceFileExtension)(z)?{workspaceUri:te}:{fileUri:te},F);re&&W.push(re)}}const U=L._;for(const z of U){const te=F.remoteAuthority?this.doResolvePathRemote(z,F):this.doResolveFilePath(z,F);te&&W.push(te)}return W}cliArgToUri(L){try{const W=c.URI.parse(L);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${L}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${L}, ${W.message}`)}}doGetPathsFromLastSession(){const L=this.getRestoreWindowsSetting();switch(L){case"none":return[];case"one":case"all":case"preserve":case"folders":const W=[];L!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const F=[];for(const N of W)if(N.workspace){const V=this.resolveOpenable({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});$(V)&&F.push(V)}else if(N.folderUri){const V=this.resolveOpenable({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});K(V)&&F.push(V)}else L!=="folders"&&N.backupPath&&F.push({backupPath:N.backupPath,remoteAuthority:N.remoteAuthority});return F}}getRestoreWindowsSetting(){let L;return this.lifecycleMainService.wasRestarted?L="all":(L=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(L)||(L="all")),L}resolveOpenable(L,W=Object.create(null)){let F=this.resourceFromOpenable(L);return F.scheme===m.Schemas.file?((0,Q.isFileToOpen)(L)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(F.fsPath,W)):this.doResolveRemoteOpenable(L,W)}doResolveRemoteOpenable(L,W){let F=this.resourceFromOpenable(L);const N=(0,T.getRemoteAuthority)(F)||W.remoteAuthority;if(F=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(F)),(0,Q.isFileToOpen)(L)){if(W.gotoLineMode){const{path:V,line:U,column:z}=(0,d.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:V}),selection:U?{startLineNumber:U,startColumn:z||1}:void 0,remoteAuthority:N}}return{fileUri:F,remoteAuthority:N}}else if((0,Q.isWorkspaceToOpen)(L))return{workspace:(0,H.getWorkspaceIdentifier)(F),remoteAuthority:N};return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:N}}resourceFromOpenable(L){return(0,Q.isWorkspaceToOpen)(L)?L.workspaceUri:(0,Q.isFolderToOpen)(L)?L.folderUri:L.fileUri}doResolveFilePath(L,W){let F,N;W.gotoLineMode&&({path:L,line:F,column:N}=(0,d.parseLineAndColumnAware)(L)),L=(0,d.sanitizeFilePath)((0,y.normalize)(L),(0,E.cwd)());try{const V=(0,D.statSync)(L);if(V.isFile()){if(!W.forceOpenWorkspaceAsFile){const U=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.URI.file(L));if(U)return U.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:U.id,configPath:U.configPath},type:i.FileType.File,exists:!0,remoteAuthority:U.remoteAuthority,transient:U.transient}}return{fileUri:c.URI.file(L),type:i.FileType.File,exists:!0,selection:F?{startLineNumber:F,startColumn:N||1}:void 0}}else{if(V.isDirectory())return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(c.URI.file(L),V),type:i.FileType.Directory,exists:!0};if(!g.isWindows&&L==="/dev/null")return{fileUri:c.URI.file(L),type:i.FileType.File,exists:!0}}}catch(V){const U=c.URI.file(L);if(this.workspacesHistoryMainService.removeRecentlyOpened([U]),W.ignoreFileNotFound)return{fileUri:U,type:i.FileType.File,exists:!1}}}doResolvePathRemote(L,W){const F=L.charCodeAt(0),N=W.remoteAuthority;let V,U;W.gotoLineMode&&({path:L,line:V,column:U}=(0,d.parseLineAndColumnAware)(L)),F!==47&&((0,d.isWindowsDriveLetter)(F)&&L.charCodeAt(L.charCodeAt(1))===58&&(L=(0,d.toSlashes)(L)),L=`/${L}`);const z=c.URI.from({scheme:m.Schemas.vscodeRemote,authority:N,path:L});if(L.charCodeAt(L.length-1)!==47){if((0,O.hasWorkspaceFileExtension)(L))return W.forceOpenWorkspaceAsFile?{fileUri:z,selection:V?{startLineNumber:V,startColumn:U||1}:void 0,remoteAuthority:W.remoteAuthority}:{workspace:(0,H.getWorkspaceIdentifier)(z),remoteAuthority:N};if(W.gotoLineMode||y.posix.basename(L).indexOf(".")!==-1)return{fileUri:z,selection:V?{startLineNumber:V,startColumn:U||1}:void 0,remoteAuthority:N}}return{workspace:(0,H.getSingleFolderWorkspaceIdentifier)(z),remoteAuthority:N}}shouldOpenNewWindow(L){const W=this.configurationService.getValue("window"),F=W?.openFoldersInNewWindow||"default",N=W?.openFilesInNewWindow||"off";let V=(L.preferNewWindow||L.forceNewWindow)&&!L.forceReuseWindow;!L.forceNewWindow&&!L.forceReuseWindow&&(F==="on"||F==="off")&&(V=F==="on");let U=!1;return L.forceNewWindow||L.forceReuseWindow?U=!!L.forceNewWindow&&!L.forceReuseWindow:(g.isMacintosh?L.context===1&&(U=!0):L.context!==3&&L.context!==2&&!(L.userEnv&&L.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!L.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(U=N==="on")),{openFolderInNewWindow:!!V,openFilesInNewWindow:U}}openExtensionDevelopmentHostWindow(L,W){const F=(0,oe.findWindowOnExtensionDevelopmentPath)(this.getWindows(),L);if(F)return this.lifecycleMainService.reload(F,W.cli),F.focus(),[F];let N=W.cli["folder-uri"]||[],V=W.cli["file-uri"]||[],U=W.cli._;if(!U.length&&!N.length&&!V.length&&!W.cli.extensionTestsPath){const se=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,J=se&&(se.workspace||se.folderUri);J&&(c.URI.isUri(J)?J.scheme===m.Schemas.file?U=[J.fsPath]:N=[J.toString()]:J.configPath.scheme===m.Schemas.file?U=[(0,v.originalFSPath)(J.configPath)]:V=[J.configPath.toString()])}let z=W.remoteAuthority;for(const se of L)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const J=c.URI.parse(se),ce=(0,T.getRemoteAuthority)(J);ce&&(z?(0,v.isEqualAuthority)(ce,z)||this.logService.error("more than one extension development path authority"):z=ce)}U=U.filter(se=>{const J=c.URI.file(se);return(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z)}),N=N.filter(se=>{const J=this.cliArgToUri(se);return J&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),V=V.filter(se=>{const J=this.cliArgToUri(se);return J&&!!(0,oe.findWindowOnWorkspaceOrFolder)(this.getWindows(),J)?!1:J?(0,v.isEqualAuthority)((0,T.getRemoteAuthority)(J),z):!1}),W.cli._=U,W.cli["folder-uri"]=N,W.cli["file-uri"]=V;const te=!U.length&&!N.length&&!V.length,re={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:te,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:z};return this.open(re)}openInBrowserWindow(L){const W=this.configurationService.getValue("window"),F={...this.environmentMainService.args,...L.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:L.emptyWindowBackupInfo?(0,y.join)(this.environmentMainService.backupHome,L.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:L.remoteAuthority,workspace:L.workspace,userEnv:{...this.initialUserEnv,...L.userEnv},filesToOpenOrCreate:L.filesToOpen?.filesToOpenOrCreate,filesToDiff:L.filesToOpen?.filesToDiff,filesToWait:L.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:L.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,C.release)(),hostname:(0,C.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let N;if(!L.forceNewWindow&&!L.forceNewTabbedWindow&&(N=L.windowToUse||this.getLastActiveWindow(),N&&N.focus()),N){const V=N.config;!F.extensionDevelopmentPath&&V&&!!V.extensionDevelopmentPath&&(F.extensionDevelopmentPath=V.extensionDevelopmentPath,F.verbose=V.verbose,F["inspect-brk-extensions"]=V["inspect-brk-extensions"],F.debugId=V.debugId,F.extensionEnvironment=V.extensionEnvironment,F["inspect-extensions"]=V["inspect-extensions"],F["extensions-dir"]=V["extensions-dir"])}else{const V=this.windowsStateHandler.getNewWindowState(F);(0,t.mark)("code/willCreateCodeWindow");const U=N=this.instantiationService.createInstance(ne.CodeWindow,{state:V,extensionDevelopmentPath:F.extensionDevelopmentPath,isExtensionTestHost:!!F.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),L.forceNewTabbedWindow){const te=this.getLastActiveWindow();te&&te.addTabbedWindow(U)}it.WINDOWS.push(U),this._onDidOpenWindow.fire(U),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,f.once)(U.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(U)),(0,f.once)(U.onDidClose)(()=>this.onWindowClosed(U)),(0,f.once)(U.onDidDestroy)(()=>this._onDidDestroyWindow.fire(U));const z=(0,P.assertIsDefined)(U.win?.webContents);z.removeAllListeners("devtools-reload-page"),z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(U)),this.lifecycleMainService.registerWindow(U)}return F.windowId=N.id,N.isReady?this.lifecycleMainService.unload(N,4).then(V=>{V||this.doOpenInBrowserWindow(N,F,L)}):this.doOpenInBrowserWindow(N,F,L),N}doOpenInBrowserWindow(L,W,F){if(!W.extensionDevelopmentPath)if((0,O.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,O.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const N=F.emptyWindowBackupInfo&&F.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(N,W.remoteAuthority)}L.load(W)}onWindowClosed(L){const W=it.WINDOWS.indexOf(L);it.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const L=p.BrowserWindow.getFocusedWindow();if(L)return this.getWindowById(L.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(L){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,v.isEqualAuthority)(W.remoteAuthority,L)))}doGetLastActiveWindow(L){const W=Math.max.apply(Math,L.map(F=>F.lastFocusTime));return L.find(F=>F.lastFocusTime===W)}sendToFocused(L,...W){const F=this.getFocusedWindow()||this.getLastActiveWindow();F&&F.sendWhenReady(L,n.CancellationToken.None,...W)}sendToAll(L,W,F){for(const N of this.getWindows())F&&F.indexOf(N.id)>=0||N.sendWhenReady(L,n.CancellationToken.None,W)}getWindows(){return it.WINDOWS}getWindowCount(){return it.WINDOWS.length}getWindowById(L){const W=this.getWindows().filter(F=>F.id===L);return(0,M.firstOrDefault)(W)}getWindowByWebContents(L){const W=p.BrowserWindow.fromWebContents(L);if(!!W)return this.getWindowById(W.id)}};ee.WINDOWS=[],ee=de([ie(2,w.ILogService),ie(3,_.IStateMainService),ie(4,r.IEnvironmentMainService),ie(5,h.ILifecycleMainService),ie(6,u.IBackupMainService),ie(7,s.IConfigurationService),ie(8,q.IWorkspacesHistoryMainService),ie(9,Y.IWorkspacesManagementMainService),ie(10,o.IInstantiationService),ie(11,l.IDialogMainService),ie(12,i.IFileService),ie(13,A.IProductService),ie(14,R.IProtocolMainService)],ee),e.WindowsMainService=ee}),define(Z[243],x([0,1,52,35,68,45]),function(j,e,p,D,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let n=class{constructor(d,f,S,b){this.workspacesManagementMainService=d,this.windowsMainService=f,this.workspacesHistoryMainService=S,this.backupMainService=b,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,f){const S=this.windowsMainService.getWindowById(d);if(S)return this.workspacesManagementMainService.enterWorkspace(S,this.windowsMainService.getWindows(),f)}createUntitledWorkspace(d,f,S){return this.workspacesManagementMainService.createUntitledWorkspace(f,S)}deleteUntitledWorkspace(d,f){return this.workspacesManagementMainService.deleteUntitledWorkspace(f)}getWorkspaceIdentifier(d,f){return this.workspacesManagementMainService.getWorkspaceIdentifier(f)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,f){return this.workspacesHistoryMainService.addRecentlyOpened(f)}async removeRecentlyOpened(d,f){return this.workspacesHistoryMainService.removeRecentlyOpened(f)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};n=de([ie(0,M.IWorkspacesManagementMainService),ie(1,D.IWindowsMainService),ie(2,C.IWorkspacesHistoryMainService),ie(3,p.IBackupMainService)],n),e.WorkspacesMainService=n}),define(Z[244],x([0,1,14,27,26,17,44,16,32,42,38,33,2,10,8,3,15,13,7,31,71,121,36,124,85,235,134,52,225,19,180,163,74,50,226,88,24,53,90,171,188,172,222,89,173,18,183,93,73,5,75,236,201,102,20,6,185,241,51,22,64,231,76,37,219,99,202,28,204,206,65,41,210,233,237,234,238,98,211,212,213,214,216,35,242,217,29,68,243,45]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l,r,i,o,h,w,k,A,R,T,_,Q,ne,oe,X,O,H,q,Y,$,K,ee,B,L,W,F,N,V,U,z,te,re,se,J,ce,le,he,ge,be,fe,me,pe,Pe,Re,Fe,$e,ze,Qe,Ge,gt,Je,at,ct,Ve,He,G,ae,ue,ve,Ie,Ce,Te,We,Oe,Ne,je,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let mt=class extends m.Disposable{constructor(we,ye,Ee,Se,ke,De,Me,Le,Ae,Xe){super();this.mainProcessNodeIpcServer=we,this.userEnv=ye,this.mainInstantiationService=Ee,this.logService=Se,this.environmentMainService=ke,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Le,this.fileService=Ae,this.productService=Xe,this.configureSession(),this.registerListeners()}configureSession(){const we=Se=>Se?.startsWith(`${y.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((Se,ke,De,Me)=>we(Me.requestingUrl)?De(ye.has(ke)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((Se,ke,De,Me)=>we(Me.requestingUrl)?ye.has(ke):!1);const Ee=p.session.defaultSession;typeof Ee.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Ee.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,I.setUnexpectedErrorHandler)(Ee=>this.onUnexpectedError(Ee)),process.on("uncaughtException",Ee=>(0,I.onUnexpectedError)(Ee)),process.on("unhandledRejection",Ee=>(0,I.onUnexpectedError)(Ee)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,u.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Ee,Se)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",Se)}),p.app.on("activate",(Ee,Se)=>{this.logService.trace("app#activate"),Se||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Ee,Se)=>{Se.on("will-navigate",ke=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),ke.preventDefault()}),Se.setWindowOpenHandler(({url:ke})=>(this.nativeHostMainService?.openExternal(void 0,ke),{action:"deny"}))});let we=[],ye;p.app.on("open-file",(Ee,Se)=>{this.logService.trace("app#open-file: ",Se),Ee.preventDefault(),we.push(this.getWindowOpenableFromPathSync(Se)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Ee=>{const Se=this.windowsMainService?.getWindowByWebContents(Ee.sender);let ke,De;return Se?.config?(ke=Se.config,De={...process.env,...Se.config.userEnv}):(ke=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(ke,De,!1)}),p.ipcMain.handle("vscode:writeNlsFile",(Ee,Se,ke)=>{const De=this.validateNlsPath([Se]);if(!De||typeof ke!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,M.VSBuffer.fromString(ke))}),p.ipcMain.handle("vscode:readNlsFile",async(Ee,...Se)=>{const ke=this.validateNlsPath(Se);if(!ke)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(ke)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Ee=>Ee.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Ee=>Ee.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Ee=>Ee.sender.reload())}validateNlsPath(we){let ye;for(const Ee of we)typeof Ee=="string"&&(typeof ye!="string"?ye=Ee:ye=(0,t.join)(ye,Ee));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!g.isLinux)))return P.URI.file(ye)}onUnexpectedError(we){if(we){const ye={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;g.isWindows&&we&&p.app.setAppUserModelId(we);try{g.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new l.Server;this.logService.trace("Resolving machine identifier...");const Ee=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Ee}`);const{sharedProcess:Se,sharedProcessReady:ke,sharedProcessClient:De}=this.setupSharedProcess(Ee),Me=await this.initServices(Ee,Se,ke);if(this.environmentMainService.driverHandle){const Ae=await(0,Q.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Me.createInstance(i.ProxyAuthHandler)),Me.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Le=Me.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));Me.invokeFunction(Ae=>this.afterWindowOpen(Ae,Se)),this.environmentMainService.args.trace&&Me.invokeFunction(Ae=>this.stopTracingEventually(Ae,Le))}async resolveMachineId(){let we=this.stateMainService.getItem(Fe.machineIdKey);return(!we||g.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,a.getMachineId)(),this.stateMainService.setItem(Fe.machineIdKey,we)),we}setupSharedProcess(we){const ye=this._register(this.mainInstantiationService.createInstance(be.SharedProcess,we,this.userEnv)),Ee=(async()=>{this.logService.trace("Main->SharedProcess#connect");const ke=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new r.Client(ke,"main")})(),Se=(async()=>(await ye.whenReady(),Ee))();return{sharedProcess:ye,sharedProcessReady:Se,sharedProcessClient:Ee}}async initServices(we,ye,Ee){const Se=new V.ServiceCollection;switch(process.platform){case"win32":Se.set(Ge.IUpdateService,new F.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":g.isLinuxSnap?Se.set(Ge.IUpdateService,new F.SyncDescriptor(ct.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):Se.set(Ge.IUpdateService,new F.SyncDescriptor(at.LinuxUpdateService));break;case"darwin":Se.set(Ge.IUpdateService,new F.SyncDescriptor(Je.DarwinUpdateService));break}Se.set(Ce.IWindowsMainService,new F.SyncDescriptor(Te.WindowsMainService,[we,this.userEnv])),Se.set(_.IDialogMainService,new F.SyncDescriptor(_.DialogMainService)),Se.set(te.ILaunchMainService,new F.SyncDescriptor(te.LaunchMainService)),Se.set(T.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(Ee.then(De=>De.getChannel("diagnostics"))))),Se.set(U.IIssueMainService,new F.SyncDescriptor(U.IssueMainService,[this.userEnv])),Se.set(ne.IEncryptionMainService,new F.SyncDescriptor(ne.EncryptionMainService,[we])),Se.set(z.IKeyboardLayoutMainService,new F.SyncDescriptor(z.KeyboardLayoutMainService)),Se.set(le.INativeHostMainService,new F.SyncDescriptor(le.NativeHostMainService,[ye])),Se.set(ve.IWebviewManagerService,new F.SyncDescriptor(Ie.WebviewMainService)),Se.set(Oe.IWorkspacesService,new F.SyncDescriptor(je.WorkspacesMainService)),Se.set(bt.IWorkspacesManagementMainService,new F.SyncDescriptor(bt.WorkspacesManagementMainService)),Se.set(Ne.IWorkspacesHistoryMainService,new F.SyncDescriptor(Ne.WorkspacesHistoryMainService)),Se.set(ce.IMenubarMainService,new F.SyncDescriptor(ce.MenubarMainService)),Se.set(H.IExtensionUrlTrustService,new F.SyncDescriptor(q.ExtensionUrlTrustService)),Se.set(Y.IExtensionHostStarter,new F.SyncDescriptor($.WorkerMainProcessExtensionHostStarter)),Se.set(Pe.IStorageMainService,new F.SyncDescriptor(Pe.StorageMainService)),g.isWindows?Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(ee.WindowsExternalTerminalService)):g.isMacintosh?Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(ee.MacExternalTerminalService)):g.isLinux&&Se.set(K.IExternalTerminalMainService,new F.SyncDescriptor(ee.LinuxExternalTerminalService));const ke=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(Se.set(h.IBackupMainService,ke),Se.set(He.IURLService,new F.SyncDescriptor(ae.NativeURLService)),(0,Qe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,s.getDelayedChannel)(Ee.then(Ze=>Ze.getChannel("telemetryAppender"))),Me=new $e.TelemetryAppenderClient(De),Le=(0,Re.resolveCommonProperties)(this.fileService,(0,C.release)(),(0,C.hostname)(),process.arch,this.productService.commit,this.productService.version,we,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],Xe={appenders:[Me],commonProperties:Le,piiPaths:Ae,sendErrorTelemetry:!0};Se.set(Fe.ITelemetryService,new F.SyncDescriptor(ze.TelemetryService,[Xe]))}else Se.set(Fe.ITelemetryService,Qe.NullTelemetryService);return await ke.initialize(),this.mainInstantiationService.createChild(Se)}initChannels(we,ye,Ee){const Se=s.ProxyChannel.fromService(we.get(te.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",Se);const ke=this.fileService.getProvider(y.Schemas.file);(0,v.assertType)(ke instanceof W.DiskFileSystemProvider);const De=new L.DiskFileSystemProviderChannel(ke,this.logService);ye.registerChannel("localFilesystem",De);const Me=new A.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService);ye.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)),Ee.then(Be=>Be.registerChannel(A.UserConfigurationFileServiceId,s.ProxyChannel.fromService(Me)));const Le=new gt.UpdateChannel(we.get(Ge.IUpdateService));ye.registerChannel("update",Le);const Ae=s.ProxyChannel.fromService(we.get(U.IIssueMainService));ye.registerChannel("issue",Ae);const Xe=s.ProxyChannel.fromService(we.get(ne.IEncryptionMainService));ye.registerChannel("encryption",Xe);const Ze=s.ProxyChannel.fromService(we.get(fe.ISignService));ye.registerChannel("sign",Ze);const nt=s.ProxyChannel.fromService(we.get(z.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",nt),this.nativeHostMainService=we.get(le.INativeHostMainService);const xe=s.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",xe),Ee.then(Be=>Be.registerChannel("nativeHost",xe));const wt=s.ProxyChannel.fromService(we.get(Oe.IWorkspacesService));ye.registerChannel("workspaces",wt);const Ue=s.ProxyChannel.fromService(we.get(ce.IMenubarMainService));ye.registerChannel("menubar",Ue);const lt=s.ProxyChannel.fromService(we.get(He.IURLService));ye.registerChannel("url",lt);const rt=s.ProxyChannel.fromService(we.get(H.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",rt);const st=s.ProxyChannel.fromService(we.get(ve.IWebviewManagerService));ye.registerChannel("webview",st);const ot=this._register(new pe.StorageDatabaseChannel(this.logService,we.get(Pe.IStorageMainService)));ye.registerChannel("storage",ot),Ee.then(Be=>Be.registerChannel("storage",ot));const ut=s.ProxyChannel.fromService(we.get(K.IExternalTerminalMainService));ye.registerChannel("externalTerminal",ut);const et=new J.LogLevelChannel(we.get(se.ILogService));ye.registerChannel("logLevel",et),Ee.then(Be=>Be.registerChannel("logLevel",et));const tt=new J.LoggerChannel(we.get(se.ILoggerService));ye.registerChannel("logger",tt),Ee.then(Be=>Be.registerChannel("logger",tt));const ht=new R.ElectronExtensionHostDebugBroadcastChannel(we.get(Ce.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",ht);const _e=s.ProxyChannel.fromService(we.get(Y.IExtensionHostStarter));ye.registerChannel(Y.ipcExtensionHostStarterChannelName,_e)}openFirstWindow(we,ye){const Ee=this.windowsMainService=we.get(Ce.IWindowsMainService),Se=we.get(He.IURLService),ke=we.get(le.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:P.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Be=this.getWindowOpenableFromProtocolLink(_e.uri);return Be?(De.push(Be),!1):!0}),Le=this,Ae=this.environmentMainService,Xe=this.productService;Se.registerHandler({async handleURL(_e,Be){if(_e.scheme===Xe.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:P.URI.parse(_e.query).path,query:""})),Le.shouldBlockURI(_e))return!0;const Et=Le.getWindowOpenableFromProtocolLink(_e);if(Et){const[pt]=Ee.open({context:5,cli:{...Ae.args},urisToOpen:[Et],gotoLineMode:!0});return pt.focus(),!0}if(g.isMacintosh&&Ee.getWindowCount()===0){const[pt]=Ee.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ge.getRemoteAuthority)(_e)});return await pt.ready(),Se.open(_e,Be)}return!1}});const Ze=this._register(new We.ActiveWindowManager({onDidOpenWindow:ke.onDidOpenWindow,onDidFocusWindow:ke.onDidFocusWindow,getActiveWindowId:()=>ke.getActiveWindowId(-1)})),nt=new s.StaticRouter(_e=>Ze.getActiveClientId().then(Be=>_e===Be)),xe=new G.URLHandlerRouter(nt),wt=ye.getChannel("urlHandler",xe);Se.registerHandler(new G.URLHandlerChannelClient(wt)),this._register(new ue.ElectronURLListener(Me,Se,Ee,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,lt=global.macOpenFiles,rt=(0,X.isLaunchedFromCli)(process.env)?0:4,st=Ue._.length,ot=!!Ue["folder-uri"],ut=!!Ue["file-uri"],et=Ue["skip-add-to-recently-opened"]===!0,tt=Ue.wait&&Ue.waitMarkerFilePath?P.URI.file(Ue.waitMarkerFilePath):void 0,ht=Ue.remote||void 0;return De.length>0?Ee.open({context:rt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!st&&!ot&&!ut?Ee.open({context:rt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0,remoteAuthority:ht}):lt.length&&!st&&!ot&&!ut?Ee.open({context:1,cli:Ue,urisToOpen:lt.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:et,waitMarkerFileURI:tt,initialStartup:!0}):Ee.open({context:rt,cli:Ue,forceNewWindow:Ue["new-window"]||!st&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:et,waitMarkerFileURI:tt,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:ht})}shouldBlockURI(we){return!!(we.authority===y.Schemas.file&&g.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,b.getPathLabel)(we.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===y.Schemas.file){const ye=P.URI.file(we.fsPath);return(0,Oe.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(we.authority===y.Schemas.vscodeRemote){const ye=we.path.indexOf(t.posix.sep,1);if(ye!==-1){const Ee=we.path.substring(1,ye),Se=we.path.substring(ye),ke=P.URI.from({scheme:y.Schemas.vscodeRemote,authority:Ee,path:Se,query:we.query,fragment:we.fragment});return(0,Oe.hasWorkspaceFileExtension)(Se)?{workspaceUri:ke}:/:[\d]+$/.test(Se)?{fileUri:ke}:{folderUri:ke}}}}}getWindowOpenableFromPathSync(we){try{if((0,D.statSync)(we).isDirectory())return{folderUri:P.URI.file(we)};if((0,Oe.hasWorkspaceFileExtension)(we))return{workspaceUri:P.URI.file(we)}}catch(ye){}return{fileUri:P.URI.file(we)}}async afterWindowOpen(we,ye){this.lifecycleMainService.phase=3;let Ee=!1;(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Ee=!0);const Se=we.get(Fe.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Le})=>{let Ae;switch(Me){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Le?.reason??"<unknown>"}, code: ${Le?.exitCode??"<unknown>"})`;break}(0,I.onUnexpectedError)(new Error(Ae)),Se.publicLog2("sharedprocesserror",{type:Me,reason:Le?.reason,code:Le?.exitCode,visible:ye.isVisible(),shuttingdown:Ee})}));const ke=this.productService.win32MutexName;if(g.isWindows&&ke)try{const Me=j.__$__nodeRequire("windows-mutex").Mutex,Le=new Me(ke);(0,f.once)(this.lifecycleMainService.onWillShutdown)(()=>Le.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Me,Le)=>{Le({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=we.get(Ge.IUpdateService);(De instanceof Ve.Win32UpdateService||De instanceof at.LinuxUpdateService||De instanceof Je.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const Le=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,S.stripComments)(Le))["enable-crash-reporter"]===void 0){const Ze=(0,Qe.getTelemetryLevel)(this.configurationService)>=1,nt=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ze},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,c.generateUuid)()}"`,"}"],xe=Le.substring(0,Le.length-2).concat(`,
`,nt.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(xe))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(we,ye,Ee){try{return await(0,O.getResolvedShellEnv)(this.logService,we,ye)}catch(Se){const ke=(0,n.toErrorMessage)(Se);Ee?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",ke):this.logService.error(ke)}return{}}stopTracingEventually(we,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Ee=we.get(_.IDialogMainService);let Se=!1;const ke=async Me=>{if(Se)return;Se=!0;const Le=await p.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Le}`):Ee.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,Le),buttons:[(0,b.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>ke(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),ke(!1)})}};mt=de([ie(2,N.IInstantiationService),ie(3,se.ILogService),ie(4,oe.IEnvironmentMainService),ie(5,re.ILifecycleMainService),ie(6,k.IConfigurationService),ie(7,me.IStateMainService),ie(8,B.IFileService),ie(9,he.IProductService)],mt),e.CodeApplication=mt}),define(Z[251],x([0,1,14,27,30,9,44,16,32,42,33,10,8,63,3,34,25,21,36,57,244,11,19,192,203,24,53,166,18,182,93,73,175,75,20,94,6,186,95,54,22,55,189,96,228,49,230,76,200,37,232,65,66,209]),function(j,e,p,D,C,M,n,I,d,f,S,b,m,y,t,g,E,v,P,c,a,u,s,l,r,i,o,h,w,k,A,R,T,_,Q,ne,oe,X,O,H,q,Y,$,K,ee,B,L,W,F,N,V,U,z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class te{main(){try{this.startup()}catch(J){console.error(J.message),p.app.exit(1)}}async startup(){(0,I.setUnexpectedErrorHandler)(me=>console.error(me));const[J,ce,le,he,ge,be,fe]=this.createServices();try{try{await this.initServices(le,he,ge)}catch(me){throw this.handleStartupDataDirError(le,fe.nameLong,me),me}await J.invokeFunction(async me=>{const pe=me.get(oe.ILogService),Pe=me.get(Q.ILifecycleMainService),Re=me.get(w.IFileService),Fe=await this.claimInstance(pe,le,Pe,J,fe,!0);return v.Promises.writeFile(le.mainLockfile,String(process.pid)).catch($e=>{pe.warn(`Error writing main lockfile: ${$e.stack}`)}),be.logger=new O.SpdLogLogger("main",(0,m.join)(le.logsPath,"main.log"),!0,!1,be.getLevel()),(0,f.once)(Pe.onWillShutdown)($e=>{Re.dispose(),he.dispose(),$e.join(v.Promises.unlink(le.mainLockfile).catch(()=>{}))}),J.createInstance(a.CodeApplication,Fe,ce).startup()})}catch(me){J.invokeFunction(this.quit,me)}}createServices(){const J=new _.ServiceCollection,ce={_serviceBrand:void 0,...H.default};J.set(q.IProductService,ce);const le=new i.EnvironmentMainService(this.resolveArgs(),ce),he=this.patchEnvironment(le);J.set(i.IEnvironmentMainService,le);const ge=new ne.BufferLogService,be=new oe.MultiplexLogService([new oe.ConsoleMainLogger((0,oe.getLogLevel)(le)),ge]);process.once("exit",()=>be.dispose()),J.set(oe.ILogService,be);const fe=new k.FileService(be);J.set(w.IFileService,fe);const me=new A.DiskFileSystemProvider(be);fe.registerProvider(b.Schemas.file,me),J.set(oe.ILoggerService,new X.LoggerService(be,fe));const pe=new l.ConfigurationService(le.settingsResource,fe);J.set(s.IConfigurationService,pe),J.set(Q.ILifecycleMainService,new R.SyncDescriptor(Q.LifecycleMainService));const Pe=new V.StateMainService(le,be,fe);return J.set(N.IStateMainService,Pe),J.set(B.IRequestService,new R.SyncDescriptor(L.RequestMainService)),J.set(z.IThemeMainService,new R.SyncDescriptor(z.ThemeMainService)),J.set(W.ISignService,new R.SyncDescriptor(F.SignService)),J.set(K.ITunnelService,new R.SyncDescriptor(ee.TunnelService)),J.set(Y.IProtocolMainService,new R.SyncDescriptor($.ProtocolMainService)),[new T.InstantiationService(J,!0),he,le,pe,Pe,ge,ce]}patchEnvironment(J){const ce={VSCODE_IPC_HOOK:J.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(le=>{const he=process.env[le];typeof he=="string"&&(ce[le]=he)}),Object.assign(process.env,ce),ce}initServices(J,ce,le){return M.Promises.settled([Promise.all([J.extensionsPath,J.codeCachePath,J.logsPath,J.globalStorageHome.fsPath,J.workspaceStorageHome.fsPath,J.backupHome].map(he=>he?v.Promises.mkdir(he,{recursive:!0}):void 0)),ce.initialize(),le.init()])}async claimInstance(J,ce,le,he,ge,be){let fe;try{(0,y.mark)("code/willStartMainServer"),fe=await(0,c.serve)(ce.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,f.once)(le.onWillShutdown)(()=>fe.dispose())}catch(me){if(me.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ce,ge.nameLong,me),me;let pe;try{pe=await(0,c.connect)(ce.mainIPCHandle,"main")}catch(Fe){if(!be||t.isWindows||Fe.code!=="ECONNREFUSED")throw Fe.code==="EPERM"&&this.showStartupWarningDialog((0,u.localize)(0,null,ge.nameShort),(0,u.localize)(1,null),ge.nameLong),Fe;try{(0,D.unlinkSync)(ce.mainIPCHandle)}catch($e){throw J.warn("Could not delete obsolete instance handle",$e),$e}return this.claimInstance(J,ce,le,he,ge,!1)}if(ce.extensionTestsLocationURI&&!ce.debugExtensionHost.break){const Fe="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw J.error(Fe),pe.dispose(),new Error(Fe)}let Pe;!ce.args.wait&&!ce.args.status&&(Pe=setTimeout(()=>{this.showStartupWarningDialog((0,u.localize)(2,null,ge.nameShort),(0,u.localize)(3,null),ge.nameLong)},1e4));const Re=P.ProxyChannel.toService(pe.getChannel("launch"),{disableMarshalling:!0});if(ce.args.status)return he.invokeFunction(async()=>{const Fe=new r.DiagnosticsService(U.NullTelemetryService,ge),$e=await Re.getMainProcessInfo(),ze=await Re.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Qe=await Fe.getDiagnostics($e,ze);throw console.log(Qe),new I.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Re,J),J.trace("Sending env to running instance..."),await Re.start(ce.args,process.env),pe.dispose(),Pe&&clearTimeout(Pe),new I.ExpectedError("Sent env to running instance. Terminating...")}if(ce.args.status)throw J.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new I.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),fe}handleStartupDataDirError(J,ce,le){if(le.code==="EACCES"||le.code==="EPERM"){const he=(0,C.coalesce)([J.userDataPath,J.extensionsPath,c.XDG_RUNTIME_DIR]).map(ge=>(0,S.getPathLabel)(ge,J));this.showStartupWarningDialog((0,u.localize)(4,null),(0,u.localize)(5,null,(0,n.toErrorMessage)(le),he.join(`
`)),ce)}}showStartupWarningDialog(J,ce,le){p.dialog.showMessageBoxSync({title:le,type:"warning",buttons:[(0,S.mnemonicButtonLabel)((0,u.localize)(6,null))],message:J,detail:ce,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(J,ce){if(t.isWindows){const le=await J.getMainProcessId();ce.trace("Sending some foreground love to the running instance:",le);try{(await new Promise((he,ge)=>{j(["windows-foreground-love"],he,ge)})).allowSetForegroundWindow(le)}catch(he){ce.error(he)}}}quit(J,ce){const le=J.get(oe.ILogService),he=J.get(Q.ILifecycleMainService);let ge=0;ce&&(ce.isExpected?ce.message&&le.trace(ce.message):(ge=1,ce.stack?le.error(ce.stack):le.error(`Startup error: ${ce.toString()}`))),he.kill(ge)}resolveArgs(){const J=this.validatePaths((0,o.parseMainProcessArgv)(process.argv));if(J.wait&&!J.waitMarkerFilePath){const ce=(0,h.createWaitMarkerFile)(J.verbose);ce&&((0,o.addArg)(process.argv,"--waitMarkerFilePath",ce),J.waitMarkerFilePath=ce)}return J}validatePaths(J){if(J["open-url"]&&(J._urls=J._,J._=[]),!J.remote){const ce=this.doValidatePaths(J._,J.goto);J._=ce}return J}doValidatePaths(J,ce){const le=(0,g.cwd)(),he=J.map(fe=>{let me=String(fe),pe;ce&&(pe=(0,d.parseLineAndColumnAware)(me),me=pe.path),me&&(me=this.preparePath(le,me));const Pe=(0,d.sanitizeFilePath)(me,le),Re=(0,m.basename)(Pe);return Re&&!(0,d.isValidBasename)(Re)?null:ce&&pe?(pe.path=Pe,this.toPath(pe)):Pe}),ge=t.isWindows||t.isMacintosh,be=(0,C.distinct)(he,fe=>fe&&ge?fe.toLowerCase():fe||"");return(0,C.coalesce)(be)}preparePath(J,ce){return t.isWindows&&(ce=(0,E.rtrim)(ce,'"')),ce=(0,E.trim)((0,E.trim)(ce," "),"	"),t.isWindows&&(ce=(0,m.resolve)(J,ce),ce=(0,E.rtrim)(ce,".")),ce}toPath(J){const ce=[J.path];return typeof J.line=="number"&&ce.push(String(J.line)),typeof J.column=="number"&&ce.push(String(J.column)),ce.join(":")}}new te().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/10791447894a9abc9f2ae4927bf92bcf30f3fdef/core/vs/code/electron-main/main.js.map
